/*
 * Copyright (C) 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: task_struct.c,v 1.2 2001/06/09 02:52:19 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: User-space program to determine offsets in task_struct
 */

#include <wr_conf.h>

#include <stdio.h>

#include <asm/types.h>
#include <asm/processor.h>
#include <asm/timex.h>
#include "task_struct.h"

#define taskoffset(n) (int) &((struct task_struct *)0)->n

int
main( int argc, char **argv )
{
   if( argc > 1 )
   {
      int i;
      for( i = 1; i < argc; i++ )
      {
         if( !strncmp( argv[i], "pid", 3 ) )
            printf( "pid = %d\n", taskoffset(pid) );
      }
   }
   else
   {
      printf( "pid = %d\n", taskoffset(pid) );
   }
   return 0;
}

