#!/usr/local/bin/perl
# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: convert_l2s.pl,v 1.12 2001/04/05 18:40:19 stevek Exp $
#
# Perl 5 script for converting Windows long filenames to short form.
#

require 5.003;

sub longNameToShortName {
   my @long = split( /\//, shift );
   my $short = shift @long;
   my $comspec = 'CMD.EXE /C DIR /X';

   my $part;
   foreach $part ( @long ) {
      $part =~ s!\\ ! !g;
      my $cmd = $comspec . ' "' . $short;
      if( $short =~ /:$/ ) {
         $cmd .= '\\';
         $cmd .= '\\' if $^O eq 'cygwin';
      }
      $cmd .= '" |';
      open( LTOS, $cmd ) ||
         die 'Unable to convert long name to short';
      while( <LTOS> ) {
         /^[0-9\/]{8,10}\s+[0-9:ap]{6}\s{6,8}(<DIR>\s{9}|[0-9,\s]{14})\s(\S*)\s+(\S[^\n\r]*)[\n\r]+$/;
         next if !$3;
         next if( ( lc($3) ne lc($part) ) && ( lc($2) ne lc($part) ) );
         $short .= '\\';
         $short .= '\\' if $^O eq 'cygwin';
         $short .= lc(($2)?$2:$3);
         last;
      }
      close( LTOS );
   }

   $short;
}

my $longname = lc($ARGV[0]);
$longname =~ s!\\+!\\!g;
$longname =~ s!^"|"$!!g;
$longname =~ s!\\(\S)!/\1!g;
print longNameToShortName $longname;

