#!/usr/local/bin/perl -w
# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#

require 5.005;
use strict;

my $incdir = 'e:/progra~1/micros~1/vc98/include';
my $matched = 0;
my $entries = 0;

$| = 1;

if( open( FILE, 'UndocWin32.txt' ) ) {
   while( <FILE> ) {
      chomp;
      next unless /\S/;
      next if /^\s*#/;

      $entries++;
      print "$_: ";

      my $symbol = $_;

      opendir( DIR, $incdir );
      while( my $dirent = readdir(DIR) ) {
         next unless lc($dirent) =~ /\.h$/;

         my $fd;
         if( open( *fd, "$incdir/$dirent" ) ) {
            while( <*fd> ) {
               (print "Matched"), $matched++, last if /\s*$symbol\s*\(/;
            }
            close( *fd );
         }
      }
      print "\n";
   }
   close( FILE );
}

print "\nMatched $matched/$entries symbols\n";

