/*! \file dbinterface.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: dbinterface.h,v 1.4 2001/02/23 19:02:01 stevek Exp $
 *
 * \brief   Database inteface header
 * \author  Steve Kiernan
 * \version $Revision: 1.4 $
 * \date    $Date: 2001/02/23 19:02:01 $
 */

#ifndef __DBINTERFACE_H
#define __DBINTERFACE_H 1

#include <wr_conf.h>
#include <wsi_mutex.h>

typedef struct wql_table_opaque
{
   WSI_MUTEX_PROTECT(table);
}
wqtabopaque, *wqtabopaque_t;


#define WREV_CREATETAB           1
#define WREV_DROPTAB             2
#define WREV_UPDATETAB_INSERTROW 3
#define WREV_UPDATETAB_DELETEROW 4
#define WREV_UPDATETAB_UPDATEROW 5
#define WREV_MODULE_LOADED       6
#define WREV_MODULE_UNLOADED     7


void wss_db_lock         __P(( void ));
void wss_db_unlock       __P(( void ));
void wss_db_lock_table   __P(( wqtab_t ));
void wss_db_unlock_table __P(( wqtab_t ));

#endif /* __DBINTERFACE_H */

