/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 *  Author: Calvin Ko
 *  Email : calvin_ko@nai.com
 *
 *  $Id: code-wdl.h,v 1.4 2001/02/23 19:02:03 stevek Exp $
 */

#ifndef K_CODE_WDL_H
#define K_CODE_WDL_H

#include "gram.h"

/** Class for generation of WDL code from a pegram */
class PEGram_WDL : public PEGram {
public:
	PEGram_WDL(const char *n) : PEGram(n) {
	};
	source *gencode();
	source *gen_tokenfuncs();
	source *gen_errorclause();

	source gen_define_auditops();
	source gen_tokenfunc(TermDef *, source *);
	source gen_decl();
	source gen_subfunctbl();
	source gen_subfunc();
	source gen_parsefunc();
	
  	/** Generate WDL clause for the given EvSelExpr */
  	source gen_wdlclause(TermDef *td, EvSelExpr *e, source *cond);
	
};

#endif /* K_CODE_WDL_H */
