/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */

int  wr_printf(const char *fmt, ...);
int  wr_sprintf(char *s, const char *fmt, ...);
int  wr_audit(unsigned long logid, unsigned long identifier,
             void* buffer, unsigned long length);
int  wr_audit_printf (unsigned long logid, unsigned long identifier, 
                     const char*, ...);
int  wr_strcmp	(const char *, const char *);
int  wr_strncmp (const char *, const char *, int);

int  wr_strlen 	(const char *);
int  wr_atoi    (const char *);

char *wr_strcpy (char *dst, const char *src);
char *wr_strncpy(char *dst, const char *src, int);
char *wr_strchr	(const char *str, int c);
char *wr_strrchr(const char *str, int c);
char *wr_strcat (char *s, char *append);
char *wr_strncat (char *s, char *append, int count);

void wr_bcopy	(const void *src, void *dst, size_t len);
void wr_bzero	(void *src, size_t len);

void new_tparser(int, int);
void detach_proc();

int setRetVal(int i);
int setErrno(int i);

int created(int pid, FileTk *f);
int createdBySubj(int sid, FileTk *f);
int inside(const char *path, const char *dir);
int extractPort(const char *path);
char *getProgName();
char *objType(int);

char *symflag(int);

/* For open call */
#ifdef WR_UNIX
#define ISFLAG_read(f)          ((f & O_ACCMODE) == O_RDONLY)
#define ISFLAG_write(f)         ((f & O_ACCMODE) == O_WRONLY)
#define ISFLAG_rw(f)       	((f & O_ACCMODE) == O_RDWR)
#define ISFLAG_create(f)        (f & O_CREAT)

#define WorldReadable(m)	(m & 04)
#define GroupReadable(m)	(m & 040)
#define OwnerReadable(m)	(m & 0400)

#define WorldWritable(m)	(m & 02)
#define GroupWritable(m)	(m & 020)
#define OwnerWritable(m)	(m & 0200)

#define WorldExecutable(m)	(m & 01)
#define GroupExecutable(m)	(m & 010)
#define OwnerExecutable(m)	(m & 0100)

#define IsSetUid(m)		(m & 04000)
#define IsSticky(m)		(m & 01000)

#define IsObjPipe(o)               ((o.st_mode & S_IFMT) == S_IFIFO)
#define IsObjDir(o)                ((o.st_mode & S_IFMT) == S_IFDIR)
#define IsObjSymlink(o)            ((o.st_mode & S_IFMT) == S_IFLNK)
#define IsObjSocket(o)             ((o.st_mode & S_IFMT) == S_IFSOCK)
#define IsObjCharDev(o)            ((o.st_mode & S_IFMT) == S_IFCHR)
#define IsObjBlkDev(o)             ((o.st_mode & S_IFMT) == S_IFBLK)
#define IsObjRegFile(o)            ((o.st_mode & S_IFMT) == S_IFREG)
#define IsObjWhiteOut(o)           ((o.st_mode & S_IFMT) == S_IFWHT)

#define IsPipe(m)               ((m & S_IFMT) == S_IFIFO)
#define IsDir(m)                ((m & S_IFMT) == S_IFDIR)
#define IsSymlink(m)            ((m & S_IFMT) == S_IFLNK)
#define IsSocket(m)             ((m & S_IFMT) == S_IFSOCK)
#define IsCharDev(m)            ((m & S_IFMT) == S_IFCHR)
#define IsBlkDev(m)             ((m & S_IFMT) == S_IFBLK)
#define IsRegFile(m)            ((m & S_IFMT) == S_IFREG)
#define IsWhiteOut(m)           ((m & S_IFMT) == S_IFWHT)
#define IsFile(f, p)		!wr_strcmp(f, p)

#define IS_goodmode(m)          !(m & 022)

#endif

#define createdBySelf(f)        createdBySubj($S.uid, f)
#define ispath(f, p)		!wr_strcmp(f, p)

                                                                
#define aprintf 			wr_audit_printf
#define Indir				wr_strcmp
