:- unset(cover)?
:- set(c,10)?
:- set(h,100)?
%:- set(posonly)?
%:- unset(condition)?            

:- modeh(*, readop(+subj, +path, +fattr, +pmode))?
:- modeh(*, readop((+id, +id, +id), +path, (+id, +id, +id), +pmode))?

:- modeb(3, own(+subj, +fattr))?
:- modeb(3, group(+subj, +fattr))?
:- modeb(3, worldreadable(+pmode))?
:- modeb(3, groupreadable(+pmode))?
:- modeb(3, ownerreadable(+pmode))?
:- modeb(1, isfile(+path, #path))?
:- modeb(1, createdbyself(+fattr))?
:- modeb(3, indir(+path, #path))?

% Definitions for members

member(X, [X|Tail]).
member(X, [Head|Tail]) :- member(X, Tail).

% Definitions of subject (euid, egid, pid)

subj((U, G, Pid)) :- id(U), id(G), id(Pid).

% Definitions of path   /etc/passwd is represented as [etc, passwd]
path([]).
path([A]).
path([A|B]) :- path(B).

% Definition of indir
indir([X|D], D).
indir([X|Y], D) :- indir(Y,D).


% Definitions of permission mode
pmode(m(W, G, O)) :- W =< 7, W >= 0, G =< 7, G >= 0, O =< 7, O >= 0.

% Definitions of psubj
psubj(world).  psubj(group). psubj(owner).  

% Definitions of user ID
id(U) :- U =< 65535, U >= 0.

% Definitions of own
own((U, G, Pid), f(U, OG, I)).
group((U, G, Pid), f(OU, G, I)).

isfile(A, B) :- A = B.

% Definitions of fattr, file attributes

fattr(f(Ouid, Ogid, I)) :- id(Ouid), id(Ogid), int(I).

%executable(m(O, G, W), world) :- odd(W).
%writable(m(O, G, W), world) :- Y is W / 2, Z is floor(Y), odd(Z).
%readable(m(O, G, W), world) :- W >= 4.

%executable(m(O, G, W), group) :- odd(G).
%writable(m(O, G, W), group) :- Y is G / 2, Z is floor(Y), odd(Z).
%readable(m(O, G, W), group) :- G >= 4.

%executable(m(O, G, W), owner) :- odd(O).
%writable(m(O, G, W), owner) :- Y is O / 2, Z is floor(Y), odd(Z).
%readable(m(O, G, W), owner) :- O >= 4.

worldreadable(m(O, G, W)) :- W >= 4.
groupreadable(m(O, G, W)) :- G >= 4.
ownerreadable(m(O, G, W)) :- O >= 4.
                                                      

%:-readop((215,10,352), ['spwd.db', 'etc'],f(3,7,184332), m(6, 0, 0)).
:-readop((215,10,352), ['at.deny', 'etc'],f(0,7,132108), m(6, 0, 0)).

%:- generalise(readop/4)?


