/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * $Id: syslogutil.c,v 1.3 2001/02/23 19:02:04 stevek Exp $
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define wr_strchr strchr
#define wr_atoi   atoi

typedef struct {
	short class;
	short priority;
	char *date;
	char *time;
	char *prog;
	int	pid;
	char *msg;
} SysLogRec;

int unpackSyslogMsg(char *msg, SysLogRec *rec) 

{
	int n;
	char *cp = msg+1;		
	char *e;
	e = wr_strchr(cp, '>');	
	*e = '\0';
 	e++;	
	n = wr_atoi(cp);
	rec->priority = n & 7;
	rec->class = n >> 3;	

	/* get date */
	rec->date = e;
	e = wr_strchr(e, ' ');	
	e++;
	e = wr_strchr(e, ' ');	
	*e = '\0';
	e++;

	/* get time */	
	rec->time = e;
	e = wr_strchr(e, ' ');	
	*e = '\0';
	e++;

	/* get program */
	rec->prog = e;
	e = wr_strchr(e, ' ');	
	*e = '\0';
	e++;	
	cp = wr_strchr(rec->prog, '[');
	if (cp != NULL) {
		 *cp = '\0';
		cp++;
		rec->pid = wr_atoi(cp);
	} else
		rec->pid = 0;

	rec->msg = e;
	return 1;		
}

main(int argc, char *argv[])

{
	SysLogRec r;
	unpackSyslogMsg(argv[1], &r);
	printf("date:%s \t time:%s \t prog:%s -- %s\n", 
		   r.date, r.time, r.prog, r.msg);
}
