/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * $Id: netcmd.h,v 1.7 2001/02/23 19:02:04 stevek Exp $
 */


#define WRNETCMD_MAX_SIZE 	1024	
#define WRNETCMD_HEADER_SIZE	8

#define 	WQL_INSERTROW		'I' + 256 * ' '
#define	WQL_DELETEROW		2		
#define	WQL_UPDATEROW		3
#define	WQL_CREATTBL		4
#define	WQL_DROPTBL		5
#define	WQL_NAME_MAX		256

/** for Wrapper Network Command */
struct WrNetCmd {
	char 	name[4];		/* Name of Cmd */
	int		size;		/* size of the whole cmd, including header */
	char 	buf[WRNETCMD_MAX_SIZE];
};


/**  for WQL Cmd
 */

typedef struct {
	short	cmd;
	short	nitems;			/* for insertRow, updateRow	*/
	char		*tblname;
	char		**rowitem;		/* for insertRow, updateRow 	*/
	char		*cond;			/* for updateRow, deleteRow 	*/
	char 	*assmt;			/* for updateRow 			*/
	char 	errmsg[WQL_NAME_MAX];
} WQLCmd;
	
extern int doWQLCmd(char *cbuf, int size);
extern int printWQLCmd(char *cbuf, int size);
extern int packInsRowCmd(char *cbuf, char *tablename, char **fields);
extern int packUpdateRowCmd(char *cbuf, char *tablename, char *fieldassmt, char *cond);
extern int sendCmd(char *ip, char *cmd, int len);
extern int fillWQLCmdHdr(char *buf, int size);





