/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * $Id: wqltest.c,v 1.4 2001/02/23 19:02:04 stevek Exp $
 */
/***************************************************************************
                          clientmain.c  -  description
                             -------------------
    begin                : Fri May 26 2000
    copyright            : (C) 2000 by Calvin Ko
    email                : ko@tislabs.com
 ***************************************************************************/


#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include "comm.h"
#include "netcmd.h"



int main(int argc, char *argv[])

{
	int s;
	int size;
	char buf[1024];
	char *tblname;
	char *fassmt;
	char *cond;
	char *row[10];
	if (argc <= 4) {
		fprintf(stderr, "wqltest HOST [insert tblname fields]\n");
		fprintf(stderr, "           [delete tblname condition]\n");
		exit(0);
	}

	s = connectTCP(argv[1], WRD_PORT);
	if (s < 0) {
          perror(errmsg);
		exit(0);
	}

	if (!strcmp(argv[2], "insert")) {
		int i;
		tblname = argv[3];
		for (i=4; i<argc ;i++) {
			row[i-4] = argv[i];	
		}
		row[i-4] = NULL;	
		size = packInsRowCmd(buf+8, tblname, row);
		size += 8;			
		strncpy(buf, "WQL0", 4);
		bcopy(&size, buf + 4, sizeof(size));
	} else if (!strcmp(argv[2], "update")) {
		tblname = argv[3];
		fassmt = argv[4];
		cond = argv[5];
		printf("%s %s %s\n", tblname, fassmt, cond);
		size = packUpdateRowCmd(buf+8, tblname, fassmt, cond);
		size += 8;
		strncpy(buf, "WQL0", 4);
		bcopy(&size, buf+4, sizeof(size));
	} else {
		exit(0);
	}
 	write(s, buf, size);
	close(s);
	return 1;
}
