/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * $Id: wrevent.c,v 1.6 2001/02/23 19:02:04 stevek Exp $
 */
/***************************************************************************
                          wrevent.c  -  description
                             -------------------
    begin                : Tue May 30 2000
    copyright            : (C) 2000 by Calvin Ko
    email                : 
 ***************************************************************************/


#include "wr_conf.h"

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>

#include <eventfs.h>
#include <libeventfs.h>
#include <libwrv.h>

#define WDAEMON_QNUM	0
eventfs_event_group_t   group;
eventfs_event_stream_t 	stream;

int getauditfd()

{
	ulong 			mask = 1 << WDAEMON_QNUM;	/* wdaemon queue #0 */

	/* Check if WSS is loaded */
	if (!wrvIsLoaded()) {
		fprintf(stderr, "WSS not loaded\n");
		exit(1);
	}
	
	/*
	 * Register with the WSS
	 */
	if( wrvInit() < 0 ) {
		perror( "wrvInit" );
		exit(1);
	}

	/*
 	 * Open the group
	 */
	group = eventfsEventGetGroup(WREV_AUDIT_GROUP);
	if (group == 0) {
		perror("eventfsEventGetGroup("WREV_AUDIT_GROUP")");
		exit(1);
	}

	/*
	 * Open the stream
	 */
	if ( (stream = eventfsEventGroupGetStream(group, mask)) == NULL) {
		perror( "eventfsEventGroupGetStream" );
		exit(1);
	}
	
	/* return the file descriptor associated with the audit stream */
	return stream->stream;
};

int getauditdata(char *buf)

{
	eventfs_event_t event;
	if ((event = eventfsEventStreamGetNextEvent(stream)) != NULL) {
		strncpy(buf, eventfsEventGetData(event), eventfsEventGetSize(event));
		buf[eventfsEventGetSize(event)] = '\0';
		eventfsEventRelease(event);
	}
	return 1;
}




