/*
 * $Id: gswtk.h,v 1.22 2001/03/29 23:34:18 stevek Exp $
 *
 */

#ifdef PD_IN_KERNEL
/* --- GSWTK Kernel Headers --- */

#ifndef _GSWTK_H
#define _GSWTK_H 1

#ifdef GSWTK_INCL_ASSEMBLY
#define PD_ASSEMBLY 1
#endif /* GSWTK_INCL_ASSEMBLY */
#include <pdpi/pi_defs.h>

#ifndef GSWKERNLINKAGE
#  ifdef GSWKERNSOURCE
#    define GSWKERNLINKAGE EXPORT
#  else
#    define GSWKERNLINKAGE IMPORT
#  endif
#endif

#ifndef GSWTK_INCL_ASSEMBLY
#include <gswtk/types.h>
#include <gswtk/kernel/options.h>
#include <gswtk/kernel/kernel.h>
#include <gswtk/kernel/component.h>
#endif /* GSWTK_INCL_ASSEMBLY */

#define GSWTK_MODULE_HEADER(MOD,HDR) <gswtk/modules/MOD/HDR>

#if   defined(PD_UNIX)
#define GSWTK_KERNEL_OS_HEADER(HDR) <gswtk/kernel/os/system/HDR>
#define GSWTK_KERNEL_OS_MACH_HEADER(HDR) <gswtk/kernel/os/system/mach/HDR>
#define GSWTK_MODULE_OS_HEADER(MOD,HDR) <gswtk/modules/MOD/os/system/HDR>
#define GSWTK_MODULE_OS_MACH_HEADER(MOD,HDR) <gswtk/modules/MOD/os/system/mach/HDR>
#elif defined(PD_WINNT)
#define GSWTK_KERNEL_OS_HEADER(HDR) <gswtk/kernel/os/winnt/HDR>
#define GSWTK_KERNEL_OS_MACH_HEADER(HDR) <gswtk/kernel/os/winnt/GSWTK_CONFIG_MACH/HDR>
#define GSWTK_MODULE_OS_HEADER(MOD,HDR) <gswtk/modules/MOD/os/winnt/HDR>
#define GSWTK_MODULE_OS_MACH_HEADER(MOD,HDR) <gswtk/modules/MOD/os/winnt/GSWTK_CONFIG_MACH/HDR>
#else
#error Unknown OS, please create PD/PI common include headers for your system
#endif


#ifndef GSWTK_INCL_ASSEMBLY
#include <gswtk/kernel/os/panic.h>
#include <gswtk/kernel/os/mach.h>
#endif /* GSWTK_INCL_ASSEMBLY */

#endif /* _GSWTK_H */

/* Thread Headers */
#if defined(GSWTK_INCL_THREAD) || defined(GSWTK_INCL_ALL)
#include <gswtk/kernel/os/thread.h>
#endif /* GSWTK_INCL_THREAD */

/* Reference Counting Headers */
#if defined(GSWTK_INCL_REF) || defined(GSWTK_INCL_ALL)
#include <gswtk/kernel/ref.h>
#endif /* GSWTK_INCL_REF */

/* Basic Linked List Headers */
#if defined(GSWTK_INCL_BASICLIST) || defined(GSWTK_INCL_ALL)
#include <gswtk/kernel/basiclist.h>
#endif /* GSWTK_INCL_BASICLIST */

/* Mutex Headers */
#if defined(GSWTK_INCL_MUTEX) || defined(GSWTK_INCL_ALL)
#include <gswtk/kernel/os/mutex.h>
#endif /* GSWTK_INCL_MUTEX */

/* Condition Variable Headers */
#if defined(GSWTK_INCL_COND) || defined(GSWTK_INCL_ALL)
#include <gswtk/kernel/os/cond.h>
#endif /* GSWTK_INCL_COND */

/* Memory Headers */
#if defined(GSWTK_INCL_MEMORY) || defined(GSWTK_INCL_ALL)
#include <gswtk/kernel/os/memory_macros.h>
#include <gswtk/kernel/memory.h>
#endif /* GSWTK_INCL_MEMORY */

/* Hash Table Headers */
#if defined(GSWTK_INCL_HASH) || defined(GSWTK_INCL_ALL)
#include <gswtk/kernel/hash.h>
#endif /* GSWTK_INCL_HASH */

/* String Headers */
#if defined(GSWTK_INCL_STRING) || defined(GSWTK_INCL_ALL)
#include <gswtk/kernel/string.h>
#endif /* GSWTK_INCL_STRING */

/* Quick Sort Headers */
#if defined(GSWTK_INCL_QSORT) || defined(GSWTK_INCL_ALL)
#include <gswtk/kernel/qsort.h>
#endif /* GSWTK_INCL_QSORT */

#else
/* --- GSWTK User Space Headers --- */

#ifndef _GSWTK_H
#define _GSWTK_H 1
#include <pdpi/pi_defs.h>
#endif /* _GSWTK_H */

#endif

