/*
 * $Id: mutex.h,v 1.5 2001/03/27 20:48:48 stevek Exp $
 *
 *   Section: GSWTK Kernel
 * Component: Linux-specific Mutexes
 * 
 */

#ifndef _GSWTK_KERNEL_OS_LINUX_MUTEX_H_SEEN
#define _GSWTK_KERNEL_OS_LINUX_MUTEX_H_SEEN 1

#include GSWTK_KERNEL_OS_HEADER(mach.h)

#endif /* _GSWTK_KERNEL_OS_LINUX_MUTEX_H_SEEN */


#ifndef _GSWTK_KERNEL_OS_LINUX_MUTEX_H
#define _GSWTK_KERNEL_OS_LINUX_MUTEX_H 1

#include <asm/spinlock.h>


/***************************************************************************\
 * Public structures and types                                             *
\***************************************************************************/

typedef struct gswk_mutex_os gswk_mutex_os_t;

struct gswk_mutex_os
{
   spinlock_t       mutex_lock;
   const pd_char_t *mutex_name;
#ifdef GSWTK_OPTION_DEBUG_MUTEX
   const pd_char_t *mutex_file;
   int              mutex_line;
#endif /* GSWTK_OPTION_DEBUG_MUTEX */
};


/***************************************************************************\
 * Public macros                                                           *
\***************************************************************************/

#ifndef GSWTK_OPTION_DEBUG_MUTEX
#define GSW_MUTEX_OS_INIT() { {}, (const pd_char_t *)NULL }
#else
#define GSW_MUTEX_OS_INIT() { {}, (const pd_char_t *)NULL, \
                              (const pd_char_t *)NULL, 0 }
#endif

#endif /* _GSWTK_KERNEL_OS_LINUX_MUTEX_H */

