/*
 * $Id: panic.h,v 1.3 2001/03/20 20:46:08 stevek Exp $
 *
 *   Section: GSWTK Kernel
 * Component: Panic Functions
 * 
 */

#ifndef _GSWTK_KERNEL_OS_PANIC_H
#define _GSWTK_KERNEL_OS_PANIC_H 1

/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/

void GSWKERNLINKAGE GSW_PANIC( const pd_char_t *fmt, ... );
void GSWKERNLINKAGE GSW_WARN ( const pd_char_t *fmt, ... );

/***************************************************************************\

 * Public macros                                                           *
\***************************************************************************/

#define GSW_WARNPANIC(opt,pnc) \
   do { \
      if( ( _gswk_state.runtime.options & (opt) ) != 0 ) \
         GSW_PANIC pnc; \
      else \
         GSW_WARN pnc; \
   } \
   while(0)

#ifdef GSWTK_OPTION_VARIANTS
#define GSW_ASSERT(a) \
   do { \
      if( !(a) ) \
         GSW_PANIC(PD_MAKESTR("Assertion failure: '%s' in %s at line %d\n"), \
                   PD_MAKESTR(#a), __FILE__, __LINE__); \
   } while(0)
#else
#define GSW_ASSERT(a)
#endif

#endif /* _GSWTK_KERNEL_OS_PANIC_H */

