/*
 * $Id: memory.h,v 1.3 2001/03/20 20:46:10 stevek Exp $
 *
 *   Section: GSWTK Kernel
 * Component: FreeBSD-specific Memory Management
 * 
 */

#ifndef _GSWTK_KERNEL_OS_FREEBSD_MEMORY_H
#define _GSWTK_KERNEL_OS_FREEBSD_MEMORY_H 1

#if defined(KERNEL) || defined(_KERNEL)
#include <sys/kernel.h>
#endif
#include <sys/malloc.h>

/***************************************************************************\
 * Define memory allocation types                                          *
\***************************************************************************/

MALLOC_DECLARE(M_GSWTK);


/***************************************************************************\
 * Public functions implemented as macros                                  *
\***************************************************************************/

#define gswk_mem_os_alloc(s) malloc((s), M_GSWTK, M_WAITOK)
#define gswk_mem_os_free(a)  free((a), M_GSWTK)

#endif /* _GSWTK_KERNEL_OS_FREEBSD_MEMORY_H */

