/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: pd_types.h,v 1.3 2001/05/04 20:54:27 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: This file contains system-specific types
 */

#ifndef __PD_TYPES_H
#define __PD_TYPES_H 1

#ifdef PD_IN_KERNEL
#  ifndef KERNEL
#    define KERNEL 1
#  endif
#  ifndef _KERNEL
#    define _KERNEL 1
#  endif
#  include <sys/param.h>
#else
#  include <osreldate.h>
#endif

#include <sys/types.h>


/************************************************************************\
 * Public types                                                         *
\************************************************************************/

typedef char          pd_char_t;
typedef unsigned char pd_byte_t;
typedef unsigned char pd_bool_t;
typedef off_t         pd_offset_t;

typedef int           pd_syscall_id_t;
typedef int           pd_fd_obj;
typedef pd_char_t     TCHAR;
typedef TCHAR        *LPTSTR;
typedef unsigned char BOOL;


/************************************************************************\
 * Public macros                                                        *
\************************************************************************/

#define PD_MAKESTR(a) a

#endif /* __PD_TYPES_H */

