/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: pd_defs.h,v 1.10 2001/05/09 21:16:14 stevek Exp $
 * 
 * Authors: Douglas Kilpatrick, Steve Kiernan
 */

#ifndef __PD_DEFS_H
#define __PD_DEFS_H

#if defined(__linux__)

#ifdef PD_IN_KERNEL
#ifndef PD_MOD_SET_KERNEL_VERSION
#define __NO_VERSION__          1
#endif
#define MODULE                  1
#define _LOOSE_KERNEL_NAMES     1
#endif

#include <linux/version.h>

#if LINUX_VERSION_CODE < 131584
#  error Linux kernels earlier than 2.2.x are not supported
#elif LINUX_VERSION_CODE < 131840
#  define PD_LINUX 0x02002
#elif LINUX_VERSION_CODE < 132096
#  define PD_LINUX 0x02003
#elif LINUX_VERSION_CODE < 132352
#  define PD_LINUX 0x02004
#else
#  error Linux kernels later than 2.4.x are not supported
#endif

#define PD_UNIX

#define FILESEP '/'

#define PICFLAG -fpic

#ifndef PD_ASSEMBLY
#ifndef __PD_TYPES_H
#include <pdpi/linux/pd_types.h>
#endif /* __PD_TYPES_H */
#endif /* !PD_ASSEMBLY */

#ifdef PD_IN_KERNEL
#ifndef __P
#define __P(foo) foo
#endif

#define PD_NO_QSORT_DECL        1

#ifndef SUPPRESS_MACROS
#define bzero(b,n) memset((b),0,(n))
#define bcopy(s,d,n) memcpy((d),(s),(n))
#endif

#ifndef MAXPATHLEN
#define MAXPATHLEN 1024
#endif

#else /* PD_IN_KERNEL */

#ifndef PD_ASSEMBLY
#include <sys/param.h>
#endif /* !PD_ASSEMBLY */

#endif /* PD_IN_KERNEL */

#define PD_PAGESIZE PAGE_SIZE

#ifndef LINKAGE
#define LINKAGE
#endif

#define IMPORT
#define EXPORT

#ifndef MAXNAMELEN
#define MAXNAMELEN 255
#endif

#ifndef PD_ASSEMBLY
typedef unsigned int vm_offset_t;

typedef struct task_struct proc_t;
#endif /* !PD_ASSEMBLY */

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef PD_BUILTINSUPPORT
#define PD_BUILTINSUPPORT       1
#endif

#ifndef PD_PTRPTRSUB
#define PD_PTRPTRSUB            1
#endif

#ifndef PD_NOSIGSYS
#define PD_NOSIGSYS             1
#endif

#ifndef PD_SMP_SUPPORT
#define PD_SMP_SUPPORT          1
#endif

#ifndef PD_KTHREAD_SUPPORT
#define PD_KTHREAD_SUPPORT      1
#endif

#define pd_printf printk

#endif /* __linux__ */

#endif /* __PD_DEFS_H */

