/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: pi_mutex.h,v 1.3 2001/02/23 19:02:06 stevek Exp $
 * 
 * Author: Douglas Kilpatrick, Steve Kiernan
 * 
 * Purpose:
 *    To place random platform specific typedef's and defines and header-fixes
 *    in one place.
 */

#ifndef __PI_MUTEX_H
#define __PI_MUTEX_H

#if defined(__sun__) && defined(__svr4__)
#ifndef __PD_MUTEX_H
#include <pdpi/solaris/pd_mutex.h>
#endif /* __PD_MUTEX_H */

#elif defined(__linux__)
#ifndef __PD_MUTEX_H
#include <pdpi/linux/pd_mutex.h>
#endif /* __PD_MUTEX_H */

#elif defined(__FreeBSD__)
#ifndef __PD_MUTEX_H
#include <pdpi/freebsd/pd_mutex.h>
#endif /* __PD_MUTEX_H */

#elif defined(_WIN32)
#ifndef __PD_MUTEX_H
#include <pdpi/winnt/pd_mutex.h>
#endif /* __PD_MUTEX_H */

#else
#error "Platform not supported by the common includes"
#endif

#endif /* __PI_MUTEX_H */

