/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: pd_defs.h,v 1.7 2001/04/06 22:22:50 stevek Exp $
 * 
 * Authors: Douglas Kilpatrick, Steve Kiernan
 */

#ifndef __PD_DEFS_H
#define __PD_DEFS_H


#if defined(__sun__) && defined(__svr4__)

#ifndef PD_ASSEMBLY
#ifndef __PD_TYPES_H
#include <pdpi/solaris/pd_types.h>
#endif /* __PD_TYPES_H */
#endif /* !PD_ASSEMBLY */

#define PD_SOLARIS
#define PD_UNIX
/* Solaris specific issues. */
/* No vm_offset_t typedef.  I suspect this is global to everything not BSD */
typedef unsigned int vm_offset_t;
#ifndef __P
#define __P(foo) foo
#endif

#define PD_THREADED		1
#define PD_BROKEN_SYSTM_H	1
#define PD_NO_QSORT_DECL        1
#define PD_NO_SNPRINTF_DECL     1
#define PD_BROKEN_SPRINTF_RETV  1

#define FALSE 0
#define TRUE 1

#define FILESEP '/'

#define PICFLAG -fPIC

#ifndef PD_ASSEMBLY
/* If in kernel */
#ifdef PD_IN_KERNEL
#include <sys/param.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/proc.h>
#include <sys/uio.h>
#include <sys/systm.h>
#include <sys/cmn_err.h>
#else
#include <strings.h>
#endif
#endif /* !PD_ASSEMBLY */

#ifndef MAXNAMELEN
#define MAXNAMELEN 256
#endif

#ifndef MAXPATHLEN
#define MAXPATHLEN 1024
#endif

#ifndef LINKAGE
#define LINKAGE
#endif

#define IMPORT
#define EXPORT
#endif

#ifndef PD_SMP_SUPPORT
#define PD_SMP_SUPPORT          1
#endif

#ifndef PD_KTHREAD_SUPPORT
#define PD_KTHREAD_SUPPORT      1
#endif

#define pd_printf printf

#endif /* __PD_DEFS_H */

