/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: pd_defs.h,v 1.5 2001/03/29 22:36:09 stevek Exp $
 * 
 * Authors: Douglas Kilpatrick, Steve Kiernan
 */

#ifndef __PD_DEFS_H
#define __PD_DEFS_H

#if defined(_WIN32)

#ifndef PD_ASSEMBLY
#ifndef __PD_TYPES_H
#include <pdpi/winnt/pd_types.h>
#endif /* __PD_TYPES_H */
#endif /* !PD_ASSEMBLY */

#define PD_WINNT _WIN32_WINNT

#ifndef PD_ASSEMBLY
#include <windows.h>
#include <process.h>
#ifdef __CYGWIN__
#include <mingw32/tchar.h>
#else
#include <tchar.h>
#endif
/* #include <crtdbg.h> */
#include <stdarg.h>

#ifndef __GNUC__
typedef unsigned long       u_long;
typedef DWORD               pid_t;
#endif
typedef struct proc         proc_t;
#ifndef __CYGWIN__
typedef size_t              ssize_t;
#endif
#endif /* !PD_ASSEMBLY */

#ifndef __P
#define __P(foo) foo
#endif

#define PD_THREADED             1
#define PD_NOSIGSYS             1


#define FILESEP '\\'

#ifdef __CYGWIN__
#define _MAX_PATH MAX_PATH
#endif
#define MAXPATHLEN _MAX_PATH
#define MAXNAMELEN MAXPATHLEN

#define EXPORT __declspec( dllexport )
#define IMPORT __declspec( dllimport )

#ifndef snprintf
#define snprintf _snprintf
#endif

#ifndef isatty
#define isatty _isatty
#endif

#ifndef popen
#define popen _popen
#endif

#ifndef pclose
#define pclose _pclose
#endif

#   ifndef ASSERT
#pragma warning (disable : 4127)
#       ifdef _ASSERTE
#           define ASSERT _ASSERTE
#       endif

#       ifdef _ASSERT
#           undef _ASSERT
#           define _ASSERT  ASSERT
#       endif
#   endif   // ifndef ASSERT

#ifndef PD_SMP_SUPPORT
#define PD_SMP_SUPPORT          1
#endif

#ifndef PD_KTHREAD_SUPPORT
#define PD_KTHREAD_SUPPORT      1
#endif

#endif /* Win32 */

#endif /* __PD_DEFS_H */

