/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: pd_types.h,v 1.5 2001/03/27 21:13:20 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: This file contains system-specific types
 */

#ifndef __PD_TYPES_H
#define __PD_TYPES_H 1

#include <windows.h>

#ifdef __CYGWIN__
#include <mingw32/tchar.h>
#else
#include <tchar.h>
#endif

#include <errno.h>


/************************************************************************\
 * Public types                                                         *
\************************************************************************/

#if !defined(__GNUC__)
typedef UCHAR         u_int8_t;
typedef USHORT        u_int16_t;
typedef UINT32        u_int32_t;
typedef UINT64        u_int64_t;
#elif !defined(__CYGWIN__)
typedef UCHAR         u_int8_t;
typedef USHORT        u_int16_t;
typedef UINT          u_int32_t;
typedef ULONG         u_int64_t;
#endif

typedef TCHAR         pd_char_t;
typedef unsigned char pd_byte_t;
typedef BOOL          pd_bool_t;
typedef int           pd_offset_t;

typedef int           pd_syscall_id_t;

typedef HANDLE        pd_fd_obj;

typedef struct timespec
{
   long tv_sec;
   long tv_nsec;
}
timespec_t;


/************************************************************************\
 * Public macros                                                        *
\************************************************************************/

#define PD_MAKESTR(a) _TEXT(a)

#define EALREADY 37	/* Operation already in progress */

#endif /* __PD_TYPES_H */

