#!/usr/local/bin/perl
# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: genkmod.pl,v 1.4 2001/04/05 18:40:33 stevek Exp $

my $num = ( $#ARGV + 1 ) if @ARGV;
print "Processing $num linker(s)...\n";

$| = 1;

open( OUT, '>kmod_linux.c' ) || die "kmod_linux.c: $!";

print OUT <<EOF;
/*
 * Automatically generated by genkmod.pl
 *
 * Do not modify.
 */
#include <wr_conf.h>

#include <wsi_stdlib.h>

extern int wsi_load   __P((void));
extern int wsi_unload __P((void));

#if 0
extern struct modlinkage modlinkage;
#endif

EOF

map { print OUT <<EOF
extern int linker_${_}_init __P((void));

#if 0
static struct modlmisc modlmisc_$_ =
{
   &mod_miscops,
   PD_MAKESTR("WSS - $_ module linker")
};
#endif

EOF
} @ARGV;


print OUT <<EOF;

/*
 * This is the lkm unload function.  It shuts down the WSS, restores
 * the replaced system calls, removes the exit function, removes the
 * added system calls, unloads wrapper modules, and forces LWPs to
 * reissue their system calls.
 *
 */
void cleanup_module(void)
{
    wsi_unload();
    return;
}

/*
 * This is the lkm load function.  It initializes the WSS, replaces
 * some system calls, adds an exit function, adds a new system call,
 * and prepares for the loading of wrappers.
 */
int init_module(void)
{
   int error = wsi_load();
EOF

#
# Call version-specific initialization
#
foreach $format ( @ARGV ) {
   print "  $format ";

   print OUT <<EOF;
   if( !error )
      error = linker_${format}_init();
EOF

   print "- done\n";
}

#
# Close out the file, doing final code writes
#
print OUT <<EOF;

   return error;
}

#if 0
struct modlinkage modlinkage =
{
   MODREV_1,
   {
      &modlmisc,
EOF

map { print OUT '      &modlmisc_'.$_.",\n" } @ARGV;

print OUT <<EOF;
      NULL
   }
};
#endif

EOF

close( OUT );

