#!/usr/local/bin/perl
# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: genkmod.pl,v 1.5 2001/04/05 18:40:33 stevek Exp $

die "Missing dependency list" if !@ARGV;

my $depends = $ARGV[0];
shift @ARGV;

my $num = ( $#ARGV + 1 ) if @ARGV;
print "Processing $num linker(s)...\n";

$| = 1;

open( OUT, '>kmod_solaris.c' ) || die "kmod_solaris.c: $!";

print OUT <<EOF;
/*
 * Automatically generated by genkmod.pl
 *
 * Do not modify.
 */
#include <wr_conf.h>

#include <wsi_stdlib.h>

#include <sys/modctl.h>

extern struct modlmisc modlmisc;

extern int wsi_load   __P((void));
extern int wsi_unload __P((void));

extern struct modlinkage modlinkage;

EOF

if( length( $depends ) ) {
   print OUT <<EOF;
char _depends_on[] = "$depends";

EOF
}

map { print OUT <<EOF
extern int linker_${_}_init __P((void));

static struct modlmisc modlmisc_$_ =
{
   &mod_miscops,
   PD_MAKESTR("WSS - $_ module linker")
};

EOF
} @ARGV;


print OUT <<EOF;

int
_info( struct modinfo *modinfop )
{
   return( mod_info( &modlinkage, modinfop ) );
}

int
_fini()
{
   return wsi_unload();
}

int
_init()
{
   int error = wsi_load();

EOF

#
# Call version-specific initialization
#
foreach $format ( @ARGV ) {
   print "  $format ";

   print OUT <<EOF;
   if( !error )
      error = linker_${format}_init();
EOF

   print "- done\n";
}

#
# Close out the file, doing final code writes
#
print OUT <<EOF;

   return error;
}

struct modlinkage modlinkage =
{
   MODREV_1,
   {
      &modlmisc,
EOF

map { print OUT '      &modlmisc_'.$_.",\n" } @ARGV;

print OUT <<EOF;
      NULL
   }
};

EOF

close( OUT );

