/*! \file linker_crit.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: linker_crit.h,v 1.12 2001/02/23 19:02:09 stevek Exp $
 *
 * \brief   Prototypes and structures used by the criteria linker
 * \author  Steve Kiernan
 * \version $Revision: 1.12 $
 * \date    $Date: 2001/02/23 19:02:09 $
 */

#ifndef __LINKER_CRIT_H
#define __LINKER_CRIT_H	1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifndef __WSS_LINKER_H
#include <wss_linker.h>
#endif

#include <libre.h>
#include <libcrit.h>


/***************************************************************************\
 * Public macros                                                           *
\***************************************************************************/


/***************************************************************************\
 * Public structures and types                                             *
\***************************************************************************/

typedef struct linker_crit_data linker_crit_data_t;
typedef enum linker_crit_compat linker_crit_compat_t;

struct linker_crit_data
{
   crit_header_t     *hdr;
   pd_char_t        *name;
   pd_char_t        *strtab;
   size_t             numlits;
   crit_literal_t    *littab;
   size_t             numexps;
   crit_expression_t *exptab;
   size_t             numregex;
   crit_regex_t      *regextab;
   size_t             numregexelems;
   crit_regex_node_t *regexelems;
   pd_char_t        *implist[2];
};

enum linker_crit_compat
{
   LCC_UNKNOWN,
   LCC_EXP,
   LCC_INT,
   LCC_STRING,
   LCC_RE
};


/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/


#endif /* __LINKER_CRIT_H */

