/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: gwmcomm.h,v 1.14 2001/02/23 19:02:11 stevek Exp $
 */

#ifndef __GWMCOMM_H
#define __GWMCOMM_H 1

#include <wr_conf.h>

#include <pipesrv.h>

#ifndef LINKAGE
#define LINKAGE IMPORT
#endif /* LINKAGE */
#include "../gwm/gwm.h"


/***************************************************************************\
 * Define Macros                                                           *
\***************************************************************************/

#define GWMCOMM_TRANSACT_SUCCESS      0
#define GWMCOMM_TRANSACT_WRITE_FAILED 1
#define GWMCOMM_TRANSACT_READ_FAILED  2


/***************************************************************************\
 * Public Functions                                                        *
\***************************************************************************/

BOOL gwmcommRequestWrappers       __P(( DWORD *, LPTSTR * ));
BOOL gwmcommSendCreatedChild      __P(( DWORD pid ));
BOOL gwmcommSendCreatingChild     __P(( void ));
void gwmcommSetup                 __P(( void ));
void gwmcommShutdown              __P(( void ));
int  gwmcommTransactPacket        __P(( LPPIPESRV_COMM_HEADER, PVOID,
                                        LPPIPESRV_COMM_RESP_HEADER *, PVOID *,
                                        PINT ));
BOOL gwmcommWaitForPacketResponse __P(( LPPIPESRV_COMM_RESP_HEADER *,
                                        PVOID * ));
BOOL gwmcommWritePacket           __P(( LPPIPESRV_COMM_HEADER pCommHdr,
                                        PVOID pData ));

#endif /* __GWMCOMM_H */

