/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * lwmstubs4.h
 *
 * $Id: lwmstubs4.h,v 1.7 2001/02/23 19:02:11 stevek Exp $
 *
 * Note: This file is automatically generated by genstubs.pl
 *       Do not modify.
 */

#ifndef __LWMSTUBS_H
#define __LWMSTUBS_H 1

#include "hook.h"

#ifdef __cplusplus
extern "C" {
#endif

extern const int    k_NUM_HOOKED_FUNCS;
extern HOOKFUNCDESC g_stToHookFuncs[];
extern PROC         g_pOrigFuncs[];

/*
 * Intercepted function prototypes
 */
BOOL WINAPI LWM_AbortSystemShutdownA( LPSTR lpMachineName );

BOOL WINAPI LWM_AbortSystemShutdownW( LPWSTR lpMachineName );

BOOL WINAPI LWM_AccessCheck( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                             HANDLE ClientToken,
                             DWORD DesiredAccess,
                             PGENERIC_MAPPING GenericMapping,
                             PPRIVILEGE_SET PrivilegeSet,
                             LPDWORD PrivilegeSetLength,
                             LPDWORD GrantedAccess,
                             LPBOOL AccessStatus
                           );

BOOL WINAPI LWM_AccessCheckAndAuditAlarmA( LPCSTR SubsystemName,
                                           LPVOID HandleId,
                                           LPSTR ObjectTypeName,
                                           LPSTR ObjectName,
                                           PSECURITY_DESCRIPTOR SecurityDescriptor,
                                           DWORD DesiredAccess,
                                           PGENERIC_MAPPING GenericMapping,
                                           BOOL ObjectCreation,
                                           LPDWORD GrantedAccess,
                                           LPBOOL AccessStatus,
                                           LPBOOL pfGenerateOnClose
                                         );

BOOL WINAPI LWM_AccessCheckAndAuditAlarmW( LPCWSTR SubsystemName,
                                           LPVOID HandleId,
                                           LPWSTR ObjectTypeName,
                                           LPWSTR ObjectName,
                                           PSECURITY_DESCRIPTOR SecurityDescriptor,
                                           DWORD DesiredAccess,
                                           PGENERIC_MAPPING GenericMapping,
                                           BOOL ObjectCreation,
                                           LPDWORD GrantedAccess,
                                           LPBOOL AccessStatus,
                                           LPBOOL pfGenerateOnClose
                                         );

BOOL WINAPI LWM_AddAccessAllowedAce( PACL pAcl,
                                     DWORD dwAceRevision,
                                     DWORD AccessMask,
                                     PSID pSid
                                   );

BOOL WINAPI LWM_AddAccessDeniedAce( PACL pAcl,
                                    DWORD dwAceRevision,
                                    DWORD AccessMask,
                                    PSID pSid
                                  );

BOOL WINAPI LWM_AddAce( PACL pAcl,
                        DWORD dwAceRevision,
                        DWORD dwStartingAceIndex,
                        LPVOID pAceList,
                        DWORD nAceListLength
                      );

ATOM WINAPI LWM_AddAtomA( LPCSTR lpString );

ATOM WINAPI LWM_AddAtomW( LPCWSTR lpString );

BOOL WINAPI LWM_AddAuditAccessAce( PACL pAcl,
                                   DWORD dwAceRevision,
                                   DWORD dwAccessMask,
                                   PSID pSid,
                                   BOOL bAuditSuccess,
                                   BOOL bAuditFailure
                                 );

BOOL WINAPI LWM_AdjustTokenGroups( HANDLE TokenHandle,
                                   BOOL ResetToDefault,
                                   PTOKEN_GROUPS NewState,
                                   DWORD BufferLength,
                                   PTOKEN_GROUPS PreviousState,
                                   PDWORD ReturnLength
                                 );

BOOL WINAPI LWM_AdjustTokenPrivileges( HANDLE TokenHandle,
                                       BOOL DisableAllPrivileges,
                                       PTOKEN_PRIVILEGES NewState,
                                       DWORD BufferLength,
                                       PTOKEN_PRIVILEGES PreviousState,
                                       PDWORD ReturnLength
                                     );

BOOL WINAPI LWM_AllocConsole( void );

BOOL WINAPI LWM_AllocateAndInitializeSid( PSID_IDENTIFIER_AUTHORITY pIdentifierAuthority,
                                          BYTE nSubAuthorityCount,
                                          DWORD nSubAuthority0,
                                          DWORD nSubAuthority1,
                                          DWORD nSubAuthority2,
                                          DWORD nSubAuthority3,
                                          DWORD nSubAuthority4,
                                          DWORD nSubAuthority5,
                                          DWORD nSubAuthority6,
                                          DWORD nSubAuthority7,
                                          PSID * pSid
                                        );

BOOL WINAPI LWM_AllocateLocallyUniqueId( PLUID Luid );

BOOL WINAPI LWM_AreAllAccessesGranted( DWORD GrantedAccess,
                                       DWORD DesiredAccess
                                     );

BOOL WINAPI LWM_AreAnyAccessesGranted( DWORD GrantedAccess,
                                       DWORD DesiredAccess
                                     );

BOOL WINAPI LWM_AreFileApisANSI( void );

BOOL WINAPI LWM_BackupEventLogA( HANDLE hEventLog,
                                 LPCSTR lpBackupFileName
                               );

BOOL WINAPI LWM_BackupEventLogW( HANDLE hEventLog,
                                 LPCWSTR lpBackupFileName
                               );

BOOL WINAPI LWM_BackupRead( HANDLE hFile,
                            LPBYTE lpBuffer,
                            DWORD nNumberOfBytesToRead,
                            LPDWORD lpNumberOfBytesRead,
                            BOOL bAbort,
                            BOOL bProcessSecurity,
                            LPVOID * lpContext
                          );

BOOL WINAPI LWM_BackupSeek( HANDLE hFile,
                            DWORD dwLowBytesToSeek,
                            DWORD dwHighBytesToSeek,
                            LPDWORD lpdwLowByteSeeked,
                            LPDWORD lpdwHighByteSeeked,
                            LPVOID * lpContext
                          );

BOOL WINAPI LWM_BackupWrite( HANDLE hFile,
                             LPBYTE lpBuffer,
                             DWORD nNumberOfBytesToWrite,
                             LPDWORD lpNumberOfBytesWritten,
                             BOOL bAbort,
                             BOOL bProcessSecurity,
                             LPVOID * lpContext
                           );

BOOL WINAPI LWM_Beep( DWORD dwFreq,
                      DWORD dwDuration
                    );

HANDLE WINAPI LWM_BeginUpdateResourceA( LPCSTR pFileName,
                                        BOOL bDeleteExistingResources
                                      );

HANDLE WINAPI LWM_BeginUpdateResourceW( LPCWSTR pFileName,
                                        BOOL bDeleteExistingResources
                                      );

BOOL WINAPI LWM_BuildCommDCBA( LPCSTR lpDef,
                               LPDCB lpDCB
                             );

BOOL WINAPI LWM_BuildCommDCBAndTimeoutsA( LPCSTR lpDef,
                                          LPDCB lpDCB,
                                          LPCOMMTIMEOUTS lpCommTimeouts
                                        );

BOOL WINAPI LWM_BuildCommDCBAndTimeoutsW( LPCWSTR lpDef,
                                          LPDCB lpDCB,
                                          LPCOMMTIMEOUTS lpCommTimeouts
                                        );

BOOL WINAPI LWM_BuildCommDCBW( LPCWSTR lpDef,
                               LPDCB lpDCB
                             );

BOOL WINAPI LWM_CallNamedPipeA( LPCSTR lpNamedPipeName,
                                LPVOID lpInBuffer,
                                DWORD nInBufferSize,
                                LPVOID lpOutBuffer,
                                DWORD nOutBufferSize,
                                LPDWORD lpBytesRead,
                                DWORD nTimeOut
                              );

BOOL WINAPI LWM_CallNamedPipeW( LPCWSTR lpNamedPipeName,
                                LPVOID lpInBuffer,
                                DWORD nInBufferSize,
                                LPVOID lpOutBuffer,
                                DWORD nOutBufferSize,
                                LPDWORD lpBytesRead,
                                DWORD nTimeOut
                              );

BOOL WINAPI LWM_CancelIo( HANDLE hFile );

BOOL WINAPI LWM_CancelWaitableTimer( HANDLE hTimer );

BOOL WINAPI LWM_ChangeServiceConfigA( SC_HANDLE hService,
                                      DWORD dwServiceType,
                                      DWORD dwStartType,
                                      DWORD dwErrorControl,
                                      LPCSTR lpBinaryPathName,
                                      LPCSTR lpLoadOrderGroup,
                                      LPDWORD lpdwTagId,
                                      LPCSTR lpDependencies,
                                      LPCSTR lpServiceStartName,
                                      LPCSTR lpPassword,
                                      LPCSTR lpDisplayName
                                    );

BOOL WINAPI LWM_ChangeServiceConfigW( SC_HANDLE hService,
                                      DWORD dwServiceType,
                                      DWORD dwStartType,
                                      DWORD dwErrorControl,
                                      LPCWSTR lpBinaryPathName,
                                      LPCWSTR lpLoadOrderGroup,
                                      LPDWORD lpdwTagId,
                                      LPCWSTR lpDependencies,
                                      LPCWSTR lpServiceStartName,
                                      LPCWSTR lpPassword,
                                      LPCWSTR lpDisplayName
                                    );

BOOL WINAPI LWM_ClearCommBreak( HANDLE hFile );

BOOL WINAPI LWM_ClearCommError( HANDLE hFile,
                                LPDWORD lpErrors,
                                LPCOMSTAT lpStat
                              );

BOOL WINAPI LWM_ClearEventLogA( HANDLE hEventLog,
                                LPCSTR lpBackupFileName
                              );

BOOL WINAPI LWM_ClearEventLogW( HANDLE hEventLog,
                                LPCWSTR lpBackupFileName
                              );

BOOL WINAPI LWM_CloseEventLog( HANDLE hEventLog );

BOOL WINAPI LWM_CloseHandle( HANDLE hObject );

BOOL WINAPI LWM_CloseServiceHandle( SC_HANDLE hSCObject );

BOOL WINAPI LWM_CommConfigDialogA( LPCSTR lpszName,
                                   HWND hWnd,
                                   LPCOMMCONFIG lpCC
                                 );

BOOL WINAPI LWM_CommConfigDialogW( LPCWSTR lpszName,
                                   HWND hWnd,
                                   LPCOMMCONFIG lpCC
                                 );

LONG WINAPI LWM_CompareFileTime( const FILETIME * lpFileTime1,
                                 const FILETIME * lpFileTime2
                               );

int WINAPI LWM_CompareStringA( LCID Locale,
                               DWORD dwCmpFlags,
                               LPCSTR lpString1,
                               int cchCount1,
                               LPCSTR lpString2,
                               int cchCount2
                             );

int WINAPI LWM_CompareStringW( LCID Locale,
                               DWORD dwCmpFlags,
                               LPCWSTR lpString1,
                               int cchCount1,
                               LPCWSTR lpString2,
                               int cchCount2
                             );

BOOL WINAPI LWM_ConnectNamedPipe( HANDLE hNamedPipe,
                                  LPOVERLAPPED lpOverlapped
                                );

BOOL WINAPI LWM_ContinueDebugEvent( DWORD dwProcessId,
                                    DWORD dwThreadId,
                                    DWORD dwContinueStatus
                                  );

BOOL WINAPI LWM_ControlService( SC_HANDLE hService,
                                DWORD dwControl,
                                LPSERVICE_STATUS lpServiceStatus
                              );

LCID WINAPI LWM_ConvertDefaultLocale( LCID Locale );

LPVOID WINAPI LWM_ConvertThreadToFiber( LPVOID lpParameter );

BOOL WINAPI LWM_CopyFileA( LPCSTR lpExistingFileName,
                           LPCSTR lpNewFileName,
                           BOOL bFailIfExists
                         );

BOOL WINAPI LWM_CopyFileExA( LPCSTR lpExistingFileName,
                             LPCSTR lpNewFileName,
                             LPPROGRESS_ROUTINE lpProgressRoutine,
                             LPVOID lpData,
                             LPBOOL pbCancel,
                             DWORD dwCopyFlags
                           );

BOOL WINAPI LWM_CopyFileExW( LPCWSTR lpExistingFileName,
                             LPCWSTR lpNewFileName,
                             LPPROGRESS_ROUTINE lpProgressRoutine,
                             LPVOID lpData,
                             LPBOOL pbCancel,
                             DWORD dwCopyFlags
                           );

BOOL WINAPI LWM_CopyFileW( LPCWSTR lpExistingFileName,
                           LPCWSTR lpNewFileName,
                           BOOL bFailIfExists
                         );

BOOL WINAPI LWM_CopySid( DWORD nDestinationSidLength,
                         PSID pDestinationSid,
                         PSID pSourceSid
                       );

HANDLE WINAPI LWM_CreateConsoleScreenBuffer( DWORD dwDesiredAccess,
                                             DWORD dwShareMode,
                                             const SECURITY_ATTRIBUTES * lpSecurityAttributes,
                                             DWORD dwFlags,
                                             LPVOID lpScreenBufferData
                                           );

BOOL WINAPI LWM_CreateDirectoryA( LPCSTR lpPathName,
                                  LPSECURITY_ATTRIBUTES lpSecurityAttributes
                                );

BOOL WINAPI LWM_CreateDirectoryExA( LPCSTR lpTemplateDirectory,
                                    LPCSTR lpNewDirectory,
                                    LPSECURITY_ATTRIBUTES lpSecurityAttributes
                                  );

BOOL WINAPI LWM_CreateDirectoryExW( LPCWSTR lpTemplateDirectory,
                                    LPCWSTR lpNewDirectory,
                                    LPSECURITY_ATTRIBUTES lpSecurityAttributes
                                  );

BOOL WINAPI LWM_CreateDirectoryW( LPCWSTR lpPathName,
                                  LPSECURITY_ATTRIBUTES lpSecurityAttributes
                                );

HANDLE WINAPI LWM_CreateEventA( LPSECURITY_ATTRIBUTES lpEventAttributes,
                                BOOL bManualReset,
                                BOOL bInitialState,
                                LPCSTR lpName
                              );

HANDLE WINAPI LWM_CreateEventW( LPSECURITY_ATTRIBUTES lpEventAttributes,
                                BOOL bManualReset,
                                BOOL bInitialState,
                                LPCWSTR lpName
                              );

LPVOID WINAPI LWM_CreateFiber( DWORD dwStackSize,
                               LPFIBER_START_ROUTINE lpStartAddress,
                               LPVOID lpParameter
                             );

HANDLE WINAPI LWM_CreateFileA( LPCSTR lpFileName,
                               DWORD dwDesiredAccess,
                               DWORD dwShareMode,
                               LPSECURITY_ATTRIBUTES lpSecurityAttributes,
                               DWORD dwCreationDisposition,
                               DWORD dwFlagsAndAttributes,
                               HANDLE hTemplateFile
                             );

HANDLE WINAPI LWM_CreateFileMappingA( HANDLE hFile,
                                      LPSECURITY_ATTRIBUTES lpFileMappingAttributes,
                                      DWORD flProtect,
                                      DWORD dwMaximumSizeHigh,
                                      DWORD dwMaximumSizeLow,
                                      LPCSTR lpName
                                    );

HANDLE WINAPI LWM_CreateFileMappingW( HANDLE hFile,
                                      LPSECURITY_ATTRIBUTES lpFileMappingAttributes,
                                      DWORD flProtect,
                                      DWORD dwMaximumSizeHigh,
                                      DWORD dwMaximumSizeLow,
                                      LPCWSTR lpName
                                    );

HANDLE WINAPI LWM_CreateFileW( LPCWSTR lpFileName,
                               DWORD dwDesiredAccess,
                               DWORD dwShareMode,
                               LPSECURITY_ATTRIBUTES lpSecurityAttributes,
                               DWORD dwCreationDisposition,
                               DWORD dwFlagsAndAttributes,
                               HANDLE hTemplateFile
                             );

HANDLE WINAPI LWM_CreateIoCompletionPort( HANDLE FileHandle,
                                          HANDLE ExistingCompletionPort,
                                          ULONG_PTR CompletionKey,
                                          DWORD NumberOfConcurrentThreads
                                        );

HANDLE WINAPI LWM_CreateMailslotA( LPCSTR lpName,
                                   DWORD nMaxMessageSize,
                                   DWORD lReadTimeout,
                                   LPSECURITY_ATTRIBUTES lpSecurityAttributes
                                 );

HANDLE WINAPI LWM_CreateMailslotW( LPCWSTR lpName,
                                   DWORD nMaxMessageSize,
                                   DWORD lReadTimeout,
                                   LPSECURITY_ATTRIBUTES lpSecurityAttributes
                                 );

HANDLE WINAPI LWM_CreateMutexA( LPSECURITY_ATTRIBUTES lpMutexAttributes,
                                BOOL bInitialOwner,
                                LPCSTR lpName
                              );

HANDLE WINAPI LWM_CreateMutexW( LPSECURITY_ATTRIBUTES lpMutexAttributes,
                                BOOL bInitialOwner,
                                LPCWSTR lpName
                              );

HANDLE WINAPI LWM_CreateNamedPipeA( LPCSTR lpName,
                                    DWORD dwOpenMode,
                                    DWORD dwPipeMode,
                                    DWORD nMaxInstances,
                                    DWORD nOutBufferSize,
                                    DWORD nInBufferSize,
                                    DWORD nDefaultTimeOut,
                                    LPSECURITY_ATTRIBUTES lpSecurityAttributes
                                  );

HANDLE WINAPI LWM_CreateNamedPipeW( LPCWSTR lpName,
                                    DWORD dwOpenMode,
                                    DWORD dwPipeMode,
                                    DWORD nMaxInstances,
                                    DWORD nOutBufferSize,
                                    DWORD nInBufferSize,
                                    DWORD nDefaultTimeOut,
                                    LPSECURITY_ATTRIBUTES lpSecurityAttributes
                                  );

BOOL WINAPI LWM_CreatePipe( PHANDLE hReadPipe,
                            PHANDLE hWritePipe,
                            LPSECURITY_ATTRIBUTES lpPipeAttributes,
                            DWORD nSize
                          );

BOOL WINAPI LWM_CreatePrivateObjectSecurity( PSECURITY_DESCRIPTOR ParentDescriptor,
                                             PSECURITY_DESCRIPTOR CreatorDescriptor,
                                             PSECURITY_DESCRIPTOR * NewDescriptor,
                                             BOOL IsDirectoryObject,
                                             HANDLE Token,
                                             PGENERIC_MAPPING GenericMapping
                                           );

BOOL WINAPI LWM_CreateProcessA( LPCSTR lpApplicationName,
                                LPSTR lpCommandLine,
                                LPSECURITY_ATTRIBUTES lpProcessAttributes,
                                LPSECURITY_ATTRIBUTES lpThreadAttributes,
                                BOOL bInheritHandles,
                                DWORD dwCreationFlags,
                                LPVOID lpEnvironment,
                                LPCSTR lpCurrentDirectory,
                                LPSTARTUPINFOA lpStartupInfo,
                                LPPROCESS_INFORMATION lpProcessInformation
                              );

BOOL WINAPI LWM_CreateProcessAsUserA( HANDLE hToken,
                                      LPCSTR lpApplicationName,
                                      LPSTR lpCommandLine,
                                      LPSECURITY_ATTRIBUTES lpProcessAttributes,
                                      LPSECURITY_ATTRIBUTES lpThreadAttributes,
                                      BOOL bInheritHandles,
                                      DWORD dwCreationFlags,
                                      LPVOID lpEnvironment,
                                      LPCSTR lpCurrentDirectory,
                                      LPSTARTUPINFOA lpStartupInfo,
                                      LPPROCESS_INFORMATION lpProcessInformation
                                    );

BOOL WINAPI LWM_CreateProcessAsUserW( HANDLE hToken,
                                      LPCWSTR lpApplicationName,
                                      LPWSTR lpCommandLine,
                                      LPSECURITY_ATTRIBUTES lpProcessAttributes,
                                      LPSECURITY_ATTRIBUTES lpThreadAttributes,
                                      BOOL bInheritHandles,
                                      DWORD dwCreationFlags,
                                      LPVOID lpEnvironment,
                                      LPCWSTR lpCurrentDirectory,
                                      LPSTARTUPINFOW lpStartupInfo,
                                      LPPROCESS_INFORMATION lpProcessInformation
                                    );

BOOL WINAPI LWM_CreateProcessW( LPCWSTR lpApplicationName,
                                LPWSTR lpCommandLine,
                                LPSECURITY_ATTRIBUTES lpProcessAttributes,
                                LPSECURITY_ATTRIBUTES lpThreadAttributes,
                                BOOL bInheritHandles,
                                DWORD dwCreationFlags,
                                LPVOID lpEnvironment,
                                LPCWSTR lpCurrentDirectory,
                                LPSTARTUPINFOW lpStartupInfo,
                                LPPROCESS_INFORMATION lpProcessInformation
                              );

HANDLE WINAPI LWM_CreateRemoteThread( HANDLE hProcess,
                                      LPSECURITY_ATTRIBUTES lpThreadAttributes,
                                      DWORD dwStackSize,
                                      LPTHREAD_START_ROUTINE lpStartAddress,
                                      LPVOID lpParameter,
                                      DWORD dwCreationFlags,
                                      LPDWORD lpThreadId
                                    );

HANDLE WINAPI LWM_CreateSemaphoreA( LPSECURITY_ATTRIBUTES lpSemaphoreAttributes,
                                    LONG lInitialCount,
                                    LONG lMaximumCount,
                                    LPCSTR lpName
                                  );

HANDLE WINAPI LWM_CreateSemaphoreW( LPSECURITY_ATTRIBUTES lpSemaphoreAttributes,
                                    LONG lInitialCount,
                                    LONG lMaximumCount,
                                    LPCWSTR lpName
                                  );

SC_HANDLE WINAPI LWM_CreateServiceA( SC_HANDLE hSCManager,
                                     LPCSTR lpServiceName,
                                     LPCSTR lpDisplayName,
                                     DWORD dwDesiredAccess,
                                     DWORD dwServiceType,
                                     DWORD dwStartType,
                                     DWORD dwErrorControl,
                                     LPCSTR lpBinaryPathName,
                                     LPCSTR lpLoadOrderGroup,
                                     LPDWORD lpdwTagId,
                                     LPCSTR lpDependencies,
                                     LPCSTR lpServiceStartName,
                                     LPCSTR lpPassword
                                   );

SC_HANDLE WINAPI LWM_CreateServiceW( SC_HANDLE hSCManager,
                                     LPCWSTR lpServiceName,
                                     LPCWSTR lpDisplayName,
                                     DWORD dwDesiredAccess,
                                     DWORD dwServiceType,
                                     DWORD dwStartType,
                                     DWORD dwErrorControl,
                                     LPCWSTR lpBinaryPathName,
                                     LPCWSTR lpLoadOrderGroup,
                                     LPDWORD lpdwTagId,
                                     LPCWSTR lpDependencies,
                                     LPCWSTR lpServiceStartName,
                                     LPCWSTR lpPassword
                                   );

DWORD WINAPI LWM_CreateTapePartition( HANDLE hDevice,
                                      DWORD dwPartitionMethod,
                                      DWORD dwCount,
                                      DWORD dwSize
                                    );

HANDLE WINAPI LWM_CreateThread( LPSECURITY_ATTRIBUTES lpThreadAttributes,
                                DWORD dwStackSize,
                                LPTHREAD_START_ROUTINE lpStartAddress,
                                LPVOID lpParameter,
                                DWORD dwCreationFlags,
                                LPDWORD lpThreadId
                              );

HANDLE WINAPI LWM_CreateWaitableTimerA( LPSECURITY_ATTRIBUTES lpTimerAttributes,
                                        BOOL bManualReset,
                                        LPCSTR lpTimerName
                                      );

HANDLE WINAPI LWM_CreateWaitableTimerW( LPSECURITY_ATTRIBUTES lpTimerAttributes,
                                        BOOL bManualReset,
                                        LPCWSTR lpTimerName
                                      );

BOOL WINAPI LWM_CryptAcquireContextA( HCRYPTPROV * phProv,
                                      LPCSTR pszContainer,
                                      LPCSTR pszProvider,
                                      DWORD dwProvType,
                                      DWORD dwFlags
                                    );

BOOL WINAPI LWM_CryptAcquireContextW( HCRYPTPROV * phProv,
                                      LPCWSTR pszContainer,
                                      LPCWSTR pszProvider,
                                      DWORD dwProvType,
                                      DWORD dwFlags
                                    );

BOOL WINAPI LWM_CryptCreateHash( HCRYPTPROV hProv,
                                 ALG_ID Algid,
                                 HCRYPTKEY hKey,
                                 DWORD dwFlags,
                                 HCRYPTHASH * phHash
                               );

BOOL WINAPI LWM_CryptDecrypt( HCRYPTKEY hKey,
                              HCRYPTHASH hHash,
                              BOOL Final,
                              DWORD dwFlags,
                              BYTE * pbData,
                              DWORD * pdwDataLen
                            );

BOOL WINAPI LWM_CryptDeriveKey( HCRYPTPROV hProv,
                                ALG_ID Algid,
                                HCRYPTHASH hBaseData,
                                DWORD dwFlags,
                                HCRYPTKEY * phKey
                              );

BOOL WINAPI LWM_CryptDestroyHash( HCRYPTHASH hHash );

BOOL WINAPI LWM_CryptDestroyKey( HCRYPTKEY hKey );

BOOL WINAPI LWM_CryptEncrypt( HCRYPTKEY hKey,
                              HCRYPTHASH hHash,
                              BOOL Final,
                              DWORD dwFlags,
                              BYTE * pbData,
                              DWORD * pdwDataLen,
                              DWORD dwBufLen
                            );

BOOL WINAPI LWM_CryptExportKey( HCRYPTKEY hKey,
                                HCRYPTKEY hExpKey,
                                DWORD dwBlobType,
                                DWORD dwFlags,
                                BYTE * pbData,
                                DWORD * pdwDataLen
                              );

BOOL WINAPI LWM_CryptGenKey( HCRYPTPROV hProv,
                             ALG_ID Algid,
                             DWORD dwFlags,
                             HCRYPTKEY * phKey
                           );

BOOL WINAPI LWM_CryptGenRandom( HCRYPTPROV hProv,
                                DWORD dwLen,
                                BYTE * pbBuffer
                              );

BOOL WINAPI LWM_CryptGetHashParam( HCRYPTHASH hHash,
                                   DWORD dwParam,
                                   BYTE * pbData,
                                   DWORD * pdwDataLen,
                                   DWORD dwFlags
                                 );

BOOL WINAPI LWM_CryptGetKeyParam( HCRYPTKEY hKey,
                                  DWORD dwParam,
                                  BYTE * pbData,
                                  DWORD * pdwDataLen,
                                  DWORD dwFlags
                                );

BOOL WINAPI LWM_CryptGetProvParam( HCRYPTPROV hProv,
                                   DWORD dwParam,
                                   BYTE * pbData,
                                   DWORD * pdwDataLen,
                                   DWORD dwFlags
                                 );

BOOL WINAPI LWM_CryptGetUserKey( HCRYPTPROV hProv,
                                 DWORD dwKeySpec,
                                 HCRYPTKEY * phUserKey
                               );

BOOL WINAPI LWM_CryptHashData( HCRYPTHASH hHash,
                               const BYTE * pbData,
                               DWORD dwDataLen,
                               DWORD dwFlags
                             );

BOOL WINAPI LWM_CryptHashSessionKey( HCRYPTHASH hHash,
                                     HCRYPTKEY hKey,
                                     DWORD dwFlags
                                   );

BOOL WINAPI LWM_CryptImportKey( HCRYPTPROV hProv,
                                const BYTE * pbData,
                                DWORD dwDataLen,
                                HCRYPTKEY hPubKey,
                                DWORD dwFlags,
                                HCRYPTKEY * phKey
                              );

BOOL WINAPI LWM_CryptReleaseContext( HCRYPTPROV hProv,
                                     ULONG_PTR dwFlags
                                   );

BOOL WINAPI LWM_CryptSetHashParam( HCRYPTHASH hHash,
                                   DWORD dwParam,
                                   BYTE * pbData,
                                   DWORD dwFlags
                                 );

BOOL WINAPI LWM_CryptSetKeyParam( HCRYPTKEY hKey,
                                  DWORD dwParam,
                                  BYTE * pbData,
                                  DWORD dwFlags
                                );

BOOL WINAPI LWM_CryptSetProvParam( HCRYPTPROV hProv,
                                   DWORD dwParam,
                                   BYTE * pbData,
                                   DWORD dwFlags
                                 );

BOOL WINAPI LWM_CryptSetProviderA( LPCSTR pszProvName,
                                   DWORD dwProvType
                                 );

BOOL WINAPI LWM_CryptSetProviderW( LPCWSTR pszProvName,
                                   DWORD dwProvType
                                 );

BOOL WINAPI LWM_CryptSignHashA( HCRYPTHASH hHash,
                                DWORD dwKeySpec,
                                LPCSTR sDescription,
                                DWORD dwFlags,
                                BYTE * pbSignature,
                                DWORD * pdwSigLen
                              );

BOOL WINAPI LWM_CryptSignHashW( HCRYPTHASH hHash,
                                DWORD dwKeySpec,
                                LPCWSTR sDescription,
                                DWORD dwFlags,
                                BYTE * pbSignature,
                                DWORD * pdwSigLen
                              );

BOOL WINAPI LWM_CryptVerifySignatureA( HCRYPTHASH hHash,
                                       const BYTE * pbSignature,
                                       DWORD dwSigLen,
                                       HCRYPTKEY hPubKey,
                                       LPCSTR sDescription,
                                       DWORD dwFlags
                                     );

BOOL WINAPI LWM_CryptVerifySignatureW( HCRYPTHASH hHash,
                                       const BYTE * pbSignature,
                                       DWORD dwSigLen,
                                       HCRYPTKEY hPubKey,
                                       LPCWSTR sDescription,
                                       DWORD dwFlags
                                     );

BOOL WINAPI LWM_DebugActiveProcess( DWORD dwProcessId );

void WINAPI LWM_DebugBreak( void );

BOOL WINAPI LWM_DefineDosDeviceA( DWORD dwFlags,
                                  LPCSTR lpDeviceName,
                                  LPCSTR lpTargetPath
                                );

BOOL WINAPI LWM_DefineDosDeviceW( DWORD dwFlags,
                                  LPCWSTR lpDeviceName,
                                  LPCWSTR lpTargetPath
                                );

BOOL WINAPI LWM_DeleteAce( PACL pAcl,
                           DWORD dwAceIndex
                         );

ATOM WINAPI LWM_DeleteAtom( ATOM nAtom );

void WINAPI LWM_DeleteFiber( LPVOID lpFiber );

BOOL WINAPI LWM_DeleteFileA( LPCSTR lpFileName );

BOOL WINAPI LWM_DeleteFileW( LPCWSTR lpFileName );

BOOL WINAPI LWM_DeleteService( SC_HANDLE hService );

BOOL WINAPI LWM_DeregisterEventSource( HANDLE hEventLog );

BOOL WINAPI LWM_DestroyPrivateObjectSecurity( PSECURITY_DESCRIPTOR * ObjectDescriptor );

BOOL WINAPI LWM_DeviceIoControl( HANDLE hDevice,
                                 DWORD dwIoControlCode,
                                 LPVOID lpInBuffer,
                                 DWORD nInBufferSize,
                                 LPVOID lpOutBuffer,
                                 DWORD nOutBufferSize,
                                 LPDWORD lpBytesReturned,
                                 LPOVERLAPPED lpOverlapped
                               );

BOOL WINAPI LWM_DisableThreadLibraryCalls( HMODULE hLibModule );

BOOL WINAPI LWM_DisconnectNamedPipe( HANDLE hNamedPipe );

BOOL WINAPI LWM_DosDateTimeToFileTime( WORD wFatDate,
                                       WORD wFatTime,
                                       LPFILETIME lpFileTime
                                     );

BOOL WINAPI LWM_DuplicateHandle( HANDLE hSourceProcessHandle,
                                 HANDLE hSourceHandle,
                                 HANDLE hTargetProcessHandle,
                                 LPHANDLE lpTargetHandle,
                                 DWORD dwDesiredAccess,
                                 BOOL bInheritHandle,
                                 DWORD dwOptions
                               );

BOOL WINAPI LWM_DuplicateToken( HANDLE ExistingTokenHandle,
                                SECURITY_IMPERSONATION_LEVEL ImpersonationLevel,
                                PHANDLE DuplicateTokenHandle
                              );

BOOL WINAPI LWM_DuplicateTokenEx( HANDLE hExistingToken,
                                  DWORD dwDesiredAccess,
                                  LPSECURITY_ATTRIBUTES lpTokenAttributes,
                                  SECURITY_IMPERSONATION_LEVEL ImpersonationLevel,
                                  TOKEN_TYPE TokenType,
                                  PHANDLE phNewToken
                                );

BOOL WINAPI LWM_EndUpdateResourceA( HANDLE hUpdate,
                                    BOOL fDiscard
                                  );

BOOL WINAPI LWM_EndUpdateResourceW( HANDLE hUpdate,
                                    BOOL fDiscard
                                  );

BOOL WINAPI LWM_EnumCalendarInfoA( CALINFO_ENUMPROCA lpCalInfoEnumProc,
                                   LCID Locale,
                                   CALID Calendar,
                                   CALTYPE CalType
                                 );

BOOL WINAPI LWM_EnumCalendarInfoW( CALINFO_ENUMPROCW lpCalInfoEnumProc,
                                   LCID Locale,
                                   CALID Calendar,
                                   CALTYPE CalType
                                 );

BOOL WINAPI LWM_EnumDateFormatsA( DATEFMT_ENUMPROCA lpDateFmtEnumProc,
                                  LCID Locale,
                                  DWORD dwFlags
                                );

BOOL WINAPI LWM_EnumDateFormatsW( DATEFMT_ENUMPROCW lpDateFmtEnumProc,
                                  LCID Locale,
                                  DWORD dwFlags
                                );

BOOL WINAPI LWM_EnumDependentServicesA( SC_HANDLE hService,
                                        DWORD dwServiceState,
                                        LPENUM_SERVICE_STATUSA lpServices,
                                        DWORD cbBufSize,
                                        LPDWORD pcbBytesNeeded,
                                        LPDWORD lpServicesReturned
                                      );

BOOL WINAPI LWM_EnumDependentServicesW( SC_HANDLE hService,
                                        DWORD dwServiceState,
                                        LPENUM_SERVICE_STATUSW lpServices,
                                        DWORD cbBufSize,
                                        LPDWORD pcbBytesNeeded,
                                        LPDWORD lpServicesReturned
                                      );

BOOL WINAPI LWM_EnumResourceLanguagesA( HMODULE hModule,
                                        LPCSTR lpType,
                                        LPCSTR lpName,
                                        ENUMRESLANGPROCA lpEnumFunc,
                                        LONG_PTR lParam
                                      );

BOOL WINAPI LWM_EnumResourceLanguagesW( HMODULE hModule,
                                        LPCWSTR lpType,
                                        LPCWSTR lpName,
                                        ENUMRESLANGPROCW lpEnumFunc,
                                        LONG_PTR lParam
                                      );

BOOL WINAPI LWM_EnumResourceNamesA( HMODULE hModule,
                                    LPCSTR lpType,
                                    ENUMRESNAMEPROCA lpEnumFunc,
                                    LONG_PTR lParam
                                  );

BOOL WINAPI LWM_EnumResourceNamesW( HMODULE hModule,
                                    LPCWSTR lpType,
                                    ENUMRESNAMEPROCW lpEnumFunc,
                                    LONG_PTR lParam
                                  );

BOOL WINAPI LWM_EnumResourceTypesA( HMODULE hModule,
                                    ENUMRESTYPEPROCA lpEnumFunc,
                                    LONG_PTR lParam
                                  );

BOOL WINAPI LWM_EnumResourceTypesW( HMODULE hModule,
                                    ENUMRESTYPEPROCW lpEnumFunc,
                                    LONG_PTR lParam
                                  );

BOOL WINAPI LWM_EnumServicesStatusA( SC_HANDLE hSCManager,
                                     DWORD dwServiceType,
                                     DWORD dwServiceState,
                                     LPENUM_SERVICE_STATUSA lpServices,
                                     DWORD cbBufSize,
                                     LPDWORD pcbBytesNeeded,
                                     LPDWORD lpServicesReturned,
                                     LPDWORD lpResumeHandle
                                   );

BOOL WINAPI LWM_EnumServicesStatusExA( SC_HANDLE hSCManager,
                                       SC_ENUM_TYPE InfoLevel,
                                       DWORD dwServiceType,
                                       DWORD dwServiceState,
                                       LPBYTE lpServices,
                                       DWORD cbBufSize,
                                       LPDWORD pcbBytesNeeded,
                                       LPDWORD lpServicesReturned,
                                       LPDWORD lpResumeHandle,
                                       LPCSTR pszGroupName
                                     );

BOOL WINAPI LWM_EnumServicesStatusExW( SC_HANDLE hSCManager,
                                       SC_ENUM_TYPE InfoLevel,
                                       DWORD dwServiceType,
                                       DWORD dwServiceState,
                                       LPBYTE lpServices,
                                       DWORD cbBufSize,
                                       LPDWORD pcbBytesNeeded,
                                       LPDWORD lpServicesReturned,
                                       LPDWORD lpResumeHandle,
                                       LPCWSTR pszGroupName
                                     );

BOOL WINAPI LWM_EnumServicesStatusW( SC_HANDLE hSCManager,
                                     DWORD dwServiceType,
                                     DWORD dwServiceState,
                                     LPENUM_SERVICE_STATUSW lpServices,
                                     DWORD cbBufSize,
                                     LPDWORD pcbBytesNeeded,
                                     LPDWORD lpServicesReturned,
                                     LPDWORD lpResumeHandle
                                   );

BOOL WINAPI LWM_EnumSystemCodePagesA( CODEPAGE_ENUMPROCA lpCodePageEnumProc,
                                      DWORD dwFlags
                                    );

BOOL WINAPI LWM_EnumSystemCodePagesW( CODEPAGE_ENUMPROCW lpCodePageEnumProc,
                                      DWORD dwFlags
                                    );

BOOL WINAPI LWM_EnumSystemLocalesA( LOCALE_ENUMPROCA lpLocaleEnumProc,
                                    DWORD dwFlags
                                  );

BOOL WINAPI LWM_EnumSystemLocalesW( LOCALE_ENUMPROCW lpLocaleEnumProc,
                                    DWORD dwFlags
                                  );

BOOL WINAPI LWM_EnumTimeFormatsA( TIMEFMT_ENUMPROCA lpTimeFmtEnumProc,
                                  LCID Locale,
                                  DWORD dwFlags
                                );

BOOL WINAPI LWM_EnumTimeFormatsW( TIMEFMT_ENUMPROCW lpTimeFmtEnumProc,
                                  LCID Locale,
                                  DWORD dwFlags
                                );

BOOL WINAPI LWM_EqualPrefixSid( PSID pSid1,
                                PSID pSid2
                              );

BOOL WINAPI LWM_EqualSid( PSID pSid1,
                          PSID pSid2
                        );

DWORD WINAPI LWM_EraseTape( HANDLE hDevice,
                            DWORD dwEraseType,
                            BOOL bImmediate
                          );

BOOL WINAPI LWM_EscapeCommFunction( HANDLE hFile,
                                    DWORD dwFunc
                                  );

void WINAPI LWM_ExitProcess( UINT uExitCode );

void WINAPI LWM_ExitThread( DWORD dwExitCode );

DWORD WINAPI LWM_ExpandEnvironmentStringsA( LPCSTR lpSrc,
                                            LPSTR lpDst,
                                            DWORD nSize
                                          );

DWORD WINAPI LWM_ExpandEnvironmentStringsW( LPCWSTR lpSrc,
                                            LPWSTR lpDst,
                                            DWORD nSize
                                          );

void WINAPI LWM_FatalAppExitA( UINT uAction,
                               LPCSTR lpMessageText
                             );

void WINAPI LWM_FatalAppExitW( UINT uAction,
                               LPCWSTR lpMessageText
                             );

void WINAPI LWM_FatalExit( int ExitCode );

BOOL WINAPI LWM_FileTimeToDosDateTime( const FILETIME * lpFileTime,
                                       LPWORD lpFatDate,
                                       LPWORD lpFatTime
                                     );

BOOL WINAPI LWM_FileTimeToLocalFileTime( const FILETIME * lpFileTime,
                                         LPFILETIME lpLocalFileTime
                                       );

BOOL WINAPI LWM_FileTimeToSystemTime( const FILETIME * lpFileTime,
                                      LPSYSTEMTIME lpSystemTime
                                    );

BOOL WINAPI LWM_FillConsoleOutputAttribute( HANDLE hConsoleOutput,
                                            WORD wAttribute,
                                            DWORD nLength,
                                            COORD dwWriteCoord,
                                            LPDWORD lpNumberOfAttrsWritten
                                          );

BOOL WINAPI LWM_FillConsoleOutputCharacterA( HANDLE hConsoleOutput,
                                             CHAR cCharacter,
                                             DWORD nLength,
                                             COORD dwWriteCoord,
                                             LPDWORD lpNumberOfCharsWritten
                                           );

BOOL WINAPI LWM_FillConsoleOutputCharacterW( HANDLE hConsoleOutput,
                                             WCHAR cCharacter,
                                             DWORD nLength,
                                             COORD dwWriteCoord,
                                             LPDWORD lpNumberOfCharsWritten
                                           );

ATOM WINAPI LWM_FindAtomA( LPCSTR lpString );

ATOM WINAPI LWM_FindAtomW( LPCWSTR lpString );

BOOL WINAPI LWM_FindClose( HANDLE hFindFile );

BOOL WINAPI LWM_FindCloseChangeNotification( HANDLE hChangeHandle );

HANDLE WINAPI LWM_FindFirstChangeNotificationA( LPCSTR lpPathName,
                                                BOOL bWatchSubtree,
                                                DWORD dwNotifyFilter
                                              );

HANDLE WINAPI LWM_FindFirstChangeNotificationW( LPCWSTR lpPathName,
                                                BOOL bWatchSubtree,
                                                DWORD dwNotifyFilter
                                              );

HANDLE WINAPI LWM_FindFirstFileA( LPCSTR lpFileName,
                                  LPWIN32_FIND_DATAA lpFindFileData
                                );

HANDLE WINAPI LWM_FindFirstFileExA( LPCSTR lpFileName,
                                    FINDEX_INFO_LEVELS fInfoLevelId,
                                    LPVOID lpFindFileData,
                                    FINDEX_SEARCH_OPS fSearchOp,
                                    LPVOID lpSearchFilter,
                                    DWORD dwAdditionalFlags
                                  );

HANDLE WINAPI LWM_FindFirstFileExW( LPCWSTR lpFileName,
                                    FINDEX_INFO_LEVELS fInfoLevelId,
                                    LPVOID lpFindFileData,
                                    FINDEX_SEARCH_OPS fSearchOp,
                                    LPVOID lpSearchFilter,
                                    DWORD dwAdditionalFlags
                                  );

HANDLE WINAPI LWM_FindFirstFileW( LPCWSTR lpFileName,
                                  LPWIN32_FIND_DATAW lpFindFileData
                                );

BOOL WINAPI LWM_FindFirstFreeAce( PACL pAcl,
                                  LPVOID * pAce
                                );

BOOL WINAPI LWM_FindNextChangeNotification( HANDLE hChangeHandle );

BOOL WINAPI LWM_FindNextFileA( HANDLE hFindFile,
                               LPWIN32_FIND_DATAA lpFindFileData
                             );

BOOL WINAPI LWM_FindNextFileW( HANDLE hFindFile,
                               LPWIN32_FIND_DATAW lpFindFileData
                             );

HRSRC WINAPI LWM_FindResourceA( HMODULE hModule,
                                LPCSTR lpName,
                                LPCSTR lpType
                              );

HRSRC WINAPI LWM_FindResourceExA( HMODULE hModule,
                                  LPCSTR lpType,
                                  LPCSTR lpName,
                                  WORD wLanguage
                                );

HRSRC WINAPI LWM_FindResourceExW( HMODULE hModule,
                                  LPCWSTR lpType,
                                  LPCWSTR lpName,
                                  WORD wLanguage
                                );

HRSRC WINAPI LWM_FindResourceW( HMODULE hModule,
                                LPCWSTR lpName,
                                LPCWSTR lpType
                              );

BOOL WINAPI LWM_FlushConsoleInputBuffer( HANDLE hConsoleInput );

BOOL WINAPI LWM_FlushFileBuffers( HANDLE hFile );

BOOL WINAPI LWM_FlushInstructionCache( HANDLE hProcess,
                                       LPCVOID lpBaseAddress,
                                       DWORD dwSize
                                     );

BOOL WINAPI LWM_FlushViewOfFile( LPCVOID lpBaseAddress,
                                 SIZE_T dwNumberOfBytesToFlush
                               );

int WINAPI LWM_FoldStringA( DWORD dwMapFlags,
                            LPCSTR lpSrcStr,
                            int cchSrc,
                            LPSTR lpDestStr,
                            int cchDest
                          );

int WINAPI LWM_FoldStringW( DWORD dwMapFlags,
                            LPCWSTR lpSrcStr,
                            int cchSrc,
                            LPWSTR lpDestStr,
                            int cchDest
                          );

DWORD WINAPI LWM_FormatMessageA( DWORD dwFlags,
                                 LPCVOID lpSource,
                                 DWORD dwMessageId,
                                 DWORD dwLanguageId,
                                 LPSTR lpBuffer,
                                 DWORD nSize,
                                 va_list * Arguments
                               );

DWORD WINAPI LWM_FormatMessageW( DWORD dwFlags,
                                 LPCVOID lpSource,
                                 DWORD dwMessageId,
                                 DWORD dwLanguageId,
                                 LPWSTR lpBuffer,
                                 DWORD nSize,
                                 va_list * Arguments
                               );

BOOL WINAPI LWM_FreeConsole( void );

BOOL WINAPI LWM_FreeEnvironmentStringsA( LPSTR lpStr1 );

BOOL WINAPI LWM_FreeEnvironmentStringsW( LPWSTR lpWStr1 );

BOOL WINAPI LWM_FreeLibrary( HMODULE hLibModule );

void WINAPI LWM_FreeLibraryAndExitThread( HMODULE hLibModule,
                                          DWORD dwExitCode
                                        );

BOOL WINAPI LWM_FreeResource( HGLOBAL hResData );

PVOID WINAPI LWM_FreeSid( PSID pSid );

BOOL WINAPI LWM_GenerateConsoleCtrlEvent( DWORD dwCtrlEvent,
                                          DWORD dwProcessGroupId
                                        );

UINT WINAPI LWM_GetACP( void );

BOOL WINAPI LWM_GetAce( PACL pAcl,
                        DWORD dwAceIndex,
                        LPVOID * pAce
                      );

BOOL WINAPI LWM_GetAclInformation( PACL pAcl,
                                   LPVOID pAclInformation,
                                   DWORD nAclInformationLength,
                                   ACL_INFORMATION_CLASS dwAclInformationClass
                                 );

UINT WINAPI LWM_GetAtomNameA( ATOM nAtom,
                              LPSTR lpBuffer,
                              int nSize
                            );

UINT WINAPI LWM_GetAtomNameW( ATOM nAtom,
                              LPWSTR lpBuffer,
                              int nSize
                            );

BOOL WINAPI LWM_GetBinaryTypeA( LPCSTR lpApplicationName,
                                LPDWORD lpBinaryType
                              );

BOOL WINAPI LWM_GetBinaryTypeW( LPCWSTR lpApplicationName,
                                LPDWORD lpBinaryType
                              );

BOOL WINAPI LWM_GetCPInfo( UINT CodePage,
                           LPCPINFO lpCPInfo
                         );

BOOL WINAPI LWM_GetCommConfig( HANDLE hCommDev,
                               LPCOMMCONFIG lpCC,
                               LPDWORD lpdwSize
                             );

BOOL WINAPI LWM_GetCommMask( HANDLE hFile,
                             LPDWORD lpEvtMask
                           );

BOOL WINAPI LWM_GetCommModemStatus( HANDLE hFile,
                                    LPDWORD lpModemStat
                                  );

BOOL WINAPI LWM_GetCommProperties( HANDLE hFile,
                                   LPCOMMPROP lpCommProp
                                 );

BOOL WINAPI LWM_GetCommState( HANDLE hFile,
                              LPDCB lpDCB
                            );

BOOL WINAPI LWM_GetCommTimeouts( HANDLE hFile,
                                 LPCOMMTIMEOUTS lpCommTimeouts
                               );

LPSTR WINAPI LWM_GetCommandLineA( void );

LPWSTR WINAPI LWM_GetCommandLineW( void );

DWORD WINAPI LWM_GetCompressedFileSizeA( LPCSTR lpFileName,
                                         LPDWORD lpFileSizeHigh
                                       );

DWORD WINAPI LWM_GetCompressedFileSizeW( LPCWSTR lpFileName,
                                         LPDWORD lpFileSizeHigh
                                       );

BOOL WINAPI LWM_GetComputerNameA( LPSTR lpBuffer,
                                  LPDWORD nSize
                                );

BOOL WINAPI LWM_GetComputerNameW( LPWSTR lpBuffer,
                                  LPDWORD nSize
                                );

UINT WINAPI LWM_GetConsoleCP( void );

BOOL WINAPI LWM_GetConsoleCursorInfo( HANDLE hConsoleOutput,
                                      PCONSOLE_CURSOR_INFO lpConsoleCursorInfo
                                    );

BOOL WINAPI LWM_GetConsoleMode( HANDLE hConsoleHandle,
                                LPDWORD lpMode
                              );

UINT WINAPI LWM_GetConsoleOutputCP( void );

BOOL WINAPI LWM_GetConsoleScreenBufferInfo( HANDLE hConsoleOutput,
                                            PCONSOLE_SCREEN_BUFFER_INFO lpConsoleScreenBufferInfo
                                          );

DWORD WINAPI LWM_GetConsoleTitleA( LPSTR lpConsoleTitle,
                                   DWORD nSize
                                 );

DWORD WINAPI LWM_GetConsoleTitleW( LPWSTR lpConsoleTitle,
                                   DWORD nSize
                                 );

int WINAPI LWM_GetCurrencyFormatA( LCID Locale,
                                   DWORD dwFlags,
                                   LPCSTR lpValue,
                                   const CURRENCYFMTA * lpFormat,
                                   LPSTR lpCurrencyStr,
                                   int cchCurrency
                                 );

int WINAPI LWM_GetCurrencyFormatW( LCID Locale,
                                   DWORD dwFlags,
                                   LPCWSTR lpValue,
                                   const CURRENCYFMTW * lpFormat,
                                   LPWSTR lpCurrencyStr,
                                   int cchCurrency
                                 );

DWORD WINAPI LWM_GetCurrentDirectoryA( DWORD nBufferLength,
                                       LPSTR lpBuffer
                                     );

DWORD WINAPI LWM_GetCurrentDirectoryW( DWORD nBufferLength,
                                       LPWSTR lpBuffer
                                     );

BOOL WINAPI LWM_GetCurrentHwProfileA( LPHW_PROFILE_INFOA lpHwProfileInfo );

BOOL WINAPI LWM_GetCurrentHwProfileW( LPHW_PROFILE_INFOW lpHwProfileInfo );

HANDLE WINAPI LWM_GetCurrentProcess( void );

DWORD WINAPI LWM_GetCurrentProcessId( void );

HANDLE WINAPI LWM_GetCurrentThread( void );

DWORD WINAPI LWM_GetCurrentThreadId( void );

int WINAPI LWM_GetDateFormatA( LCID Locale,
                               DWORD dwFlags,
                               const SYSTEMTIME * lpDate,
                               LPCSTR lpFormat,
                               LPSTR lpDateStr,
                               int cchDate
                             );

int WINAPI LWM_GetDateFormatW( LCID Locale,
                               DWORD dwFlags,
                               const SYSTEMTIME * lpDate,
                               LPCWSTR lpFormat,
                               LPWSTR lpDateStr,
                               int cchDate
                             );

BOOL WINAPI LWM_GetDefaultCommConfigA( LPCSTR lpszName,
                                       LPCOMMCONFIG lpCC,
                                       LPDWORD lpdwSize
                                     );

BOOL WINAPI LWM_GetDefaultCommConfigW( LPCWSTR lpszName,
                                       LPCOMMCONFIG lpCC,
                                       LPDWORD lpdwSize
                                     );

BOOL WINAPI LWM_GetDiskFreeSpaceA( LPCSTR lpRootPathName,
                                   LPDWORD lpSectorsPerCluster,
                                   LPDWORD lpBytesPerSector,
                                   LPDWORD lpNumberOfFreeClusters,
                                   LPDWORD lpTotalNumberOfClusters
                                 );

BOOL WINAPI LWM_GetDiskFreeSpaceExA( LPCSTR lpDirectoryName,
                                     PULARGE_INTEGER lpFreeBytesAvailableToCaller,
                                     PULARGE_INTEGER lpTotalNumberOfBytes,
                                     PULARGE_INTEGER lpTotalNumberOfFreeBytes
                                   );

BOOL WINAPI LWM_GetDiskFreeSpaceExW( LPCWSTR lpDirectoryName,
                                     PULARGE_INTEGER lpFreeBytesAvailableToCaller,
                                     PULARGE_INTEGER lpTotalNumberOfBytes,
                                     PULARGE_INTEGER lpTotalNumberOfFreeBytes
                                   );

BOOL WINAPI LWM_GetDiskFreeSpaceW( LPCWSTR lpRootPathName,
                                   LPDWORD lpSectorsPerCluster,
                                   LPDWORD lpBytesPerSector,
                                   LPDWORD lpNumberOfFreeClusters,
                                   LPDWORD lpTotalNumberOfClusters
                                 );

UINT WINAPI LWM_GetDriveTypeA( LPCSTR lpRootPathName );

UINT WINAPI LWM_GetDriveTypeW( LPCWSTR lpRootPathName );

LPSTR WINAPI LWM_GetEnvironmentStrings( void );

LPWSTR WINAPI LWM_GetEnvironmentStringsW( void );

DWORD WINAPI LWM_GetEnvironmentVariableA( LPCSTR lpName,
                                          LPSTR lpBuffer,
                                          DWORD nSize
                                        );

DWORD WINAPI LWM_GetEnvironmentVariableW( LPCWSTR lpName,
                                          LPWSTR lpBuffer,
                                          DWORD nSize
                                        );

BOOL WINAPI LWM_GetExitCodeProcess( HANDLE hProcess,
                                    LPDWORD lpExitCode
                                  );

BOOL WINAPI LWM_GetExitCodeThread( HANDLE hThread,
                                   LPDWORD lpExitCode
                                 );

DWORD WINAPI LWM_GetFileAttributesA( LPCSTR lpFileName );

BOOL WINAPI LWM_GetFileAttributesExA( LPCSTR lpFileName,
                                      GET_FILEEX_INFO_LEVELS fInfoLevelId,
                                      LPVOID lpFileInformation
                                    );

BOOL WINAPI LWM_GetFileAttributesExW( LPCWSTR lpFileName,
                                      GET_FILEEX_INFO_LEVELS fInfoLevelId,
                                      LPVOID lpFileInformation
                                    );

DWORD WINAPI LWM_GetFileAttributesW( LPCWSTR lpFileName );

BOOL WINAPI LWM_GetFileInformationByHandle( HANDLE hFile,
                                            LPBY_HANDLE_FILE_INFORMATION lpFileInformation
                                          );

BOOL WINAPI LWM_GetFileSecurityA( LPCSTR lpFileName,
                                  SECURITY_INFORMATION RequestedInformation,
                                  PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                  DWORD nLength,
                                  LPDWORD lpnLengthNeeded
                                );

BOOL WINAPI LWM_GetFileSecurityW( LPCWSTR lpFileName,
                                  SECURITY_INFORMATION RequestedInformation,
                                  PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                  DWORD nLength,
                                  LPDWORD lpnLengthNeeded
                                );

DWORD WINAPI LWM_GetFileSize( HANDLE hFile,
                              LPDWORD lpFileSizeHigh
                            );

BOOL WINAPI LWM_GetFileTime( HANDLE hFile,
                             LPFILETIME lpCreationTime,
                             LPFILETIME lpLastAccessTime,
                             LPFILETIME lpLastWriteTime
                           );

DWORD WINAPI LWM_GetFileType( HANDLE hFile );

DWORD WINAPI LWM_GetFullPathNameA( LPCSTR lpFileName,
                                   DWORD nBufferLength,
                                   LPSTR lpBuffer,
                                   LPSTR * lpFilePart
                                 );

DWORD WINAPI LWM_GetFullPathNameW( LPCWSTR lpFileName,
                                   DWORD nBufferLength,
                                   LPWSTR lpBuffer,
                                   LPWSTR * lpFilePart
                                 );

BOOL WINAPI LWM_GetHandleInformation( HANDLE hObject,
                                      LPDWORD lpdwFlags
                                    );

BOOL WINAPI LWM_GetKernelObjectSecurity( HANDLE Handle,
                                         SECURITY_INFORMATION RequestedInformation,
                                         PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                         DWORD nLength,
                                         LPDWORD lpnLengthNeeded
                                       );

COORD WINAPI LWM_GetLargestConsoleWindowSize( HANDLE hConsoleOutput );

DWORD WINAPI LWM_GetLastError( void );

DWORD WINAPI LWM_GetLengthSid( PSID pSid );

void WINAPI LWM_GetLocalTime( LPSYSTEMTIME lpSystemTime );

int WINAPI LWM_GetLocaleInfoA( LCID Locale,
                               LCTYPE LCType,
                               LPSTR lpLCData,
                               int cchData
                             );

int WINAPI LWM_GetLocaleInfoW( LCID Locale,
                               LCTYPE LCType,
                               LPWSTR lpLCData,
                               int cchData
                             );

DWORD WINAPI LWM_GetLogicalDriveStringsA( DWORD nBufferLength,
                                          LPSTR lpBuffer
                                        );

DWORD WINAPI LWM_GetLogicalDriveStringsW( DWORD nBufferLength,
                                          LPWSTR lpBuffer
                                        );

DWORD WINAPI LWM_GetLogicalDrives( void );

BOOL WINAPI LWM_GetMailslotInfo( HANDLE hMailslot,
                                 LPDWORD lpMaxMessageSize,
                                 LPDWORD lpNextSize,
                                 LPDWORD lpMessageCount,
                                 LPDWORD lpReadTimeout
                               );

DWORD WINAPI LWM_GetModuleFileNameA( HMODULE hModule,
                                     LPSTR lpFilename,
                                     DWORD nSize
                                   );

DWORD WINAPI LWM_GetModuleFileNameW( HMODULE hModule,
                                     LPWSTR lpFilename,
                                     DWORD nSize
                                   );

HMODULE WINAPI LWM_GetModuleHandleA( LPCSTR lpModuleName );

HMODULE WINAPI LWM_GetModuleHandleW( LPCWSTR lpModuleName );

BOOL WINAPI LWM_GetNamedPipeHandleStateA( HANDLE hNamedPipe,
                                          LPDWORD lpState,
                                          LPDWORD lpCurInstances,
                                          LPDWORD lpMaxCollectionCount,
                                          LPDWORD lpCollectDataTimeout,
                                          LPSTR lpUserName,
                                          DWORD nMaxUserNameSize
                                        );

BOOL WINAPI LWM_GetNamedPipeHandleStateW( HANDLE hNamedPipe,
                                          LPDWORD lpState,
                                          LPDWORD lpCurInstances,
                                          LPDWORD lpMaxCollectionCount,
                                          LPDWORD lpCollectDataTimeout,
                                          LPWSTR lpUserName,
                                          DWORD nMaxUserNameSize
                                        );

BOOL WINAPI LWM_GetNamedPipeInfo( HANDLE hNamedPipe,
                                  LPDWORD lpFlags,
                                  LPDWORD lpOutBufferSize,
                                  LPDWORD lpInBufferSize,
                                  LPDWORD lpMaxInstances
                                );

int WINAPI LWM_GetNumberFormatA( LCID Locale,
                                 DWORD dwFlags,
                                 LPCSTR lpValue,
                                 const NUMBERFMTA * lpFormat,
                                 LPSTR lpNumberStr,
                                 int cchNumber
                               );

int WINAPI LWM_GetNumberFormatW( LCID Locale,
                                 DWORD dwFlags,
                                 LPCWSTR lpValue,
                                 const NUMBERFMTW * lpFormat,
                                 LPWSTR lpNumberStr,
                                 int cchNumber
                               );

BOOL WINAPI LWM_GetNumberOfConsoleInputEvents( HANDLE hConsoleInput,
                                               LPDWORD lpNumberOfEvents
                                             );

BOOL WINAPI LWM_GetNumberOfConsoleMouseButtons( LPDWORD lpNumberOfMouseButtons );

BOOL WINAPI LWM_GetNumberOfEventLogRecords( HANDLE hEventLog,
                                            PDWORD NumberOfRecords
                                          );

UINT WINAPI LWM_GetOEMCP( void );

BOOL WINAPI LWM_GetOldestEventLogRecord( HANDLE hEventLog,
                                         PDWORD OldestRecord
                                       );

BOOL WINAPI LWM_GetOverlappedResult( HANDLE hFile,
                                     LPOVERLAPPED lpOverlapped,
                                     LPDWORD lpNumberOfBytesTransferred,
                                     BOOL bWait
                                   );

DWORD WINAPI LWM_GetPriorityClass( HANDLE hProcess );

BOOL WINAPI LWM_GetPrivateObjectSecurity( PSECURITY_DESCRIPTOR ObjectDescriptor,
                                          SECURITY_INFORMATION SecurityInformation,
                                          PSECURITY_DESCRIPTOR ResultantDescriptor,
                                          DWORD DescriptorLength,
                                          PDWORD ReturnLength
                                        );

UINT WINAPI LWM_GetPrivateProfileIntA( LPCSTR lpAppName,
                                       LPCSTR lpKeyName,
                                       INT nDefault,
                                       LPCSTR lpFileName
                                     );

UINT WINAPI LWM_GetPrivateProfileIntW( LPCWSTR lpAppName,
                                       LPCWSTR lpKeyName,
                                       INT nDefault,
                                       LPCWSTR lpFileName
                                     );

DWORD WINAPI LWM_GetPrivateProfileSectionA( LPCSTR lpAppName,
                                            LPSTR lpReturnedString,
                                            DWORD nSize,
                                            LPCSTR lpFileName
                                          );

DWORD WINAPI LWM_GetPrivateProfileSectionNamesA( LPSTR lpszReturnBuffer,
                                                 DWORD nSize,
                                                 LPCSTR lpFileName
                                               );

DWORD WINAPI LWM_GetPrivateProfileSectionNamesW( LPWSTR lpszReturnBuffer,
                                                 DWORD nSize,
                                                 LPCWSTR lpFileName
                                               );

DWORD WINAPI LWM_GetPrivateProfileSectionW( LPCWSTR lpAppName,
                                            LPWSTR lpReturnedString,
                                            DWORD nSize,
                                            LPCWSTR lpFileName
                                          );

DWORD WINAPI LWM_GetPrivateProfileStringA( LPCSTR lpAppName,
                                           LPCSTR lpKeyName,
                                           LPCSTR lpDefault,
                                           LPSTR lpReturnedString,
                                           DWORD nSize,
                                           LPCSTR lpFileName
                                         );

DWORD WINAPI LWM_GetPrivateProfileStringW( LPCWSTR lpAppName,
                                           LPCWSTR lpKeyName,
                                           LPCWSTR lpDefault,
                                           LPWSTR lpReturnedString,
                                           DWORD nSize,
                                           LPCWSTR lpFileName
                                         );

BOOL WINAPI LWM_GetPrivateProfileStructA( LPCSTR lpszSection,
                                          LPCSTR lpszKey,
                                          LPVOID lpStruct,
                                          UINT uSizeStruct,
                                          LPCSTR szFile
                                        );

BOOL WINAPI LWM_GetPrivateProfileStructW( LPCWSTR lpszSection,
                                          LPCWSTR lpszKey,
                                          LPVOID lpStruct,
                                          UINT uSizeStruct,
                                          LPCWSTR szFile
                                        );

FARPROC WINAPI LWM_GetProcAddress( HMODULE hModule,
                                   LPCSTR lpProcName
                                 );

BOOL WINAPI LWM_GetProcessAffinityMask( HANDLE hProcess,
                                        PDWORD_PTR lpProcessAffinityMask,
                                        PDWORD_PTR lpSystemAffinityMask
                                      );

HANDLE WINAPI LWM_GetProcessHeap( void );

DWORD WINAPI LWM_GetProcessHeaps( DWORD NumberOfHeaps,
                                  PHANDLE ProcessHeaps
                                );

BOOL WINAPI LWM_GetProcessPriorityBoost( HANDLE hProcess,
                                         PBOOL pDisablePriorityBoost
                                       );

BOOL WINAPI LWM_GetProcessShutdownParameters( LPDWORD lpdwLevel,
                                              LPDWORD lpdwFlags
                                            );

BOOL WINAPI LWM_GetProcessTimes( HANDLE hProcess,
                                 LPFILETIME lpCreationTime,
                                 LPFILETIME lpExitTime,
                                 LPFILETIME lpKernelTime,
                                 LPFILETIME lpUserTime
                               );

DWORD WINAPI LWM_GetProcessVersion( DWORD ProcessId );

BOOL WINAPI LWM_GetProcessWorkingSetSize( HANDLE hProcess,
                                          PSIZE_T lpMinimumWorkingSetSize,
                                          PSIZE_T lpMaximumWorkingSetSize
                                        );

UINT WINAPI LWM_GetProfileIntA( LPCSTR lpAppName,
                                LPCSTR lpKeyName,
                                INT nDefault
                              );

UINT WINAPI LWM_GetProfileIntW( LPCWSTR lpAppName,
                                LPCWSTR lpKeyName,
                                INT nDefault
                              );

DWORD WINAPI LWM_GetProfileSectionA( LPCSTR lpAppName,
                                     LPSTR lpReturnedString,
                                     DWORD nSize
                                   );

DWORD WINAPI LWM_GetProfileSectionW( LPCWSTR lpAppName,
                                     LPWSTR lpReturnedString,
                                     DWORD nSize
                                   );

DWORD WINAPI LWM_GetProfileStringA( LPCSTR lpAppName,
                                    LPCSTR lpKeyName,
                                    LPCSTR lpDefault,
                                    LPSTR lpReturnedString,
                                    DWORD nSize
                                  );

DWORD WINAPI LWM_GetProfileStringW( LPCWSTR lpAppName,
                                    LPCWSTR lpKeyName,
                                    LPCWSTR lpDefault,
                                    LPWSTR lpReturnedString,
                                    DWORD nSize
                                  );

BOOL WINAPI LWM_GetQueuedCompletionStatus( HANDLE CompletionPort,
                                           LPDWORD lpNumberOfBytesTransferred,
                                           PULONG_PTR lpCompletionKey,
                                           LPOVERLAPPED * lpOverlapped,
                                           DWORD dwMilliseconds
                                         );

BOOL WINAPI LWM_GetSecurityDescriptorControl( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                              PSECURITY_DESCRIPTOR_CONTROL pControl,
                                              LPDWORD lpdwRevision
                                            );

BOOL WINAPI LWM_GetSecurityDescriptorDacl( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                           LPBOOL lpbDaclPresent,
                                           PACL * pDacl,
                                           LPBOOL lpbDaclDefaulted
                                         );

BOOL WINAPI LWM_GetSecurityDescriptorGroup( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                            PSID * pGroup,
                                            LPBOOL lpbGroupDefaulted
                                          );

DWORD WINAPI LWM_GetSecurityDescriptorLength( PSECURITY_DESCRIPTOR pSecurityDescriptor );

BOOL WINAPI LWM_GetSecurityDescriptorOwner( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                            PSID * pOwner,
                                            LPBOOL lpbOwnerDefaulted
                                          );

BOOL WINAPI LWM_GetSecurityDescriptorSacl( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                           LPBOOL lpbSaclPresent,
                                           PACL * pSacl,
                                           LPBOOL lpbSaclDefaulted
                                         );

BOOL WINAPI LWM_GetServiceDisplayNameA( SC_HANDLE hSCManager,
                                        LPCSTR lpServiceName,
                                        LPSTR lpDisplayName,
                                        LPDWORD lpcchBuffer
                                      );

BOOL WINAPI LWM_GetServiceDisplayNameW( SC_HANDLE hSCManager,
                                        LPCWSTR lpServiceName,
                                        LPWSTR lpDisplayName,
                                        LPDWORD lpcchBuffer
                                      );

BOOL WINAPI LWM_GetServiceKeyNameA( SC_HANDLE hSCManager,
                                    LPCSTR lpDisplayName,
                                    LPSTR lpServiceName,
                                    LPDWORD lpcchBuffer
                                  );

BOOL WINAPI LWM_GetServiceKeyNameW( SC_HANDLE hSCManager,
                                    LPCWSTR lpDisplayName,
                                    LPWSTR lpServiceName,
                                    LPDWORD lpcchBuffer
                                  );

DWORD WINAPI LWM_GetShortPathNameA( LPCSTR lpszLongPath,
                                    LPSTR lpszShortPath,
                                    DWORD cchBuffer
                                  );

DWORD WINAPI LWM_GetShortPathNameW( LPCWSTR lpszLongPath,
                                    LPWSTR lpszShortPath,
                                    DWORD cchBuffer
                                  );

PSID_IDENTIFIER_AUTHORITY WINAPI LWM_GetSidIdentifierAuthority( PSID pSid );

DWORD WINAPI LWM_GetSidLengthRequired( UCHAR nSubAuthorityCount );

PDWORD WINAPI LWM_GetSidSubAuthority( PSID pSid,
                                      DWORD nSubAuthority
                                    );

PUCHAR WINAPI LWM_GetSidSubAuthorityCount( PSID pSid );

void WINAPI LWM_GetStartupInfoA( LPSTARTUPINFOA lpStartupInfo );

void WINAPI LWM_GetStartupInfoW( LPSTARTUPINFOW lpStartupInfo );

HANDLE WINAPI LWM_GetStdHandle( DWORD nStdHandle );

BOOL WINAPI LWM_GetStringTypeA( LCID Locale,
                                DWORD dwInfoType,
                                LPCSTR lpSrcStr,
                                int cchSrc,
                                LPWORD lpCharType
                              );

BOOL WINAPI LWM_GetStringTypeExA( LCID Locale,
                                  DWORD dwInfoType,
                                  LPCSTR lpSrcStr,
                                  int cchSrc,
                                  LPWORD lpCharType
                                );

BOOL WINAPI LWM_GetStringTypeExW( LCID Locale,
                                  DWORD dwInfoType,
                                  LPCWSTR lpSrcStr,
                                  int cchSrc,
                                  LPWORD lpCharType
                                );

BOOL WINAPI LWM_GetStringTypeW( DWORD dwInfoType,
                                LPCWSTR lpSrcStr,
                                int cchSrc,
                                LPWORD lpCharType
                              );

LCID WINAPI LWM_GetSystemDefaultLCID( void );

LANGID WINAPI LWM_GetSystemDefaultLangID( void );

UINT WINAPI LWM_GetSystemDirectoryA( LPSTR lpBuffer,
                                     UINT uSize
                                   );

UINT WINAPI LWM_GetSystemDirectoryW( LPWSTR lpBuffer,
                                     UINT uSize
                                   );

void WINAPI LWM_GetSystemInfo( LPSYSTEM_INFO lpSystemInfo );

void WINAPI LWM_GetSystemTime( LPSYSTEMTIME lpSystemTime );

BOOL WINAPI LWM_GetSystemTimeAdjustment( PDWORD lpTimeAdjustment,
                                         PDWORD lpTimeIncrement,
                                         PBOOL lpTimeAdjustmentDisabled
                                       );

void WINAPI LWM_GetSystemTimeAsFileTime( LPFILETIME lpSystemTimeAsFileTime );

DWORD WINAPI LWM_GetTapeParameters( HANDLE hDevice,
                                    DWORD dwOperation,
                                    LPDWORD lpdwSize,
                                    LPVOID lpTapeInformation
                                  );

DWORD WINAPI LWM_GetTapePosition( HANDLE hDevice,
                                  DWORD dwPositionType,
                                  LPDWORD lpdwPartition,
                                  LPDWORD lpdwOffsetLow,
                                  LPDWORD lpdwOffsetHigh
                                );

DWORD WINAPI LWM_GetTapeStatus( HANDLE hDevice );

UINT WINAPI LWM_GetTempFileNameA( LPCSTR lpPathName,
                                  LPCSTR lpPrefixString,
                                  UINT uUnique,
                                  LPSTR lpTempFileName
                                );

UINT WINAPI LWM_GetTempFileNameW( LPCWSTR lpPathName,
                                  LPCWSTR lpPrefixString,
                                  UINT uUnique,
                                  LPWSTR lpTempFileName
                                );

DWORD WINAPI LWM_GetTempPathA( DWORD nBufferLength,
                               LPSTR lpBuffer
                             );

DWORD WINAPI LWM_GetTempPathW( DWORD nBufferLength,
                               LPWSTR lpBuffer
                             );

BOOL WINAPI LWM_GetThreadContext( HANDLE hThread,
                                  LPCONTEXT lpContext
                                );

LCID WINAPI LWM_GetThreadLocale( void );

int WINAPI LWM_GetThreadPriority( HANDLE hThread );

BOOL WINAPI LWM_GetThreadPriorityBoost( HANDLE hThread,
                                        PBOOL pDisablePriorityBoost
                                      );

BOOL WINAPI LWM_GetThreadSelectorEntry( HANDLE hThread,
                                        DWORD dwSelector,
                                        LPLDT_ENTRY lpSelectorEntry
                                      );

BOOL WINAPI LWM_GetThreadTimes( HANDLE hThread,
                                LPFILETIME lpCreationTime,
                                LPFILETIME lpExitTime,
                                LPFILETIME lpKernelTime,
                                LPFILETIME lpUserTime
                              );

DWORD WINAPI LWM_GetTickCount( void );

int WINAPI LWM_GetTimeFormatA( LCID Locale,
                               DWORD dwFlags,
                               const SYSTEMTIME * lpTime,
                               LPCSTR lpFormat,
                               LPSTR lpTimeStr,
                               int cchTime
                             );

int WINAPI LWM_GetTimeFormatW( LCID Locale,
                               DWORD dwFlags,
                               const SYSTEMTIME * lpTime,
                               LPCWSTR lpFormat,
                               LPWSTR lpTimeStr,
                               int cchTime
                             );

DWORD WINAPI LWM_GetTimeZoneInformation( LPTIME_ZONE_INFORMATION lpTimeZoneInformation );

BOOL WINAPI LWM_GetTokenInformation( HANDLE TokenHandle,
                                     TOKEN_INFORMATION_CLASS TokenInformationClass,
                                     LPVOID TokenInformation,
                                     DWORD TokenInformationLength,
                                     PDWORD ReturnLength
                                   );

LCID WINAPI LWM_GetUserDefaultLCID( void );

LANGID WINAPI LWM_GetUserDefaultLangID( void );

BOOL WINAPI LWM_GetUserNameA( LPSTR lpBuffer,
                              LPDWORD nSize
                            );

BOOL WINAPI LWM_GetUserNameW( LPWSTR lpBuffer,
                              LPDWORD nSize
                            );

DWORD WINAPI LWM_GetVersion( void );

BOOL WINAPI LWM_GetVersionExA( LPOSVERSIONINFOA lpVersionInformation );

BOOL WINAPI LWM_GetVersionExW( LPOSVERSIONINFOW lpVersionInformation );

BOOL WINAPI LWM_GetVolumeInformationA( LPCSTR lpRootPathName,
                                       LPSTR lpVolumeNameBuffer,
                                       DWORD nVolumeNameSize,
                                       LPDWORD lpVolumeSerialNumber,
                                       LPDWORD lpMaximumComponentLength,
                                       LPDWORD lpFileSystemFlags,
                                       LPSTR lpFileSystemNameBuffer,
                                       DWORD nFileSystemNameSize
                                     );

BOOL WINAPI LWM_GetVolumeInformationW( LPCWSTR lpRootPathName,
                                       LPWSTR lpVolumeNameBuffer,
                                       DWORD nVolumeNameSize,
                                       LPDWORD lpVolumeSerialNumber,
                                       LPDWORD lpMaximumComponentLength,
                                       LPDWORD lpFileSystemFlags,
                                       LPWSTR lpFileSystemNameBuffer,
                                       DWORD nFileSystemNameSize
                                     );

UINT WINAPI LWM_GetWindowsDirectoryA( LPSTR lpBuffer,
                                      UINT uSize
                                    );

UINT WINAPI LWM_GetWindowsDirectoryW( LPWSTR lpBuffer,
                                      UINT uSize
                                    );

ATOM WINAPI LWM_GlobalAddAtomA( LPCSTR lpString );

ATOM WINAPI LWM_GlobalAddAtomW( LPCWSTR lpString );

HGLOBAL WINAPI LWM_GlobalAlloc( UINT uFlags,
                                SIZE_T dwBytes
                              );

SIZE_T WINAPI LWM_GlobalCompact( DWORD dwMinFree );

ATOM WINAPI LWM_GlobalDeleteAtom( ATOM nAtom );

ATOM WINAPI LWM_GlobalFindAtomA( LPCSTR lpString );

ATOM WINAPI LWM_GlobalFindAtomW( LPCWSTR lpString );

void WINAPI LWM_GlobalFix( HGLOBAL hMem );

UINT WINAPI LWM_GlobalFlags( HGLOBAL hMem );

HGLOBAL WINAPI LWM_GlobalFree( HGLOBAL hMem );

UINT WINAPI LWM_GlobalGetAtomNameA( ATOM nAtom,
                                    LPSTR lpBuffer,
                                    int nSize
                                  );

UINT WINAPI LWM_GlobalGetAtomNameW( ATOM nAtom,
                                    LPWSTR lpBuffer,
                                    int nSize
                                  );

HGLOBAL WINAPI LWM_GlobalHandle( LPCVOID pMem );

LPVOID WINAPI LWM_GlobalLock( HGLOBAL hMem );

void WINAPI LWM_GlobalMemoryStatus( LPMEMORYSTATUS lpBuffer );

HGLOBAL WINAPI LWM_GlobalReAlloc( HGLOBAL hMem,
                                  SIZE_T dwBytes,
                                  UINT uFlags
                                );

SIZE_T WINAPI LWM_GlobalSize( HGLOBAL hMem );

BOOL WINAPI LWM_GlobalUnWire( HGLOBAL hMem );

void WINAPI LWM_GlobalUnfix( HGLOBAL hMem );

BOOL WINAPI LWM_GlobalUnlock( HGLOBAL hMem );

LPVOID WINAPI LWM_GlobalWire( HGLOBAL hMem );

SIZE_T WINAPI LWM_HeapCompact( HANDLE hHeap,
                               DWORD dwFlags
                             );

HANDLE WINAPI LWM_HeapCreate( DWORD flOptions,
                              SIZE_T dwInitialSize,
                              SIZE_T dwMaximumSize
                            );

BOOL WINAPI LWM_HeapDestroy( HANDLE hHeap );

BOOL WINAPI LWM_HeapLock( HANDLE hHeap );

BOOL WINAPI LWM_HeapUnlock( HANDLE hHeap );

BOOL WINAPI LWM_HeapValidate( HANDLE hHeap,
                              DWORD dwFlags,
                              LPCVOID lpMem
                            );

BOOL WINAPI LWM_HeapWalk( HANDLE hHeap,
                          LPPROCESS_HEAP_ENTRY lpEntry
                        );

BOOL WINAPI LWM_ImpersonateLoggedOnUser( HANDLE hToken );

BOOL WINAPI LWM_ImpersonateNamedPipeClient( HANDLE hNamedPipe );

BOOL WINAPI LWM_ImpersonateSelf( SECURITY_IMPERSONATION_LEVEL ImpersonationLevel );

BOOL WINAPI LWM_InitAtomTable( DWORD nSize );

BOOL WINAPI LWM_InitializeAcl( PACL pAcl,
                               DWORD nAclLength,
                               DWORD dwAclRevision
                             );

void WINAPI LWM_InitializeCriticalSection( LPCRITICAL_SECTION lpCriticalSection );

BOOL WINAPI LWM_InitializeSecurityDescriptor( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                              DWORD dwRevision
                                            );

BOOL WINAPI LWM_InitializeSid( PSID Sid,
                               PSID_IDENTIFIER_AUTHORITY pIdentifierAuthority,
                               BYTE nSubAuthorityCount
                             );

BOOL WINAPI LWM_InitiateSystemShutdownA( LPSTR lpMachineName,
                                         LPSTR lpMessage,
                                         DWORD dwTimeout,
                                         BOOL bForceAppsClosed,
                                         BOOL bRebootAfterShutdown
                                       );

BOOL WINAPI LWM_InitiateSystemShutdownW( LPWSTR lpMachineName,
                                         LPWSTR lpMessage,
                                         DWORD dwTimeout,
                                         BOOL bForceAppsClosed,
                                         BOOL bRebootAfterShutdown
                                       );

LONG WINAPI LWM_InterlockedCompareExchange( LPLONG Destination,
                                            LONG Exchange,
                                            LONG Comperand
                                          );

LONG WINAPI LWM_InterlockedDecrement( LPLONG lpAddend );

LONG WINAPI LWM_InterlockedExchange( LPLONG Target,
                                     LONG Value
                                   );

LONG WINAPI LWM_InterlockedExchangeAdd( LPLONG Addend,
                                        LONG Value
                                      );

LONG WINAPI LWM_InterlockedIncrement( LPLONG lpAddend );

BOOL WINAPI LWM_IsBadCodePtr( FARPROC lpfn );

BOOL WINAPI LWM_IsBadHugeReadPtr( const void * lp,
                                  UINT_PTR ucb
                                );

BOOL WINAPI LWM_IsBadHugeWritePtr( LPVOID lp,
                                   UINT_PTR ucb
                                 );

BOOL WINAPI LWM_IsBadReadPtr( const void * lp,
                              UINT_PTR ucb
                            );

BOOL WINAPI LWM_IsBadStringPtrA( LPCSTR lpsz,
                                 UINT_PTR ucchMax
                               );

BOOL WINAPI LWM_IsBadStringPtrW( LPCWSTR lpsz,
                                 UINT_PTR ucchMax
                               );

BOOL WINAPI LWM_IsBadWritePtr( LPVOID lp,
                               UINT_PTR ucb
                             );

BOOL WINAPI LWM_IsDBCSLeadByte( BYTE TestChar );

BOOL WINAPI LWM_IsDBCSLeadByteEx( UINT CodePage,
                                  BYTE TestChar
                                );

BOOL WINAPI LWM_IsDebuggerPresent( void );

BOOL WINAPI LWM_IsProcessorFeaturePresent( DWORD ProcessorFeature );

BOOL WINAPI LWM_IsTextUnicode( const LPVOID lpBuffer,
                               int cb,
                               LPINT lpi
                             );

BOOL WINAPI LWM_IsValidAcl( PACL pAcl );

BOOL WINAPI LWM_IsValidCodePage( UINT CodePage );

BOOL WINAPI LWM_IsValidLocale( LCID Locale,
                               DWORD dwFlags
                             );

BOOL WINAPI LWM_IsValidSecurityDescriptor( PSECURITY_DESCRIPTOR pSecurityDescriptor );

BOOL WINAPI LWM_IsValidSid( PSID pSid );

int WINAPI LWM_LCMapStringA( LCID Locale,
                             DWORD dwMapFlags,
                             LPCSTR lpSrcStr,
                             int cchSrc,
                             LPSTR lpDestStr,
                             int cchDest
                           );

int WINAPI LWM_LCMapStringW( LCID Locale,
                             DWORD dwMapFlags,
                             LPCWSTR lpSrcStr,
                             int cchSrc,
                             LPWSTR lpDestStr,
                             int cchDest
                           );

HMODULE WINAPI LWM_LoadLibraryA( LPCSTR lpLibFileName );

HMODULE WINAPI LWM_LoadLibraryExA( LPCSTR lpLibFileName,
                                   HANDLE hFile,
                                   DWORD dwFlags
                                 );

HMODULE WINAPI LWM_LoadLibraryExW( LPCWSTR lpLibFileName,
                                   HANDLE hFile,
                                   DWORD dwFlags
                                 );

HMODULE WINAPI LWM_LoadLibraryW( LPCWSTR lpLibFileName );

DWORD WINAPI LWM_LoadModule( LPCSTR lpModuleName,
                             LPVOID lpParameterBlock
                           );

HGLOBAL WINAPI LWM_LoadResource( HMODULE hModule,
                                 HRSRC hResInfo
                               );

HLOCAL WINAPI LWM_LocalAlloc( UINT uFlags,
                              SIZE_T uBytes
                            );

SIZE_T WINAPI LWM_LocalCompact( UINT uMinFree );

BOOL WINAPI LWM_LocalFileTimeToFileTime( const FILETIME * lpLocalFileTime,
                                         LPFILETIME lpFileTime
                                       );

UINT WINAPI LWM_LocalFlags( HLOCAL hMem );

HLOCAL WINAPI LWM_LocalFree( HLOCAL hMem );

HLOCAL WINAPI LWM_LocalHandle( LPCVOID pMem );

LPVOID WINAPI LWM_LocalLock( HLOCAL hMem );

HLOCAL WINAPI LWM_LocalReAlloc( HLOCAL hMem,
                                SIZE_T uBytes,
                                UINT uFlags
                              );

SIZE_T WINAPI LWM_LocalShrink( HLOCAL hMem,
                               UINT cbNewSize
                             );

SIZE_T WINAPI LWM_LocalSize( HLOCAL hMem );

BOOL WINAPI LWM_LocalUnlock( HLOCAL hMem );

BOOL WINAPI LWM_LockFile( HANDLE hFile,
                          DWORD dwFileOffsetLow,
                          DWORD dwFileOffsetHigh,
                          DWORD nNumberOfBytesToLockLow,
                          DWORD nNumberOfBytesToLockHigh
                        );

BOOL WINAPI LWM_LockFileEx( HANDLE hFile,
                            DWORD dwFlags,
                            DWORD dwReserved,
                            DWORD nNumberOfBytesToLockLow,
                            DWORD nNumberOfBytesToLockHigh,
                            LPOVERLAPPED lpOverlapped
                          );

LPVOID WINAPI LWM_LockResource( HGLOBAL hResData );

SC_LOCK WINAPI LWM_LockServiceDatabase( SC_HANDLE hSCManager );

BOOL WINAPI LWM_LogonUserA( LPSTR lpszUsername,
                            LPSTR lpszDomain,
                            LPSTR lpszPassword,
                            DWORD dwLogonType,
                            DWORD dwLogonProvider,
                            PHANDLE phToken
                          );

BOOL WINAPI LWM_LogonUserW( LPWSTR lpszUsername,
                            LPWSTR lpszDomain,
                            LPWSTR lpszPassword,
                            DWORD dwLogonType,
                            DWORD dwLogonProvider,
                            PHANDLE phToken
                          );

BOOL WINAPI LWM_LookupAccountNameA( LPCSTR lpSystemName,
                                    LPCSTR lpAccountName,
                                    PSID Sid,
                                    LPDWORD cbSid,
                                    LPSTR ReferencedDomainName,
                                    LPDWORD cbReferencedDomainName,
                                    PSID_NAME_USE peUse
                                  );

BOOL WINAPI LWM_LookupAccountNameW( LPCWSTR lpSystemName,
                                    LPCWSTR lpAccountName,
                                    PSID Sid,
                                    LPDWORD cbSid,
                                    LPWSTR ReferencedDomainName,
                                    LPDWORD cbReferencedDomainName,
                                    PSID_NAME_USE peUse
                                  );

BOOL WINAPI LWM_LookupAccountSidA( LPCSTR lpSystemName,
                                   PSID Sid,
                                   LPSTR Name,
                                   LPDWORD cbName,
                                   LPSTR ReferencedDomainName,
                                   LPDWORD cbReferencedDomainName,
                                   PSID_NAME_USE peUse
                                 );

BOOL WINAPI LWM_LookupAccountSidW( LPCWSTR lpSystemName,
                                   PSID Sid,
                                   LPWSTR Name,
                                   LPDWORD cbName,
                                   LPWSTR ReferencedDomainName,
                                   LPDWORD cbReferencedDomainName,
                                   PSID_NAME_USE peUse
                                 );

BOOL WINAPI LWM_LookupPrivilegeDisplayNameA( LPCSTR lpSystemName,
                                             LPCSTR lpName,
                                             LPSTR lpDisplayName,
                                             LPDWORD cbDisplayName,
                                             LPDWORD lpLanguageId
                                           );

BOOL WINAPI LWM_LookupPrivilegeDisplayNameW( LPCWSTR lpSystemName,
                                             LPCWSTR lpName,
                                             LPWSTR lpDisplayName,
                                             LPDWORD cbDisplayName,
                                             LPDWORD lpLanguageId
                                           );

BOOL WINAPI LWM_LookupPrivilegeNameA( LPCSTR lpSystemName,
                                      PLUID lpLuid,
                                      LPSTR lpName,
                                      LPDWORD cbName
                                    );

BOOL WINAPI LWM_LookupPrivilegeNameW( LPCWSTR lpSystemName,
                                      PLUID lpLuid,
                                      LPWSTR lpName,
                                      LPDWORD cbName
                                    );

BOOL WINAPI LWM_LookupPrivilegeValueA( LPCSTR lpSystemName,
                                       LPCSTR lpName,
                                       PLUID lpLuid
                                     );

BOOL WINAPI LWM_LookupPrivilegeValueW( LPCWSTR lpSystemName,
                                       LPCWSTR lpName,
                                       PLUID lpLuid
                                     );

BOOL WINAPI LWM_MakeAbsoluteSD( PSECURITY_DESCRIPTOR pSelfRelativeSecurityDescriptor,
                                PSECURITY_DESCRIPTOR pAbsoluteSecurityDescriptor,
                                LPDWORD lpdwAbsoluteSecurityDescriptorSize,
                                PACL pDacl,
                                LPDWORD lpdwDaclSize,
                                PACL pSacl,
                                LPDWORD lpdwSaclSize,
                                PSID pOwner,
                                LPDWORD lpdwOwnerSize,
                                PSID pPrimaryGroup,
                                LPDWORD lpdwPrimaryGroupSize
                              );

BOOL WINAPI LWM_MakeSelfRelativeSD( PSECURITY_DESCRIPTOR pAbsoluteSecurityDescriptor,
                                    PSECURITY_DESCRIPTOR pSelfRelativeSecurityDescriptor,
                                    LPDWORD lpdwBufferLength
                                  );

void WINAPI LWM_MapGenericMask( PDWORD AccessMask,
                                PGENERIC_MAPPING GenericMapping
                              );

LPVOID WINAPI LWM_MapViewOfFile( HANDLE hFileMappingObject,
                                 DWORD dwDesiredAccess,
                                 DWORD dwFileOffsetHigh,
                                 DWORD dwFileOffsetLow,
                                 SIZE_T dwNumberOfBytesToMap
                               );

LPVOID WINAPI LWM_MapViewOfFileEx( HANDLE hFileMappingObject,
                                   DWORD dwDesiredAccess,
                                   DWORD dwFileOffsetHigh,
                                   DWORD dwFileOffsetLow,
                                   SIZE_T dwNumberOfBytesToMap,
                                   LPVOID lpBaseAddress
                                 );

BOOL WINAPI LWM_MoveFileA( LPCSTR lpExistingFileName,
                           LPCSTR lpNewFileName
                         );

BOOL WINAPI LWM_MoveFileExA( LPCSTR lpExistingFileName,
                             LPCSTR lpNewFileName,
                             DWORD dwFlags
                           );

BOOL WINAPI LWM_MoveFileExW( LPCWSTR lpExistingFileName,
                             LPCWSTR lpNewFileName,
                             DWORD dwFlags
                           );

BOOL WINAPI LWM_MoveFileW( LPCWSTR lpExistingFileName,
                           LPCWSTR lpNewFileName
                         );

int WINAPI LWM_MulDiv( int nNumber,
                       int nNumerator,
                       int nDenominator
                     );

int WINAPI LWM_MultiByteToWideChar( UINT CodePage,
                                    DWORD dwFlags,
                                    LPCSTR lpMultiByteStr,
                                    int cbMultiByte,
                                    LPWSTR lpWideCharStr,
                                    int cchWideChar
                                  );

BOOL WINAPI LWM_NotifyBootConfigStatus( BOOL BootAcceptable );

BOOL WINAPI LWM_NotifyChangeEventLog( HANDLE hEventLog,
                                      HANDLE hEvent
                                    );

BOOL WINAPI LWM_ObjectCloseAuditAlarmA( LPCSTR SubsystemName,
                                        LPVOID HandleId,
                                        BOOL GenerateOnClose
                                      );

BOOL WINAPI LWM_ObjectCloseAuditAlarmW( LPCWSTR SubsystemName,
                                        LPVOID HandleId,
                                        BOOL GenerateOnClose
                                      );

BOOL WINAPI LWM_ObjectDeleteAuditAlarmA( LPCSTR SubsystemName,
                                         LPVOID HandleId,
                                         BOOL GenerateOnClose
                                       );

BOOL WINAPI LWM_ObjectDeleteAuditAlarmW( LPCWSTR SubsystemName,
                                         LPVOID HandleId,
                                         BOOL GenerateOnClose
                                       );

BOOL WINAPI LWM_ObjectOpenAuditAlarmA( LPCSTR SubsystemName,
                                       LPVOID HandleId,
                                       LPSTR ObjectTypeName,
                                       LPSTR ObjectName,
                                       PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                       HANDLE ClientToken,
                                       DWORD DesiredAccess,
                                       DWORD GrantedAccess,
                                       PPRIVILEGE_SET Privileges,
                                       BOOL ObjectCreation,
                                       BOOL AccessGranted,
                                       LPBOOL GenerateOnClose
                                     );

BOOL WINAPI LWM_ObjectOpenAuditAlarmW( LPCWSTR SubsystemName,
                                       LPVOID HandleId,
                                       LPWSTR ObjectTypeName,
                                       LPWSTR ObjectName,
                                       PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                       HANDLE ClientToken,
                                       DWORD DesiredAccess,
                                       DWORD GrantedAccess,
                                       PPRIVILEGE_SET Privileges,
                                       BOOL ObjectCreation,
                                       BOOL AccessGranted,
                                       LPBOOL GenerateOnClose
                                     );

BOOL WINAPI LWM_ObjectPrivilegeAuditAlarmA( LPCSTR SubsystemName,
                                            LPVOID HandleId,
                                            HANDLE ClientToken,
                                            DWORD DesiredAccess,
                                            PPRIVILEGE_SET Privileges,
                                            BOOL AccessGranted
                                          );

BOOL WINAPI LWM_ObjectPrivilegeAuditAlarmW( LPCWSTR SubsystemName,
                                            LPVOID HandleId,
                                            HANDLE ClientToken,
                                            DWORD DesiredAccess,
                                            PPRIVILEGE_SET Privileges,
                                            BOOL AccessGranted
                                          );

HANDLE WINAPI LWM_OpenBackupEventLogA( LPCSTR lpUNCServerName,
                                       LPCSTR lpFileName
                                     );

HANDLE WINAPI LWM_OpenBackupEventLogW( LPCWSTR lpUNCServerName,
                                       LPCWSTR lpFileName
                                     );

HANDLE WINAPI LWM_OpenEventA( DWORD dwDesiredAccess,
                              BOOL bInheritHandle,
                              LPCSTR lpName
                            );

HANDLE WINAPI LWM_OpenEventLogA( LPCSTR lpUNCServerName,
                                 LPCSTR lpSourceName
                               );

HANDLE WINAPI LWM_OpenEventLogW( LPCWSTR lpUNCServerName,
                                 LPCWSTR lpSourceName
                               );

HANDLE WINAPI LWM_OpenEventW( DWORD dwDesiredAccess,
                              BOOL bInheritHandle,
                              LPCWSTR lpName
                            );

HFILE WINAPI LWM_OpenFile( LPCSTR lpFileName,
                           LPOFSTRUCT lpReOpenBuff,
                           UINT uStyle
                         );

HANDLE WINAPI LWM_OpenFileMappingA( DWORD dwDesiredAccess,
                                    BOOL bInheritHandle,
                                    LPCSTR lpName
                                  );

HANDLE WINAPI LWM_OpenFileMappingW( DWORD dwDesiredAccess,
                                    BOOL bInheritHandle,
                                    LPCWSTR lpName
                                  );

HANDLE WINAPI LWM_OpenMutexA( DWORD dwDesiredAccess,
                              BOOL bInheritHandle,
                              LPCSTR lpName
                            );

HANDLE WINAPI LWM_OpenMutexW( DWORD dwDesiredAccess,
                              BOOL bInheritHandle,
                              LPCWSTR lpName
                            );

HANDLE WINAPI LWM_OpenProcess( DWORD dwDesiredAccess,
                               BOOL bInheritHandle,
                               DWORD dwProcessId
                             );

BOOL WINAPI LWM_OpenProcessToken( HANDLE ProcessHandle,
                                  DWORD DesiredAccess,
                                  PHANDLE TokenHandle
                                );

SC_HANDLE WINAPI LWM_OpenSCManagerA( LPCSTR lpMachineName,
                                     LPCSTR lpDatabaseName,
                                     DWORD dwDesiredAccess
                                   );

SC_HANDLE WINAPI LWM_OpenSCManagerW( LPCWSTR lpMachineName,
                                     LPCWSTR lpDatabaseName,
                                     DWORD dwDesiredAccess
                                   );

HANDLE WINAPI LWM_OpenSemaphoreA( DWORD dwDesiredAccess,
                                  BOOL bInheritHandle,
                                  LPCSTR lpName
                                );

HANDLE WINAPI LWM_OpenSemaphoreW( DWORD dwDesiredAccess,
                                  BOOL bInheritHandle,
                                  LPCWSTR lpName
                                );

SC_HANDLE WINAPI LWM_OpenServiceA( SC_HANDLE hSCManager,
                                   LPCSTR lpServiceName,
                                   DWORD dwDesiredAccess
                                 );

SC_HANDLE WINAPI LWM_OpenServiceW( SC_HANDLE hSCManager,
                                   LPCWSTR lpServiceName,
                                   DWORD dwDesiredAccess
                                 );

BOOL WINAPI LWM_OpenThreadToken( HANDLE ThreadHandle,
                                 DWORD DesiredAccess,
                                 BOOL OpenAsSelf,
                                 PHANDLE TokenHandle
                               );

HANDLE WINAPI LWM_OpenWaitableTimerA( DWORD dwDesiredAccess,
                                      BOOL bInheritHandle,
                                      LPCSTR lpTimerName
                                    );

HANDLE WINAPI LWM_OpenWaitableTimerW( DWORD dwDesiredAccess,
                                      BOOL bInheritHandle,
                                      LPCWSTR lpTimerName
                                    );

void WINAPI LWM_OutputDebugStringA( LPCSTR lpOutputString );

void WINAPI LWM_OutputDebugStringW( LPCWSTR lpOutputString );

BOOL WINAPI LWM_PeekConsoleInputA( HANDLE hConsoleInput,
                                   PINPUT_RECORD lpBuffer,
                                   DWORD nLength,
                                   LPDWORD lpNumberOfEventsRead
                                 );

BOOL WINAPI LWM_PeekConsoleInputW( HANDLE hConsoleInput,
                                   PINPUT_RECORD lpBuffer,
                                   DWORD nLength,
                                   LPDWORD lpNumberOfEventsRead
                                 );

BOOL WINAPI LWM_PeekNamedPipe( HANDLE hNamedPipe,
                               LPVOID lpBuffer,
                               DWORD nBufferSize,
                               LPDWORD lpBytesRead,
                               LPDWORD lpTotalBytesAvail,
                               LPDWORD lpBytesLeftThisMessage
                             );

BOOL WINAPI LWM_PostQueuedCompletionStatus( HANDLE CompletionPort,
                                            DWORD dwNumberOfBytesTransferred,
                                            ULONG_PTR dwCompletionKey,
                                            LPOVERLAPPED lpOverlapped
                                          );

DWORD WINAPI LWM_PrepareTape( HANDLE hDevice,
                              DWORD dwOperation,
                              BOOL bImmediate
                            );

BOOL WINAPI LWM_PrivilegeCheck( HANDLE ClientToken,
                                PPRIVILEGE_SET RequiredPrivileges,
                                LPBOOL pfResult
                              );

BOOL WINAPI LWM_PrivilegedServiceAuditAlarmA( LPCSTR SubsystemName,
                                              LPCSTR ServiceName,
                                              HANDLE ClientToken,
                                              PPRIVILEGE_SET Privileges,
                                              BOOL AccessGranted
                                            );

BOOL WINAPI LWM_PrivilegedServiceAuditAlarmW( LPCWSTR SubsystemName,
                                              LPCWSTR ServiceName,
                                              HANDLE ClientToken,
                                              PPRIVILEGE_SET Privileges,
                                              BOOL AccessGranted
                                            );

BOOL WINAPI LWM_PulseEvent( HANDLE hEvent );

BOOL WINAPI LWM_PurgeComm( HANDLE hFile,
                           DWORD dwFlags
                         );

DWORD WINAPI LWM_QueryDosDeviceA( LPCSTR lpDeviceName,
                                  LPSTR lpTargetPath,
                                  DWORD ucchMax
                                );

DWORD WINAPI LWM_QueryDosDeviceW( LPCWSTR lpDeviceName,
                                  LPWSTR lpTargetPath,
                                  DWORD ucchMax
                                );

BOOL WINAPI LWM_QueryPerformanceCounter( LARGE_INTEGER * lpPerformanceCount );

BOOL WINAPI LWM_QueryPerformanceFrequency( LARGE_INTEGER * lpFrequency );

BOOL WINAPI LWM_QueryServiceConfigA( SC_HANDLE hService,
                                     LPQUERY_SERVICE_CONFIGA lpServiceConfig,
                                     DWORD cbBufSize,
                                     LPDWORD pcbBytesNeeded
                                   );

BOOL WINAPI LWM_QueryServiceConfigW( SC_HANDLE hService,
                                     LPQUERY_SERVICE_CONFIGW lpServiceConfig,
                                     DWORD cbBufSize,
                                     LPDWORD pcbBytesNeeded
                                   );

BOOL WINAPI LWM_QueryServiceLockStatusA( SC_HANDLE hSCManager,
                                         LPQUERY_SERVICE_LOCK_STATUSA lpLockStatus,
                                         DWORD cbBufSize,
                                         LPDWORD pcbBytesNeeded
                                       );

BOOL WINAPI LWM_QueryServiceLockStatusW( SC_HANDLE hSCManager,
                                         LPQUERY_SERVICE_LOCK_STATUSW lpLockStatus,
                                         DWORD cbBufSize,
                                         LPDWORD pcbBytesNeeded
                                       );

BOOL WINAPI LWM_QueryServiceObjectSecurity( SC_HANDLE hService,
                                            SECURITY_INFORMATION dwSecurityInformation,
                                            PSECURITY_DESCRIPTOR lpSecurityDescriptor,
                                            DWORD cbBufSize,
                                            LPDWORD pcbBytesNeeded
                                          );

BOOL WINAPI LWM_QueryServiceStatus( SC_HANDLE hService,
                                    LPSERVICE_STATUS lpServiceStatus
                                  );

BOOL WINAPI LWM_QueryServiceStatusEx( SC_HANDLE hService,
                                      SC_STATUS_TYPE InfoLevel,
                                      LPBYTE lpBuffer,
                                      DWORD cbBufSize,
                                      LPDWORD pcbBytesNeeded
                                    );

DWORD WINAPI LWM_QueueUserAPC( PAPCFUNC pfnAPC,
                               HANDLE hThread,
                               ULONG_PTR dwData
                             );

void WINAPI LWM_RaiseException( DWORD dwExceptionCode,
                                DWORD dwExceptionFlags,
                                DWORD nNumberOfArguments,
                                const ULONG_PTR * lpArguments
                              );

BOOL WINAPI LWM_ReadConsoleA( HANDLE hConsoleInput,
                              LPVOID lpBuffer,
                              DWORD nNumberOfCharsToRead,
                              LPDWORD lpNumberOfCharsRead,
                              LPVOID lpReserved
                            );

BOOL WINAPI LWM_ReadConsoleInputA( HANDLE hConsoleInput,
                                   PINPUT_RECORD lpBuffer,
                                   DWORD nLength,
                                   LPDWORD lpNumberOfEventsRead
                                 );

BOOL WINAPI LWM_ReadConsoleInputW( HANDLE hConsoleInput,
                                   PINPUT_RECORD lpBuffer,
                                   DWORD nLength,
                                   LPDWORD lpNumberOfEventsRead
                                 );

BOOL WINAPI LWM_ReadConsoleOutputA( HANDLE hConsoleOutput,
                                    PCHAR_INFO lpBuffer,
                                    COORD dwBufferSize,
                                    COORD dwBufferCoord,
                                    PSMALL_RECT lpReadRegion
                                  );

BOOL WINAPI LWM_ReadConsoleOutputAttribute( HANDLE hConsoleOutput,
                                            LPWORD lpAttribute,
                                            DWORD nLength,
                                            COORD dwReadCoord,
                                            LPDWORD lpNumberOfAttrsRead
                                          );

BOOL WINAPI LWM_ReadConsoleOutputCharacterA( HANDLE hConsoleOutput,
                                             LPSTR lpCharacter,
                                             DWORD nLength,
                                             COORD dwReadCoord,
                                             LPDWORD lpNumberOfCharsRead
                                           );

BOOL WINAPI LWM_ReadConsoleOutputCharacterW( HANDLE hConsoleOutput,
                                             LPWSTR lpCharacter,
                                             DWORD nLength,
                                             COORD dwReadCoord,
                                             LPDWORD lpNumberOfCharsRead
                                           );

BOOL WINAPI LWM_ReadConsoleOutputW( HANDLE hConsoleOutput,
                                    PCHAR_INFO lpBuffer,
                                    COORD dwBufferSize,
                                    COORD dwBufferCoord,
                                    PSMALL_RECT lpReadRegion
                                  );

BOOL WINAPI LWM_ReadConsoleW( HANDLE hConsoleInput,
                              LPVOID lpBuffer,
                              DWORD nNumberOfCharsToRead,
                              LPDWORD lpNumberOfCharsRead,
                              LPVOID lpReserved
                            );

BOOL WINAPI LWM_ReadDirectoryChangesW( HANDLE hDirectory,
                                       LPVOID lpBuffer,
                                       DWORD nBufferLength,
                                       BOOL bWatchSubtree,
                                       DWORD dwNotifyFilter,
                                       LPDWORD lpBytesReturned,
                                       LPOVERLAPPED lpOverlapped,
                                       LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
                                     );

BOOL WINAPI LWM_ReadEventLogA( HANDLE hEventLog,
                               DWORD dwReadFlags,
                               DWORD dwRecordOffset,
                               LPVOID lpBuffer,
                               DWORD nNumberOfBytesToRead,
                               DWORD * pnBytesRead,
                               DWORD * pnMinNumberOfBytesNeeded
                             );

BOOL WINAPI LWM_ReadEventLogW( HANDLE hEventLog,
                               DWORD dwReadFlags,
                               DWORD dwRecordOffset,
                               LPVOID lpBuffer,
                               DWORD nNumberOfBytesToRead,
                               DWORD * pnBytesRead,
                               DWORD * pnMinNumberOfBytesNeeded
                             );

BOOL WINAPI LWM_ReadFile( HANDLE hFile,
                          LPVOID lpBuffer,
                          DWORD nNumberOfBytesToRead,
                          LPDWORD lpNumberOfBytesRead,
                          LPOVERLAPPED lpOverlapped
                        );

BOOL WINAPI LWM_ReadFileEx( HANDLE hFile,
                            LPVOID lpBuffer,
                            DWORD nNumberOfBytesToRead,
                            LPOVERLAPPED lpOverlapped,
                            LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
                          );

BOOL WINAPI LWM_ReadFileScatter( HANDLE hFile,
                                 FILE_SEGMENT_ELEMENT aSegmentArray [ ],
                                 DWORD nNumberOfBytesToRead,
                                 LPDWORD lpReserved,
                                 LPOVERLAPPED lpOverlapped
                               );

BOOL WINAPI LWM_ReadProcessMemory( HANDLE hProcess,
                                   LPCVOID lpBaseAddress,
                                   LPVOID lpBuffer,
                                   DWORD nSize,
                                   LPDWORD lpNumberOfBytesRead
                                 );

LONG WINAPI LWM_RegCloseKey( HKEY hKey );

LONG WINAPI LWM_RegConnectRegistryA( LPCSTR lpMachineName,
                                     HKEY hKey,
                                     PHKEY phkResult
                                   );

LONG WINAPI LWM_RegConnectRegistryW( LPCWSTR lpMachineName,
                                     HKEY hKey,
                                     PHKEY phkResult
                                   );

LONG WINAPI LWM_RegCreateKeyA( HKEY hKey,
                               LPCSTR lpSubKey,
                               PHKEY phkResult
                             );

LONG WINAPI LWM_RegCreateKeyExA( HKEY hKey,
                                 LPCSTR lpSubKey,
                                 DWORD Reserved,
                                 LPSTR lpClass,
                                 DWORD dwOptions,
                                 REGSAM samDesired,
                                 LPSECURITY_ATTRIBUTES lpSecurityAttributes,
                                 PHKEY phkResult,
                                 LPDWORD lpdwDisposition
                               );

LONG WINAPI LWM_RegCreateKeyExW( HKEY hKey,
                                 LPCWSTR lpSubKey,
                                 DWORD Reserved,
                                 LPWSTR lpClass,
                                 DWORD dwOptions,
                                 REGSAM samDesired,
                                 LPSECURITY_ATTRIBUTES lpSecurityAttributes,
                                 PHKEY phkResult,
                                 LPDWORD lpdwDisposition
                               );

LONG WINAPI LWM_RegCreateKeyW( HKEY hKey,
                               LPCWSTR lpSubKey,
                               PHKEY phkResult
                             );

LONG WINAPI LWM_RegDeleteKeyA( HKEY hKey,
                               LPCSTR lpSubKey
                             );

LONG WINAPI LWM_RegDeleteKeyW( HKEY hKey,
                               LPCWSTR lpSubKey
                             );

LONG WINAPI LWM_RegDeleteValueA( HKEY hKey,
                                 LPCSTR lpValueName
                               );

LONG WINAPI LWM_RegDeleteValueW( HKEY hKey,
                                 LPCWSTR lpValueName
                               );

LONG WINAPI LWM_RegEnumKeyA( HKEY hKey,
                             DWORD dwIndex,
                             LPSTR lpName,
                             DWORD cbName
                           );

LONG WINAPI LWM_RegEnumKeyExA( HKEY hKey,
                               DWORD dwIndex,
                               LPSTR lpName,
                               LPDWORD lpcbName,
                               LPDWORD lpReserved,
                               LPSTR lpClass,
                               LPDWORD lpcbClass,
                               PFILETIME lpftLastWriteTime
                             );

LONG WINAPI LWM_RegEnumKeyExW( HKEY hKey,
                               DWORD dwIndex,
                               LPWSTR lpName,
                               LPDWORD lpcbName,
                               LPDWORD lpReserved,
                               LPWSTR lpClass,
                               LPDWORD lpcbClass,
                               PFILETIME lpftLastWriteTime
                             );

LONG WINAPI LWM_RegEnumKeyW( HKEY hKey,
                             DWORD dwIndex,
                             LPWSTR lpName,
                             DWORD cbName
                           );

LONG WINAPI LWM_RegEnumValueA( HKEY hKey,
                               DWORD dwIndex,
                               LPSTR lpValueName,
                               LPDWORD lpcbValueName,
                               LPDWORD lpReserved,
                               LPDWORD lpType,
                               LPBYTE lpData,
                               LPDWORD lpcbData
                             );

LONG WINAPI LWM_RegEnumValueW( HKEY hKey,
                               DWORD dwIndex,
                               LPWSTR lpValueName,
                               LPDWORD lpcbValueName,
                               LPDWORD lpReserved,
                               LPDWORD lpType,
                               LPBYTE lpData,
                               LPDWORD lpcbData
                             );

LONG WINAPI LWM_RegFlushKey( HKEY hKey );

LONG WINAPI LWM_RegGetKeySecurity( HKEY hKey,
                                   SECURITY_INFORMATION SecurityInformation,
                                   PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                   LPDWORD lpcbSecurityDescriptor
                                 );

LONG WINAPI LWM_RegLoadKeyA( HKEY hKey,
                             LPCSTR lpSubKey,
                             LPCSTR lpFile
                           );

LONG WINAPI LWM_RegLoadKeyW( HKEY hKey,
                             LPCWSTR lpSubKey,
                             LPCWSTR lpFile
                           );

LONG WINAPI LWM_RegNotifyChangeKeyValue( HKEY hKey,
                                         BOOL bWatchSubtree,
                                         DWORD dwNotifyFilter,
                                         HANDLE hEvent,
                                         BOOL fAsynchronus
                                       );

LONG WINAPI LWM_RegOpenKeyA( HKEY hKey,
                             LPCSTR lpSubKey,
                             PHKEY phkResult
                           );

LONG WINAPI LWM_RegOpenKeyExA( HKEY hKey,
                               LPCSTR lpSubKey,
                               DWORD ulOptions,
                               REGSAM samDesired,
                               PHKEY phkResult
                             );

LONG WINAPI LWM_RegOpenKeyExW( HKEY hKey,
                               LPCWSTR lpSubKey,
                               DWORD ulOptions,
                               REGSAM samDesired,
                               PHKEY phkResult
                             );

LONG WINAPI LWM_RegOpenKeyW( HKEY hKey,
                             LPCWSTR lpSubKey,
                             PHKEY phkResult
                           );

LONG WINAPI LWM_RegQueryInfoKeyA( HKEY hKey,
                                  LPSTR lpClass,
                                  LPDWORD lpcbClass,
                                  LPDWORD lpReserved,
                                  LPDWORD lpcSubKeys,
                                  LPDWORD lpcbMaxSubKeyLen,
                                  LPDWORD lpcbMaxClassLen,
                                  LPDWORD lpcValues,
                                  LPDWORD lpcbMaxValueNameLen,
                                  LPDWORD lpcbMaxValueLen,
                                  LPDWORD lpcbSecurityDescriptor,
                                  PFILETIME lpftLastWriteTime
                                );

LONG WINAPI LWM_RegQueryInfoKeyW( HKEY hKey,
                                  LPWSTR lpClass,
                                  LPDWORD lpcbClass,
                                  LPDWORD lpReserved,
                                  LPDWORD lpcSubKeys,
                                  LPDWORD lpcbMaxSubKeyLen,
                                  LPDWORD lpcbMaxClassLen,
                                  LPDWORD lpcValues,
                                  LPDWORD lpcbMaxValueNameLen,
                                  LPDWORD lpcbMaxValueLen,
                                  LPDWORD lpcbSecurityDescriptor,
                                  PFILETIME lpftLastWriteTime
                                );

LONG WINAPI LWM_RegQueryMultipleValuesA( HKEY hKey,
                                         PVALENTA val_list,
                                         DWORD num_vals,
                                         LPSTR lpValueBuf,
                                         LPDWORD ldwTotsize
                                       );

LONG WINAPI LWM_RegQueryMultipleValuesW( HKEY hKey,
                                         PVALENTW val_list,
                                         DWORD num_vals,
                                         LPWSTR lpValueBuf,
                                         LPDWORD ldwTotsize
                                       );

LONG WINAPI LWM_RegQueryValueA( HKEY hKey,
                                LPCSTR lpSubKey,
                                LPSTR lpValue,
                                PLONG lpcbValue
                              );

LONG WINAPI LWM_RegQueryValueExA( HKEY hKey,
                                  LPCSTR lpValueName,
                                  LPDWORD lpReserved,
                                  LPDWORD lpType,
                                  LPBYTE lpData,
                                  LPDWORD lpcbData
                                );

LONG WINAPI LWM_RegQueryValueExW( HKEY hKey,
                                  LPCWSTR lpValueName,
                                  LPDWORD lpReserved,
                                  LPDWORD lpType,
                                  LPBYTE lpData,
                                  LPDWORD lpcbData
                                );

LONG WINAPI LWM_RegQueryValueW( HKEY hKey,
                                LPCWSTR lpSubKey,
                                LPWSTR lpValue,
                                PLONG lpcbValue
                              );

LONG WINAPI LWM_RegReplaceKeyA( HKEY hKey,
                                LPCSTR lpSubKey,
                                LPCSTR lpNewFile,
                                LPCSTR lpOldFile
                              );

LONG WINAPI LWM_RegReplaceKeyW( HKEY hKey,
                                LPCWSTR lpSubKey,
                                LPCWSTR lpNewFile,
                                LPCWSTR lpOldFile
                              );

LONG WINAPI LWM_RegRestoreKeyA( HKEY hKey,
                                LPCSTR lpFile,
                                DWORD dwFlags
                              );

LONG WINAPI LWM_RegRestoreKeyW( HKEY hKey,
                                LPCWSTR lpFile,
                                DWORD dwFlags
                              );

LONG WINAPI LWM_RegSaveKeyA( HKEY hKey,
                             LPCSTR lpFile,
                             LPSECURITY_ATTRIBUTES lpSecurityAttributes
                           );

LONG WINAPI LWM_RegSaveKeyW( HKEY hKey,
                             LPCWSTR lpFile,
                             LPSECURITY_ATTRIBUTES lpSecurityAttributes
                           );

LONG WINAPI LWM_RegSetKeySecurity( HKEY hKey,
                                   SECURITY_INFORMATION SecurityInformation,
                                   PSECURITY_DESCRIPTOR pSecurityDescriptor
                                 );

LONG WINAPI LWM_RegSetValueA( HKEY hKey,
                              LPCSTR lpSubKey,
                              DWORD dwType,
                              LPCSTR lpData,
                              DWORD cbData
                            );

LONG WINAPI LWM_RegSetValueExA( HKEY hKey,
                                LPCSTR lpValueName,
                                DWORD Reserved,
                                DWORD dwType,
                                const BYTE * lpData,
                                DWORD cbData
                              );

LONG WINAPI LWM_RegSetValueExW( HKEY hKey,
                                LPCWSTR lpValueName,
                                DWORD Reserved,
                                DWORD dwType,
                                const BYTE * lpData,
                                DWORD cbData
                              );

LONG WINAPI LWM_RegSetValueW( HKEY hKey,
                              LPCWSTR lpSubKey,
                              DWORD dwType,
                              LPCWSTR lpData,
                              DWORD cbData
                            );

LONG WINAPI LWM_RegUnLoadKeyA( HKEY hKey,
                               LPCSTR lpSubKey
                             );

LONG WINAPI LWM_RegUnLoadKeyW( HKEY hKey,
                               LPCWSTR lpSubKey
                             );

HANDLE WINAPI LWM_RegisterEventSourceA( LPCSTR lpUNCServerName,
                                        LPCSTR lpSourceName
                                      );

HANDLE WINAPI LWM_RegisterEventSourceW( LPCWSTR lpUNCServerName,
                                        LPCWSTR lpSourceName
                                      );

SERVICE_STATUS_HANDLE WINAPI LWM_RegisterServiceCtrlHandlerA( LPCSTR lpServiceName,
                                                              LPHANDLER_FUNCTION lpHandlerProc
                                                            );

SERVICE_STATUS_HANDLE WINAPI LWM_RegisterServiceCtrlHandlerW( LPCWSTR lpServiceName,
                                                              LPHANDLER_FUNCTION lpHandlerProc
                                                            );

BOOL WINAPI LWM_ReleaseMutex( HANDLE hMutex );

BOOL WINAPI LWM_ReleaseSemaphore( HANDLE hSemaphore,
                                  LONG lReleaseCount,
                                  LPLONG lpPreviousCount
                                );

BOOL WINAPI LWM_RemoveDirectoryA( LPCSTR lpPathName );

BOOL WINAPI LWM_RemoveDirectoryW( LPCWSTR lpPathName );

BOOL WINAPI LWM_ReportEventA( HANDLE hEventLog,
                              WORD wType,
                              WORD wCategory,
                              DWORD dwEventID,
                              PSID lpUserSid,
                              WORD wNumStrings,
                              DWORD dwDataSize,
                              LPCSTR * lpStrings,
                              LPVOID lpRawData
                            );

BOOL WINAPI LWM_ReportEventW( HANDLE hEventLog,
                              WORD wType,
                              WORD wCategory,
                              DWORD dwEventID,
                              PSID lpUserSid,
                              WORD wNumStrings,
                              DWORD dwDataSize,
                              LPCWSTR * lpStrings,
                              LPVOID lpRawData
                            );

BOOL WINAPI LWM_ResetEvent( HANDLE hEvent );

DWORD WINAPI LWM_ResumeThread( HANDLE hThread );

BOOL WINAPI LWM_RevertToSelf( void );

BOOL WINAPI LWM_ScrollConsoleScreenBufferA( HANDLE hConsoleOutput,
                                            const SMALL_RECT * lpScrollRectangle,
                                            const SMALL_RECT * lpClipRectangle,
                                            COORD dwDestinationOrigin,
                                            const CHAR_INFO * lpFill
                                          );

BOOL WINAPI LWM_ScrollConsoleScreenBufferW( HANDLE hConsoleOutput,
                                            const SMALL_RECT * lpScrollRectangle,
                                            const SMALL_RECT * lpClipRectangle,
                                            COORD dwDestinationOrigin,
                                            const CHAR_INFO * lpFill
                                          );

DWORD WINAPI LWM_SearchPathA( LPCSTR lpPath,
                              LPCSTR lpFileName,
                              LPCSTR lpExtension,
                              DWORD nBufferLength,
                              LPSTR lpBuffer,
                              LPSTR * lpFilePart
                            );

DWORD WINAPI LWM_SearchPathW( LPCWSTR lpPath,
                              LPCWSTR lpFileName,
                              LPCWSTR lpExtension,
                              DWORD nBufferLength,
                              LPWSTR lpBuffer,
                              LPWSTR * lpFilePart
                            );

BOOL WINAPI LWM_SetAclInformation( PACL pAcl,
                                   LPVOID pAclInformation,
                                   DWORD nAclInformationLength,
                                   ACL_INFORMATION_CLASS dwAclInformationClass
                                 );

BOOL WINAPI LWM_SetCommBreak( HANDLE hFile );

BOOL WINAPI LWM_SetCommConfig( HANDLE hCommDev,
                               LPCOMMCONFIG lpCC,
                               DWORD dwSize
                             );

BOOL WINAPI LWM_SetCommMask( HANDLE hFile,
                             DWORD dwEvtMask
                           );

BOOL WINAPI LWM_SetCommState( HANDLE hFile,
                              LPDCB lpDCB
                            );

BOOL WINAPI LWM_SetCommTimeouts( HANDLE hFile,
                                 LPCOMMTIMEOUTS lpCommTimeouts
                               );

BOOL WINAPI LWM_SetComputerNameA( LPCSTR lpComputerName );

BOOL WINAPI LWM_SetComputerNameW( LPCWSTR lpComputerName );

BOOL WINAPI LWM_SetConsoleActiveScreenBuffer( HANDLE hConsoleOutput );

BOOL WINAPI LWM_SetConsoleCP( UINT wCodePageID );

BOOL WINAPI LWM_SetConsoleCtrlHandler( PHANDLER_ROUTINE HandlerRoutine,
                                       BOOL Add
                                     );

BOOL WINAPI LWM_SetConsoleCursorInfo( HANDLE hConsoleOutput,
                                      const CONSOLE_CURSOR_INFO * lpConsoleCursorInfo
                                    );

BOOL WINAPI LWM_SetConsoleCursorPosition( HANDLE hConsoleOutput,
                                          COORD dwCursorPosition
                                        );

BOOL WINAPI LWM_SetConsoleMode( HANDLE hConsoleHandle,
                                DWORD dwMode
                              );

BOOL WINAPI LWM_SetConsoleOutputCP( UINT wCodePageID );

BOOL WINAPI LWM_SetConsoleScreenBufferSize( HANDLE hConsoleOutput,
                                            COORD dwSize
                                          );

BOOL WINAPI LWM_SetConsoleTextAttribute( HANDLE hConsoleOutput,
                                         WORD wAttributes
                                       );

BOOL WINAPI LWM_SetConsoleTitleA( LPCSTR lpConsoleTitle );

BOOL WINAPI LWM_SetConsoleTitleW( LPCWSTR lpConsoleTitle );

BOOL WINAPI LWM_SetConsoleWindowInfo( HANDLE hConsoleOutput,
                                      BOOL bAbsolute,
                                      const SMALL_RECT * lpConsoleWindow
                                    );

BOOL WINAPI LWM_SetCurrentDirectoryA( LPCSTR lpPathName );

BOOL WINAPI LWM_SetCurrentDirectoryW( LPCWSTR lpPathName );

BOOL WINAPI LWM_SetDefaultCommConfigA( LPCSTR lpszName,
                                       LPCOMMCONFIG lpCC,
                                       DWORD dwSize
                                     );

BOOL WINAPI LWM_SetDefaultCommConfigW( LPCWSTR lpszName,
                                       LPCOMMCONFIG lpCC,
                                       DWORD dwSize
                                     );

BOOL WINAPI LWM_SetEndOfFile( HANDLE hFile );

BOOL WINAPI LWM_SetEnvironmentVariableA( LPCSTR lpName,
                                         LPCSTR lpValue
                                       );

BOOL WINAPI LWM_SetEnvironmentVariableW( LPCWSTR lpName,
                                         LPCWSTR lpValue
                                       );

UINT WINAPI LWM_SetErrorMode( UINT uMode );

BOOL WINAPI LWM_SetEvent( HANDLE hEvent );

void WINAPI LWM_SetFileApisToANSI( void );

void WINAPI LWM_SetFileApisToOEM( void );

BOOL WINAPI LWM_SetFileAttributesA( LPCSTR lpFileName,
                                    DWORD dwFileAttributes
                                  );

BOOL WINAPI LWM_SetFileAttributesW( LPCWSTR lpFileName,
                                    DWORD dwFileAttributes
                                  );

DWORD WINAPI LWM_SetFilePointer( HANDLE hFile,
                                 LONG lDistanceToMove,
                                 PLONG lpDistanceToMoveHigh,
                                 DWORD dwMoveMethod
                               );

BOOL WINAPI LWM_SetFileSecurityA( LPCSTR lpFileName,
                                  SECURITY_INFORMATION SecurityInformation,
                                  PSECURITY_DESCRIPTOR pSecurityDescriptor
                                );

BOOL WINAPI LWM_SetFileSecurityW( LPCWSTR lpFileName,
                                  SECURITY_INFORMATION SecurityInformation,
                                  PSECURITY_DESCRIPTOR pSecurityDescriptor
                                );

BOOL WINAPI LWM_SetFileTime( HANDLE hFile,
                             const FILETIME * lpCreationTime,
                             const FILETIME * lpLastAccessTime,
                             const FILETIME * lpLastWriteTime
                           );

UINT WINAPI LWM_SetHandleCount( UINT uNumber );

BOOL WINAPI LWM_SetHandleInformation( HANDLE hObject,
                                      DWORD dwMask,
                                      DWORD dwFlags
                                    );

BOOL WINAPI LWM_SetKernelObjectSecurity( HANDLE Handle,
                                         SECURITY_INFORMATION SecurityInformation,
                                         PSECURITY_DESCRIPTOR SecurityDescriptor
                                       );

void WINAPI LWM_SetLastError( DWORD dwErrCode );

BOOL WINAPI LWM_SetLocalTime( const SYSTEMTIME * lpSystemTime );

BOOL WINAPI LWM_SetLocaleInfoA( LCID Locale,
                                LCTYPE LCType,
                                LPCSTR lpLCData
                              );

BOOL WINAPI LWM_SetLocaleInfoW( LCID Locale,
                                LCTYPE LCType,
                                LPCWSTR lpLCData
                              );

BOOL WINAPI LWM_SetMailslotInfo( HANDLE hMailslot,
                                 DWORD lReadTimeout
                               );

BOOL WINAPI LWM_SetNamedPipeHandleState( HANDLE hNamedPipe,
                                         LPDWORD lpMode,
                                         LPDWORD lpMaxCollectionCount,
                                         LPDWORD lpCollectDataTimeout
                                       );

BOOL WINAPI LWM_SetPriorityClass( HANDLE hProcess,
                                  DWORD dwPriorityClass
                                );

BOOL WINAPI LWM_SetPrivateObjectSecurity( SECURITY_INFORMATION SecurityInformation,
                                          PSECURITY_DESCRIPTOR ModificationDescriptor,
                                          PSECURITY_DESCRIPTOR * ObjectsSecurityDescriptor,
                                          PGENERIC_MAPPING GenericMapping,
                                          HANDLE Token
                                        );

BOOL WINAPI LWM_SetProcessAffinityMask( HANDLE hProcess,
                                        DWORD_PTR dwProcessAffinityMask
                                      );

BOOL WINAPI LWM_SetProcessPriorityBoost( HANDLE hProcess,
                                         BOOL bDisablePriorityBoost
                                       );

BOOL WINAPI LWM_SetProcessShutdownParameters( DWORD dwLevel,
                                              DWORD dwFlags
                                            );

BOOL WINAPI LWM_SetProcessWorkingSetSize( HANDLE hProcess,
                                          SIZE_T dwMinimumWorkingSetSize,
                                          SIZE_T dwMaximumWorkingSetSize
                                        );

BOOL WINAPI LWM_SetSecurityDescriptorDacl( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                           BOOL bDaclPresent,
                                           PACL pDacl,
                                           BOOL bDaclDefaulted
                                         );

BOOL WINAPI LWM_SetSecurityDescriptorGroup( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                            PSID pGroup,
                                            BOOL bGroupDefaulted
                                          );

BOOL WINAPI LWM_SetSecurityDescriptorOwner( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                            PSID pOwner,
                                            BOOL bOwnerDefaulted
                                          );

BOOL WINAPI LWM_SetSecurityDescriptorSacl( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                           BOOL bSaclPresent,
                                           PACL pSacl,
                                           BOOL bSaclDefaulted
                                         );

BOOL WINAPI LWM_SetServiceObjectSecurity( SC_HANDLE hService,
                                          SECURITY_INFORMATION dwSecurityInformation,
                                          PSECURITY_DESCRIPTOR lpSecurityDescriptor
                                        );

BOOL WINAPI LWM_SetServiceStatus( SERVICE_STATUS_HANDLE hServiceStatus,
                                  LPSERVICE_STATUS lpServiceStatus
                                );

BOOL WINAPI LWM_SetStdHandle( DWORD nStdHandle,
                              HANDLE hHandle
                            );

BOOL WINAPI LWM_SetSystemTime( const SYSTEMTIME * lpSystemTime );

BOOL WINAPI LWM_SetSystemTimeAdjustment( DWORD dwTimeAdjustment,
                                         BOOL bTimeAdjustmentDisabled
                                       );

DWORD WINAPI LWM_SetTapeParameters( HANDLE hDevice,
                                    DWORD dwOperation,
                                    LPVOID lpTapeInformation
                                  );

DWORD WINAPI LWM_SetTapePosition( HANDLE hDevice,
                                  DWORD dwPositionMethod,
                                  DWORD dwPartition,
                                  DWORD dwOffsetLow,
                                  DWORD dwOffsetHigh,
                                  BOOL bImmediate
                                );

DWORD_PTR WINAPI LWM_SetThreadAffinityMask( HANDLE hThread,
                                            DWORD_PTR dwThreadAffinityMask
                                          );

BOOL WINAPI LWM_SetThreadContext( HANDLE hThread,
                                  const CONTEXT * lpContext
                                );

DWORD WINAPI LWM_SetThreadIdealProcessor( HANDLE hThread,
                                          DWORD dwIdealProcessor
                                        );

BOOL WINAPI LWM_SetThreadLocale( LCID Locale );

BOOL WINAPI LWM_SetThreadPriority( HANDLE hThread,
                                   int nPriority
                                 );

BOOL WINAPI LWM_SetThreadPriorityBoost( HANDLE hThread,
                                        BOOL bDisablePriorityBoost
                                      );

BOOL WINAPI LWM_SetThreadToken( PHANDLE Thread,
                                HANDLE Token
                              );

BOOL WINAPI LWM_SetTimeZoneInformation( const TIME_ZONE_INFORMATION * lpTimeZoneInformation );

BOOL WINAPI LWM_SetTokenInformation( HANDLE TokenHandle,
                                     TOKEN_INFORMATION_CLASS TokenInformationClass,
                                     LPVOID TokenInformation,
                                     DWORD TokenInformationLength
                                   );

LPTOP_LEVEL_EXCEPTION_FILTER WINAPI LWM_SetUnhandledExceptionFilter( LPTOP_LEVEL_EXCEPTION_FILTER lpTopLevelExceptionFilter );

BOOL WINAPI LWM_SetVolumeLabelA( LPCSTR lpRootPathName,
                                 LPCSTR lpVolumeName
                               );

BOOL WINAPI LWM_SetVolumeLabelW( LPCWSTR lpRootPathName,
                                 LPCWSTR lpVolumeName
                               );

BOOL WINAPI LWM_SetWaitableTimer( HANDLE hTimer,
                                  const LARGE_INTEGER * lpDueTime,
                                  LONG lPeriod,
                                  PTIMERAPCROUTINE pfnCompletionRoutine,
                                  LPVOID lpArgToCompletionRoutine,
                                  BOOL fResume
                                );

BOOL WINAPI LWM_SetupComm( HANDLE hFile,
                           DWORD dwInQueue,
                           DWORD dwOutQueue
                         );

DWORD WINAPI LWM_SignalObjectAndWait( HANDLE hObjectToSignal,
                                      HANDLE hObjectToWaitOn,
                                      DWORD dwMilliseconds,
                                      BOOL bAlertable
                                    );

DWORD WINAPI LWM_SizeofResource( HMODULE hModule,
                                 HRSRC hResInfo
                               );

void WINAPI LWM_Sleep( DWORD dwMilliseconds );

DWORD WINAPI LWM_SleepEx( DWORD dwMilliseconds,
                          BOOL bAlertable
                        );

BOOL WINAPI LWM_StartServiceA( SC_HANDLE hService,
                               DWORD dwNumServiceArgs,
                               LPCSTR * lpServiceArgVectors
                             );

BOOL WINAPI LWM_StartServiceCtrlDispatcherA( const SERVICE_TABLE_ENTRYA * lpServiceStartTable );

BOOL WINAPI LWM_StartServiceCtrlDispatcherW( const SERVICE_TABLE_ENTRYW * lpServiceStartTable );

BOOL WINAPI LWM_StartServiceW( SC_HANDLE hService,
                               DWORD dwNumServiceArgs,
                               LPCWSTR * lpServiceArgVectors
                             );

DWORD WINAPI LWM_SuspendThread( HANDLE hThread );

void WINAPI LWM_SwitchToFiber( LPVOID lpFiber );

BOOL WINAPI LWM_SwitchToThread( void );

BOOL WINAPI LWM_SystemTimeToFileTime( const SYSTEMTIME * lpSystemTime,
                                      LPFILETIME lpFileTime
                                    );

BOOL WINAPI LWM_SystemTimeToTzSpecificLocalTime( LPTIME_ZONE_INFORMATION lpTimeZoneInformation,
                                                 LPSYSTEMTIME lpUniversalTime,
                                                 LPSYSTEMTIME lpLocalTime
                                               );

BOOL WINAPI LWM_TerminateProcess( HANDLE hProcess,
                                  UINT uExitCode
                                );

BOOL WINAPI LWM_TerminateThread( HANDLE hThread,
                                 DWORD dwExitCode
                               );

DWORD WINAPI LWM_TlsAlloc( void );

BOOL WINAPI LWM_TlsFree( DWORD dwTlsIndex );

LPVOID WINAPI LWM_TlsGetValue( DWORD dwTlsIndex );

BOOL WINAPI LWM_TlsSetValue( DWORD dwTlsIndex,
                             LPVOID lpTlsValue
                           );

BOOL WINAPI LWM_TransactNamedPipe( HANDLE hNamedPipe,
                                   LPVOID lpInBuffer,
                                   DWORD nInBufferSize,
                                   LPVOID lpOutBuffer,
                                   DWORD nOutBufferSize,
                                   LPDWORD lpBytesRead,
                                   LPOVERLAPPED lpOverlapped
                                 );

BOOL WINAPI LWM_TransmitCommChar( HANDLE hFile,
                                  char cChar
                                );

LONG WINAPI LWM_UnhandledExceptionFilter( struct _EXCEPTION_POINTERS * ExceptionInfo );

BOOL WINAPI LWM_UnlockFile( HANDLE hFile,
                            DWORD dwFileOffsetLow,
                            DWORD dwFileOffsetHigh,
                            DWORD nNumberOfBytesToUnlockLow,
                            DWORD nNumberOfBytesToUnlockHigh
                          );

BOOL WINAPI LWM_UnlockFileEx( HANDLE hFile,
                              DWORD dwReserved,
                              DWORD nNumberOfBytesToUnlockLow,
                              DWORD nNumberOfBytesToUnlockHigh,
                              LPOVERLAPPED lpOverlapped
                            );

BOOL WINAPI LWM_UnlockServiceDatabase( SC_LOCK ScLock );

BOOL WINAPI LWM_UnmapViewOfFile( LPCVOID lpBaseAddress );

BOOL WINAPI LWM_UpdateResourceA( HANDLE hUpdate,
                                 LPCSTR lpType,
                                 LPCSTR lpName,
                                 WORD wLanguage,
                                 LPVOID lpData,
                                 DWORD cbData
                               );

BOOL WINAPI LWM_UpdateResourceW( HANDLE hUpdate,
                                 LPCWSTR lpType,
                                 LPCWSTR lpName,
                                 WORD wLanguage,
                                 LPVOID lpData,
                                 DWORD cbData
                               );

BOOL WINAPI LWM_VerifyVersionInfoA( LPOSVERSIONINFOEXA lpVersionInformation,
                                    DWORD dwTypeMask,
                                    DWORDLONG dwlConditionMask
                                  );

BOOL WINAPI LWM_VerifyVersionInfoW( LPOSVERSIONINFOEXW lpVersionInformation,
                                    DWORD dwTypeMask,
                                    DWORDLONG dwlConditionMask
                                  );

LPVOID WINAPI LWM_VirtualAlloc( LPVOID lpAddress,
                                SIZE_T dwSize,
                                DWORD flAllocationType,
                                DWORD flProtect
                              );

LPVOID WINAPI LWM_VirtualAllocEx( HANDLE hProcess,
                                  LPVOID lpAddress,
                                  SIZE_T dwSize,
                                  DWORD flAllocationType,
                                  DWORD flProtect
                                );

BOOL WINAPI LWM_VirtualFree( LPVOID lpAddress,
                             SIZE_T dwSize,
                             DWORD dwFreeType
                           );

BOOL WINAPI LWM_VirtualFreeEx( HANDLE hProcess,
                               LPVOID lpAddress,
                               SIZE_T dwSize,
                               DWORD dwFreeType
                             );

BOOL WINAPI LWM_VirtualLock( LPVOID lpAddress,
                             SIZE_T dwSize
                           );

BOOL WINAPI LWM_VirtualProtect( LPVOID lpAddress,
                                SIZE_T dwSize,
                                DWORD flNewProtect,
                                PDWORD lpflOldProtect
                              );

BOOL WINAPI LWM_VirtualProtectEx( HANDLE hProcess,
                                  LPVOID lpAddress,
                                  SIZE_T dwSize,
                                  DWORD flNewProtect,
                                  PDWORD lpflOldProtect
                                );

DWORD WINAPI LWM_VirtualQuery( LPCVOID lpAddress,
                               PMEMORY_BASIC_INFORMATION lpBuffer,
                               DWORD dwLength
                             );

DWORD WINAPI LWM_VirtualQueryEx( HANDLE hProcess,
                                 LPCVOID lpAddress,
                                 PMEMORY_BASIC_INFORMATION lpBuffer,
                                 DWORD dwLength
                               );

BOOL WINAPI LWM_VirtualUnlock( LPVOID lpAddress,
                               SIZE_T dwSize
                             );

BOOL WINAPI LWM_WaitCommEvent( HANDLE hFile,
                               LPDWORD lpEvtMask,
                               LPOVERLAPPED lpOverlapped
                             );

BOOL WINAPI LWM_WaitForDebugEvent( LPDEBUG_EVENT lpDebugEvent,
                                   DWORD dwMilliseconds
                                 );

DWORD WINAPI LWM_WaitForMultipleObjects( DWORD nCount,
                                         const HANDLE * lpHandles,
                                         BOOL bWaitAll,
                                         DWORD dwMilliseconds
                                       );

DWORD WINAPI LWM_WaitForMultipleObjectsEx( DWORD nCount,
                                           const HANDLE * lpHandles,
                                           BOOL bWaitAll,
                                           DWORD dwMilliseconds,
                                           BOOL bAlertable
                                         );

DWORD WINAPI LWM_WaitForSingleObject( HANDLE hHandle,
                                      DWORD dwMilliseconds
                                    );

DWORD WINAPI LWM_WaitForSingleObjectEx( HANDLE hHandle,
                                        DWORD dwMilliseconds,
                                        BOOL bAlertable
                                      );

BOOL WINAPI LWM_WaitNamedPipeA( LPCSTR lpNamedPipeName,
                                DWORD nTimeOut
                              );

BOOL WINAPI LWM_WaitNamedPipeW( LPCWSTR lpNamedPipeName,
                                DWORD nTimeOut
                              );

int WINAPI LWM_WideCharToMultiByte( UINT CodePage,
                                    DWORD dwFlags,
                                    LPCWSTR lpWideCharStr,
                                    int cchWideChar,
                                    LPSTR lpMultiByteStr,
                                    int cbMultiByte,
                                    LPCSTR lpDefaultChar,
                                    LPBOOL lpUsedDefaultChar
                                  );

UINT WINAPI LWM_WinExec( LPCSTR lpCmdLine,
                         UINT uCmdShow
                       );

BOOL WINAPI LWM_WriteConsoleA( HANDLE hConsoleOutput,
                               const void * lpBuffer,
                               DWORD nNumberOfCharsToWrite,
                               LPDWORD lpNumberOfCharsWritten,
                               LPVOID lpReserved
                             );

BOOL WINAPI LWM_WriteConsoleInputA( HANDLE hConsoleInput,
                                    const INPUT_RECORD * lpBuffer,
                                    DWORD nLength,
                                    LPDWORD lpNumberOfEventsWritten
                                  );

BOOL WINAPI LWM_WriteConsoleInputW( HANDLE hConsoleInput,
                                    const INPUT_RECORD * lpBuffer,
                                    DWORD nLength,
                                    LPDWORD lpNumberOfEventsWritten
                                  );

BOOL WINAPI LWM_WriteConsoleOutputA( HANDLE hConsoleOutput,
                                     const CHAR_INFO * lpBuffer,
                                     COORD dwBufferSize,
                                     COORD dwBufferCoord,
                                     PSMALL_RECT lpWriteRegion
                                   );

BOOL WINAPI LWM_WriteConsoleOutputAttribute( HANDLE hConsoleOutput,
                                             const WORD * lpAttribute,
                                             DWORD nLength,
                                             COORD dwWriteCoord,
                                             LPDWORD lpNumberOfAttrsWritten
                                           );

BOOL WINAPI LWM_WriteConsoleOutputCharacterA( HANDLE hConsoleOutput,
                                              LPCSTR lpCharacter,
                                              DWORD nLength,
                                              COORD dwWriteCoord,
                                              LPDWORD lpNumberOfCharsWritten
                                            );

BOOL WINAPI LWM_WriteConsoleOutputCharacterW( HANDLE hConsoleOutput,
                                              LPCWSTR lpCharacter,
                                              DWORD nLength,
                                              COORD dwWriteCoord,
                                              LPDWORD lpNumberOfCharsWritten
                                            );

BOOL WINAPI LWM_WriteConsoleOutputW( HANDLE hConsoleOutput,
                                     const CHAR_INFO * lpBuffer,
                                     COORD dwBufferSize,
                                     COORD dwBufferCoord,
                                     PSMALL_RECT lpWriteRegion
                                   );

BOOL WINAPI LWM_WriteConsoleW( HANDLE hConsoleOutput,
                               const void * lpBuffer,
                               DWORD nNumberOfCharsToWrite,
                               LPDWORD lpNumberOfCharsWritten,
                               LPVOID lpReserved
                             );

BOOL WINAPI LWM_WriteFile( HANDLE hFile,
                           LPCVOID lpBuffer,
                           DWORD nNumberOfBytesToWrite,
                           LPDWORD lpNumberOfBytesWritten,
                           LPOVERLAPPED lpOverlapped
                         );

BOOL WINAPI LWM_WriteFileEx( HANDLE hFile,
                             LPCVOID lpBuffer,
                             DWORD nNumberOfBytesToWrite,
                             LPOVERLAPPED lpOverlapped,
                             LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
                           );

BOOL WINAPI LWM_WriteFileGather( HANDLE hFile,
                                 FILE_SEGMENT_ELEMENT aSegmentArray [ ],
                                 DWORD nNumberOfBytesToWrite,
                                 LPDWORD lpReserved,
                                 LPOVERLAPPED lpOverlapped
                               );

BOOL WINAPI LWM_WritePrivateProfileSectionA( LPCSTR lpAppName,
                                             LPCSTR lpString,
                                             LPCSTR lpFileName
                                           );

BOOL WINAPI LWM_WritePrivateProfileSectionW( LPCWSTR lpAppName,
                                             LPCWSTR lpString,
                                             LPCWSTR lpFileName
                                           );

BOOL WINAPI LWM_WritePrivateProfileStringA( LPCSTR lpAppName,
                                            LPCSTR lpKeyName,
                                            LPCSTR lpString,
                                            LPCSTR lpFileName
                                          );

BOOL WINAPI LWM_WritePrivateProfileStringW( LPCWSTR lpAppName,
                                            LPCWSTR lpKeyName,
                                            LPCWSTR lpString,
                                            LPCWSTR lpFileName
                                          );

BOOL WINAPI LWM_WritePrivateProfileStructA( LPCSTR lpszSection,
                                            LPCSTR lpszKey,
                                            LPVOID lpStruct,
                                            UINT uSizeStruct,
                                            LPCSTR szFile
                                          );

BOOL WINAPI LWM_WritePrivateProfileStructW( LPCWSTR lpszSection,
                                            LPCWSTR lpszKey,
                                            LPVOID lpStruct,
                                            UINT uSizeStruct,
                                            LPCWSTR szFile
                                          );

BOOL WINAPI LWM_WriteProcessMemory( HANDLE hProcess,
                                    LPVOID lpBaseAddress,
                                    LPVOID lpBuffer,
                                    DWORD nSize,
                                    LPDWORD lpNumberOfBytesWritten
                                  );

BOOL WINAPI LWM_WriteProfileSectionA( LPCSTR lpAppName,
                                      LPCSTR lpString
                                    );

BOOL WINAPI LWM_WriteProfileSectionW( LPCWSTR lpAppName,
                                      LPCWSTR lpString
                                    );

BOOL WINAPI LWM_WriteProfileStringA( LPCSTR lpAppName,
                                     LPCSTR lpKeyName,
                                     LPCSTR lpString
                                   );

BOOL WINAPI LWM_WriteProfileStringW( LPCWSTR lpAppName,
                                     LPCWSTR lpKeyName,
                                     LPCWSTR lpString
                                   );

DWORD WINAPI LWM_WriteTapemark( HANDLE hDevice,
                                DWORD dwTapemarkType,
                                DWORD dwTapemarkCount,
                                BOOL bImmediate
                              );

long WINAPI LWM__hread( HFILE hFile,
                        LPVOID lpBuffer,
                        long lBytes
                      );

long WINAPI LWM__hwrite( HFILE hFile,
                         LPCSTR lpBuffer,
                         long lBytes
                       );

HFILE WINAPI LWM__lclose( HFILE hFile );

HFILE WINAPI LWM__lcreat( LPCSTR lpPathName,
                          int iAttribute
                        );

LONG WINAPI LWM__llseek( HFILE hFile,
                         LONG lOffset,
                         int iOrigin
                       );

HFILE WINAPI LWM__lopen( LPCSTR lpPathName,
                         int iReadWrite
                       );

UINT WINAPI LWM__lread( HFILE hFile,
                        LPVOID lpBuffer,
                        UINT uBytes
                      );

UINT WINAPI LWM__lwrite( HFILE hFile,
                         LPCSTR lpBuffer,
                         UINT uBytes
                       );


#ifdef __cplusplus
}
#endif

#endif /* !__LWMSTUBS_H */

