/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * lwmstubs5.cxx
 *
 * $Id: lwmstubs5.cxx,v 1.9 2001/04/05 18:40:41 stevek Exp $
 *
 * Note: This file is automatically generated by genstubs.pl
 *       Do not modify.
 */

#include <wr_conf.h>

#include <wsi_stdlib.h>

#include "hook.h"
#include "lwmstubs5.h"

#include <wss_process.h>
#include <wss_wrapper.h>
#include <wss_arg.h>
#include <wsi_os.h>

extern HOOKMAP        g_hookMap;
extern wss_proc      *g_wrp;
extern volatile BOOL  g_bTraceCalls;
extern volatile BOOL  g_bCountCalls;

#ifdef UNICODE
#undef GetEnvironmentStrings
#endif

// Modules which can be hooked
const char *k_MODULES_TO_HOOK[] =
{
   "kernel32.dll",
   "advapi32.dll",
   ""
};

// The number of functions to possibly be hooked
const int k_NUM_HOOKED_FUNCS = 949;

// The master table of function names and the hook functions.
HOOKFUNCDESC g_stToHookFuncs1[] =
{
   HOOKFUNCDESC( "AbortSystemShutdownA", (PROC)LWM_AbortSystemShutdownA, "advapi32.dll", 4 ),
   HOOKFUNCDESC( "AbortSystemShutdownW", (PROC)LWM_AbortSystemShutdownW, "advapi32.dll", 5 ),
   HOOKFUNCDESC( "AccessCheck", (PROC)LWM_AccessCheck, "advapi32.dll", 6 ),
   HOOKFUNCDESC( "AccessCheckAndAuditAlarmA", (PROC)LWM_AccessCheckAndAuditAlarmA, "advapi32.dll", 7 ),
   HOOKFUNCDESC( "AccessCheckAndAuditAlarmW", (PROC)LWM_AccessCheckAndAuditAlarmW, "advapi32.dll", 8 ),
   HOOKFUNCDESC( "AccessCheckByType", (PROC)LWM_AccessCheckByType, "advapi32.dll", 9 ),
   HOOKFUNCDESC( "AccessCheckByTypeAndAuditAlarmA", (PROC)LWM_AccessCheckByTypeAndAuditAlarmA, "advapi32.dll", 10 ),
   HOOKFUNCDESC( "AccessCheckByTypeAndAuditAlarmW", (PROC)LWM_AccessCheckByTypeAndAuditAlarmW, "advapi32.dll", 11 ),
   HOOKFUNCDESC( "AccessCheckByTypeResultList", (PROC)LWM_AccessCheckByTypeResultList, "advapi32.dll", 12 ),
   HOOKFUNCDESC( "AccessCheckByTypeResultListAndAuditAlarmA", (PROC)LWM_AccessCheckByTypeResultListAndAuditAlarmA, "advapi32.dll", 13 ),
   HOOKFUNCDESC( "AccessCheckByTypeResultListAndAuditAlarmByHandleA", (PROC)LWM_AccessCheckByTypeResultListAndAuditAlarmByHandleA, "advapi32.dll", 14 ),
   HOOKFUNCDESC( "AccessCheckByTypeResultListAndAuditAlarmByHandleW", (PROC)LWM_AccessCheckByTypeResultListAndAuditAlarmByHandleW, "advapi32.dll", 15 ),
   HOOKFUNCDESC( "AccessCheckByTypeResultListAndAuditAlarmW", (PROC)LWM_AccessCheckByTypeResultListAndAuditAlarmW, "advapi32.dll", 16 ),
   HOOKFUNCDESC( "AddAccessAllowedAce", (PROC)LWM_AddAccessAllowedAce, "advapi32.dll", 17 ),
   HOOKFUNCDESC( "AddAccessAllowedAceEx", (PROC)LWM_AddAccessAllowedAceEx, "advapi32.dll", 18 ),
   HOOKFUNCDESC( "AddAccessAllowedObjectAce", (PROC)LWM_AddAccessAllowedObjectAce, "advapi32.dll", 19 ),
   HOOKFUNCDESC( "AddAccessDeniedAce", (PROC)LWM_AddAccessDeniedAce, "advapi32.dll", 20 ),
   HOOKFUNCDESC( "AddAccessDeniedAceEx", (PROC)LWM_AddAccessDeniedAceEx, "advapi32.dll", 21 ),
   HOOKFUNCDESC( "AddAccessDeniedObjectAce", (PROC)LWM_AddAccessDeniedObjectAce, "advapi32.dll", 22 ),
   HOOKFUNCDESC( "AddAce", (PROC)LWM_AddAce, "advapi32.dll", 23 ),
   HOOKFUNCDESC( "AddAtomA", (PROC)LWM_AddAtomA, "kernel32.dll", 1 ),
   HOOKFUNCDESC( "AddAtomW", (PROC)LWM_AddAtomW, "kernel32.dll", 2 ),
   HOOKFUNCDESC( "AddAuditAccessAce", (PROC)LWM_AddAuditAccessAce, "advapi32.dll", 24 ),
   HOOKFUNCDESC( "AddAuditAccessAceEx", (PROC)LWM_AddAuditAccessAceEx, "advapi32.dll", 25 ),
   HOOKFUNCDESC( "AddAuditAccessObjectAce", (PROC)LWM_AddAuditAccessObjectAce, "advapi32.dll", 26 ),
   HOOKFUNCDESC( "AddUsersToEncryptedFile", (PROC)LWM_AddUsersToEncryptedFile, "advapi32.dll", 27 ),
   HOOKFUNCDESC( "AdjustTokenGroups", (PROC)LWM_AdjustTokenGroups, "advapi32.dll", 28 ),
   HOOKFUNCDESC( "AdjustTokenPrivileges", (PROC)LWM_AdjustTokenPrivileges, "advapi32.dll", 29 ),
   HOOKFUNCDESC( "AllocConsole", (PROC)LWM_AllocConsole, "kernel32.dll", 5 ),
   HOOKFUNCDESC( "AllocateAndInitializeSid", (PROC)LWM_AllocateAndInitializeSid, "advapi32.dll", 30 ),
   HOOKFUNCDESC( "AllocateLocallyUniqueId", (PROC)LWM_AllocateLocallyUniqueId, "advapi32.dll", 31 ),
   HOOKFUNCDESC( "AllocateUserPhysicalPages", (PROC)LWM_AllocateUserPhysicalPages, "kernel32.dll", 6 ),
   HOOKFUNCDESC( "AreAllAccessesGranted", (PROC)LWM_AreAllAccessesGranted, "advapi32.dll", 32 ),
   HOOKFUNCDESC( "AreAnyAccessesGranted", (PROC)LWM_AreAnyAccessesGranted, "advapi32.dll", 33 ),
   HOOKFUNCDESC( "AreFileApisANSI", (PROC)LWM_AreFileApisANSI, "kernel32.dll", 7 ),
   HOOKFUNCDESC( "AssignProcessToJobObject", (PROC)LWM_AssignProcessToJobObject, "kernel32.dll", 8 ),
   HOOKFUNCDESC( "BackupEventLogA", (PROC)LWM_BackupEventLogA, "advapi32.dll", 34 ),
   HOOKFUNCDESC( "BackupEventLogW", (PROC)LWM_BackupEventLogW, "advapi32.dll", 35 ),
   HOOKFUNCDESC( "BackupRead", (PROC)LWM_BackupRead, "kernel32.dll", 9 ),
   HOOKFUNCDESC( "BackupSeek", (PROC)LWM_BackupSeek, "kernel32.dll", 10 ),
   HOOKFUNCDESC( "BackupWrite", (PROC)LWM_BackupWrite, "kernel32.dll", 11 ),
   HOOKFUNCDESC( "Beep", (PROC)LWM_Beep, "kernel32.dll", 13 ),
   HOOKFUNCDESC( "BeginUpdateResourceA", (PROC)LWM_BeginUpdateResourceA, "kernel32.dll", 14 ),
   HOOKFUNCDESC( "BeginUpdateResourceW", (PROC)LWM_BeginUpdateResourceW, "kernel32.dll", 15 ),
   HOOKFUNCDESC( "BindIoCompletionCallback", (PROC)LWM_BindIoCompletionCallback, "kernel32.dll", 16 ),
   HOOKFUNCDESC( "BuildCommDCBA", (PROC)LWM_BuildCommDCBA, "kernel32.dll", 17 ),
   HOOKFUNCDESC( "BuildCommDCBAndTimeoutsA", (PROC)LWM_BuildCommDCBAndTimeoutsA, "kernel32.dll", 18 ),
   HOOKFUNCDESC( "BuildCommDCBAndTimeoutsW", (PROC)LWM_BuildCommDCBAndTimeoutsW, "kernel32.dll", 19 ),
   HOOKFUNCDESC( "BuildCommDCBW", (PROC)LWM_BuildCommDCBW, "kernel32.dll", 20 ),
   HOOKFUNCDESC( "CallNamedPipeA", (PROC)LWM_CallNamedPipeA, "kernel32.dll", 21 ),
   HOOKFUNCDESC( "CallNamedPipeW", (PROC)LWM_CallNamedPipeW, "kernel32.dll", 22 ),
   HOOKFUNCDESC( "CancelDeviceWakeupRequest", (PROC)LWM_CancelDeviceWakeupRequest, "kernel32.dll", 23 ),
   HOOKFUNCDESC( "CancelIo", (PROC)LWM_CancelIo, "kernel32.dll", 24 ),
   HOOKFUNCDESC( "CancelTimerQueueTimer", (PROC)LWM_CancelTimerQueueTimer, "kernel32.dll", 25 ),
   HOOKFUNCDESC( "CancelWaitableTimer", (PROC)LWM_CancelWaitableTimer, "kernel32.dll", 26 ),
   HOOKFUNCDESC( "ChangeServiceConfig2A", (PROC)LWM_ChangeServiceConfig2A, "advapi32.dll", 53 ),
   HOOKFUNCDESC( "ChangeServiceConfig2W", (PROC)LWM_ChangeServiceConfig2W, "advapi32.dll", 54 ),
   HOOKFUNCDESC( "ChangeServiceConfigA", (PROC)LWM_ChangeServiceConfigA, "advapi32.dll", 55 ),
   HOOKFUNCDESC( "ChangeServiceConfigW", (PROC)LWM_ChangeServiceConfigW, "advapi32.dll", 56 ),
   HOOKFUNCDESC( "ChangeTimerQueueTimer", (PROC)LWM_ChangeTimerQueueTimer, "kernel32.dll", 27 ),
   HOOKFUNCDESC( "ClearCommBreak", (PROC)LWM_ClearCommBreak, "kernel32.dll", 28 ),
   HOOKFUNCDESC( "ClearCommError", (PROC)LWM_ClearCommError, "kernel32.dll", 29 ),
   HOOKFUNCDESC( "ClearEventLogA", (PROC)LWM_ClearEventLogA, "advapi32.dll", 58 ),
   HOOKFUNCDESC( "ClearEventLogW", (PROC)LWM_ClearEventLogW, "advapi32.dll", 59 ),
   HOOKFUNCDESC( "CloseEncryptedFileRaw", (PROC)LWM_CloseEncryptedFileRaw, "advapi32.dll", 60 ),
   HOOKFUNCDESC( "CloseEventLog", (PROC)LWM_CloseEventLog, "advapi32.dll", 61 ),
   HOOKFUNCDESC( "CloseHandle", (PROC)LWM_CloseHandle, "kernel32.dll", 31 ),
   HOOKFUNCDESC( "CloseServiceHandle", (PROC)LWM_CloseServiceHandle, "advapi32.dll", 62 ),
   HOOKFUNCDESC( "CommConfigDialogA", (PROC)LWM_CommConfigDialogA, "kernel32.dll", 34 ),
   HOOKFUNCDESC( "CommConfigDialogW", (PROC)LWM_CommConfigDialogW, "kernel32.dll", 35 ),
   HOOKFUNCDESC( "CompareFileTime", (PROC)LWM_CompareFileTime, "kernel32.dll", 36 ),
   HOOKFUNCDESC( "CompareStringA", (PROC)LWM_CompareStringA, "kernel32.dll", 37 ),
   HOOKFUNCDESC( "CompareStringW", (PROC)LWM_CompareStringW, "kernel32.dll", 38 ),
   HOOKFUNCDESC( "ConnectNamedPipe", (PROC)LWM_ConnectNamedPipe, "kernel32.dll", 39 ),
   HOOKFUNCDESC( "ContinueDebugEvent", (PROC)LWM_ContinueDebugEvent, "kernel32.dll", 41 ),
   HOOKFUNCDESC( "ControlService", (PROC)LWM_ControlService, "advapi32.dll", 65 ),
   HOOKFUNCDESC( "ConvertDefaultLocale", (PROC)LWM_ConvertDefaultLocale, "kernel32.dll", 42 ),
   HOOKFUNCDESC( "ConvertThreadToFiber", (PROC)LWM_ConvertThreadToFiber, "kernel32.dll", 43 ),
   HOOKFUNCDESC( "ConvertToAutoInheritPrivateObjectSecurity", (PROC)LWM_ConvertToAutoInheritPrivateObjectSecurity, "advapi32.dll", 86 ),
   HOOKFUNCDESC( "CopyFileA", (PROC)LWM_CopyFileA, "kernel32.dll", 44 ),
   HOOKFUNCDESC( "CopyFileExA", (PROC)LWM_CopyFileExA, "kernel32.dll", 45 ),
   HOOKFUNCDESC( "CopyFileExW", (PROC)LWM_CopyFileExW, "kernel32.dll", 46 ),
   HOOKFUNCDESC( "CopyFileW", (PROC)LWM_CopyFileW, "kernel32.dll", 47 ),
   HOOKFUNCDESC( "CopySid", (PROC)LWM_CopySid, "advapi32.dll", 87 ),
   HOOKFUNCDESC( "CreateConsoleScreenBuffer", (PROC)LWM_CreateConsoleScreenBuffer, "kernel32.dll", 48 ),
   HOOKFUNCDESC( "CreateDirectoryA", (PROC)LWM_CreateDirectoryA, "kernel32.dll", 49 ),
   HOOKFUNCDESC( "CreateDirectoryExA", (PROC)LWM_CreateDirectoryExA, "kernel32.dll", 50 ),
   HOOKFUNCDESC( "CreateDirectoryExW", (PROC)LWM_CreateDirectoryExW, "kernel32.dll", 51 ),
   HOOKFUNCDESC( "CreateDirectoryW", (PROC)LWM_CreateDirectoryW, "kernel32.dll", 52 ),
   HOOKFUNCDESC( "CreateEventA", (PROC)LWM_CreateEventA, "kernel32.dll", 53 ),
   HOOKFUNCDESC( "CreateEventW", (PROC)LWM_CreateEventW, "kernel32.dll", 54 ),
   HOOKFUNCDESC( "CreateFiber", (PROC)LWM_CreateFiber, "kernel32.dll", 55 ),
   HOOKFUNCDESC( "CreateFileA", (PROC)LWM_CreateFileA, "kernel32.dll", 56 ),
   HOOKFUNCDESC( "CreateFileMappingA", (PROC)LWM_CreateFileMappingA, "kernel32.dll", 57 ),
   HOOKFUNCDESC( "CreateFileMappingW", (PROC)LWM_CreateFileMappingW, "kernel32.dll", 58 ),
   HOOKFUNCDESC( "CreateFileW", (PROC)LWM_CreateFileW, "kernel32.dll", 59 ),
   HOOKFUNCDESC( "CreateHardLinkA", (PROC)LWM_CreateHardLinkA, "kernel32.dll", 60 ),
   HOOKFUNCDESC( "CreateHardLinkW", (PROC)LWM_CreateHardLinkW, "kernel32.dll", 61 ),
   HOOKFUNCDESC( "CreateIoCompletionPort", (PROC)LWM_CreateIoCompletionPort, "kernel32.dll", 62 ),
   HOOKFUNCDESC( "CreateJobObjectA", (PROC)LWM_CreateJobObjectA, "kernel32.dll", 63 ),
   HOOKFUNCDESC( "CreateJobObjectW", (PROC)LWM_CreateJobObjectW, "kernel32.dll", 64 ),
   HOOKFUNCDESC( "CreateMailslotA", (PROC)LWM_CreateMailslotA, "kernel32.dll", 65 ),
   HOOKFUNCDESC( "CreateMailslotW", (PROC)LWM_CreateMailslotW, "kernel32.dll", 66 ),
   HOOKFUNCDESC( "CreateMutexA", (PROC)LWM_CreateMutexA, "kernel32.dll", 67 ),
   HOOKFUNCDESC( "CreateMutexW", (PROC)LWM_CreateMutexW, "kernel32.dll", 68 ),
   HOOKFUNCDESC( "CreateNamedPipeA", (PROC)LWM_CreateNamedPipeA, "kernel32.dll", 69 ),
   HOOKFUNCDESC( "CreateNamedPipeW", (PROC)LWM_CreateNamedPipeW, "kernel32.dll", 70 ),
   HOOKFUNCDESC( "CreatePipe", (PROC)LWM_CreatePipe, "kernel32.dll", 71 ),
   HOOKFUNCDESC( "CreatePrivateObjectSecurity", (PROC)LWM_CreatePrivateObjectSecurity, "advapi32.dll", 88 ),
   HOOKFUNCDESC( "CreatePrivateObjectSecurityEx", (PROC)LWM_CreatePrivateObjectSecurityEx, "advapi32.dll", 89 ),
   HOOKFUNCDESC( "CreateProcessA", (PROC)LWM_CreateProcessA, "kernel32.dll", 72 ),
   HOOKFUNCDESC( "CreateProcessAsUserA", (PROC)LWM_CreateProcessAsUserA, "advapi32.dll", 90 ),
   HOOKFUNCDESC( "CreateProcessAsUserW", (PROC)LWM_CreateProcessAsUserW, "advapi32.dll", 91 ),
   HOOKFUNCDESC( "CreateProcessW", (PROC)LWM_CreateProcessW, "kernel32.dll", 73 ),
   HOOKFUNCDESC( "CreateProcessWithLogonW", (PROC)LWM_CreateProcessWithLogonW, "advapi32.dll", 92 ),
   HOOKFUNCDESC( "CreateRemoteThread", (PROC)LWM_CreateRemoteThread, "kernel32.dll", 74 ),
   HOOKFUNCDESC( "CreateRestrictedToken", (PROC)LWM_CreateRestrictedToken, "advapi32.dll", 93 ),
   HOOKFUNCDESC( "CreateSemaphoreA", (PROC)LWM_CreateSemaphoreA, "kernel32.dll", 75 ),
   HOOKFUNCDESC( "CreateSemaphoreW", (PROC)LWM_CreateSemaphoreW, "kernel32.dll", 76 ),
   HOOKFUNCDESC( "CreateServiceA", (PROC)LWM_CreateServiceA, "advapi32.dll", 94 ),
   HOOKFUNCDESC( "CreateServiceW", (PROC)LWM_CreateServiceW, "advapi32.dll", 95 ),
   HOOKFUNCDESC( "CreateTapePartition", (PROC)LWM_CreateTapePartition, "kernel32.dll", 77 ),
   HOOKFUNCDESC( "CreateThread", (PROC)LWM_CreateThread, "kernel32.dll", 78 ),
   HOOKFUNCDESC( "CreateTimerQueue", (PROC)LWM_CreateTimerQueue, "kernel32.dll", 79 ),
   HOOKFUNCDESC( "CreateTimerQueueTimer", (PROC)LWM_CreateTimerQueueTimer, "kernel32.dll", 80 ),
   HOOKFUNCDESC( "CreateWaitableTimerA", (PROC)LWM_CreateWaitableTimerA, "kernel32.dll", 83 ),
   HOOKFUNCDESC( "CreateWaitableTimerW", (PROC)LWM_CreateWaitableTimerW, "kernel32.dll", 84 ),
   HOOKFUNCDESC( "CryptAcquireContextA", (PROC)LWM_CryptAcquireContextA, "advapi32.dll", 97 ),
   HOOKFUNCDESC( "CryptAcquireContextW", (PROC)LWM_CryptAcquireContextW, "advapi32.dll", 98 ),
   HOOKFUNCDESC( "CryptContextAddRef", (PROC)LWM_CryptContextAddRef, "advapi32.dll", 99 ),
   HOOKFUNCDESC( "CryptCreateHash", (PROC)LWM_CryptCreateHash, "advapi32.dll", 100 ),
   HOOKFUNCDESC( "CryptDecrypt", (PROC)LWM_CryptDecrypt, "advapi32.dll", 101 ),
   HOOKFUNCDESC( "CryptDeriveKey", (PROC)LWM_CryptDeriveKey, "advapi32.dll", 102 ),
   HOOKFUNCDESC( "CryptDestroyHash", (PROC)LWM_CryptDestroyHash, "advapi32.dll", 103 ),
   HOOKFUNCDESC( "CryptDestroyKey", (PROC)LWM_CryptDestroyKey, "advapi32.dll", 104 ),
   HOOKFUNCDESC( "CryptDuplicateHash", (PROC)LWM_CryptDuplicateHash, "advapi32.dll", 105 ),
   HOOKFUNCDESC( "CryptDuplicateKey", (PROC)LWM_CryptDuplicateKey, "advapi32.dll", 106 ),
   HOOKFUNCDESC( "CryptEncrypt", (PROC)LWM_CryptEncrypt, "advapi32.dll", 107 ),
   HOOKFUNCDESC( "CryptEnumProviderTypesA", (PROC)LWM_CryptEnumProviderTypesA, "advapi32.dll", 108 ),
   HOOKFUNCDESC( "CryptEnumProviderTypesW", (PROC)LWM_CryptEnumProviderTypesW, "advapi32.dll", 109 ),
   HOOKFUNCDESC( "CryptEnumProvidersA", (PROC)LWM_CryptEnumProvidersA, "advapi32.dll", 110 ),
   HOOKFUNCDESC( "CryptEnumProvidersW", (PROC)LWM_CryptEnumProvidersW, "advapi32.dll", 111 ),
   HOOKFUNCDESC( "CryptExportKey", (PROC)LWM_CryptExportKey, "advapi32.dll", 112 ),
   HOOKFUNCDESC( "CryptGenKey", (PROC)LWM_CryptGenKey, "advapi32.dll", 113 ),
   HOOKFUNCDESC( "CryptGenRandom", (PROC)LWM_CryptGenRandom, "advapi32.dll", 114 ),
   HOOKFUNCDESC( "CryptGetDefaultProviderA", (PROC)LWM_CryptGetDefaultProviderA, "advapi32.dll", 115 ),
   HOOKFUNCDESC( "CryptGetDefaultProviderW", (PROC)LWM_CryptGetDefaultProviderW, "advapi32.dll", 116 ),
   HOOKFUNCDESC( "CryptGetHashParam", (PROC)LWM_CryptGetHashParam, "advapi32.dll", 117 ),
   HOOKFUNCDESC( "CryptGetKeyParam", (PROC)LWM_CryptGetKeyParam, "advapi32.dll", 118 ),
   HOOKFUNCDESC( "CryptGetProvParam", (PROC)LWM_CryptGetProvParam, "advapi32.dll", 119 ),
   HOOKFUNCDESC( "CryptGetUserKey", (PROC)LWM_CryptGetUserKey, "advapi32.dll", 120 ),
   HOOKFUNCDESC( "CryptHashData", (PROC)LWM_CryptHashData, "advapi32.dll", 121 ),
   HOOKFUNCDESC( "CryptHashSessionKey", (PROC)LWM_CryptHashSessionKey, "advapi32.dll", 122 ),
   HOOKFUNCDESC( "CryptImportKey", (PROC)LWM_CryptImportKey, "advapi32.dll", 123 ),
   HOOKFUNCDESC( "CryptReleaseContext", (PROC)LWM_CryptReleaseContext, "advapi32.dll", 124 ),
   HOOKFUNCDESC( "CryptSetHashParam", (PROC)LWM_CryptSetHashParam, "advapi32.dll", 125 ),
   HOOKFUNCDESC( "CryptSetKeyParam", (PROC)LWM_CryptSetKeyParam, "advapi32.dll", 126 ),
   HOOKFUNCDESC( "CryptSetProvParam", (PROC)LWM_CryptSetProvParam, "advapi32.dll", 127 ),
   HOOKFUNCDESC( "CryptSetProviderA", (PROC)LWM_CryptSetProviderA, "advapi32.dll", 128 ),
   HOOKFUNCDESC( "CryptSetProviderExA", (PROC)LWM_CryptSetProviderExA, "advapi32.dll", 129 ),
   HOOKFUNCDESC( "CryptSetProviderExW", (PROC)LWM_CryptSetProviderExW, "advapi32.dll", 130 ),
   HOOKFUNCDESC( "CryptSetProviderW", (PROC)LWM_CryptSetProviderW, "advapi32.dll", 131 ),
   HOOKFUNCDESC( "CryptSignHashA", (PROC)LWM_CryptSignHashA, "advapi32.dll", 132 ),
   HOOKFUNCDESC( "CryptSignHashW", (PROC)LWM_CryptSignHashW, "advapi32.dll", 133 ),
   HOOKFUNCDESC( "CryptVerifySignatureA", (PROC)LWM_CryptVerifySignatureA, "advapi32.dll", 134 ),
   HOOKFUNCDESC( "CryptVerifySignatureW", (PROC)LWM_CryptVerifySignatureW, "advapi32.dll", 135 ),
   HOOKFUNCDESC( "DebugActiveProcess", (PROC)LWM_DebugActiveProcess, "kernel32.dll", 85 ),
   HOOKFUNCDESC( "DebugBreak", (PROC)LWM_DebugBreak, "kernel32.dll", 86 ),
   HOOKFUNCDESC( "DecryptFileA", (PROC)LWM_DecryptFileA, "advapi32.dll", 136 ),
   HOOKFUNCDESC( "DecryptFileW", (PROC)LWM_DecryptFileW, "advapi32.dll", 137 ),
   HOOKFUNCDESC( "DefineDosDeviceA", (PROC)LWM_DefineDosDeviceA, "kernel32.dll", 87 ),
   HOOKFUNCDESC( "DefineDosDeviceW", (PROC)LWM_DefineDosDeviceW, "kernel32.dll", 88 ),
   HOOKFUNCDESC( "DeleteAce", (PROC)LWM_DeleteAce, "advapi32.dll", 138 ),
   HOOKFUNCDESC( "DeleteAtom", (PROC)LWM_DeleteAtom, "kernel32.dll", 90 ),
   HOOKFUNCDESC( "DeleteFiber", (PROC)LWM_DeleteFiber, "kernel32.dll", 92 ),
   HOOKFUNCDESC( "DeleteFileA", (PROC)LWM_DeleteFileA, "kernel32.dll", 93 ),
   HOOKFUNCDESC( "DeleteFileW", (PROC)LWM_DeleteFileW, "kernel32.dll", 94 ),
   HOOKFUNCDESC( "DeleteService", (PROC)LWM_DeleteService, "advapi32.dll", 139 ),
   HOOKFUNCDESC( "DeleteTimerQueue", (PROC)LWM_DeleteTimerQueue, "kernel32.dll", 95 ),
   HOOKFUNCDESC( "DeleteTimerQueueEx", (PROC)LWM_DeleteTimerQueueEx, "kernel32.dll", 96 ),
   HOOKFUNCDESC( "DeleteTimerQueueTimer", (PROC)LWM_DeleteTimerQueueTimer, "kernel32.dll", 97 ),
   HOOKFUNCDESC( "DeleteVolumeMountPointA", (PROC)LWM_DeleteVolumeMountPointA, "kernel32.dll", 98 ),
   HOOKFUNCDESC( "DeleteVolumeMountPointW", (PROC)LWM_DeleteVolumeMountPointW, "kernel32.dll", 99 ),
   HOOKFUNCDESC( "DeregisterEventSource", (PROC)LWM_DeregisterEventSource, "advapi32.dll", 140 ),
   HOOKFUNCDESC( "DestroyPrivateObjectSecurity", (PROC)LWM_DestroyPrivateObjectSecurity, "advapi32.dll", 141 ),
   HOOKFUNCDESC( "DeviceIoControl", (PROC)LWM_DeviceIoControl, "kernel32.dll", 100 ),
   HOOKFUNCDESC( "DisableThreadLibraryCalls", (PROC)LWM_DisableThreadLibraryCalls, "kernel32.dll", 101 ),
   HOOKFUNCDESC( "DisconnectNamedPipe", (PROC)LWM_DisconnectNamedPipe, "kernel32.dll", 102 ),
   HOOKFUNCDESC( "DnsHostnameToComputerNameA", (PROC)LWM_DnsHostnameToComputerNameA, "kernel32.dll", 103 ),
   HOOKFUNCDESC( "DnsHostnameToComputerNameW", (PROC)LWM_DnsHostnameToComputerNameW, "kernel32.dll", 104 ),
   HOOKFUNCDESC( "DosDateTimeToFileTime", (PROC)LWM_DosDateTimeToFileTime, "kernel32.dll", 105 ),
   HOOKFUNCDESC( "DuplicateHandle", (PROC)LWM_DuplicateHandle, "kernel32.dll", 109 ),
   HOOKFUNCDESC( "DuplicateToken", (PROC)LWM_DuplicateToken, "advapi32.dll", 143 ),
   HOOKFUNCDESC( "DuplicateTokenEx", (PROC)LWM_DuplicateTokenEx, "advapi32.dll", 144 ),
   HOOKFUNCDESC( "EncryptFileA", (PROC)LWM_EncryptFileA, "advapi32.dll", 165 ),
   HOOKFUNCDESC( "EncryptFileW", (PROC)LWM_EncryptFileW, "advapi32.dll", 166 ),
   HOOKFUNCDESC( "EncryptionDisable", (PROC)LWM_EncryptionDisable, "advapi32.dll", 167 ),
   HOOKFUNCDESC( "EndUpdateResourceA", (PROC)LWM_EndUpdateResourceA, "kernel32.dll", 110 ),
   HOOKFUNCDESC( "EndUpdateResourceW", (PROC)LWM_EndUpdateResourceW, "kernel32.dll", 111 ),
   HOOKFUNCDESC( "EnumCalendarInfoA", (PROC)LWM_EnumCalendarInfoA, "kernel32.dll", 113 ),
   HOOKFUNCDESC( "EnumCalendarInfoW", (PROC)LWM_EnumCalendarInfoW, "kernel32.dll", 116 ),
   HOOKFUNCDESC( "EnumDateFormatsA", (PROC)LWM_EnumDateFormatsA, "kernel32.dll", 117 ),
   HOOKFUNCDESC( "EnumDateFormatsW", (PROC)LWM_EnumDateFormatsW, "kernel32.dll", 120 ),
   HOOKFUNCDESC( "EnumDependentServicesA", (PROC)LWM_EnumDependentServicesA, "advapi32.dll", 168 ),
   HOOKFUNCDESC( "EnumDependentServicesW", (PROC)LWM_EnumDependentServicesW, "advapi32.dll", 169 ),
   HOOKFUNCDESC( "EnumResourceLanguagesA", (PROC)LWM_EnumResourceLanguagesA, "kernel32.dll", 123 ),
   HOOKFUNCDESC( "EnumResourceLanguagesW", (PROC)LWM_EnumResourceLanguagesW, "kernel32.dll", 124 ),
   HOOKFUNCDESC( "EnumResourceNamesA", (PROC)LWM_EnumResourceNamesA, "kernel32.dll", 125 ),
   HOOKFUNCDESC( "EnumResourceNamesW", (PROC)LWM_EnumResourceNamesW, "kernel32.dll", 126 ),
   HOOKFUNCDESC( "EnumResourceTypesA", (PROC)LWM_EnumResourceTypesA, "kernel32.dll", 127 ),
   HOOKFUNCDESC( "EnumResourceTypesW", (PROC)LWM_EnumResourceTypesW, "kernel32.dll", 128 ),
   HOOKFUNCDESC( "EnumServicesStatusA", (PROC)LWM_EnumServicesStatusA, "advapi32.dll", 171 ),
   HOOKFUNCDESC( "EnumServicesStatusExA", (PROC)LWM_EnumServicesStatusExA, "advapi32.dll", 172 ),
   HOOKFUNCDESC( "EnumServicesStatusExW", (PROC)LWM_EnumServicesStatusExW, "advapi32.dll", 173 ),
   HOOKFUNCDESC( "EnumServicesStatusW", (PROC)LWM_EnumServicesStatusW, "advapi32.dll", 174 ),
   HOOKFUNCDESC( "EnumSystemCodePagesA", (PROC)LWM_EnumSystemCodePagesA, "kernel32.dll", 129 ),
   HOOKFUNCDESC( "EnumSystemCodePagesW", (PROC)LWM_EnumSystemCodePagesW, "kernel32.dll", 130 ),
   HOOKFUNCDESC( "EnumSystemLocalesA", (PROC)LWM_EnumSystemLocalesA, "kernel32.dll", 133 ),
   HOOKFUNCDESC( "EnumSystemLocalesW", (PROC)LWM_EnumSystemLocalesW, "kernel32.dll", 134 ),
   HOOKFUNCDESC( "EnumTimeFormatsA", (PROC)LWM_EnumTimeFormatsA, "kernel32.dll", 135 ),
   HOOKFUNCDESC( "EnumTimeFormatsW", (PROC)LWM_EnumTimeFormatsW, "kernel32.dll", 136 ),
   HOOKFUNCDESC( "EqualPrefixSid", (PROC)LWM_EqualPrefixSid, "advapi32.dll", 175 ),
   HOOKFUNCDESC( "EqualSid", (PROC)LWM_EqualSid, "advapi32.dll", 176 ),
   HOOKFUNCDESC( "EraseTape", (PROC)LWM_EraseTape, "kernel32.dll", 139 ),
   HOOKFUNCDESC( "EscapeCommFunction", (PROC)LWM_EscapeCommFunction, "kernel32.dll", 140 ),
   HOOKFUNCDESC( "ExitProcess", (PROC)LWM_ExitProcess, "kernel32.dll", 141 ),
   HOOKFUNCDESC( "ExitThread", (PROC)LWM_ExitThread, "kernel32.dll", 142 ),
   HOOKFUNCDESC( "ExpandEnvironmentStringsA", (PROC)LWM_ExpandEnvironmentStringsA, "kernel32.dll", 144 ),
   HOOKFUNCDESC( "ExpandEnvironmentStringsW", (PROC)LWM_ExpandEnvironmentStringsW, "kernel32.dll", 145 ),
   HOOKFUNCDESC( "FatalAppExitA", (PROC)LWM_FatalAppExitA, "kernel32.dll", 149 ),
   HOOKFUNCDESC( "FatalAppExitW", (PROC)LWM_FatalAppExitW, "kernel32.dll", 150 ),
   HOOKFUNCDESC( "FatalExit", (PROC)LWM_FatalExit, "kernel32.dll", 151 ),
   HOOKFUNCDESC( "FileEncryptionStatusA", (PROC)LWM_FileEncryptionStatusA, "advapi32.dll", 177 ),
   HOOKFUNCDESC( "FileEncryptionStatusW", (PROC)LWM_FileEncryptionStatusW, "advapi32.dll", 178 ),
   HOOKFUNCDESC( "FileTimeToDosDateTime", (PROC)LWM_FileTimeToDosDateTime, "kernel32.dll", 152 ),
   HOOKFUNCDESC( "FileTimeToLocalFileTime", (PROC)LWM_FileTimeToLocalFileTime, "kernel32.dll", 153 ),
   HOOKFUNCDESC( "FileTimeToSystemTime", (PROC)LWM_FileTimeToSystemTime, "kernel32.dll", 154 ),
   HOOKFUNCDESC( "FillConsoleOutputAttribute", (PROC)LWM_FillConsoleOutputAttribute, "kernel32.dll", 155 ),
   HOOKFUNCDESC( "FillConsoleOutputCharacterA", (PROC)LWM_FillConsoleOutputCharacterA, "kernel32.dll", 156 ),
   HOOKFUNCDESC( "FillConsoleOutputCharacterW", (PROC)LWM_FillConsoleOutputCharacterW, "kernel32.dll", 157 ),
   HOOKFUNCDESC( "FindAtomA", (PROC)LWM_FindAtomA, "kernel32.dll", 158 ),
   HOOKFUNCDESC( "FindAtomW", (PROC)LWM_FindAtomW, "kernel32.dll", 159 ),
   HOOKFUNCDESC( "FindClose", (PROC)LWM_FindClose, "kernel32.dll", 160 ),
   HOOKFUNCDESC( "FindCloseChangeNotification", (PROC)LWM_FindCloseChangeNotification, "kernel32.dll", 161 ),
   HOOKFUNCDESC( "FindFirstChangeNotificationA", (PROC)LWM_FindFirstChangeNotificationA, "kernel32.dll", 162 ),
   HOOKFUNCDESC( "FindFirstChangeNotificationW", (PROC)LWM_FindFirstChangeNotificationW, "kernel32.dll", 163 ),
   HOOKFUNCDESC( "FindFirstFileA", (PROC)LWM_FindFirstFileA, "kernel32.dll", 164 ),
   HOOKFUNCDESC( "FindFirstFileExA", (PROC)LWM_FindFirstFileExA, "kernel32.dll", 165 ),
   HOOKFUNCDESC( "FindFirstFileExW", (PROC)LWM_FindFirstFileExW, "kernel32.dll", 166 ),
   HOOKFUNCDESC( "FindFirstFileW", (PROC)LWM_FindFirstFileW, "kernel32.dll", 167 ),
   HOOKFUNCDESC( "FindFirstFreeAce", (PROC)LWM_FindFirstFreeAce, "advapi32.dll", 179 ),
   HOOKFUNCDESC( "FindFirstVolumeA", (PROC)LWM_FindFirstVolumeA, "kernel32.dll", 168 ),
   HOOKFUNCDESC( "FindFirstVolumeMountPointA", (PROC)LWM_FindFirstVolumeMountPointA, "kernel32.dll", 169 ),
   HOOKFUNCDESC( "FindFirstVolumeMountPointW", (PROC)LWM_FindFirstVolumeMountPointW, "kernel32.dll", 170 ),
   HOOKFUNCDESC( "FindFirstVolumeW", (PROC)LWM_FindFirstVolumeW, "kernel32.dll", 171 ),
   HOOKFUNCDESC( "FindNextChangeNotification", (PROC)LWM_FindNextChangeNotification, "kernel32.dll", 172 ),
   HOOKFUNCDESC( "FindNextFileA", (PROC)LWM_FindNextFileA, "kernel32.dll", 173 ),
   HOOKFUNCDESC( "FindNextFileW", (PROC)LWM_FindNextFileW, "kernel32.dll", 174 ),
   HOOKFUNCDESC( "FindNextVolumeA", (PROC)LWM_FindNextVolumeA, "kernel32.dll", 175 ),
   HOOKFUNCDESC( "FindNextVolumeMountPointA", (PROC)LWM_FindNextVolumeMountPointA, "kernel32.dll", 176 ),
   HOOKFUNCDESC( "FindNextVolumeMountPointW", (PROC)LWM_FindNextVolumeMountPointW, "kernel32.dll", 177 ),
   HOOKFUNCDESC( "FindNextVolumeW", (PROC)LWM_FindNextVolumeW, "kernel32.dll", 178 ),
   HOOKFUNCDESC( "FindResourceA", (PROC)LWM_FindResourceA, "kernel32.dll", 179 ),
   HOOKFUNCDESC( "FindResourceExA", (PROC)LWM_FindResourceExA, "kernel32.dll", 180 ),
   HOOKFUNCDESC( "FindResourceExW", (PROC)LWM_FindResourceExW, "kernel32.dll", 181 ),
   HOOKFUNCDESC( "FindResourceW", (PROC)LWM_FindResourceW, "kernel32.dll", 182 ),
   HOOKFUNCDESC( "FindVolumeClose", (PROC)LWM_FindVolumeClose, "kernel32.dll", 183 ),
   HOOKFUNCDESC( "FindVolumeMountPointClose", (PROC)LWM_FindVolumeMountPointClose, "kernel32.dll", 184 ),
   HOOKFUNCDESC( "FlushConsoleInputBuffer", (PROC)LWM_FlushConsoleInputBuffer, "kernel32.dll", 185 ),
   HOOKFUNCDESC( "FlushFileBuffers", (PROC)LWM_FlushFileBuffers, "kernel32.dll", 186 ),
   HOOKFUNCDESC( "FlushInstructionCache", (PROC)LWM_FlushInstructionCache, "kernel32.dll", 187 ),
   HOOKFUNCDESC( "FlushViewOfFile", (PROC)LWM_FlushViewOfFile, "kernel32.dll", 188 ),
   HOOKFUNCDESC( "FoldStringA", (PROC)LWM_FoldStringA, "kernel32.dll", 189 ),
   HOOKFUNCDESC( "FoldStringW", (PROC)LWM_FoldStringW, "kernel32.dll", 190 ),
   HOOKFUNCDESC( "FormatMessageA", (PROC)LWM_FormatMessageA, "kernel32.dll", 191 ),
   HOOKFUNCDESC( "FormatMessageW", (PROC)LWM_FormatMessageW, "kernel32.dll", 192 ),
   HOOKFUNCDESC( "FreeConsole", (PROC)LWM_FreeConsole, "kernel32.dll", 193 ),
   HOOKFUNCDESC( "FreeEncryptionCertificateHashList", (PROC)LWM_FreeEncryptionCertificateHashList, "advapi32.dll", 180 ),
   HOOKFUNCDESC( "FreeEnvironmentStringsA", (PROC)LWM_FreeEnvironmentStringsA, "kernel32.dll", 194 ),
   HOOKFUNCDESC( "FreeEnvironmentStringsW", (PROC)LWM_FreeEnvironmentStringsW, "kernel32.dll", 195 ),
   HOOKFUNCDESC( "FreeLibrary", (PROC)LWM_FreeLibrary, "kernel32.dll", 196 ),
   HOOKFUNCDESC( "FreeLibraryAndExitThread", (PROC)LWM_FreeLibraryAndExitThread, "kernel32.dll", 197 ),
   HOOKFUNCDESC( "FreeResource", (PROC)LWM_FreeResource, "kernel32.dll", 198 ),
   HOOKFUNCDESC( "FreeSid", (PROC)LWM_FreeSid, "advapi32.dll", 181 ),
   HOOKFUNCDESC( "FreeUserPhysicalPages", (PROC)LWM_FreeUserPhysicalPages, "kernel32.dll", 199 ),
   HOOKFUNCDESC( "GenerateConsoleCtrlEvent", (PROC)LWM_GenerateConsoleCtrlEvent, "kernel32.dll", 201 ),
   HOOKFUNCDESC( "GetACP", (PROC)LWM_GetACP, "kernel32.dll", 202 ),
   HOOKFUNCDESC( "GetAce", (PROC)LWM_GetAce, "advapi32.dll", 184 ),
   HOOKFUNCDESC( "GetAclInformation", (PROC)LWM_GetAclInformation, "advapi32.dll", 185 ),
   HOOKFUNCDESC( "GetAtomNameA", (PROC)LWM_GetAtomNameA, "kernel32.dll", 203 ),
   HOOKFUNCDESC( "GetAtomNameW", (PROC)LWM_GetAtomNameW, "kernel32.dll", 204 ),
   HOOKFUNCDESC( "GetBinaryTypeA", (PROC)LWM_GetBinaryTypeA, "kernel32.dll", 206 ),
   HOOKFUNCDESC( "GetBinaryTypeW", (PROC)LWM_GetBinaryTypeW, "kernel32.dll", 207 ),
   HOOKFUNCDESC( "GetCPInfo", (PROC)LWM_GetCPInfo, "kernel32.dll", 208 ),
   HOOKFUNCDESC( "GetCPInfoExA", (PROC)LWM_GetCPInfoExA, "kernel32.dll", 209 ),
   HOOKFUNCDESC( "GetCPInfoExW", (PROC)LWM_GetCPInfoExW, "kernel32.dll", 210 ),
   HOOKFUNCDESC( "GetCommConfig", (PROC)LWM_GetCommConfig, "kernel32.dll", 213 ),
   HOOKFUNCDESC( "GetCommMask", (PROC)LWM_GetCommMask, "kernel32.dll", 214 ),
   HOOKFUNCDESC( "GetCommModemStatus", (PROC)LWM_GetCommModemStatus, "kernel32.dll", 215 ),
   HOOKFUNCDESC( "GetCommProperties", (PROC)LWM_GetCommProperties, "kernel32.dll", 216 ),
   HOOKFUNCDESC( "GetCommState", (PROC)LWM_GetCommState, "kernel32.dll", 217 ),
   HOOKFUNCDESC( "GetCommTimeouts", (PROC)LWM_GetCommTimeouts, "kernel32.dll", 218 ),
   HOOKFUNCDESC( "GetCommandLineA", (PROC)LWM_GetCommandLineA, "kernel32.dll", 219 ),
   HOOKFUNCDESC( "GetCommandLineW", (PROC)LWM_GetCommandLineW, "kernel32.dll", 220 ),
   HOOKFUNCDESC( "GetCompressedFileSizeA", (PROC)LWM_GetCompressedFileSizeA, "kernel32.dll", 221 ),
   HOOKFUNCDESC( "GetCompressedFileSizeW", (PROC)LWM_GetCompressedFileSizeW, "kernel32.dll", 222 ),
   HOOKFUNCDESC( "GetComputerNameA", (PROC)LWM_GetComputerNameA, "kernel32.dll", 223 ),
   HOOKFUNCDESC( "GetComputerNameExA", (PROC)LWM_GetComputerNameExA, "kernel32.dll", 224 ),
   HOOKFUNCDESC( "GetComputerNameExW", (PROC)LWM_GetComputerNameExW, "kernel32.dll", 225 ),
   HOOKFUNCDESC( "GetComputerNameW", (PROC)LWM_GetComputerNameW, "kernel32.dll", 226 ),
   HOOKFUNCDESC( "GetConsoleCP", (PROC)LWM_GetConsoleCP, "kernel32.dll", 237 ),
   HOOKFUNCDESC( "GetConsoleCursorInfo", (PROC)LWM_GetConsoleCursorInfo, "kernel32.dll", 243 ),
   HOOKFUNCDESC( "GetConsoleMode", (PROC)LWM_GetConsoleMode, "kernel32.dll", 254 ),
   HOOKFUNCDESC( "GetConsoleOutputCP", (PROC)LWM_GetConsoleOutputCP, "kernel32.dll", 256 ),
   HOOKFUNCDESC( "GetConsoleScreenBufferInfo", (PROC)LWM_GetConsoleScreenBufferInfo, "kernel32.dll", 257 ),
   HOOKFUNCDESC( "GetConsoleTitleA", (PROC)LWM_GetConsoleTitleA, "kernel32.dll", 258 ),
   HOOKFUNCDESC( "GetConsoleTitleW", (PROC)LWM_GetConsoleTitleW, "kernel32.dll", 259 ),
   HOOKFUNCDESC( "GetCurrencyFormatA", (PROC)LWM_GetCurrencyFormatA, "kernel32.dll", 261 ),
   HOOKFUNCDESC( "GetCurrencyFormatW", (PROC)LWM_GetCurrencyFormatW, "kernel32.dll", 262 ),
   HOOKFUNCDESC( "GetCurrentDirectoryA", (PROC)LWM_GetCurrentDirectoryA, "kernel32.dll", 264 ),
   HOOKFUNCDESC( "GetCurrentDirectoryW", (PROC)LWM_GetCurrentDirectoryW, "kernel32.dll", 265 ),
   HOOKFUNCDESC( "GetCurrentHwProfileA", (PROC)LWM_GetCurrentHwProfileA, "advapi32.dll", 188 ),
   HOOKFUNCDESC( "GetCurrentHwProfileW", (PROC)LWM_GetCurrentHwProfileW, "advapi32.dll", 189 ),
   HOOKFUNCDESC( "GetCurrentProcess", (PROC)LWM_GetCurrentProcess, "kernel32.dll", 266 ),
   HOOKFUNCDESC( "GetCurrentProcessId", (PROC)LWM_GetCurrentProcessId, "kernel32.dll", 267 ),
   HOOKFUNCDESC( "GetCurrentThread", (PROC)LWM_GetCurrentThread, "kernel32.dll", 268 ),
   HOOKFUNCDESC( "GetCurrentThreadId", (PROC)LWM_GetCurrentThreadId, "kernel32.dll", 269 ),
   HOOKFUNCDESC( "GetDateFormatA", (PROC)LWM_GetDateFormatA, "kernel32.dll", 270 ),
   HOOKFUNCDESC( "GetDateFormatW", (PROC)LWM_GetDateFormatW, "kernel32.dll", 271 ),
   HOOKFUNCDESC( "GetDefaultCommConfigA", (PROC)LWM_GetDefaultCommConfigA, "kernel32.dll", 272 ),
   HOOKFUNCDESC( "GetDefaultCommConfigW", (PROC)LWM_GetDefaultCommConfigW, "kernel32.dll", 273 ),
   HOOKFUNCDESC( "GetDevicePowerState", (PROC)LWM_GetDevicePowerState, "kernel32.dll", 275 ),
   HOOKFUNCDESC( "GetDiskFreeSpaceA", (PROC)LWM_GetDiskFreeSpaceA, "kernel32.dll", 276 ),
   HOOKFUNCDESC( "GetDiskFreeSpaceExA", (PROC)LWM_GetDiskFreeSpaceExA, "kernel32.dll", 277 ),
   HOOKFUNCDESC( "GetDiskFreeSpaceExW", (PROC)LWM_GetDiskFreeSpaceExW, "kernel32.dll", 278 ),
   HOOKFUNCDESC( "GetDiskFreeSpaceW", (PROC)LWM_GetDiskFreeSpaceW, "kernel32.dll", 279 ),
   HOOKFUNCDESC( "GetDriveTypeA", (PROC)LWM_GetDriveTypeA, "kernel32.dll", 280 ),
   HOOKFUNCDESC( "GetDriveTypeW", (PROC)LWM_GetDriveTypeW, "kernel32.dll", 281 ),
   HOOKFUNCDESC( "GetEnvironmentStrings", (PROC)LWM_GetEnvironmentStrings, "kernel32.dll", 282 ),
   HOOKFUNCDESC( "GetEnvironmentStringsW", (PROC)LWM_GetEnvironmentStringsW, "kernel32.dll", 284 ),
   HOOKFUNCDESC( "GetEnvironmentVariableA", (PROC)LWM_GetEnvironmentVariableA, "kernel32.dll", 285 ),
   HOOKFUNCDESC( "GetEnvironmentVariableW", (PROC)LWM_GetEnvironmentVariableW, "kernel32.dll", 286 ),
   HOOKFUNCDESC( "GetEventLogInformation", (PROC)LWM_GetEventLogInformation, "advapi32.dll", 192 ),
   HOOKFUNCDESC( "GetExitCodeProcess", (PROC)LWM_GetExitCodeProcess, "kernel32.dll", 287 ),
   HOOKFUNCDESC( "GetExitCodeThread", (PROC)LWM_GetExitCodeThread, "kernel32.dll", 288 ),
   HOOKFUNCDESC( "GetFileAttributesA", (PROC)LWM_GetFileAttributesA, "kernel32.dll", 289 ),
   HOOKFUNCDESC( "GetFileAttributesExA", (PROC)LWM_GetFileAttributesExA, "kernel32.dll", 290 ),
   HOOKFUNCDESC( "GetFileAttributesExW", (PROC)LWM_GetFileAttributesExW, "kernel32.dll", 291 ),
   HOOKFUNCDESC( "GetFileAttributesW", (PROC)LWM_GetFileAttributesW, "kernel32.dll", 292 ),
   HOOKFUNCDESC( "GetFileInformationByHandle", (PROC)LWM_GetFileInformationByHandle, "kernel32.dll", 293 ),
   HOOKFUNCDESC( "GetFileSecurityA", (PROC)LWM_GetFileSecurityA, "advapi32.dll", 195 ),
   HOOKFUNCDESC( "GetFileSecurityW", (PROC)LWM_GetFileSecurityW, "advapi32.dll", 196 ),
   HOOKFUNCDESC( "GetFileSize", (PROC)LWM_GetFileSize, "kernel32.dll", 294 ),
   HOOKFUNCDESC( "GetFileSizeEx", (PROC)LWM_GetFileSizeEx, "kernel32.dll", 295 ),
   HOOKFUNCDESC( "GetFileTime", (PROC)LWM_GetFileTime, "kernel32.dll", 296 ),
   HOOKFUNCDESC( "GetFileType", (PROC)LWM_GetFileType, "kernel32.dll", 297 ),
   HOOKFUNCDESC( "GetFullPathNameA", (PROC)LWM_GetFullPathNameA, "kernel32.dll", 298 ),
   HOOKFUNCDESC( "GetFullPathNameW", (PROC)LWM_GetFullPathNameW, "kernel32.dll", 299 ),
   HOOKFUNCDESC( "GetHandleInformation", (PROC)LWM_GetHandleInformation, "kernel32.dll", 300 ),
   HOOKFUNCDESC( "GetKernelObjectSecurity", (PROC)LWM_GetKernelObjectSecurity, "advapi32.dll", 197 ),
   HOOKFUNCDESC( "GetLargestConsoleWindowSize", (PROC)LWM_GetLargestConsoleWindowSize, "kernel32.dll", 301 ),
   HOOKFUNCDESC( "GetLastError", (PROC)LWM_GetLastError, "kernel32.dll", 302 ),
   HOOKFUNCDESC( "GetLengthSid", (PROC)LWM_GetLengthSid, "advapi32.dll", 198 ),
   HOOKFUNCDESC( "GetLocalTime", (PROC)LWM_GetLocalTime, "kernel32.dll", 304 ),
   HOOKFUNCDESC( "GetLocaleInfoA", (PROC)LWM_GetLocaleInfoA, "kernel32.dll", 305 ),
   HOOKFUNCDESC( "GetLocaleInfoW", (PROC)LWM_GetLocaleInfoW, "kernel32.dll", 306 ),
   HOOKFUNCDESC( "GetLogicalDriveStringsA", (PROC)LWM_GetLogicalDriveStringsA, "kernel32.dll", 307 ),
   HOOKFUNCDESC( "GetLogicalDriveStringsW", (PROC)LWM_GetLogicalDriveStringsW, "kernel32.dll", 308 ),
   HOOKFUNCDESC( "GetLogicalDrives", (PROC)LWM_GetLogicalDrives, "kernel32.dll", 309 ),
   HOOKFUNCDESC( "GetLongPathNameA", (PROC)LWM_GetLongPathNameA, "kernel32.dll", 310 ),
   HOOKFUNCDESC( "GetLongPathNameW", (PROC)LWM_GetLongPathNameW, "kernel32.dll", 311 ),
   HOOKFUNCDESC( "GetMailslotInfo", (PROC)LWM_GetMailslotInfo, "kernel32.dll", 312 ),
   HOOKFUNCDESC( "GetMangledSiteSid", (PROC)LWM_GetMangledSiteSid, "advapi32.dll", 201 ),
   HOOKFUNCDESC( "GetModuleFileNameA", (PROC)LWM_GetModuleFileNameA, "kernel32.dll", 313 ),
   HOOKFUNCDESC( "GetModuleFileNameW", (PROC)LWM_GetModuleFileNameW, "kernel32.dll", 314 ),
   HOOKFUNCDESC( "GetModuleHandleA", (PROC)LWM_GetModuleHandleA, "kernel32.dll", 315 ),
   HOOKFUNCDESC( "GetModuleHandleW", (PROC)LWM_GetModuleHandleW, "kernel32.dll", 316 ),
   HOOKFUNCDESC( "GetNamedPipeHandleStateA", (PROC)LWM_GetNamedPipeHandleStateA, "kernel32.dll", 317 ),
   HOOKFUNCDESC( "GetNamedPipeHandleStateW", (PROC)LWM_GetNamedPipeHandleStateW, "kernel32.dll", 318 ),
   HOOKFUNCDESC( "GetNamedPipeInfo", (PROC)LWM_GetNamedPipeInfo, "kernel32.dll", 319 ),
   HOOKFUNCDESC( "GetNumberFormatA", (PROC)LWM_GetNumberFormatA, "kernel32.dll", 322 ),
   HOOKFUNCDESC( "GetNumberFormatW", (PROC)LWM_GetNumberFormatW, "kernel32.dll", 323 ),
   HOOKFUNCDESC( "GetNumberOfConsoleInputEvents", (PROC)LWM_GetNumberOfConsoleInputEvents, "kernel32.dll", 325 ),
   HOOKFUNCDESC( "GetNumberOfConsoleMouseButtons", (PROC)LWM_GetNumberOfConsoleMouseButtons, "kernel32.dll", 326 ),
   HOOKFUNCDESC( "GetNumberOfEventLogRecords", (PROC)LWM_GetNumberOfEventLogRecords, "advapi32.dll", 210 ),
   HOOKFUNCDESC( "GetOEMCP", (PROC)LWM_GetOEMCP, "kernel32.dll", 327 ),
   HOOKFUNCDESC( "GetOldestEventLogRecord", (PROC)LWM_GetOldestEventLogRecord, "advapi32.dll", 211 ),
   HOOKFUNCDESC( "GetOverlappedResult", (PROC)LWM_GetOverlappedResult, "kernel32.dll", 328 ),
   HOOKFUNCDESC( "GetPriorityClass", (PROC)LWM_GetPriorityClass, "kernel32.dll", 329 ),
   HOOKFUNCDESC( "GetPrivateObjectSecurity", (PROC)LWM_GetPrivateObjectSecurity, "advapi32.dll", 213 ),
   HOOKFUNCDESC( "GetPrivateProfileIntA", (PROC)LWM_GetPrivateProfileIntA, "kernel32.dll", 330 ),
   HOOKFUNCDESC( "GetPrivateProfileIntW", (PROC)LWM_GetPrivateProfileIntW, "kernel32.dll", 331 ),
   HOOKFUNCDESC( "GetPrivateProfileSectionA", (PROC)LWM_GetPrivateProfileSectionA, "kernel32.dll", 332 ),
   HOOKFUNCDESC( "GetPrivateProfileSectionNamesA", (PROC)LWM_GetPrivateProfileSectionNamesA, "kernel32.dll", 333 ),
   HOOKFUNCDESC( "GetPrivateProfileSectionNamesW", (PROC)LWM_GetPrivateProfileSectionNamesW, "kernel32.dll", 334 ),
   HOOKFUNCDESC( "GetPrivateProfileSectionW", (PROC)LWM_GetPrivateProfileSectionW, "kernel32.dll", 335 ),
   HOOKFUNCDESC( "GetPrivateProfileStringA", (PROC)LWM_GetPrivateProfileStringA, "kernel32.dll", 336 ),
   HOOKFUNCDESC( "GetPrivateProfileStringW", (PROC)LWM_GetPrivateProfileStringW, "kernel32.dll", 337 ),
   HOOKFUNCDESC( "GetPrivateProfileStructA", (PROC)LWM_GetPrivateProfileStructA, "kernel32.dll", 338 ),
   HOOKFUNCDESC( "GetPrivateProfileStructW", (PROC)LWM_GetPrivateProfileStructW, "kernel32.dll", 339 ),
   HOOKFUNCDESC( "GetProcAddress", (PROC)LWM_GetProcAddress, "kernel32.dll", 340 ),
   HOOKFUNCDESC( "GetProcessAffinityMask", (PROC)LWM_GetProcessAffinityMask, "kernel32.dll", 341 ),
   HOOKFUNCDESC( "GetProcessHeap", (PROC)LWM_GetProcessHeap, "kernel32.dll", 342 ),
   HOOKFUNCDESC( "GetProcessHeaps", (PROC)LWM_GetProcessHeaps, "kernel32.dll", 343 ),
   HOOKFUNCDESC( "GetProcessIoCounters", (PROC)LWM_GetProcessIoCounters, "kernel32.dll", 344 ),
   HOOKFUNCDESC( "GetProcessPriorityBoost", (PROC)LWM_GetProcessPriorityBoost, "kernel32.dll", 345 ),
   HOOKFUNCDESC( "GetProcessShutdownParameters", (PROC)LWM_GetProcessShutdownParameters, "kernel32.dll", 346 ),
   HOOKFUNCDESC( "GetProcessTimes", (PROC)LWM_GetProcessTimes, "kernel32.dll", 347 ),
   HOOKFUNCDESC( "GetProcessVersion", (PROC)LWM_GetProcessVersion, "kernel32.dll", 348 ),
   HOOKFUNCDESC( "GetProcessWorkingSetSize", (PROC)LWM_GetProcessWorkingSetSize, "kernel32.dll", 349 ),
   HOOKFUNCDESC( "GetProfileIntA", (PROC)LWM_GetProfileIntA, "kernel32.dll", 350 ),
   HOOKFUNCDESC( "GetProfileIntW", (PROC)LWM_GetProfileIntW, "kernel32.dll", 351 ),
   HOOKFUNCDESC( "GetProfileSectionA", (PROC)LWM_GetProfileSectionA, "kernel32.dll", 352 ),
   HOOKFUNCDESC( "GetProfileSectionW", (PROC)LWM_GetProfileSectionW, "kernel32.dll", 353 ),
   HOOKFUNCDESC( "GetProfileStringA", (PROC)LWM_GetProfileStringA, "kernel32.dll", 354 ),
   HOOKFUNCDESC( "GetProfileStringW", (PROC)LWM_GetProfileStringW, "kernel32.dll", 355 ),
   HOOKFUNCDESC( "GetQueuedCompletionStatus", (PROC)LWM_GetQueuedCompletionStatus, "kernel32.dll", 356 ),
   HOOKFUNCDESC( "GetSecurityDescriptorControl", (PROC)LWM_GetSecurityDescriptorControl, "advapi32.dll", 214 ),
   HOOKFUNCDESC( "GetSecurityDescriptorDacl", (PROC)LWM_GetSecurityDescriptorDacl, "advapi32.dll", 215 ),
   HOOKFUNCDESC( "GetSecurityDescriptorGroup", (PROC)LWM_GetSecurityDescriptorGroup, "advapi32.dll", 216 ),
   HOOKFUNCDESC( "GetSecurityDescriptorLength", (PROC)LWM_GetSecurityDescriptorLength, "advapi32.dll", 217 ),
   HOOKFUNCDESC( "GetSecurityDescriptorOwner", (PROC)LWM_GetSecurityDescriptorOwner, "advapi32.dll", 218 ),
   HOOKFUNCDESC( "GetSecurityDescriptorRMControl", (PROC)LWM_GetSecurityDescriptorRMControl, "advapi32.dll", 219 ),
   HOOKFUNCDESC( "GetSecurityDescriptorSacl", (PROC)LWM_GetSecurityDescriptorSacl, "advapi32.dll", 220 ),
   HOOKFUNCDESC( "GetServiceDisplayNameA", (PROC)LWM_GetServiceDisplayNameA, "advapi32.dll", 224 ),
   HOOKFUNCDESC( "GetServiceDisplayNameW", (PROC)LWM_GetServiceDisplayNameW, "advapi32.dll", 225 ),
   HOOKFUNCDESC( "GetServiceKeyNameA", (PROC)LWM_GetServiceKeyNameA, "advapi32.dll", 226 ),
   HOOKFUNCDESC( "GetServiceKeyNameW", (PROC)LWM_GetServiceKeyNameW, "advapi32.dll", 227 ),
   HOOKFUNCDESC( "GetShortPathNameA", (PROC)LWM_GetShortPathNameA, "kernel32.dll", 357 ),
   HOOKFUNCDESC( "GetShortPathNameW", (PROC)LWM_GetShortPathNameW, "kernel32.dll", 358 ),
   HOOKFUNCDESC( "GetSidIdentifierAuthority", (PROC)LWM_GetSidIdentifierAuthority, "advapi32.dll", 228 ),
   HOOKFUNCDESC( "GetSidLengthRequired", (PROC)LWM_GetSidLengthRequired, "advapi32.dll", 229 ),
   HOOKFUNCDESC( "GetSidSubAuthority", (PROC)LWM_GetSidSubAuthority, "advapi32.dll", 230 ),
   HOOKFUNCDESC( "GetSidSubAuthorityCount", (PROC)LWM_GetSidSubAuthorityCount, "advapi32.dll", 231 ),
   HOOKFUNCDESC( "GetSiteDirectoryA", (PROC)LWM_GetSiteDirectoryA, "advapi32.dll", 232 ),
   HOOKFUNCDESC( "GetSiteDirectoryW", (PROC)LWM_GetSiteDirectoryW, "advapi32.dll", 233 ),
   HOOKFUNCDESC( "GetSiteNameFromSid", (PROC)LWM_GetSiteNameFromSid, "advapi32.dll", 234 ),
   HOOKFUNCDESC( "GetSiteSidFromToken", (PROC)LWM_GetSiteSidFromToken, "advapi32.dll", 235 ),
   HOOKFUNCDESC( "GetSiteSidFromUrl", (PROC)LWM_GetSiteSidFromUrl, "advapi32.dll", 236 ),
   HOOKFUNCDESC( "GetStartupInfoA", (PROC)LWM_GetStartupInfoA, "kernel32.dll", 359 ),
   HOOKFUNCDESC( "GetStartupInfoW", (PROC)LWM_GetStartupInfoW, "kernel32.dll", 360 ),
   HOOKFUNCDESC( "GetStdHandle", (PROC)LWM_GetStdHandle, "kernel32.dll", 361 ),
   HOOKFUNCDESC( "GetStringTypeA", (PROC)LWM_GetStringTypeA, "kernel32.dll", 362 ),
   HOOKFUNCDESC( "GetStringTypeExA", (PROC)LWM_GetStringTypeExA, "kernel32.dll", 363 ),
   HOOKFUNCDESC( "GetStringTypeExW", (PROC)LWM_GetStringTypeExW, "kernel32.dll", 364 ),
   HOOKFUNCDESC( "GetStringTypeW", (PROC)LWM_GetStringTypeW, "kernel32.dll", 365 ),
   HOOKFUNCDESC( "GetSystemDefaultLCID", (PROC)LWM_GetSystemDefaultLCID, "kernel32.dll", 366 ),
   HOOKFUNCDESC( "GetSystemDefaultLangID", (PROC)LWM_GetSystemDefaultLangID, "kernel32.dll", 367 ),
   HOOKFUNCDESC( "GetSystemDirectoryA", (PROC)LWM_GetSystemDirectoryA, "kernel32.dll", 369 ),
   HOOKFUNCDESC( "GetSystemDirectoryW", (PROC)LWM_GetSystemDirectoryW, "kernel32.dll", 370 ),
   HOOKFUNCDESC( "GetSystemInfo", (PROC)LWM_GetSystemInfo, "kernel32.dll", 371 ),
   HOOKFUNCDESC( "GetSystemTime", (PROC)LWM_GetSystemTime, "kernel32.dll", 373 ),
   HOOKFUNCDESC( "GetSystemTimeAdjustment", (PROC)LWM_GetSystemTimeAdjustment, "kernel32.dll", 374 ),
   HOOKFUNCDESC( "GetSystemTimeAsFileTime", (PROC)LWM_GetSystemTimeAsFileTime, "kernel32.dll", 375 ),
   HOOKFUNCDESC( "GetSystemWindowsDirectoryA", (PROC)LWM_GetSystemWindowsDirectoryA, "kernel32.dll", 376 ),
   HOOKFUNCDESC( "GetSystemWindowsDirectoryW", (PROC)LWM_GetSystemWindowsDirectoryW, "kernel32.dll", 377 ),
   HOOKFUNCDESC( "GetTapeParameters", (PROC)LWM_GetTapeParameters, "kernel32.dll", 378 ),
   HOOKFUNCDESC( "GetTapePosition", (PROC)LWM_GetTapePosition, "kernel32.dll", 379 ),
   HOOKFUNCDESC( "GetTapeStatus", (PROC)LWM_GetTapeStatus, "kernel32.dll", 380 ),
   HOOKFUNCDESC( "GetTempFileNameA", (PROC)LWM_GetTempFileNameA, "kernel32.dll", 381 ),
   HOOKFUNCDESC( "GetTempFileNameW", (PROC)LWM_GetTempFileNameW, "kernel32.dll", 382 ),
   HOOKFUNCDESC( "GetTempPathA", (PROC)LWM_GetTempPathA, "kernel32.dll", 383 ),
   HOOKFUNCDESC( "GetTempPathW", (PROC)LWM_GetTempPathW, "kernel32.dll", 384 ),
   HOOKFUNCDESC( "GetThreadContext", (PROC)LWM_GetThreadContext, "kernel32.dll", 385 ),
   HOOKFUNCDESC( "GetThreadLocale", (PROC)LWM_GetThreadLocale, "kernel32.dll", 386 ),
   HOOKFUNCDESC( "GetThreadPriority", (PROC)LWM_GetThreadPriority, "kernel32.dll", 387 ),
   HOOKFUNCDESC( "GetThreadPriorityBoost", (PROC)LWM_GetThreadPriorityBoost, "kernel32.dll", 388 ),
   HOOKFUNCDESC( "GetThreadSelectorEntry", (PROC)LWM_GetThreadSelectorEntry, "kernel32.dll", 389 ),
   HOOKFUNCDESC( "GetThreadTimes", (PROC)LWM_GetThreadTimes, "kernel32.dll", 390 ),
   HOOKFUNCDESC( "GetTickCount", (PROC)LWM_GetTickCount, "kernel32.dll", 391 ),
   HOOKFUNCDESC( "GetTimeFormatA", (PROC)LWM_GetTimeFormatA, "kernel32.dll", 392 ),
   HOOKFUNCDESC( "GetTimeFormatW", (PROC)LWM_GetTimeFormatW, "kernel32.dll", 393 ),
   HOOKFUNCDESC( "GetTimeZoneInformation", (PROC)LWM_GetTimeZoneInformation, "kernel32.dll", 394 ),
   HOOKFUNCDESC( "GetTokenInformation", (PROC)LWM_GetTokenInformation, "advapi32.dll", 237 ),
   HOOKFUNCDESC( "GetUserDefaultLCID", (PROC)LWM_GetUserDefaultLCID, "kernel32.dll", 395 ),
   HOOKFUNCDESC( "GetUserDefaultLangID", (PROC)LWM_GetUserDefaultLangID, "kernel32.dll", 396 ),
   HOOKFUNCDESC( "GetUserNameA", (PROC)LWM_GetUserNameA, "advapi32.dll", 247 ),
   HOOKFUNCDESC( "GetUserNameW", (PROC)LWM_GetUserNameW, "advapi32.dll", 248 ),
   HOOKFUNCDESC( "GetVersion", (PROC)LWM_GetVersion, "kernel32.dll", 399 ),
   HOOKFUNCDESC( "GetVersionExA", (PROC)LWM_GetVersionExA, "kernel32.dll", 400 ),
   HOOKFUNCDESC( "GetVersionExW", (PROC)LWM_GetVersionExW, "kernel32.dll", 401 ),
   HOOKFUNCDESC( "GetVolumeInformationA", (PROC)LWM_GetVolumeInformationA, "kernel32.dll", 402 ),
   HOOKFUNCDESC( "GetVolumeInformationW", (PROC)LWM_GetVolumeInformationW, "kernel32.dll", 403 ),
   HOOKFUNCDESC( "GetVolumeNameForVolumeMountPointA", (PROC)LWM_GetVolumeNameForVolumeMountPointA, "kernel32.dll", 404 ),
   HOOKFUNCDESC( "GetVolumeNameForVolumeMountPointW", (PROC)LWM_GetVolumeNameForVolumeMountPointW, "kernel32.dll", 405 ),
   HOOKFUNCDESC( "GetVolumePathNameA", (PROC)LWM_GetVolumePathNameA, "kernel32.dll", 406 ),
   HOOKFUNCDESC( "GetVolumePathNameW", (PROC)LWM_GetVolumePathNameW, "kernel32.dll", 407 ),
   HOOKFUNCDESC( "GetWindowsDirectoryA", (PROC)LWM_GetWindowsDirectoryA, "kernel32.dll", 408 ),
   HOOKFUNCDESC( "GetWindowsDirectoryW", (PROC)LWM_GetWindowsDirectoryW, "kernel32.dll", 409 ),
   HOOKFUNCDESC( "GetWriteWatch", (PROC)LWM_GetWriteWatch, "kernel32.dll", 410 ),
   HOOKFUNCDESC( "GlobalAddAtomA", (PROC)LWM_GlobalAddAtomA, "kernel32.dll", 411 ),
   HOOKFUNCDESC( "GlobalAddAtomW", (PROC)LWM_GlobalAddAtomW, "kernel32.dll", 412 ),
   HOOKFUNCDESC( "GlobalAlloc", (PROC)LWM_GlobalAlloc, "kernel32.dll", 413 ),
   HOOKFUNCDESC( "GlobalCompact", (PROC)LWM_GlobalCompact, "kernel32.dll", 414 ),
   HOOKFUNCDESC( "GlobalDeleteAtom", (PROC)LWM_GlobalDeleteAtom, "kernel32.dll", 415 ),
   HOOKFUNCDESC( "GlobalFindAtomA", (PROC)LWM_GlobalFindAtomA, "kernel32.dll", 416 ),
   HOOKFUNCDESC( "GlobalFindAtomW", (PROC)LWM_GlobalFindAtomW, "kernel32.dll", 417 ),
   HOOKFUNCDESC( "GlobalFix", (PROC)LWM_GlobalFix, "kernel32.dll", 418 ),
   HOOKFUNCDESC( "GlobalFlags", (PROC)LWM_GlobalFlags, "kernel32.dll", 419 ),
   HOOKFUNCDESC( "GlobalFree", (PROC)LWM_GlobalFree, "kernel32.dll", 420 )};

HOOKFUNCDESC g_stToHookFuncs2[] =
{
   HOOKFUNCDESC( "GlobalGetAtomNameA", (PROC)LWM_GlobalGetAtomNameA, "kernel32.dll", 421 ),
   HOOKFUNCDESC( "GlobalGetAtomNameW", (PROC)LWM_GlobalGetAtomNameW, "kernel32.dll", 422 ),
   HOOKFUNCDESC( "GlobalHandle", (PROC)LWM_GlobalHandle, "kernel32.dll", 423 ),
   HOOKFUNCDESC( "GlobalLock", (PROC)LWM_GlobalLock, "kernel32.dll", 424 ),
   HOOKFUNCDESC( "GlobalMemoryStatus", (PROC)LWM_GlobalMemoryStatus, "kernel32.dll", 425 ),
   HOOKFUNCDESC( "GlobalMemoryStatusEx", (PROC)LWM_GlobalMemoryStatusEx, "kernel32.dll", 426 ),
   HOOKFUNCDESC( "GlobalReAlloc", (PROC)LWM_GlobalReAlloc, "kernel32.dll", 427 ),
   HOOKFUNCDESC( "GlobalSize", (PROC)LWM_GlobalSize, "kernel32.dll", 428 ),
   HOOKFUNCDESC( "GlobalUnWire", (PROC)LWM_GlobalUnWire, "kernel32.dll", 429 ),
   HOOKFUNCDESC( "GlobalUnfix", (PROC)LWM_GlobalUnfix, "kernel32.dll", 430 ),
   HOOKFUNCDESC( "GlobalUnlock", (PROC)LWM_GlobalUnlock, "kernel32.dll", 431 ),
   HOOKFUNCDESC( "GlobalWire", (PROC)LWM_GlobalWire, "kernel32.dll", 432 ),
   HOOKFUNCDESC( "HeapCompact", (PROC)LWM_HeapCompact, "kernel32.dll", 438 ),
   HOOKFUNCDESC( "HeapCreate", (PROC)LWM_HeapCreate, "kernel32.dll", 439 ),
   HOOKFUNCDESC( "HeapDestroy", (PROC)LWM_HeapDestroy, "kernel32.dll", 441 ),
   HOOKFUNCDESC( "HeapLock", (PROC)LWM_HeapLock, "kernel32.dll", 444 ),
   HOOKFUNCDESC( "HeapUnlock", (PROC)LWM_HeapUnlock, "kernel32.dll", 449 ),
   HOOKFUNCDESC( "HeapValidate", (PROC)LWM_HeapValidate, "kernel32.dll", 451 ),
   HOOKFUNCDESC( "HeapWalk", (PROC)LWM_HeapWalk, "kernel32.dll", 452 ),
   HOOKFUNCDESC( "ImpersonateAnonymousToken", (PROC)LWM_ImpersonateAnonymousToken, "advapi32.dll", 252 ),
   HOOKFUNCDESC( "ImpersonateLoggedOnUser", (PROC)LWM_ImpersonateLoggedOnUser, "advapi32.dll", 253 ),
   HOOKFUNCDESC( "ImpersonateNamedPipeClient", (PROC)LWM_ImpersonateNamedPipeClient, "advapi32.dll", 254 ),
   HOOKFUNCDESC( "ImpersonateSelf", (PROC)LWM_ImpersonateSelf, "advapi32.dll", 255 ),
   HOOKFUNCDESC( "InitAtomTable", (PROC)LWM_InitAtomTable, "kernel32.dll", 453 ),
   HOOKFUNCDESC( "InitializeAcl", (PROC)LWM_InitializeAcl, "advapi32.dll", 256 ),
   HOOKFUNCDESC( "InitializeCriticalSection", (PROC)LWM_InitializeCriticalSection, "kernel32.dll", 454 ),
   HOOKFUNCDESC( "InitializeCriticalSectionAndSpinCount", (PROC)LWM_InitializeCriticalSectionAndSpinCount, "kernel32.dll", 455 ),
   HOOKFUNCDESC( "InitializeSecurityDescriptor", (PROC)LWM_InitializeSecurityDescriptor, "advapi32.dll", 257 ),
   HOOKFUNCDESC( "InitializeSid", (PROC)LWM_InitializeSid, "advapi32.dll", 258 ),
   HOOKFUNCDESC( "InitiateSystemShutdownA", (PROC)LWM_InitiateSystemShutdownA, "advapi32.dll", 259 ),
   HOOKFUNCDESC( "InitiateSystemShutdownExA", (PROC)LWM_InitiateSystemShutdownExA, "advapi32.dll", 260 ),
   HOOKFUNCDESC( "InitiateSystemShutdownExW", (PROC)LWM_InitiateSystemShutdownExW, "advapi32.dll", 261 ),
   HOOKFUNCDESC( "InitiateSystemShutdownW", (PROC)LWM_InitiateSystemShutdownW, "advapi32.dll", 262 ),
   HOOKFUNCDESC( "InterlockedCompareExchange", (PROC)LWM_InterlockedCompareExchange, "kernel32.dll", 456 ),
   HOOKFUNCDESC( "InterlockedDecrement", (PROC)LWM_InterlockedDecrement, "kernel32.dll", 457 ),
   HOOKFUNCDESC( "InterlockedExchange", (PROC)LWM_InterlockedExchange, "kernel32.dll", 458 ),
   HOOKFUNCDESC( "InterlockedExchangeAdd", (PROC)LWM_InterlockedExchangeAdd, "kernel32.dll", 459 ),
   HOOKFUNCDESC( "InterlockedIncrement", (PROC)LWM_InterlockedIncrement, "kernel32.dll", 460 ),
   HOOKFUNCDESC( "IsBadCodePtr", (PROC)LWM_IsBadCodePtr, "kernel32.dll", 462 ),
   HOOKFUNCDESC( "IsBadHugeReadPtr", (PROC)LWM_IsBadHugeReadPtr, "kernel32.dll", 463 ),
   HOOKFUNCDESC( "IsBadHugeWritePtr", (PROC)LWM_IsBadHugeWritePtr, "kernel32.dll", 464 ),
   HOOKFUNCDESC( "IsBadReadPtr", (PROC)LWM_IsBadReadPtr, "kernel32.dll", 465 ),
   HOOKFUNCDESC( "IsBadStringPtrA", (PROC)LWM_IsBadStringPtrA, "kernel32.dll", 466 ),
   HOOKFUNCDESC( "IsBadStringPtrW", (PROC)LWM_IsBadStringPtrW, "kernel32.dll", 467 ),
   HOOKFUNCDESC( "IsBadWritePtr", (PROC)LWM_IsBadWritePtr, "kernel32.dll", 468 ),
   HOOKFUNCDESC( "IsDBCSLeadByte", (PROC)LWM_IsDBCSLeadByte, "kernel32.dll", 469 ),
   HOOKFUNCDESC( "IsDBCSLeadByteEx", (PROC)LWM_IsDBCSLeadByteEx, "kernel32.dll", 470 ),
   HOOKFUNCDESC( "IsDebuggerPresent", (PROC)LWM_IsDebuggerPresent, "kernel32.dll", 471 ),
   HOOKFUNCDESC( "IsProcessRestricted", (PROC)LWM_IsProcessRestricted, "advapi32.dll", 264 ),
   HOOKFUNCDESC( "IsProcessorFeaturePresent", (PROC)LWM_IsProcessorFeaturePresent, "kernel32.dll", 472 ),
   HOOKFUNCDESC( "IsSystemResumeAutomatic", (PROC)LWM_IsSystemResumeAutomatic, "kernel32.dll", 473 ),
   HOOKFUNCDESC( "IsTextUnicode", (PROC)LWM_IsTextUnicode, "advapi32.dll", 265 ),
   HOOKFUNCDESC( "IsTokenRestricted", (PROC)LWM_IsTokenRestricted, "advapi32.dll", 266 ),
   HOOKFUNCDESC( "IsValidAcl", (PROC)LWM_IsValidAcl, "advapi32.dll", 267 ),
   HOOKFUNCDESC( "IsValidCodePage", (PROC)LWM_IsValidCodePage, "kernel32.dll", 474 ),
   HOOKFUNCDESC( "IsValidLocale", (PROC)LWM_IsValidLocale, "kernel32.dll", 476 ),
   HOOKFUNCDESC( "IsValidSecurityDescriptor", (PROC)LWM_IsValidSecurityDescriptor, "advapi32.dll", 268 ),
   HOOKFUNCDESC( "IsValidSid", (PROC)LWM_IsValidSid, "advapi32.dll", 269 ),
   HOOKFUNCDESC( "LCMapStringA", (PROC)LWM_LCMapStringA, "kernel32.dll", 477 ),
   HOOKFUNCDESC( "LCMapStringW", (PROC)LWM_LCMapStringW, "kernel32.dll", 478 ),
   HOOKFUNCDESC( "LoadLibraryA", (PROC)LWM_LoadLibraryA, "kernel32.dll", 480 ),
   HOOKFUNCDESC( "LoadLibraryExA", (PROC)LWM_LoadLibraryExA, "kernel32.dll", 481 ),
   HOOKFUNCDESC( "LoadLibraryExW", (PROC)LWM_LoadLibraryExW, "kernel32.dll", 482 ),
   HOOKFUNCDESC( "LoadLibraryW", (PROC)LWM_LoadLibraryW, "kernel32.dll", 483 ),
   HOOKFUNCDESC( "LoadModule", (PROC)LWM_LoadModule, "kernel32.dll", 484 ),
   HOOKFUNCDESC( "LoadResource", (PROC)LWM_LoadResource, "kernel32.dll", 485 ),
   HOOKFUNCDESC( "LocalAlloc", (PROC)LWM_LocalAlloc, "kernel32.dll", 486 ),
   HOOKFUNCDESC( "LocalCompact", (PROC)LWM_LocalCompact, "kernel32.dll", 487 ),
   HOOKFUNCDESC( "LocalFileTimeToFileTime", (PROC)LWM_LocalFileTimeToFileTime, "kernel32.dll", 488 ),
   HOOKFUNCDESC( "LocalFlags", (PROC)LWM_LocalFlags, "kernel32.dll", 489 ),
   HOOKFUNCDESC( "LocalFree", (PROC)LWM_LocalFree, "kernel32.dll", 490 ),
   HOOKFUNCDESC( "LocalHandle", (PROC)LWM_LocalHandle, "kernel32.dll", 491 ),
   HOOKFUNCDESC( "LocalLock", (PROC)LWM_LocalLock, "kernel32.dll", 492 ),
   HOOKFUNCDESC( "LocalReAlloc", (PROC)LWM_LocalReAlloc, "kernel32.dll", 493 ),
   HOOKFUNCDESC( "LocalShrink", (PROC)LWM_LocalShrink, "kernel32.dll", 494 ),
   HOOKFUNCDESC( "LocalSize", (PROC)LWM_LocalSize, "kernel32.dll", 495 ),
   HOOKFUNCDESC( "LocalUnlock", (PROC)LWM_LocalUnlock, "kernel32.dll", 496 ),
   HOOKFUNCDESC( "LockFile", (PROC)LWM_LockFile, "kernel32.dll", 497 ),
   HOOKFUNCDESC( "LockFileEx", (PROC)LWM_LockFileEx, "kernel32.dll", 498 ),
   HOOKFUNCDESC( "LockResource", (PROC)LWM_LockResource, "kernel32.dll", 499 ),
   HOOKFUNCDESC( "LockServiceDatabase", (PROC)LWM_LockServiceDatabase, "advapi32.dll", 270 ),
   HOOKFUNCDESC( "LogonUserA", (PROC)LWM_LogonUserA, "advapi32.dll", 271 ),
   HOOKFUNCDESC( "LogonUserW", (PROC)LWM_LogonUserW, "advapi32.dll", 272 ),
   HOOKFUNCDESC( "LookupAccountNameA", (PROC)LWM_LookupAccountNameA, "advapi32.dll", 273 ),
   HOOKFUNCDESC( "LookupAccountNameW", (PROC)LWM_LookupAccountNameW, "advapi32.dll", 274 ),
   HOOKFUNCDESC( "LookupAccountSidA", (PROC)LWM_LookupAccountSidA, "advapi32.dll", 275 ),
   HOOKFUNCDESC( "LookupAccountSidW", (PROC)LWM_LookupAccountSidW, "advapi32.dll", 276 ),
   HOOKFUNCDESC( "LookupPrivilegeDisplayNameA", (PROC)LWM_LookupPrivilegeDisplayNameA, "advapi32.dll", 277 ),
   HOOKFUNCDESC( "LookupPrivilegeDisplayNameW", (PROC)LWM_LookupPrivilegeDisplayNameW, "advapi32.dll", 278 ),
   HOOKFUNCDESC( "LookupPrivilegeNameA", (PROC)LWM_LookupPrivilegeNameA, "advapi32.dll", 279 ),
   HOOKFUNCDESC( "LookupPrivilegeNameW", (PROC)LWM_LookupPrivilegeNameW, "advapi32.dll", 280 ),
   HOOKFUNCDESC( "LookupPrivilegeValueA", (PROC)LWM_LookupPrivilegeValueA, "advapi32.dll", 281 ),
   HOOKFUNCDESC( "LookupPrivilegeValueW", (PROC)LWM_LookupPrivilegeValueW, "advapi32.dll", 282 ),
   HOOKFUNCDESC( "MakeAbsoluteSD", (PROC)LWM_MakeAbsoluteSD, "advapi32.dll", 341 ),
   HOOKFUNCDESC( "MakeAbsoluteSD2", (PROC)LWM_MakeAbsoluteSD2, "advapi32.dll", 340 ),
   HOOKFUNCDESC( "MakeSelfRelativeSD", (PROC)LWM_MakeSelfRelativeSD, "advapi32.dll", 342 ),
   HOOKFUNCDESC( "MapGenericMask", (PROC)LWM_MapGenericMask, "advapi32.dll", 343 ),
   HOOKFUNCDESC( "MapUserPhysicalPages", (PROC)LWM_MapUserPhysicalPages, "kernel32.dll", 500 ),
   HOOKFUNCDESC( "MapUserPhysicalPagesScatter", (PROC)LWM_MapUserPhysicalPagesScatter, "kernel32.dll", 501 ),
   HOOKFUNCDESC( "MapViewOfFile", (PROC)LWM_MapViewOfFile, "kernel32.dll", 502 ),
   HOOKFUNCDESC( "MapViewOfFileEx", (PROC)LWM_MapViewOfFileEx, "kernel32.dll", 503 ),
   HOOKFUNCDESC( "MoveFileA", (PROC)LWM_MoveFileA, "kernel32.dll", 508 ),
   HOOKFUNCDESC( "MoveFileExA", (PROC)LWM_MoveFileExA, "kernel32.dll", 509 ),
   HOOKFUNCDESC( "MoveFileExW", (PROC)LWM_MoveFileExW, "kernel32.dll", 510 ),
   HOOKFUNCDESC( "MoveFileW", (PROC)LWM_MoveFileW, "kernel32.dll", 511 ),
   HOOKFUNCDESC( "MoveFileWithProgressA", (PROC)LWM_MoveFileWithProgressA, "kernel32.dll", 512 ),
   HOOKFUNCDESC( "MoveFileWithProgressW", (PROC)LWM_MoveFileWithProgressW, "kernel32.dll", 513 ),
   HOOKFUNCDESC( "MulDiv", (PROC)LWM_MulDiv, "kernel32.dll", 514 ),
   HOOKFUNCDESC( "MultiByteToWideChar", (PROC)LWM_MultiByteToWideChar, "kernel32.dll", 515 ),
   HOOKFUNCDESC( "NotifyBootConfigStatus", (PROC)LWM_NotifyBootConfigStatus, "advapi32.dll", 344 ),
   HOOKFUNCDESC( "NotifyChangeEventLog", (PROC)LWM_NotifyChangeEventLog, "advapi32.dll", 345 ),
   HOOKFUNCDESC( "ObjectCloseAuditAlarmA", (PROC)LWM_ObjectCloseAuditAlarmA, "advapi32.dll", 346 ),
   HOOKFUNCDESC( "ObjectCloseAuditAlarmW", (PROC)LWM_ObjectCloseAuditAlarmW, "advapi32.dll", 347 ),
   HOOKFUNCDESC( "ObjectDeleteAuditAlarmA", (PROC)LWM_ObjectDeleteAuditAlarmA, "advapi32.dll", 348 ),
   HOOKFUNCDESC( "ObjectDeleteAuditAlarmW", (PROC)LWM_ObjectDeleteAuditAlarmW, "advapi32.dll", 349 ),
   HOOKFUNCDESC( "ObjectOpenAuditAlarmA", (PROC)LWM_ObjectOpenAuditAlarmA, "advapi32.dll", 350 ),
   HOOKFUNCDESC( "ObjectOpenAuditAlarmW", (PROC)LWM_ObjectOpenAuditAlarmW, "advapi32.dll", 351 ),
   HOOKFUNCDESC( "ObjectPrivilegeAuditAlarmA", (PROC)LWM_ObjectPrivilegeAuditAlarmA, "advapi32.dll", 352 ),
   HOOKFUNCDESC( "ObjectPrivilegeAuditAlarmW", (PROC)LWM_ObjectPrivilegeAuditAlarmW, "advapi32.dll", 353 ),
   HOOKFUNCDESC( "OpenBackupEventLogA", (PROC)LWM_OpenBackupEventLogA, "advapi32.dll", 354 ),
   HOOKFUNCDESC( "OpenBackupEventLogW", (PROC)LWM_OpenBackupEventLogW, "advapi32.dll", 355 ),
   HOOKFUNCDESC( "OpenEncryptedFileRawA", (PROC)LWM_OpenEncryptedFileRawA, "advapi32.dll", 356 ),
   HOOKFUNCDESC( "OpenEncryptedFileRawW", (PROC)LWM_OpenEncryptedFileRawW, "advapi32.dll", 357 ),
   HOOKFUNCDESC( "OpenEventA", (PROC)LWM_OpenEventA, "kernel32.dll", 521 ),
   HOOKFUNCDESC( "OpenEventLogA", (PROC)LWM_OpenEventLogA, "advapi32.dll", 358 ),
   HOOKFUNCDESC( "OpenEventLogW", (PROC)LWM_OpenEventLogW, "advapi32.dll", 359 ),
   HOOKFUNCDESC( "OpenEventW", (PROC)LWM_OpenEventW, "kernel32.dll", 522 ),
   HOOKFUNCDESC( "OpenFile", (PROC)LWM_OpenFile, "kernel32.dll", 523 ),
   HOOKFUNCDESC( "OpenFileMappingA", (PROC)LWM_OpenFileMappingA, "kernel32.dll", 524 ),
   HOOKFUNCDESC( "OpenFileMappingW", (PROC)LWM_OpenFileMappingW, "kernel32.dll", 525 ),
   HOOKFUNCDESC( "OpenJobObjectA", (PROC)LWM_OpenJobObjectA, "kernel32.dll", 526 ),
   HOOKFUNCDESC( "OpenJobObjectW", (PROC)LWM_OpenJobObjectW, "kernel32.dll", 527 ),
   HOOKFUNCDESC( "OpenMutexA", (PROC)LWM_OpenMutexA, "kernel32.dll", 528 ),
   HOOKFUNCDESC( "OpenMutexW", (PROC)LWM_OpenMutexW, "kernel32.dll", 529 ),
   HOOKFUNCDESC( "OpenProcess", (PROC)LWM_OpenProcess, "kernel32.dll", 530 ),
   HOOKFUNCDESC( "OpenProcessToken", (PROC)LWM_OpenProcessToken, "advapi32.dll", 360 ),
   HOOKFUNCDESC( "OpenSCManagerA", (PROC)LWM_OpenSCManagerA, "advapi32.dll", 361 ),
   HOOKFUNCDESC( "OpenSCManagerW", (PROC)LWM_OpenSCManagerW, "advapi32.dll", 362 ),
   HOOKFUNCDESC( "OpenSemaphoreA", (PROC)LWM_OpenSemaphoreA, "kernel32.dll", 532 ),
   HOOKFUNCDESC( "OpenSemaphoreW", (PROC)LWM_OpenSemaphoreW, "kernel32.dll", 533 ),
   HOOKFUNCDESC( "OpenServiceA", (PROC)LWM_OpenServiceA, "advapi32.dll", 363 ),
   HOOKFUNCDESC( "OpenServiceW", (PROC)LWM_OpenServiceW, "advapi32.dll", 364 ),
   HOOKFUNCDESC( "OpenThread", (PROC)LWM_OpenThread, "kernel32.dll", 534 ),
   HOOKFUNCDESC( "OpenThreadToken", (PROC)LWM_OpenThreadToken, "advapi32.dll", 365 ),
   HOOKFUNCDESC( "OpenWaitableTimerA", (PROC)LWM_OpenWaitableTimerA, "kernel32.dll", 535 ),
   HOOKFUNCDESC( "OpenWaitableTimerW", (PROC)LWM_OpenWaitableTimerW, "kernel32.dll", 536 ),
   HOOKFUNCDESC( "OutputDebugStringA", (PROC)LWM_OutputDebugStringA, "kernel32.dll", 537 ),
   HOOKFUNCDESC( "OutputDebugStringW", (PROC)LWM_OutputDebugStringW, "kernel32.dll", 538 ),
   HOOKFUNCDESC( "PeekConsoleInputA", (PROC)LWM_PeekConsoleInputA, "kernel32.dll", 539 ),
   HOOKFUNCDESC( "PeekConsoleInputW", (PROC)LWM_PeekConsoleInputW, "kernel32.dll", 540 ),
   HOOKFUNCDESC( "PeekNamedPipe", (PROC)LWM_PeekNamedPipe, "kernel32.dll", 541 ),
   HOOKFUNCDESC( "PostQueuedCompletionStatus", (PROC)LWM_PostQueuedCompletionStatus, "kernel32.dll", 542 ),
   HOOKFUNCDESC( "PrepareTape", (PROC)LWM_PrepareTape, "kernel32.dll", 543 ),
   HOOKFUNCDESC( "PrivilegeCheck", (PROC)LWM_PrivilegeCheck, "advapi32.dll", 368 ),
   HOOKFUNCDESC( "PrivilegedServiceAuditAlarmA", (PROC)LWM_PrivilegedServiceAuditAlarmA, "advapi32.dll", 369 ),
   HOOKFUNCDESC( "PrivilegedServiceAuditAlarmW", (PROC)LWM_PrivilegedServiceAuditAlarmW, "advapi32.dll", 370 ),
   HOOKFUNCDESC( "ProcessIdToSessionId", (PROC)LWM_ProcessIdToSessionId, "kernel32.dll", 550 ),
   HOOKFUNCDESC( "PulseEvent", (PROC)LWM_PulseEvent, "kernel32.dll", 551 ),
   HOOKFUNCDESC( "PurgeComm", (PROC)LWM_PurgeComm, "kernel32.dll", 552 ),
   HOOKFUNCDESC( "QueryDosDeviceA", (PROC)LWM_QueryDosDeviceA, "kernel32.dll", 553 ),
   HOOKFUNCDESC( "QueryDosDeviceW", (PROC)LWM_QueryDosDeviceW, "kernel32.dll", 554 ),
   HOOKFUNCDESC( "QueryInformationJobObject", (PROC)LWM_QueryInformationJobObject, "kernel32.dll", 555 ),
   HOOKFUNCDESC( "QueryPerformanceCounter", (PROC)LWM_QueryPerformanceCounter, "kernel32.dll", 556 ),
   HOOKFUNCDESC( "QueryPerformanceFrequency", (PROC)LWM_QueryPerformanceFrequency, "kernel32.dll", 557 ),
   HOOKFUNCDESC( "QueryRecoveryAgentsOnEncryptedFile", (PROC)LWM_QueryRecoveryAgentsOnEncryptedFile, "advapi32.dll", 374 ),
   HOOKFUNCDESC( "QueryServiceConfig2A", (PROC)LWM_QueryServiceConfig2A, "advapi32.dll", 375 ),
   HOOKFUNCDESC( "QueryServiceConfig2W", (PROC)LWM_QueryServiceConfig2W, "advapi32.dll", 376 ),
   HOOKFUNCDESC( "QueryServiceConfigA", (PROC)LWM_QueryServiceConfigA, "advapi32.dll", 377 ),
   HOOKFUNCDESC( "QueryServiceConfigW", (PROC)LWM_QueryServiceConfigW, "advapi32.dll", 378 ),
   HOOKFUNCDESC( "QueryServiceLockStatusA", (PROC)LWM_QueryServiceLockStatusA, "advapi32.dll", 379 ),
   HOOKFUNCDESC( "QueryServiceLockStatusW", (PROC)LWM_QueryServiceLockStatusW, "advapi32.dll", 380 ),
   HOOKFUNCDESC( "QueryServiceObjectSecurity", (PROC)LWM_QueryServiceObjectSecurity, "advapi32.dll", 381 ),
   HOOKFUNCDESC( "QueryServiceStatus", (PROC)LWM_QueryServiceStatus, "advapi32.dll", 382 ),
   HOOKFUNCDESC( "QueryServiceStatusEx", (PROC)LWM_QueryServiceStatusEx, "advapi32.dll", 383 ),
   HOOKFUNCDESC( "QueryUsersOnEncryptedFile", (PROC)LWM_QueryUsersOnEncryptedFile, "advapi32.dll", 384 ),
   HOOKFUNCDESC( "QueueUserAPC", (PROC)LWM_QueueUserAPC, "kernel32.dll", 559 ),
   HOOKFUNCDESC( "QueueUserWorkItem", (PROC)LWM_QueueUserWorkItem, "kernel32.dll", 560 ),
   HOOKFUNCDESC( "RaiseException", (PROC)LWM_RaiseException, "kernel32.dll", 561 ),
   HOOKFUNCDESC( "ReadConsoleA", (PROC)LWM_ReadConsoleA, "kernel32.dll", 562 ),
   HOOKFUNCDESC( "ReadConsoleInputA", (PROC)LWM_ReadConsoleInputA, "kernel32.dll", 563 ),
   HOOKFUNCDESC( "ReadConsoleInputW", (PROC)LWM_ReadConsoleInputW, "kernel32.dll", 566 ),
   HOOKFUNCDESC( "ReadConsoleOutputA", (PROC)LWM_ReadConsoleOutputA, "kernel32.dll", 567 ),
   HOOKFUNCDESC( "ReadConsoleOutputAttribute", (PROC)LWM_ReadConsoleOutputAttribute, "kernel32.dll", 568 ),
   HOOKFUNCDESC( "ReadConsoleOutputCharacterA", (PROC)LWM_ReadConsoleOutputCharacterA, "kernel32.dll", 569 ),
   HOOKFUNCDESC( "ReadConsoleOutputCharacterW", (PROC)LWM_ReadConsoleOutputCharacterW, "kernel32.dll", 570 ),
   HOOKFUNCDESC( "ReadConsoleOutputW", (PROC)LWM_ReadConsoleOutputW, "kernel32.dll", 571 ),
   HOOKFUNCDESC( "ReadConsoleW", (PROC)LWM_ReadConsoleW, "kernel32.dll", 572 ),
   HOOKFUNCDESC( "ReadDirectoryChangesW", (PROC)LWM_ReadDirectoryChangesW, "kernel32.dll", 573 ),
   HOOKFUNCDESC( "ReadEncryptedFileRaw", (PROC)LWM_ReadEncryptedFileRaw, "advapi32.dll", 386 ),
   HOOKFUNCDESC( "ReadEventLogA", (PROC)LWM_ReadEventLogA, "advapi32.dll", 387 ),
   HOOKFUNCDESC( "ReadEventLogW", (PROC)LWM_ReadEventLogW, "advapi32.dll", 388 ),
   HOOKFUNCDESC( "ReadFile", (PROC)LWM_ReadFile, "kernel32.dll", 574 ),
   HOOKFUNCDESC( "ReadFileEx", (PROC)LWM_ReadFileEx, "kernel32.dll", 575 ),
   HOOKFUNCDESC( "ReadFileScatter", (PROC)LWM_ReadFileScatter, "kernel32.dll", 576 ),
   HOOKFUNCDESC( "ReadProcessMemory", (PROC)LWM_ReadProcessMemory, "kernel32.dll", 577 ),
   HOOKFUNCDESC( "RegCloseKey", (PROC)LWM_RegCloseKey, "advapi32.dll", 389 ),
   HOOKFUNCDESC( "RegConnectRegistryA", (PROC)LWM_RegConnectRegistryA, "advapi32.dll", 390 ),
   HOOKFUNCDESC( "RegConnectRegistryW", (PROC)LWM_RegConnectRegistryW, "advapi32.dll", 391 ),
   HOOKFUNCDESC( "RegCreateKeyA", (PROC)LWM_RegCreateKeyA, "advapi32.dll", 392 ),
   HOOKFUNCDESC( "RegCreateKeyExA", (PROC)LWM_RegCreateKeyExA, "advapi32.dll", 393 ),
   HOOKFUNCDESC( "RegCreateKeyExW", (PROC)LWM_RegCreateKeyExW, "advapi32.dll", 394 ),
   HOOKFUNCDESC( "RegCreateKeyW", (PROC)LWM_RegCreateKeyW, "advapi32.dll", 395 ),
   HOOKFUNCDESC( "RegDeleteKeyA", (PROC)LWM_RegDeleteKeyA, "advapi32.dll", 396 ),
   HOOKFUNCDESC( "RegDeleteKeyW", (PROC)LWM_RegDeleteKeyW, "advapi32.dll", 397 ),
   HOOKFUNCDESC( "RegDeleteValueA", (PROC)LWM_RegDeleteValueA, "advapi32.dll", 398 ),
   HOOKFUNCDESC( "RegDeleteValueW", (PROC)LWM_RegDeleteValueW, "advapi32.dll", 399 ),
   HOOKFUNCDESC( "RegDisablePredefinedCache", (PROC)LWM_RegDisablePredefinedCache, "advapi32.dll", 400 ),
   HOOKFUNCDESC( "RegEnumKeyA", (PROC)LWM_RegEnumKeyA, "advapi32.dll", 401 ),
   HOOKFUNCDESC( "RegEnumKeyExA", (PROC)LWM_RegEnumKeyExA, "advapi32.dll", 402 ),
   HOOKFUNCDESC( "RegEnumKeyExW", (PROC)LWM_RegEnumKeyExW, "advapi32.dll", 403 ),
   HOOKFUNCDESC( "RegEnumKeyW", (PROC)LWM_RegEnumKeyW, "advapi32.dll", 404 ),
   HOOKFUNCDESC( "RegEnumValueA", (PROC)LWM_RegEnumValueA, "advapi32.dll", 405 ),
   HOOKFUNCDESC( "RegEnumValueW", (PROC)LWM_RegEnumValueW, "advapi32.dll", 406 ),
   HOOKFUNCDESC( "RegFlushKey", (PROC)LWM_RegFlushKey, "advapi32.dll", 407 ),
   HOOKFUNCDESC( "RegGetKeySecurity", (PROC)LWM_RegGetKeySecurity, "advapi32.dll", 408 ),
   HOOKFUNCDESC( "RegLoadKeyA", (PROC)LWM_RegLoadKeyA, "advapi32.dll", 409 ),
   HOOKFUNCDESC( "RegLoadKeyW", (PROC)LWM_RegLoadKeyW, "advapi32.dll", 410 ),
   HOOKFUNCDESC( "RegNotifyChangeKeyValue", (PROC)LWM_RegNotifyChangeKeyValue, "advapi32.dll", 411 ),
   HOOKFUNCDESC( "RegOpenCurrentUser", (PROC)LWM_RegOpenCurrentUser, "advapi32.dll", 412 ),
   HOOKFUNCDESC( "RegOpenKeyA", (PROC)LWM_RegOpenKeyA, "advapi32.dll", 413 ),
   HOOKFUNCDESC( "RegOpenKeyExA", (PROC)LWM_RegOpenKeyExA, "advapi32.dll", 414 ),
   HOOKFUNCDESC( "RegOpenKeyExW", (PROC)LWM_RegOpenKeyExW, "advapi32.dll", 415 ),
   HOOKFUNCDESC( "RegOpenKeyW", (PROC)LWM_RegOpenKeyW, "advapi32.dll", 416 ),
   HOOKFUNCDESC( "RegOpenUserClassesRoot", (PROC)LWM_RegOpenUserClassesRoot, "advapi32.dll", 417 ),
   HOOKFUNCDESC( "RegOverridePredefKey", (PROC)LWM_RegOverridePredefKey, "advapi32.dll", 418 ),
   HOOKFUNCDESC( "RegQueryInfoKeyA", (PROC)LWM_RegQueryInfoKeyA, "advapi32.dll", 419 ),
   HOOKFUNCDESC( "RegQueryInfoKeyW", (PROC)LWM_RegQueryInfoKeyW, "advapi32.dll", 420 ),
   HOOKFUNCDESC( "RegQueryMultipleValuesA", (PROC)LWM_RegQueryMultipleValuesA, "advapi32.dll", 421 ),
   HOOKFUNCDESC( "RegQueryMultipleValuesW", (PROC)LWM_RegQueryMultipleValuesW, "advapi32.dll", 422 ),
   HOOKFUNCDESC( "RegQueryValueA", (PROC)LWM_RegQueryValueA, "advapi32.dll", 423 ),
   HOOKFUNCDESC( "RegQueryValueExA", (PROC)LWM_RegQueryValueExA, "advapi32.dll", 424 ),
   HOOKFUNCDESC( "RegQueryValueExW", (PROC)LWM_RegQueryValueExW, "advapi32.dll", 425 ),
   HOOKFUNCDESC( "RegQueryValueW", (PROC)LWM_RegQueryValueW, "advapi32.dll", 426 ),
   HOOKFUNCDESC( "RegReplaceKeyA", (PROC)LWM_RegReplaceKeyA, "advapi32.dll", 427 ),
   HOOKFUNCDESC( "RegReplaceKeyW", (PROC)LWM_RegReplaceKeyW, "advapi32.dll", 428 ),
   HOOKFUNCDESC( "RegRestoreKeyA", (PROC)LWM_RegRestoreKeyA, "advapi32.dll", 429 ),
   HOOKFUNCDESC( "RegRestoreKeyW", (PROC)LWM_RegRestoreKeyW, "advapi32.dll", 430 ),
   HOOKFUNCDESC( "RegSaveKeyA", (PROC)LWM_RegSaveKeyA, "advapi32.dll", 431 ),
   HOOKFUNCDESC( "RegSaveKeyW", (PROC)LWM_RegSaveKeyW, "advapi32.dll", 432 ),
   HOOKFUNCDESC( "RegSetKeySecurity", (PROC)LWM_RegSetKeySecurity, "advapi32.dll", 433 ),
   HOOKFUNCDESC( "RegSetValueA", (PROC)LWM_RegSetValueA, "advapi32.dll", 434 ),
   HOOKFUNCDESC( "RegSetValueExA", (PROC)LWM_RegSetValueExA, "advapi32.dll", 435 ),
   HOOKFUNCDESC( "RegSetValueExW", (PROC)LWM_RegSetValueExW, "advapi32.dll", 436 ),
   HOOKFUNCDESC( "RegSetValueW", (PROC)LWM_RegSetValueW, "advapi32.dll", 437 ),
   HOOKFUNCDESC( "RegUnLoadKeyA", (PROC)LWM_RegUnLoadKeyA, "advapi32.dll", 438 ),
   HOOKFUNCDESC( "RegUnLoadKeyW", (PROC)LWM_RegUnLoadKeyW, "advapi32.dll", 439 ),
   HOOKFUNCDESC( "RegisterEventSourceA", (PROC)LWM_RegisterEventSourceA, "advapi32.dll", 440 ),
   HOOKFUNCDESC( "RegisterEventSourceW", (PROC)LWM_RegisterEventSourceW, "advapi32.dll", 441 ),
   HOOKFUNCDESC( "RegisterServiceCtrlHandlerA", (PROC)LWM_RegisterServiceCtrlHandlerA, "advapi32.dll", 442 ),
   HOOKFUNCDESC( "RegisterServiceCtrlHandlerExA", (PROC)LWM_RegisterServiceCtrlHandlerExA, "advapi32.dll", 443 ),
   HOOKFUNCDESC( "RegisterServiceCtrlHandlerExW", (PROC)LWM_RegisterServiceCtrlHandlerExW, "advapi32.dll", 444 ),
   HOOKFUNCDESC( "RegisterServiceCtrlHandlerW", (PROC)LWM_RegisterServiceCtrlHandlerW, "advapi32.dll", 445 ),
   HOOKFUNCDESC( "RegisterWaitForSingleObject", (PROC)LWM_RegisterWaitForSingleObject, "kernel32.dll", 582 ),
   HOOKFUNCDESC( "RegisterWaitForSingleObjectEx", (PROC)LWM_RegisterWaitForSingleObjectEx, "kernel32.dll", 583 ),
   HOOKFUNCDESC( "ReleaseMutex", (PROC)LWM_ReleaseMutex, "kernel32.dll", 586 ),
   HOOKFUNCDESC( "ReleaseSemaphore", (PROC)LWM_ReleaseSemaphore, "kernel32.dll", 587 ),
   HOOKFUNCDESC( "RemoveDirectoryA", (PROC)LWM_RemoveDirectoryA, "kernel32.dll", 588 ),
   HOOKFUNCDESC( "RemoveDirectoryW", (PROC)LWM_RemoveDirectoryW, "kernel32.dll", 589 ),
   HOOKFUNCDESC( "RemoveUsersFromEncryptedFile", (PROC)LWM_RemoveUsersFromEncryptedFile, "advapi32.dll", 449 ),
   HOOKFUNCDESC( "ReplaceFileA", (PROC)LWM_ReplaceFileA, "kernel32.dll", 591 ),
   HOOKFUNCDESC( "ReplaceFileW", (PROC)LWM_ReplaceFileW, "kernel32.dll", 592 ),
   HOOKFUNCDESC( "ReportEventA", (PROC)LWM_ReportEventA, "advapi32.dll", 450 ),
   HOOKFUNCDESC( "ReportEventW", (PROC)LWM_ReportEventW, "advapi32.dll", 451 ),
   HOOKFUNCDESC( "RequestDeviceWakeup", (PROC)LWM_RequestDeviceWakeup, "kernel32.dll", 593 ),
   HOOKFUNCDESC( "RequestWakeupLatency", (PROC)LWM_RequestWakeupLatency, "kernel32.dll", 594 ),
   HOOKFUNCDESC( "ResetEvent", (PROC)LWM_ResetEvent, "kernel32.dll", 595 ),
   HOOKFUNCDESC( "ResetWriteWatch", (PROC)LWM_ResetWriteWatch, "kernel32.dll", 596 ),
   HOOKFUNCDESC( "ResumeThread", (PROC)LWM_ResumeThread, "kernel32.dll", 597 ),
   HOOKFUNCDESC( "RevertToSelf", (PROC)LWM_RevertToSelf, "advapi32.dll", 452 ),
   HOOKFUNCDESC( "ScrollConsoleScreenBufferA", (PROC)LWM_ScrollConsoleScreenBufferA, "kernel32.dll", 602 ),
   HOOKFUNCDESC( "ScrollConsoleScreenBufferW", (PROC)LWM_ScrollConsoleScreenBufferW, "kernel32.dll", 603 ),
   HOOKFUNCDESC( "SearchPathA", (PROC)LWM_SearchPathA, "kernel32.dll", 604 ),
   HOOKFUNCDESC( "SearchPathW", (PROC)LWM_SearchPathW, "kernel32.dll", 605 ),
   HOOKFUNCDESC( "SetAclInformation", (PROC)LWM_SetAclInformation, "advapi32.dll", 453 ),
   HOOKFUNCDESC( "SetCommBreak", (PROC)LWM_SetCommBreak, "kernel32.dll", 609 ),
   HOOKFUNCDESC( "SetCommConfig", (PROC)LWM_SetCommConfig, "kernel32.dll", 610 ),
   HOOKFUNCDESC( "SetCommMask", (PROC)LWM_SetCommMask, "kernel32.dll", 611 ),
   HOOKFUNCDESC( "SetCommState", (PROC)LWM_SetCommState, "kernel32.dll", 612 ),
   HOOKFUNCDESC( "SetCommTimeouts", (PROC)LWM_SetCommTimeouts, "kernel32.dll", 613 ),
   HOOKFUNCDESC( "SetComputerNameA", (PROC)LWM_SetComputerNameA, "kernel32.dll", 614 ),
   HOOKFUNCDESC( "SetComputerNameExA", (PROC)LWM_SetComputerNameExA, "kernel32.dll", 615 ),
   HOOKFUNCDESC( "SetComputerNameExW", (PROC)LWM_SetComputerNameExW, "kernel32.dll", 616 ),
   HOOKFUNCDESC( "SetComputerNameW", (PROC)LWM_SetComputerNameW, "kernel32.dll", 617 ),
   HOOKFUNCDESC( "SetConsoleActiveScreenBuffer", (PROC)LWM_SetConsoleActiveScreenBuffer, "kernel32.dll", 618 ),
   HOOKFUNCDESC( "SetConsoleCP", (PROC)LWM_SetConsoleCP, "kernel32.dll", 619 ),
   HOOKFUNCDESC( "SetConsoleCtrlHandler", (PROC)LWM_SetConsoleCtrlHandler, "kernel32.dll", 621 ),
   HOOKFUNCDESC( "SetConsoleCursorInfo", (PROC)LWM_SetConsoleCursorInfo, "kernel32.dll", 623 ),
   HOOKFUNCDESC( "SetConsoleCursorPosition", (PROC)LWM_SetConsoleCursorPosition, "kernel32.dll", 625 ),
   HOOKFUNCDESC( "SetConsoleMode", (PROC)LWM_SetConsoleMode, "kernel32.dll", 636 ),
   HOOKFUNCDESC( "SetConsoleOutputCP", (PROC)LWM_SetConsoleOutputCP, "kernel32.dll", 641 ),
   HOOKFUNCDESC( "SetConsoleScreenBufferSize", (PROC)LWM_SetConsoleScreenBufferSize, "kernel32.dll", 643 ),
   HOOKFUNCDESC( "SetConsoleTextAttribute", (PROC)LWM_SetConsoleTextAttribute, "kernel32.dll", 644 ),
   HOOKFUNCDESC( "SetConsoleTitleA", (PROC)LWM_SetConsoleTitleA, "kernel32.dll", 645 ),
   HOOKFUNCDESC( "SetConsoleTitleW", (PROC)LWM_SetConsoleTitleW, "kernel32.dll", 646 ),
   HOOKFUNCDESC( "SetConsoleWindowInfo", (PROC)LWM_SetConsoleWindowInfo, "kernel32.dll", 647 ),
   HOOKFUNCDESC( "SetCurrentDirectoryA", (PROC)LWM_SetCurrentDirectoryA, "kernel32.dll", 649 ),
   HOOKFUNCDESC( "SetCurrentDirectoryW", (PROC)LWM_SetCurrentDirectoryW, "kernel32.dll", 650 ),
   HOOKFUNCDESC( "SetDefaultCommConfigA", (PROC)LWM_SetDefaultCommConfigA, "kernel32.dll", 651 ),
   HOOKFUNCDESC( "SetDefaultCommConfigW", (PROC)LWM_SetDefaultCommConfigW, "kernel32.dll", 652 ),
   HOOKFUNCDESC( "SetEndOfFile", (PROC)LWM_SetEndOfFile, "kernel32.dll", 653 ),
   HOOKFUNCDESC( "SetEnvironmentVariableA", (PROC)LWM_SetEnvironmentVariableA, "kernel32.dll", 654 ),
   HOOKFUNCDESC( "SetEnvironmentVariableW", (PROC)LWM_SetEnvironmentVariableW, "kernel32.dll", 655 ),
   HOOKFUNCDESC( "SetErrorMode", (PROC)LWM_SetErrorMode, "kernel32.dll", 656 ),
   HOOKFUNCDESC( "SetEvent", (PROC)LWM_SetEvent, "kernel32.dll", 657 ),
   HOOKFUNCDESC( "SetFileApisToANSI", (PROC)LWM_SetFileApisToANSI, "kernel32.dll", 658 ),
   HOOKFUNCDESC( "SetFileApisToOEM", (PROC)LWM_SetFileApisToOEM, "kernel32.dll", 659 ),
   HOOKFUNCDESC( "SetFileAttributesA", (PROC)LWM_SetFileAttributesA, "kernel32.dll", 660 ),
   HOOKFUNCDESC( "SetFileAttributesW", (PROC)LWM_SetFileAttributesW, "kernel32.dll", 661 ),
   HOOKFUNCDESC( "SetFilePointer", (PROC)LWM_SetFilePointer, "kernel32.dll", 662 ),
   HOOKFUNCDESC( "SetFilePointerEx", (PROC)LWM_SetFilePointerEx, "kernel32.dll", 663 ),
   HOOKFUNCDESC( "SetFileSecurityA", (PROC)LWM_SetFileSecurityA, "advapi32.dll", 460 ),
   HOOKFUNCDESC( "SetFileSecurityW", (PROC)LWM_SetFileSecurityW, "advapi32.dll", 461 ),
   HOOKFUNCDESC( "SetFileTime", (PROC)LWM_SetFileTime, "kernel32.dll", 664 ),
   HOOKFUNCDESC( "SetHandleCount", (PROC)LWM_SetHandleCount, "kernel32.dll", 665 ),
   HOOKFUNCDESC( "SetHandleInformation", (PROC)LWM_SetHandleInformation, "kernel32.dll", 666 ),
   HOOKFUNCDESC( "SetInformationJobObject", (PROC)LWM_SetInformationJobObject, "kernel32.dll", 667 ),
   HOOKFUNCDESC( "SetKernelObjectSecurity", (PROC)LWM_SetKernelObjectSecurity, "advapi32.dll", 462 ),
   HOOKFUNCDESC( "SetLastError", (PROC)LWM_SetLastError, "kernel32.dll", 669 ),
   HOOKFUNCDESC( "SetLocalTime", (PROC)LWM_SetLocalTime, "kernel32.dll", 670 ),
   HOOKFUNCDESC( "SetLocaleInfoA", (PROC)LWM_SetLocaleInfoA, "kernel32.dll", 671 ),
   HOOKFUNCDESC( "SetLocaleInfoW", (PROC)LWM_SetLocaleInfoW, "kernel32.dll", 672 ),
   HOOKFUNCDESC( "SetMailslotInfo", (PROC)LWM_SetMailslotInfo, "kernel32.dll", 673 ),
   HOOKFUNCDESC( "SetMessageWaitingIndicator", (PROC)LWM_SetMessageWaitingIndicator, "kernel32.dll", 674 ),
   HOOKFUNCDESC( "SetNamedPipeHandleState", (PROC)LWM_SetNamedPipeHandleState, "kernel32.dll", 675 ),
   HOOKFUNCDESC( "SetPriorityClass", (PROC)LWM_SetPriorityClass, "kernel32.dll", 676 ),
   HOOKFUNCDESC( "SetPrivateObjectSecurity", (PROC)LWM_SetPrivateObjectSecurity, "advapi32.dll", 467 ),
   HOOKFUNCDESC( "SetPrivateObjectSecurityEx", (PROC)LWM_SetPrivateObjectSecurityEx, "advapi32.dll", 468 ),
   HOOKFUNCDESC( "SetProcessAffinityMask", (PROC)LWM_SetProcessAffinityMask, "kernel32.dll", 677 ),
   HOOKFUNCDESC( "SetProcessPriorityBoost", (PROC)LWM_SetProcessPriorityBoost, "kernel32.dll", 678 ),
   HOOKFUNCDESC( "SetProcessShutdownParameters", (PROC)LWM_SetProcessShutdownParameters, "kernel32.dll", 679 ),
   HOOKFUNCDESC( "SetProcessWorkingSetSize", (PROC)LWM_SetProcessWorkingSetSize, "kernel32.dll", 680 ),
   HOOKFUNCDESC( "SetSecurityDescriptorControl", (PROC)LWM_SetSecurityDescriptorControl, "advapi32.dll", 469 ),
   HOOKFUNCDESC( "SetSecurityDescriptorDacl", (PROC)LWM_SetSecurityDescriptorDacl, "advapi32.dll", 470 ),
   HOOKFUNCDESC( "SetSecurityDescriptorGroup", (PROC)LWM_SetSecurityDescriptorGroup, "advapi32.dll", 471 ),
   HOOKFUNCDESC( "SetSecurityDescriptorOwner", (PROC)LWM_SetSecurityDescriptorOwner, "advapi32.dll", 472 ),
   HOOKFUNCDESC( "SetSecurityDescriptorRMControl", (PROC)LWM_SetSecurityDescriptorRMControl, "advapi32.dll", 473 ),
   HOOKFUNCDESC( "SetSecurityDescriptorSacl", (PROC)LWM_SetSecurityDescriptorSacl, "advapi32.dll", 474 ),
   HOOKFUNCDESC( "SetServiceObjectSecurity", (PROC)LWM_SetServiceObjectSecurity, "advapi32.dll", 479 ),
   HOOKFUNCDESC( "SetServiceStatus", (PROC)LWM_SetServiceStatus, "advapi32.dll", 480 ),
   HOOKFUNCDESC( "SetStdHandle", (PROC)LWM_SetStdHandle, "kernel32.dll", 681 ),
   HOOKFUNCDESC( "SetSystemTime", (PROC)LWM_SetSystemTime, "kernel32.dll", 683 ),
   HOOKFUNCDESC( "SetSystemTimeAdjustment", (PROC)LWM_SetSystemTimeAdjustment, "kernel32.dll", 684 ),
   HOOKFUNCDESC( "SetTapeParameters", (PROC)LWM_SetTapeParameters, "kernel32.dll", 685 ),
   HOOKFUNCDESC( "SetTapePosition", (PROC)LWM_SetTapePosition, "kernel32.dll", 686 ),
   HOOKFUNCDESC( "SetThreadAffinityMask", (PROC)LWM_SetThreadAffinityMask, "kernel32.dll", 688 ),
   HOOKFUNCDESC( "SetThreadContext", (PROC)LWM_SetThreadContext, "kernel32.dll", 689 ),
   HOOKFUNCDESC( "SetThreadExecutionState", (PROC)LWM_SetThreadExecutionState, "kernel32.dll", 690 ),
   HOOKFUNCDESC( "SetThreadIdealProcessor", (PROC)LWM_SetThreadIdealProcessor, "kernel32.dll", 691 ),
   HOOKFUNCDESC( "SetThreadLocale", (PROC)LWM_SetThreadLocale, "kernel32.dll", 692 ),
   HOOKFUNCDESC( "SetThreadPriority", (PROC)LWM_SetThreadPriority, "kernel32.dll", 693 ),
   HOOKFUNCDESC( "SetThreadPriorityBoost", (PROC)LWM_SetThreadPriorityBoost, "kernel32.dll", 694 ),
   HOOKFUNCDESC( "SetThreadToken", (PROC)LWM_SetThreadToken, "advapi32.dll", 481 ),
   HOOKFUNCDESC( "SetTimeZoneInformation", (PROC)LWM_SetTimeZoneInformation, "kernel32.dll", 695 ),
   HOOKFUNCDESC( "SetTimerQueueTimer", (PROC)LWM_SetTimerQueueTimer, "kernel32.dll", 696 ),
   HOOKFUNCDESC( "SetTokenInformation", (PROC)LWM_SetTokenInformation, "advapi32.dll", 482 ),
   HOOKFUNCDESC( "SetUnhandledExceptionFilter", (PROC)LWM_SetUnhandledExceptionFilter, "kernel32.dll", 697 ),
   HOOKFUNCDESC( "SetUserFileEncryptionKey", (PROC)LWM_SetUserFileEncryptionKey, "advapi32.dll", 484 ),
   HOOKFUNCDESC( "SetVolumeLabelA", (PROC)LWM_SetVolumeLabelA, "kernel32.dll", 699 ),
   HOOKFUNCDESC( "SetVolumeLabelW", (PROC)LWM_SetVolumeLabelW, "kernel32.dll", 700 ),
   HOOKFUNCDESC( "SetVolumeMountPointA", (PROC)LWM_SetVolumeMountPointA, "kernel32.dll", 701 ),
   HOOKFUNCDESC( "SetVolumeMountPointW", (PROC)LWM_SetVolumeMountPointW, "kernel32.dll", 702 ),
   HOOKFUNCDESC( "SetWaitableTimer", (PROC)LWM_SetWaitableTimer, "kernel32.dll", 703 ),
   HOOKFUNCDESC( "SetupComm", (PROC)LWM_SetupComm, "kernel32.dll", 704 ),
   HOOKFUNCDESC( "SignalObjectAndWait", (PROC)LWM_SignalObjectAndWait, "kernel32.dll", 706 ),
   HOOKFUNCDESC( "SizeofResource", (PROC)LWM_SizeofResource, "kernel32.dll", 707 ),
   HOOKFUNCDESC( "Sleep", (PROC)LWM_Sleep, "kernel32.dll", 708 ),
   HOOKFUNCDESC( "SleepEx", (PROC)LWM_SleepEx, "kernel32.dll", 709 ),
   HOOKFUNCDESC( "StartServiceA", (PROC)LWM_StartServiceA, "advapi32.dll", 485 ),
   HOOKFUNCDESC( "StartServiceCtrlDispatcherA", (PROC)LWM_StartServiceCtrlDispatcherA, "advapi32.dll", 486 ),
   HOOKFUNCDESC( "StartServiceCtrlDispatcherW", (PROC)LWM_StartServiceCtrlDispatcherW, "advapi32.dll", 487 ),
   HOOKFUNCDESC( "StartServiceW", (PROC)LWM_StartServiceW, "advapi32.dll", 488 ),
   HOOKFUNCDESC( "SuspendThread", (PROC)LWM_SuspendThread, "kernel32.dll", 710 ),
   HOOKFUNCDESC( "SwitchToFiber", (PROC)LWM_SwitchToFiber, "kernel32.dll", 711 ),
   HOOKFUNCDESC( "SwitchToThread", (PROC)LWM_SwitchToThread, "kernel32.dll", 712 ),
   HOOKFUNCDESC( "SystemTimeToFileTime", (PROC)LWM_SystemTimeToFileTime, "kernel32.dll", 713 ),
   HOOKFUNCDESC( "SystemTimeToTzSpecificLocalTime", (PROC)LWM_SystemTimeToTzSpecificLocalTime, "kernel32.dll", 714 ),
   HOOKFUNCDESC( "TerminateJobObject", (PROC)LWM_TerminateJobObject, "kernel32.dll", 715 ),
   HOOKFUNCDESC( "TerminateProcess", (PROC)LWM_TerminateProcess, "kernel32.dll", 716 ),
   HOOKFUNCDESC( "TerminateThread", (PROC)LWM_TerminateThread, "kernel32.dll", 717 ),
   HOOKFUNCDESC( "TlsAlloc", (PROC)LWM_TlsAlloc, "kernel32.dll", 721 ),
   HOOKFUNCDESC( "TlsFree", (PROC)LWM_TlsFree, "kernel32.dll", 722 ),
   HOOKFUNCDESC( "TlsGetValue", (PROC)LWM_TlsGetValue, "kernel32.dll", 723 ),
   HOOKFUNCDESC( "TlsSetValue", (PROC)LWM_TlsSetValue, "kernel32.dll", 724 ),
   HOOKFUNCDESC( "TransactNamedPipe", (PROC)LWM_TransactNamedPipe, "kernel32.dll", 726 ),
   HOOKFUNCDESC( "TransmitCommChar", (PROC)LWM_TransmitCommChar, "kernel32.dll", 727 ),
   HOOKFUNCDESC( "UnhandledExceptionFilter", (PROC)LWM_UnhandledExceptionFilter, "kernel32.dll", 732 ),
   HOOKFUNCDESC( "UnlockFile", (PROC)LWM_UnlockFile, "kernel32.dll", 733 ),
   HOOKFUNCDESC( "UnlockFileEx", (PROC)LWM_UnlockFileEx, "kernel32.dll", 734 ),
   HOOKFUNCDESC( "UnlockServiceDatabase", (PROC)LWM_UnlockServiceDatabase, "advapi32.dll", 532 ),
   HOOKFUNCDESC( "UnmapViewOfFile", (PROC)LWM_UnmapViewOfFile, "kernel32.dll", 735 ),
   HOOKFUNCDESC( "UnregisterWait", (PROC)LWM_UnregisterWait, "kernel32.dll", 737 ),
   HOOKFUNCDESC( "UnregisterWaitEx", (PROC)LWM_UnregisterWaitEx, "kernel32.dll", 738 ),
   HOOKFUNCDESC( "UpdateResourceA", (PROC)LWM_UpdateResourceA, "kernel32.dll", 739 ),
   HOOKFUNCDESC( "UpdateResourceW", (PROC)LWM_UpdateResourceW, "kernel32.dll", 740 ),
   HOOKFUNCDESC( "VerifyVersionInfoA", (PROC)LWM_VerifyVersionInfoA, "kernel32.dll", 749 ),
   HOOKFUNCDESC( "VerifyVersionInfoW", (PROC)LWM_VerifyVersionInfoW, "kernel32.dll", 750 ),
   HOOKFUNCDESC( "VirtualAlloc", (PROC)LWM_VirtualAlloc, "kernel32.dll", 751 ),
   HOOKFUNCDESC( "VirtualAllocEx", (PROC)LWM_VirtualAllocEx, "kernel32.dll", 752 ),
   HOOKFUNCDESC( "VirtualFree", (PROC)LWM_VirtualFree, "kernel32.dll", 754 ),
   HOOKFUNCDESC( "VirtualFreeEx", (PROC)LWM_VirtualFreeEx, "kernel32.dll", 755 ),
   HOOKFUNCDESC( "VirtualLock", (PROC)LWM_VirtualLock, "kernel32.dll", 756 ),
   HOOKFUNCDESC( "VirtualProtect", (PROC)LWM_VirtualProtect, "kernel32.dll", 757 ),
   HOOKFUNCDESC( "VirtualProtectEx", (PROC)LWM_VirtualProtectEx, "kernel32.dll", 758 ),
   HOOKFUNCDESC( "VirtualQuery", (PROC)LWM_VirtualQuery, "kernel32.dll", 759 ),
   HOOKFUNCDESC( "VirtualQueryEx", (PROC)LWM_VirtualQueryEx, "kernel32.dll", 760 ),
   HOOKFUNCDESC( "VirtualUnlock", (PROC)LWM_VirtualUnlock, "kernel32.dll", 761 ),
   HOOKFUNCDESC( "WaitCommEvent", (PROC)LWM_WaitCommEvent, "kernel32.dll", 762 ),
   HOOKFUNCDESC( "WaitForDebugEvent", (PROC)LWM_WaitForDebugEvent, "kernel32.dll", 763 ),
   HOOKFUNCDESC( "WaitForMultipleObjects", (PROC)LWM_WaitForMultipleObjects, "kernel32.dll", 764 ),
   HOOKFUNCDESC( "WaitForMultipleObjectsEx", (PROC)LWM_WaitForMultipleObjectsEx, "kernel32.dll", 765 ),
   HOOKFUNCDESC( "WaitForSingleObject", (PROC)LWM_WaitForSingleObject, "kernel32.dll", 766 ),
   HOOKFUNCDESC( "WaitForSingleObjectEx", (PROC)LWM_WaitForSingleObjectEx, "kernel32.dll", 767 ),
   HOOKFUNCDESC( "WaitNamedPipeA", (PROC)LWM_WaitNamedPipeA, "kernel32.dll", 768 ),
   HOOKFUNCDESC( "WaitNamedPipeW", (PROC)LWM_WaitNamedPipeW, "kernel32.dll", 769 ),
   HOOKFUNCDESC( "WideCharToMultiByte", (PROC)LWM_WideCharToMultiByte, "kernel32.dll", 770 ),
   HOOKFUNCDESC( "WinExec", (PROC)LWM_WinExec, "kernel32.dll", 771 ),
   HOOKFUNCDESC( "WriteConsoleA", (PROC)LWM_WriteConsoleA, "kernel32.dll", 772 ),
   HOOKFUNCDESC( "WriteConsoleInputA", (PROC)LWM_WriteConsoleInputA, "kernel32.dll", 773 ),
   HOOKFUNCDESC( "WriteConsoleInputW", (PROC)LWM_WriteConsoleInputW, "kernel32.dll", 776 ),
   HOOKFUNCDESC( "WriteConsoleOutputA", (PROC)LWM_WriteConsoleOutputA, "kernel32.dll", 777 ),
   HOOKFUNCDESC( "WriteConsoleOutputAttribute", (PROC)LWM_WriteConsoleOutputAttribute, "kernel32.dll", 778 ),
   HOOKFUNCDESC( "WriteConsoleOutputCharacterA", (PROC)LWM_WriteConsoleOutputCharacterA, "kernel32.dll", 779 ),
   HOOKFUNCDESC( "WriteConsoleOutputCharacterW", (PROC)LWM_WriteConsoleOutputCharacterW, "kernel32.dll", 780 ),
   HOOKFUNCDESC( "WriteConsoleOutputW", (PROC)LWM_WriteConsoleOutputW, "kernel32.dll", 781 ),
   HOOKFUNCDESC( "WriteConsoleW", (PROC)LWM_WriteConsoleW, "kernel32.dll", 782 ),
   HOOKFUNCDESC( "WriteEncryptedFileRaw", (PROC)LWM_WriteEncryptedFileRaw, "advapi32.dll", 557 ),
   HOOKFUNCDESC( "WriteFile", (PROC)LWM_WriteFile, "kernel32.dll", 783 ),
   HOOKFUNCDESC( "WriteFileEx", (PROC)LWM_WriteFileEx, "kernel32.dll", 784 ),
   HOOKFUNCDESC( "WriteFileGather", (PROC)LWM_WriteFileGather, "kernel32.dll", 785 ),
   HOOKFUNCDESC( "WritePrivateProfileSectionA", (PROC)LWM_WritePrivateProfileSectionA, "kernel32.dll", 786 ),
   HOOKFUNCDESC( "WritePrivateProfileSectionW", (PROC)LWM_WritePrivateProfileSectionW, "kernel32.dll", 787 ),
   HOOKFUNCDESC( "WritePrivateProfileStringA", (PROC)LWM_WritePrivateProfileStringA, "kernel32.dll", 788 ),
   HOOKFUNCDESC( "WritePrivateProfileStringW", (PROC)LWM_WritePrivateProfileStringW, "kernel32.dll", 789 ),
   HOOKFUNCDESC( "WritePrivateProfileStructA", (PROC)LWM_WritePrivateProfileStructA, "kernel32.dll", 790 ),
   HOOKFUNCDESC( "WritePrivateProfileStructW", (PROC)LWM_WritePrivateProfileStructW, "kernel32.dll", 791 ),
   HOOKFUNCDESC( "WriteProcessMemory", (PROC)LWM_WriteProcessMemory, "kernel32.dll", 792 ),
   HOOKFUNCDESC( "WriteProfileSectionA", (PROC)LWM_WriteProfileSectionA, "kernel32.dll", 793 ),
   HOOKFUNCDESC( "WriteProfileSectionW", (PROC)LWM_WriteProfileSectionW, "kernel32.dll", 794 ),
   HOOKFUNCDESC( "WriteProfileStringA", (PROC)LWM_WriteProfileStringA, "kernel32.dll", 795 ),
   HOOKFUNCDESC( "WriteProfileStringW", (PROC)LWM_WriteProfileStringW, "kernel32.dll", 796 ),
   HOOKFUNCDESC( "WriteTapemark", (PROC)LWM_WriteTapemark, "kernel32.dll", 797 ),
   HOOKFUNCDESC( "_hread", (PROC)LWM__hread, "kernel32.dll", 798 ),
   HOOKFUNCDESC( "_hwrite", (PROC)LWM__hwrite, "kernel32.dll", 799 ),
   HOOKFUNCDESC( "_lclose", (PROC)LWM__lclose, "kernel32.dll", 800 ),
   HOOKFUNCDESC( "_lcreat", (PROC)LWM__lcreat, "kernel32.dll", 801 ),
   HOOKFUNCDESC( "_llseek", (PROC)LWM__llseek, "kernel32.dll", 802 ),
   HOOKFUNCDESC( "_lopen", (PROC)LWM__lopen, "kernel32.dll", 803 ),
   HOOKFUNCDESC( "_lread", (PROC)LWM__lread, "kernel32.dll", 804 ),
   HOOKFUNCDESC( "_lwrite", (PROC)LWM__lwrite, "kernel32.dll", 805 )};

HOOKFUNCDESC & lwmstubGetHookFuncEntry( int index )
{
   if( ( index >= ( ( 1 - 1 ) * 500 ) ) &&
       ( index < ( 1 * 500 ) ) )
      return g_stToHookFuncs1[ index - (1 - 1) * 500 ];
   else if( ( index >= ( ( 2 - 1 ) * 500 ) ) &&
       ( index < 949 ) )
      return g_stToHookFuncs2[ index - (2 - 1) * 500 ];
   panic( "lwmstubGetHookFuncEntry: invalid index" );
   
}

WSS_MUTEX_PROTECT(g_callcount);
volatile DWORD g_callcount = 0;

WSS_MUTEX_PROTECT(g_tracecount);
volatile DWORD g_tracecount = 0;

PROC g_pOrigFuncs[ k_NUM_HOOKED_FUNCS ] =
{
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
   NULL
};

LPCWSTR _LWMStubs_ConvertASCIIToUnicode( LPCSTR pStr )
{
   if( pStr == NULL ) return NULL;

   DWORD strLen = strlen( pStr ) + 1;
   pd_char_t *wstr = (pd_char_t *)malloc( strLen * sizeof(pd_char_t) );
   MultiByteToWideChar( CP_ACP, 0, pStr, strLen, wstr,
                        strLen * sizeof(pd_char_t) );
   return wstr;
}

LPCSTR _LWMStubs_ConvertUnicodeToASCII( LPCWSTR pStr )
{
   if( pStr == NULL ) return NULL;

   DWORD strLen = _tcslen( pStr ) + 1;
   char *wstr = (char *)malloc( strLen * sizeof(pd_char_t) );
   WideCharToMultiByte( CP_ACP, 0, pStr, strLen, wstr,
                        strLen * sizeof(pd_char_t), NULL, NULL );
   return wstr;
}

#include "lwmstubs5_0.cxx"
#include "lwmstubs5_1.cxx"
