/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */
#include "windows.h"

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
  STARTUPINFO si;         
  PROCESS_INFORMATION pi;
  
  /* Launch the process and waits for it to complete */  
  si.cb = sizeof(STARTUPINFO);         
  si.lpReserved = NULL; 
  si.lpReserved2 = NULL;
  si.cbReserved2 = 0; 
  si.lpTitle = lpCmdLine;
  si.lpDesktop = (LPTSTR)NULL; 
  si.dwFlags = STARTF_FORCEONFEEDBACK;
  if (!CreateProcess(NULL, 
		     lpCmdLine,
		     NULL, 
		     NULL,
		     FALSE, 
		     NORMAL_PRIORITY_CLASS,
		     NULL, 
		     (LPTSTR)NULL,
		     &si, 
		     &pi)) {                 
    MessageBox( 0, "CreateProcess Failed!", "CreateProcess", 
		( MB_OK | MB_ICONEXCLAMATION | MB_DEFAULT_DESKTOP_ONLY ) );
  }  

  /* wait for completion. */ 
  WaitForSingleObject(pi.hProcess, INFINITE);  
  /* close process and thread handles */ 
  CloseHandle(pi.hThread); 
  CloseHandle(pi.hProcess);  

  return 0;
}



