# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: FreeBSD.mak,v 1.84 2001/05/31 20:03:50 stevek Exp $
#
# Build Files for Toolkit
#
# FreeBSD makefile defaults
#
#

#
# Platform variables
#
BUILDPLATFORM=FreeBSD
PLATFORMTARGET=UNIX
OSTARGET=FREEBSD
NULLDEV=/dev/null

OSSCRIPTEXT=
OSSCRIPTRUN=sh


#
# Path variables
#
BUILDDIR=freebsd
JNIINCDIR=freebsd
PATHSEP=:


#
# Binaries
#
JARFLAGS=
RANLIB=ranlib
LORDER=lorder
TSORT=tsort -q
LN=ln -f -s
RM=rm -f fobieqtz
MV=mv
CP=cp -f
MD=mkdir
NM=nm


#
# Compiler
#
CFLAGS += ${MYINCLUDES} ${MYCFLAGS}
CFLAGS += -pipe
CXXFLAGS += ${MYINCLUDES} ${MYCXXFLAGS}
CXXFLAGS += -pipe
PICFLAG=-fpic
COMPILE_CMD.s = $(AS) $(ASFLAGS)
COMPILE_CMD.S = $(CC) $(CFLAGS) $(ASFLAGS:%=-W,%) -c
COMPILE_CMD.c = $(CC) $(CFLAGS) -c
COMPILE_CMD.cxx = $(CXX) $(CXXFLAGS) -c
COMPILE_CMD.cc = $(CXX) $(CXXFLAGS) -c
PLATFORM_CPPDEF	= __FreeBSD__
CPPFLAGS = -E
ASMFLAGS = -S
OBJ=.o
SHOBJ=.so
SHOBJS=${OBJS:.o=.so} ${UNIX_SHOBJS} ${FREEBSD_SHOBJS}
MKDEP=mkdep
MKDEPOUT=


#
# Libraries
#
GCC_PIC=-lgcc_pic
LIBEXT=.a
LIBPRFX=lib
.if defined(NOLIBVERS)
SHLIBEXT=${SHOBJ}
.else
SHLIBEXT=${SHOBJ}.${SHLIB_MAJOR}.${SHLIB_MINOR}
.endif
PIC=_pic
PICLIBEXT=${PIC}${LIBEXT}
DLLIB=
 
LIB_LINK=${AR} -qc
LIB_OUT=${LIBRARY}
LIB_OBJS=`${LORDER} ${OBJS} ${LINKLIBS} | ${TSORT}`

.ifndef SHLIB_LINK_ONLYC
SHLIB_LINK_ONLYC=no
.endif

.if (${SHLIB_LINK_ONLYC} != "yes")
SHLIB_LINK=${CXX} -shared -Wl,-x ${SHLIB_FLAGS}
.else
SHLIB_LINK=${CC} -shared -Wl,-x ${SHLIB_FLAGS}
.endif
SHLIB_OUT=-o ${SHLIBRARY}
SHLIB_OBJS=`${LORDER} ${SHOBJS} ${SHLINKLIBS} | ${TSORT}` ${LDADD}

PICLIB_LINK=${AR} -qc
PICLIB_OUT=${PICLIBRARY}
PICLIB_OBJS=`${LORDER} ${SHOBJS} ${PICLINKLIBS} | ${TSORT}`


#
# Programs
#
PROG_LINK=${CXX} ${CXXFLAGS}
PROG_OUT=-o $@
PROG_OBJS=${LDFLAGS} ${OBJS} ${LDLIBS}
PROGEXT=


#
# Kernel modules
#
OSREL!=sysctl -n kern.osreldate
.if exists(/etc/objformat) && !defined(OBJFORMAT)
.include "/etc/objformat"
.endif
# Default executable format
OBJFORMAT?= elf
KLD_CAPABLE!=test ${OSREL} -gt 300000 && echo "yes" || echo "no"
KLD_DEPENDS!=test ${OSREL} -gt 500000 && echo "yes" || echo "no"
.if (${KLD_DEPENDS} != "no")
FREEBSD_LDFLAGS += ${FREEBSD5_LDFLAGS}
FREEBSD_LDLIBS += ${FREEBSD5_LDLIBS}
FREEBSD_LDADD += ${FREEBSD5_LDADD}
.endif
.if (${KLD_CAPABLE} != "yes") || (${OBJFORMAT} != "elf")
.ifdef VFS_KMOD
EXPORT_SYMS=_${KMOD}_mod
KMOD_EXT=_mod.o
.else
EXPORT_SYMS=_${KMOD}
KMOD_EXT=.o
.endif
PREGENERATE=true
BUILDSETS=true
KMOD_PREGENOBJS=
KMOD_LDLIBS_PRE=
KMOD_LDLIBS_POST=
KMOD_LDFLAGS=-r
.else
PREGENERATE=gensetdefs
BUILDSETS=${CC} ${CFLAGS} -c setdef0.c -o _setdef0.o; ${CC} ${CFLAGS} -c setdef1.c -o _setdef1.o
KMOD_LDLIBS_PRE=_setdef0.o
KMOD_LDLIBS_POST=_setdef1.o
KMOD_LDFLAGS=-Bshareable
KMOD_EXT=.ko
KMOD_LD=$(LD)
KMOD_MV=$(MV)
.if (${KLD_DEPENDS} != "yes")
KMOD_PREGENOBJS=
KMODDEPLINKSOLD=${KMODDEPENDS}
.else
KMOD_PREGENOBJS=${KMODDEPENDS}
KMODDEPLINKS=${KMODDEPENDS}
.endif
CLEANFILES += _setdef0.o _setdef1.o setdef0.c setdef1.c setdefs.h
.endif
KMOD_CATEGORY=
KMOD_LOAD=/sbin/kldload

