# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: Linux.mak,v 1.46 2001/06/14 13:51:23 stevek Exp $
#
# Build Files for Toolkit
#
# Linux makefile defaults
#

#
# Platform variables
#
BUILDPLATFORM=Linux
OSTARGET=LINUX
PLATFORMTARGET=UNIX
NULLDEV=/dev/null

OSSCRIPTEXT=
OSSCRIPTRUN=sh


#
# Path variables
#
BUILDDIR=linux
ifeq ($(shell test -d ${JAVAHOME}/include/genunix && echo yes),yes)
JNIINCDIR=genunix
else
JNIINCDIR=linux
endif

PATHSEP=:

#
# Binaries
#
JARFLAGS=
LORDER=echo
TSORT=cat
RANLIB=true
LN=ln -f -s
RM=rm -f
MV=mv
CP=cp -f
MD=mkdir
NM=nm


#
# Compiler
#
CFLAGS += ${MYINCLUDES} ${MYCFLAGS}
CFLAGS += -pipe
CXXFLAGS += ${MYINCLUDES} ${MYCXXFLAGS}
CXXFLAGS += -pipe
PICFLAG=-fpic
COMPILE_CMD.s = $(AS) $(ASFLAGS)
COMPILE_CMD.S = $(CC) $(CFLAGS) $(ASFLAGS:%=-W,%) -c
KERNEL_COMPILE_CMD.S = $(KCC) $(CFLAGS) $(ASFLAGS:%=-W,%) -c
COMPILE_CMD.c = $(CC) $(CFLAGS) -c
KERNEL_COMPILE_CMD.c = $(KCC) $(CFLAGS) -c
COMPILE_CMD.cxx = $(CXX) $(CXXFLAGS) -c
COMPILE_CMD.cpp = $(CXX) $(CXXFLAGS) -c
COMPILE_CMD.cc = $(CXX) $(CXXFLAGS) -c
PLATFORM_CPPDEF	= __linux__
CPPFLAGS = 
ASMFLAGS = -S
OBJ=.o
SHOBJ=.so
SHOBJS=${OBJS:.o=.so} ${UNIX_SHOBJS} ${LINUX_SHOBJS}
MKDEP=${CC} -E -M
MKDEPOUT=>.depend


#
# Libraries
#
GCC_PIC=
LIBEXT=.a
LIBPRFX=lib
ifeq (${strip ${NOLIBVERS}},)
SHLIBEXT=${SHOBJ}.${SHLIB_MAJOR}.${SHLIB_MINOR}
else
SHLIBEXT=${SHOBJ} 
endif
PIC=_pic
PICLIBEXT=${PIC}${LIBEXT}
DLLIB=-ldl

LIB_LINK=${AR} -qc
LIB_OUT=${LIBRARY}
LIB_OBJS=`${LORDER} ${OBJS} | ${TSORT}`

SHLIB_LINK=${CXX} -shared -Wl,-x ${SHLIB_FLAGS}
SHLIB_OUT=-o ${SHLIBRARY}
SHLIB_OBJS=`${LORDER} ${SHOBJS} ${SHLINKLIBS} | ${TSORT}` ${LDADD}

PICLIB_LINK=${AR} -qc
PICLIB_OUT=${PICLIBRARY}
PICLIB_OBJS=`${LORDER} ${SHOBJS} | ${TSORT}`


#
# Programs
#
PROG_LINK=${CXX}
PROG_OUT=-o $@
PROG_OBJS=${LDFLAGS} ${OBJS} ${LDLIBS}
PROGEXT=


#
# Kernel modules
#
KMOD_EXT=.o
EXPORT_SYMS=
PREGENERATE=true
BUILDSETS=true
KMOD_LDLIBS_PRE=
KMOD_LDLIBS_POST=
KMOD_LDFLAGS=-r
KMOD_LD=$(LD)
KMOD_MV=$(MV)
KMOD_CATEGORY?=${LINUX_KMOD_CATEGORY}
KMOD_LOAD=/sbin/insmod

