# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: Windows_NT.mak,v 1.85 2001/05/31 20:03:50 stevek Exp $
#
# Build Files for Toolkit
#
# Windows NT/2000 makefile defaults
#

#
# Platform variables
#
BUILDPLATFORM=Windows_NT
OSTARGET=WINNT
PLATFORMTARGET=
NULLDEV=NUL
OSVERS=$(patsubst CYGWIN_NT-%.0,%,$(shell uname -s))

OSSCRIPTEXT=.bat
OSSCRIPTRUN=cmd.exe /C


#
# Path variables
#
BUILDDIR=Windows_NT
LIBPATH=${LIB}
JNIINCDIR=win32
PATHSEP=;


#
# Binaries
#
CCC=$(CXX)
JARFLAGS=
RANLIB=echo
RC=RC /R
LN=cp -r
LD=link
RM=rm -f
CP=cp -f
MD=mkdir
NM=dumpbin /symbols


#
# Compiler
#
CFLAGS		+= ${MYINCLUDES} ${MYCFLAGS}
CXXFLAGS	+= ${MYINCLUDES} ${MYCXXFLAGS}

ifeq ("gcc",${CCNAME})
CFLAGS		+= -mwindows -c -D_WIN32_WINNT=0x0${OSVERS}00 -g
CXXFLAGS	+= -mwindows -c -D_WIN32_WINNT=0x0${OSVERS}00 -g
else
CFLAGS		+= -nologo /c -D_WIN32_WINNT=0x0${OSVERS}00 /MTd /Zi /W3
CXXFLAGS	+= -nologo /c -D_WIN32_WINNT=0x0${OSVERS}00 /MTd /GX /Zi /W3
endif
CCFLAGS		= $(CXXFLAGS)
COMPILE_CMD.s	= $(AS) $(ASFLAGS)
COMPILE_CMD.S	= $(AS) $(ASFLAGS)
COMPILE_CMD.c	= $(CC) $(CFLAGS)
COMPILE_CMD.cxx	= $(CXX) $(CXXFLAGS)
ifeq ("gcc",${CCNAME})
COMPILE_CMD.cc	= $(CXX) $(CXXFLAGS)
COMPILE_CMD.cpp	= $(CXX) $(CXXFLAGS)
CPPFLAGS	= -E
OBJ		= .o
SHOBJ		= .so
MKDEP		= ${CC} -E -M
MKDEPOUT	= >.depend
else
COMPILE_CMD.s	= $(AS) $(ASFLAGS)
COMPILE_CMD.S	= $(AS) $(ASFLAGS)
COMPILE_CMD.cc	= $(CXX) $(CXXFLAGS) /TP
COMPILE_CMD.cpp	= $(CXX) $(CXXFLAGS) /TP
CPPFLAGS	= /E
OBJ		= .obj
SHOBJ		= .sobj
MKDEP		= ${PERL} -- ${TOPDIR}/mak/mkdep-msvc.pl
MKDEPOUT	= >.depend
endif
PLATFORM_CPPDEF	=
ASMFLAGS =
SHOBJS=${OBJS:.obj=.sobj} ${WINNT_SHOBJS}


#
# Libraries
#
SHLIBEXT=.dll
ifeq ("gcc",${CCNAME})
LIBEXT=.a
LIBPRFX=lib
WINLIBS=-luser32 -lole32
else
LIBEXT=.lib
LIBPRFX=
WINLIBS=user32.lib ole32.lib
endif
DLLIB=

LIB_LINK=lib /NOLOGO
LIB_OUT=/OUT:${LIBRARY}
LIB_OBJS=${OBJS} ${LDLIBS}

ifeq ("gcc",${CCNAME})
LIB_LINK=ar rcu
LIB_OUT=${LIBRARY}
LIB_OBJS=${OBJS}

SHLIB_LINK=${CC} -Wl,--out-implib,lib${LIBBASE}.import.a -shared
SHLIB_OUT=-o ${SHLIBRARY}
else
LIB_LINK=lib /NOLOGO
LIB_OUT=/OUT:${LIBRARY}
LIB_OBJS=${OBJS} ${LDLIBS}

SHLIB_LINK=link /NOLOGO /DLL /DEBUG
SHLIB_OUT=/OUT:${SHLIBRARY}
endif
SHLIB_OBJS=${SHOBJS} ${WINLIBS} ${LDLIBS} ${SHLINKLIBS}


#
# Programs
#
PROG_LINK=link /NOLOGO /DEBUG
PROG_OUT=/OUT:$@
PROG_OBJS=${OBJS} ${LDFLAGS} ${LDLIBS}
PROGEXT=.exe


#
# Kernel modules
#
EXPORT_SYMS=
KMOD_EXT=
PREGENERATE=lib /NOLOGO /OUT:${LIBPRFX}${KMOD_TARGET}${LIBEXT}
KMOD_LD=@echo
KMOD_LD_POST=>NUL
KMOD_MV=@echo
KMOD_MV_POST=>NUL
BUILDSETS=@echo
KMOD_CATEGORY=

