# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# Build Files for Toolkit
#
# Common makefile defaults for GNU make
#
# $Id: common.mak.GNU,v 1.13 2001/04/05 18:40:49 stevek Exp $
#

ifeq (${COMMONMAK},)
COMMONMAK=included

MAKEFLAGS	+= --no-print-directory

ifeq (${TOPDIR},)
${error TOPDIR must be defined}
endif

BASEDIR=${shell ${TOPDIR}/mak/subdir}

ifeq (${shell test -d ${TOPDIR}/perl && echo "yes"},yes)
ifeq (${PERLLIB},)
PERLLIB = ${TOPDIR}/perl
else
PERLLIB = ${PERLLIB}${PATHSEP}${TOPDIR}/perl
endif
endif

ifneq (${${OSTARGET}_OBJS},)
OBJS += ${${OSTARGET}_OBJS}
endif
ifneq (${${PLATFORMTARGET}_OBJS},)
OBJS += ${${PLATFORMTARGET}_OBJS}
endif

ifneq (${${OSTARGET}_SHLINKLIBS},)
SHLINKLIBS += ${${OSTARGET}_SHLINKLIBS}
endif
ifneq (${${PLATFORMTARGET}_SHLINKLIBS},)
SHLINKLIBS += ${${PLATFORMTARGET}_SHLINKLIBS}
endif

ifneq (${${OSTARGET}_CFLAGS},)
CFLAGS += ${${OSTARGET}_CFLAGS}
endif
ifneq (${${PLATFORMTARGET}_CFLAGS},)
CFLAGS += ${${PLATFORMTARGET}_CFLAGS}
endif

ifneq (${${OSTARGET}_CXXFLAGS},)
CXXFLAGS += ${${OSTARGET}_CXXFLAGS}
endif
ifneq (${${PLATFORMTARGET}_CXXFLAGS},)
CXXFLAGS += ${${PLATFORMTARGET}_CXXFLAGS}
endif

ifneq (${${OSTARGET}_LDFLAGS},)
LDFLAGS += ${${OSTARGET}_LDFLAGS}
endif
ifneq (${${PLATFORMTARGET}_LDFLAGS},)
LDFLAGS += ${${PLATFORMTARGET}_LDFLAGS}
endif

ifneq (${${OSTARGET}_LDLIBS},)
LDLIBS += ${${OSTARGET}_LDLIBS}
endif
ifneq (${${PLATFORMTARGET}_LDLIBS},)
LDLIBS += ${${PLATFORMTARGET}_LDLIBS}
endif

ifneq (${${OSTARGET}_LDADD},)
LDADD += ${${OSTARGET}_LDADD}
endif
ifneq (${${PLATFORMTARGET}_LDADD},)
LDADD += ${${PLATFORMTARGET}_LDADD}
endif

ifneq (${${OSTARGET}_SUBDIR},)
SUBDIR += ${${OSTARGET}_SUBDIR}
endif
ifneq (${${PLATFORMTARGET}_SUBDIR},)
SUBDIR += ${${PLATFORMTARGET}_SUBDIR}
endif

ifneq (${${OSTARGET}_SUBDIR_POST},)
SUBDIR_POST += ${${OSTARGET}_SUBDIR_POST}
endif
ifneq (${${PLATFORMTARGET}_SUBDIR_POST},)
SUBDIR_POST += ${${PLATFORMTARGET}_SUBDIR_POST}
endif

ifneq (${${OSTARGET}_PRETARGET},)
PRETARGET += ${${OSTARGET}_PRETARGET}
endif
ifneq (${${PLATFORMTARGET}_PRETARGET},)
PRETARGET += ${${PLATFORMTARGET}_PRETARGET}
endif

ifneq (${${OSTARGET}_POSTTARGET},)
POSTTARGET += ${${OSTARGET}_POSTTARGET}
endif
ifneq (${${PLATFORMTARGET}_POSTTARGET},)
POSTTARGET += ${${PLATFORMTARGET}_POSTTARGET}
endif

ifneq (${${OSTARGET}_PRETARGETCLEAN},)
PRETARGETCLEAN += ${${OSTARGET}_PRETARGETCLEAN}
endif
ifneq (${${PLATFORMTARGET}_PRETARGETCLEAN},)
PRETARGETCLEAN += ${${PLATFORMTARGET}_PRETARGETCLEAN}
endif

ifneq (${${OSTARGET}_PRETARGETTEST},)
PRETARGETTEST += ${${OSTARGET}_PRETARGETTEST}
endif
ifneq (${${PLATFORMTARGET}_PRETARGETTEST},)
PRETARGETTEST += ${${PLATFORMTARGET}_PRETARGETTEST}
endif

ifneq (${${OSTARGET}_PRETARGETPOSTTEST},)
PRETARGETPOSTTEST += ${${OSTARGET}_PRETARGETPOSTTEST}
endif
ifneq (${${PLATFORMTARGET}_PRETARGETPOSTTEST},)
PRETARGETPOSTTEST += ${${PLATFORMTARGET}_PRETARGETPOSTTEST}
endif

endif

