# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# Build Files for Toolkit
#
# Windows NT/2000 driver makefile defaults
#
# $Id: driver-Windows_NT.mak,v 1.9 2001/04/30 20:17:52 stevek Exp $
#
# Makefile variables:
#
# [Required]
#	TOPDIR		: Path to the top of the source tree
#
#	DRIVER		: Name of the output driver (minus the .sys extension)
#	OBJS		: List of object files to build from source
#
# [Optional]
#	CPPFLAGS	: Additional C preprocessor flags to pass on the
#			  command line
#	CFLAGS		: Additional C compiler flags to pass on the command
#			  line
#	LDFLAGS		: Additional flags to pass to the linker on the
#			  command line
#	LDLIBS		: Additional libraries to link against
#

include ${TOPDIR}/mak/common.mak

OBJMAK = pre
include ${TOPDIR}/mak/obj.mak.${MAKEINC}

.SUFFIXES: .c .i ${OBJ}

CFLAGS += -I ${TOPDIR}/include
CFLAGS += -I ${DDKPATH}/inc
CFLAGS += -D_X86_=1 -Di386=1 -DSTD_CALL -DCONDITION_HANDLING=1 -DNT_UP=1
CFLAGS += -DNT_INST=0 -DWIN32_LEAN_AND_MEAN=1 -DDEVL=1 -DFPO=1 -DNDEBUG
CFLAGS += -D_DLL=1 -D_IDWBUILD
CFLAGS += /c /Zel /Zp8 /Gy -cbstring /W3 /Gz /QIfdiv- /QIf /Gi- /Gm- /GX-
CFLAGS += /GR- /GF /Oxs /Oy -FI${DDKPATH}/inc/warning.h

LDFLAGS += -MERGE:_PAGE=PAGE -MERGE:_TEXT=.text -SECTION:INIT,d
LDFLAGS += -OPT:REF -INCREMENTAL:NO -FORCE:MULTIPLE -RELEASE -FULLBUILD
LDFLAGS += -IGNORE:4001,4037,4039,4065,4070,4078,4087,4089,4096
LDFLAGS += -NODEFAULTLIB -debug:notmapped,MINIMAL -debugtype:coff -PDB:NONE
LDFLAGS += -MERGE:.rdata=.text -optidata -driver -align:0x20
LDFLAGS += -subsystem:native,4.00 -base:0x10000 -entry:DriverEntry@8

LDLIBS	+= ${DDKPATH}/lib/i386/free/int64.lib
LDLIBS	+= ${DDKPATH}/lib/i386/free/ntoskrnl.lib
LDLIBS	+= ${DDKPATH}/lib/i386/free/hal.lib

OUTPUT = ${DRIVER}.sys

all: ${OUTPUT}

clean:
	${RM} ${OUTPUT} ${OBJS}

install:

release:

test:

posttest:

${OUTPUT}: ${OBJS}
	${PROG_LINK} ${PROG_OUT} ${PROG_OBJS}

.c.i:
	${RM} $@
	${COMPILE.c} ${INCLUDES} ${CPPFLAGS} $< > $@

.c${OBJ}:
	${COMPILE.c} ${INCLUDES} $<

install-driver: ${OUTPUT}
	instdrv ${DRIVER} ${subst \,\\,${shell cygpath -w ${shell pwd}/${OUTPUT}}}

remove-driver: ${OUTPUT}
	instdrv ${DRIVER} remove

OBJMAK = post
include ${TOPDIR}/mak/obj.mak.${MAKEINC}

