# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# Build Files for Toolkit
#
# Java(tm) package makefile rules for GNU make
#
# $Id: javapkg.mak.GNU,v 1.7 2001/04/05 18:40:49 stevek Exp $
#
# Makefile variables:
#

JAVA2_PLATFORM = ${shell test "${JAVAMAJOR}" -gt 1 -o "${JAVAMINOR}" -ge 2 && echo "yes" || echo "no"}

ifeq "${JAVA2_PLATFORM}" "yes"
ifdef JAVA2_MANIFEST
MANIFEST = ${JAVA2_MANIFEST}
endif
else
ifdef JAVA1_MANIFEST
MANIFEST = ${JAVA1_MANIFEST}
endif
endif

${ARCHIVE}: SUBDIRS
	@echo "Constructing JAR file ${ARCHIVE}"
	@${RM} ${ARCHIVE}
	@touch ${ARCHIVE}
ifdef MANIFEST
ifeq "${JAVA2_PLATFORM}" "yes"
	@grep "Name:" ${MANIFEST} | awk '{ print $$2 }' | \
	   xargs ${JAR} ${JARFLAGS} -ufm ${ARCHIVE} ${MANIFEST}
else
	@${JAR} ${JARFLAGS} -c0fm ${ARCHIVE} ${MANIFEST} \
	   `grep "Name:" ${MANIFEST} | awk '{ print $$2 }'`;
endif
else
ifeq "${JAVA2_PLATFORM}" "yes"
	@${JAR} ${JARFLAGS} -c0f ${ARCHIVE} `echo "${JAR_CONTENTS}" | \
	   awk '{ print $$1; }' | \
	   sed -e 'y/./\//' -e 's/\*class/\*.class/g'`;
	@(for a in `echo "${JAR_CONTENTS}" | \
	   sed -e 'y/./\//' -e 's/\*class/\*.class/g'`; do echo "$$a"; \
	   done; \
	 if [ ! -z "${JARCONTENTS}" ]; then echo "${JARCONTENTS}"; fi) | \
	xargs ${JAR} ${JARFLAGS} -uf ${ARCHIVE};
else
	@${JAR} ${JARFLAGS} -c0f ${ARCHIVE} `echo "${JAR_CONTENTS}" | \
	   sed -e 'y/./\//' -e 's/\*class/\*.class/g'`;
endif
endif

