#!/usr/bin/perl

sub processFile {
   my( $flags, $filename ) = @_;

   open( CPP, "cl /nologo /E $flags $filename |" ) || die "$filename: $!";
   my %files;
   while( <CPP> ) {
      next unless /^#line \d+ "(.*)"/ && lc($1) ne lc($filename);

      my $path = lc($1);
      $path =~ s{ ^(\S): |
                  (\\+)
                }
                { if($1)    { '/cygdrive/'.lc($1) }
                  elsif($2) {'/' }
                }gex;
      next if exists $files{$path};
      $files{$path} = undef;
   }
   close( CPP );

   my $nfiles;
   foreach( sort keys %files ) {
      if( $nfiles++ ) {
         print " \\\n\t";
      }
      else {
         print $filename . ": ";
      }
      print '"' . $_ . '"';
   }
   print "\n" if $nfiles;
}

my @flags;
while( @ARGV ) {
   last unless $ARGV[0] =~ /^[-\/]\S/;

   ($ARGV[0] =~ /^[-\/]I$/) && do { push( @flags, shift @ARGV ) };

   push( @flags, shift @ARGV );
}
my $flags = join(' ',@flags);

foreach( @ARGV ) {
   processFile($flags, $_);
}

