# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# Build Files for Toolkit
#
# Program makefile rules
#
# $Id: prog.mak,v 1.45 2001/04/09 22:30:08 stevek Exp $
#
# Makefile variables:
#
# [Required]
#	PROG		: Base name of the executable (any platform-applicable
#			  extensions will be added automatically)
#	OBJS		: Object files to build from source
#	COPYBINDIR	: Path where to copy resultant exectable
#			  (Typically set by the configure script)
#
# [Optional]
#	CFLAGS		: Additional flags to pass to the C compiler on the
#			  command line
#	CXXFLAGS	: Additional flags to pass to the C++ compiler on the
#			  command line
#
#	PROGDEPENDS	: Files and targets depended on by the executable
#
#	PRETARGET	: Targets to invoke before building the executable
#
#	LDFLAGS		: Additional flags to pass to the linker on
#			  the command line
#	LDADD		: Additional files to link against when
#			  constructing the executable
#	LDLIBS		: Additional libraries to link against when
#			  constructing the executable
#
#	INSTALL_TARGET	: Dependency targets to invoke on install
#

include ${TOPDIR}/mak/common.mak

PROGMAK = pre
include ${TOPDIR}/mak/prog.mak.${MAKEINC}

CFLAGS += -I ${TOPDIR}/include
CXXFLAGS += -I ${TOPDIR}/include

.PHONY: all clean install release ${BUILDPLATFORM}

all: ${PRETARGET} ${PROG}${PROGEXT}

clean: ${PRETARGETCLEAN}
	${RM} ${PROG}${PROGEXT} ${OBJS} ${CLEANFILES}
	${RM} ${COPYBINDIR}/${PROG}${PROGEXT}

install: ${INSTALL_TARGET}
	@if [ -z "${INSTALLDIR}" ]; then \
	   if [ "${INSTALLSBIN}" = yes ]; then \
	      INSTALLDIR="${SBINDIR}"; export INSTALLDIR; \
	   else \
	      INSTALLDIR="${BINDIR}"; export INSTALLDIR; \
	   fi; \
	else \
	   INSTALLDIR="${INSTALLDIR}"; export INSTALLDIR; \
	fi; \
	if [ ! -z "${INSTALLROOT}" ]; then \
	   INSTALLDIR="${INSTALLROOT}/$${INSTALLDIR}"; export INSTALLDIR; \
	fi; \
	if [ ! -d "$${INSTALLDIR}" ]; then \
	   ${SHELL} -c "${TOPDIR}/mak/mkdirhier \"$${INSTALLDIR}\""; \
	fi; \
	echo "${CP} ${PROG}${PROGEXT} \"$${INSTALLDIR}\""; \
	${CP} ${PROG}${PROGEXT} "$${INSTALLDIR}"

release:

${PROG}${PROGEXT}: ${PROGDEPENDS} ${OBJS}
	${PROG_LINK} ${PROG_OUT} ${PROG_OBJS}
	@echo Copying executable to shared bin directory
	@if [ ! -d ${COPYBINDIR} ]; then \
		${TOPDIR}/mak/mkdirhier ${COPYBINDIR}; \
	fi
	${CP} ${PROG}${PROGEXT} ${COPYBINDIR}

include ${TOPDIR}/mak/obj.mak

PROGMAK = post
include ${TOPDIR}/mak/prog.mak.${MAKEINC}

