/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * $Id: eventfs_pipe.h,v 1.10 2001/02/23 19:02:16 stevek Exp $
 */

#ifndef __EVENTFS_PIPE_H
#define __EVENTFS_PIPE_H 1

#include <pipesrv.h>

extern HANDLE g_hServerStopEvent;

#define PAGE_SIZE 4096

#define HEARTBEAT_TIMEOUT 2000L

typedef struct _EVENTFS_DATA_STREAM EVENTFS_DATA_STREAM,
                                    * LPEVENTFS_DATA_STREAM;
typedef struct _EVENTFS_GROUP_DATA  EVENTFS_GROUP_DATA,
                                    * LPEVENTFS_GROUP_DATA;
typedef struct _EVENTFS_STREAM_DATA EVENTFS_STREAM_DATA,
                                    * LPEVENTFS_STREAM_DATA;
struct _EVENTFS_DATA_STREAM
{
   struct eventfs_stream *pES;
   HANDLE                 hSema;
};

struct _EVENTFS_GROUP_DATA
{
   LPPIPESRV_QUEUE_INFO  pqiStats;
   LPPIPESRV_QUEUE_INFO  pqiIoctl;
};

struct _EVENTFS_STREAM_DATA
{
   LPPIPESRV_QUEUE_INFO  pqiStats;
   LPPIPESRV_QUEUE_INFO  pqiData;
};


void EventFSCloseStreamData          ( LPPIPESRV_PIPE_INFO );
BOOL EventFSOpenStreamData           ( LPPIPESRV_PIPE_INFO );
BOOL EventFSProcessGroupIoctlPacket  ( LPPIPESRV_PIPE_INFO );
BOOL EventFSProcessGroupStatusPacket ( LPPIPESRV_PIPE_INFO );
BOOL EventFSProcessStreamDataPacket  ( LPPIPESRV_PIPE_INFO );
BOOL EventFSProcessStreamStatusPacket( LPPIPESRV_PIPE_INFO );
BOOL EventFSWritePacket              ( LPPIPESRV_PIPE_INFO, PVOID, size_t );

#endif /* __EVENTFS_PIPE_H */

