/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: EventMap.java,v 1.5 2001/04/05 18:40:59 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 */

package com.eventfs;

import java.util.*;

public class EventMap extends Hashtable
{
	// Constructors
	public EventMap() { super(); }
	public EventMap(int cap) { super(cap); }
	public EventMap(int cap, float loadFactor) { super(cap,loadFactor); }

	// Public methods
	public void remap( String key, Integer mask ) throws NullPointerException, IllegalArgumentException
	{
		if( key == null )
			throw new NullPointerException( "Invalid key" );
		if( mask == null )
			throw new NullPointerException( "Invalid mask" );

		Object o = get(key);
		if( o == null )
			throw new IllegalArgumentException( "Invalid key" );
		remove(key);
		put(mask, o);
	}
}

