/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * $Id: TestEventTypeTable.java,v 1.9 2001/04/05 18:41:01 stevek Exp $
 */

import java.io.*;
import com.eventfs.EventGroup;
import com.eventfs.EventManager;
import com.eventfs.EventTypeTable;

public class TestEventTypeTable
{
	public TestEventTypeTable() throws Exception
	{
		EventManager em = EventManager.getEventManager();

		// Note: even though we are using the EventGroup class here,
		//       it is only as a container for the group name
		EventGroup eg = new EventGroup( TestConstants.GROUP );

		InputStream is = em.openGroupStats(eg);
		EventTypeTable ett = new EventTypeTable( is );
		System.out.println(ett.toString());
		System.out.println("<<<PASSED>>>");
	}

	public static void main( String args[] )
	{
		try
		{
			new TestEventTypeTable();
		}
		catch( Exception e )
		{
			e.printStackTrace(System.out);
		}
	}
}


