/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * $Id: testioctl.c,v 1.3 2001/02/23 19:02:18 stevek Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <sys/fcntl.h>

#include "../../../eventfs_ioctl.h"

FILE *f = NULL;

void
myexit()
{
   if( f )
   {
      printf( "Closing descriptor\n" );
      fclose( f );
   }
}

int
main( int argc, char *argv[] )
{
   char buf[4096];
   int mask = 0;

   FILE *f = fopen( "/event/efstest/stats", "r" );
   if( f == NULL )
   {
      perror( "fopen" );
      return errno;
   }

   atexit( myexit );

   fscanf( f, "%s\n", buf );
   printf( "Reading stats for %s\n", buf );

   while( !feof(f) )
   {
      int id;
      fscanf( f, "%d\t%s\n", &id, buf );

      printf( "%5d | %s\n", id, buf );

      mask |= id;
   }

   if( mask )
   {
      struct eventfs_request req;

      printf( "\nRequesting stream to handle mask 0x%x\n", mask );

      req.mask = mask;
      if( ioctl( fileno(f), EFSIOCREQ, &req ) )
         perror( "ioctl" );
      else
         printf( "Resulting stream '%s'\n", req.name );
   }

   return 0;
}

