/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * $Id: testread.c,v 1.4 2001/02/23 19:02:18 stevek Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <sys/fcntl.h>

int f;

void
myexit()
{
   printf( "Closing stream\n" );
   close( f );
}

int
main( int argc, char *argv[] )
{
   char buf[4096];

   int f = open( "/event/efstest/raw/data", O_RDONLY );
   if( f < 0 )
   {
      perror( "open" );
      return errno;
   }

   atexit( myexit );

   printf( "Opened stream\n" );
   while( 1 )
   {
      int nr;

      printf( "Reading\n" );
      if( ( nr = read( f, buf, 4096 ) ) < 0 )
         perror( "read" );
      else
      {
         printf( "Read %d bytes from stream\n", nr );
         if( nr == 4096 )
            continue;
      }

      printf( "Sleeping\n" );
      sleep( 60 );
   }

   return 0;
}

