/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * $Id: eventfs_linux.h,v 1.13 2001/06/21 17:25:41 stevek Exp $
 */

#ifndef __EVENTFS_LINUX_H
#define __EVENTFS_LINUX_H 1

#define   _PATH_EVENTFS   "/proc/eventfs"      /* Default mountpoint */

#ifdef PD_IN_KERNEL
#include <linux/malloc.h>
#include <linux/string.h>

#define EFS_MALLOC(v,t,s) ((v) = (t)kmalloc((s),GFP_KERNEL))
#define EFS_FREE(v) kfree(v)

#define printf(s, args...) printk(s, ## args)
#define eventfs_sprintf(buf, s, args...) sprintf((buf),s, ## args)

#else /* PD_IN_KERNEL */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <sys/ioctl.h>

#endif /* PD_IN_KERNEL */


struct eventfs_request
{
    unsigned long       mask;
    char                name[MAXNAMELEN];
};

enum eventfs_ioctl_cmds {
    /* 1 and 2 are taken by default IOCTL's.  Huh? */
    EFSIOCREQ   = 5
};

#endif /* __EVENTFS_H */

