package BinFile;
# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: BinFile.pm,v 1.9 2001/04/05 18:41:11 stevek Exp $

require 5.004;
use strict;
use vars qw($VERSION @ISA @EXPORT);
use Carp;

$VERSION = 0.001;
@ISA     = qw(Exporter);
@EXPORT  = qw(BINFILE_LOADSTRINGS BINFILE_LOADSYMS);

sub new {
   my $this = shift;
   my $class = ref($this) || $this;
   my $file = shift;
   my $options = @_?shift:0;
   my $self = {};
   bless $self, $class;
   $self->_initialize($file, $options);
}

sub _initialize {
   my $self = shift;
   my $file = shift;
   my $options = shift;

   my $fd;
   if( ref($file) ) {
      *fd = $file;
   }
   else {
      croak "File not found" unless -f $file;

      open(*fd, $file) || croak "$!";
   }

   $self->{'Descriptor'} = \*fd;
   $self->{'Options'} = $options;
   $self->{'Header Strings'} = undef;
   $self;
}

sub format ($) { "Unknown"; }

sub dumpheader ($) {
   my $this = shift;
   print '['.$this->format.' Header]'."\n";
}

sub hdrstr {
   my $this = shift;
   $this->{'Header Strings'} = shift if @_;
   $this->{'Header Strings'};
}

sub findSymbols {
}

sub BINFILE_LOADSTRINGS { 0x0001; }
sub BINFILE_LOADSYMS    { 0x0002; }

1;
