package BinFile::AutoDetect;
# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: AutoDetect.pm,v 1.7 2001/04/05 18:41:11 stevek Exp $

require 5.004;
use strict;
use vars qw($VERSION @ISA @EXPORT);
use Carp;
use BinFile::ELF;
use BinFile::PE;

$VERSION = 0.001;
@ISA     = qw(Exporter);
@EXPORT  = qw();

my $debuglevel = 0;
sub debug {
   if(@_) { $debuglevel = $_[0]; }
   else   { $debuglevel++; }
   $debuglevel;
}

sub new {
   my $this = shift;
   my $class = ref($this) || $this;
   my $file = shift;
   my $options = @_?shift:0;

   my $self;
   $self = eval { new BinFile::ELF($file,$options); };
   carp $@ if $@ && ($debuglevel>0);
   $self = eval { new BinFile::PE($file,$options); } unless ref($self);
   carp $@ if $@ && ($debuglevel>0);
   croak $file.': Unknown binary format' unless ref($self);
   $self;
}

1;
