
package BinFile::DOS::EXE;
# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: EXE.pm,v 1.7 2001/04/05 18:41:12 stevek Exp $

require 5.004;
use strict;
use vars qw($VERSION @ISA @EXPORT);
use Carp;
use BinFile;
use BinFile::DOS::EXE::Header;
use IO::Seekable;

$VERSION = 0.001;
@ISA     = qw(BinFile);
@EXPORT  = qw();

sub new {
   my $this = shift;
   my $class = ref($this) || $this;
   my $file = shift;
   my $options = shift;
   my $self = {};
   bless $self, $class;
   $self->_initialize( $file, $options );
}

sub _initialize {
   my $self = shift;
   my $file = shift;
   my $options = shift;

   # Initialize BinFile
   $self->SUPER::_initialize( $file, $options );

   my $fd;
   *fd = $self->{'Descriptor'};
   my $dosHeader = loadDosExeHeader( \*fd );
   croak "Not a DOS EXE file" unless $dosHeader->signature eq "MZ";

   $self->{'DOS Header'} = $dosHeader;
   $self;
}

sub format ($) { "DOS Executable"; }

sub dosheader {
   my $this = shift;
   $this->{'DOS Header'};
}

1;
