package BinFile::SymbolTable;
# 
# Copyright (C) 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: SymbolTable.pm,v 1.6 2001/01/19 18:30:12 stevek Exp $
#
require 5.004;
use strict;
use vars qw(@ISA $VERSION);
use Exporter;
use Carp;
use IO::Seekable;

@ISA     = qw(Exporter);

$VERSION = 0.001;

sub new {
   my $this = shift;
   my $class = ref($this) || $this;
   my $self = {};
   bless $self, $class;
   $self->_initialize;
}

sub _initialize ($) {
   my $self = shift;
   $self->{'Symbols'} = [];
   $self->{'Symbol Names'} = {};
   $self;
}

sub addsymbol ($$) {
   my $this = shift;
   my $symbol = shift;
   croak 'Not a valid symbol class' unless $symbol->isa('BinFile::Symbol');
   push(@{$this->symbols}, $symbol);
   $this->names->{$symbol->name} = $symbol if $symbol->name;
   $symbol;
}

sub names ($) {
   my $this = shift;
   $this->{'Symbol Names'};
}

sub symbols ($) {
   my $this = shift;
   $this->{'Symbols'};
}

sub lookup ($$) {
   my $this = shift;
   $this->symbols->{shift};
}

sub search ($$) {
   my $this = shift;
   my $key = shift;
   my @results;
   while( my( $name, $sym ) = each %{$this->names} ) {
      push( @results, $sym ) if $name =~ /$key/;
   }
   @results;
}

sub dump ($) {
   my $this = shift;
   printf("[Symbol Table]\n");
   foreach( @{$this->symbols} ) {
      $_->dump;
   }
}

1;
