#!/usr/local/bin/perl
# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: decode.pl,v 1.4 2001/04/05 18:41:15 stevek Exp $

require 5.003;
use strict;
use CPU::x86::Opcodes qw(:FIELDS);
use Data::Dumper;

my $lookup;
my $patterns;

printf("%8s %8s\n", "Mask", "Pattern");
foreach( @$x86_opcodes ) {
   my( $opcode, $mode, $bits ) = @$_;

   my @bits = map(chr, unpack("C*", $bits));

   my( $mask, $pattern, $bit );
   foreach $bit ( @bits ) {
      $mask <<= 1;
      $pattern <<= 1;
      $pattern |= 1 if $bit eq '1';
      $mask |= 1 if $bit =~ /[01]/;
   }

   printf("%8x %8x\n", $mask, $pattern);
   $lookup->{$mask} = undef unless exists $lookup->{$mask};
   $lookup->{$mask}->{$pattern} = $_;
}

print "\n\nMasks:\n";
foreach( sort { $a <=> $b } keys %$lookup ) {
   printf("%8x\n", $_);
}

