#!/usr/bin/perl -w

use strict;

use BinFile;
use BinFile::AutoDetect;

# &BinFile::AutoDetect::debug;

(print STDERR "Usage: search.pl <bin> <symbol pattern>\n"), exit
   unless @ARGV == 2;

my $file = $ARGV[0];
my $pattern = $ARGV[1];

(warn "Missing or unknown file: $_"), exit unless -f $file;

print '--[ '.$file.' ]--'."\n";
my $f = new BinFile::AutoDetect($file, BINFILE_LOADSYMS);
print 'Format: ' . $f->format . "\n";
my @results = $f->search( $pattern );
print "No matches found.\n" unless @results;
foreach( @results ) {
   $_->dump;
}

