/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: dbi.h,v 1.13 2001/02/23 19:02:22 stevek Exp $
 *
 * Author: Lee Badger
 *
 * Interface with the parser.
 */

typedef struct order_clause {
        int         order_field;
        int         decending;       
} *wqoc_t;

enum cmds { create_c, drop_c, insert_c, select_c, delete_c, update_c };
typedef struct parse_result {
	union result {
                struct {
                    wqcd_t	create;
                    int         col_count;
                } c;
		wqrow_t	insert;
                /* Sorry for the mess.  Select needs more info than fits in
                 * just the selection criteria.  I suppose I should put that
                 * layer of indirection elsewhere, but then it wouldn't map
                 * to the wss_select API
                 */
                struct {
                    wqsx_t	select;
                    wqoc_t      order;
                } s;
                struct {
                    wqsx_t      select;
                    wqusl_t     update;
                } u;
		/* more */
	} r;

	enum cmds cmd;
} *pres_t;

int wr_parse_dbi_command(struct parse_result *res, char *str, enum cmds cmd);
extern vm_offset_t wss_vm_data;
#define abs2rel(addr)   ((char*)((char*)(addr) - (char*)wss_vm_data))
#define rel2abs(addr)   ((char*)((char*)(addr) + (int)wss_vm_data))

