/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: jwreview.java,v 1.6 2001/04/05 18:41:17 stevek Exp $
 *
 * Java version of the Wrapper event stream viewer
 *
 * Author: Steve Kiernan
 *
 */

import com.gswtk.wrapper.event.*;

public class jwreview
{
	// Constructors
	public jwreview() throws Exception
	{
		RawEventStream res = new RawEventStream();

		res.addWrapperEventGroupEventListener(
		   new WrapperEventGroupEventListener() {
			public void wrapperEventGroupEventOccurred( WrapperEventGroupEvent wege ) {
				System.out.println(wege.toString());
			}
		   } );

		try
		{
			res.listen();
			this.waitAround();
		}
		catch( Exception e )
		{ }
	}

	public synchronized void waitAround() throws Exception
	{
		System.out.println( "Waiting for events..." );
		wait();
	}

	// Public methods
	public static void main( String args[] )
	{
		try
		{
			new jwreview();
		}
		catch( ExceptionInInitializerError e )
		{
			System.err.println( "ExceptionInInitializerError:\n" );
			e.getException().printStackTrace( System.err );
		}
		catch (Throwable e)
		{
			System.out.println("Caught exception: " + e.toString());
		}
	}
}
