/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wrdisable.c,v 1.1 2001/06/22 03:56:24 stevek Exp $
 *
 * Author: Chris Vance
 *
 * Purpose: User-space program to disable criteria
 */

#define LINKAGE IMPORT

#include <wr_conf.h>

#include <stdio.h>
#include <stdlib.h>

#include <libwrmod.h>

void
usage()
{
   fprintf( stderr, "Usage: wrdisable <id> [<id1> .. <idn>]\n" );
}

/*
 * Very tiny program with a simple set of arguments.  Turns off the
 * Criteria with the given id.
 */
int
main( int argc, char *argv[] )
{
   int i;
   int error = 0;

   if( argc < 2 )
   {
      usage();
      return 1;
   }

   for( i = 1; i < argc; i++ )
   {
      int id;

      id = atoi(argv[i]);
      if( id <= 0 )
      {
         fprintf( stderr, "Bad id %s, must be > 0\n", argv[i] );
         return 1;
      }
   
      /*
       * All the "real" work, call the WSS syscall.
       */
      error = wrmodEnable( id, 0 );
      if( error != 0 )
         perror( "wrdisable" );
   }
   return (error);
}

