/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: WRVPanelNotebook.java,v 1.6 2001/04/05 18:41:24 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 */

package com.gswtk.ui;

import java.awt.*;
import jclass.bwt.JCTabButton;
import jclass.bwt.JCTabManager;

public class WRVPanelNotebook extends JCTabManager
{
	// Constructors
	public WRVPanelNotebook()
	{
		super();

		setTabResize( true );
		setTabStretch( true );
	}

	// Protected methods
	protected int findLastVisibleTab() { return findLastVisibleTab( -1 ); }
	protected int findLastVisibleTab( int threshold )
	{
		JCTabButton[] tabArray = tab_panel.getTabs();
		int visible = -1;

		if( threshold == -1 || threshold > tabArray.length )
			threshold = tabArray.length;

		for( int i = 0; i < threshold; i++ )
		{
			Component page = tabArray[i].getPage();

			if( page != null && page instanceof WRVPanel && ((WRVPanel)page).isDocked() )
				visible = i;
		}

		if( visible < 0 )
		{
			for( int i = threshold + 1; i < tabArray.length; i++ )
			{
				Component page = tabArray[i].getPage();

				if( page != null && page instanceof WRVPanel && ((WRVPanel)page).isDocked() )
				{
					visible = i;
					break;
				}
			}
		}
		return visible;
	}

	// Public methods
	public void removeTab( int tab ) { removeTab( tab, true ); }
	public void hideTab( JCTabButton tab )
	{
		if( tab.isVisible() == true )
		{
			int nextTab = findLastVisibleTab( getTab( tab ) );

			if( nextTab >= 0 && getCurrentTab() == getTab( tab ) )
			{
				makeTabVisible( nextTab );
				setCurrentTab( nextTab, true );
			}
			tab.setVisible( false );
		}
	}

	public void showTab( JCTabButton tab )
	{
		if( tab.isVisible() == false )
		{
			tab.setVisible( true );
		}
	}
}

