/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: ActivationCriteria.java,v 1.9 2001/04/05 18:41:25 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 */

package com.gswtk.viewer;

public class ActivationCriteria extends Criteria
{
	// Constructors
	public ActivationCriteria( int handle )
	{ super( handle ); }
	public ActivationCriteria( String name, int handle )
	{ super( name, handle ); }
	public ActivationCriteria( String name, int handle, int status )
	{ super( name, handle, status ); }
	public ActivationCriteria( String name, int handle, int status, String user, String loadtime, long loadaddr, int size )
	{ super( name, handle, status, user, loadtime, loadaddr, size ); }


	// Public methods
	public void refresh()
	{
		if( isDirty() )
		{
			WrapperViewer wv = WrapperViewer.getGlobal();
			refresh(wv.requestActivationCriteriaInfo(getHandle()));
		}
	}
}

