/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: Module.java,v 1.11 2001/04/05 18:41:25 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 */

package com.gswtk.viewer;

public abstract class Module
{
	// Private data
	private   boolean dirty    = true;


	// Protected data
	protected int	  id;
	protected String  name;
	protected long    loadaddr = 0;
	protected int     size     = 0;
	protected String  user;
	protected String  loadtime;


	// Constructors
	public Module( int handle )
	{
		id = handle;
	}

	public Module( String newName, int handle )
	{
		this( handle );
		name = newName.intern();
	}

	public Module( String name, int handle, String newUser, String newLoadTime, long newLoadAddr, int newSize )
	{
		this( name, handle );
		user = newUser.intern();
		loadtime = newLoadTime.intern();
		loadaddr = newLoadAddr;
		size = newSize;
	}


	// Protected methods
	protected void markClean() { dirty = false; }


	// Public methods
	public boolean equals( Object obj )
	{
		if( obj instanceof Module )
			return ( ((Module)obj).getHandle() == id ) &&
			       ((Module)obj).getName().equals( name );
		else
			return false;
	}

	public int getHandle() { return id; }
	public long getLoadAddr() { return loadaddr; }
	public String getName() { return name; }
	public int getSize() { return size; }
	public boolean isDirty() { return dirty; }
	public abstract void refresh();
}

