/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * $Id: TestWrapperViewer.java,v 1.4 2001/04/05 18:41:26 stevek Exp $
 */

import java.util.*;
import com.gswtk.viewer.WrapperViewer;
import com.gswtk.db.Table;

public class TestWrapperViewer
{
	// Constructors
	public TestWrapperViewer() throws Exception
	{
		WrapperViewer wv = WrapperViewer.getGlobal();

		for( Enumeration e = wv.requestTables(); e.hasMoreElements(); )
		{
			Table t = (Table)e.nextElement();
			System.out.println(t.toString());
		}

		System.out.println("<<<PASSED>>>");
		System.exit(0);
	}


	// Public methods
	public static void main( String args[] )
	{
		try
		{
			new TestWrapperViewer();
		}
		catch( Exception e )
		{
			e.printStackTrace(System.out);
		}
	}
}

