/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: ModuleEventStream.java,v 1.5 2001/04/05 18:41:26 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 */

package com.gswtk.wrapper.event;

import java.util.*;
import com.eventfs.*;

public class ModuleEventStream extends EventStream
{
	private Vector modEventListeners = new Vector();

	// Constructors
	public ModuleEventStream() throws Exception
	{ this(new WrapperEventGroup()); }

	public ModuleEventStream( WrapperEventGroup eg ) throws Exception
	{ super(eg, WrapperEventConstants.WREV_EFS_MODULE_STREAM); }

	// Public methods
	public void eventGroupEventOccurred( EventGroupEvent ege ) throws EventException
	{
		super.eventGroupEventOccurred(ege);
		ModuleEvent mEvent = (ModuleEvent)ege;
		for( Enumeration enum = modEventListeners.elements();
		     enum.hasMoreElements(); )
			((ModuleEventListener)enum.nextElement()).moduleEventOccurred(mEvent);
	}

	public void addModuleEventListener( ModuleEventListener mel )
	{ modEventListeners.addElement(mel); }

	public void removeModuleEventListener( ModuleEventListener mel )
	{ modEventListeners.removeElement(mel); }
}

