/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: TableEvent.java,v 1.7 2001/04/05 18:41:26 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 */

package com.gswtk.wrapper.event;

import java.io.*;
import com.endian.*;
import com.eventfs.*;

public class TableEvent extends WrapperEventGroupEvent
{
	private int tableID;

	// Constructors
	public TableEvent( WrapperEventGroup eg ) { super(eg); }
	public TableEvent( WrapperEventGroup eg, int newMask )
	{ super(eg, newMask); }
	public TableEvent( EventGroup eg, int newMask ) throws EventException
	{ super(eg, newMask); }


	// Public methods
	public int readData( InputStream is ) throws IOException, CorruptEventException
	{
		int nread = super.readData(is);

		ByteArrayInputStream bais =
			new ByteArrayInputStream( getData(), dataOffset,
       			                          getSize() - dataOffset );
		EndianDataInputStream edis = new EndianDataInputStream(bais);

		tableID = edis.readInt();
		dataOffset += 4;

		return nread;
	}

	public int getTableID() { return tableID; }
}

