/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: WrapperEventConstants.java,v 1.7 2001/04/05 18:41:26 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 */

package com.gswtk.wrapper.event;

public class WrapperEventConstants
{
	// Constructors
	private WrapperEventConstants() {}


	// Finalized public data
	public static final String WREV_EFS_GROUP = "wrappers";

	public static final String WREV_EFS_RAW_STREAM = "raw";
	public static final String WREV_EFS_DB_STREAM = "db";
	public static final String WREV_EFS_MODULE_STREAM = "module";

	public static final String WREV_ET_CREATETAB = "create table";
	public static final String WREV_ET_DROPTAB = "drop table";
	public static final String WREV_ET_UPDATETAB_INSERTROW = "insert table row";
	public static final String WREV_ET_UPDATETAB_DELETEROW = "delete table row";
	public static final String WREV_ET_UPDATETAB_UPDATEROW = "update table row";
	public static final String WREV_ET_WRAPPER_LOADED = "wrapper loaded";
	public static final String WREV_ET_ACTCRIT_LOADED = "activation criteria loaded";
	public static final String WREV_ET_DEACTCRIT_LOADED = "deactivation criteria loaded";
	public static final String WREV_ET_LIBRARY_LOADED = "library loaded";
	public static final String WREV_ET_WRAPPER_UNLOADED = "wrapper unloaded";
	public static final String WREV_ET_ACTCRIT_UNLOADED = "activation criteria unloaded";
	public static final String WREV_ET_DEACTCRIT_UNLOADED = "deactivation criteria unloaded";
	public static final String WREV_ET_LIBRARY_UNLOADED = "library unloaded";
}

