/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: WrapperEventMap.java,v 1.8 2001/04/05 18:41:26 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 */

package com.gswtk.wrapper.event;

import com.eventfs.*;

public class WrapperEventMap extends EventMap
{
	// Constructors
	public WrapperEventMap()
	{
		super();

		put(WrapperEventConstants.WREV_ET_CREATETAB,
		    "com.gswtk.wrapper.event.CreateTableEvent");

		put(WrapperEventConstants.WREV_ET_DROPTAB,
		    "com.gswtk.wrapper.event.DropTableEvent");

		put(WrapperEventConstants.WREV_ET_UPDATETAB_INSERTROW,
		    "com.gswtk.wrapper.event.InsertRowEvent");

		put(WrapperEventConstants.WREV_ET_UPDATETAB_DELETEROW,
		    "com.gswtk.wrapper.event.DeleteRowEvent");

		put(WrapperEventConstants.WREV_ET_UPDATETAB_UPDATEROW,
		    "com.gswtk.wrapper.event.UpdateRowEvent");

		put(WrapperEventConstants.WREV_ET_WRAPPER_LOADED,
		    "com.gswtk.wrapper.event.WrapperLoadedEvent");

		put(WrapperEventConstants.WREV_ET_ACTCRIT_LOADED,
		    "com.gswtk.wrapper.event.ActivationCriteriaLoadedEvent");

		put(WrapperEventConstants.WREV_ET_DEACTCRIT_LOADED,
		    "com.gswtk.wrapper.event.DeactivationCriteriaLoadedEvent");

		put(WrapperEventConstants.WREV_ET_LIBRARY_LOADED,
		    "com.gswtk.wrapper.event.LibraryLoadedEvent");

		put(WrapperEventConstants.WREV_ET_WRAPPER_UNLOADED,
		    "com.gswtk.wrapper.event.WrapperUnloadedEvent");

		put(WrapperEventConstants.WREV_ET_ACTCRIT_UNLOADED,
		    "com.gswtk.wrapper.event.ActivationCriteriaUnloadedEvent");

		put(WrapperEventConstants.WREV_ET_DEACTCRIT_UNLOADED,
		    "com.gswtk.wrapper.event.DeactivationCriteriaUnloadedEvent");

		put(WrapperEventConstants.WREV_ET_LIBRARY_UNLOADED,
		    "com.gswtk.wrapper.event.LibraryUnloadedEvent");
	}
}

