/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: local.ch,v 1.14 2001/04/05 18:41:30 stevek Exp $
 *
 * By including this file, portable concrete wrappers (those using
 * attrbutes common across platforms) can be compiled on the
 * various platforms on which wrappers are supported without having to
 * edit the wrapper to change the name of the included
 * characterization file.
 */

/* FreeBSD */
#if defined(__FreeBSD__)
#  include <osreldate.h>
#  if (__FreeBSD_version >= 500000)
#     include "./freebsd5.ch"
#  elif (__FreeBSD_version >= 400000)
#     include "./freebsd4.ch"
#  elif (__FreeBSD_version >= 300000)
#     include "./freebsd3.ch"
#  else
#     error Unsupported version of FreeBSD
#  endif
 
/* Solaris */
#elif defined(__sun__)
#include "./solaris.ch"

/* Windows NT */
#elif defined(_WIN32)
#  if (_WIN32_WINNT >= 0x0500)
#     include "./winnt5.ch"
#  elif (_WIN32_WINNT >= 0x0400)
#     include "./winnt4.ch"
#  else
#     error Unsupported version of Windows
#  endif

/* Linux */
#elif defined(__linux)
#include "./linux.ch"

#else
#error Unsupported Platform.

#endif
