/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * $Id: winnt5.ch,v 1.6 2001/04/05 18:41:31 stevek Exp $
 */

#if 0
#define WR_KERNEL_MODULE
#include "wr_conf.h"
#endif

#define WR_WIN32 1

includes{
#ifndef _WR_DEFS_INCLUDED
#include "wr_conf.h"
#endif

#include <windows.h>
};

#include "wr_errname.h"

#define WR_LOCAL win32

characterize WR_LOCAL {

int errnum{
       errnum{
          vmap(WR_SUCC,         _),
          vmap(WR_FAIL,         _),
          vmap(WR_BADPERM,      ERROR_ACCESS_DENIED),    /* !!! no equivalent to super user */
          vmap(WR_NOFILE,       ERROR_FILE_NOT_FOUND),
          vmap(WR_NOPROC,       ERROR_NOT_FOUND),        /* !!! probably not correct, can't find exact complement to process not found */
          vmap(WR_IOERR,        ERROR_IO_DEVICE),        /* !!! seems to be best match */
          vmap(WR_ARG2LONG,     ERROR_BAD_LENGTH),       /* !!! probably not correct */
          vmap(WR_BADFD,        ERROR_INVALID_HANDLE),   /* !!! wider in scope than wrapper error */
          vmap(WR_NOCHILD,      ERROR_WAIT_NO_CHILDREN), /* !!! not really a good match */ 
          vmap(WR_BADACCES,     ERROR_ACCESS_DENIED),    /* !!! probably shouldn't be the same as WR_BADPERM */
          vmap(WR_FILEEXIST,    ERROR_FILE_EXISTS),
          vmap(WR_BADARG,       ERROR_BAD_ARGUMENTS),	 /* !!! may not be a good match, might be too specific on nt */
          vmap(WR_FILEBSY,      ERROR_LOCK_VIOLATION),   /* !!! might not be correct match */
          vmap(WR_FILE2BIG,     _),                      /* !!! can't find equivalent on NT */
          vmap(WR_NOSPC,        ERROR_DISK_FULL),
          vmap(WR_FNAME2LONG,   ERROR_BUFFER_OVERFLOW)	 /* !!! seems odd, but that's what the docs say */
       }
   };

/* 
 * syscalls that return 0 on success and -1 on failure
 */
#define STD_RET wrret{vmap(WR_SUCC,0), vmap(*,-1)}
/* 
 * syscalls that return some values on success and -1 on failure
 */
#define VAL_RET wrret{vmap(WR_SUCC,_), vmap(*,-1)}
/* 
 * syscalls that are always successful, and no return value is 
 * reserved to indicate an error. 
 */
#define NOERR_RET wrret
   
/*
 * calls that return handles
 */
					/* Too Much Knowledge encoded here */
#define HANDLE_RET wrret{vmap(WR_SUCC,_), vmap(*,-1)}

/*
 * calls that return a boolean
 */
#define BOOL_RET wrret{vmap(WR_SUCC,TRUE), vmap(*,FALSE)}

/* 
 * calls that return some values on success and 0 on failure
 */
#define NONZERO_RET wrret{vmap(WR_SUCC,_), vmap(*,0)}

/* 
 * calls that return zero on success and something else on failure
 */
#define ZERO_RET wrret{vmap(WR_SUCC,0), vmap(*,_)}

/* 
 * calls that return non-null on success and null on failure
 */
#define NONNULL_RET wrret{vmap(WR_SUCC,_), vmap(*,0)}


/*
 * Macros for wide-format functions without ASCII-format complements
 */
#define ReadDirectoryChanges ReadDirectoryChangesW
#define CreateProcessWithLogon CreateProcessWithLogonW


/*
 * Function call characterizations
 */

BOOL {boolret, BOOL_RET}
AbortSystemShutdown{systemop, unicode}(
		LPWSTR lpMachineName {lpMachineName}
);

BOOL {boolret, BOOL_RET}
AccessCheck{aclop, nativeop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		HANDLE ClientToken {ClientToken, handle, fd},
		DWORD DesiredAccess {DesiredAccess},
		PGENERIC_MAPPING GenericMapping {GenericMapping},
		PPRIVILEGE_SET PrivilegeSet {PrivilegeSet},
		LPDWORD PrivilegeSetLength {PrivilegeSetLength, out},
		LPDWORD GrantedAccess {GrantedAccess, out},
		LPBOOL AccessStatus {AccessStatus}
);

BOOL {boolret, BOOL_RET}
AccessCheckAndAuditAlarm{aclop, unicode}(
		LPCWSTR SubsystemName {SubsystemName, nterm},
		LPVOID HandleId {HandleId},
		LPWSTR ObjectTypeName {ObjectTypeName},
		LPWSTR ObjectName {ObjectName},
		PSECURITY_DESCRIPTOR SecurityDescriptor {SecurityDescriptor},
		DWORD DesiredAccess {DesiredAccess},
		PGENERIC_MAPPING GenericMapping {GenericMapping},
		BOOL ObjectCreation {ObjectCreation},
		LPDWORD GrantedAccess {GrantedAccess, out},
		LPBOOL AccessStatus {AccessStatus},
		LPBOOL pfGenerateOnClose {pfGenerateOnClose}
);

BOOL {boolret, BOOL_RET}
AccessCheckByType{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		PSID PrincipalSelfSid {PrincipalSelfSid, sid},
		HANDLE ClientToken {ClientToken, handle, fd},
		DWORD DesiredAccess {DesiredAccess},
		POBJECT_TYPE_LIST ObjectTypeList {ObjectTypeList},
		DWORD ObjectTypeListLength {ObjectTypeListLength},
		PGENERIC_MAPPING GenericMapping {GenericMapping},
		PPRIVILEGE_SET PrivilegeSet {PrivilegeSet},
		LPDWORD PrivilegeSetLength {PrivilegeSetLength, out},
		LPDWORD GrantedAccess {GrantedAccess, out},
		LPBOOL AccessStatus {AccessStatus}
);

BOOL {boolret, BOOL_RET}
AccessCheckByTypeAndAuditAlarm{aclop, unicode}(
		LPCWSTR SubsystemName {SubsystemName, nterm},
		LPVOID HandleId {HandleId},
		LPCWSTR ObjectTypeName {ObjectTypeName, nterm},
		LPCWSTR ObjectName {ObjectName, nterm},
		PSECURITY_DESCRIPTOR SecurityDescriptor {SecurityDescriptor},
		PSID PrincipalSelfSid {PrincipalSelfSid, sid},
		DWORD DesiredAccess {DesiredAccess},
		AUDIT_EVENT_TYPE AuditType {AuditType},
		DWORD Flags {Flags},
		POBJECT_TYPE_LIST ObjectTypeList {ObjectTypeList},
		DWORD ObjectTypeListLength {ObjectTypeListLength},
		PGENERIC_MAPPING GenericMapping {GenericMapping},
		BOOL ObjectCreation {ObjectCreation},
		LPDWORD GrantedAccess {GrantedAccess, out},
		LPBOOL AccessStatus {AccessStatus},
		LPBOOL pfGenerateOnClose {pfGenerateOnClose}
);

BOOL {boolret, BOOL_RET}
AccessCheckByTypeResultList{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		PSID PrincipalSelfSid {PrincipalSelfSid, sid},
		HANDLE ClientToken {ClientToken, handle, fd},
		DWORD DesiredAccess {DesiredAccess},
		POBJECT_TYPE_LIST ObjectTypeList {ObjectTypeList},
		DWORD ObjectTypeListLength {ObjectTypeListLength},
		PGENERIC_MAPPING GenericMapping {GenericMapping},
		PPRIVILEGE_SET PrivilegeSet {PrivilegeSet},
		LPDWORD PrivilegeSetLength {PrivilegeSetLength, out},
		LPDWORD GrantedAccessList {GrantedAccessList, out},
		LPDWORD AccessStatusList {AccessStatusList, out}
);

BOOL {boolret, BOOL_RET}
AccessCheckByTypeResultListAndAuditAlarmByHandle{aclop, unicode}(
		LPCWSTR SubsystemName {SubsystemName, nterm},
		LPVOID HandleId {HandleId},
		HANDLE ClientToken {ClientToken, handle, fd},
		LPCWSTR ObjectTypeName {ObjectTypeName, nterm},
		LPCWSTR ObjectName {ObjectName, nterm},
		PSECURITY_DESCRIPTOR SecurityDescriptor {SecurityDescriptor},
		PSID PrincipalSelfSid {PrincipalSelfSid, sid},
		DWORD DesiredAccess {DesiredAccess},
		AUDIT_EVENT_TYPE AuditType {AuditType},
		DWORD Flags {Flags},
		POBJECT_TYPE_LIST ObjectTypeList {ObjectTypeList},
		DWORD ObjectTypeListLength {ObjectTypeListLength},
		PGENERIC_MAPPING GenericMapping {GenericMapping},
		BOOL ObjectCreation {ObjectCreation},
		LPDWORD GrantedAccess {GrantedAccess, out},
		LPDWORD AccessStatusList {AccessStatusList, out},
		LPBOOL pfGenerateOnClose {pfGenerateOnClose}
);

BOOL {boolret, BOOL_RET}
AccessCheckByTypeResultListAndAuditAlarm{aclop, unicode}(
		LPCWSTR SubsystemName {SubsystemName, nterm},
		LPVOID HandleId {HandleId},
		LPCWSTR ObjectTypeName {ObjectTypeName, nterm},
		LPCWSTR ObjectName {ObjectName, nterm},
		PSECURITY_DESCRIPTOR SecurityDescriptor {SecurityDescriptor},
		PSID PrincipalSelfSid {PrincipalSelfSid, sid},
		DWORD DesiredAccess {DesiredAccess},
		AUDIT_EVENT_TYPE AuditType {AuditType},
		DWORD Flags {Flags},
		POBJECT_TYPE_LIST ObjectTypeList {ObjectTypeList},
		DWORD ObjectTypeListLength {ObjectTypeListLength},
		PGENERIC_MAPPING GenericMapping {GenericMapping},
		BOOL ObjectCreation {ObjectCreation},
		LPDWORD GrantedAccess {GrantedAccess, out},
		LPDWORD AccessStatusList {AccessStatusList, out},
		LPBOOL pfGenerateOnClose {pfGenerateOnClose}
);

BOOL {boolret, BOOL_RET}
AddAccessAllowedAce{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceRevision {dwAceRevision},
		DWORD AccessMask {AccessMask},
		PSID pSid {pSid, sid}
);

BOOL {boolret, BOOL_RET}
AddAccessAllowedAceEx{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceRevision {dwAceRevision},
		DWORD AceFlags {AceFlags},
		DWORD AccessMask {AccessMask},
		PSID pSid {pSid, sid}
);

BOOL {boolret, BOOL_RET}
AddAccessAllowedObjectAce{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceRevision {dwAceRevision},
		DWORD AceFlags {AceFlags},
		DWORD AccessMask {AccessMask},
		GUID * ObjectTypeGuid {ObjectTypeGuid},
		GUID * InheritedObjectTypeGuid {InheritedObjectTypeGuid},
		PSID pSid {pSid, sid}
);

BOOL {boolret, BOOL_RET}
AddAccessDeniedAce{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceRevision {dwAceRevision},
		DWORD AccessMask {AccessMask},
		PSID pSid {pSid, sid}
);

BOOL {boolret, BOOL_RET}
AddAccessDeniedAceEx{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceRevision {dwAceRevision},
		DWORD AceFlags {AceFlags},
		DWORD AccessMask {AccessMask},
		PSID pSid {pSid, sid}
);

BOOL {boolret, BOOL_RET}
AddAccessDeniedObjectAce{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceRevision {dwAceRevision},
		DWORD AceFlags {AceFlags},
		DWORD AccessMask {AccessMask},
		GUID * ObjectTypeGuid {ObjectTypeGuid},
		GUID * InheritedObjectTypeGuid {InheritedObjectTypeGuid},
		PSID pSid {pSid, sid}
);

BOOL {boolret, BOOL_RET}
AddAce{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceRevision {dwAceRevision},
		DWORD dwStartingAceIndex {dwStartingAceIndex},
		LPVOID pAceList {pAceList},
		DWORD nAceListLength {nAceListLength}
);

ATOM {atomret, NONZERO_RET}
AddAtom{atomop, nativeop, unicode}(
		LPCWSTR lpString {lpString, nterm}
);

BOOL {boolret, BOOL_RET}
AddAuditAccessAce{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceRevision {dwAceRevision},
		DWORD dwAccessMask {dwAccessMask},
		PSID pSid {pSid, sid},
		BOOL bAuditSuccess {bAuditSuccess},
		BOOL bAuditFailure {bAuditFailure}
);

BOOL {boolret, BOOL_RET}
AddAuditAccessAceEx{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceRevision {dwAceRevision},
		DWORD AceFlags {AceFlags},
		DWORD dwAccessMask {dwAccessMask},
		PSID pSid {pSid, sid},
		BOOL bAuditSuccess {bAuditSuccess},
		BOOL bAuditFailure {bAuditFailure}
);

BOOL {boolret, BOOL_RET}
AddAuditAccessObjectAce{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceRevision {dwAceRevision},
		DWORD AceFlags {AceFlags},
		DWORD AccessMask {AccessMask},
		GUID * ObjectTypeGuid {ObjectTypeGuid},
		GUID * InheritedObjectTypeGuid {InheritedObjectTypeGuid},
		PSID pSid {pSid, sid},
		BOOL bAuditSuccess {bAuditSuccess},
		BOOL bAuditFailure {bAuditFailure}
);

DWORD {NOERR_RET}
AddUsersToEncryptedFile{cryptop, fileop}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		PENCRYPTION_CERTIFICATE_LIST pUsers {pUsers}
);

BOOL {boolret, BOOL_RET}
AdjustTokenGroups{handleop, nativeop, tokenop}(
		HANDLE TokenHandle {TokenHandle, handle, fd},
		BOOL ResetToDefault {ResetToDefault},
		PTOKEN_GROUPS NewState {NewState},
		DWORD BufferLength {BufferLength},
		PTOKEN_GROUPS PreviousState {PreviousState},
		PDWORD ReturnLength {ReturnLength}
);

BOOL {boolret, BOOL_RET}
AdjustTokenPrivileges{aclop, handleop, nativeop}(
		HANDLE TokenHandle {TokenHandle, handle, fd},
		BOOL DisableAllPrivileges {DisableAllPrivileges},
		PTOKEN_PRIVILEGES NewState {NewState},
		DWORD BufferLength {BufferLength},
		PTOKEN_PRIVILEGES PreviousState {PreviousState},
		PDWORD ReturnLength {ReturnLength}
);

BOOL {boolret, BOOL_RET}
AllocConsole{consoleop}( void );

BOOL {boolret, BOOL_RET}
AllocateAndInitializeSid{sidop}(
		PSID_IDENTIFIER_AUTHORITY pIdentifierAuthority {pIdentifierAuthority},
		BYTE nSubAuthorityCount {nSubAuthorityCount},
		DWORD nSubAuthority0 {nSubAuthority0},
		DWORD nSubAuthority1 {nSubAuthority1},
		DWORD nSubAuthority2 {nSubAuthority2},
		DWORD nSubAuthority3 {nSubAuthority3},
		DWORD nSubAuthority4 {nSubAuthority4},
		DWORD nSubAuthority5 {nSubAuthority5},
		DWORD nSubAuthority6 {nSubAuthority6},
		DWORD nSubAuthority7 {nSubAuthority7},
		PSID * pSid {pSid}
);

BOOL {boolret, BOOL_RET}
AllocateLocallyUniqueId{nativeop}(
		PLUID Luid {Luid}
);

BOOL {boolret, BOOL_RET}
AllocateUserPhysicalPages{handleop, memop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		PULONG_PTR NumberOfPages {NumberOfPages},
		PULONG_PTR PageArray {PageArray}
);

BOOL {boolret, BOOL_RET}
AreAllAccessesGranted{aclop}(
		DWORD GrantedAccess {GrantedAccess},
		DWORD DesiredAccess {DesiredAccess}
);

BOOL {boolret, BOOL_RET}
AreAnyAccessesGranted{aclop}(
		DWORD GrantedAccess {GrantedAccess},
		DWORD DesiredAccess {DesiredAccess}
);

BOOL {boolret, BOOL_RET}
AreFileApisANSI{fileop}( void );

BOOL {boolret, BOOL_RET}
AssignProcessToJobObject{handleop, jobobjectop}(
		HANDLE hJob {hJob, handle, fd},
		HANDLE hProcess {hProcess, handle, fd}
);

BOOL {boolret, BOOL_RET}
BackupEventLog{eventlogop, handleop, syncop, unicode}(
		HANDLE hEventLog {hEventLog, handle, fd},
		LPCWSTR lpBackupFileName {lpBackupFileName, nterm}
);

BOOL {boolret, BOOL_RET}
BackupRead{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPBYTE lpBuffer {lpBuffer},
		DWORD nNumberOfBytesToRead {nNumberOfBytesToRead, nbytes},
		LPDWORD lpNumberOfBytesRead {lpNumberOfBytesRead, out},
		BOOL bAbort {bAbort},
		BOOL bProcessSecurity {bProcessSecurity},
		LPVOID * lpContext {lpContext, inout}
);

BOOL {boolret, BOOL_RET}
BackupSeek{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		DWORD dwLowBytesToSeek {dwLowBytesToSeek},
		DWORD dwHighBytesToSeek {dwHighBytesToSeek},
		LPDWORD lpdwLowByteSeeked {lpdwLowByteSeeked, out},
		LPDWORD lpdwHighByteSeeked {lpdwHighByteSeeked, out},
		LPVOID * lpContext {lpContext, inout}
);

BOOL {boolret, BOOL_RET}
BackupWrite{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPBYTE lpBuffer {lpBuffer},
		DWORD nNumberOfBytesToWrite {nNumberOfBytesToWrite, nbytes},
		LPDWORD lpNumberOfBytesWritten {lpNumberOfBytesWritten, out},
		BOOL bAbort {bAbort},
		BOOL bProcessSecurity {bProcessSecurity},
		LPVOID * lpContext {lpContext, inout}
);

BOOL {boolret, BOOL_RET}
Beep{hardwareop}(
		DWORD dwFreq {dwFreq},
		DWORD dwDuration {dwDuration}
);

HANDLE {handleret, HANDLE_RET}
BeginUpdateResource{fdretop, handleretop, resourceop, unicode}(
		LPCWSTR pFileName {pFileName, nterm},
		BOOL bDeleteExistingResources {bDeleteExistingResources}
);

BOOL {boolret, BOOL_RET}
BindIoCompletionCallback{handleop}(
		HANDLE FileHandle {FileHandle, handle, fd},
		LPOVERLAPPED_COMPLETION_ROUTINE Function {Function},
		ULONG Flags {Flags}
);

BOOL {boolret, BOOL_RET}
BuildCommDCBAndTimeouts{dcbop, unicode}(
		LPCWSTR lpDef {lpDef, nterm},
		LPDCB lpDCB {lpDCB},
		LPCOMMTIMEOUTS lpCommTimeouts {lpCommTimeouts}
);

BOOL {boolret, BOOL_RET}
BuildCommDCB{dcbop, unicode}(
		LPCWSTR lpDef {lpDef, nterm},
		LPDCB lpDCB {lpDCB}
);

BOOL {boolret, BOOL_RET}
CallNamedPipe{ipcop, pipeop, unicode}(
		LPCWSTR lpNamedPipeName {lpNamedPipeName, nterm},
		LPVOID lpInBuffer {lpInBuffer, out},
		DWORD nInBufferSize {nInBufferSize},
		LPVOID lpOutBuffer {lpOutBuffer},
		DWORD nOutBufferSize {nOutBufferSize},
		LPDWORD lpBytesRead {lpBytesRead, out},
		DWORD nTimeOut {nTimeOut}
);

BOOL {boolret, BOOL_RET}
CancelDeviceWakeupRequest{handleop, powerop}(
		HANDLE hDevice {hDevice, handle, fd}
);

BOOL {boolret, BOOL_RET}
CancelIo{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd}
);

BOOL {boolret, BOOL_RET}
CancelTimerQueueTimer{handleop, timerqueueop}(
		HANDLE TimerQueue {TimerQueue, handle, fd},
		HANDLE Timer {Timer, handle, fd}
);

BOOL {boolret, BOOL_RET}
CancelWaitableTimer{handleop, nativeop, timerop}(
		HANDLE hTimer {hTimer, handle, fd}
);

BOOL {boolret, BOOL_RET}
ChangeServiceConfig2{handleop, serviceop, unicode}(
		SC_HANDLE hService {hService, handle},
		DWORD dwInfoLevel {dwInfoLevel},
		LPVOID lpInfo {lpInfo}
);

BOOL {boolret, BOOL_RET}
ChangeServiceConfig{handleop, serviceop, unicode}(
		SC_HANDLE hService {hService, handle},
		DWORD dwServiceType {dwServiceType},
		DWORD dwStartType {dwStartType},
		DWORD dwErrorControl {dwErrorControl},
		LPCWSTR lpBinaryPathName {lpBinaryPathName, nterm},
		LPCWSTR lpLoadOrderGroup {lpLoadOrderGroup, nterm},
		LPDWORD lpdwTagId {lpdwTagId, out},
		LPCWSTR lpDependencies {lpDependencies, nterm},
		LPCWSTR lpServiceStartName {lpServiceStartName, nterm},
		LPCWSTR lpPassword {lpPassword, nterm},
		LPCWSTR lpDisplayName {lpDisplayName, nterm}
);

BOOL {boolret, BOOL_RET}
ChangeTimerQueueTimer{handleop, timerqueueop}(
		HANDLE TimerQueue {TimerQueue, handle, fd},
		HANDLE Timer {Timer, handle, fd},
		ULONG DueTime {DueTime},
		ULONG Period {Period}
);

BOOL {boolret, BOOL_RET}
ClearCommBreak{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd}
);

BOOL {boolret, BOOL_RET}
ClearCommError{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPDWORD lpErrors {lpErrors, out},
		LPCOMSTAT lpStat {lpStat}
);

BOOL {boolret, BOOL_RET}
ClearEventLog{eventlogop, handleop, syncop, unicode}(
		HANDLE hEventLog {hEventLog, handle, fd},
		LPCWSTR lpBackupFileName {lpBackupFileName, nterm}
);

void {NO_RET}
CloseEncryptedFileRaw{cryptop, fileop}(
		PVOID pvContext {pvContext}
);

BOOL {boolret, BOOL_RET}
CloseEventLog{eventlogop, handleop, syncop}(
		HANDLE hEventLog {hEventLog, handle, fd}
);

BOOL {boolret, BOOL_RET}
CloseHandle{handleop, nativeop}(
		HANDLE hObject {hObject, handle, fd}
);

BOOL {boolret, BOOL_RET}
CloseServiceHandle{handleop, serviceop}(
		SC_HANDLE hSCObject {hSCObject, handle}
);

BOOL {boolret, BOOL_RET}
CommConfigDialog{commconfigop, unicode}(
		LPCWSTR lpszName {lpszName, nterm},
		HWND hWnd {hWnd, window, handle, fd},
		LPCOMMCONFIG lpCC {lpCC}
);

LONG {errret, ZERO_RET}
CompareFileTime{dateop}(
		const FILETIME * lpFileTime1 {lpFileTime1},
		const FILETIME * lpFileTime2 {lpFileTime2}
);

int {sizeret,VAL_RET}
CompareString{localeop, unicode}(
		LCID Locale {Locale},
		DWORD dwCmpFlags {dwCmpFlags},
		LPCWSTR lpString1 {lpString1, nterm},
		int cchCount1 {cchCount1},
		LPCWSTR lpString2 {lpString2, nterm},
		int cchCount2 {cchCount2}
);

BOOL {boolret, BOOL_RET}
ConnectNamedPipe{handleop, ipcop, pipeop}(
		HANDLE hNamedPipe {hNamedPipe, handle, fd},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

BOOL {boolret, BOOL_RET}
ContinueDebugEvent{debugop}(
		DWORD dwProcessId {dwProcessId},
		DWORD dwThreadId {dwThreadId},
		DWORD dwContinueStatus {dwContinueStatus}
);

BOOL {boolret, BOOL_RET}
ControlService{handleop, serviceop}(
		SC_HANDLE hService {hService, handle},
		DWORD dwControl {dwControl},
		LPSERVICE_STATUS lpServiceStatus {lpServiceStatus}
);

LCID {localeret, NOERR_RET}
ConvertDefaultLocale{localeop}(
		LCID Locale {Locale}
);

LPVOID {pointerret, NONNULL_RET}
ConvertThreadToFiber{threadop}(
		LPVOID lpParameter {lpParameter}
);

BOOL {boolret, BOOL_RET}
ConvertToAutoInheritPrivateObjectSecurity{aclop}(
		PSECURITY_DESCRIPTOR ParentDescriptor {ParentDescriptor},
		PSECURITY_DESCRIPTOR CurrentSecurityDescriptor {CurrentSecurityDescriptor},
		PSECURITY_DESCRIPTOR * NewSecurityDescriptor {NewSecurityDescriptor},
		GUID * ObjectType {ObjectType},
		BOOLEAN IsDirectoryObject {IsDirectoryObject},
		PGENERIC_MAPPING GenericMapping {GenericMapping}
);

BOOL {boolret, BOOL_RET}
CopyFileEx{fileop, unicode}(
		LPCWSTR lpExistingFileName {lpExistingFileName, path, nterm},
		LPCWSTR lpNewFileName {lpNewFileName, destpath, nterm},
		LPPROGRESS_ROUTINE lpProgressRoutine {lpProgressRoutine},
		LPVOID lpData {lpData},
		LPBOOL pbCancel {pbCancel},
		DWORD dwCopyFlags {dwCopyFlags}
);

BOOL {boolret, BOOL_RET}
CopyFile{fileop, unicode}(
		LPCWSTR lpExistingFileName {lpExistingFileName, path, nterm},
		LPCWSTR lpNewFileName {lpNewFileName, destpath, nterm},
		BOOL bFailIfExists {bFailIfExists}
);

BOOL {boolret, BOOL_RET}
CopySid{sidop}(
		DWORD nDestinationSidLength {nDestinationSidLength},
		PSID pDestinationSid {pDestinationSid, sid},
		PSID pSourceSid {pSourceSid, sid}
);

HANDLE {handleret, HANDLE_RET}
CreateConsoleScreenBuffer{consoleop, fdretop, handleretop}(
		DWORD dwDesiredAccess {dwDesiredAccess},
		DWORD dwShareMode {dwShareMode},
		const SECURITY_ATTRIBUTES * lpSecurityAttributes {lpSecurityAttributes},
		DWORD dwFlags {dwFlags},
		LPVOID lpScreenBufferData {lpScreenBufferData}
);

BOOL {boolret, BOOL_RET}
CreateDirectoryEx{fileop, nativeop, unicode}(
		LPCWSTR lpTemplateDirectory {lpTemplateDirectory, path, nterm},
		LPCWSTR lpNewDirectory {lpNewDirectory, nterm},
		LPSECURITY_ATTRIBUTES lpSecurityAttributes {lpSecurityAttributes}
);

BOOL {boolret, BOOL_RET}
CreateDirectory{fileop, nativeop, unicode}(
		LPCWSTR lpPathName {lpPathName, path, nterm},
		LPSECURITY_ATTRIBUTES lpSecurityAttributes {lpSecurityAttributes}
);

HANDLE {handleret, HANDLE_RET}
CreateEvent{fdretop, handleretop, nativeop, syncop, unicode}(
		LPSECURITY_ATTRIBUTES lpEventAttributes {lpEventAttributes},
		BOOL bManualReset {bManualReset},
		BOOL bInitialState {bInitialState},
		LPCWSTR lpName {lpName, nterm}
);

LPVOID {pointerret, NONNULL_RET}
CreateFiber{threadop}(
		DWORD dwStackSize {dwStackSize},
		LPFIBER_START_ROUTINE lpStartAddress {lpStartAddress},
		LPVOID lpParameter {lpParameter}
);

HANDLE {handleret, HANDLE_RET}
CreateFileMapping{fdretop, fileop, handleop, handleretop, nativeop, unicode}(
		HANDLE hFile {hFile, handle, fd},
		LPSECURITY_ATTRIBUTES lpFileMappingAttributes {lpFileMappingAttributes},
		DWORD flProtect {flProtect},
		DWORD dwMaximumSizeHigh {dwMaximumSizeHigh},
		DWORD dwMaximumSizeLow {dwMaximumSizeLow},
		LPCWSTR lpName {lpName, nterm}
);

HANDLE {handleret, HANDLE_RET}
CreateFile{fdretop, fileop, handleretop, nativeop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		DWORD dwDesiredAccess {dwDesiredAccess},
		DWORD dwShareMode {dwShareMode},
		LPSECURITY_ATTRIBUTES lpSecurityAttributes {lpSecurityAttributes},
		DWORD dwCreationDisposition {dwCreationDisposition},
		DWORD dwFlagsAndAttributes {dwFlagsAndAttributes},
		HANDLE hTemplateFile {hTemplateFile, handle, fd}
);

BOOL {boolret, BOOL_RET}
CreateHardLink{fileop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		LPCWSTR lpExistingFileName {lpExistingFileName, path, nterm},
		LPSECURITY_ATTRIBUTES lpSecurityAttributes {lpSecurityAttributes}
);

HANDLE {handleret, HANDLE_RET}
CreateIoCompletionPort{fdretop, handleop, handleretop, nativeop}(
		HANDLE FileHandle {FileHandle, handle, fd},
		HANDLE ExistingCompletionPort {ExistingCompletionPort, handle, fd},
		ULONG_PTR CompletionKey {CompletionKey},
		DWORD NumberOfConcurrentThreads {NumberOfConcurrentThreads}
);

HANDLE {handleret, HANDLE_RET}
CreateJobObject{fdretop, handleretop, jobobjectop, unicode}(
		LPSECURITY_ATTRIBUTES lpJobAttributes {lpJobAttributes},
		LPCWSTR lpName {lpName, nterm}
);

HANDLE {handleret, HANDLE_RET}
CreateMailslot{fdretop, handleretop, ipcop, mailslotop, unicode}(
		LPCWSTR lpName {lpName, nterm},
		DWORD nMaxMessageSize {nMaxMessageSize},
		DWORD lReadTimeout {lReadTimeout},
		LPSECURITY_ATTRIBUTES lpSecurityAttributes {lpSecurityAttributes}
);

HANDLE {handleret, HANDLE_RET}
CreateMutex{fdretop, handleretop, nativeop, syncop, unicode}(
		LPSECURITY_ATTRIBUTES lpMutexAttributes {lpMutexAttributes},
		BOOL bInitialOwner {bInitialOwner},
		LPCWSTR lpName {lpName, nterm}
);

HANDLE {handleret, HANDLE_RET}
CreateNamedPipe{fdretop, handleretop, ipcop, nativeop, pipeop, unicode}(
		LPCWSTR lpName {lpName, nterm},
		DWORD dwOpenMode {dwOpenMode},
		DWORD dwPipeMode {dwPipeMode},
		DWORD nMaxInstances {nMaxInstances},
		DWORD nOutBufferSize {nOutBufferSize},
		DWORD nInBufferSize {nInBufferSize},
		DWORD nDefaultTimeOut {nDefaultTimeOut},
		LPSECURITY_ATTRIBUTES lpSecurityAttributes {lpSecurityAttributes}
);

BOOL {boolret, BOOL_RET}
CreatePipe{ipcop, pipeop}(
		PHANDLE hReadPipe {hReadPipe},
		PHANDLE hWritePipe {hWritePipe},
		LPSECURITY_ATTRIBUTES lpPipeAttributes {lpPipeAttributes},
		DWORD nSize {nSize, nbytes}
);

BOOL {boolret, BOOL_RET}
CreatePrivateObjectSecurity{aclop}(
		PSECURITY_DESCRIPTOR ParentDescriptor {ParentDescriptor},
		PSECURITY_DESCRIPTOR CreatorDescriptor {CreatorDescriptor},
		PSECURITY_DESCRIPTOR * NewDescriptor {NewDescriptor},
		BOOL IsDirectoryObject {IsDirectoryObject},
		HANDLE Token {Token, handle, fd},
		PGENERIC_MAPPING GenericMapping {GenericMapping}
);

BOOL {boolret, BOOL_RET}
CreatePrivateObjectSecurityEx{aclop}(
		PSECURITY_DESCRIPTOR ParentDescriptor {ParentDescriptor},
		PSECURITY_DESCRIPTOR CreatorDescriptor {CreatorDescriptor},
		PSECURITY_DESCRIPTOR * NewDescriptor {NewDescriptor},
		GUID * ObjectType {ObjectType},
		BOOL IsContainerObject {IsContainerObject},
		ULONG AutoInheritFlags {AutoInheritFlags},
		HANDLE Token {Token, handle, fd},
		PGENERIC_MAPPING GenericMapping {GenericMapping}
);

BOOL {boolret, BOOL_RET}
CreateProcessAsUser{execop, handleop, processop, unicode}(
		HANDLE hToken {hToken, handle, fd},
		LPCWSTR lpApplicationName {lpApplicationName, path, nterm},
		LPWSTR lpCommandLine {lpCommandLine},
		LPSECURITY_ATTRIBUTES lpProcessAttributes {lpProcessAttributes},
		LPSECURITY_ATTRIBUTES lpThreadAttributes {lpThreadAttributes},
		BOOL bInheritHandles {bInheritHandles},
		DWORD dwCreationFlags {dwCreationFlags},
		LPVOID lpEnvironment {lpEnvironment},
		LPCWSTR lpCurrentDirectory {lpCurrentDirectory, nterm},
		LPSTARTUPINFOW lpStartupInfo {lpStartupInfo},
		LPPROCESS_INFORMATION lpProcessInformation {lpProcessInformation}
);

BOOL {boolret, BOOL_RET}
CreateProcess{execop, fileop, nativeop, processop, unicode}(
		LPCWSTR lpApplicationName {lpApplicationName, path, nterm},
		LPWSTR lpCommandLine {lpCommandLine},
		LPSECURITY_ATTRIBUTES lpProcessAttributes {lpProcessAttributes},
		LPSECURITY_ATTRIBUTES lpThreadAttributes {lpThreadAttributes},
		BOOL bInheritHandles {bInheritHandles},
		DWORD dwCreationFlags {dwCreationFlags},
		LPVOID lpEnvironment {lpEnvironment},
		LPCWSTR lpCurrentDirectory {lpCurrentDirectory, nterm},
		LPSTARTUPINFOW lpStartupInfo {lpStartupInfo},
		LPPROCESS_INFORMATION lpProcessInformation {lpProcessInformation}
);

BOOL {boolret, BOOL_RET}
CreateProcessWithLogon{execop, processop, unicode}(
		LPCWSTR lpUsername {lpUsername, nterm},
		LPCWSTR lpDomain {lpDomain, nterm},
		LPCWSTR lpPassword {lpPassword, nterm},
		DWORD dwLogonFlags {dwLogonFlags},
		LPCWSTR lpApplicationName {lpApplicationName, path, nterm},
		LPWSTR lpCommandLine {lpCommandLine},
		DWORD dwCreationFlags {dwCreationFlags},
		LPVOID lpEnvironment {lpEnvironment},
		LPCWSTR lpCurrentDirectory {lpCurrentDirectory, nterm},
		LPSTARTUPINFOW lpStartupInfo {lpStartupInfo},
		LPPROCESS_INFORMATION lpProcessInformation {lpProcessInformation}
);

HANDLE {handleret, HANDLE_RET}
CreateRemoteThread{fdretop, handleop, handleretop, processop, threadop}(
		HANDLE hProcess {hProcess, handle, fd},
		LPSECURITY_ATTRIBUTES lpThreadAttributes {lpThreadAttributes},
		DWORD dwStackSize {dwStackSize},
		LPTHREAD_START_ROUTINE lpStartAddress {lpStartAddress},
		LPVOID lpParameter {lpParameter},
		DWORD dwCreationFlags {dwCreationFlags},
		LPDWORD lpThreadId {lpThreadId, out}
);

BOOL {boolret, BOOL_RET}
CreateRestrictedToken{handleop, tokenop}(
		HANDLE ExistingTokenHandle {ExistingTokenHandle, handle, fd},
		DWORD Flags {Flags},
		DWORD DisableSidCount {DisableSidCount},
		PSID_AND_ATTRIBUTES SidsToDisable {SidsToDisable},
		DWORD DeletePrivilegeCount {DeletePrivilegeCount},
		PLUID_AND_ATTRIBUTES PrivilegesToDelete {PrivilegesToDelete},
		DWORD RestrictedSidCount {RestrictedSidCount},
		PSID_AND_ATTRIBUTES SidsToRestrict {SidsToRestrict},
		PHANDLE NewTokenHandle {NewTokenHandle}
);

HANDLE {handleret, HANDLE_RET}
CreateSemaphore{fdretop, handleretop, nativeop, syncop, unicode}(
		LPSECURITY_ATTRIBUTES lpSemaphoreAttributes {lpSemaphoreAttributes},
		LONG lInitialCount {lInitialCount},
		LONG lMaximumCount {lMaximumCount},
		LPCWSTR lpName {lpName, nterm}
);

SC_HANDLE {sc_handleret, SC_HANDLE_RET}
CreateService{handleop, serviceop, unicode}(
		SC_HANDLE hSCManager {hSCManager, handle},
		LPCWSTR lpServiceName {lpServiceName, nterm},
		LPCWSTR lpDisplayName {lpDisplayName, nterm},
		DWORD dwDesiredAccess {dwDesiredAccess},
		DWORD dwServiceType {dwServiceType},
		DWORD dwStartType {dwStartType},
		DWORD dwErrorControl {dwErrorControl},
		LPCWSTR lpBinaryPathName {lpBinaryPathName, nterm},
		LPCWSTR lpLoadOrderGroup {lpLoadOrderGroup, nterm},
		LPDWORD lpdwTagId {lpdwTagId, out},
		LPCWSTR lpDependencies {lpDependencies, nterm},
		LPCWSTR lpServiceStartName {lpServiceStartName, nterm},
		LPCWSTR lpPassword {lpPassword, nterm}
);

DWORD {NOERR_RET}
CreateTapePartition{handleop}(
		HANDLE hDevice {hDevice, handle, fd},
		DWORD dwPartitionMethod {dwPartitionMethod},
		DWORD dwCount {dwCount},
		DWORD dwSize {dwSize}
);

HANDLE {handleret, HANDLE_RET}
CreateThread{fdretop, handleretop, nativeop, threadop}(
		LPSECURITY_ATTRIBUTES lpThreadAttributes {lpThreadAttributes},
		DWORD dwStackSize {dwStackSize},
		LPTHREAD_START_ROUTINE lpStartAddress {lpStartAddress},
		LPVOID lpParameter {lpParameter},
		DWORD dwCreationFlags {dwCreationFlags},
		LPDWORD lpThreadId {lpThreadId, out}
);

HANDLE {handleret, HANDLE_RET}
CreateTimerQueue{timerqueueop}( void );

BOOL {boolret, BOOL_RET}
CreateTimerQueueTimer{timerqueueop}(
		PHANDLE phNewTimer {phNewTimer},
		HANDLE TimerQueue {TimerQueue, handle, fd},
		WAITORTIMERCALLBACK Callback {Callback},
		PVOID Parameter {Parameter},
		DWORD DueTime {DueTime},
		DWORD Period {Period},
		ULONG Flags {Flags}
);

HANDLE {handleret, HANDLE_RET}
CreateWaitableTimer{fdretop, handleretop, nativeop, timerop, unicode}(
		LPSECURITY_ATTRIBUTES lpTimerAttributes {lpTimerAttributes},
		BOOL bManualReset {bManualReset},
		LPCWSTR lpTimerName {lpTimerName, nterm}
);

BOOL {boolret, BOOL_RET}
CryptAcquireContext{cryptop, unicode}(
		HCRYPTPROV * phProv {phProv},
		LPCWSTR pszContainer {pszContainer, nterm},
		LPCWSTR pszProvider {pszProvider, nterm},
		DWORD dwProvType {dwProvType},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptContextAddRef{cryptop, handleop}(
		HCRYPTPROV hProv {hProv, cryptprovider, handle},
		DWORD * pdwReserved {pdwReserved},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptCreateHash{cryptop, handleop}(
		HCRYPTPROV hProv {hProv, cryptprovider, handle},
		ALG_ID Algid {Algid},
		HCRYPTKEY hKey {hKey, cryptkey, handle},
		DWORD dwFlags {dwFlags},
		HCRYPTHASH * phHash {phHash}
);

BOOL {boolret, BOOL_RET}
CryptDecrypt{cryptop, handleop}(
		HCRYPTKEY hKey {hKey, cryptkey, handle},
		HCRYPTHASH hHash {hHash, crypthash, handle},
		BOOL Final {Final},
		DWORD dwFlags {dwFlags},
		BYTE * pbData {pbData},
		DWORD * pdwDataLen {pdwDataLen}
);

BOOL {boolret, BOOL_RET}
CryptDeriveKey{cryptop, handleop}(
		HCRYPTPROV hProv {hProv, cryptprovider, handle},
		ALG_ID Algid {Algid},
		HCRYPTHASH hBaseData {hBaseData},
		DWORD dwFlags {dwFlags},
		HCRYPTKEY * phKey {phKey}
);

BOOL {boolret, BOOL_RET}
CryptDestroyHash{cryptop, handleop}(
		HCRYPTHASH hHash {hHash, crypthash, handle}
);

BOOL {boolret, BOOL_RET}
CryptDestroyKey{cryptop, handleop}(
		HCRYPTKEY hKey {hKey, cryptkey, handle}
);

BOOL {boolret, BOOL_RET}
CryptDuplicateHash{cryptop, handleop}(
		HCRYPTHASH hHash {hHash, crypthash, handle},
		DWORD * pdwReserved {pdwReserved},
		DWORD dwFlags {dwFlags},
		HCRYPTHASH * phHash {phHash}
);

BOOL {boolret, BOOL_RET}
CryptDuplicateKey{cryptop, handleop}(
		HCRYPTKEY hKey {hKey, cryptkey, handle},
		DWORD * pdwReserved {pdwReserved},
		DWORD dwFlags {dwFlags},
		HCRYPTKEY * phKey {phKey}
);

BOOL {boolret, BOOL_RET}
CryptEncrypt{cryptop, handleop}(
		HCRYPTKEY hKey {hKey, cryptkey, handle},
		HCRYPTHASH hHash {hHash, crypthash, handle},
		BOOL Final {Final},
		DWORD dwFlags {dwFlags},
		BYTE * pbData {pbData},
		DWORD * pdwDataLen {pdwDataLen},
		DWORD dwBufLen {dwBufLen}
);

BOOL {boolret, BOOL_RET}
CryptEnumProviderTypes{cryptop, unicode}(
		DWORD dwIndex {dwIndex},
		DWORD * pdwReserved {pdwReserved},
		DWORD dwFlags {dwFlags},
		DWORD * pdwProvType {pdwProvType},
		LPWSTR pszTypeName {pszTypeName},
		DWORD * pcbTypeName {pcbTypeName}
);

BOOL {boolret, BOOL_RET}
CryptEnumProviders{cryptop, unicode}(
		DWORD dwIndex {dwIndex},
		DWORD * pdwReserved {pdwReserved},
		DWORD dwFlags {dwFlags},
		DWORD * pdwProvType {pdwProvType},
		LPWSTR pszProvName {pszProvName},
		DWORD * pcbProvName {pcbProvName}
);

BOOL {boolret, BOOL_RET}
CryptExportKey{cryptop, handleop}(
		HCRYPTKEY hKey {hKey, cryptkey, handle},
		HCRYPTKEY hExpKey {hExpKey},
		DWORD dwBlobType {dwBlobType},
		DWORD dwFlags {dwFlags},
		BYTE * pbData {pbData},
		DWORD * pdwDataLen {pdwDataLen}
);

BOOL {boolret, BOOL_RET}
CryptGenKey{cryptop, handleop}(
		HCRYPTPROV hProv {hProv, cryptprovider, handle},
		ALG_ID Algid {Algid},
		DWORD dwFlags {dwFlags},
		HCRYPTKEY * phKey {phKey}
);

BOOL {boolret, BOOL_RET}
CryptGenRandom{cryptop, handleop}(
		HCRYPTPROV hProv {hProv, cryptprovider, handle},
		DWORD dwLen {dwLen},
		BYTE * pbBuffer {pbBuffer}
);

BOOL {boolret, BOOL_RET}
CryptGetDefaultProvider{cryptop, unicode}(
		DWORD dwProvType {dwProvType},
		DWORD * pdwReserved {pdwReserved},
		DWORD dwFlags {dwFlags},
		LPWSTR pszProvName {pszProvName},
		DWORD * pcbProvName {pcbProvName}
);

BOOL {boolret, BOOL_RET}
CryptGetHashParam{cryptop, handleop}(
		HCRYPTHASH hHash {hHash, crypthash, handle},
		DWORD dwParam {dwParam},
		BYTE * pbData {pbData},
		DWORD * pdwDataLen {pdwDataLen},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptGetKeyParam{cryptop, handleop}(
		HCRYPTKEY hKey {hKey, cryptkey, handle},
		DWORD dwParam {dwParam},
		BYTE * pbData {pbData},
		DWORD * pdwDataLen {pdwDataLen},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptGetProvParam{cryptop, handleop}(
		HCRYPTPROV hProv {hProv, cryptprovider, handle},
		DWORD dwParam {dwParam},
		BYTE * pbData {pbData},
		DWORD * pdwDataLen {pdwDataLen},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptGetUserKey{cryptop, handleop}(
		HCRYPTPROV hProv {hProv, cryptprovider, handle},
		DWORD dwKeySpec {dwKeySpec},
		HCRYPTKEY * phUserKey {phUserKey}
);

BOOL {boolret, BOOL_RET}
CryptHashData{cryptop, handleop}(
		HCRYPTHASH hHash {hHash, crypthash, handle},
		const BYTE * pbData {pbData},
		DWORD dwDataLen {dwDataLen},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptHashSessionKey{cryptop, handleop}(
		HCRYPTHASH hHash {hHash, crypthash, handle},
		HCRYPTKEY hKey {hKey, cryptkey, handle},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptImportKey{cryptop, handleop}(
		HCRYPTPROV hProv {hProv, cryptprovider, handle},
		const BYTE * pbData {pbData},
		DWORD dwDataLen {dwDataLen},
		HCRYPTKEY hPubKey {hPubKey},
		DWORD dwFlags {dwFlags},
		HCRYPTKEY * phKey {phKey}
);

BOOL {boolret, BOOL_RET}
CryptReleaseContext{cryptop, handleop}(
		HCRYPTPROV hProv {hProv, cryptprovider, handle},
		ULONG_PTR dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptSetHashParam{cryptop, handleop}(
		HCRYPTHASH hHash {hHash, crypthash, handle},
		DWORD dwParam {dwParam},
		BYTE * pbData {pbData},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptSetKeyParam{cryptop, handleop}(
		HCRYPTKEY hKey {hKey, cryptkey, handle},
		DWORD dwParam {dwParam},
		BYTE * pbData {pbData},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptSetProvParam{cryptop, handleop}(
		HCRYPTPROV hProv {hProv, cryptprovider, handle},
		DWORD dwParam {dwParam},
		BYTE * pbData {pbData},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptSetProviderEx{cryptop, unicode}(
		LPCWSTR pszProvName {pszProvName, nterm},
		DWORD dwProvType {dwProvType},
		DWORD * pdwReserved {pdwReserved},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
CryptSetProvider{cryptop, unicode}(
		LPCWSTR pszProvName {pszProvName, nterm},
		DWORD dwProvType {dwProvType}
);

BOOL {boolret, BOOL_RET}
CryptSignHash{cryptop, handleop, unicode}(
		HCRYPTHASH hHash {hHash, crypthash, handle},
		DWORD dwKeySpec {dwKeySpec},
		LPCWSTR sDescription {sDescription, nterm},
		DWORD dwFlags {dwFlags},
		BYTE * pbSignature {pbSignature},
		DWORD * pdwSigLen {pdwSigLen}
);

BOOL {boolret, BOOL_RET}
CryptVerifySignature{cryptop, handleop, unicode}(
		HCRYPTHASH hHash {hHash, crypthash, handle},
		const BYTE * pbSignature {pbSignature},
		DWORD dwSigLen {dwSigLen},
		HCRYPTKEY hPubKey {hPubKey},
		LPCWSTR sDescription {sDescription, nterm},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
DebugActiveProcess{debugop}(
		DWORD dwProcessId {dwProcessId}
);

void {NO_RET}
DebugBreak{debugop}( void );

BOOL {boolret, BOOL_RET}
DecryptFile{fileop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		DWORD dwReserved {dwReserved}
);

BOOL {boolret, BOOL_RET}
DefineDosDevice{hardwareop, unicode}(
		DWORD dwFlags {dwFlags},
		LPCWSTR lpDeviceName {lpDeviceName, nterm},
		LPCWSTR lpTargetPath {lpTargetPath, nterm}
);

BOOL {boolret, BOOL_RET}
DeleteAce{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceIndex {dwAceIndex}
);

ATOM {atomret, NONZERO_RET}
DeleteAtom{atomop, nativeop}(
		ATOM nAtom {nAtom}
);

void {NO_RET}
DeleteFiber{threadop}(
		LPVOID lpFiber {lpFiber}
);

BOOL {boolret, BOOL_RET}
DeleteFile{fileop, nativeop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm}
);

BOOL {boolret, BOOL_RET}
DeleteService{handleop, serviceop}(
		SC_HANDLE hService {hService, handle}
);

BOOL {boolret, BOOL_RET}
DeleteTimerQueue{handleop, timerqueueop}(
		HANDLE TimerQueue {TimerQueue, handle, fd}
);

BOOL {boolret, BOOL_RET}
DeleteTimerQueueEx{handleop, timerqueueop}(
		HANDLE TimerQueue {TimerQueue, handle, fd},
		HANDLE CompletionEvent {CompletionEvent, handle, fd}
);

BOOL {boolret, BOOL_RET}
DeleteTimerQueueTimer{handleop, timerqueueop}(
		HANDLE TimerQueue {TimerQueue, handle, fd},
		HANDLE Timer {Timer, handle, fd},
		HANDLE CompletionEvent {CompletionEvent, handle, fd}
);

BOOL {boolret, BOOL_RET}
DeleteVolumeMountPoint{unicode, volumeop}(
		LPCWSTR lpszVolumeMountPoint {lpszVolumeMountPoint, nterm}
);

BOOL {boolret, BOOL_RET}
DeregisterEventSource{eventlogop, handleop, syncop}(
		HANDLE hEventLog {hEventLog, handle, fd}
);

BOOL {boolret, BOOL_RET}
DestroyPrivateObjectSecurity{aclop}(
		PSECURITY_DESCRIPTOR * ObjectDescriptor {ObjectDescriptor}
);

BOOL {boolret, BOOL_RET}
DeviceIoControl{handleop, nativeop}(
		HANDLE hDevice {hDevice, handle, fd},
		DWORD dwIoControlCode {dwIoControlCode},
		LPVOID lpInBuffer {lpInBuffer, out},
		DWORD nInBufferSize {nInBufferSize},
		LPVOID lpOutBuffer {lpOutBuffer},
		DWORD nOutBufferSize {nOutBufferSize},
		LPDWORD lpBytesReturned {lpBytesReturned, out},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

BOOL {boolret, BOOL_RET}
DisableThreadLibraryCalls{moduleop, threadop}(
		HMODULE hLibModule {hLibModule}
);

BOOL {boolret, BOOL_RET}
DisconnectNamedPipe{handleop, ipcop, pipeop}(
		HANDLE hNamedPipe {hNamedPipe, handle, fd}
);

BOOL {boolret, BOOL_RET}
DnsHostnameToComputerName{sysinfoop, unicode}(
		LPWSTR Hostname {Hostname},
		LPWSTR ComputerName {ComputerName},
		LPDWORD nSize {nSize, out}
);

BOOL {boolret, BOOL_RET}
DosDateTimeToFileTime{dateop}(
		WORD wFatDate {wFatDate},
		WORD wFatTime {wFatTime},
		LPFILETIME lpFileTime {lpFileTime}
);

BOOL {boolret, BOOL_RET}
DuplicateHandle{handleop, nativeop}(
		HANDLE hSourceProcessHandle {hSourceProcessHandle, handle, fd},
		HANDLE hSourceHandle {hSourceHandle, handle, fd},
		HANDLE hTargetProcessHandle {hTargetProcessHandle, handle, fd},
		LPHANDLE lpTargetHandle {lpTargetHandle},
		DWORD dwDesiredAccess {dwDesiredAccess},
		BOOL bInheritHandle {bInheritHandle},
		DWORD dwOptions {dwOptions}
);

BOOL {boolret, BOOL_RET}
DuplicateToken{handleop, nativeop, tokenop}(
		HANDLE ExistingTokenHandle {ExistingTokenHandle, handle, fd},
		SECURITY_IMPERSONATION_LEVEL ImpersonationLevel {ImpersonationLevel},
		PHANDLE DuplicateTokenHandle {DuplicateTokenHandle}
);

BOOL {boolret, BOOL_RET}
DuplicateTokenEx{handleop, nativeop, tokenop}(
		HANDLE hExistingToken {hExistingToken, handle, fd},
		DWORD dwDesiredAccess {dwDesiredAccess},
		LPSECURITY_ATTRIBUTES lpTokenAttributes {lpTokenAttributes},
		SECURITY_IMPERSONATION_LEVEL ImpersonationLevel {ImpersonationLevel},
		TOKEN_TYPE TokenType {TokenType},
		PHANDLE phNewToken {phNewToken}
);

BOOL {boolret, BOOL_RET}
EncryptFile{cryptop, fileop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm}
);

BOOL {boolret, BOOL_RET}
EncryptionDisable{cryptop}(
		LPCWSTR DirPath {DirPath, nterm},
		BOOL Disable {Disable}
);

BOOL {boolret, BOOL_RET}
EndUpdateResource{handleop, resourceop, unicode}(
		HANDLE hUpdate {hUpdate, handle, fd},
		BOOL fDiscard {fDiscard}
);

BOOL {boolret, BOOL_RET}
EnumCalendarInfo{dateop, unicode}(
		CALINFO_ENUMPROCW lpCalInfoEnumProc {lpCalInfoEnumProc},
		LCID Locale {Locale},
		CALID Calendar {Calendar},
		CALTYPE CalType {CalType}
);

BOOL {boolret, BOOL_RET}
EnumDateFormats{dateop, unicode}(
		DATEFMT_ENUMPROCW lpDateFmtEnumProc {lpDateFmtEnumProc},
		LCID Locale {Locale},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
EnumDependentServices{handleop, serviceop, unicode}(
		SC_HANDLE hService {hService, handle},
		DWORD dwServiceState {dwServiceState},
		LPENUM_SERVICE_STATUSW lpServices {lpServices},
		DWORD cbBufSize {cbBufSize, nbytes},
		LPDWORD pcbBytesNeeded {pcbBytesNeeded, out},
		LPDWORD lpServicesReturned {lpServicesReturned, out}
);

BOOL {boolret, BOOL_RET}
EnumResourceLanguages{moduleop, resourceop, unicode}(
		HMODULE hModule {hModule},
		LPCWSTR lpType {lpType, nterm},
		LPCWSTR lpName {lpName, nterm},
		ENUMRESLANGPROCW lpEnumFunc {lpEnumFunc},
		LONG_PTR lParam {lParam}
);

BOOL {boolret, BOOL_RET}
EnumResourceNames{moduleop, resourceop, unicode}(
		HMODULE hModule {hModule},
		LPCWSTR lpType {lpType, nterm},
		ENUMRESNAMEPROCW lpEnumFunc {lpEnumFunc},
		LONG_PTR lParam {lParam}
);

BOOL {boolret, BOOL_RET}
EnumResourceTypes{moduleop, resourceop, unicode}(
		HMODULE hModule {hModule},
		ENUMRESTYPEPROCW lpEnumFunc {lpEnumFunc},
		LONG_PTR lParam {lParam}
);

BOOL {boolret, BOOL_RET}
EnumServicesStatusEx{handleop, serviceop, unicode}(
		SC_HANDLE hSCManager {hSCManager, handle},
		SC_ENUM_TYPE InfoLevel {InfoLevel},
		DWORD dwServiceType {dwServiceType},
		DWORD dwServiceState {dwServiceState},
		LPBYTE lpServices {lpServices},
		DWORD cbBufSize {cbBufSize, nbytes},
		LPDWORD pcbBytesNeeded {pcbBytesNeeded, out},
		LPDWORD lpServicesReturned {lpServicesReturned, out},
		LPDWORD lpResumeHandle {lpResumeHandle, out},
		LPCWSTR pszGroupName {pszGroupName, nterm}
);

BOOL {boolret, BOOL_RET}
EnumServicesStatus{handleop, serviceop, unicode}(
		SC_HANDLE hSCManager {hSCManager, handle},
		DWORD dwServiceType {dwServiceType},
		DWORD dwServiceState {dwServiceState},
		LPENUM_SERVICE_STATUSW lpServices {lpServices},
		DWORD cbBufSize {cbBufSize, nbytes},
		LPDWORD pcbBytesNeeded {pcbBytesNeeded, out},
		LPDWORD lpServicesReturned {lpServicesReturned, out},
		LPDWORD lpResumeHandle {lpResumeHandle, out}
);

BOOL {boolret, BOOL_RET}
EnumSystemCodePages{localeop, unicode}(
		CODEPAGE_ENUMPROCW lpCodePageEnumProc {lpCodePageEnumProc},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
EnumSystemLocales{localeop, unicode}(
		LOCALE_ENUMPROCW lpLocaleEnumProc {lpLocaleEnumProc},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
EnumTimeFormats{dateop, unicode}(
		TIMEFMT_ENUMPROCW lpTimeFmtEnumProc {lpTimeFmtEnumProc},
		LCID Locale {Locale},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
EqualPrefixSid{sidop}(
		PSID pSid1 {pSid1, sid},
		PSID pSid2 {pSid2, sid}
);

BOOL {boolret, BOOL_RET}
EqualSid{sidop}(
		PSID pSid1 {pSid1, sid},
		PSID pSid2 {pSid2, sid}
);

DWORD {NOERR_RET}
EraseTape{handleop}(
		HANDLE hDevice {hDevice, handle, fd},
		DWORD dwEraseType {dwEraseType},
		BOOL bImmediate {bImmediate}
);

BOOL {boolret, BOOL_RET}
EscapeCommFunction{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		DWORD dwFunc {dwFunc}
);

void {NO_RET}
ExitProcess{processop}(
		UINT uExitCode {uExitCode}
);

void {NO_RET}
ExitThread{processop, threadop}(
		DWORD dwExitCode {dwExitCode}
);

DWORD {NOERR_RET}
ExpandEnvironmentStrings{envop, unicode}(
		LPCWSTR lpSrc {lpSrc, nterm},
		LPWSTR lpDst {lpDst},
		DWORD nSize {nSize, nbytes}
);

void {NO_RET}
FatalAppExit{processop, unicode}(
		UINT uAction {uAction},
		LPCWSTR lpMessageText {lpMessageText, nterm}
);

void {NO_RET}
FatalExit{processop}(
		int ExitCode {ExitCode}
);

BOOL {boolret, BOOL_RET}
FileEncryptionStatus{cryptop, fileop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		LPDWORD lpStatus {lpStatus, out}
);

BOOL {boolret, BOOL_RET}
FileTimeToDosDateTime{dateop}(
		const FILETIME * lpFileTime {lpFileTime},
		LPWORD lpFatDate {lpFatDate},
		LPWORD lpFatTime {lpFatTime}
);

BOOL {boolret, BOOL_RET}
FileTimeToLocalFileTime{dateop}(
		const FILETIME * lpFileTime {lpFileTime},
		LPFILETIME lpLocalFileTime {lpLocalFileTime}
);

BOOL {boolret, BOOL_RET}
FileTimeToSystemTime{dateop}(
		const FILETIME * lpFileTime {lpFileTime},
		LPSYSTEMTIME lpSystemTime {lpSystemTime}
);

BOOL {boolret, BOOL_RET}
FillConsoleOutputAttribute{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		WORD wAttribute {wAttribute},
		DWORD nLength {nLength},
		COORD * dwWriteCoord {dwWriteCoord},
		LPDWORD lpNumberOfAttrsWritten {lpNumberOfAttrsWritten, out}
);

BOOL {boolret, BOOL_RET}
FillConsoleOutputCharacter{consoleop, handleop, unicode}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		WCHAR cCharacter {cCharacter},
		DWORD nLength {nLength},
		COORD * dwWriteCoord {dwWriteCoord},
		LPDWORD lpNumberOfCharsWritten {lpNumberOfCharsWritten, out}
);

ATOM {atomret, NONZERO_RET}
FindAtom{atomop, nativeop, unicode}(
		LPCWSTR lpString {lpString, nterm}
);

BOOL {boolret, BOOL_RET}
FindClose{handleop}(
		HANDLE hFindFile {hFindFile, handle, fd}
);

BOOL {boolret, BOOL_RET}
FindCloseChangeNotification{fileop, handleop}(
		HANDLE hChangeHandle {hChangeHandle, handle, fd}
);

HANDLE {handleret, HANDLE_RET}
FindFirstChangeNotification{fdretop, fileop, handleretop, nativeop, unicode}(
		LPCWSTR lpPathName {lpPathName, path, nterm},
		BOOL bWatchSubtree {bWatchSubtree},
		DWORD dwNotifyFilter {dwNotifyFilter}
);

HANDLE {handleret, HANDLE_RET}
FindFirstFileEx{fdretop, fileop, handleretop, nativeop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		FINDEX_INFO_LEVELS fInfoLevelId {fInfoLevelId},
		LPVOID lpFindFileData {lpFindFileData},
		FINDEX_SEARCH_OPS fSearchOp {fSearchOp},
		LPVOID lpSearchFilter {lpSearchFilter},
		DWORD dwAdditionalFlags {dwAdditionalFlags}
);

HANDLE {handleret, HANDLE_RET}
FindFirstFile{fdretop, fileop, handleretop, nativeop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		LPWIN32_FIND_DATAW lpFindFileData {lpFindFileData}
);

BOOL {boolret, BOOL_RET}
FindFirstFreeAce{aclop}(
		PACL pAcl {pAcl, acl},
		LPVOID * pAce {pAce}
);

HANDLE {handleret, HANDLE_RET}
FindFirstVolumeMountPoint{fdretop, handleretop, unicode, volumeop}(
		LPCWSTR lpszRootPathName {lpszRootPathName, nterm},
		LPWSTR lpszVolumeMountPoint {lpszVolumeMountPoint},
		DWORD cchBufferLength {cchBufferLength}
);

HANDLE {handleret, HANDLE_RET}
FindFirstVolume{fdretop, handleretop, unicode, volumeop}(
		LPWSTR lpszVolumeName {lpszVolumeName},
		DWORD cchBufferLength {cchBufferLength}
);

BOOL {boolret, BOOL_RET}
FindNextChangeNotification{fileop, handleop, nativeop}(
		HANDLE hChangeHandle {hChangeHandle, handle, fd}
);

BOOL {boolret, BOOL_RET}
FindNextFile{fileop, handleop, nativeop, unicode}(
		HANDLE hFindFile {hFindFile, handle, fd},
		LPWIN32_FIND_DATAW lpFindFileData {lpFindFileData}
);

BOOL {boolret, BOOL_RET}
FindNextVolumeMountPoint{handleop, unicode, volumeop}(
		HANDLE hFindVolumeMountPoint {hFindVolumeMountPoint, handle, fd},
		LPWSTR lpszVolumeMountPoint {lpszVolumeMountPoint},
		DWORD cchBufferLength {cchBufferLength}
);

BOOL {boolret, BOOL_RET}
FindNextVolume{handleop, unicode, volumeop}(
		HANDLE hFindVolume {hFindVolume, handle, fd},
		LPWSTR lpszVolumeName {lpszVolumeName},
		DWORD cchBufferLength {cchBufferLength}
);

HRSRC {resourceret, NONNULL_RET}
FindResourceEx{moduleop, resourceop, unicode}(
		HMODULE hModule {hModule},
		LPCWSTR lpType {lpType, nterm},
		LPCWSTR lpName {lpName, nterm},
		WORD wLanguage {wLanguage}
);

HRSRC {resourceret, NONNULL_RET}
FindResource{moduleop, resourceop, unicode}(
		HMODULE hModule {hModule},
		LPCWSTR lpName {lpName, nterm},
		LPCWSTR lpType {lpType, nterm}
);

BOOL {boolret, BOOL_RET}
FindVolumeClose{handleop, volumeop}(
		HANDLE hFindVolume {hFindVolume, handle, fd}
);

BOOL {boolret, BOOL_RET}
FindVolumeMountPointClose{handleop, volumeop}(
		HANDLE hFindVolumeMountPoint {hFindVolumeMountPoint, handle, fd}
);

BOOL {boolret, BOOL_RET}
FlushConsoleInputBuffer{consoleop, handleop}(
		HANDLE hConsoleInput {hConsoleInput, handle, fd}
);

BOOL {boolret, BOOL_RET}
FlushFileBuffers{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd}
);

BOOL {boolret, BOOL_RET}
FlushInstructionCache{handleop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		LPCVOID lpBaseAddress {lpBaseAddress},
		DWORD dwSize {dwSize}
);

BOOL {boolret, BOOL_RET}
FlushViewOfFile{fileop, nativeop}(
		LPCVOID lpBaseAddress {lpBaseAddress},
		SIZE_T dwNumberOfBytesToFlush {dwNumberOfBytesToFlush}
);

int {sizeret,VAL_RET}
FoldString{stringop, unicode}(
		DWORD dwMapFlags {dwMapFlags},
		LPCWSTR lpSrcStr {lpSrcStr, nterm},
		int cchSrc {cchSrc},
		LPWSTR lpDestStr {lpDestStr},
		int cchDest {cchDest}
);

DWORD {NOERR_RET}
FormatMessage{stringop, unicode}(
		DWORD dwFlags {dwFlags},
		LPCVOID lpSource {lpSource},
		DWORD dwMessageId {dwMessageId},
		DWORD dwLanguageId {dwLanguageId},
		LPWSTR lpBuffer {lpBuffer},
		DWORD nSize {nSize, nbytes},
		va_list * Arguments {Arguments}
);

BOOL {boolret, BOOL_RET}
FreeConsole{consoleop}( void );

void {NO_RET}
FreeEncryptionCertificateHashList{cryptop}(
		PENCRYPTION_CERTIFICATE_HASH_LIST pHashes {pHashes}
);

BOOL {boolret, BOOL_RET}
FreeEnvironmentStrings{envop, unicode}(
		LPWSTR lpWStr1 {lpWStr1}
);

BOOL {boolret, BOOL_RET}
FreeLibrary{moduleop}(
		HMODULE hLibModule {hLibModule}
);

void {NO_RET}
FreeLibraryAndExitThread{moduleop, threadop}(
		HMODULE hLibModule {hLibModule},
		DWORD dwExitCode {dwExitCode}
);

BOOL {boolret, BOOL_RET}
FreeResource{resourceop}(
		HGLOBAL hResData {hResData, memory, handle, fd}
);

PVOID {pointerret, NONNULL_RET}
FreeSid{sidop}(
		PSID pSid {pSid, sid}
);

BOOL {boolret, BOOL_RET}
FreeUserPhysicalPages{handleop, memop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		PULONG_PTR NumberOfPages {NumberOfPages},
		PULONG_PTR PageArray {PageArray}
);

BOOL {boolret, BOOL_RET}
GenerateConsoleCtrlEvent{consoleop}(
		DWORD dwCtrlEvent {dwCtrlEvent},
		DWORD dwProcessGroupId {dwProcessGroupId}
);

UINT {sizeret, NONZERO_RET}
GetACP{localeop}( void );

BOOL {boolret, BOOL_RET}
GetAce{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD dwAceIndex {dwAceIndex},
		LPVOID * pAce {pAce}
);

BOOL {boolret, BOOL_RET}
GetAclInformation{aclop}(
		PACL pAcl {pAcl, acl},
		LPVOID pAclInformation {pAclInformation},
		DWORD nAclInformationLength {nAclInformationLength},
		ACL_INFORMATION_CLASS dwAclInformationClass {dwAclInformationClass}
);

UINT {sizeret, NONZERO_RET}
GetAtomName{atomop, nativeop, unicode}(
		ATOM nAtom {nAtom},
		LPWSTR lpBuffer {lpBuffer},
		int nSize {nSize}
);

BOOL {boolret, BOOL_RET}
GetBinaryType{fileop, unicode}(
		LPCWSTR lpApplicationName {lpApplicationName, path, nterm},
		LPDWORD lpBinaryType {lpBinaryType, out}
);

BOOL {boolret, BOOL_RET}
GetCPInfo{localeop}(
		UINT CodePage {CodePage},
		LPCPINFO lpCPInfo {lpCPInfo}
);

BOOL {boolret, BOOL_RET}
GetCPInfoEx{localeop, unicode}(
		UINT CodePage {CodePage},
		DWORD dwFlags {dwFlags},
		LPCPINFOEXW lpCPInfoEx {lpCPInfoEx}
);

BOOL {boolret, BOOL_RET}
GetCommConfig{handleop}(
		HANDLE hCommDev {hCommDev, handle, fd},
		LPCOMMCONFIG lpCC {lpCC},
		LPDWORD lpdwSize {lpdwSize, out}
);

BOOL {boolret, BOOL_RET}
GetCommMask{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPDWORD lpEvtMask {lpEvtMask, out}
);

BOOL {boolret, BOOL_RET}
GetCommModemStatus{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPDWORD lpModemStat {lpModemStat, out}
);

BOOL {boolret, BOOL_RET}
GetCommProperties{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPCOMMPROP lpCommProp {lpCommProp}
);

BOOL {boolret, BOOL_RET}
GetCommState{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPDCB lpDCB {lpDCB}
);

BOOL {boolret, BOOL_RET}
GetCommTimeouts{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPCOMMTIMEOUTS lpCommTimeouts {lpCommTimeouts}
);

LPWSTR {NOERR_RET}
GetCommandLine{processop}( void );

DWORD {NOERR_RET}
GetCompressedFileSize{fileop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		LPDWORD lpFileSizeHigh {lpFileSizeHigh, out}
);

BOOL {boolret, BOOL_RET}
GetComputerNameEx{sysinfoop, unicode}(
		COMPUTER_NAME_FORMAT NameType {NameType},
		LPWSTR lpBuffer {lpBuffer, outpath, nterm},
		LPDWORD nSize {nSize, out}
);

BOOL {boolret, BOOL_RET}
GetComputerName{sysinfoop, unicode}(
		LPWSTR lpBuffer {lpBuffer},
		LPDWORD nSize {nSize, out}
);

UINT {sizeret, NONZERO_RET}
GetConsoleCP{consoleop}( void );

BOOL {boolret, BOOL_RET}
GetConsoleCursorInfo{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		PCONSOLE_CURSOR_INFO lpConsoleCursorInfo {lpConsoleCursorInfo}
);

BOOL {boolret, BOOL_RET}
GetConsoleMode{consoleop, handleop}(
		HANDLE hConsoleHandle {hConsoleHandle, handle, fd},
		LPDWORD lpMode {lpMode, out}
);

UINT {sizeret, NONZERO_RET}
GetConsoleOutputCP{consoleop}( void );

BOOL {boolret, BOOL_RET}
GetConsoleScreenBufferInfo{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		PCONSOLE_SCREEN_BUFFER_INFO lpConsoleScreenBufferInfo {lpConsoleScreenBufferInfo}
);

DWORD {NOERR_RET}
GetConsoleTitle{consoleop, unicode}(
		LPWSTR lpConsoleTitle {lpConsoleTitle},
		DWORD nSize {nSize, nbytes}
);

int {sizeret,VAL_RET}
GetCurrencyFormat{localeop, unicode}(
		LCID Locale {Locale},
		DWORD dwFlags {dwFlags},
		LPCWSTR lpValue {lpValue, nterm},
		const CURRENCYFMTW * lpFormat {lpFormat},
		LPWSTR lpCurrencyStr {lpCurrencyStr},
		int cchCurrency {cchCurrency}
);

DWORD {NOERR_RET}
GetCurrentDirectory{fileop, unicode}(
		DWORD nBufferLength {nBufferLength, nbytes},
		LPWSTR lpBuffer {lpBuffer, outpath, nterm}
);

BOOL {boolret, BOOL_RET}
GetCurrentHwProfile{hardwareop, unicode}(
		LPHW_PROFILE_INFOW lpHwProfileInfo {lpHwProfileInfo}
);

HANDLE {handleret, HANDLE_RET}
GetCurrentProcess{processop}( void );

DWORD {NOERR_RET}
GetCurrentProcessId{processop}( void );

HANDLE {handleret, HANDLE_RET}
GetCurrentThread{threadop}( void );

DWORD {NOERR_RET}
GetCurrentThreadId{threadop}( void );

int {sizeret,VAL_RET}
GetDateFormat{dateop, localeop, unicode}(
		LCID Locale {Locale},
		DWORD dwFlags {dwFlags},
		const SYSTEMTIME * lpDate {lpDate},
		LPCWSTR lpFormat {lpFormat, nterm},
		LPWSTR lpDateStr {lpDateStr},
		int cchDate {cchDate}
);

BOOL {boolret, BOOL_RET}
GetDefaultCommConfig{commconfigop, unicode}(
		LPCWSTR lpszName {lpszName, nterm},
		LPCOMMCONFIG lpCC {lpCC},
		LPDWORD lpdwSize {lpdwSize, out}
);

BOOL {boolret, BOOL_RET}
GetDevicePowerState{handleop, powerop}(
		HANDLE hDevice {hDevice, handle, fd},
		BOOL * pfOn {pfOn}
);

BOOL {boolret, BOOL_RET}
GetDiskFreeSpaceEx{fileop, unicode}(
		LPCWSTR lpDirectoryName {lpDirectoryName, nterm},
		PULARGE_INTEGER lpFreeBytesAvailableToCaller {lpFreeBytesAvailableToCaller},
		PULARGE_INTEGER lpTotalNumberOfBytes {lpTotalNumberOfBytes},
		PULARGE_INTEGER lpTotalNumberOfFreeBytes {lpTotalNumberOfFreeBytes}
);

BOOL {boolret, BOOL_RET}
GetDiskFreeSpace{fileop, nativeop, unicode}(
		LPCWSTR lpRootPathName {lpRootPathName, nterm},
		LPDWORD lpSectorsPerCluster {lpSectorsPerCluster, out},
		LPDWORD lpBytesPerSector {lpBytesPerSector, out},
		LPDWORD lpNumberOfFreeClusters {lpNumberOfFreeClusters, out},
		LPDWORD lpTotalNumberOfClusters {lpTotalNumberOfClusters, out}
);

UINT {sizeret, NONZERO_RET}
GetDriveType{fileop, nativeop, unicode}(
		LPCWSTR lpRootPathName {lpRootPathName, nterm}
);

LPWSTR {NOERR_RET}
GetEnvironmentStrings{envop}( void );

DWORD {NOERR_RET}
GetEnvironmentVariable{envop, nativeop, unicode}(
		LPCWSTR lpName {lpName, nterm},
		LPWSTR lpBuffer {lpBuffer},
		DWORD nSize {nSize, nbytes}
);

BOOL {boolret, BOOL_RET}
GetEventLogInformation{eventlogop, handleop, syncop}(
		HANDLE hEventLog {hEventLog, handle, fd},
		DWORD dwInfoLevel {dwInfoLevel},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,cbBufSize), out},
		DWORD cbBufSize {cbBufSize, nbytes},
		LPDWORD pcbBytesNeeded {pcbBytesNeeded, out}
);

BOOL {boolret, BOOL_RET}
GetExitCodeProcess{handleop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		LPDWORD lpExitCode {lpExitCode, out}
);

BOOL {boolret, BOOL_RET}
GetExitCodeThread{handleop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		LPDWORD lpExitCode {lpExitCode, out}
);

BOOL {boolret, BOOL_RET}
GetFileAttributesEx{fileop, nativeop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		GET_FILEEX_INFO_LEVELS fInfoLevelId {fInfoLevelId},
		LPVOID lpFileInformation {lpFileInformation, out}
);

DWORD {NOERR_RET}
GetFileAttributes{fileop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm}
);

BOOL {boolret, BOOL_RET}
GetFileInformationByHandle{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPBY_HANDLE_FILE_INFORMATION lpFileInformation {lpFileInformation}
);

BOOL {boolret, BOOL_RET}
GetFileSecurity{fileop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		SECURITY_INFORMATION RequestedInformation {RequestedInformation},
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		DWORD nLength {nLength},
		LPDWORD lpnLengthNeeded {lpnLengthNeeded, out}
);

DWORD {NOERR_RET}
GetFileSize{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		LPDWORD lpFileSizeHigh {lpFileSizeHigh, out}
);

BOOL {boolret, BOOL_RET}
GetFileSizeEx{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		PLARGE_INTEGER lpFileSize {lpFileSize}
);

BOOL {boolret, BOOL_RET}
GetFileTime{dateop, fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		LPFILETIME lpCreationTime {lpCreationTime},
		LPFILETIME lpLastAccessTime {lpLastAccessTime},
		LPFILETIME lpLastWriteTime {lpLastWriteTime}
);

DWORD {NOERR_RET}
GetFileType{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd}
);

DWORD {NOERR_RET}
GetFullPathName{fileop, nativeop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		DWORD nBufferLength {nBufferLength, nbytes},
		LPWSTR lpBuffer {lpBuffer, outpath, nterm},
		LPWSTR * lpFilePart {lpFilePart}
);

BOOL {boolret, BOOL_RET}
GetHandleInformation{handleop}(
		HANDLE hObject {hObject, handle, fd},
		LPDWORD lpdwFlags {lpdwFlags, out}
);

BOOL {boolret, BOOL_RET}
GetKernelObjectSecurity{handleop}(
		HANDLE Handle {Handle, handle, fd},
		SECURITY_INFORMATION RequestedInformation {RequestedInformation},
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		DWORD nLength {nLength},
		LPDWORD lpnLengthNeeded {lpnLengthNeeded, out}
);

COORD {NOERR_RET}
GetLargestConsoleWindowSize{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd}
);

DWORD {NOERR_RET}
GetLastError{errorop}( void );

DWORD {NOERR_RET}
GetLengthSid{sidop}(
		PSID pSid {pSid, sid}
);

void {NO_RET}
GetLocalTime{dateop}(
		LPSYSTEMTIME lpSystemTime {lpSystemTime}
);

int {sizeret,VAL_RET}
GetLocaleInfo{localeop, nativeop, unicode}(
		LCID Locale {Locale},
		LCTYPE LCType {LCType},
		LPWSTR lpLCData {lpLCData},
		int cchData {cchData}
);

DWORD {NOERR_RET}
GetLogicalDriveStrings{fileop, unicode}(
		DWORD nBufferLength {nBufferLength, nbytes},
		LPWSTR lpBuffer {lpBuffer}
);

DWORD {NOERR_RET}
GetLogicalDrives{fileop}( void );

DWORD {NOERR_RET}
GetLongPathName{fileop, nativeop, unicode}(
		LPCWSTR lpszShortPath {lpszShortPath, nterm},
		LPWSTR lpszLongPath {lpszLongPath},
		DWORD cchBuffer {cchBuffer}
);

BOOL {boolret, BOOL_RET}
GetMailslotInfo{handleop, ipcop, mailslotop}(
		HANDLE hMailslot {hMailslot, handle, fd},
		LPDWORD lpMaxMessageSize {lpMaxMessageSize, out},
		LPDWORD lpNextSize {lpNextSize, out},
		LPDWORD lpMessageCount {lpMessageCount, out},
		LPDWORD lpReadTimeout {lpReadTimeout, out}
);

HRESULT 
GetMangledSiteSid{sidop}(
		PSID pSid {pSid, sid},
		ULONG cchMangledSite {cchMangledSite},
		LPWSTR * ppwszMangledSite {ppwszMangledSite}
);

DWORD {NOERR_RET}
GetModuleFileName{fileop, moduleop, unicode}(
		HMODULE hModule {hModule},
		LPWSTR lpFilename {lpFilename},
		DWORD nSize {nSize, nbytes}
);

HMODULE {moduleret, NONNULL_RET}
GetModuleHandle{moduleop, unicode}(
		LPCWSTR lpModuleName {lpModuleName, nterm}
);

BOOL {boolret, BOOL_RET}
GetNamedPipeHandleState{handleop, ipcop, pipeop, unicode}(
		HANDLE hNamedPipe {hNamedPipe, handle, fd},
		LPDWORD lpState {lpState, out},
		LPDWORD lpCurInstances {lpCurInstances, out},
		LPDWORD lpMaxCollectionCount {lpMaxCollectionCount, out},
		LPDWORD lpCollectDataTimeout {lpCollectDataTimeout, out},
		LPWSTR lpUserName {lpUserName},
		DWORD nMaxUserNameSize {nMaxUserNameSize}
);

BOOL {boolret, BOOL_RET}
GetNamedPipeInfo{handleop, ipcop, pipeop}(
		HANDLE hNamedPipe {hNamedPipe, handle, fd},
		LPDWORD lpFlags {lpFlags, out},
		LPDWORD lpOutBufferSize {lpOutBufferSize, out},
		LPDWORD lpInBufferSize {lpInBufferSize, out},
		LPDWORD lpMaxInstances {lpMaxInstances, out}
);

int {sizeret,VAL_RET}
GetNumberFormat{localeop, unicode}(
		LCID Locale {Locale},
		DWORD dwFlags {dwFlags},
		LPCWSTR lpValue {lpValue, nterm},
		const NUMBERFMTW * lpFormat {lpFormat},
		LPWSTR lpNumberStr {lpNumberStr},
		int cchNumber {cchNumber}
);

BOOL {boolret, BOOL_RET}
GetNumberOfConsoleInputEvents{consoleop, handleop}(
		HANDLE hConsoleInput {hConsoleInput, handle, fd},
		LPDWORD lpNumberOfEvents {lpNumberOfEvents, out}
);

BOOL {boolret, BOOL_RET}
GetNumberOfConsoleMouseButtons{consoleop}(
		LPDWORD lpNumberOfMouseButtons {lpNumberOfMouseButtons, out}
);

BOOL {boolret, BOOL_RET}
GetNumberOfEventLogRecords{eventlogop, handleop, syncop}(
		HANDLE hEventLog {hEventLog, handle, fd},
		PDWORD NumberOfRecords {NumberOfRecords}
);

UINT {sizeret, NONZERO_RET}
GetOEMCP{localeop}( void );

BOOL {boolret, BOOL_RET}
GetOldestEventLogRecord{eventlogop, handleop, syncop}(
		HANDLE hEventLog {hEventLog, handle, fd},
		PDWORD OldestRecord {OldestRecord}
);

BOOL {boolret, BOOL_RET}
GetOverlappedResult{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout},
		LPDWORD lpNumberOfBytesTransferred {lpNumberOfBytesTransferred, out},
		BOOL bWait {bWait}
);

DWORD {NOERR_RET}
GetPriorityClass{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd}
);

BOOL {boolret, BOOL_RET}
GetPrivateObjectSecurity{aclop, nativeop}(
		PSECURITY_DESCRIPTOR ObjectDescriptor {ObjectDescriptor},
		SECURITY_INFORMATION SecurityInformation {SecurityInformation},
		PSECURITY_DESCRIPTOR ResultantDescriptor {ResultantDescriptor},
		DWORD DescriptorLength {DescriptorLength},
		PDWORD ReturnLength {ReturnLength}
);

UINT {sizeret, NONZERO_RET}
GetPrivateProfileInt{registryop, unicode}(
		LPCWSTR lpAppName {lpAppName, nterm},
		LPCWSTR lpKeyName {lpKeyName, nterm},
		INT nDefault {nDefault},
		LPCWSTR lpFileName {lpFileName, path, nterm}
);

DWORD {NOERR_RET}
GetPrivateProfileSectionNames{registryop, unicode}(
		LPWSTR lpszReturnBuffer {lpszReturnBuffer},
		DWORD nSize {nSize, nbytes},
		LPCWSTR lpFileName {lpFileName, path, nterm}
);

DWORD {NOERR_RET}
GetPrivateProfileSection{registryop, unicode}(
		LPCWSTR lpAppName {lpAppName, nterm},
		LPWSTR lpReturnedString {lpReturnedString},
		DWORD nSize {nSize, nbytes},
		LPCWSTR lpFileName {lpFileName, path, nterm}
);

DWORD {NOERR_RET}
GetPrivateProfileString{registryop, unicode}(
		LPCWSTR lpAppName {lpAppName, nterm},
		LPCWSTR lpKeyName {lpKeyName, nterm},
		LPCWSTR lpDefault {lpDefault, nterm},
		LPWSTR lpReturnedString {lpReturnedString},
		DWORD nSize {nSize, nbytes},
		LPCWSTR lpFileName {lpFileName, path, nterm}
);

BOOL {boolret, BOOL_RET}
GetPrivateProfileStruct{registryop, unicode}(
		LPCWSTR lpszSection {lpszSection, nterm},
		LPCWSTR lpszKey {lpszKey, nterm},
		LPVOID lpStruct {lpStruct, out},
		UINT uSizeStruct {uSizeStruct},
		LPCWSTR szFile {szFile, nterm}
);

FARPROC {pointerret, NONNULL_RET}
GetProcAddress{moduleop}(
		HMODULE hModule {hModule},
		LPCSTR lpProcName {lpProcName, nterm}
);

BOOL {boolret, BOOL_RET}
GetProcessAffinityMask{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		PDWORD_PTR lpProcessAffinityMask {lpProcessAffinityMask},
		PDWORD_PTR lpSystemAffinityMask {lpSystemAffinityMask}
);

HANDLE {handleret, HANDLE_RET}
GetProcessHeap{processop}( void );

DWORD {NOERR_RET}
GetProcessHeaps{processop}(
		DWORD NumberOfHeaps {NumberOfHeaps},
		PHANDLE ProcessHeaps {ProcessHeaps}
);

BOOL {boolret, BOOL_RET}
GetProcessIoCounters{handleop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		PIO_COUNTERS lpIoCounters {lpIoCounters}
);

BOOL {boolret, BOOL_RET}
GetProcessPriorityBoost{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		PBOOL pDisablePriorityBoost {pDisablePriorityBoost}
);

BOOL {boolret, BOOL_RET}
GetProcessShutdownParameters{nativeop, processop}(
		LPDWORD lpdwLevel {lpdwLevel, out},
		LPDWORD lpdwFlags {lpdwFlags, out}
);

BOOL {boolret, BOOL_RET}
GetProcessTimes{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		LPFILETIME lpCreationTime {lpCreationTime},
		LPFILETIME lpExitTime {lpExitTime},
		LPFILETIME lpKernelTime {lpKernelTime},
		LPFILETIME lpUserTime {lpUserTime}
);

DWORD {NOERR_RET}
GetProcessVersion{nativeop, processop}(
		DWORD ProcessId {ProcessId}
);

BOOL {boolret, BOOL_RET}
GetProcessWorkingSetSize{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		PSIZE_T lpMinimumWorkingSetSize {lpMinimumWorkingSetSize},
		PSIZE_T lpMaximumWorkingSetSize {lpMaximumWorkingSetSize}
);

UINT {sizeret, NONZERO_RET}
GetProfileInt{registryop, unicode}(
		LPCWSTR lpAppName {lpAppName, nterm},
		LPCWSTR lpKeyName {lpKeyName, nterm},
		INT nDefault {nDefault}
);

DWORD {NOERR_RET}
GetProfileSection{registryop, unicode}(
		LPCWSTR lpAppName {lpAppName, nterm},
		LPWSTR lpReturnedString {lpReturnedString},
		DWORD nSize {nSize, nbytes}
);

DWORD {NOERR_RET}
GetProfileString{registryop, unicode}(
		LPCWSTR lpAppName {lpAppName, nterm},
		LPCWSTR lpKeyName {lpKeyName, nterm},
		LPCWSTR lpDefault {lpDefault, nterm},
		LPWSTR lpReturnedString {lpReturnedString},
		DWORD nSize {nSize, nbytes}
);

BOOL {boolret, BOOL_RET}
GetQueuedCompletionStatus{handleop}(
		HANDLE CompletionPort {CompletionPort, handle, fd},
		LPDWORD lpNumberOfBytesTransferred {lpNumberOfBytesTransferred, out},
		PULONG_PTR lpCompletionKey {lpCompletionKey},
		LPOVERLAPPED * lpOverlapped {lpOverlapped},
		DWORD dwMilliseconds {dwMilliseconds}
);

BOOL {boolret, BOOL_RET}
GetSecurityDescriptorControl{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		PSECURITY_DESCRIPTOR_CONTROL pControl {pControl},
		LPDWORD lpdwRevision {lpdwRevision, out}
);

BOOL {boolret, BOOL_RET}
GetSecurityDescriptorDacl{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		LPBOOL lpbDaclPresent {lpbDaclPresent},
		PACL * pDacl {pDacl},
		LPBOOL lpbDaclDefaulted {lpbDaclDefaulted}
);

BOOL {boolret, BOOL_RET}
GetSecurityDescriptorGroup{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		PSID * pGroup {pGroup},
		LPBOOL lpbGroupDefaulted {lpbGroupDefaulted}
);

DWORD {NOERR_RET}
GetSecurityDescriptorLength{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor}
);

BOOL {boolret, BOOL_RET}
GetSecurityDescriptorOwner{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		PSID * pOwner {pOwner},
		LPBOOL lpbOwnerDefaulted {lpbOwnerDefaulted}
);

DWORD {NOERR_RET}
GetSecurityDescriptorRMControl{aclop}(
		PSECURITY_DESCRIPTOR SecurityDescriptor {SecurityDescriptor},
		PUCHAR RMControl {RMControl}
);

BOOL {boolret, BOOL_RET}
GetSecurityDescriptorSacl{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		LPBOOL lpbSaclPresent {lpbSaclPresent},
		PACL * pSacl {pSacl},
		LPBOOL lpbSaclDefaulted {lpbSaclDefaulted}
);

BOOL {boolret, BOOL_RET}
GetServiceDisplayName{handleop, serviceop, unicode}(
		SC_HANDLE hSCManager {hSCManager, handle},
		LPCWSTR lpServiceName {lpServiceName, nterm},
		LPWSTR lpDisplayName {lpDisplayName},
		LPDWORD lpcchBuffer {lpcchBuffer, out}
);

BOOL {boolret, BOOL_RET}
GetServiceKeyName{handleop, serviceop, unicode}(
		SC_HANDLE hSCManager {hSCManager, handle},
		LPCWSTR lpDisplayName {lpDisplayName, nterm},
		LPWSTR lpServiceName {lpServiceName},
		LPDWORD lpcchBuffer {lpcchBuffer, out}
);

DWORD {NOERR_RET}
GetShortPathName{fileop, nativeop, unicode}(
		LPCWSTR lpszLongPath {lpszLongPath, nterm},
		LPWSTR lpszShortPath {lpszShortPath},
		DWORD cchBuffer {cchBuffer}
);

PSID_IDENTIFIER_AUTHORITY {psid_identifier_authorityret, PSID_IDENTIFIER_AUTHORITY_RET}
GetSidIdentifierAuthority{sidop}(
		PSID pSid {pSid, sid}
);

DWORD {NOERR_RET}
GetSidLengthRequired{sidop}(
		UCHAR nSubAuthorityCount {nSubAuthorityCount}
);

PDWORD {pdwordret}
GetSidSubAuthority{sidop}(
		PSID pSid {pSid, sid},
		DWORD nSubAuthority {nSubAuthority}
);

PUCHAR {pucharret}
GetSidSubAuthorityCount{sidop}(
		PSID pSid {pSid, sid}
);

ULONG 
GetSiteDirectory{fileop, handleop, unicode}(
		HANDLE hToken {hToken, handle, fd},
		LPWSTR pszSiteDirectory {pszSiteDirectory},
		ULONG uSize {uSize}
);

HRESULT 
GetSiteNameFromSid{sidop}(
		PSID pSid {pSid, sid},
		LPWSTR * pwsSite {pwsSite}
);

PSID 
GetSiteSidFromToken{handleop, sidop}(
		HANDLE TokenHandle {TokenHandle, handle, fd}
);

PSID 
GetSiteSidFromUrl{sidop}(
		LPCWSTR pszUrl {pszUrl, nterm}
);

void {NO_RET}
GetStartupInfo{processop, unicode}(
		LPSTARTUPINFOW lpStartupInfo {lpStartupInfo}
);

HANDLE {handleret, HANDLE_RET}
GetStdHandle{fdretop, fileop, handleretop}(
		DWORD nStdHandle {nStdHandle}
);

BOOL {boolret, BOOL_RET}
GetStringTypeEx{localeop, stringop, unicode}(
		LCID Locale {Locale},
		DWORD dwInfoType {dwInfoType},
		LPCWSTR lpSrcStr {lpSrcStr, nterm},
		int cchSrc {cchSrc},
		LPWORD lpCharType {lpCharType}
);

BOOL {boolret, BOOL_RET}
GetStringType{stringop, unicode}(
		DWORD dwInfoType {dwInfoType},
		LPCWSTR lpSrcStr {lpSrcStr, nterm},
		int cchSrc {cchSrc},
		LPWORD lpCharType {lpCharType}
);

LCID {localeret, NOERR_RET}
GetSystemDefaultLCID{localeop}( void );

LANGID {langret, NONZERO_RET}
GetSystemDefaultLangID{localeop}( void );

UINT {sizeret, NONZERO_RET}
GetSystemDirectory{fileop, unicode}(
		LPWSTR lpBuffer {lpBuffer, outpath, nterm},
		UINT uSize {uSize}
);

void {NO_RET}
GetSystemInfo{sysinfoop}(
		LPSYSTEM_INFO lpSystemInfo {lpSystemInfo}
);

void {NO_RET}
GetSystemTime{dateop, nativeop}(
		LPSYSTEMTIME lpSystemTime {lpSystemTime}
);

BOOL {boolret, BOOL_RET}
GetSystemTimeAdjustment{dateop}(
		PDWORD lpTimeAdjustment {lpTimeAdjustment},
		PDWORD lpTimeIncrement {lpTimeIncrement},
		PBOOL lpTimeAdjustmentDisabled {lpTimeAdjustmentDisabled}
);

void {NO_RET}
GetSystemTimeAsFileTime{dateop}(
		LPFILETIME lpSystemTimeAsFileTime {lpSystemTimeAsFileTime}
);

UINT {sizeret, NONZERO_RET}
GetSystemWindowsDirectory{fileop, unicode}(
		LPWSTR lpBuffer {lpBuffer, outpath, nterm},
		UINT uSize {uSize}
);

DWORD {NOERR_RET}
GetTapeParameters{handleop}(
		HANDLE hDevice {hDevice, handle, fd},
		DWORD dwOperation {dwOperation},
		LPDWORD lpdwSize {lpdwSize, out},
		LPVOID lpTapeInformation {lpTapeInformation, out}
);

DWORD {NOERR_RET}
GetTapePosition{handleop}(
		HANDLE hDevice {hDevice, handle, fd},
		DWORD dwPositionType {dwPositionType},
		LPDWORD lpdwPartition {lpdwPartition, out},
		LPDWORD lpdwOffsetLow {lpdwOffsetLow, out},
		LPDWORD lpdwOffsetHigh {lpdwOffsetHigh, out}
);

DWORD {NOERR_RET}
GetTapeStatus{handleop}(
		HANDLE hDevice {hDevice, handle, fd}
);

UINT {sizeret, NONZERO_RET}
GetTempFileName{fileop, unicode}(
		LPCWSTR lpPathName {lpPathName, path, nterm},
		LPCWSTR lpPrefixString {lpPrefixString, nterm},
		UINT uUnique {uUnique},
		LPWSTR lpTempFileName {lpTempFileName}
);

DWORD {NOERR_RET}
GetTempPath{fileop, unicode}(
		DWORD nBufferLength {nBufferLength, nbytes},
		LPWSTR lpBuffer {lpBuffer, outpath, nterm}
);

BOOL {boolret, BOOL_RET}
GetThreadContext{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		LPCONTEXT lpContext {lpContext}
);

LCID {localeret, NOERR_RET}
GetThreadLocale{threadop}( void );

int {sizeret,VAL_RET}
GetThreadPriority{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd}
);

BOOL {boolret, BOOL_RET}
GetThreadPriorityBoost{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		PBOOL pDisablePriorityBoost {pDisablePriorityBoost}
);

BOOL {boolret, BOOL_RET}
GetThreadSelectorEntry{handleop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		DWORD dwSelector {dwSelector},
		LPLDT_ENTRY lpSelectorEntry {lpSelectorEntry}
);

BOOL {boolret, BOOL_RET}
GetThreadTimes{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		LPFILETIME lpCreationTime {lpCreationTime},
		LPFILETIME lpExitTime {lpExitTime},
		LPFILETIME lpKernelTime {lpKernelTime},
		LPFILETIME lpUserTime {lpUserTime}
);

DWORD {NOERR_RET}
GetTickCount{timerop}( void );

int {sizeret,VAL_RET}
GetTimeFormat{localeop, unicode}(
		LCID Locale {Locale},
		DWORD dwFlags {dwFlags},
		const SYSTEMTIME * lpTime {lpTime},
		LPCWSTR lpFormat {lpFormat, nterm},
		LPWSTR lpTimeStr {lpTimeStr},
		int cchTime {cchTime}
);

DWORD {NOERR_RET}
GetTimeZoneInformation{dateop}(
		LPTIME_ZONE_INFORMATION lpTimeZoneInformation {lpTimeZoneInformation}
);

BOOL {boolret, BOOL_RET}
GetTokenInformation{handleop, nativeop, tokenop}(
		HANDLE TokenHandle {TokenHandle, handle, fd},
		TOKEN_INFORMATION_CLASS TokenInformationClass {TokenInformationClass},
		LPVOID TokenInformation {TokenInformation},
		DWORD TokenInformationLength {TokenInformationLength},
		PDWORD ReturnLength {ReturnLength}
);

LCID {localeret, NOERR_RET}
GetUserDefaultLCID{localeop}( void );

LANGID {langret, NONZERO_RET}
GetUserDefaultLangID{localeop}( void );

BOOL {boolret, BOOL_RET}
GetUserName{sysinfoop, unicode}(
		LPWSTR lpBuffer {lpBuffer, outpath, nterm},
		LPDWORD nSize {nSize, out}
);

DWORD {NOERR_RET}
GetVersion{sysinfoop}( void );

BOOL {boolret, BOOL_RET}
GetVersionEx{sysinfoop, unicode}(
		LPOSVERSIONINFOW lpVersionInformation {lpVersionInformation}
);

BOOL {boolret, BOOL_RET}
GetVolumeInformation{fileop, unicode, volumeop}(
		LPCWSTR lpRootPathName {lpRootPathName, nterm},
		LPWSTR lpVolumeNameBuffer {lpVolumeNameBuffer},
		DWORD nVolumeNameSize {nVolumeNameSize},
		LPDWORD lpVolumeSerialNumber {lpVolumeSerialNumber, out},
		LPDWORD lpMaximumComponentLength {lpMaximumComponentLength, out},
		LPDWORD lpFileSystemFlags {lpFileSystemFlags, out},
		LPWSTR lpFileSystemNameBuffer {lpFileSystemNameBuffer},
		DWORD nFileSystemNameSize {nFileSystemNameSize}
);

BOOL {boolret, BOOL_RET}
GetVolumeNameForVolumeMountPoint{unicode, volumeop}(
		LPCWSTR lpszVolumeMountPoint {lpszVolumeMountPoint, nterm},
		LPWSTR lpszVolumeName {lpszVolumeName},
		DWORD cchBufferLength {cchBufferLength}
);

BOOL {boolret, BOOL_RET}
GetVolumePathName{fileop, unicode}(
		LPCWSTR lpszFileName {lpszFileName, nterm},
		LPWSTR lpszVolumePathName {lpszVolumePathName},
		DWORD cchBufferLength {cchBufferLength}
);

UINT {sizeret, NONZERO_RET}
GetWindowsDirectory{fileop, unicode}(
		LPWSTR lpBuffer {lpBuffer, outpath, nterm},
		UINT uSize {uSize}
);

UINT {sizeret, NONZERO_RET}
GetWriteWatch{memop}(
		DWORD dwFlags {dwFlags},
		PVOID lpBaseAddress {lpBaseAddress},
		SIZE_T dwRegionSize {dwRegionSize},
		PVOID * lpAddresses {lpAddresses},
		PULONG_PTR lpdwCount {lpdwCount},
		PULONG lpdwGranularity {lpdwGranularity}
);

ATOM {atomret, NONZERO_RET}
GlobalAddAtom{atomop, unicode}(
		LPCWSTR lpString {lpString, nterm}
);

HGLOBAL {globalret, NONNULL_RET}
GlobalAlloc{memop}(
		UINT uFlags {uFlags},
		SIZE_T dwBytes {dwBytes}
);

SIZE_T 
GlobalCompact{memop}(
		DWORD dwMinFree {dwMinFree}
);

ATOM {atomret, NONZERO_RET}
GlobalDeleteAtom{atomop}(
		ATOM nAtom {nAtom}
);

ATOM {atomret, NONZERO_RET}
GlobalFindAtom{atomop, unicode}(
		LPCWSTR lpString {lpString, nterm}
);

void {NO_RET}
GlobalFix{handleop, memop}(
		HGLOBAL hMem {hMem, memory, handle, fd}
);

UINT {sizeret, NONZERO_RET}
GlobalFlags{handleop, memop}(
		HGLOBAL hMem {hMem, memory, handle, fd}
);

HGLOBAL {globalret, NONNULL_RET}
GlobalFree{handleop, memop}(
		HGLOBAL hMem {hMem, memory, handle, fd}
);

UINT {sizeret, NONZERO_RET}
GlobalGetAtomName{atomop, unicode}(
		ATOM nAtom {nAtom},
		LPWSTR lpBuffer {lpBuffer},
		int nSize {nSize}
);

HGLOBAL {globalret, NONNULL_RET}
GlobalHandle{memop}(
		LPCVOID pMem {pMem}
);

LPVOID {pointerret, NONNULL_RET}
GlobalLock{handleop, memop}(
		HGLOBAL hMem {hMem, memory, handle, fd}
);

void {NO_RET}
GlobalMemoryStatus{memop}(
		LPMEMORYSTATUS lpBuffer {lpBuffer}
);

BOOL {boolret, BOOL_RET}
GlobalMemoryStatusEx{memop}(
		LPMEMORYSTATUSEX lpBuffer {lpBuffer}
);

HGLOBAL {globalret, NONNULL_RET}
GlobalReAlloc{handleop, memop}(
		HGLOBAL hMem {hMem, memory, handle, fd},
		SIZE_T dwBytes {dwBytes},
		UINT uFlags {uFlags}
);

SIZE_T 
GlobalSize{handleop, memop}(
		HGLOBAL hMem {hMem, memory, handle, fd}
);

BOOL {boolret, BOOL_RET}
GlobalUnWire{handleop, memop}(
		HGLOBAL hMem {hMem, memory, handle, fd}
);

void {NO_RET}
GlobalUnfix{handleop, memop}(
		HGLOBAL hMem {hMem, memory, handle, fd}
);

BOOL {boolret, BOOL_RET}
GlobalUnlock{handleop, memop}(
		HGLOBAL hMem {hMem, memory, handle, fd}
);

LPVOID {pointerret, NONNULL_RET}
GlobalWire{handleop, memop}(
		HGLOBAL hMem {hMem, memory, handle, fd}
);

SIZE_T 
HeapCompact{handleop, memop}(
		HANDLE hHeap {hHeap, handle, fd},
		DWORD dwFlags {dwFlags}
);

HANDLE {handleret, HANDLE_RET}
HeapCreate{fdretop, handleretop, memop}(
		DWORD flOptions {flOptions},
		SIZE_T dwInitialSize {dwInitialSize},
		SIZE_T dwMaximumSize {dwMaximumSize}
);

BOOL {boolret, BOOL_RET}
HeapDestroy{handleop, memop}(
		HANDLE hHeap {hHeap, handle, fd}
);

BOOL {boolret, BOOL_RET}
HeapLock{handleop, memop}(
		HANDLE hHeap {hHeap, handle, fd}
);

BOOL {boolret, BOOL_RET}
HeapUnlock{handleop, memop}(
		HANDLE hHeap {hHeap, handle, fd}
);

BOOL {boolret, BOOL_RET}
HeapValidate{handleop, memop}(
		HANDLE hHeap {hHeap, handle, fd},
		DWORD dwFlags {dwFlags},
		LPCVOID lpMem {lpMem}
);

BOOL {boolret, BOOL_RET}
HeapWalk{handleop, memop}(
		HANDLE hHeap {hHeap, handle, fd},
		LPPROCESS_HEAP_ENTRY lpEntry {lpEntry}
);

BOOL {boolret, BOOL_RET}
ImpersonateAnonymousToken{handleop, tokenop}(
		HANDLE ThreadHandle {ThreadHandle, handle, fd}
);

BOOL {boolret, BOOL_RET}
ImpersonateLoggedOnUser{handleop, nativeop}(
		HANDLE hToken {hToken, handle, fd}
);

BOOL {boolret, BOOL_RET}
ImpersonateNamedPipeClient{handleop, ipcop, pipeop}(
		HANDLE hNamedPipe {hNamedPipe, handle, fd}
);

BOOL {boolret, BOOL_RET}
ImpersonateSelf{aclop}(
		SECURITY_IMPERSONATION_LEVEL ImpersonationLevel {ImpersonationLevel}
);

BOOL {boolret, BOOL_RET}
InitAtomTable{atomop}(
		DWORD nSize {nSize, nbytes}
);

BOOL {boolret, BOOL_RET}
InitializeAcl{aclop}(
		PACL pAcl {pAcl, acl},
		DWORD nAclLength {nAclLength},
		DWORD dwAclRevision {dwAclRevision}
);

void {NO_RET}
InitializeCriticalSection{syncop}(
		LPCRITICAL_SECTION lpCriticalSection {lpCriticalSection}
);

BOOL {boolret, BOOL_RET}
InitializeCriticalSectionAndSpinCount{syncop}(
		LPCRITICAL_SECTION lpCriticalSection {lpCriticalSection},
		DWORD dwSpinCount {dwSpinCount}
);

BOOL {boolret, BOOL_RET}
InitializeSecurityDescriptor{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		DWORD dwRevision {dwRevision}
);

BOOL {boolret, BOOL_RET}
InitializeSid{sidop}(
		PSID Sid {Sid, sid},
		PSID_IDENTIFIER_AUTHORITY pIdentifierAuthority {pIdentifierAuthority},
		BYTE nSubAuthorityCount {nSubAuthorityCount}
);

BOOL {boolret, BOOL_RET}
InitiateSystemShutdownEx{systemop, unicode}(
		LPWSTR lpMachineName {lpMachineName},
		LPWSTR lpMessage {lpMessage},
		DWORD dwTimeout {dwTimeout},
		BOOL bForceAppsClosed {bForceAppsClosed},
		BOOL bRebootAfterShutdown {bRebootAfterShutdown},
		DWORD dwReason {dwReason}
);

BOOL {boolret, BOOL_RET}
InitiateSystemShutdown{systemop, unicode}(
		LPWSTR lpMachineName {lpMachineName},
		LPWSTR lpMessage {lpMessage},
		DWORD dwTimeout {dwTimeout},
		BOOL bForceAppsClosed {bForceAppsClosed},
		BOOL bRebootAfterShutdown {bRebootAfterShutdown}
);

LONG {errret, ZERO_RET}
InterlockedCompareExchange{syncop}(
		LPLONG Destination {Destination},
		LONG Exchange {Exchange},
		LONG Comperand {Comperand}
);

LONG {errret, ZERO_RET}
InterlockedDecrement{syncop}(
		LPLONG lpAddend {lpAddend}
);

LONG {errret, ZERO_RET}
InterlockedExchange{syncop}(
		LPLONG Target {Target},
		LONG Value {Value}
);

LONG {errret, ZERO_RET}
InterlockedExchangeAdd{syncop}(
		LPLONG Addend {Addend},
		LONG Value {Value}
);

LONG {errret, ZERO_RET}
InterlockedIncrement{syncop}(
		LPLONG lpAddend {lpAddend}
);

BOOL {boolret, BOOL_RET}
IsBadCodePtr{memop}(
		FARPROC lpfn {lpfn}
);

BOOL {boolret, BOOL_RET}
IsBadHugeReadPtr{memop}(
		const void * lp {lp},
		UINT_PTR ucb {ucb}
);

BOOL {boolret, BOOL_RET}
IsBadHugeWritePtr{memop}(
		LPVOID lp {lp},
		UINT_PTR ucb {ucb}
);

BOOL {boolret, BOOL_RET}
IsBadReadPtr{memop}(
		const void * lp {lp},
		UINT_PTR ucb {ucb}
);

BOOL {boolret, BOOL_RET}
IsBadStringPtr{memop, unicode}(
		LPCWSTR lpsz {lpsz, nterm},
		UINT_PTR ucchMax {ucchMax}
);

BOOL {boolret, BOOL_RET}
IsBadWritePtr{memop}(
		LPVOID lp {lp},
		UINT_PTR ucb {ucb}
);

BOOL {boolret, BOOL_RET}
IsDBCSLeadByte{stringop}(
		BYTE TestChar {TestChar}
);

BOOL {boolret, BOOL_RET}
IsDBCSLeadByteEx{localeop, stringop}(
		UINT CodePage {CodePage},
		BYTE TestChar {TestChar}
);

BOOL {boolret, BOOL_RET}
IsDebuggerPresent{debugop}( void );

BOOL {boolret, BOOL_RET}
IsProcessRestricted{processop}( void );

BOOL {boolret, BOOL_RET}
IsProcessorFeaturePresent{processop}(
		DWORD ProcessorFeature {ProcessorFeature}
);

BOOL {boolret, BOOL_RET}
IsSystemResumeAutomatic{powerop}( void );

BOOL {boolret, BOOL_RET}
IsTextUnicode{stringop}(
		const LPVOID lpBuffer {lpBuffer},
		int cb {cb},
		LPINT lpi {lpi}
);

BOOL {boolret, BOOL_RET}
IsTokenRestricted{handleop, tokenop}(
		HANDLE TokenHandle {TokenHandle, handle, fd}
);

BOOL {boolret, BOOL_RET}
IsValidAcl{aclop}(
		PACL pAcl {pAcl, acl}
);

BOOL {boolret, BOOL_RET}
IsValidCodePage{localeop}(
		UINT CodePage {CodePage}
);

BOOL {boolret, BOOL_RET}
IsValidLocale{localeop}(
		LCID Locale {Locale},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
IsValidSecurityDescriptor{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor}
);

BOOL {boolret, BOOL_RET}
IsValidSid{sidop}(
		PSID pSid {pSid, sid}
);

int {sizeret,VAL_RET}
LCMapString{localeop, unicode}(
		LCID Locale {Locale},
		DWORD dwMapFlags {dwMapFlags},
		LPCWSTR lpSrcStr {lpSrcStr, nterm},
		int cchSrc {cchSrc},
		LPWSTR lpDestStr {lpDestStr},
		int cchDest {cchDest}
);

HMODULE {moduleret, NONNULL_RET}
LoadLibraryEx{moduleop, unicode}(
		LPCWSTR lpLibFileName {lpLibFileName, nterm},
		HANDLE hFile {hFile, handle, fd},
		DWORD dwFlags {dwFlags}
);

HMODULE {moduleret, NONNULL_RET}
LoadLibrary{moduleop, unicode}(
		LPCWSTR lpLibFileName {lpLibFileName, nterm}
);

DWORD {NOERR_RET}
LoadModule{moduleop}(
		LPCSTR lpModuleName {lpModuleName, nterm},
		LPVOID lpParameterBlock {lpParameterBlock}
);

HGLOBAL {globalret, NONNULL_RET}
LoadResource{moduleop, resourceop}(
		HMODULE hModule {hModule},
		HRSRC hResInfo {hResInfo}
);

HLOCAL {localret, NONNULL_RET}
LocalAlloc{memop}(
		UINT uFlags {uFlags},
		SIZE_T uBytes {uBytes}
);

SIZE_T 
LocalCompact{memop}(
		UINT uMinFree {uMinFree}
);

BOOL {boolret, BOOL_RET}
LocalFileTimeToFileTime{dateop}(
		const FILETIME * lpLocalFileTime {lpLocalFileTime},
		LPFILETIME lpFileTime {lpFileTime}
);

UINT {sizeret, NONZERO_RET}
LocalFlags{handleop, memop}(
		HLOCAL hMem {hMem, memory, handle, fd}
);

HLOCAL {localret, NONNULL_RET}
LocalFree{handleop, memop}(
		HLOCAL hMem {hMem, memory, handle, fd}
);

HLOCAL {localret, NONNULL_RET}
LocalHandle{memop}(
		LPCVOID pMem {pMem}
);

LPVOID {pointerret, NONNULL_RET}
LocalLock{handleop, memop}(
		HLOCAL hMem {hMem, memory, handle, fd}
);

HLOCAL {localret, NONNULL_RET}
LocalReAlloc{handleop, memop}(
		HLOCAL hMem {hMem, memory, handle, fd},
		SIZE_T uBytes {uBytes},
		UINT uFlags {uFlags}
);

SIZE_T 
LocalShrink{handleop, memop}(
		HLOCAL hMem {hMem, memory, handle, fd},
		UINT cbNewSize {cbNewSize}
);

SIZE_T 
LocalSize{handleop, memop}(
		HLOCAL hMem {hMem, memory, handle, fd}
);

BOOL {boolret, BOOL_RET}
LocalUnlock{handleop, memop}(
		HLOCAL hMem {hMem, memory, handle, fd}
);

BOOL {boolret, BOOL_RET}
LockFile{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		DWORD dwFileOffsetLow {dwFileOffsetLow},
		DWORD dwFileOffsetHigh {dwFileOffsetHigh},
		DWORD nNumberOfBytesToLockLow {nNumberOfBytesToLockLow},
		DWORD nNumberOfBytesToLockHigh {nNumberOfBytesToLockHigh}
);

BOOL {boolret, BOOL_RET}
LockFileEx{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		DWORD dwFlags {dwFlags},
		DWORD dwReserved {dwReserved},
		DWORD nNumberOfBytesToLockLow {nNumberOfBytesToLockLow},
		DWORD nNumberOfBytesToLockHigh {nNumberOfBytesToLockHigh},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

LPVOID {pointerret, NONNULL_RET}
LockResource{resourceop}(
		HGLOBAL hResData {hResData, memory, handle, fd}
);

SC_LOCK {sc_lockret}
LockServiceDatabase{handleop, serviceop}(
		SC_HANDLE hSCManager {hSCManager, handle}
);

BOOL {boolret, BOOL_RET}
LogonUser{tokenop, unicode}(
		LPWSTR lpszUsername {lpszUsername},
		LPWSTR lpszDomain {lpszDomain},
		LPWSTR lpszPassword {lpszPassword},
		DWORD dwLogonType {dwLogonType},
		DWORD dwLogonProvider {dwLogonProvider},
		PHANDLE phToken {phToken}
);

BOOL {boolret, BOOL_RET}
LookupAccountName{sidop, unicode}(
		LPCWSTR lpSystemName {lpSystemName, nterm},
		LPCWSTR lpAccountName {lpAccountName, nterm},
		PSID Sid {Sid, sid},
		LPDWORD cbSid {cbSid, out},
		LPWSTR ReferencedDomainName {ReferencedDomainName},
		LPDWORD cbReferencedDomainName {cbReferencedDomainName, out},
		PSID_NAME_USE peUse {peUse}
);

BOOL {boolret, BOOL_RET}
LookupAccountSid{sidop, unicode}(
		LPCWSTR lpSystemName {lpSystemName, nterm},
		PSID Sid {Sid, sid},
		LPWSTR Name {Name},
		LPDWORD cbName {cbName, out},
		LPWSTR ReferencedDomainName {ReferencedDomainName},
		LPDWORD cbReferencedDomainName {cbReferencedDomainName, out},
		PSID_NAME_USE peUse {peUse}
);

BOOL {boolret, BOOL_RET}
LookupPrivilegeDisplayName{aclop, unicode}(
		LPCWSTR lpSystemName {lpSystemName, nterm},
		LPCWSTR lpName {lpName, nterm},
		LPWSTR lpDisplayName {lpDisplayName},
		LPDWORD cbDisplayName {cbDisplayName, out},
		LPDWORD lpLanguageId {lpLanguageId, out}
);

BOOL {boolret, BOOL_RET}
LookupPrivilegeName{aclop, unicode}(
		LPCWSTR lpSystemName {lpSystemName, nterm},
		PLUID lpLuid {lpLuid},
		LPWSTR lpName {lpName},
		LPDWORD cbName {cbName, out}
);

BOOL {boolret, BOOL_RET}
LookupPrivilegeValue{aclop, unicode}(
		LPCWSTR lpSystemName {lpSystemName, nterm},
		LPCWSTR lpName {lpName, nterm},
		PLUID lpLuid {lpLuid}
);

BOOL {boolret, BOOL_RET}
MakeAbsoluteSD{aclop}(
		PSECURITY_DESCRIPTOR pSelfRelativeSecurityDescriptor {pSelfRelativeSecurityDescriptor},
		PSECURITY_DESCRIPTOR pAbsoluteSecurityDescriptor {pAbsoluteSecurityDescriptor},
		LPDWORD lpdwAbsoluteSecurityDescriptorSize {lpdwAbsoluteSecurityDescriptorSize, out},
		PACL pDacl {pDacl},
		LPDWORD lpdwDaclSize {lpdwDaclSize, out},
		PACL pSacl {pSacl},
		LPDWORD lpdwSaclSize {lpdwSaclSize, out},
		PSID pOwner {pOwner, sid},
		LPDWORD lpdwOwnerSize {lpdwOwnerSize, out},
		PSID pPrimaryGroup {pPrimaryGroup, sid},
		LPDWORD lpdwPrimaryGroupSize {lpdwPrimaryGroupSize, out}
);

BOOL {boolret, BOOL_RET}
MakeAbsoluteSD2{aclop}(
		PSECURITY_DESCRIPTOR pSelfRelativeSecurityDescriptor {pSelfRelativeSecurityDescriptor},
		LPDWORD lpdwBufferSize {lpdwBufferSize, out}
);

BOOL {boolret, BOOL_RET}
MakeSelfRelativeSD{aclop}(
		PSECURITY_DESCRIPTOR pAbsoluteSecurityDescriptor {pAbsoluteSecurityDescriptor},
		PSECURITY_DESCRIPTOR pSelfRelativeSecurityDescriptor {pSelfRelativeSecurityDescriptor},
		LPDWORD lpdwBufferLength {lpdwBufferLength, out}
);

void {NO_RET}
MapGenericMask{aclop}(
		PDWORD AccessMask {AccessMask},
		PGENERIC_MAPPING GenericMapping {GenericMapping}
);

BOOL {boolret, BOOL_RET}
MapUserPhysicalPages{memop}(
		PVOID VirtualAddress {VirtualAddress},
		ULONG_PTR NumberOfPages {NumberOfPages},
		PULONG_PTR PageArray {PageArray}
);

BOOL {boolret, BOOL_RET}
MapUserPhysicalPagesScatter{memop}(
		PVOID * VirtualAddresses {VirtualAddresses},
		ULONG_PTR NumberOfPages {NumberOfPages},
		PULONG_PTR PageArray {PageArray}
);

LPVOID {pointerret, NONNULL_RET}
MapViewOfFile{fileop, handleop, memop, nativeop}(
		HANDLE hFileMappingObject {hFileMappingObject, handle, fd},
		DWORD dwDesiredAccess {dwDesiredAccess},
		DWORD dwFileOffsetHigh {dwFileOffsetHigh},
		DWORD dwFileOffsetLow {dwFileOffsetLow},
		SIZE_T dwNumberOfBytesToMap {dwNumberOfBytesToMap}
);

LPVOID {pointerret, NONNULL_RET}
MapViewOfFileEx{fileop, handleop, memop}(
		HANDLE hFileMappingObject {hFileMappingObject, handle, fd},
		DWORD dwDesiredAccess {dwDesiredAccess},
		DWORD dwFileOffsetHigh {dwFileOffsetHigh},
		DWORD dwFileOffsetLow {dwFileOffsetLow},
		SIZE_T dwNumberOfBytesToMap {dwNumberOfBytesToMap},
		LPVOID lpBaseAddress {lpBaseAddress}
);

BOOL {boolret, BOOL_RET}
MoveFileEx{fileop, unicode}(
		LPCWSTR lpExistingFileName {lpExistingFileName, path, nterm},
		LPCWSTR lpNewFileName {lpNewFileName, destpath, nterm},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
MoveFile{fileop, unicode}(
		LPCWSTR lpExistingFileName {lpExistingFileName, path, nterm},
		LPCWSTR lpNewFileName {lpNewFileName, destpath, nterm}
);

BOOL {boolret, BOOL_RET}
MoveFileWithProgress{fileop, unicode}(
		LPCWSTR lpExistingFileName {lpExistingFileName, path, nterm},
		LPCWSTR lpNewFileName {lpNewFileName, destpath, nterm},
		LPPROGRESS_ROUTINE lpProgressRoutine {lpProgressRoutine},
		LPVOID lpData {lpData},
		DWORD dwFlags {dwFlags}
);

int {sizeret,VAL_RET}
MulDiv(
		int nNumber {nNumber},
		int nNumerator {nNumerator},
		int nDenominator {nDenominator}
);

int {sizeret,VAL_RET}
MultiByteToWideChar{localeop}(
		UINT CodePage {CodePage},
		DWORD dwFlags {dwFlags},
		LPCSTR lpMultiByteStr {lpMultiByteStr, nterm},
		int cbMultiByte {cbMultiByte},
		LPWSTR lpWideCharStr {lpWideCharStr},
		int cchWideChar {cchWideChar}
);

BOOL {boolret, BOOL_RET}
NotifyBootConfigStatus{serviceop, systemop}(
		BOOL BootAcceptable {BootAcceptable}
);

BOOL {boolret, BOOL_RET}
NotifyChangeEventLog{eventlogop, handleop, syncop}(
		HANDLE hEventLog {hEventLog, handle, fd},
		HANDLE hEvent {hEvent, handle, fd}
);

BOOL {boolret, BOOL_RET}
ObjectCloseAuditAlarm{aclop, nativeop, unicode}(
		LPCWSTR SubsystemName {SubsystemName, nterm},
		LPVOID HandleId {HandleId},
		BOOL GenerateOnClose {GenerateOnClose}
);

BOOL {boolret, BOOL_RET}
ObjectDeleteAuditAlarm{aclop, nativeop, unicode}(
		LPCWSTR SubsystemName {SubsystemName, nterm},
		LPVOID HandleId {HandleId},
		BOOL GenerateOnClose {GenerateOnClose}
);

BOOL {boolret, BOOL_RET}
ObjectOpenAuditAlarm{aclop, nativeop, unicode}(
		LPCWSTR SubsystemName {SubsystemName, nterm},
		LPVOID HandleId {HandleId},
		LPWSTR ObjectTypeName {ObjectTypeName},
		LPWSTR ObjectName {ObjectName},
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		HANDLE ClientToken {ClientToken, handle, fd},
		DWORD DesiredAccess {DesiredAccess},
		DWORD GrantedAccess {GrantedAccess},
		PPRIVILEGE_SET Privileges {Privileges},
		BOOL ObjectCreation {ObjectCreation},
		BOOL AccessGranted {AccessGranted},
		LPBOOL GenerateOnClose {GenerateOnClose}
);

BOOL {boolret, BOOL_RET}
ObjectPrivilegeAuditAlarm{aclop, nativeop, unicode}(
		LPCWSTR SubsystemName {SubsystemName, nterm},
		LPVOID HandleId {HandleId},
		HANDLE ClientToken {ClientToken, handle, fd},
		DWORD DesiredAccess {DesiredAccess},
		PPRIVILEGE_SET Privileges {Privileges},
		BOOL AccessGranted {AccessGranted}
);

HANDLE {handleret, HANDLE_RET}
OpenBackupEventLog{fdretop, fileop, handleretop, syncop, unicode}(
		LPCWSTR lpUNCServerName {lpUNCServerName, nterm},
		LPCWSTR lpFileName {lpFileName, path, nterm}
);

DWORD {NOERR_RET}
OpenEncryptedFileRaw{cryptop, fileop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		ULONG ulFlags {ulFlags},
		PVOID * pvContext {pvContext}
);

HANDLE {handleret, HANDLE_RET}
OpenEventLog{fdretop, fileop, handleretop, syncop, unicode}(
		LPCWSTR lpUNCServerName {lpUNCServerName, nterm},
		LPCWSTR lpSourceName {lpSourceName, nterm}
);

HANDLE {handleret, HANDLE_RET}
OpenEvent{fdretop, handleretop, nativeop, syncop, unicode}(
		DWORD dwDesiredAccess {dwDesiredAccess},
		BOOL bInheritHandle {bInheritHandle},
		LPCWSTR lpName {lpName, nterm}
);

HFILE {handleret, HANDLE_RET}
OpenFile{fileop, nativeop}(
		LPCSTR lpFileName {lpFileName, path, nterm},
		LPOFSTRUCT lpReOpenBuff {lpReOpenBuff},
		UINT uStyle {uStyle}
);

HANDLE {handleret, HANDLE_RET}
OpenFileMapping{fdretop, fileop, handleretop, nativeop, unicode}(
		DWORD dwDesiredAccess {dwDesiredAccess},
		BOOL bInheritHandle {bInheritHandle},
		LPCWSTR lpName {lpName, nterm}
);

HANDLE {handleret, HANDLE_RET}
OpenJobObject{fdretop, handleretop, jobobjectop, unicode}(
		DWORD dwDesiredAccess {dwDesiredAccess},
		BOOL bInheritHandle {bInheritHandle},
		LPCWSTR lpName {lpName, nterm}
);

HANDLE {handleret, HANDLE_RET}
OpenMutex{fdretop, handleretop, nativeop, syncop, unicode}(
		DWORD dwDesiredAccess {dwDesiredAccess},
		BOOL bInheritHandle {bInheritHandle},
		LPCWSTR lpName {lpName, nterm}
);

HANDLE {handleret, HANDLE_RET}
OpenProcess{fdretop, handleretop, nativeop, processop}(
		DWORD dwDesiredAccess {dwDesiredAccess},
		BOOL bInheritHandle {bInheritHandle},
		DWORD dwProcessId {dwProcessId}
);

BOOL {boolret, BOOL_RET}
OpenProcessToken{handleop, nativeop, processop}(
		HANDLE ProcessHandle {ProcessHandle, handle, fd},
		DWORD DesiredAccess {DesiredAccess},
		PHANDLE TokenHandle {TokenHandle}
);

SC_HANDLE {sc_handleret, SC_HANDLE_RET}
OpenSCManager{serviceop, unicode}(
		LPCWSTR lpMachineName {lpMachineName, nterm},
		LPCWSTR lpDatabaseName {lpDatabaseName, nterm},
		DWORD dwDesiredAccess {dwDesiredAccess}
);

HANDLE {handleret, HANDLE_RET}
OpenSemaphore{fdretop, handleretop, nativeop, syncop, unicode}(
		DWORD dwDesiredAccess {dwDesiredAccess},
		BOOL bInheritHandle {bInheritHandle},
		LPCWSTR lpName {lpName, nterm}
);

SC_HANDLE {sc_handleret, SC_HANDLE_RET}
OpenService{handleop, serviceop, unicode}(
		SC_HANDLE hSCManager {hSCManager, handle},
		LPCWSTR lpServiceName {lpServiceName, nterm},
		DWORD dwDesiredAccess {dwDesiredAccess}
);

HANDLE {handleret, HANDLE_RET}
OpenThread{fdretop, handleretop, nativeop, threadop}(
		DWORD dwDesiredAccess {dwDesiredAccess},
		BOOL bInheritHandle {bInheritHandle},
		DWORD dwThreadId {dwThreadId}
);

BOOL {boolret, BOOL_RET}
OpenThreadToken{handleop, nativeop, threadop}(
		HANDLE ThreadHandle {ThreadHandle, handle, fd},
		DWORD DesiredAccess {DesiredAccess},
		BOOL OpenAsSelf {OpenAsSelf},
		PHANDLE TokenHandle {TokenHandle}
);

HANDLE {handleret, HANDLE_RET}
OpenWaitableTimer{fdretop, handleretop, nativeop, timerop, unicode}(
		DWORD dwDesiredAccess {dwDesiredAccess},
		BOOL bInheritHandle {bInheritHandle},
		LPCWSTR lpTimerName {lpTimerName, nterm}
);

void {NO_RET}
OutputDebugString{debugop, unicode}(
		LPCWSTR lpOutputString {lpOutputString, nterm}
);

BOOL {boolret, BOOL_RET}
PeekConsoleInput{consoleop, handleop, unicode}(
		HANDLE hConsoleInput {hConsoleInput, handle, fd},
		PINPUT_RECORD lpBuffer {lpBuffer},
		DWORD nLength {nLength},
		LPDWORD lpNumberOfEventsRead {lpNumberOfEventsRead, out}
);

BOOL {boolret, BOOL_RET}
PeekNamedPipe{handleop, ipcop, pipeop}(
		HANDLE hNamedPipe {hNamedPipe, handle, fd},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,nBufferSize), out},
		DWORD nBufferSize {nBufferSize, nbytes},
		LPDWORD lpBytesRead {lpBytesRead, out},
		LPDWORD lpTotalBytesAvail {lpTotalBytesAvail, out},
		LPDWORD lpBytesLeftThisMessage {lpBytesLeftThisMessage, out}
);

BOOL {boolret, BOOL_RET}
PostQueuedCompletionStatus{handleop}(
		HANDLE CompletionPort {CompletionPort, handle, fd},
		DWORD dwNumberOfBytesTransferred {dwNumberOfBytesTransferred},
		ULONG_PTR dwCompletionKey {dwCompletionKey},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

DWORD {NOERR_RET}
PrepareTape{handleop}(
		HANDLE hDevice {hDevice, handle, fd},
		DWORD dwOperation {dwOperation},
		BOOL bImmediate {bImmediate}
);

BOOL {boolret, BOOL_RET}
PrivilegeCheck{aclop, handleop, nativeop}(
		HANDLE ClientToken {ClientToken, handle, fd},
		PPRIVILEGE_SET RequiredPrivileges {RequiredPrivileges},
		LPBOOL pfResult {pfResult}
);

BOOL {boolret, BOOL_RET}
PrivilegedServiceAuditAlarm{aclop, nativeop, unicode}(
		LPCWSTR SubsystemName {SubsystemName, nterm},
		LPCWSTR ServiceName {ServiceName, nterm},
		HANDLE ClientToken {ClientToken, handle, fd},
		PPRIVILEGE_SET Privileges {Privileges},
		BOOL AccessGranted {AccessGranted}
);

BOOL {boolret, BOOL_RET}
ProcessIdToSessionId{processop}(
		DWORD dwProcessId {dwProcessId},
		DWORD * pSessionId {pSessionId}
);

BOOL {boolret, BOOL_RET}
PulseEvent{handleop, ipcop, nativeop, syncop}(
		HANDLE hEvent {hEvent, handle, fd}
);

BOOL {boolret, BOOL_RET}
PurgeComm{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		DWORD dwFlags {dwFlags}
);

DWORD {NOERR_RET}
QueryDosDevice{hardwareop, unicode}(
		LPCWSTR lpDeviceName {lpDeviceName, nterm},
		LPWSTR lpTargetPath {lpTargetPath},
		DWORD ucchMax {ucchMax}
);

BOOL {boolret, BOOL_RET}
QueryInformationJobObject{handleop, jobobjectop}(
		HANDLE hJob {hJob, handle, fd},
		JOBOBJECTINFOCLASS JobObjectInformationClass {JobObjectInformationClass},
		LPVOID lpJobObjectInformation {lpJobObjectInformation},
		DWORD cbJobObjectInformationLength {cbJobObjectInformationLength},
		LPDWORD lpReturnLength {lpReturnLength, out}
);

BOOL {boolret, BOOL_RET}
QueryPerformanceCounter{hardwareop, nativeop}(
		LARGE_INTEGER * lpPerformanceCount {lpPerformanceCount}
);

BOOL {boolret, BOOL_RET}
QueryPerformanceFrequency{hardwareop, nativeop}(
		LARGE_INTEGER * lpFrequency {lpFrequency}
);

DWORD {NOERR_RET}
QueryRecoveryAgentsOnEncryptedFile{cryptop, fileop}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		PENCRYPTION_CERTIFICATE_HASH_LIST * pRecoveryAgents {pRecoveryAgents}
);

BOOL {boolret, BOOL_RET}
QueryServiceConfig2{handleop, serviceop, unicode}(
		SC_HANDLE hService {hService, handle},
		DWORD dwInfoLevel {dwInfoLevel},
		LPBYTE lpBuffer {lpBuffer},
		DWORD cbBufSize {cbBufSize, nbytes},
		LPDWORD pcbBytesNeeded {pcbBytesNeeded, out}
);

BOOL {boolret, BOOL_RET}
QueryServiceConfig{handleop, serviceop, unicode}(
		SC_HANDLE hService {hService, handle},
		LPQUERY_SERVICE_CONFIGW lpServiceConfig {lpServiceConfig},
		DWORD cbBufSize {cbBufSize, nbytes},
		LPDWORD pcbBytesNeeded {pcbBytesNeeded, out}
);

BOOL {boolret, BOOL_RET}
QueryServiceLockStatus{handleop, serviceop, unicode}(
		SC_HANDLE hSCManager {hSCManager, handle},
		LPQUERY_SERVICE_LOCK_STATUSW lpLockStatus {lpLockStatus},
		DWORD cbBufSize {cbBufSize, nbytes},
		LPDWORD pcbBytesNeeded {pcbBytesNeeded, out}
);

BOOL {boolret, BOOL_RET}
QueryServiceObjectSecurity{handleop, serviceop}(
		SC_HANDLE hService {hService, handle},
		SECURITY_INFORMATION dwSecurityInformation {dwSecurityInformation},
		PSECURITY_DESCRIPTOR lpSecurityDescriptor {lpSecurityDescriptor},
		DWORD cbBufSize {cbBufSize, nbytes},
		LPDWORD pcbBytesNeeded {pcbBytesNeeded, out}
);

BOOL {boolret, BOOL_RET}
QueryServiceStatus{handleop, serviceop}(
		SC_HANDLE hService {hService, handle},
		LPSERVICE_STATUS lpServiceStatus {lpServiceStatus}
);

BOOL {boolret, BOOL_RET}
QueryServiceStatusEx{handleop, serviceop}(
		SC_HANDLE hService {hService, handle},
		SC_STATUS_TYPE InfoLevel {InfoLevel},
		LPBYTE lpBuffer {lpBuffer},
		DWORD cbBufSize {cbBufSize, nbytes},
		LPDWORD pcbBytesNeeded {pcbBytesNeeded, out}
);

DWORD {NOERR_RET}
QueryUsersOnEncryptedFile{cryptop, fileop}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		PENCRYPTION_CERTIFICATE_HASH_LIST * pUsers {pUsers}
);

DWORD {NOERR_RET}
QueueUserAPC{syncop}(
		PAPCFUNC pfnAPC {pfnAPC},
		HANDLE hThread {hThread, handle, fd},
		ULONG_PTR dwData {dwData}
);

BOOL {boolret, BOOL_RET}
QueueUserWorkItem{threadop}(
		LPTHREAD_START_ROUTINE Function {Function},
		PVOID Context {Context},
		ULONG Flags {Flags}
);

void {NO_RET}
RaiseException{exop, nativeop}(
		DWORD dwExceptionCode {dwExceptionCode},
		DWORD dwExceptionFlags {dwExceptionFlags},
		DWORD nNumberOfArguments {nNumberOfArguments},
		const ULONG_PTR * lpArguments {lpArguments}
);

BOOL {boolret, BOOL_RET}
ReadConsoleInput{consoleop, handleop, unicode}(
		HANDLE hConsoleInput {hConsoleInput, handle, fd},
		PINPUT_RECORD lpBuffer {lpBuffer},
		DWORD nLength {nLength},
		LPDWORD lpNumberOfEventsRead {lpNumberOfEventsRead, out}
);

BOOL {boolret, BOOL_RET}
ReadConsoleOutputAttribute{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		LPWORD lpAttribute {lpAttribute},
		DWORD nLength {nLength},
		COORD * dwReadCoord {dwReadCoord},
		LPDWORD lpNumberOfAttrsRead {lpNumberOfAttrsRead, out}
);

BOOL {boolret, BOOL_RET}
ReadConsoleOutputCharacter{consoleop, handleop, unicode}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		LPWSTR lpCharacter {lpCharacter},
		DWORD nLength {nLength},
		COORD * dwReadCoord {dwReadCoord},
		LPDWORD lpNumberOfCharsRead {lpNumberOfCharsRead, out}
);

BOOL {boolret, BOOL_RET}
ReadConsoleOutput{consoleop, handleop, unicode}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		PCHAR_INFO lpBuffer {lpBuffer},
		COORD * dwBufferSize {dwBufferSize},
		COORD * dwBufferCoord {dwBufferCoord},
		PSMALL_RECT lpReadRegion {lpReadRegion}
);

BOOL {boolret, BOOL_RET}
ReadConsole{consoleop, handleop, unicode}(
		HANDLE hConsoleInput {hConsoleInput, handle, fd},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,nNumberOfCharsToRead), out},
		DWORD nNumberOfCharsToRead {nNumberOfCharsToRead, nbytes},
		LPDWORD lpNumberOfCharsRead {lpNumberOfCharsRead, out},
		LPVOID lpReserved {lpReserved}
);

BOOL {boolret, BOOL_RET}
ReadDirectoryChanges{fileop, handleop, unicode}(
		HANDLE hDirectory {hDirectory, handle, fd},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,nBufferLength), out},
		DWORD nBufferLength {nBufferLength, nbytes},
		BOOL bWatchSubtree {bWatchSubtree},
		DWORD dwNotifyFilter {dwNotifyFilter},
		LPDWORD lpBytesReturned {lpBytesReturned, out},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout},
		LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine {lpCompletionRoutine}
);

DWORD {NOERR_RET}
ReadEncryptedFileRaw{cryptop, fileop}(
		PFE_EXPORT_FUNC pfExportCallback {pfExportCallback},
		PVOID pvCallbackContext {pvCallbackContext},
		PVOID pvContext {pvContext}
);

BOOL {boolret, BOOL_RET}
ReadEventLog{eventlogop, handleop, syncop, unicode}(
		HANDLE hEventLog {hEventLog, handle, fd},
		DWORD dwReadFlags {dwReadFlags},
		DWORD dwRecordOffset {dwRecordOffset},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,nNumberOfBytesToRead), out},
		DWORD nNumberOfBytesToRead {nNumberOfBytesToRead, nbytes},
		DWORD * pnBytesRead {pnBytesRead},
		DWORD * pnMinNumberOfBytesNeeded {pnMinNumberOfBytesNeeded}
);

BOOL {boolret, BOOL_RET}
ReadFile{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,nNumberOfBytesToRead), out},
		DWORD nNumberOfBytesToRead {nNumberOfBytesToRead, nbytes},
		LPDWORD lpNumberOfBytesRead {lpNumberOfBytesRead, out},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

BOOL {boolret, BOOL_RET}
ReadFileEx{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,nNumberOfBytesToRead), out},
		DWORD nNumberOfBytesToRead {nNumberOfBytesToRead, nbytes},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout},
		LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine {lpCompletionRoutine}
);

BOOL {boolret, BOOL_RET}
ReadFileScatter{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		FILE_SEGMENT_ELEMENT aSegmentArray [ ] {aSegmentArray},
		DWORD nNumberOfBytesToRead {nNumberOfBytesToRead, nbytes},
		LPDWORD lpReserved {lpReserved, out},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

BOOL {boolret, BOOL_RET}
ReadProcessMemory{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		LPCVOID lpBaseAddress {lpBaseAddress},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,nSize), out},
		DWORD nSize {nSize, nbytes},
		LPDWORD lpNumberOfBytesRead {lpNumberOfBytesRead, out}
);

LONG {errret, ZERO_RET}
RegCloseKey{handleop, registryop}(
		HKEY hKey {hKey, handle}
);

LONG {errret, ZERO_RET}
RegConnectRegistry{registryop, unicode}(
		LPCWSTR lpMachineName {lpMachineName, nterm},
		HKEY hKey {hKey, handle},
		PHKEY phkResult {phkResult}
);

LONG {errret, ZERO_RET}
RegCreateKeyEx{handleop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpSubKey {lpSubKey, nterm},
		DWORD Reserved {Reserved},
		LPWSTR lpClass {lpClass},
		DWORD dwOptions {dwOptions},
		REGSAM samDesired {samDesired},
		LPSECURITY_ATTRIBUTES lpSecurityAttributes {lpSecurityAttributes},
		PHKEY phkResult {phkResult},
		LPDWORD lpdwDisposition {lpdwDisposition, out}
);

LONG {errret, ZERO_RET}
RegCreateKey{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpSubKey {lpSubKey, nterm},
		PHKEY phkResult {phkResult}
);

LONG {errret, ZERO_RET}
RegDeleteKey{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpSubKey {lpSubKey, nterm}
);

LONG {errret, ZERO_RET}
RegDeleteValue{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpValueName {lpValueName, nterm}
);

LONG {errret, ZERO_RET}
RegDisablePredefinedCache{registryop}( void );

LONG {errret, ZERO_RET}
RegEnumKeyEx{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		DWORD dwIndex {dwIndex},
		LPWSTR lpName {lpName},
		LPDWORD lpcbName {lpcbName, out},
		LPDWORD lpReserved {lpReserved, out},
		LPWSTR lpClass {lpClass},
		LPDWORD lpcbClass {lpcbClass, out},
		PFILETIME lpftLastWriteTime {lpftLastWriteTime}
);

LONG {errret, ZERO_RET}
RegEnumKey{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		DWORD dwIndex {dwIndex},
		LPWSTR lpName {lpName},
		DWORD cbName {cbName}
);

LONG {errret, ZERO_RET}
RegEnumValue{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		DWORD dwIndex {dwIndex},
		LPWSTR lpValueName {lpValueName},
		LPDWORD lpcbValueName {lpcbValueName, out},
		LPDWORD lpReserved {lpReserved, out},
		LPDWORD lpType {lpType, out},
		LPBYTE lpData {lpData},
		LPDWORD lpcbData {lpcbData, out}
);

LONG {errret, ZERO_RET}
RegFlushKey{handleop, nativeop, registryop}(
		HKEY hKey {hKey, handle}
);

LONG {errret, ZERO_RET}
RegGetKeySecurity{handleop, registryop}(
		HKEY hKey {hKey, handle},
		SECURITY_INFORMATION SecurityInformation {SecurityInformation},
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		LPDWORD lpcbSecurityDescriptor {lpcbSecurityDescriptor, out}
);

LONG {errret, ZERO_RET}
RegLoadKey{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpSubKey {lpSubKey, nterm},
		LPCWSTR lpFile {lpFile, nterm}
);

LONG {errret, ZERO_RET}
RegNotifyChangeKeyValue{handleop, nativeop, registryop}(
		HKEY hKey {hKey, handle},
		BOOL bWatchSubtree {bWatchSubtree},
		DWORD dwNotifyFilter {dwNotifyFilter},
		HANDLE hEvent {hEvent, handle, fd},
		BOOL fAsynchronus {fAsynchronus}
);

LONG {errret, ZERO_RET}
RegOpenCurrentUser{registryop}(
		REGSAM samDesired {samDesired},
		PHKEY phkResult {phkResult}
);

LONG {errret, ZERO_RET}
RegOpenKeyEx{handleop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpSubKey {lpSubKey, nterm},
		DWORD ulOptions {ulOptions},
		REGSAM samDesired {samDesired},
		PHKEY phkResult {phkResult}
);

LONG {errret, ZERO_RET}
RegOpenKey{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpSubKey {lpSubKey, nterm},
		PHKEY phkResult {phkResult}
);

LONG {errret, ZERO_RET}
RegOpenUserClassesRoot{handleop, registryop}(
		HANDLE hToken {hToken, handle, fd},
		DWORD dwOptions {dwOptions},
		REGSAM samDesired {samDesired},
		PHKEY phkResult {phkResult}
);

LONG {errret, ZERO_RET}
RegOverridePredefKey{handleop, registryop}(
		HKEY hKey {hKey, handle},
		HKEY hNewHKey {hNewHKey}
);

LONG {errret, ZERO_RET}
RegQueryInfoKey{handleop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPWSTR lpClass {lpClass},
		LPDWORD lpcbClass {lpcbClass, out},
		LPDWORD lpReserved {lpReserved, out},
		LPDWORD lpcSubKeys {lpcSubKeys, out},
		LPDWORD lpcbMaxSubKeyLen {lpcbMaxSubKeyLen, out},
		LPDWORD lpcbMaxClassLen {lpcbMaxClassLen, out},
		LPDWORD lpcValues {lpcValues, out},
		LPDWORD lpcbMaxValueNameLen {lpcbMaxValueNameLen, out},
		LPDWORD lpcbMaxValueLen {lpcbMaxValueLen, out},
		LPDWORD lpcbSecurityDescriptor {lpcbSecurityDescriptor, out},
		PFILETIME lpftLastWriteTime {lpftLastWriteTime}
);

LONG {errret, ZERO_RET}
RegQueryMultipleValues{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		PVALENTW val_list {val_list},
		DWORD num_vals {num_vals},
		LPWSTR lpValueBuf {lpValueBuf},
		LPDWORD ldwTotsize {ldwTotsize, out}
);

LONG {errret, ZERO_RET}
RegQueryValueEx{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpValueName {lpValueName, nterm},
		LPDWORD lpReserved {lpReserved, out},
		LPDWORD lpType {lpType, out},
		LPBYTE lpData {lpData},
		LPDWORD lpcbData {lpcbData, out}
);

LONG {errret, ZERO_RET}
RegQueryValue{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpSubKey {lpSubKey, nterm},
		LPWSTR lpValue {lpValue},
		PLONG lpcbValue {lpcbValue}
);

LONG {errret, ZERO_RET}
RegReplaceKey{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpSubKey {lpSubKey, nterm},
		LPCWSTR lpNewFile {lpNewFile, nterm},
		LPCWSTR lpOldFile {lpOldFile, nterm}
);

LONG {errret, ZERO_RET}
RegRestoreKey{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpFile {lpFile, nterm},
		DWORD dwFlags {dwFlags}
);

LONG {errret, ZERO_RET}
RegSaveKey{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpFile {lpFile, nterm},
		LPSECURITY_ATTRIBUTES lpSecurityAttributes {lpSecurityAttributes}
);

LONG {errret, ZERO_RET}
RegSetKeySecurity{handleop, registryop}(
		HKEY hKey {hKey, handle},
		SECURITY_INFORMATION SecurityInformation {SecurityInformation},
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor}
);

LONG {errret, ZERO_RET}
RegSetValueEx{handleop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpValueName {lpValueName, nterm},
		DWORD Reserved {Reserved},
		DWORD dwType {dwType},
		const BYTE * lpData {lpData},
		DWORD cbData {cbData}
);

LONG {errret, ZERO_RET}
RegSetValue{handleop, nativeop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpSubKey {lpSubKey, nterm},
		DWORD dwType {dwType},
		LPCWSTR lpData {lpData, nterm},
		DWORD cbData {cbData}
);

LONG {errret, ZERO_RET}
RegUnLoadKey{handleop, registryop, unicode}(
		HKEY hKey {hKey, handle},
		LPCWSTR lpSubKey {lpSubKey, nterm}
);

HANDLE {handleret, HANDLE_RET}
RegisterEventSource{eventop, fdretop, fileop, handleretop, unicode}(
		LPCWSTR lpUNCServerName {lpUNCServerName, nterm},
		LPCWSTR lpSourceName {lpSourceName, nterm}
);

SERVICE_STATUS_HANDLE {service_status_handleret, SERVICE_STATUS_HANDLE_RET}
RegisterServiceCtrlHandlerEx{serviceop, unicode}(
		LPCWSTR lpServiceName {lpServiceName, nterm},
		LPHANDLER_FUNCTION_EX lpHandlerProc {lpHandlerProc},
		LPVOID lpContext {lpContext}
);

SERVICE_STATUS_HANDLE {service_status_handleret, SERVICE_STATUS_HANDLE_RET}
RegisterServiceCtrlHandler{serviceop, unicode}(
		LPCWSTR lpServiceName {lpServiceName, nterm},
		LPHANDLER_FUNCTION lpHandlerProc {lpHandlerProc}
);

BOOL {boolret, BOOL_RET}
RegisterWaitForSingleObject{registryop}(
		PHANDLE phNewWaitObject {phNewWaitObject},
		HANDLE hObject {hObject, handle, fd},
		WAITORTIMERCALLBACK Callback {Callback},
		PVOID Context {Context},
		ULONG dwMilliseconds {dwMilliseconds},
		ULONG dwFlags {dwFlags}
);

HANDLE {handleret, HANDLE_RET}
RegisterWaitForSingleObjectEx{fdretop, handleop, handleretop, registryop}(
		HANDLE hObject {hObject, handle, fd},
		WAITORTIMERCALLBACK Callback {Callback},
		PVOID Context {Context},
		ULONG dwMilliseconds {dwMilliseconds},
		ULONG dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
ReleaseMutex{handleop, nativeop, syncop}(
		HANDLE hMutex {hMutex, handle, fd}
);

BOOL {boolret, BOOL_RET}
ReleaseSemaphore{handleop, nativeop, syncop}(
		HANDLE hSemaphore {hSemaphore, handle, fd},
		LONG lReleaseCount {lReleaseCount},
		LPLONG lpPreviousCount {lpPreviousCount}
);

BOOL {boolret, BOOL_RET}
RemoveDirectory{fileop, unicode}(
		LPCWSTR lpPathName {lpPathName, path, nterm}
);

DWORD {NOERR_RET}
RemoveUsersFromEncryptedFile{cryptop, fileop}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		PENCRYPTION_CERTIFICATE_HASH_LIST pHashes {pHashes}
);

BOOL {boolret, BOOL_RET}
ReplaceFile{fileop, unicode}(
		LPCWSTR lpReplacedFileName {lpReplacedFileName, nterm},
		LPCWSTR lpReplacementFileName {lpReplacementFileName, nterm},
		LPCWSTR lpBackupFileName {lpBackupFileName, nterm},
		DWORD dwReplaceFlags {dwReplaceFlags},
		LPVOID lpExclude {lpExclude},
		LPVOID lpReserved {lpReserved}
);

BOOL {boolret, BOOL_RET}
ReportEvent{eventlogop, handleop, unicode}(
		HANDLE hEventLog {hEventLog, handle, fd},
		WORD wType {wType},
		WORD wCategory {wCategory},
		DWORD dwEventID {dwEventID},
		PSID lpUserSid {lpUserSid, sid},
		WORD wNumStrings {wNumStrings},
		DWORD dwDataSize {dwDataSize},
		LPCWSTR * lpStrings {lpStrings},
		LPVOID lpRawData {lpRawData}
);

BOOL {boolret, BOOL_RET}
RequestDeviceWakeup{handleop, powerop}(
		HANDLE hDevice {hDevice, handle, fd}
);

BOOL {boolret, BOOL_RET}
RequestWakeupLatency{powerop}(
		LATENCY_TIME * latency {latency}
);

BOOL {boolret, BOOL_RET}
ResetEvent{handleop, ipcop, nativeop, syncop}(
		HANDLE hEvent {hEvent, handle, fd}
);

UINT {sizeret, NONZERO_RET}
ResetWriteWatch{memop}(
		LPVOID lpBaseAddress {lpBaseAddress},
		SIZE_T dwRegionSize {dwRegionSize}
);

DWORD {NOERR_RET}
ResumeThread{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd}
);

BOOL {boolret, BOOL_RET}
RevertToSelf{aclop}( void );

BOOL {boolret, BOOL_RET}
ScrollConsoleScreenBuffer{consoleop, handleop, unicode}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		const SMALL_RECT * lpScrollRectangle {lpScrollRectangle},
		const SMALL_RECT * lpClipRectangle {lpClipRectangle},
		COORD * dwDestinationOrigin {dwDestinationOrigin},
		const CHAR_INFO * lpFill {lpFill}
);

DWORD {NOERR_RET}
SearchPath{fileop, searchop, unicode}(
		LPCWSTR lpPath {lpPath, nterm},
		LPCWSTR lpFileName {lpFileName, path, nterm},
		LPCWSTR lpExtension {lpExtension, nterm},
		DWORD nBufferLength {nBufferLength, nbytes},
		LPWSTR lpBuffer {lpBuffer, outpath, nterm},
		LPWSTR * lpFilePart {lpFilePart}
);

BOOL {boolret, BOOL_RET}
SetAclInformation{aclop}(
		PACL pAcl {pAcl, acl},
		LPVOID pAclInformation {pAclInformation},
		DWORD nAclInformationLength {nAclInformationLength},
		ACL_INFORMATION_CLASS dwAclInformationClass {dwAclInformationClass}
);

BOOL {boolret, BOOL_RET}
SetCommBreak{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd}
);

BOOL {boolret, BOOL_RET}
SetCommConfig{handleop}(
		HANDLE hCommDev {hCommDev, handle, fd},
		LPCOMMCONFIG lpCC {lpCC},
		DWORD dwSize {dwSize}
);

BOOL {boolret, BOOL_RET}
SetCommMask{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		DWORD dwEvtMask {dwEvtMask}
);

BOOL {boolret, BOOL_RET}
SetCommState{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPDCB lpDCB {lpDCB}
);

BOOL {boolret, BOOL_RET}
SetCommTimeouts{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LPCOMMTIMEOUTS lpCommTimeouts {lpCommTimeouts}
);

BOOL {boolret, BOOL_RET}
SetComputerNameEx{sysinfoop, unicode}(
		COMPUTER_NAME_FORMAT NameType {NameType},
		LPCWSTR lpBuffer {lpBuffer, nterm}
);

BOOL {boolret, BOOL_RET}
SetComputerName{sysinfoop, systemop, unicode}(
		LPCWSTR lpComputerName {lpComputerName, nterm}
);

BOOL {boolret, BOOL_RET}
SetConsoleActiveScreenBuffer{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd}
);

BOOL {boolret, BOOL_RET}
SetConsoleCP{consoleop}(
		UINT wCodePageID {wCodePageID}
);

BOOL {boolret, BOOL_RET}
SetConsoleCtrlHandler{consoleop}(
		PHANDLER_ROUTINE HandlerRoutine {HandlerRoutine},
		BOOL Add {Add}
);

BOOL {boolret, BOOL_RET}
SetConsoleCursorInfo{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		const CONSOLE_CURSOR_INFO * lpConsoleCursorInfo {lpConsoleCursorInfo}
);

BOOL {boolret, BOOL_RET}
SetConsoleCursorPosition{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		COORD * dwCursorPosition {dwCursorPosition}
);

BOOL {boolret, BOOL_RET}
SetConsoleMode{consoleop, handleop}(
		HANDLE hConsoleHandle {hConsoleHandle, handle, fd},
		DWORD dwMode {dwMode}
);

BOOL {boolret, BOOL_RET}
SetConsoleOutputCP{consoleop}(
		UINT wCodePageID {wCodePageID}
);

BOOL {boolret, BOOL_RET}
SetConsoleScreenBufferSize{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		COORD * dwSize {dwSize}
);

BOOL {boolret, BOOL_RET}
SetConsoleTextAttribute{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		WORD wAttributes {wAttributes}
);

BOOL {boolret, BOOL_RET}
SetConsoleTitle{consoleop, unicode}(
		LPCWSTR lpConsoleTitle {lpConsoleTitle, nterm}
);

BOOL {boolret, BOOL_RET}
SetConsoleWindowInfo{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		BOOL bAbsolute {bAbsolute},
		const SMALL_RECT * lpConsoleWindow {lpConsoleWindow}
);

BOOL {boolret, BOOL_RET}
SetCurrentDirectory{fileop, unicode}(
		LPCWSTR lpPathName {lpPathName, path, nterm}
);

BOOL {boolret, BOOL_RET}
SetDefaultCommConfig{commconfigop, unicode}(
		LPCWSTR lpszName {lpszName, nterm},
		LPCOMMCONFIG lpCC {lpCC},
		DWORD dwSize {dwSize}
);

BOOL {boolret, BOOL_RET}
SetEndOfFile{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd}
);

BOOL {boolret, BOOL_RET}
SetEnvironmentVariable{envop, nativeop, unicode}(
		LPCWSTR lpName {lpName, nterm},
		LPCWSTR lpValue {lpValue, nterm}
);

UINT {sizeret, NONZERO_RET}
SetErrorMode{nativeop, systemop}(
		UINT uMode {uMode}
);

BOOL {boolret, BOOL_RET}
SetEvent{handleop, ipcop, nativeop, syncop}(
		HANDLE hEvent {hEvent, handle, fd}
);

void {NO_RET}
SetFileApisToANSI{fileop}( void );

void {NO_RET}
SetFileApisToOEM{fileop}( void );

BOOL {boolret, BOOL_RET}
SetFileAttributes{fileop, nativeop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		DWORD dwFileAttributes {dwFileAttributes}
);

DWORD {NOERR_RET}
SetFilePointer{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LONG lDistanceToMove {lDistanceToMove},
		PLONG lpDistanceToMoveHigh {lpDistanceToMoveHigh},
		DWORD dwMoveMethod {dwMoveMethod}
);

BOOL {boolret, BOOL_RET}
SetFilePointerEx{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		LARGE_INTEGER * liDistanceToMove {liDistanceToMove},
		PLARGE_INTEGER lpNewFilePointer {lpNewFilePointer},
		DWORD dwMoveMethod {dwMoveMethod}
);

BOOL {boolret, BOOL_RET}
SetFileSecurity{fileop, unicode}(
		LPCWSTR lpFileName {lpFileName, path, nterm},
		SECURITY_INFORMATION SecurityInformation {SecurityInformation},
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor}
);

BOOL {boolret, BOOL_RET}
SetFileTime{dateop, fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		const FILETIME * lpCreationTime {lpCreationTime},
		const FILETIME * lpLastAccessTime {lpLastAccessTime},
		const FILETIME * lpLastWriteTime {lpLastWriteTime}
);

UINT {sizeret, NONZERO_RET}
SetHandleCount{processop}(
		UINT uNumber {uNumber}
);

BOOL {boolret, BOOL_RET}
SetHandleInformation{handleop}(
		HANDLE hObject {hObject, handle, fd},
		DWORD dwMask {dwMask},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
SetInformationJobObject{handleop, jobobjectop}(
		HANDLE hJob {hJob, handle, fd},
		JOBOBJECTINFOCLASS JobObjectInformationClass {JobObjectInformationClass},
		LPVOID lpJobObjectInformation {lpJobObjectInformation},
		DWORD cbJobObjectInformationLength {cbJobObjectInformationLength}
);

BOOL {boolret, BOOL_RET}
SetKernelObjectSecurity{handleop}(
		HANDLE Handle {Handle, handle, fd},
		SECURITY_INFORMATION SecurityInformation {SecurityInformation},
		PSECURITY_DESCRIPTOR SecurityDescriptor {SecurityDescriptor}
);

void {NO_RET}
SetLastError{errorop}(
		DWORD dwErrCode {dwErrCode}
);

BOOL {boolret, BOOL_RET}
SetLocalTime{dateop}(
		const SYSTEMTIME * lpSystemTime {lpSystemTime}
);

BOOL {boolret, BOOL_RET}
SetLocaleInfo{localeop, nativeop, unicode}(
		LCID Locale {Locale},
		LCTYPE LCType {LCType},
		LPCWSTR lpLCData {lpLCData, nterm}
);

BOOL {boolret, BOOL_RET}
SetMailslotInfo{handleop, ipcop, mailslotop, nativeop}(
		HANDLE hMailslot {hMailslot, handle, fd},
		DWORD lReadTimeout {lReadTimeout}
);

BOOL {boolret, BOOL_RET}
SetMessageWaitingIndicator{handleop}(
		HANDLE hMsgIndicator {hMsgIndicator, handle, fd},
		ULONG ulMsgCount {ulMsgCount}
);

BOOL {boolret, BOOL_RET}
SetNamedPipeHandleState{handleop, ipcop, nativeop, pipeop}(
		HANDLE hNamedPipe {hNamedPipe, handle, fd},
		LPDWORD lpMode {lpMode, out},
		LPDWORD lpMaxCollectionCount {lpMaxCollectionCount, out},
		LPDWORD lpCollectDataTimeout {lpCollectDataTimeout, out}
);

BOOL {boolret, BOOL_RET}
SetPriorityClass{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		DWORD dwPriorityClass {dwPriorityClass}
);

BOOL {boolret, BOOL_RET}
SetPrivateObjectSecurity{aclop}(
		SECURITY_INFORMATION SecurityInformation {SecurityInformation},
		PSECURITY_DESCRIPTOR ModificationDescriptor {ModificationDescriptor},
		PSECURITY_DESCRIPTOR * ObjectsSecurityDescriptor {ObjectsSecurityDescriptor},
		PGENERIC_MAPPING GenericMapping {GenericMapping},
		HANDLE Token {Token, handle, fd}
);

BOOL {boolret, BOOL_RET}
SetPrivateObjectSecurityEx{aclop}(
		SECURITY_INFORMATION SecurityInformation {SecurityInformation},
		PSECURITY_DESCRIPTOR ModificationDescriptor {ModificationDescriptor},
		PSECURITY_DESCRIPTOR * ObjectsSecurityDescriptor {ObjectsSecurityDescriptor},
		ULONG AutoInheritFlags {AutoInheritFlags},
		PGENERIC_MAPPING GenericMapping {GenericMapping},
		HANDLE Token {Token, handle, fd}
);

BOOL {boolret, BOOL_RET}
SetProcessAffinityMask{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		DWORD_PTR dwProcessAffinityMask {dwProcessAffinityMask}
);

BOOL {boolret, BOOL_RET}
SetProcessPriorityBoost{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		BOOL bDisablePriorityBoost {bDisablePriorityBoost}
);

BOOL {boolret, BOOL_RET}
SetProcessShutdownParameters{nativeop, processop}(
		DWORD dwLevel {dwLevel},
		DWORD dwFlags {dwFlags}
);

BOOL {boolret, BOOL_RET}
SetProcessWorkingSetSize{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		SIZE_T dwMinimumWorkingSetSize {dwMinimumWorkingSetSize},
		SIZE_T dwMaximumWorkingSetSize {dwMaximumWorkingSetSize}
);

BOOL {boolret, BOOL_RET}
SetSecurityDescriptorControl{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		SECURITY_DESCRIPTOR_CONTROL ControlBitsOfInterest {ControlBitsOfInterest},
		SECURITY_DESCRIPTOR_CONTROL ControlBitsToSet {ControlBitsToSet}
);

BOOL {boolret, BOOL_RET}
SetSecurityDescriptorDacl{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		BOOL bDaclPresent {bDaclPresent},
		PACL pDacl {pDacl},
		BOOL bDaclDefaulted {bDaclDefaulted}
);

BOOL {boolret, BOOL_RET}
SetSecurityDescriptorGroup{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		PSID pGroup {pGroup, sid},
		BOOL bGroupDefaulted {bGroupDefaulted}
);

BOOL {boolret, BOOL_RET}
SetSecurityDescriptorOwner{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		PSID pOwner {pOwner, sid},
		BOOL bOwnerDefaulted {bOwnerDefaulted}
);

DWORD {NOERR_RET}
SetSecurityDescriptorRMControl{aclop}(
		PSECURITY_DESCRIPTOR SecurityDescriptor {SecurityDescriptor},
		PUCHAR RMControl {RMControl}
);

BOOL {boolret, BOOL_RET}
SetSecurityDescriptorSacl{aclop}(
		PSECURITY_DESCRIPTOR pSecurityDescriptor {pSecurityDescriptor},
		BOOL bSaclPresent {bSaclPresent},
		PACL pSacl {pSacl},
		BOOL bSaclDefaulted {bSaclDefaulted}
);

BOOL {boolret, BOOL_RET}
SetServiceObjectSecurity{handleop, serviceop}(
		SC_HANDLE hService {hService, handle},
		SECURITY_INFORMATION dwSecurityInformation {dwSecurityInformation},
		PSECURITY_DESCRIPTOR lpSecurityDescriptor {lpSecurityDescriptor}
);

BOOL {boolret, BOOL_RET}
SetServiceStatus{serviceop}(
		SERVICE_STATUS_HANDLE hServiceStatus {hServiceStatus},
		LPSERVICE_STATUS lpServiceStatus {lpServiceStatus}
);

BOOL {boolret, BOOL_RET}
SetStdHandle{fileop}(
		DWORD nStdHandle {nStdHandle},
		HANDLE hHandle {hHandle, handle, fd}
);

BOOL {boolret, BOOL_RET}
SetSystemTime{dateop, nativeop}(
		const SYSTEMTIME * lpSystemTime {lpSystemTime}
);

BOOL {boolret, BOOL_RET}
SetSystemTimeAdjustment{dateop}(
		DWORD dwTimeAdjustment {dwTimeAdjustment},
		BOOL bTimeAdjustmentDisabled {bTimeAdjustmentDisabled}
);

DWORD {NOERR_RET}
SetTapeParameters{handleop}(
		HANDLE hDevice {hDevice, handle, fd},
		DWORD dwOperation {dwOperation},
		LPVOID lpTapeInformation {lpTapeInformation, out}
);

DWORD {NOERR_RET}
SetTapePosition{handleop}(
		HANDLE hDevice {hDevice, handle, fd},
		DWORD dwPositionMethod {dwPositionMethod},
		DWORD dwPartition {dwPartition},
		DWORD dwOffsetLow {dwOffsetLow},
		DWORD dwOffsetHigh {dwOffsetHigh},
		BOOL bImmediate {bImmediate}
);

DWORD_PTR 
SetThreadAffinityMask{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		DWORD_PTR dwThreadAffinityMask {dwThreadAffinityMask}
);

BOOL {boolret, BOOL_RET}
SetThreadContext{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		const CONTEXT * lpContext {lpContext}
);

EXECUTION_STATE 
SetThreadExecutionState{powerop}(
		EXECUTION_STATE esFlags {esFlags}
);

DWORD {NOERR_RET}
SetThreadIdealProcessor{handleop, nativeop, processop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		DWORD dwIdealProcessor {dwIdealProcessor}
);

BOOL {boolret, BOOL_RET}
SetThreadLocale{localeop, threadop}(
		LCID Locale {Locale}
);

BOOL {boolret, BOOL_RET}
SetThreadPriority{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		int nPriority {nPriority}
);

BOOL {boolret, BOOL_RET}
SetThreadPriorityBoost{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		BOOL bDisablePriorityBoost {bDisablePriorityBoost}
);

BOOL {boolret, BOOL_RET}
SetThreadToken{threadop}(
		PHANDLE Thread {Thread},
		HANDLE Token {Token, handle, fd}
);

BOOL {boolret, BOOL_RET}
SetTimeZoneInformation{dateop}(
		const TIME_ZONE_INFORMATION * lpTimeZoneInformation {lpTimeZoneInformation}
);

HANDLE {handleret, HANDLE_RET}
SetTimerQueueTimer{fdretop, handleop, handleretop, timerqueueop}(
		HANDLE TimerQueue {TimerQueue, handle, fd},
		WAITORTIMERCALLBACK Callback {Callback},
		PVOID Parameter {Parameter},
		DWORD DueTime {DueTime},
		DWORD Period {Period},
		BOOL PreferIo {PreferIo}
);

BOOL {boolret, BOOL_RET}
SetTokenInformation{handleop, nativeop, tokenop}(
		HANDLE TokenHandle {TokenHandle, handle, fd},
		TOKEN_INFORMATION_CLASS TokenInformationClass {TokenInformationClass},
		LPVOID TokenInformation {TokenInformation},
		DWORD TokenInformationLength {TokenInformationLength}
);

LPTOP_LEVEL_EXCEPTION_FILTER {NOERR_RET}
SetUnhandledExceptionFilter{exop}(
		LPTOP_LEVEL_EXCEPTION_FILTER lpTopLevelExceptionFilter {lpTopLevelExceptionFilter}
);

DWORD {NOERR_RET}
SetUserFileEncryptionKey{cryptop}(
		PENCRYPTION_CERTIFICATE pEncryptionCertificate {pEncryptionCertificate}
);

BOOL {boolret, BOOL_RET}
SetVolumeLabel{fileop, nativeop, unicode, volumeop}(
		LPCWSTR lpRootPathName {lpRootPathName, nterm},
		LPCWSTR lpVolumeName {lpVolumeName, nterm}
);

BOOL {boolret, BOOL_RET}
SetVolumeMountPoint{unicode, volumeop}(
		LPCWSTR lpszVolumeMountPoint {lpszVolumeMountPoint, nterm},
		LPCWSTR lpszVolumeName {lpszVolumeName, nterm}
);

BOOL {boolret, BOOL_RET}
SetWaitableTimer{handleop, timerop}(
		HANDLE hTimer {hTimer, handle, fd},
		const LARGE_INTEGER * lpDueTime {lpDueTime},
		LONG lPeriod {lPeriod},
		PTIMERAPCROUTINE pfnCompletionRoutine {pfnCompletionRoutine},
		LPVOID lpArgToCompletionRoutine {lpArgToCompletionRoutine},
		BOOL fResume {fResume}
);

BOOL {boolret, BOOL_RET}
SetupComm{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		DWORD dwInQueue {dwInQueue},
		DWORD dwOutQueue {dwOutQueue}
);

DWORD {NOERR_RET}
SignalObjectAndWait{handleop}(
		HANDLE hObjectToSignal {hObjectToSignal, handle, fd},
		HANDLE hObjectToWaitOn {hObjectToWaitOn, handle, fd},
		DWORD dwMilliseconds {dwMilliseconds},
		BOOL bAlertable {bAlertable}
);

DWORD {NOERR_RET}
SizeofResource{moduleop, resourceop}(
		HMODULE hModule {hModule},
		HRSRC hResInfo {hResInfo}
);

void {NO_RET}
Sleep{nativeop, processop}(
		DWORD dwMilliseconds {dwMilliseconds}
);

DWORD {NOERR_RET}
SleepEx{nativeop, processop}(
		DWORD dwMilliseconds {dwMilliseconds},
		BOOL bAlertable {bAlertable}
);

BOOL {boolret, BOOL_RET}
StartServiceCtrlDispatcher{serviceop, unicode}(
		const SERVICE_TABLE_ENTRYW * lpServiceStartTable {lpServiceStartTable}
);

BOOL {boolret, BOOL_RET}
StartService{handleop, serviceop, unicode}(
		SC_HANDLE hService {hService, handle},
		DWORD dwNumServiceArgs {dwNumServiceArgs},
		LPCWSTR * lpServiceArgVectors {lpServiceArgVectors}
);

DWORD {NOERR_RET}
SuspendThread{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd}
);

void {NO_RET}
SwitchToFiber{threadop}(
		LPVOID lpFiber {lpFiber}
);

BOOL {boolret, BOOL_RET}
SwitchToThread{threadop}( void );

BOOL {boolret, BOOL_RET}
SystemTimeToFileTime{dateop}(
		const SYSTEMTIME * lpSystemTime {lpSystemTime},
		LPFILETIME lpFileTime {lpFileTime}
);

BOOL {boolret, BOOL_RET}
SystemTimeToTzSpecificLocalTime{dateop}(
		LPTIME_ZONE_INFORMATION lpTimeZoneInformation {lpTimeZoneInformation},
		LPSYSTEMTIME lpUniversalTime {lpUniversalTime},
		LPSYSTEMTIME lpLocalTime {lpLocalTime}
);

BOOL {boolret, BOOL_RET}
TerminateJobObject{handleop, jobobjectop}(
		HANDLE hJob {hJob, handle, fd},
		UINT uExitCode {uExitCode}
);

BOOL {boolret, BOOL_RET}
TerminateProcess{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		UINT uExitCode {uExitCode}
);

BOOL {boolret, BOOL_RET}
TerminateThread{handleop, nativeop, threadop}(
		HANDLE hThread {hThread, handle, fd},
		DWORD dwExitCode {dwExitCode}
);

DWORD {NOERR_RET}
TlsAlloc{memop, threadop}( void );

BOOL {boolret, BOOL_RET}
TlsFree{memop, threadop}(
		DWORD dwTlsIndex {dwTlsIndex}
);

LPVOID {pointerret, NONNULL_RET}
TlsGetValue{threadop}(
		DWORD dwTlsIndex {dwTlsIndex}
);

BOOL {boolret, BOOL_RET}
TlsSetValue{threadop}(
		DWORD dwTlsIndex {dwTlsIndex},
		LPVOID lpTlsValue {lpTlsValue}
);

BOOL {boolret, BOOL_RET}
TransactNamedPipe{handleop, ipcop, pipeop}(
		HANDLE hNamedPipe {hNamedPipe, handle, fd},
		LPVOID lpInBuffer {lpInBuffer, out},
		DWORD nInBufferSize {nInBufferSize},
		LPVOID lpOutBuffer {lpOutBuffer},
		DWORD nOutBufferSize {nOutBufferSize},
		LPDWORD lpBytesRead {lpBytesRead, out},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

BOOL {boolret, BOOL_RET}
TransmitCommChar{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		char cChar {cChar}
);

LONG {errret, ZERO_RET}
UnhandledExceptionFilter{exop}(
		struct _EXCEPTION_POINTERS * ExceptionInfo {ExceptionInfo}
);

BOOL {boolret, BOOL_RET}
UnlockFile{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		DWORD dwFileOffsetLow {dwFileOffsetLow},
		DWORD dwFileOffsetHigh {dwFileOffsetHigh},
		DWORD nNumberOfBytesToUnlockLow {nNumberOfBytesToUnlockLow},
		DWORD nNumberOfBytesToUnlockHigh {nNumberOfBytesToUnlockHigh}
);

BOOL {boolret, BOOL_RET}
UnlockFileEx{fileop, handleop}(
		HANDLE hFile {hFile, handle, fd},
		DWORD dwReserved {dwReserved},
		DWORD nNumberOfBytesToUnlockLow {nNumberOfBytesToUnlockLow},
		DWORD nNumberOfBytesToUnlockHigh {nNumberOfBytesToUnlockHigh},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

BOOL {boolret, BOOL_RET}
UnlockServiceDatabase{serviceop}(
		SC_LOCK ScLock {ScLock}
);

BOOL {boolret, BOOL_RET}
UnmapViewOfFile{fileop, nativeop}(
		LPCVOID lpBaseAddress {lpBaseAddress}
);

BOOL {boolret, BOOL_RET}
UnregisterWait{handleop}(
		HANDLE WaitHandle {WaitHandle, handle, fd}
);

BOOL {boolret, BOOL_RET}
UnregisterWaitEx{handleop}(
		HANDLE WaitHandle {WaitHandle, handle, fd},
		HANDLE CompletionEvent {CompletionEvent, handle, fd}
);

BOOL {boolret, BOOL_RET}
UpdateResource{handleop, resourceop, unicode}(
		HANDLE hUpdate {hUpdate, handle, fd},
		LPCWSTR lpType {lpType, nterm},
		LPCWSTR lpName {lpName, nterm},
		WORD wLanguage {wLanguage},
		LPVOID lpData {lpData},
		DWORD cbData {cbData}
);

BOOL {boolret, BOOL_RET}
VerifyVersionInfo{sysinfoop, unicode}(
		LPOSVERSIONINFOEXW lpVersionInformation {lpVersionInformation},
		DWORD dwTypeMask {dwTypeMask},
		DWORDLONG dwlConditionMask {dwlConditionMask}
);

LPVOID {pointerret, NONNULL_RET}
VirtualAlloc{memop, nativeop}(
		LPVOID lpAddress {lpAddress},
		SIZE_T dwSize {dwSize},
		DWORD flAllocationType {flAllocationType},
		DWORD flProtect {flProtect}
);

LPVOID {pointerret, NONNULL_RET}
VirtualAllocEx{handleop, memop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		LPVOID lpAddress {lpAddress},
		SIZE_T dwSize {dwSize},
		DWORD flAllocationType {flAllocationType},
		DWORD flProtect {flProtect}
);

BOOL {boolret, BOOL_RET}
VirtualFree{memop, nativeop}(
		LPVOID lpAddress {lpAddress},
		SIZE_T dwSize {dwSize},
		DWORD dwFreeType {dwFreeType}
);

BOOL {boolret, BOOL_RET}
VirtualFreeEx{handleop, memop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		LPVOID lpAddress {lpAddress},
		SIZE_T dwSize {dwSize},
		DWORD dwFreeType {dwFreeType}
);

BOOL {boolret, BOOL_RET}
VirtualLock{memop, nativeop}(
		LPVOID lpAddress {lpAddress},
		SIZE_T dwSize {dwSize}
);

BOOL {boolret, BOOL_RET}
VirtualProtect{memop, nativeop}(
		LPVOID lpAddress {lpAddress},
		SIZE_T dwSize {dwSize},
		DWORD flNewProtect {flNewProtect},
		PDWORD lpflOldProtect {lpflOldProtect}
);

BOOL {boolret, BOOL_RET}
VirtualProtectEx{handleop, memop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		LPVOID lpAddress {lpAddress},
		SIZE_T dwSize {dwSize},
		DWORD flNewProtect {flNewProtect},
		PDWORD lpflOldProtect {lpflOldProtect}
);

DWORD {NOERR_RET}
VirtualQuery{memop, nativeop}(
		LPCVOID lpAddress {lpAddress},
		PMEMORY_BASIC_INFORMATION lpBuffer {lpBuffer},
		DWORD dwLength {dwLength}
);

DWORD {NOERR_RET}
VirtualQueryEx{handleop, memop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		LPCVOID lpAddress {lpAddress},
		PMEMORY_BASIC_INFORMATION lpBuffer {lpBuffer},
		DWORD dwLength {dwLength}
);

BOOL {boolret, BOOL_RET}
VirtualUnlock{memop, nativeop}(
		LPVOID lpAddress {lpAddress},
		SIZE_T dwSize {dwSize}
);

BOOL {boolret, BOOL_RET}
WaitCommEvent{fileop, handleop, syncop}(
		HANDLE hFile {hFile, handle, fd},
		LPDWORD lpEvtMask {lpEvtMask, out},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

BOOL {boolret, BOOL_RET}
WaitForDebugEvent{debugop}(
		LPDEBUG_EVENT lpDebugEvent {lpDebugEvent},
		DWORD dwMilliseconds {dwMilliseconds}
);

DWORD {NOERR_RET}
WaitForMultipleObjects{nativeop, syncop}(
		DWORD nCount {nCount},
		const HANDLE * lpHandles {lpHandles},
		BOOL bWaitAll {bWaitAll},
		DWORD dwMilliseconds {dwMilliseconds}
);

DWORD {NOERR_RET}
WaitForMultipleObjectsEx{nativeop, syncop}(
		DWORD nCount {nCount},
		const HANDLE * lpHandles {lpHandles},
		BOOL bWaitAll {bWaitAll},
		DWORD dwMilliseconds {dwMilliseconds},
		BOOL bAlertable {bAlertable}
);

DWORD {NOERR_RET}
WaitForSingleObject{handleop, nativeop, syncop}(
		HANDLE hHandle {hHandle, handle, fd},
		DWORD dwMilliseconds {dwMilliseconds}
);

DWORD {NOERR_RET}
WaitForSingleObjectEx{handleop, nativeop, syncop}(
		HANDLE hHandle {hHandle, handle, fd},
		DWORD dwMilliseconds {dwMilliseconds},
		BOOL bAlertable {bAlertable}
);

BOOL {boolret, BOOL_RET}
WaitNamedPipe{ipcop, pipeop, unicode}(
		LPCWSTR lpNamedPipeName {lpNamedPipeName, nterm},
		DWORD nTimeOut {nTimeOut}
);

int {sizeret,VAL_RET}
WideCharToMultiByte{localeop}(
		UINT CodePage {CodePage},
		DWORD dwFlags {dwFlags},
		LPCWSTR lpWideCharStr {lpWideCharStr, nterm},
		int cchWideChar {cchWideChar},
		LPSTR lpMultiByteStr {lpMultiByteStr},
		int cbMultiByte {cbMultiByte},
		LPCSTR lpDefaultChar {lpDefaultChar, nterm},
		LPBOOL lpUsedDefaultChar {lpUsedDefaultChar}
);

UINT {sizeret, NONZERO_RET}
WinExec{processop}(
		LPCSTR lpCmdLine {lpCmdLine, nterm},
		UINT uCmdShow {uCmdShow}
);

BOOL {boolret, BOOL_RET}
WriteConsoleInput{consoleop, handleop, unicode}(
		HANDLE hConsoleInput {hConsoleInput, handle, fd},
		const INPUT_RECORD * lpBuffer {lpBuffer},
		DWORD nLength {nLength},
		LPDWORD lpNumberOfEventsWritten {lpNumberOfEventsWritten, out}
);

BOOL {boolret, BOOL_RET}
WriteConsoleOutputAttribute{consoleop, handleop}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		const WORD * lpAttribute {lpAttribute},
		DWORD nLength {nLength},
		COORD * dwWriteCoord {dwWriteCoord},
		LPDWORD lpNumberOfAttrsWritten {lpNumberOfAttrsWritten, out}
);

BOOL {boolret, BOOL_RET}
WriteConsoleOutputCharacter{consoleop, handleop, unicode}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		LPCWSTR lpCharacter {lpCharacter, nterm},
		DWORD nLength {nLength},
		COORD * dwWriteCoord {dwWriteCoord},
		LPDWORD lpNumberOfCharsWritten {lpNumberOfCharsWritten, out}
);

BOOL {boolret, BOOL_RET}
WriteConsoleOutput{consoleop, handleop, unicode}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		const CHAR_INFO * lpBuffer {lpBuffer},
		COORD * dwBufferSize {dwBufferSize},
		COORD * dwBufferCoord {dwBufferCoord},
		PSMALL_RECT lpWriteRegion {lpWriteRegion}
);

BOOL {boolret, BOOL_RET}
WriteConsole{consoleop, handleop, unicode}(
		HANDLE hConsoleOutput {hConsoleOutput, handle, fd},
		const void * lpBuffer {lpBuffer},
		DWORD nNumberOfCharsToWrite {nNumberOfCharsToWrite},
		LPDWORD lpNumberOfCharsWritten {lpNumberOfCharsWritten, out},
		LPVOID lpReserved {lpReserved}
);

DWORD {NOERR_RET}
WriteEncryptedFileRaw{cryptop, fileop}(
		PFE_IMPORT_FUNC pfImportCallback {pfImportCallback},
		PVOID pvCallbackContext {pvCallbackContext},
		PVOID pvContext {pvContext}
);

BOOL {boolret, BOOL_RET}
WriteFile{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		LPCVOID lpBuffer {lpBuffer, copy(lpBuffer,nNumberOfBytesToWrite)},
		DWORD nNumberOfBytesToWrite {nNumberOfBytesToWrite, nbytes},
		LPDWORD lpNumberOfBytesWritten {lpNumberOfBytesWritten, out},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

BOOL {boolret, BOOL_RET}
WriteFileEx{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		LPCVOID lpBuffer {lpBuffer, copy(lpBuffer,nNumberOfBytesToWrite)},
		DWORD nNumberOfBytesToWrite {nNumberOfBytesToWrite, nbytes},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout},
		LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine {lpCompletionRoutine}
);

BOOL {boolret, BOOL_RET}
WriteFileGather{fileop, handleop, nativeop}(
		HANDLE hFile {hFile, handle, fd},
		FILE_SEGMENT_ELEMENT aSegmentArray [ ] {aSegmentArray},
		DWORD nNumberOfBytesToWrite {nNumberOfBytesToWrite, nbytes},
		LPDWORD lpReserved {lpReserved, out},
		LPOVERLAPPED lpOverlapped {lpOverlapped, inout}
);

BOOL {boolret, BOOL_RET}
WritePrivateProfileSection{registryop, unicode}(
		LPCWSTR lpAppName {lpAppName, nterm},
		LPCWSTR lpString {lpString, nterm},
		LPCWSTR lpFileName {lpFileName, path, nterm}
);

BOOL {boolret, BOOL_RET}
WritePrivateProfileString{registryop, unicode}(
		LPCWSTR lpAppName {lpAppName, nterm},
		LPCWSTR lpKeyName {lpKeyName, nterm},
		LPCWSTR lpString {lpString, nterm},
		LPCWSTR lpFileName {lpFileName, path, nterm}
);

BOOL {boolret, BOOL_RET}
WritePrivateProfileStruct{registryop, unicode}(
		LPCWSTR lpszSection {lpszSection, nterm},
		LPCWSTR lpszKey {lpszKey, nterm},
		LPVOID lpStruct {lpStruct, out},
		UINT uSizeStruct {uSizeStruct},
		LPCWSTR szFile {szFile, nterm}
);

BOOL {boolret, BOOL_RET}
WriteProcessMemory{handleop, nativeop, processop}(
		HANDLE hProcess {hProcess, handle, fd},
		LPVOID lpBaseAddress {lpBaseAddress},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,nSize), out},
		DWORD nSize {nSize, nbytes},
		LPDWORD lpNumberOfBytesWritten {lpNumberOfBytesWritten, out}
);

BOOL {boolret, BOOL_RET}
WriteProfileSection{registryop, unicode}(
		LPCWSTR lpAppName {lpAppName, nterm},
		LPCWSTR lpString {lpString, nterm}
);

BOOL {boolret, BOOL_RET}
WriteProfileString{registryop, unicode}(
		LPCWSTR lpAppName {lpAppName, nterm},
		LPCWSTR lpKeyName {lpKeyName, nterm},
		LPCWSTR lpString {lpString, nterm}
);

DWORD {NOERR_RET}
WriteTapemark{handleop}(
		HANDLE hDevice {hDevice, handle, fd},
		DWORD dwTapemarkType {dwTapemarkType},
		DWORD dwTapemarkCount {dwTapemarkCount},
		BOOL bImmediate {bImmediate}
);

long {errret, ZERO_RET}
_hread{fileop}(
		HFILE hFile {hFile},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,lBytes), out},
		long lBytes {lBytes, nbytes}
);

long {errret, ZERO_RET}
_hwrite{fileop}(
		HFILE hFile {hFile},
		LPCSTR lpBuffer {lpBuffer, nterm},
		long lBytes {lBytes, nbytes}
);

HFILE {handleret, HANDLE_RET}
_lclose{fileop}(
		HFILE hFile {hFile}
);

HFILE {handleret, HANDLE_RET}
_lcreat{fileop}(
		LPCSTR lpPathName {lpPathName, path, nterm},
		int iAttribute {iAttribute}
);

LONG {errret, ZERO_RET}
_llseek{fileop}(
		HFILE hFile {hFile},
		LONG lOffset {lOffset},
		int iOrigin {iOrigin}
);

HFILE {handleret, HANDLE_RET}
_lopen{fileop}(
		LPCSTR lpPathName {lpPathName, path, nterm},
		int iReadWrite {iReadWrite}
);

UINT {sizeret, NONZERO_RET}
_lread{fileop}(
		HFILE hFile {hFile},
		LPVOID lpBuffer {lpBuffer, copy(lpBuffer,uBytes), out},
		UINT uBytes {uBytes, nbytes}
);

UINT {sizeret, NONZERO_RET}
_lwrite{fileop}(
		HFILE hFile {hFile},
		LPCSTR lpBuffer {lpBuffer, nterm},
		UINT uBytes {uBytes, nbytes}
);


}

