/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wr_errno.h,v 1.6 2001/02/23 19:02:25 stevek Exp $
 */

/* EPERM, 1,  Operation not permitted */
#define WR_BADPERM  		(1  * 4)
#define WR_A_BADPERM		(1  * 4 | WR_ALLOW)
#define WR_D_BADPERM		(1  * 4 | WR_DENY)
/* ENOENT, 2,  No such file or directory */
#define WR_NOFILE  		(2  * 4)
#define WR_A_NOFILE		(2  * 4 | WR_ALLOW)
#define WR_D_NOFILE		(2  * 4 | WR_DENY)
/* ESRCH, 3,  No such process */
#define WR_NOPROC  		(3  * 4)
#define WR_A_NOPROC		(3  * 4 | WR_ALLOW)
#define WR_D_NOPROC		(3  * 4 | WR_DENY)
/* EINTR, 4,  Interrupted system call */
#define WR_EINTR  		(4  * 4)
#define WR_A_EINTR		(4  * 4 | WR_ALLOW)
#define WR_D_EINTR		(4  * 4 | WR_DENY)
/* EIO, 5,  Input/output error */
#define WR_IOERR  		(5  * 4)
#define WR_A_IOERR		(5  * 4 | WR_ALLOW)
#define WR_D_IOERR		(5  * 4 | WR_DENY)
/* ENXIO, 6,  Device not configured */
#define WR_ENXIO  		(6  * 4)
#define WR_A_ENXIO		(6  * 4 | WR_ALLOW)
#define WR_D_ENXIO		(6  * 4 | WR_DENY)
/* E2BIG, 7,  Argument list too long */
#define WR_ARG2LONG  		(7  * 4)
#define WR_A_ARG2LONG		(7  * 4 | WR_ALLOW)
#define WR_D_ARG2LONG		(7  * 4 | WR_DENY)
/* ENOEXEC, 8,  Exec format error */
#define WR_ENOEXEC  		(8  * 4)
#define WR_A_ENOEXEC		(8  * 4 | WR_ALLOW)
#define WR_D_ENOEXEC		(8  * 4 | WR_DENY)
/* EBADF, 9,  Bad file descriptor */
#define WR_BADFD  		(9  * 4)
#define WR_A_BADFD		(9  * 4 | WR_ALLOW)
#define WR_D_BADFD		(9  * 4 | WR_DENY)
/* ECHILD, 10,  No child processes */
#define WR_NOCHILD  		(10  * 4)
#define WR_A_NOCHILD		(10  * 4 | WR_ALLOW)
#define WR_D_NOCHILD		(10  * 4 | WR_DENY)
/* EDEADLK, 11,  Resource deadlock avoided */
#define WR_EDEADLK  		(11  * 4)
#define WR_A_EDEADLK		(11  * 4 | WR_ALLOW)
#define WR_D_EDEADLK		(11  * 4 | WR_DENY)
/* ENOMEM, 12,  Cannot allocate memory */
#define WR_ENOMEM  		(12  * 4)
#define WR_A_ENOMEM		(12  * 4 | WR_ALLOW)
#define WR_D_ENOMEM		(12  * 4 | WR_DENY)
/* EACCES, 13,  Permission denied */
#define WR_BADACCES  		(13  * 4)
#define WR_A_BADACCES		(13  * 4 | WR_ALLOW)
#define WR_D_BADACCES		(13  * 4 | WR_DENY)
/* EFAULT, 14,  Bad address */
#define WR_EFAULT  		(14  * 4)
#define WR_A_EFAULT		(14  * 4 | WR_ALLOW)
#define WR_D_EFAULT		(14  * 4 | WR_DENY)
/* ENOTBLK, 15,  Block device required */
#define WR_ENOTBLK  		(15  * 4)
#define WR_A_ENOTBLK		(15  * 4 | WR_ALLOW)
#define WR_D_ENOTBLK		(15  * 4 | WR_DENY)
/* EBUSY, 16,  Device busy */
#define WR_EBUSY  		(16  * 4)
#define WR_A_EBUSY		(16  * 4 | WR_ALLOW)
#define WR_D_EBUSY		(16  * 4 | WR_DENY)
/* EEXIST, 17,  File exists */
#define WR_FILEEXIST  		(17  * 4)
#define WR_A_FILEEXIST		(17  * 4 | WR_ALLOW)
#define WR_D_FILEEXIST		(17  * 4 | WR_DENY)
/* EXDEV, 18,  Cross-device link */
#define WR_EXDEV  		(18  * 4)
#define WR_A_EXDEV		(18  * 4 | WR_ALLOW)
#define WR_D_EXDEV		(18  * 4 | WR_DENY)
/* ENODEV, 19,  Operation not supported by device */
#define WR_ENODEV  		(19  * 4)
#define WR_A_ENODEV		(19  * 4 | WR_ALLOW)
#define WR_D_ENODEV		(19  * 4 | WR_DENY)
/* ENOTDIR, 20,  Not a directory */
#define WR_ENOTDIR  		(20  * 4)
#define WR_A_ENOTDIR		(20  * 4 | WR_ALLOW)
#define WR_D_ENOTDIR		(20  * 4 | WR_DENY)
/* EISDIR, 21,  Is a directory */
#define WR_EISDIR  		(21  * 4)
#define WR_A_EISDIR		(21  * 4 | WR_ALLOW)
#define WR_D_EISDIR		(21  * 4 | WR_DENY)
/* EINVAL, 22,  Invalid argument */
#define WR_BADARG  		(22  * 4)
#define WR_A_BADARG		(22  * 4 | WR_ALLOW)
#define WR_D_BADARG		(22  * 4 | WR_DENY)
/* ENFILE, 23,  Too many open files in system */
#define WR_ENFILE  		(23  * 4)
#define WR_A_ENFILE		(23  * 4 | WR_ALLOW)
#define WR_D_ENFILE		(23  * 4 | WR_DENY)
/* EMFILE, 24,  Too many open files */
#define WR_EMFILE  		(24  * 4)
#define WR_A_EMFILE		(24  * 4 | WR_ALLOW)
#define WR_D_EMFILE		(24  * 4 | WR_DENY)
/* ENOTTY, 25,  Inappropriate ioctl for device */
#define WR_ENOTTY  		(25  * 4)
#define WR_A_ENOTTY		(25  * 4 | WR_ALLOW)
#define WR_D_ENOTTY		(25  * 4 | WR_DENY)
/* ETXTBSY, 26,  Text file busy */
#define WR_FILEBSY  		(26  * 4)
#define WR_A_FILEBSY		(26  * 4 | WR_ALLOW)
#define WR_D_FILEBSY		(26  * 4 | WR_DENY)
/* EFBIG, 27,  File too large */
#define WR_FILE2BIG  		(27  * 4)
#define WR_A_FILE2BIG		(27  * 4 | WR_ALLOW)
#define WR_D_FILE2BIG		(27  * 4 | WR_DENY)
/* ENOSPC, 28,  No space left on device */
#define WR_NOSPC  		(28  * 4)
#define WR_A_NOSPC		(28  * 4 | WR_ALLOW)
#define WR_D_NOSPC		(28  * 4 | WR_DENY)
/* ESPIPE, 29,  Illegal seek */
#define WR_ESPIPE  		(29  * 4)
#define WR_A_ESPIPE		(29  * 4 | WR_ALLOW)
#define WR_D_ESPIPE		(29  * 4 | WR_DENY)
/* EROFS, 30,  Read-only file system */
#define WR_EROFS  		(30  * 4)
#define WR_A_EROFS		(30  * 4 | WR_ALLOW)
#define WR_D_EROFS		(30  * 4 | WR_DENY)
/* EMLINK, 31,  Too many links */
#define WR_EMLINK  		(31  * 4)
#define WR_A_EMLINK		(31  * 4 | WR_ALLOW)
#define WR_D_EMLINK		(31  * 4 | WR_DENY)
/* EPIPE, 32,  Broken pipe */
#define WR_EPIPE  		(32  * 4)
#define WR_A_EPIPE		(32  * 4 | WR_ALLOW)
#define WR_D_EPIPE		(32  * 4 | WR_DENY)
/* EDOM, 33,  Numerical argument out of domain */
#define WR_EDOM  		(33  * 4)
#define WR_A_EDOM		(33  * 4 | WR_ALLOW)
#define WR_D_EDOM		(33  * 4 | WR_DENY)
/* ERANGE, 34,  Result too large */
#define WR_ERANGE  		(34  * 4)
#define WR_A_ERANGE		(34  * 4 | WR_ALLOW)
#define WR_D_ERANGE		(34  * 4 | WR_DENY)
/* EAGAIN, 35,  Resource temporarily unavailable */
#define WR_EAGAIN  		(35  * 4)
#define WR_A_EAGAIN		(35  * 4 | WR_ALLOW)
#define WR_D_EAGAIN		(35  * 4 | WR_DENY)
/* EINPROGRESS, 36,  Operation now in progress */
#define WR_EINPROGRESS  	(36  * 4)
#define WR_A_EINPROGRESS	(36  * 4 | WR_ALLOW)
#define WR_D_EINPROGRESS	(36  * 4 | WR_DENY)
/* EALREADY, 37,  Operation already in progress */
#define WR_EALREADY  		(37  * 4)
#define WR_A_EALREADY		(37  * 4 | WR_ALLOW)
#define WR_D_EALREADY		(37  * 4 | WR_DENY)
/* ENOTSOCK, 38,  Socket operation on non-socket */
#define WR_ENOTSOCK  		(38  * 4)
#define WR_A_ENOTSOCK		(38  * 4 | WR_ALLOW)
#define WR_D_ENOTSOCK		(38  * 4 | WR_DENY)
/* EDESTADDRREQ, 39,  Destination address required */
#define WR_EDESTADDRREQ  	(39  * 4)
#define WR_A_EDESTADDRREQ	(39  * 4 | WR_ALLOW)
#define WR_D_EDESTADDRREQ	(39  * 4 | WR_DENY)
/* EMSGSIZE, 40,  Message too long */
#define WR_EMSGSIZE  		(40  * 4)
#define WR_A_EMSGSIZE		(40  * 4 | WR_ALLOW)
#define WR_D_EMSGSIZE		(40  * 4 | WR_DENY)
/* EPROTOTYPE, 41,  Protocol wrong type for socket */
#define WR_EPROTOTYPE  		(41  * 4)
#define WR_A_EPROTOTYPE		(41  * 4 | WR_ALLOW)
#define WR_D_EPROTOTYPE		(41  * 4 | WR_DENY)
/* ENOPROTOOPT, 42,  Protocol not available */
#define WR_ENOPROTOOPT  	(42  * 4)
#define WR_A_ENOPROTOOPT	(42  * 4 | WR_ALLOW)
#define WR_D_ENOPROTOOPT	(42  * 4 | WR_DENY)
/* EPROTONOSUPPORT, 43,  Protocol not supported */
#define WR_EPROTONOSUPPORT  	(43  * 4)
#define WR_A_EPROTONOSUPPORT	(43  * 4 | WR_ALLOW)
#define WR_D_EPROTONOSUPPORT	(43  * 4 | WR_DENY)
/* ESOCKTNOSUPPORT, 44,  Socket type not supported */
#define WR_ESOCKTNOSUPPORT  	(44  * 4)
#define WR_A_ESOCKTNOSUPPORT	(44  * 4 | WR_ALLOW)
#define WR_D_ESOCKTNOSUPPORT	(44  * 4 | WR_DENY)
/* EOPNOTSUPP, 45,  Operation not supported */
#define WR_EOPNOTSUPP  		(45  * 4)
#define WR_A_EOPNOTSUPP		(45  * 4 | WR_ALLOW)
#define WR_D_EOPNOTSUPP		(45  * 4 | WR_DENY)
/* EPFNOSUPPORT, 46,  Protocol family not supported */
#define WR_EPFNOSUPPORT  	(46  * 4)
#define WR_A_EPFNOSUPPORT	(46  * 4 | WR_ALLOW)
#define WR_D_EPFNOSUPPORT	(46  * 4 | WR_DENY)
/* EAFNOSUPPORT, 47,  Address family not supported by protocol family */
#define WR_EAFNOSUPPORT  	(47  * 4)
#define WR_A_EAFNOSUPPORT	(47  * 4 | WR_ALLOW)
#define WR_D_EAFNOSUPPORT	(47  * 4 | WR_DENY)
/* EADDRINUSE, 48,  Address already in use */
#define WR_EADDRINUSE  		(48  * 4)
#define WR_A_EADDRINUSE		(48  * 4 | WR_ALLOW)
#define WR_D_EADDRINUSE		(48  * 4 | WR_DENY)
/* EADDRNOTAVAIL, 49,  Can't assign requested address */
#define WR_EADDRNOTAVAIL  	(49  * 4)
#define WR_A_EADDRNOTAVAIL	(49  * 4 | WR_ALLOW)
#define WR_D_EADDRNOTAVAIL	(49  * 4 | WR_DENY)
/* ENETDOWN, 50,  Network is down */
#define WR_ENETDOWN  		(50  * 4)
#define WR_A_ENETDOWN		(50  * 4 | WR_ALLOW)
#define WR_D_ENETDOWN		(50  * 4 | WR_DENY)
/* ENETUNREACH, 51,  Network is unreachable */
#define WR_ENETUNREACH  	(51  * 4)
#define WR_A_ENETUNREACH	(51  * 4 | WR_ALLOW)
#define WR_D_ENETUNREACH	(51  * 4 | WR_DENY)
/* ENETRESET, 52,  Network dropped connection on reset */
#define WR_ENETRESET  		(52  * 4)
#define WR_A_ENETRESET		(52  * 4 | WR_ALLOW)
#define WR_D_ENETRESET		(52  * 4 | WR_DENY)
/* ECONNABORTED, 53,  Software caused connection abort */
#define WR_ECONNABORTED  	(53  * 4)
#define WR_A_ECONNABORTED	(53  * 4 | WR_ALLOW)
#define WR_D_ECONNABORTED	(53  * 4 | WR_DENY)
/* ECONNRESET, 54,  Connection reset by peer */
#define WR_ECONNRESET  		(54  * 4)
#define WR_A_ECONNRESET		(54  * 4 | WR_ALLOW)
#define WR_D_ECONNRESET		(54  * 4 | WR_DENY)
/* ENOBUFS, 55,  No buffer space available */
#define WR_ENOBUFS  		(55  * 4)
#define WR_A_ENOBUFS		(55  * 4 | WR_ALLOW)
#define WR_D_ENOBUFS		(55  * 4 | WR_DENY)
/* EISCONN, 56,  Socket is already connected */
#define WR_EISCONN  		(56  * 4)
#define WR_A_EISCONN		(56  * 4 | WR_ALLOW)
#define WR_D_EISCONN		(56  * 4 | WR_DENY)
/* ENOTCONN, 57,  Socket is not connected */
#define WR_ENOTCONN  		(57  * 4)
#define WR_A_ENOTCONN		(57  * 4 | WR_ALLOW)
#define WR_D_ENOTCONN		(57  * 4 | WR_DENY)
/* ESHUTDOWN, 58,  Can't send after socket shutdown */
#define WR_ESHUTDOWN  		(58  * 4)
#define WR_A_ESHUTDOWN		(58  * 4 | WR_ALLOW)
#define WR_D_ESHUTDOWN		(58  * 4 | WR_DENY)
/* ETOOMANYREFS, 59,  Too many references: can't splice */
#define WR_ETOOMANYREFS  	(59  * 4)
#define WR_A_ETOOMANYREFS	(59  * 4 | WR_ALLOW)
#define WR_D_ETOOMANYREFS	(59  * 4 | WR_DENY)
/* ETIMEDOUT, 60,  Operation timed out */
#define WR_ETIMEDOUT  		(60  * 4)
#define WR_A_ETIMEDOUT		(60  * 4 | WR_ALLOW)
#define WR_D_ETIMEDOUT		(60  * 4 | WR_DENY)
/* ECONNREFUSED, 61,  Connection refused */
#define WR_ECONNREFUSED  	(61  * 4)
#define WR_A_ECONNREFUSED	(61  * 4 | WR_ALLOW)
#define WR_D_ECONNREFUSED	(61  * 4 | WR_DENY)
/* ELOOP, 62,  Too many levels of symbolic links */
#define WR_ELOOP  		(62  * 4)
#define WR_A_ELOOP		(62  * 4 | WR_ALLOW)
#define WR_D_ELOOP		(62  * 4 | WR_DENY)
/* ENAMETOOLONG, 63,  File name too long */
#define WR_FNAME2LONG  		(63  * 4)
#define WR_A_FNAME2LONG		(63  * 4 | WR_ALLOW)
#define WR_D_FNAME2LONG		(63  * 4 | WR_DENY)
/* EHOSTDOWN, 64,  Host is down */
#define WR_EHOSTDOWN  		(64  * 4)
#define WR_A_EHOSTDOWN		(64  * 4 | WR_ALLOW)
#define WR_D_EHOSTDOWN		(64  * 4 | WR_DENY)
/* EHOSTUNREACH, 65,  No route to host */
#define WR_EHOSTUNREACH  	(65  * 4)
#define WR_A_EHOSTUNREACH	(65  * 4 | WR_ALLOW)
#define WR_D_EHOSTUNREACH	(65  * 4 | WR_DENY)
/* ENOTEMPTY, 66,  Directory not empty */
#define WR_ENOTEMPTY  		(66  * 4)
#define WR_A_ENOTEMPTY		(66  * 4 | WR_ALLOW)
#define WR_D_ENOTEMPTY		(66  * 4 | WR_DENY)
/* EPROCLIM, 67,  Too many processes */
#define WR_2MANYPROC  		(67  * 4)
#define WR_A_2MANYPROC		(67  * 4 | WR_ALLOW)
#define WR_D_2MANYPROC		(67  * 4 | WR_DENY)
/* EUSERS, 68,  Too many users */
#define WR_2MANYUSER  		(68  * 4)
#define WR_A_2MANYUSER		(68  * 4 | WR_ALLOW)
#define WR_D_2MANYUSER		(68  * 4 | WR_DENY)
/* EDQUOT, 69,  Disc quota exceeded */
#define WR_EDQUOT  		(69  * 4)
#define WR_A_EDQUOT		(69  * 4 | WR_ALLOW)
#define WR_D_EDQUOT		(69  * 4 | WR_DENY)
/* ESTALE, 70,  Stale NFS file handle */
#define WR_ESTALE  		(70  * 4)
#define WR_A_ESTALE		(70  * 4 | WR_ALLOW)
#define WR_D_ESTALE		(70  * 4 | WR_DENY)
/* EREMOTE, 71,  Too many levels of remote in path */
#define WR_EREMOTE  		(71  * 4)
#define WR_A_EREMOTE		(71  * 4 | WR_ALLOW)
#define WR_D_EREMOTE		(71  * 4 | WR_DENY)
/* EBADRPC, 72,  RPC struct is bad */
#define WR_EBADRPC  		(72  * 4)
#define WR_A_EBADRPC		(72  * 4 | WR_ALLOW)
#define WR_D_EBADRPC		(72  * 4 | WR_DENY)
/* ERPCMISMATCH, 73,  RPC version wrong */
#define WR_ERPCMISMATCH  	(73  * 4)
#define WR_A_ERPCMISMATCH	(73  * 4 | WR_ALLOW)
#define WR_D_ERPCMISMATCH	(73  * 4 | WR_DENY)
/* EPROGUNAVAIL, 74,  RPC prog. not avail */
#define WR_EPROGUNAVAIL  	(74  * 4)
#define WR_A_EPROGUNAVAIL	(74  * 4 | WR_ALLOW)
#define WR_D_EPROGUNAVAIL	(74  * 4 | WR_DENY)
/* EPROGMISMATCH, 75,  Program version wrong */
#define WR_EPROGMISMATCH  	(75  * 4)
#define WR_A_EPROGMISMATCH	(75  * 4 | WR_ALLOW)
#define WR_D_EPROGMISMATCH	(75  * 4 | WR_DENY)
/* EPROCUNAVAIL, 76,  Bad procedure for program */
#define WR_EPROCUNAVAIL  	(76  * 4)
#define WR_A_EPROCUNAVAIL	(76  * 4 | WR_ALLOW)
#define WR_D_EPROCUNAVAIL	(76  * 4 | WR_DENY)
/* ENOLCK, 77,  No locks available */
#define WR_ENOLCK  		(77  * 4)
#define WR_A_ENOLCK		(77  * 4 | WR_ALLOW)
#define WR_D_ENOLCK		(77  * 4 | WR_DENY)
/* ENOSYS, 78,  Function not implemented */
#define WR_NOSYSCALL  		(78  * 4)
#define WR_A_NOSYSCALL		(78  * 4 | WR_ALLOW)
#define WR_D_NOSYSCALL		(78  * 4 | WR_DENY)
/* EFTYPE, 79,  Inappropriate file type or format */
#define WR_EFTYPE  		(79  * 4)
#define WR_A_EFTYPE		(79  * 4 | WR_ALLOW)
#define WR_D_EFTYPE		(79  * 4 | WR_DENY)
/* EAUTH, 80,  Authentication error */
#define WR_EAUTH  		(80  * 4)
#define WR_A_EAUTH		(80  * 4 | WR_ALLOW)
#define WR_D_EAUTH		(80  * 4 | WR_DENY)
/* ENEEDAUTH, 81,  Need authenticator */
#define WR_ENEEDAUTH  		(81  * 4)
#define WR_A_ENEEDAUTH		(81  * 4 | WR_ALLOW)
#define WR_D_ENEEDAUTH		(81  * 4 | WR_DENY)
/* ELAST, 81,  Must be equal largest errno */
#define WR_ELAST  		(81  * 4)
#define WR_A_ELAST		(81  * 4 | WR_ALLOW)
#define WR_D_ELAST		(81  * 4 | WR_DENY)
#define	WR_SUCC			(100 * 4)	/* SUCC, 100, Successful */
#define	WR_FAIL			(101 * 4)	/* FAIL, 101, Fail */
