/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wr_iface.h,v 1.37 2001/02/23 19:02:25 stevek Exp $
 *
 * Author: Chris Vance and Lee Badger
 *
 * Purpose: 
 */

#ifndef	WR_IFACE_H
#define WR_IFACE_H

#include <sys/param.h>
#ifndef _SYS_QUEUE_H_
#include "queue.h"
#endif

/*
 * Return codes for event interception.
 */
#define WR_ALLOW	0
#define WR_SUCCESS	0
#define WR_DENY 	1
#define WR_NONE		2
#define WR_MASK1	0x3
#define WR_MASK2        0xfffffffc

typedef char *string;

#define WR_BUFSIZE	128
struct wr_databuf {
    int max, size;
    char *buf;
};

typedef struct wr_databuf *databuf_t;

/*
 * Flags for tables
 */
#define WQTAB_ALERT	0x00000001		/* Alerts enabled */

struct wr_export_table {
        struct wr_iface *iface;
        int count;
};

struct wr_iface {
        char *library;
        char *name;
        int version;
        u_long function;
        struct wr_iface *next;
};

/*
 * List of wrappers to be activated.  An activation criterion adds elements
 * to a list provided by the WSS's exec code.
 */
struct act_wrap {
	char *name;	/* TBD, make a non-string */
	struct act_wrap *next;
};

#endif /* WR_IFACE_H */
