/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wr_string.h,v 1.6 2001/02/23 19:02:25 stevek Exp $
 *
 * Author: Linda Thomas
 *
 * Purpose:
 * Enable programmer's to include the proper string header file, <string> 
 * on post-STL compilers and <String.h> on pre-STL compilers.  
 *
 * Include this file anywhere you would have included <String.h> or <string> 
 * to ensure that we can compile in all environments.
 *
 */

#include "wr_conf.h"

#if WR_BROKEN_STL

#include <String.h>

#else

#include <string>
typedef std::string String;

#endif
