/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wrappers.h,v 1.18 2001/02/23 19:02:25 stevek Exp $
 *
 * Author: Chris Vance
 *
 * Purpose: This file contains prototypes that will be needed in
 * user-space programs.
 */


#include <wsi_syscalls.h>

/*
 * Macros for system calls added by the WSS
 */
#define WR_wrctl(command, id, buf)					\
	syscall(SYS_wrctl, (int)command, (int)(id), (void *)buf)

#define WR_wrv(option, args, bufsize)					\
	syscall(SYS_wrv, (int)(option), (void *)(args), (ssize_t *)(bufsize))


/*
 * File extension for wrapper modules
 */
#ifdef WR_WINNT
#define WR_MODULE_EXT	".dll"
#else
#define WR_MODULE_EXT	".wmo"
#endif

