/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wrerrno.h,v 1.9 2001/02/23 19:02:25 stevek Exp $
 *
 * Author: Chris Vance and Lee Badger
 *
 * This file contains definitions for errors returned by the WSS
 */ 

#define WRE_OK		0		/* Everything is OK; success	*/

#define WRE_ERROR	1		/* General, nondescript error */
#define WRE_PERM	2		/* Operation not permitted */
#define WRE_NOMEM	3		/* Cannot allocate memory */
#define WRE_NOTFOUND	4		/* Object not found */
#define WRE_REF		5		/* Object still has references */
#define WRE_EXIST	6		/* Object already exists	*/
#define	WRE_INVALID_PARAMETER	7	/* Any of a variety of problems */
#define	WRE_BAD_FIELD	8		/* Field name doesn't exist */
#define	WRE_DB_SPACE_EXHAUSTED	9	/* wss.db exhausted */
#define	WRE_TYPE_MISMATCH	10	/* Comparison of incomparable types. */
#define WRE_ALREADY	11		/* Operation already done */

