/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: libgwmcomm.h,v 1.10 2001/02/23 19:02:26 stevek Exp $
 */

#ifndef __GWMCOMM_H
#define __GWMCOMM_H 1

#include <wr_conf.h>

#include <pipesrv.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef void (*GWMCommEventCallbackFunc)( PVOID, DWORD );

void   LINKAGE gwmcommFreeData              __P(( PVOID ));
BOOL   LINKAGE gwmcommGetPacket             __P(( DWORD, LPPIPESRV_COMM_HEADER *,
                                                  PVOID * ));
void   LINKAGE gwmcommRegisterEventCallback __P(( GWMCommEventCallbackFunc ));
void   LINKAGE gwmcommSetup                 __P(( void ));
BOOL   LINKAGE gwmcommWaitForPacketResponse __P(( DWORD, DWORD *, PVOID *, DWORD * ));
void   LINKAGE gwmcommWorkThread            __P(( PVOID ));
DWORD  LINKAGE gwmcommWritePacket           __P(( DWORD, DWORD, PVOID ));

#ifdef __cplusplus
}
#endif

#endif /* __GWMCOMM_H */

