/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * $Id: re_any.cc,v 1.11 2001/04/05 18:41:32 stevek Exp $
 */

#include <wr_conf.h>

#include <stdlib.h>
#include <ctype.h>

#undef LINKAGE
#define LINKAGE EXPORT
#include "libre.h"

regex_any_token::regex_any_token( int subindex, bool_t newline, bool_t null )
   : regex_token( subindex )
{
   re_newline = newline;
   re_null    = null;
}

regex_any_token::~regex_any_token() {}

re_token_type
regex_any_token::re_gettype()
{
   return RE_ANY;
}

bool_t
regex_any_token::re_canbenull()
{
   return re_null;
}

bool_t
regex_any_token::re_canbenewline()
{
   return re_newline;
}

int
regex_any_token::re_minlen()
{
   return 1;
}

i_vec *
regex_any_token::re_match( regex_charindex &input, int index, int eflags )
{
   char ch = input.re_str[index];
   if( ( !re_newline && ( ch == '\n' ) ) ||
       ( re_null && ( ch == '\0' ) ) )
      return NULL;

   return re_next( input, index + 1, eflags );
}

void
regex_any_token::re_dump( FILE *f )
{
   fprintf( f, "." );
}

