/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * $Id: re_token.cc,v 1.15 2001/04/05 18:41:32 stevek Exp $
 */
#include <wr_conf.h>

#include <stdlib.h>

#undef LINKAGE
#define LINKAGE EXPORT
#include "libre.h"

regex_token::regex_token( int subindex, bool_t stingy )
{
   re_nexttok     = NULL;
   re_uncletok    = NULL;
   re_subindex    = subindex;
   re_canbestingy = stingy;
}

regex_token::~regex_token() {}

re_token_type
regex_token::re_gettype()
{
   return RE_NOP;
}

int
regex_token::re_minlen()
{
   return 0;
}

int
regex_token::re_children()
{
   return 0;
}

regex_token *
regex_token::operator[]( int index )
{
   return NULL;
}

bool_t
regex_token::re_canstingy()
{
   return re_canbestingy;
}

int
regex_token::re_getsubindex()
{
   return re_subindex;
}

void
regex_token::re_setstingy()
{
   re_stingy = RE_TRUE;
}

void
regex_token::re_setuncle( regex_token *uncle )
{
   re_uncletok = uncle;
}

regex_token *
regex_token::re_getuncle()
{
   return re_uncletok;
}

regex_token *
regex_token::re_getnext()
{
   return re_nexttok;
}

i_vec *
regex_token::re_next( regex_charindex &input, int index, int eflags )
{
   if( re_nexttok == NULL )
   {
      if( ( index <= input.re_index ) &&
          ( ( re_uncletok == NULL ) ||
            ( re_uncletok->re_match( input, index, eflags ) != NULL ) ) )
      {
         i_vec *rval = new i_vec();
         rval->push_back( index );
         return rval;
      }
      else
         return NULL;
   }
   return re_nexttok->re_match( input, index, eflags );
}

bool_t
regex_token::re_chain( regex_token *next )
{
   re_nexttok = next;
   return RE_TRUE;
}

regex_token *
regex_token::re_walk()
{
   return( ( re_nexttok == NULL )?re_uncletok:re_nexttok );
}

void
regex_token::re_dump( FILE *f )
{
}

void
regex_token::re_dumpall( FILE *f )
{
   re_dump( f );
   if( re_nexttok != NULL )
      re_nexttok->re_dumpall( f );
}

