#!/usr/local/bin/perl
#  
#  Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
#  All rights reserved.
# 
#  This file is part of the NAI Generic Software Wrappers Toolkit
#  (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
#  distribution.
# 
#  The GSWTK is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
# 
#  The GSWTK is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this software; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.
#

$ARGV[0] =~ s/\.c$//;

my $source = $ARGV[0] . ".c";
my $header = $ARGV[0] . ".h";

open( SOURCE, ">$source" ) || die "$source: $!";
open( HEADER, ">$header" ) || die "$header: $!";

print SOURCE <<EOF;
/*
 * Generated source file.  Do not edit.
 */
char *header_str =
EOF

$count = 0;
$nhdr = 1;
while( <STDIN> ) {
	chomp;
	s/\\/\\\\/g;
	s/"/\\"/g;
	s/$/\\n/;

	$count = $count + length($_);
	if( $count >= 65535 ) {
		$count = length($_);
		$nhdr++;
		print SOURCE <<EOF;
;

char *header_str$nhdr =
EOF
	}
	print SOURCE "\"" . $_ . "\"\n";
}

print SOURCE <<EOF;
;

EOF

print HEADER <<EOF;
/*
 * Generated header file.  Do not edit.
 */
#ifndef __HEADERS_H
#define __HEADERS_H 1

extern "C" {

extern char *header_str;
EOF

foreach( 2 .. $nhdr ) {
	print HEADER <<EOF;
extern char *header_str$_;
EOF
}

print HEADER <<EOF;

}

#define MAKE_HEADER(a,b) \\
	{ append(a); append(header_str); \\
EOF

foreach( 2 .. $nhdr ) {
	printf HEADER <<EOF;
	append(header_str$_); \\
EOF
}

print HEADER <<EOF;
	append(b);}

#endif /* __HEADERS_H */

EOF

close( HEADER );
close( SOURCE );

