/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: expr.cc,v 1.9 2001/04/05 18:41:33 stevek Exp $
 */

#include "wr_conf.h"
#include <stdio.h>
#include "expr.h"
#include "event.h"


extern TypeTbl typetbl;
extern void wdlerror(const char *s, const char *s1 = "");
Type IdentExpr::compute_type(WrEvent *ev)

{
     Param *p = ev->find_param(name);
     if (p == NULL) 
          wdlerror("Invalid parameter reference :", name);
     type = *p->d_type;
     return type;  
};

Type PtrRefExpr::compute_type(WrEvent *ev)

{
     return expr->compute_type(ev);
}

Type PtrToElmExpr::compute_type(WrEvent *ev)

{
     Type t = expr->compute_type(ev);
     if (t.tc != TC_PTR)
          wdlerror("Invalid parameter reference :", expr->get_src()->all());

     Type t1 = t.get_elmtype();
     if (!(t1.tc == TC_STRUCT || t1.tc == TC_UNION))
          wdlerror("Invalid parameter reference :", expr->get_src()->all());

     type = t1.get_elmtype(name);
     if (type.tc == errType)
          wdlerror("Invalid parameter reference :", name);
     return type;
};

Type RecElmExpr::compute_type(WrEvent *ev)

{
     Type t = expr->compute_type(ev);    
     if (!(t.tc == TC_STRUCT || t.tc == TC_UNION))
          wdlerror("Invalid parameter reference :", expr->get_src()->all());
     type = t.get_elmtype(name);  
     if (type.tc == errType) 
          wdlerror("Invalid parameter reference :", name);
     return type;
} 

Type ArrayElmExpr::compute_type(WrEvent *ev)

{
     Type t = expr->compute_type(ev);    
     if (!(t.tc == TC_ARRAY || t.tc == TC_PTR))
          wdlerror("Invalid parameter reference :", expr->get_src()->all());
     Type type = t.get_elmtype();  
     if (type.tc == errType) 
          wdlerror("Invalid parameter reference :", get_src()->all());
     return type;
} 

