/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: libwdl.h,v 1.7 2001/02/23 19:02:28 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: To centralize the externals
 *
 */

#ifndef __LIBWDL_H
#define __LIBWDL_H 1

#include <wr_conf.h>

#ifdef __cplusplus
extern "C" {
#endif

#if   defined(WR_FREEBSD)
extern char *freebsd_syscallnames[];
#define syscallnames freebsd_syscallnames
#elif defined(WR_SOLARIS)
extern char *solaris_syscallnames[];
#define syscallnames solaris_syscallnames
#elif defined(WR_WINNT)
extern LPTSTR winnt_syscallnames[];
#define syscallnames winnt_syscallnames
#elif defined(WR_LINUX)
extern char *linux_syscallnames[];
#define syscallnames linux_syscallnames
#else
#  error Unsupported platform, please port this file.
#endif

#ifdef __cplusplus
}
#endif

int get_syscallcode( const TCHAR *s );

#endif /* !__LIBWDL_H */

