/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: stack.h,v 1.7 2001/02/23 19:02:28 stevek Exp $
 *
 * Author: Mark Feldman
 *
 * Purpose: Object to manipulate stacks of ints.
 *  
 */

template <class T>
class stack {
private:
	int max, cur;
        T *data; /* Array of T for the stack */

public:
	stack() {
            max = 100;
            cur = -1;
            data = new T [max];
        }
        ~stack() {
            delete[] data;
        }
	int  is_empty() {
            return (cur == -1);
        }
	int  is_full() {
            return (cur == max - 1);
        }
	void push(T i) {
            if (cur < max - 1)
                data[++cur] = i;
        }
        T pop() {
            if (cur > -1)
                return data[cur--];
            else
                abort();
        }
        T    top() {
            if (cur > -1)
                return data[cur];
            else
                abort();
        }
};

