/*! \file libwrinit.h
 * Copyright (C) 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: libwrinit.h,v 1.5 2001/02/07 00:52:37 stevek Exp $
 *
 * \brief   Header file for configuration options
 * \author  Steve Kiernan
 * \version $Revision: 1.5 $
 * \date    $Date: 2001/02/07 00:52:37 $
 */

#ifndef __LIBWRINIT_H
#define __LIBWRINIT_H 1

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************************************\
 * Public globals                                                          *
\***************************************************************************/

extern pd_char_t LINKAGE *wss_init_home;
extern pd_char_t LINKAGE *wss_log_path;
extern pd_char_t LINKAGE *wss_db_filename;
extern pd_char_t LINKAGE *wss_inc_path;
extern pd_char_t LINKAGE *wss_wrap_inc_path;
extern int       LINKAGE  wss_db_size;

/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/

void LINKAGE wr_init_startup( void );
int  LINKAGE wr_init_read_conf( void );

#ifdef __cplusplus
}
#endif

#endif /* __LIBWRINIT_H */

