/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: libwrmod.h,v 1.14 2001/02/23 19:02:28 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: Library for manipulating wrappers modules.  
 */

#ifndef __LIBWRMOD_H
#define __LIBWRMOD_H  1

#include <wr_conf.h>

/*
 * Public functions
 */
#ifdef __cplusplus
extern "C" {
#endif

void LINKAGE wrmodSetup            __P(( void ));
int  LINKAGE wrmodLoad             __P(( const LPTSTR infile ));
int  LINKAGE wrmodUnload           __P(( int id ));
int  LINKAGE wrmodEnable           __P(( int id, int yesno ));

#ifdef WR_WINNT
int LINKAGE wrmodntProcessCommand __P(( DWORD command, PVOID pBuf, UINT size ));
#endif /* WR_WINNT */

#ifdef __cplusplus
}
#endif

#endif /* !__LIBWRMOD_H */

