/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wrstatnt.c,v 1.5 2001/02/23 19:02:29 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 */

#include <wr_conf.h>

#include <errno.h>

#define LINKAGE EXPORT

#include "../libgwmcomm/libgwmcomm.h"
#include "libwrstat.h"

int EXPORT
wrstatntProcessCommand( DWORD command, PVOID pBuf, UINT size )
{
   int error;

   DWORD dwID = gwmcommWritePacket( command, sizeof(size), &size );
   if( !dwID )
   {
      SetLastError( ENOENT );
      return -ENOENT;
   }

   if( !gwmcommWaitForPacketResponse( dwID, &error, NULL, 0 ) )
      error = -ENOENT;

   if( error < 0 )
      SetLastError( -error );

   return error;
}

