#  
#  Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
#  All rights reserved.
# 
#  This file is part of the NAI Generic Software Wrappers Toolkit
#  (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
#  distribution.
# 
#  The GSWTK is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
# 
#  The GSWTK is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this software; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.

BUILD_SHARED	= yes
BUILD_STATIC	= yes

SHLIB_MAJOR	= 0
SHLIB_MINOR	= 1

UNIX_CFLAGS	+= -g -O2 -Wall -Wpointer-arith
WINNT_CFLAGS	+= -DNDEBUG -DUNICODE -D_UNICODE -I../gwm
WINNT_CFLAGS	+= -DWSSLINKAGE=EXPORT

CFLAGS		+= -I ${TOPDIR}/wr.include
CFLAGS		+= -I ${TOPDIR}/wss/include
CFLAGS		+= -I ${TOPDIR}/wsi/${BUILDDIR}/include
CFLAGS		+= -D_WSS -DLINKER_INIT=linker_${LINKER_FORMAT}_init
STATIC_CFLAGS	+= -DPD_IN_KERNEL=1
SHLIB_CFLAGS	+= -DUSER_MODE_TEST=1

UNIX_SHLINKLIBS	+= ${TOPDIR}/testlibs/linker/${LIBPRFX}linker${PICLIBEXT}
WINNT_SHLINKLIBS += ${TOPDIR}/testlibs/linker/${LIBPRFX}linker${LIBEXT}

LIBBASE		= linker_${LINKER_FORMAT}

OBJS		+= linker_${LINKER_FORMAT}${OBJ} \
		   linker_${LINKER_FORMAT}_machdep${OBJ}

SHOBJS		+= linker_init${SHOBJ}

COPYTARGET	= ${TOPDIR}/${WSSTARGETDIR}

CLEANFILES	+= core linker_${LINKER_FORMAT}_machdep.c linker_init.c \
		   linker_header.h

include ${TOPDIR}/mak/library.mak${OSSPECEXT}

linker_${LINKER_FORMAT}_machdep.c: ${CPU}/linker_${LINKER_FORMAT}_machdep_${CPU}.c
	${LN} ${CPU}/linker_${LINKER_FORMAT}_machdep_${CPU}.c \
	      linker_${LINKER_FORMAT}_machdep.c

linker_init.c: ${TOPDIR}/linkers/linker_init.c linker_header.h
	@${RM} linker_init.c
	${LN} ${TOPDIR}/linkers/linker_init.c .

linker_header.h: linker_${LINKER_FORMAT}.h
	@${RM} linker_header.h
	${LN} linker_${LINKER_FORMAT}.h linker_header.h

wss_linker.c: ${TOPDIR}/wss/wss_linker.c
	${LN} ${TOPDIR}/wss/wss_linker.c .

