#  
#  Copyright (C) 2001  Network Associates, Incorporated (NAI)
#  All rights reserved.
# 

include ${TOPDIR}/mak/common.mak

WINNT_CFLAGS += -DUNICODE -D_UNICODE

include ${TOPDIR}/mak/obj.mak

WRAPLIBMAK = pre
include ${TOPDIR}/wr.mak/wraplib.mak.${MAKEINC}

CFLAGS += -DPDLINKAGE=IMPORT -DWSSLINKAGE=IMPORT
CFLAGS += -I ${TOPDIR}/include
LDADD = ${LDLIBS}
LDLIBS =

WRAPPER	= ${WRAPLIB}

.SUFFIXES: .wr .c ${WRAPEXT} ${OBJ} .i
.PHONY: all clean postwrapall postwrapclean depend cleandir
.PHONY: install release

all: ${BUILD_WRAPPERS_SRCS} ${BUILD_WRAPPERS_OBJS} ${BUILD_WRAPPERS_MODS} postwrapall

cleandir: clean

clean: ${PRETARGETCLEAN} postwrapclean
	for i in ${BUILD_WRAPPERS}; do \
		${RM} $${i}${OBJ} $${i}${WRAPEXT}; \
	done

depend:

.c${OBJ}: ${WRAPLIBDEPENDS}
	${COMPILE.c} $<

${OBJ}${WRAPEXT}:
	@${RELOC_LINK} ${RELOC_OUT} ${RELOC_OBJS}

SUBDIRPRFX	= postwrap

install: postwrapinstall
	@if [ -z "${INSTALLDIR}" ]; then \
	   INSTALLDIR="${WRAPDIR}"; \
	else \
	   INSTALLDIR="${INSTALLDIR}"; \
	fi; \
	if [ ! -d "$${INSTALLDIR}" ]; then \
	   ${SHELL} -c "${TOPDIR}/mak/mkdirhier \"$${INSTALLDIR}\""; \
	fi; \
	for i in ${BUILD_WRAPPERS}; do \
	   echo "${CP} $${i}${WRAPEXT} \"$${INSTALLDIR}\""; \
	   ${CP} $${i}${WRAPEXT} "$${INSTALLDIR}"; \
	done

release: postwraprelease

include ${TOPDIR}/mak/subdir.mak

WRAPLIBMAK = post
include ${TOPDIR}/wr.mak/wraplib.mak.${MAKEINC}

