#  
#  Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
#  All rights reserved.
# 
#  This file is part of the NAI Generic Software Wrappers Toolkit
#  (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
#  distribution.
# 
#  The GSWTK is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
# 
#  The GSWTK is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this software; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.

include ${TOPDIR}/mak/common.mak

KERNEL_SOURCE	= yes

WINNT_CFLAGS += -DUNICODE -D_UNICODE

OBJMAK = pre
include ${TOPDIR}/mak/obj.mak.${MAKEINC}

WRAPMAK = pre
include ${TOPDIR}/wr.mak/wrapper.mak.${MAKEINC}

WRAPC = ${TOPDIR}/wr.bin/wrapc/wrapc${PROGEXT}

WRAPCFLAGS += -DPDLINKAGE=IMPORT -DLINKAGE=IMPORT -l
WRAPCFLAGS += ${MYINCLUDES}
# WRAPCFLAGS += -DEBUG=1

CFLAGS += -DPDLINKAGE=IMPORT -DWSSLINKAGE=IMPORT
CFLAGS += -I ${TOPDIR}/include
LDADD = ${LDLIBS}
LDADD += ${TOPDIR}/wsl/libwrimp/${LIBPRFX}wrimp${LIBEXT}
LDADD += ${TOPDIR}/wsl/libwss/${LIBPRFX}wss${LIBEXT}
LDADD += ${TOPDIR}/toolkits/eventfs/src/${BUILDDIR}/libs/libmtsync/${LIBPRFX}mtsync${LIBEXT}
LDLIBS =

.SUFFIXES: .wr .c ${WRAPEXT} ${OBJ} .i
.PHONY: all clean postwrapall postwrapclean depend cleandir
.PHONY: install release

all: ${BUILD_WRAPPERS_SRCS} ${BUILD_WRAPPERS_OBJS} ${BUILD_WRAPPERS_MODS} postwrapall

cleandir: clean

clean: ${PRETARGETCLEAN} postwrapclean
	for i in ${BUILD_WRAPPERS}; do \
		${RM} $${i}${OBJ} $${i}.c $${i}${WRAPEXT}; \
	done

depend:

.wr.c: ${WRAPC} ${WRAPDEPENDS}
	${WRAPC} ${WRAPCFLAGS} $<

.wr.i: ${WRAPC}
	${WRAPC} -E ${WRAPCFLAGS} $< > $@

.c${OBJ}:
	${COMPILE.c} $<

${OBJ}${WRAPEXT}:
	@${RELOC_LINK} ${RELOC_OUT} ${RELOC_OBJS}

SUBDIRPRFX	= postwrap

install: postwrapinstall
	@if [ -z "${INSTALLDIR}" ]; then \
	   INSTALLDIR="${WRAPDIR}"; \
	else \
	   INSTALLDIR="${INSTALLDIR}"; \
	fi; \
	if [ ! -z "${INSTALLROOT}" ]; then \
	   INSTALLDIR="${INSTALLROOT}/$${INSTALLDIR}"; \
	fi; \
	if [ ! -d "$${INSTALLDIR}" ]; then \
	   ${SHELL} -c "${TOPDIR}/mak/mkdirhier \"$${INSTALLDIR}\""; \
	fi; \
	for i in ${BUILD_WRAPPERS}; do \
	   echo "${CP} $${i}${WRAPEXT} \"$${INSTALLDIR}\""; \
	   ${CP} $${i}${WRAPEXT} "$${INSTALLDIR}"; \
	done

release: postwraprelease

include ${TOPDIR}/mak/subdir.mak

WRAPMAK = post
include ${TOPDIR}/wr.mak/wrapper.mak.${MAKEINC}

OBJMAK = post
include ${TOPDIR}/mak/obj.mak.${MAKEINC}

