/*
 *  Copyright (c) 2000, Network Associates, Incorporated
 *  All rights reserved.
 *
 *  Redistribution and use are governed by the terms detailed in the
 *  license document ("LICENSE") included with the toolkit.
 *
 * $Id: codes.h,v 1.3 2000/03/20 20:22:00 dougk Exp $
 *
 * codes.h
 *
 * Provides the list of event codes for common reference.
 */

#ifndef CODES_H
#define CODES_H 1
typedef enum event_codes {
    /* Processes */
    KERN_EXIT,
    KERN_FORK, /* = KERN_VFORK = KERN_CLONE */
    KERN_EXECVE,
    KERN_KILL,
    KERN_SETREUID, KERN_SETEUID = KERN_SETREUID, /* KERN_SETUID */
    KERN_MCTL, KERN_MPROTECT = KERN_MCTL,
 
    /* Files by inode */
    KERN_LINK,
    KERN_SYMLINK,
    KERN_UNLINK,
    KERN_CHMOD, /* KERN_FCHMOD */
    KERN_CHOWN, /* KERN_FCHOWN */
    KERN_FLOCK,

    /* Files by path */
    KERN_UTIME, /* KERN_UTIMES */
    KERN_RENAME,
    KERN_MKNOD,
    KERN_MKDIR,
    KERN_RMDIR,

    KERN_CREAT,
    KERN_TRUNCATE, /* KERN_FTRUNCATE */
    KERN_OPEN_R, /* No TC flags.  There will be T or C events instead */
    KERN_OPEN_W,
    KERN_OPEN_RW,
    KERN_CORE,

    /* Network */
    KERN_ACCEPT
} event_codes_t;

/* Magic number.  */
#define BSM_AUDIT_NUMBER 5
#endif

