/*
 *  Copyright (c) 1999, 2000 Network Associates, Incorporated
 *  All rights reserved.
 *	 
 *  Redistribution and use are governed by the terms detailed in the
 *  license document ("LICENSE") included with the toolkit.
 *
 */

#include "wr_conf.h"

#ifdef WR_BROKEN_STL
#define __PUT_STATIC_DATA_MEMBERS_HERE
#endif

#ifndef MESSAGE_H
#include "Message.h"
#endif

#include "unistd.h"

static void process( MessageSource &source)
{
    bool error = false;
    while (!error) {
        Message *mp;
        if ((mp = source.Next()) == NULL)
            break;
        error = mp->toEmeraldEvent(); /* This should post to emerald. */
        delete mp;
    }
}

static void usage(char *progname)
{
    cerr << progname << ": Invalid useage." << endl;
    exit(1);
}

int main(int argc, char *argv[])
{
    char *prog_name = rindex(argv[0], '/');
    MessageSource source (argc, argv);
    
    if (!prog_name)
        prog_name = argv[0];
    else
        ++prog_name;

    /*
     * EMERALD: Put INIT_RECORD stuff here.
     */
   
    /*
     * Event loop
     */
    process(source);

    return 0;
}
