extern int  WR_SUCC;
extern int  WR_FAIL;

/* Using "Linux" characterization. */

/* Using "system" characterization. */
/* Using default library */
typedef enum event_codes {KERN_EXIT, KERN_FORK, KERN_EXECVE, KERN_KILL, KERN_SETREUID, KERN_SETEUID = KERN_SETREUID, KERN_MCTL, KERN_MPROTECT = KERN_MCTL, KERN_LINK, KERN_SYMLINK, KERN_UNLINK, KERN_CHMOD, KERN_CHOWN, KERN_FLOCK, KERN_UTIME, KERN_RENAME, KERN_MKNOD, KERN_MKDIR, KERN_RMDIR, KERN_CREAT, KERN_TRUNCATE, KERN_OPEN_R, KERN_OPEN_W, KERN_OPEN_RW, KERN_CORE, KERN_ACCEPT}
 event_codes_t;


/*
 * Generated wrapper's C source.  Do not edit.
 */

#define WR_KERNEL_MODULE


struct wr_module;

#ifdef WSSLINKAGE
#undef WSSLINKAGE
#endif
#define WSSLINKAGE IMPORT

#define CUR_THREAD_ID 0
/*
 *  Copyright (c) 1999, 2000 Network Associates, Incorporated
 *  All rights reserved.
 *	 
 *  Redistribution and use are governed by the terms detailed in the
 *  license document ("LICENSE") included with the toolkit.
 *
 * $Id: emerald-stripped.c,v 1.2 2000/10/27 20:41:22 dougk Exp $
 *
 * Author: Chris Vance and Lee Badger
 *
 * This file contains definitions for errors returned by the WSS
 */ 

#define WRE_OK		0		/* Everything is OK; success	*/

#define WRE_ERROR	1		/* General, nondescript error */
#define WRE_PERM	2		/* Operation not permitted */
#define WRE_NOMEM	3		/* Cannot allocate memory */
#define WRE_NOTFOUND	4		/* Object not found */
#define WRE_REF		5		/* Object still has references */
#define WRE_EXIST	6		/* Object already exists	*/
#define	WRE_INVALID_PARAMETER	7	/* Any of a variety of problems */
#define	WRE_BAD_FIELD	8		/* Field name doesn't exist */
#define	WRE_DB_SPACE_EXHAUSTED	9	/* wss.db exhausted */
#define	WRE_TYPE_MISMATCH	10	/* Comparison of incomparable types. */
#define WRE_ALREADY	11		/* Operation already done */

#ifndef _SYS_QUEUE_H_
#define	_SYS_QUEUE_H_

#define WSS_LIST_HEAD(name, type)					\
struct name {								\
	struct type *lh_first;	/* first element */			\
}

#define LIST_ENTRY(type)						\
struct {								\
	struct type *le_next;	/* next element */			\
	struct type **le_prev;	/* address of previous next element */	\
}

/*
 * List functions.
 */
#define	LIST_INIT(head) {						\
	(head)->lh_first = NULL;					\
}

#define LIST_INSERT_AFTER(listelm, elm, field) {			\
	if (((elm)->field.le_next = (listelm)->field.le_next) != NULL)	\
		(listelm)->field.le_next->field.le_prev =		\
		    &(elm)->field.le_next;				\
	(listelm)->field.le_next = (elm);				\
	(elm)->field.le_prev = &(listelm)->field.le_next;		\
}

#define LIST_INSERT_BEFORE(listelm, elm, field) {			\
	(elm)->field.le_prev = (listelm)->field.le_prev;		\
	(elm)->field.le_next = (listelm);				\
	*(listelm)->field.le_prev = (elm);				\
	(listelm)->field.le_prev = &(elm)->field.le_next;		\
}

#define LIST_INSERT_HEAD(head, elm, field) {				\
	if (((elm)->field.le_next = (head)->lh_first) != NULL)		\
		(head)->lh_first->field.le_prev = &(elm)->field.le_next;\
	(head)->lh_first = (elm);					\
	(elm)->field.le_prev = &(head)->lh_first;			\
}

#define LIST_REMOVE(elm, field) {					\
	if ((elm)->field.le_next != NULL)				\
		(elm)->field.le_next->field.le_prev = 			\
		    (elm)->field.le_prev;				\
	*(elm)->field.le_prev = (elm)->field.le_next;			\
}

#endif /* !_SYS_QUEUE_H_ */

#ifndef WR_DEFS_INCLUDED
#define WR_DEFS_INCLUDED

#define WR_VERSION_MAJOR  1
#define WR_VERSION_MINOR  30
#define WR_VERSION_STRING "1.3.0"

#if defined(__linux__)
#define WR_LINUX
#define WR_UNIX

#ifndef WR_HAS_EVENTFS
#define WR_HAS_EVENTFS 1
#endif

#ifndef WR_KERNEL_VERSION
#define __NO_VERSION__          1
#endif
#define __KERNEL__              1
#define MODULE                  1
#define _LOOSE_KERNEL_NAMES     1

#ifndef __P
#define __P(foo) foo
#endif

#include <linux/linkage.h>
#include <linux/version.h>
#include <linux/module.h>
/* Kernel includes stdarg.h */
#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/utime.h>
#include <linux/sys.h>

#define WR_NCALLS NR_syscalls

#ifndef LINKAGE
#define LINKAGE
#endif

#ifndef WSSLINKAGE
#define WSSLINKAGE
#endif

#define IMPORT
#define EXPORT

#ifndef MAXPATHLEN
#define MAXPATHLEN 1024
#endif

typedef struct task_struct proc_t;

#endif /* __linux__ */

#define MAKESTR(a) a
#define assert(s)

#endif /* WR_DEFS_INCLUDED */

#ifndef __WSI_ERRNO_H
#define __WSI_ERRNO_H 1
#endif /* __WSI_ERRNO_H */

#ifndef __WSI_TYPES_H
#define __WSI_TYPES_H 1

typedef char          wss_char_t;
#define WSS_MAKESTR(a) a

#endif /* __WSI_TYPES_H */


#ifndef __WSS_REF_H
#define __WSS_REF_H 1

typedef struct _wss_ref wss_ref_t;

struct _wss_ref
{
   union
   {
      int                  ref_count;
#ifdef DEBUG_REFS
      struct
      {
         const wss_char_t *ref_file;
         int               ref_line;
      }
      st;
#endif /* DEBUG_REFS */
   }
   un;
#ifdef DEBUG_REFS
   wss_ref_t              *ref_next;
#endif /* DEBUG_REFS */
};

#endif /* __WSS_REF_H */


#ifndef __WSI_MUTEX_H
#define __WSI_MUTEX_H  1

#ifndef __ASM_SPINLOCK_H
#include <asm/spinlock.h>
#endif

#define WSI_MUTEX_PROTECT(var) spinlock_t var ## _lock
typedef spinlock_t wsi_mutex_t;

#define WR_MUTEX_INIT(a)
#define WR_MUTEX_EXIT(a)
#define WR_MUTEX_DESTROY(a)
#define WR_MUTEX_ENTER(a)

#endif /* !__WSS_MUTEX_H */

#ifndef __WSI_CV_H
#define __WSI_CV_H  1
#endif /* !__WSS_CV_H */

#ifndef __WSI_FILE_H
#define __WSI_FILE_H 1
#endif /* !__WSI_FILE_H */

#ifndef __WSI_FILEUTIL_H
#define __WSI_FILEUTIL_H 1
#endif /* __WSI_FILEUTIL_H */

#ifndef __WSI_PROCESS_H
#define __WSI_PROCESS_H 1

#if defined(WR_KERNEL_MODULE)
#include <linux/sched.h>
#endif

#endif /* !__WSI_PROCESS_H */


#ifndef __WSI_WRAPPER_H
#define __WSI_WRAPPER_H  1
#endif /* __WSI_WRAPPER_H */

#ifndef __WSI_RW_H
#define __WSI_RW_H  1

#ifndef __ASM_SPINLOCK_H
#include <asm/spinlock.h>
#endif

enum _wsi_rw_type {
    RW_READER,
    RW_WRITER
};

typedef enum _wsi_rw_type wsi_rw_type_t;

struct _wsi_rw {
    rwlock_t            lock;
    wsi_rw_type_t       type;
};

typedef struct _wsi_rw wsi_rw_t;

#define WSI_RW_PROTECT(var) wsi_rw_t var ## _rwlock

#endif /* !__WSS_RW_H */

#ifndef __WSI_ERRNO_H
#define __WSI_ERRNO_H 1

#ifndef _I386_ERRNO_H
#include <asm/errno.h>
#endif

#endif /* __WSI_ERRNO_H */

#ifndef  __WSS_IFACE_H
#define __WSS_IFACE_H   1

#define WR_ALLOW   0           /*!< Allow call to continue return code    */
#define WR_SUCCESS 0           /*!< Successful completion return code     */
#define WR_DENY    1           /*!< Deny call from continuing return code */

#endif /* __WSS_IFACE_H */

#ifndef __WSS_PROCESS_H
#define __WSS_PROCESS_H 1

/*! \brief This referred to as the "wrappers-specific process information"
 * 
 *  After the WSS has been installed, each process created is
 *  intercepted during the fork1() syscall.  At this time a wss_proc
 *  structure is created and added to the global list.  This structure
 *  stores process-related information.
 */
struct wss_proc
{
   /* Fields protected by global wss_proc_list lock */
   LIST_ENTRY(wss_proc)         wrp_p_list;    /*!< List of all processes    */


   WSI_MUTEX_PROTECT           (wrp);          /*!< Mutex protecting
                                                    wrp_refcount, wrp_flags,
                                                    wrp_nsyscall             */
   /* Fields protected by wrp lock */
   wss_ref_t                    wrp_refcount;  /*!< Reference count for
                                                    structure                */
   int                          wrp_flags;     /*!< Flags                    */
   int                          wrp_nsyscall;  /*!< Reference count for
                                                    calls                    */


   WSI_RW_PROTECT              (wrp_cwd);      /*!< Reader/writer lock
                                                    protecting wrp_cwd       */
   /* Fields protected by wrp_cwd lock */
   wss_char_t                  *wrp_cwd;       /*!< Pointer to current
                                                    working directory of
                                                    process. MALLOC'd memory,
                                                    NULL-terminated          */


   WSI_MUTEX_PROTECT           (wrp_wi_list);  /*!< Mutex protecting
                                                    wrp_wi_list              */
   /* Fields protected by wrp_wi_list lock */
   volatile
   struct wss_wrapper_instance *wrp_wi_list;   /*!< Pointer to list of
                                                    wrappers instances       */


   WSI_MUTEX_PROTECT           (wrp_arg_list); /*!< Mutex protecting
                                                    wrp_arg_list             */
   /* Fields protected by wrp_arglist lock */
   void                        *wrp_arg_list;  /*!< Pointer to stack of
                                                    replaced arguments       */


   WSI_MUTEX_PROTECT           (wrp_viewer);   /*!< Mutex protecting
                                                    wrp_viewer               */
   /* Fields protected by wrp_viewer lock */
   volatile struct wss_wrv     *wrp_viewer;    /*!< Pointer to the wrapper
                                                    viewer structure when
                                                    process is a wrapper
                                                    viewer                   */


   /* Not protected by locks (exists same for life of process)
    *
    * Note: wrp_progname can change during exec, but all threads should no
    *       longer have a pointer to the old area of memory which held the
    *       name of the program pre-exec                                     */
   pid_t                        wrp_pid;       /*!< Process identifier       */
   wss_char_t                  *wrp_path;      /*!< Pointer to full path of
                                                    executable. MALLOC'd
                                                    memory, NULL-terminated  */
   wss_char_t                  *wrp_oldpath;   /*!< Pointer to full path of
                                                    old program (parent).
                                                    MALLOC'd memory,
                                                    NULL-terminated          */
   wss_char_t                  *wrp_progname;  /*!< Pointer to program name
                                                    (no path info). MALLOC'd
                                                    memory, NULL-terminated  */
   proc_t                      *wrp_p;         /*!< Pointer to process
                                                    structure (may be unused)*/
   struct sysentvec            *wrp_sysent;    /*!< Original p_sysent vector */
   void                        *wrp_opaque;    /*!< System-dependent data    */
};
#endif /* __WSS_PROCESS_H */

#ifndef __WSS_WRAPPER_H
#define __WSS_WRAPPER_H 1

typedef struct wss_wrapper_data     wss_wrapper_data_t;

/*! \brief Structure for holding addition data in wrappers */
struct wss_wrapper_data
{
   int  *errnum; /*!< Pointer to memory to contain error code */
   void *wiv;    /*!< Pointer to wrapper instance variables   */
   int  skip;    /*!< Skip should be initialized to 0 (by the WSS) or in the 
                     beginning of the 
                     dispatch_(pre or post) func.  It can be modified by any
                     of the preX or postX function.  If its value changed
                     to 1, the dispatch_pre or post function will skip the
                     remaining preX or postX function and return to the WSS 
                     the dispatcher immediately. It is kind of a hack added 
                     to WDL to allow us to generate code to recongize tokens 
                     in the IDwrapper project.   However, this also could be
                     a general feature for wrapper to allow us to skip
                     the rest of the actions on the intercepted event easily.
                  */
   /* add addition data here */
};

#define WSS_GET_WIV_VAR(var) (((struct wr_wiv*)(data->wiv))->var)
#define WSS_SAVE_WIV(newwiv) (data->wiv = (newwiv))
#define WSS_GET_WIV()        ((struct wr_wiv*)(data->wiv))

#endif /* __WSS_WRAPPER_H */

#ifndef __WSS_CRITERIA_H
#define __WSS_CRITERIA_H   1
#endif /* __WSS_CRITERIA_H */


#ifndef __WSS_LIBRARY_H
#define __WSS_LIBRARY_H 1
#endif /* __WSS_LIBRARY_H */


#ifndef __WSS_FILE_H
#define __WSS_FILE_H 1
#endif /* !__WSS_FILE_H */

#ifndef __WSS_LINKER_H
#define __WSS_LINKER_H	1

#define WRLINK_MOD_NAME               __wr_myname
#define WRLINKNAME_MOD                "__wr_myname"
#define WRLINK_MOD_DEPENDENCIES       __wr_mydependencies
#define WRLINKNAME_MOD_DEPENDENCIES   "__wr_mydependencies"
#define WRLINK_MOD_INTERCEPT_LIST     __wr_myintercepts
#define WRLINKNAME_MOD_INTERCEPT_LIST "__wr_myintercepts"

#endif /* __WSS_LINKER_H */

#ifndef __WSI_MODULE_H
#define __WSI_MODULE_H  1

#ifndef __WSS_MODULE_H
struct wss_mod;
#endif

#endif /* _WSI_MODULE_H */


#ifndef __WSS_MODULE_H
#define __WSS_MODULE_H  1

#define WRLINK_MOD_TYPE             __wr_mytype
#define WRLINKNAME_MOD_TYPE         "__wr_mytype"

#endif /* _WSS_MODULE_H */


#define	WR_SUCC			(100 * 4)	/* SUCC, 100, Successful */
#define	WR_FAIL			(101 * 4)	/* FAIL, 101, Fail */


#ifndef WR_SUPPRESS_WQL

#ifndef __WSS_DB_H
#define __WSS_DB_H 1


/***************************************************************************\
 * Public structures and types                                             *
\***************************************************************************/

typedef unsigned long wss_db_handle_t;

#if !defined(WR_KERNEL_MODULE) && !defined(__WSI_TYPES_H)
typedef unsigned char wss_byte_t;
typedef char          wss_char_t;
#endif /* !WR_KERNEL_MODULE && !__WSI_TYPES_H */

#ifdef WR_KERNEL_MODULE
/*
 * Note: this structure is allocated in kernel memory, _NOT_ the virtual
 *       memory mapped for the database.  It should only contain transient
 *       information, _NOT_ data which should be persistent
 */
typedef struct wql_table_opaque
{
   /* Protects everything except "next".  Next is protected by
    * a mutex internal to wss_db.
    */
   WSI_MUTEX_PROTECT(table);
}
wqtabopaque, *wqtabopaque_t;
#endif /* WR_KERNEL_MODULE */

typedef struct wql_table
{
   /* In order to not polute user-space with kernel-space constructs, we
    * use an opaque pointer which contains the appropriate lock for the
    * table (see struct wql_table_opaque above)
    */
   void               *opaque;
   wss_char_t         *name;
   unsigned int        flags;
   int                 col_count;
   int                 max_rows;  /* TBD */
   int                 row_count; /* TBD */
   struct wql_col_def *col_defs;  /* defines this table's format */
   struct wql_row     *rows;
   struct wql_row     *tail;      /* TBD */
   struct wql_table   *next;
}
wqtab, *wqtab_t;

typedef enum wql_dtype { none_t, wss_char_t_t, int_t, float_t } wql_dtype;
typedef struct wql_col_def
{
   wss_char_t *name;
   wql_dtype   dtype;
   int         max_len;
}
wqcd, *wqcd_t;

typedef struct wql_row
{
   struct wql_val *vals;
   struct wql_row *next;
}
wqrow, *wqrow_t;

typedef struct wql_val
{
   union
   {
      wss_char_t *cval;
      int         ival;
      float       fval;
   }
   v;
}
wqval, *wqval_t;

/* holds data returned from select */
/* This is a structure instead of a pointer to a structure so that it does
 * not need an extra creation step.
 */
struct wql_dbrow
{
   struct wql_table  results;
   struct wql_row   *cur;
};

/*
 * Definitions to support select/update/delete expressions.  An
 * expression is essentially a tree of structures.  Code in
 * select/update/delete traverses the tree to evaluate rows to act
 * upon.  It's a bit messy; will think about how to pretty it up
 * later.
 */

enum sxop { gt_op, gte_op, lt_op, lte_op, ne_op, eq_op, true_op };
enum sxarg { literal, field, variable };
typedef struct sxval
{
   union
   {
      union literal
      {
         float             fval;
         int               ival;
         const wss_char_t *cval;
      }
      l;
      struct field
      {
         int         column;  /* By index, starting at 0 */
      }
      f;
      struct variable
      {
         const void *ptr;
      }
      v;
   }
   v;
   wql_dtype  dtype;
   enum sxarg which;
   char owned;                /* boolean */
}
sxval, *sxval_t;

/*
 * Represents a relational expression such as ".count = 5" in a select
 * expression.
 */
typedef struct term_exp
{
   sxval_t left;
   sxval_t right;
   enum sxop sxop;
}
tx, *tx_t;

/* Hack.  not_op negates the left side, and ignores the right */
enum logop { and_op, or_op, not_op };
typedef struct nterm_exp
{
   struct sx_node *left;
   struct sx_node *right;
   enum logop      logop;
}
ntx, *ntx_t;


/*
 * A select (or delete or update) expression is a tree of these.  The tree
 * is evaluated at runtime to identify rows of a table that should be
 * returned/deleted/updated.
 */
enum nodekind { term, nonterm };
typedef struct sx_node
{
   union
   {
      tx_t  exp;
      ntx_t children;
   }
   un;                  /* Hideous hack to get around hideous brokenness. */
   enum nodekind which;
}
wqsx, *wqsx_t;

/*
 * Represents a update_expression: a numeric value calculated from this
 * tree structure.
 */
enum numop {multiplication, division, mod, addition, subtraction, negation};
typedef struct update_expression
{
   union
   {
      sxval_t terminal;
      struct
      {
         struct update_expression *left;
         struct update_expression *right;
         enum numop                numop;
      }
      e;
   }
   w;
   enum nodekind which;
}
wquexp, *wquexp_t;

#endif /* __WSS_DB_H */
#endif /* WR_SUPPRESS_WQL */



/* global variables used in string matching and replacement */
wss_char_t *gstr_beg, *gstr_end, *gstr;

int myversion = 1;
int myhandle = 0;

/*
 * Function declarations.
 */
#if defined(MALLOC_DEBUG)
#define wr_strdup(str) (wr_strdup_debug((str), __FILE__, __LINE__))
#define wr_malloc(size) (wr_malloc_debug((size), __FILE__, __LINE__))
#endif

void IMPORT *wr_dupin_ntermlist(void *uaddr);

/* Define some of the wdl environment variables to data in the proc
structure.  Other environment variables can't be created this way. */

#if defined(WR_LINUX)
#define _pid           wrp->wrp_p->pid
#define _ppid          (wrp->wrp_p->p_pptr?wrp->wrp_p->p_pptr->pid:0)
#define _sid           wrp->wrp_p->session
#define _progname      wrp->wrp_progname
#define _path          wrp->wrp_path
#define _uid           wrp->wrp_p->uid
#define _euid          wrp->wrp_p->euid
#define _gid           wrp->wrp_p->gid
#define _egid          wrp->wrp_p->egid
#else
#error unsupported target.
#endif


/* Using default library */
int  wr_strcmp (const  wss_char_t  * s1,const  wss_char_t  * s2);
int  wr_strlen (const  wss_char_t  * str);
wss_char_t  * wr_abspath (const  wss_char_t  * path);
wss_char_t  * wr_strcpy (wss_char_t  * dst,const  wss_char_t  * src);
void  wr_bcopy (const  void  * src,void  * dst,size_t  len);
void  wr_bzero (void  * src,size_t  len);
void  wr_audit (unsigned  long  types,const  void  * buffer,unsigned  long  length);
int  wr_copyinstr (void  * uaddr,void  * kaddr,size_t  len,unsigned  int  * done);
int  wr_resolve_event_space (wss_char_t  * name);
long  wr_get_curtime (long  * usec);
wss_char_t  * wr_strdup (const  wss_char_t  * str);
void  * wr_malloc (size_t  size);
void  wr_free (void  * ptr);
/* end library */


#ifndef WR_SUPPRESS_WQL

typedef struct wql_dbrow dbrow;

int IMPORT wql_create( wss_char_t *wrapper_name,
		        int instance_id,
		        wss_char_t *table_name,
		        int free_col_defs,
		        struct wql_col_def *col_defs,
                       int col_count,
                       unsigned long *table_id);
int IMPORT wql_drop(	unsigned long table_id );
int IMPORT wql_insert(	unsigned long table_id,
		        int free_vals,
		        wqrow_t vals);
int IMPORT wql_select(	unsigned long table_id,
		        int free_scrit,
		        wqsx_t scrit,
                       int take_first,
		        int order_by,
		        int desc,
                       wqtab_t out_table);

void IMPORT wql_free_criteria( wqsx_t expr );
u_long IMPORT wql_find_table_by_names( wss_char_t *wrapper_name, int id,
                                       wss_char_t *table_name );
wqcd_t IMPORT wr_mcol_def( int count, ... );
wqval_t IMPORT wr_mvals( int count, ... );
wqrow_t IMPORT wr_mrow( wqval_t vals, wqrow_t next );
tx_t IMPORT wr_mtx( sxval_t left, sxval_t right, enum sxop sxop );
sxval_t IMPORT wr_msxval_field( int column );
sxval_t IMPORT wr_msxval_lit_string( const wss_char_t *str );
void IMPORT dbrow_finish( struct wql_dbrow *dbrp );

/*
 * See wss_db.c for the reference implimentations.
 */
#define dbrow_start(dbrp) \
((((dbrp)->cur) = (dbrp)->results.rows),((dbrp) != NULL && (dbrp)->cur != NULL))

#define dbrow_next(dbrp) (((dbrp)->cur = (dbrp)->cur->next) != NULL)

#define dbrow_isempty(dbrp) ((dbrp)->results.rows == NULL)

#endif /* WR_SUPPRESS_WQL */

    
/* Mutex stuff */

static wss_char_t *WRLINK_MOD_DEPENDENCIES=WSS_MAKESTR("");
wss_char_t EXPORT *get_mod_dependencies()
{                                  
  return WRLINK_MOD_DEPENDENCIES;  
}                                  

static sxval *wr_db_0=0;
static wqsx *wr_db_1=0;
#if defined(WR_WINNT)
#pragma data_seg(".emerald")
#endif
WSI_MUTEX_PROTECT(login_programs);
unsigned long login_programs = 0;
static int Linux=0;
static int system=0;
#if defined(WR_WINNT)
#pragma data_seg()
#pragma comment(linker, "/SECTION:.emerald,RWS")
#endif
static int WRLINK_MOD_INTERCEPT_LIST[] = 
{
   11, 70, 0
};
;
typedef struct audit_data_header {
int  event;
uid_t  ruid, euid, auid;
gid_t  rgid, egid;
pid_t  pid, ppid, sid;
time_t  timestamp;
time_t  utimestamp;
int  retval;
} header;
typedef struct audit_path_data {
header  h;
uid_t  file_owner;
gid_t  file_group;
mode_t  file_mode;
dev_t  file_device;
unsigned  short  file_ino;
int  new_attrib;
int  path_count;
char  pathname [0];
} path_data;
typedef struct audit_sock_data {
header  h;
sa_family_t  sock_type;
uint16_t  local_port;
uint16_t  remote_port;
uint32_t  local_addr;
uint32_t  remote_addr;
} sock_data;
typedef struct proc_op_data {
header  h;
pid_t  target_pid;
uid_t  target_ruid;
uid_t  target_euid;
int  target_signal;
} op_data;
struct wr_wiv {
    int  auid;
};
/* WIV Functions
 */
void fill_header (struct wss_proc *wrp, header  * h,int  event_code,int  retval, struct wss_wrapper_data *data){
    long  usec;
    h->event = event_code;
    h->auid = WSS_GET_WIV_VAR(auid);
    h->euid = _euid;
    h->ruid = _uid;
    h->rgid = _gid;
    h->egid = _egid;
    h->sid = _sid;
    h->pid = _pid;
    h->ppid = _ppid;
    h->timestamp = wr_get_curtime (&usec);
    h->utimestamp = usec;
    h->retval = retval;
}
void do_booring_op (struct wss_proc *wrp, int  event,int  retval, struct wss_wrapper_data *data){
    header  h;
    fill_header (wrp,&h,event,retval, data);
    wr_audit (1<<5,&h,sizeof (h));
}

#define MYNAME WSS_MAKESTR("emerald")

static wss_char_t *WRLINK_MOD_NAME = MYNAME;
static wss_char_t *myname=MYNAME;

wss_char_t EXPORT **get_mod_name()
{
   return &WRLINK_MOD_NAME;
}

static wss_char_t *WRLINK_MOD_TYPE=WSS_MAKESTR("wrapper");
wss_char_t EXPORT **get_mod_type()
{
   return &WRLINK_MOD_TYPE;
}


/* The following is in the "(space == Linux)" event subsystem */

static int post0 (int space, int code, void *uap[], int *retval, struct wss_proc *wrp,struct wss_wrapper_data *data,int args_in_userspace)
{
if ((space == Linux) && ((code==70)))
{
    int wrp_return = WR_ALLOW;
    {
        if (WSS_GET_WIV_VAR(auid)==-2 && ((int ) uap[ 0 ])!=-1)
            {
                dbrow /* ::login_program_table*/ row = {{0,0,0,0,0,0,0,0},0};
                {
                    int wr_retval;
                    if (wr_db_0 == NULL) {
                    	wr_db_0 = wr_msxval_lit_string(_progname );
                    } else {
                    	wr_db_0->v.l.cval = (_progname);
                    }
                    if (wr_db_1 == NULL) {
                    	wr_db_1 = wr_mwqsx_terminal(
                                wr_mtx(
                                    wr_msxval_field(0),
                                    wr_db_0,
                                    eq_op));
                    }
                    do {
                        wr_retval = 
                            ((row.results.col_defs != NULL ? dbrow_finish(&row) : 0),
                            wql_select(login_programs,0,
                            	wr_db_1,
                            	1,-1, 0, 
                            	&(row.results)));
                            dbrow_start(&row);
                        if (wr_retval < 0) break;
                    
                    } while (0);
                }
                if (!dbrow_isempty(&row))
                    {
                        do
                        {
                            if (!wr_strcmp (_path,(row).cur->vals[1].v.cval))
                                {
                                    WSS_GET_WIV_VAR(auid) = ((int ) uap[ 0 ]);
                                }
                        }
                        
                        while (dbrow_next(&row));
                    }
                dbrow_finish(&row);
            }
    }
    postend_0:
    return wrp_return;
}
return WR_SUCCESS;
}

/* The following is in the "(space == Linux)" event subsystem */

static int pre0 (int space, int code, void *uap[], int *retval, struct wss_proc *wrp,struct wss_wrapper_data *data,int args_in_userspace)
{
if ((space == Linux) && ((code==11)))
{   void *uapk[10];
    int wrp_return = WR_ALLOW;
    /* copy in arg $envv */
    if (!args_in_userspace) {
        wr_bcopy(uap, uapk, 10 * sizeof(void*));
    } else {
        uapk[ 2 ] = wr_dupin_ntermlist(uap[ 2 ]);
    }
    /* copy in arg $argv */
    if (!args_in_userspace) {
        wr_bcopy(uap, uapk, 10 * sizeof(void*));
    } else {
        uapk[ 1 ] = wr_dupin_ntermlist(uap[ 1 ]);
    }
    /* copy in arg $fname */
    if (!args_in_userspace) {
        wr_bcopy(uap, uapk, 10 * sizeof(void*));
    } else {
        int done;
        if (uap[ 0 ]==NULL)uapk[ 0 ]=NULL;
        else {
        uapk[ 0 ] = wr_malloc(MAXPATHLEN*sizeof(wss_char_t));
        wr_copyinstr(uap[ 0 ], uapk[ 0 ], MAXPATHLEN, &done);
        }
    }
    {
        header  * pckt;
        int  i;
        size_t  size;
        char  * path;
        char  * cptr, * dptr;
        size = sizeof (*pckt);
        path = wr_abspath (((char  *) uapk[ 0 ]));
        size+=wr_strlen (path);
        i = 0;
        cptr = ((char  * *) uapk[ 1 ]) [i];
        for (;
        cptr && *cptr!='\0';
        cptr = ((char  * *) uapk[ 1 ]) [++i])
           {
               size+=wr_strlen (cptr) + 1;
           }
        ++size;
        i = 0;
        cptr = ((char  * *) uapk[ 2 ]) [i];
        for (;
        cptr && *cptr!='\0';
        cptr = ((char  * *) uapk[ 2 ]) [++i])
           {
               size+=wr_strlen (cptr) + 1;
           }
        ++size;
        pckt = wr_malloc (size);
        fill_header (wrp,pckt,KERN_EXECVE,(int ) *retval, data);
        dptr = (char  *)pckt + sizeof (*pckt);
        wr_strcpy (dptr,path);
        dptr+=wr_strlen (path) + 1;
        i = 0;
        cptr = ((char  * *) uapk[ 1 ]) [i];
        for (;
        cptr && *cptr!='\0';
        cptr = ((char  * *) uapk[ 1 ]) [++i])
           {
               wr_strcpy (dptr,cptr);
               dptr+=wr_strlen (cptr) + 1;
           }
        *dptr++ = '\0';
        i = 0;
        cptr = ((char  * *) uapk[ 2 ]) [i];
        for (;
        cptr && *cptr!='\0';
        cptr = ((char  * *) uapk[ 2 ]) [++i])
           {
               wr_strcpy (dptr,cptr);
               dptr+=wr_strlen (cptr) + 1;
           }
        *dptr++ = '\0';
        wr_audit (1<<5,pckt,size);
        wr_free (pckt);
        wr_free (path);
    }
    postend_1:
    {
        if (!args_in_userspace); else {
            wr_free_ntermlist(uapk[2]);
        }
        if (!args_in_userspace); else {
            wr_free_ntermlist(uapk[1]);
        }
        if (!args_in_userspace); else {
            wr_free(uapk[ 0 ]);
        }
    }
    return wrp_return;
}
return WR_SUCCESS;
}

/* lifecycle function */
int EXPORT wr_uninstall ( )          
{                                    
    WR_MUTEX_DESTROY(login_programs);
    if (wr_db_1 != NULL) {
    	wql_free_criteria(wr_db_1);
    	wr_db_1= NULL;
    }

    return WR_SUCCESS;
}

/* lifecycle function */
int EXPORT wr_install ( int newhandle )
{
    myhandle = newhandle;
    {
        WR_MUTEX_INIT(login_programs);
        WR_MUTEX_ENTER(login_programs);
        login_programs = wql_find_table_by_names(myname, 0, WSS_MAKESTR("login_programs"));
        WR_MUTEX_EXIT(login_programs);
        Linux = wr_resolve_event_space(WSS_MAKESTR("Linux"));
        system = wr_resolve_event_space(WSS_MAKESTR("system"));
    }
{
    WR_MUTEX_ENTER(login_programs);
    {
        int wr_retval;
        do {
            wr_retval = 
                wql_create(myname, 0, WSS_MAKESTR("login_programs"), !NULL, wr_mcol_def(2, wr_strdup(WSS_MAKESTR("progname")), wss_char_t_t, 1024,  wr_strdup(WSS_MAKESTR("path")), wss_char_t_t, 1024)
                , 2, &login_programs);
            if (wr_retval < 0) break;
            wr_retval = 
                wql_insert(login_programs, !NULL, 
		wr_mrow(wr_mvals(2, wss_char_t_t, wr_strdup(WSS_MAKESTR("login")),  wss_char_t_t, wr_strdup(WSS_MAKESTR("/bin"))), 
		wr_mrow(wr_mvals(2, wss_char_t_t, wr_strdup(WSS_MAKESTR("in.telnet")),  wss_char_t_t, wr_strdup(WSS_MAKESTR("/usr/sbin/in.telnetd"))), 
		wr_mrow(wr_mvals(2, wss_char_t_t, wr_strdup(WSS_MAKESTR("in.rshd")),  wss_char_t_t, wr_strdup(WSS_MAKESTR("/usr/sbin"))), 
		wr_mrow(wr_mvals(2, wss_char_t_t, wr_strdup(WSS_MAKESTR("in.rlogind")),  wss_char_t_t, wr_strdup(WSS_MAKESTR("/usr/sbin"))), 
		wr_mrow(wr_mvals(2, wss_char_t_t, wr_strdup(WSS_MAKESTR("in.rexecd")),  wss_char_t_t, wr_strdup(WSS_MAKESTR("/usr/sbin"))), 
		wr_mrow(wr_mvals(2, wss_char_t_t, wr_strdup(WSS_MAKESTR("sshd1")),  wss_char_t_t, wr_strdup(WSS_MAKESTR("/usr/sbin"))), 
		wr_mrow(wr_mvals(2, wss_char_t_t, wr_strdup(WSS_MAKESTR("sshd2")),  wss_char_t_t, wr_strdup(WSS_MAKESTR("/usr/sbin"))), 
		wr_mrow(wr_mvals(2, wss_char_t_t, wr_strdup(WSS_MAKESTR("sshd")),  wss_char_t_t, wr_strdup(WSS_MAKESTR("/usr/sbin"))), NULL)))))))));
            if (wr_retval < 0) break;
        
        } while (0);
    }
    WR_MUTEX_EXIT(login_programs);
}

    return WR_SUCCESS;
}

/* lifecycle function */
int EXPORT wr_activate ( struct wss_proc *wrp, struct wss_wrapper_data *data)
{
    struct wr_wiv *wr_wiv_foo;
    wr_wiv_foo=wr_malloc(sizeof(*wr_wiv_foo));
    if (WSS_GET_WIV() != NULL)
        wr_bcopy(WSS_GET_WIV(),
            wr_wiv_foo, sizeof(*wr_wiv_foo));
    else
        wr_bzero(wr_wiv_foo,
            sizeof(*wr_wiv_foo));
    WSS_SAVE_WIV(wr_wiv_foo);
    {
        WSS_GET_WIV_VAR(auid) = -2;
    }

    return WR_SUCCESS;
}

/* lifecycle function */
int EXPORT wr_duplicate ( struct wss_proc *wrp, struct wss_wrapper_data *data)
{
    struct wr_wiv *wr_wiv_foo;
    wr_wiv_foo=wr_malloc(sizeof(*wr_wiv_foo));
    if (WSS_GET_WIV() != NULL)
        wr_bcopy(WSS_GET_WIV(),
            wr_wiv_foo, sizeof(*wr_wiv_foo));
    else
        wr_bzero(wr_wiv_foo,
            sizeof(*wr_wiv_foo));
    WSS_SAVE_WIV(wr_wiv_foo);

    return WR_SUCCESS;
}

/* lifecycle function */
int EXPORT wr_deactivate ( struct wss_proc *wrp, struct wss_wrapper_data *data)
{
    wr_free(WSS_GET_WIV());
    WSS_SAVE_WIV(NULL);

    return WR_SUCCESS;
}
/* Dispatch routines. */
int EXPORT dispatch_pre(int space, int code, void *uap[],
                        int *retval,struct wss_proc *wrp,
                        struct wss_wrapper_data *data,
                        int args_in_userspace)
{
    int ret = WR_SUCCESS;

    if (ret == WR_SUCCESS && !data->skip)
         ret=pre0(space, code, uap, retval, wrp, data, args_in_userspace);
    return ret;
}
int EXPORT dispatch_post(int space, int code, void *uap[],
                        int *retval,struct wss_proc *wrp,
                        struct wss_wrapper_data *data,
                        int args_in_userspace)
{
    int ret = WR_SUCCESS;

    if (ret == WR_SUCCESS && !data->skip)
         ret=post0(space, code, uap, retval, wrp, data, args_in_userspace);
    return ret;
}
