#ifndef _PACKETS_H
#define _PACKETS_H 1

typedef unsigned short int      _wsi_uid_t;
typedef unsigned short int      _wsi_gid_t;
typedef int                     _wsi_pid_t;
typedef long                    _wsi_time_t;
typedef unsigned short int      _wsi_mode_t;
typedef unsigned short int      _wsi_dev_t;

typedef unsigned short int      _wsi_sa_family_t;

typedef struct audit_data_header {
    int                 event;
    _wsi_uid_t          ruid, euid, auid;
    _wsi_gid_t          rgid, egid;
    _wsi_pid_t          pid, ppid, sid;
    _wsi_time_t         timestamp;
    _wsi_time_t         utimestamp;
    int                 retval;
} header;

typedef struct audit_path_data {
    header              h;
    _wsi_uid_t          file_owner;
    _wsi_gid_t          file_group;
    _wsi_mode_t         file_mode;
    _wsi_dev_t          file_device;
    unsigned short      file_ino;
    int                 new_attrib;
    int                 path_count; /* Number of paths in pathname, */
    char                pathname[0]; /* '\0' terminated */
} path_data;

typedef struct audit_sock_data {
    header              h;
    _wsi_sa_family_t    sock_type;
    uint16_t            local_port;
    uint16_t            remote_port;
    uint32_t            local_addr;
    uint32_t            remote_addr;
} sock_data;

typedef struct proc_op_data {
    header              h;
    _wsi_pid_t          target_pid;
    _wsi_uid_t          target_ruid;
    _wsi_uid_t          target_euid;
    int                 target_signal;
} op_data;

#endif
