%{
/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: pol.l,v 1.9 2001/05/17 18:32:56 dougk Exp $
 *
 * Author: Lee Badger
 *
 * Purpose: Scanner for Napoleon-generated policy files.
 * 
 */

#define token(c)   { return(c); }
#include <string.h>

char error_code[256];


%}

%{
	/* could redefine things here */
%}

%x comment

ID      [/_a-zA-Z][a-zA-Z0-9_\-/\.]*
NUM     [0-9]*
REGEX      [/a-zA-Z0-9_\-\.\^[\]$]*

%{
	int pol_lineno = 0;
%}

%%

"/*"		BEGIN comment;
<comment>.	;
<comment>\n	pol_lineno++;
<comment>"*/"	BEGIN INITIAL;


\/[A-Za-z0-9_\-\/\.\+]*	{
                        pollval.u_name = strdup(poltext);
                        return K_PATH;
		}

homedir		{	return(K_HOMEDIR); }
subject_policy	{	return(K_SUBJECT); }
object_policy	{	return(K_OBJECT); }
invoke		{	return(K_INVOKE); }
syscall		{	return(K_SYSCALL); }
file		{	return(K_FILE); }
network		{	return(K_NETWORK); }
allow		{	return(K_ALLOW); }
deny		{	return(K_DENY); }
if		{	return(K_IF); }
user		{	return(K_USER); }
exec		{	return(K_EXEC); }

{ID}		{
                        pollval.u_name = strdup(poltext);
                        return IDENTIFIER;
		}

{NUM}		{
                   /*     pollval.u_name = strdup(poltext);*/
			pollval.u_int_const = atoi(poltext);
                        return NUM;
		}

[ \t]		{}
\n		{pol_lineno++;}

"&&"		{	return(K_AND); }
"||"		{	return(K_OR); }

"|"		{	token('|') }
"!"		{	token('!') }
">"		{	token('>') }
"<"		{	token('<') }

"\{"		{	token('{') }
"\}"		{	token('}') }
"("		{	token('(') }
")"		{	token(')') }
";"		{	token(';') }
","		{	token(',') }
"*"		{	token('*') }
"\."		{	token('.') }

<<EOF>>		{	yyterminate(); }


.		{	/*act_criterror("Character not recognized");*/
		}

%%

int
polerror(char *s)
{
        printf("\nNapload %s at '%s'  (line %d)\n", s, poltext, pol_lineno );
        exit(2);
	return 0;
}
