#!/bin/bash
#  
#  Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
#  All rights reserved.
# 
#  This file is part of the NAI Generic Software Wrappers Toolkit
#  (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
#  distribution.
# 
#  The GSWTK is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2, or (at your option)
#  any later version.
# 
#  The GSWTK is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this software; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
#  02111-1307, USA.
#
# $Id: wrap_immutable.sh,v 1.5 2001/04/05 18:41:53 stevek Exp $
#
# This shell script attempts to protect the wrappers subsystem from
# subversion from an attacker with root access, but not console access.
#
# This script is linux specific.
#
# We use the wrap_immutable wrapper for some policy bits, and the
# bounding cap-set for others.
#

# Policy about rawio...
# No writes to /proc
# no writes to lots of /dev
/sbin/wrload wrap_immutable.wmo

# Turn off SAK.
echo "0" > /proc/sys/kernel/sysrq

# set things immutable
/bin/mount -o remount,rw /boot
/usr/bin/chattr +i -R /boot
/bin/mount -o remount,ro /boot

# binaries used to get this far.
/usr/bin/chattr +i /bin/{mount,bash} /usr/bin/{find,xargs,chattr}
/usr/bin/chattr +i -R /sbin /lib
/usr/bin/chattr +i / /bin /usr/bin /usr

# Our modules have been copied into here, right?
/usr/bin/find /lib/modules/$(uname -r) -type f -print0 | /usr/bin/xargs -0 \
							/usr/bin/chattr +i
# We are loaded by rc.sysinit, right?
/usr/bin/find /etc/rc.d -print 0 -type f | /usr/bin/xargs -0 \
						/usr/bin/chattr +i
/usr/bin/chattr +i /etc/initttab /etc/wss.conf
/usr/bin/chattr +i /etc

#  9: CAP_LINUX_IMMUTABLE
# 16: CAP_SYS_MODULE
# 21: CAP_SYS_ADMIN (ioctl's, mount)
#(gdb) print 0xffffffff - (1<<9) - (1<<16) - (1<<21)
# $27 = 4292804095
echo "4292804095" > /proc/sys/kernel/cap-bound

/sbin/wra '1 ==> wrap_immutable'

# And that should do it.  Have fun storming the castle.
