/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_malloc.h,v 1.12 2001/02/23 19:02:31 stevek Exp $
 * 
 * Author: Steve Kiernan
 * 
 * Purpose: Declaration of Solaris WSI malloc services.
 */

#ifndef __WSI_MALLOC_H
#define __WSI_MALLOC_H  1

#include <wr_conf.h>

#include <wsi_stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif

/************************************************************************\
 * Public functions                                                     *
\************************************************************************/

void       WSSLINKAGE *wsi_malloc                __P(( size_t nbytes ));
void       WSSLINKAGE  wsi_free                  __P(( void *buf ));

void       WSSLINKAGE *wsi_curproc_malloc        __P(( size_t nbytes ));
pd_char_t WSSLINKAGE *wsi_curproc_malloc_string __P(( size_t nchars ));
void       WSSLINKAGE  wsi_curproc_free          __P(( void *addr,
                                                       size_t nbytes ));
pd_char_t WSSLINKAGE *wsi_curproc_strdup        __P(( const pd_char_t *str ));

#ifdef __cplusplus
}
#endif

#endif /* __WSI_MALLOC_H */

