/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_path.h,v 1.14 2001/06/11 17:25:46 stevek Exp $
 *
 * Author: Linda Thomas
 *
 * Purpose: This file contains prototypes and structures use by the
 *          system-depenedant parts of the pathname code
 */

#ifndef __WSI_PATH_H
#define __WSI_PATH_H 1

#ifndef __WSS_PROCESS_H
#include <wss_process.h>
#endif

#include <sys/param.h>
#include <sys/types.h>
#include <sys/proc.h>
#include <sys/vnode.h>


/************************************************************************\
 * Public functions                                                     *
\************************************************************************/

pd_char_t    *wsi_path_abspath           __P(( pd_char_t * ));
pd_char_t    *wsi_path_cwd               __P(( wss_proc_t const * ));
pd_char_t    *wsi_path_get_cwd_as_string __P(( proc_t const * ));
pd_char_t    *wsi_path_canonicalize      __P(( proc_t const *, pd_char_t *,
                                               pd_bool_t ));
int           wsi_path_is_dir            __P(( proc_t const *, pd_char_t * ));
struct vnode *wsi_path_to_vnode          __P(( proc_t const *, pd_char_t *,
                                               pd_bool_t ));
pd_char_t    *wsi_path_from_vnode        __P(( proc_t const *,
                                               struct vnode * ));

#endif /* !__WSI_PATH_H */

