/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_rw.h,v 1.5 2001/02/23 19:02:35 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: Macros for system-dependent reader/writer locks
 *
 */

#ifndef __WSI_RW_H
#define __WSI_RW_H  1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif


/************************************************************************\
 * Public macros                                                        *
\************************************************************************/

#define WSI_RW_PROTECT(var)
#define WSI_RW_PROTECT_EXPORTED(var)
#define WSI_RW_EXPORT(var)

#ifndef WR_SUPPRESS_FUNCTION_DECL
#define WSI_RW_INIT(var)
#define WSI_RW_DESTROY(var)
#define WSI_RW_ENTER(var,type)
#define WSI_RW_ENTER_DEBUG(var,type)
#define WSI_RW_EXIT(var)
#define WSI_RW_EXIT_DEBUG(var)
#define WSI_RW_DOWNGRADE(var)
#define WSI_RW_DOWNGRADE_DEBUG(var)
#endif /* WR_SUPPRESS_FUNCTION_DECL */

#endif /* !__WSS_RW_H */

