/*
 * Copyright (C) 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_i386_custom.S,v 1.4 2001/02/22 23:50:11 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: This file contains the shims for splitting out socketcall
 *          into its individual parts and setting up EAX for the call
 *          to the dispatch routine.
 *
 */

#define __ASSEMBLY__
#include <linux/sys.h>
#include <linux/linkage.h>
#include "wsi_intercept.h"

ENTRY(wsi_custom_getsockopt)
	movl $(__NR_getsockopt),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_recvfrom)
	movl $(__NR_recvfrom),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_socket)
	movl $(__NR_socket),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_connect)
	movl $(__NR_connect),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_send)
	movl $(__NR_send),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_getpeername)
	movl $(__NR_getpeername),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_sendto)
	movl $(__NR_sendto),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_setsockopt)
	movl $(__NR_setsockopt),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_listen)
	movl $(__NR_listen),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_accept)
	movl $(__NR_accept),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_recv)
	movl $(__NR_recv),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_getsockname)
	movl $(__NR_getsockname),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_sendmsg)
	movl $(__NR_sendmsg),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_socketpair)
	movl $(__NR_socketpair),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_recvmsg)
	movl $(__NR_recvmsg),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_shutdown)
	movl $(__NR_shutdown),%eax
	jmp wsi_dispatch

ENTRY(wsi_custom_bind)
	movl $(__NR_bind),%eax
	jmp wsi_dispatch

