/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_vm.h,v 1.5 2001/02/23 21:43:20 stevek Exp $
 * 
 * Authors: Doug Kilpatrick, Steve Kiernan
 * 
 * Purpose: VM function prototypes and globals
 */

#ifndef __WSI_VM_H
#define __WSI_VM_H 1


/************************************************************************\
 * Public types                                                         *
\************************************************************************/

typedef unsigned int vm_size_t;


/************************************************************************\
 * Public globals                                                       *
\************************************************************************/

extern vm_offset_t wsi_vm_data;
extern size_t wsi_vm_size;


/************************************************************************\
 * Public macros                                                        *
\************************************************************************/

#define WR_VM_MARKED (1<<(sizeof(unsigned)*8-1))
#define WR_VM_SIZE_MASK ~WR_VM_MARKED


/************************************************************************\
 * Public functions                                                     *
\************************************************************************/

vm_offset_t wsi_vm_init     __P((size_t size_in_mb));
void        wsi_vm_shutdown __P((void));

#endif /* __WSI_VM_H */
