/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_os.c,v 1.9 2001/02/23 19:02:37 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: This file contains operating system information functions
 */

#include <wr_conf.h>
#include <linux/version.h>
#include <linux/sched.h>
#include <linux/utsname.h>  

/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/

/*
 * Get the name of the OS
 */
char *
wsi_os_get_name(void)
{
   return "Linux"; /* is there any reason why this is unacceptable? */
}

/*
 * Get the version of the OS
 */
int
wsi_os_get_version(void)
{
   return LINUX_VERSION_CODE; 
}

int
wsi_os_curthreadid(void)
{
    return current->pid; /* hoping this is right */
}

char *
wsi_os_get_hostname(void)

{
     return system_utsname.nodename;
}

