/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_file.h,v 1.5 2001/02/23 19:02:41 stevek Exp $
 *
 * Author: Linda Thomas
 *
 * Purpose: This file contains prototypes and structures use by the
 *          file i/o module.
 */

#ifndef __WSI_FILE_H
#define __WSI_FILE_H 1

#include <sys/types.h>
#include <sys/proc.h>
#include <sys/vnode.h>


/************************************************************************\
 * Public structures                                                    *
\************************************************************************/

struct wsi_file
{
   struct vnode *vp;
   struct cred  *cr;
   offset_t      offset;
};


/************************************************************************\
 * Public functions                                                     *
\************************************************************************/

int wsi_file_open_path   __P(( struct wsi_file **file, char *path,
                               struct cred *cr ));
int wsi_file_open_vnode  __P(( struct wsi_file **file, struct vnode *vp,
                               int mode, struct cred *cr ));
int wsi_file_write       __P(( struct wsi_file *file, char *buffer, int len ));
int wsi_file_close       __P(( struct wsi_file *file ));
int wsi_file_seek_to_end __P(( struct wsi_file *file ));

#endif /* !__WSI_FILE_H */

