/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_process.h,v 1.8 2001/02/23 19:02:41 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: This file contains prototypes and structures use by the
 *          system-depenedant parts of the process life-cycle code
 */

#ifndef __WSI_PROCESS_H
#define __WSI_PROCESS_H 1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#include <sys/types.h>
#include <sys/proc.h>
#include <sys/rwlock.h>
#include <errno.h>

#ifndef __WSS_MUTEX_H
#include <wss_mutex.h>
#endif

#ifndef __WSS_CV_H
#include <wss_cv.h>
#endif


/************************************************************************\
 * Public structures and types                                          *
\************************************************************************/

struct wsi_proc
{
};

struct wss_proc;


/************************************************************************\
 * Public macros                                                        *
\************************************************************************/

#define WSI_PROC_OPAQUE(wrp) ((struct wsi_proc *)(wrp)->opaque)
#define wsi_process_get_curproc()       curproc
#define wsi_process_get_current_pid()   curproc->p_pid


/************************************************************************\
 * Public functions                                                     *
\************************************************************************/

#ifndef WR_SUPPRESS_FUNCTION_DECL
int  wsi_proc_insyscall          __P(( struct wss_proc *wrp ));
void wsi_proc_free               __P(( struct wss_proc *wrp ));
void wsi_proc_new                __P(( struct wss_proc *wrp ));
void wsi_proc_force_syscall_exit __P(( struct wss_proc *wrp ));
int  wsi_proc_suspend            __P(( struct proc *p ));
int  wsi_proc_suspend_lwp        __P(( kthread_t *t, int *rcode ));
void wsi_proc_continue           __P(( struct proc *p ));
void wsi_proc_continue_lwp       __P(( kthread_t *t ));
#endif /* WR_SUPPRESS_FUNCTION_DECL */

#endif /* !__WSI_PROCESS_H */

