/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_types.h,v 1.5 2001/02/23 19:02:41 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: This file contains system-specific types used in the WSS
 */

#ifndef __WSI_TYPES_H
#define __WSI_TYPES_H 1

#include <errno.h>

#include <sys/types.h>


/************************************************************************\
 * Public types                                                         *
\************************************************************************/

typedef char          pd_char_t;
typedef unsigned char pd_byte_t;
typedef unsigned char pd_bool_t;
typedef off_t         pd_offset_t;
typedef uint8_t       u_int8_t;
typedef uint16_t      u_int16_t;
typedef uint32_t      u_int32_t;
typedef uint64_t      u_int64_t;
typedef int           wss_uid_t;

typedef int           pd_fd_obj;

/************************************************************************\
 * Public macros                                                        *
\************************************************************************/

#define PD_MAKESTR(a) a
#define wql_uid        int

#endif /* __WSI_TYPES_H */

