#!/usr/local/bin/perl

# 
# Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
# All rights reserved.
#
# This file is part of the NAI Generic Software Wrappers Toolkit
# (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
# distribution.
#
# The GSWTK is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# The GSWTK is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# $Id: parsesyscall.pl,v 1.5 2001/04/05 18:41:55 stevek Exp $
#
# Purpose: This file contains the script to generate the syscall 
# interception file (wsi_intercept.c).

print "Generating wsi_intercept.c:  $count interpreted out of $lastsyscall\n";

print OUT <<EOF;
/*
 * wsi_intercept.c
 *
 *    File automatically generated by parsesyscalls.pl, do not edit!
 */
#include <wr_conf.h>

EOF

# print prototypes for the functions that duplicate each system call
# wsi_sys_<syscall>();


# int wsi_sys_<syscall>(void *uap, rval_t *retval)
# {
#     return wsi_dispatch(<code>, uap, retval);
# };

print OUT <<END;

struct syscallvec new_sysent[NSYSCALL] =
{
END

# print out a table full of the new wsi_sys_<syscall> replacements

print OUT <<END;
};

const char *original_syscallnames[] =
{
END

#print out a table fill of the syscall names.

print OUT <<END;
};

END

close(OUT);

exit;
