/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_fileutil.c,v 1.6 2001/02/23 19:02:40 stevek Exp $
 *
 * Author: Calvin Ko
 *
 * Purpose: Contain functions for network and files
 *
 */

#include <wr_conf.h>
#include <wss.h>

#include <wsi_fileutil.h>

void wsi_stat()   {}
void wsi_lstat()     {}
void wsi_fstat()     {}
void wsi_fdtype()    {}
void wsi_fdfflag()   {}
void wsi_get_family()   {}
void wsi_get_addr()  {}
void wsi_getsockname()  {}
void wsi_getpeername()  {}
void wsi_netutil_ntohs() {}

/*
 * Network Related Stuff
 */

static char *af_name[AF_MAX] = {
        "AF_UNSPEC", 
        "AF_LOCAL", 
        "AF_INET", 
        "AF_IMPLINK", 
        "AF_PUP", 
        "AF_CHAOS",  
        "AF_NS", 
        "AF_ISO", 
        "AF_ECMA", 
        "AF_DATAKIT", 
        "AF_CCITT", 
        "AF_SNA", 
        "AF_DECnet", 
        "AF_DLI", 
        "AF_LAT", 
        "AF_HYLINK", 
        "AF_APPLETALK", 
        "AF_ROUTE", 
        "AF_LINK", 
        "pseudo_AF_XTP", 
        "AF_COIP", 
        "pseudo_AF_RTIP", 
        "AF_IPX",  
        "AF_SIP", 
        "pseudo_AF_PIP", 
        "AF_ISDN", 
        "AF_E164", 
        "pseudo_AF_KEY",  
        "AF_INET6"      
};

static char *af_unknown = "AF_UNKNOWN";
static char *msg_noaddr = "No address";
static char *msg_fail = "Fail";
static char msgbuf[256];
static char netbuf[32];

static char *netitoa(long inaddr);
char *wsi_get_family(const struct sockaddr *saddr, int len);
char *wsi_get_addr(const struct sockaddr *saddr, int len);

static char *netitoa(long inaddr) { }

char *wsi_get_family(const struct sockaddr *saddr, int len) { }

char *wsi_get_addr(const struct sockaddr *saddr, int len) { }

int wsi_getsockname(int fd, struct sockaddr *s, int *len) { }

int wsi_getpeername(int fd, struct sockaddr *s, int *len) { }
