/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_process.c,v 1.5 2001/02/23 19:02:40 stevek Exp $
 *
 * Authors: Steve Kiernan
 *
 * Purpose: System-dependent process management functions
 */

#include <wr_conf.h>

/***************************************************************************\
 * External globals                                                        *
\***************************************************************************/

extern const char *original_syscallnames[];


/***************************************************************************\
 * Public functions
\***************************************************************************/

/*
 * Create the system-dependent opaque data part of the wss_proc structure
 */
void
wsi_proc_new( struct wss_proc *wrp )
{
   struct wsi_proc *wsiproc;

   wsiproc = (struct wsi_proc *)wss_malloc( sizeof(struct wsi_proc) );
   bzero(wsiproc, sizeof(*wsiproc));

   /* You might use this space for mutex's to protect the wss_proc
    * structure for example. */

   wrp->opaque = wsiproc;
}

/*
 * Free the wss_proc structure system-dependent opaque data
 */
void
wsi_proc_free( struct wss_proc *wrp )
{
   wss_free( wrp->opaque );
}

/*
 * Returns the number of LWPs within syscalls for the specified process
 */
int
wsi_proc_insyscall( struct wss_proc *wrp )
{
   return 0;
}

/*
 * This is a placeholder for code that actually does make LWPs reissue
 * their syscalls.  It's obviously TBD.
 */
void
wsi_proc_force_syscall_exit( struct wss_proc *wrp )
{
}

