/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_malloc.h,v 1.11 2001/02/23 19:02:43 stevek Exp $
 * 
 * Author: Steve Kiernan
 * 
 * Purpose: Declaration of Solaris WSI malloc services.
 */

#ifndef __WSI_MALLOC_H
#define __WSI_MALLOC_H  1

#include <wr_conf.h>
#include <wsi_types.h>


/************************************************************************\
 * Public functions                                                     *
\************************************************************************/

void       *wsi_malloc                __P(( size_t size ));
void        wsi_free                  __P(( void *ptr ));

void       *wsi_curproc_malloc        __P(( size_t size ));
void        wsi_curproc_free          __P(( void *,int ));
char       *wsi_curproc_strdup        __P(( const pd_char_t *str ));


/************************************************************************\
 * Functions implemented as macros                                      *
\************************************************************************/

#define wsi_malloc_string(s) \
           (pd_char_t*)wsi_malloc(((s)+1)*sizeof(pd_char_t))
#define wsi_curproc_malloc_string(s) \
           (pd_char_t*)wsi_curproc_malloc(((s)+1)*sizeof(pd_char_t))

#endif /* __WSI_MALLOC_H */

