/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wsi_stdlib.h,v 1.11 2001/02/23 19:02:43 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: This file contains standard library macros and prototypes
 */

#ifndef __WSI_STDLIB_H
#define __WSI_STDLIB_H 1

#include <wr_conf.h>

#include <errno.h>

#include <wsi_types.h>

#include <stdarg.h>


/************************************************************************\
 * Public functions                                                     *
\************************************************************************/

int        WSSLINKAGE  wsi_printf  __P(( const pd_char_t *format, ... ));
size_t     WSSLINKAGE  wsi_strlen  __P(( const pd_char_t *s ));
int        WSSLINKAGE  wsi_strcmp  __P(( const pd_char_t *s1,
                                         const pd_char_t *s2 ));
int        WSSLINKAGE  wsi_strncmp __P(( const pd_char_t *s1,
                                         const pd_char_t *s2, size_t len ));
pd_char_t WSSLINKAGE *wsi_strcpy  __P(( pd_char_t *dst,
                                         const pd_char_t *src ));
pd_char_t WSSLINKAGE *wsi_strncpy __P(( pd_char_t *dst,
                                         const pd_char_t *src, size_t len ));
pd_char_t WSSLINKAGE *wsi_strcat  __P(( pd_char_t *dst,
                                         const pd_char_t *src ));
int        WSSLINKAGE  wsi_vsprintf __P(( pd_char_t *buf,
                                          const pd_char_t *format,
                                          va_list ap));
int        WSSLINKAGE  wsi_sprintf __P(( pd_char_t *buf,
                                          const pd_char_t *format, ... ));
pd_char_t WSSLINKAGE  wsi_toupper __P(( pd_char_t c ));
pd_char_t WSSLINKAGE  wsi_tolower __P(( pd_char_t c ));


/************************************************************************\
 * Functions implemented as macros                                      *
\************************************************************************/

#define wsi_sprintf  sprintf
#define wsi_snprintf snprintf
#define wsi_printf   printf

#endif /* !__WSI_STDLIB_H */

