/*! \file wss_arg.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wss_arg.h,v 1.19 2001/02/23 19:02:47 stevek Exp $
 * 
 * \brief   Declaration of services for replacement of call arguments
 *          from within a wrapper
 * \author  Chris Vance, Doug Kilpatrick
 * \version $Revision: 1.19 $
 * \date    $Date: 2001/02/23 19:02:47 $
 *
 * \sa wss_arg.c
 */

#ifndef __WSS_ARG_H
#define __WSS_ARG_H 1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifndef __WSI_TYPES_H
#include <wsi_types.h>
#endif

#ifndef __WSS_PROCESS_H
#include <wss_process.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif


/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/

void WSSLINKAGE  wss_arg_init              ( void );
void WSSLINKAGE  wss_arg_shutdown          ( void );
int  WSSLINKAGE  wss_arg_add               ( wss_proc_t *wrp, int handle,
                                             int space, pd_syscall_id_t code,
                                             void *uap[], int index,
                                             size_t size );
void WSSLINKAGE  wss_arg_donesyscall       ( wss_proc_t *wrp, int handle,
                                             int space, pd_syscall_id_t code,
                                             void *uap[] );
int  WSSLINKAGE  wss_arg_replace           ( wss_proc_t *wrp, int handle,
                                             int space, pd_syscall_id_t code,
                                             void *uap[], void *new_arg,
                                             int index, size_t size );
int  WSSLINKAGE  wss_arg_copy              ( void *uap[], void *new_arg,
                                             int index, size_t size );
void WSSLINKAGE *wss_arg_dupin             ( void *src, size_t size );
void WSSLINKAGE *wss_arg_dupin             ( void *src, size_t size );
void WSSLINKAGE *wss_arg_dupin_ntermlist   ( void *src );
void WSSLINKAGE  wss_arg_free_ntermlist    ( void *kaddr );
int  WSSLINKAGE  wss_arg_replace_ntermlist ( wss_proc_t *wrp, void *uap[],
                                             void *new_arg, int index );
                                            
void WSSLINKAGE *wss_arg_dupout            ( void *src, size_t size );

#ifdef __cplusplus
}
#endif

#endif /* __WSS_ARG_H */

