/*! \file wss_audit.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wss_audit.h,v 1.14 2001/02/23 19:02:47 stevek Exp $
 * 
 * \brief   Header file for audit component
 * \author  Douglas Kilpatrick
 * \version $Revision: 1.14 $
 * \date    $Date: 2001/02/23 19:02:47 $
 * 
 * Audits are implemented as event types, but this provides a sligtly
 * more intuitive interface to the functionality.
 *
 * \sa wss_audit.c
 */

#ifndef WSS_AUDIT_H
#define WSS_AUDIT_H

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifndef __WSI_TYPES_H
#include <wsi_types.h>
#endif

#ifndef __WSS_WRVEVENT_H
#include <wss_wrvevent.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern u_long WREV_AUDIT_0;
extern u_long WREV_AUDIT_1;
extern u_long WREV_AUDIT_2;
extern u_long WREV_AUDIT_3;
extern u_long WREV_AUDIT_4;
extern u_long WREV_AUDIT_5;
extern u_long WREV_AUDIT_6;
extern u_long WREV_AUDIT_7;
extern u_long WREV_AUDIT_8;
extern u_long WREV_AUDIT_9;
extern u_long WREV_AUDIT_A;
extern u_long WREV_AUDIT_B;
extern u_long WREV_AUDIT_C;
extern u_long WREV_AUDIT_D;
extern u_long WREV_AUDIT_E;
extern u_long WREV_AUDIT_F;
extern u_long WREV_AUDIT_10;
extern u_long WREV_AUDIT_11;
extern u_long WREV_AUDIT_12;
extern u_long WREV_AUDIT_13;
extern u_long WREV_AUDIT_14;
extern u_long WREV_AUDIT_15;
extern u_long WREV_AUDIT_16;
extern u_long WREV_AUDIT_17;
extern u_long WREV_AUDIT_18;
extern u_long WREV_AUDIT_19;
extern u_long WREV_AUDIT_1A;
extern u_long WREV_AUDIT_1B;
extern u_long WREV_AUDIT_1C;
extern u_long WREV_AUDIT_1D;
extern u_long WREV_AUDIT_1E;
extern u_long WREV_AUDIT_1F;

void WSSLINKAGE wss_audit_write( u_long types, const void *buf, size_t length );
int WSSLINKAGE wss_audit_printf(u_long types, const pd_char_t *format, ...);
int WSSLINKAGE wss_audit_init(void);
void WSSLINKAGE wss_audit_shutdown(void);

#ifdef __cplusplus
}
#endif

#endif

