/*! \file wss_cv.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wss_cv.h,v 1.6 2001/02/23 19:02:47 stevek Exp $
 * 
 * \brief   Declaration of condition variable functions for the generated
 *          wrappers
 * \author  Steve Kiernan
 * \version $Revision: 1.6 $
 * \date    $Date: 2001/02/23 19:02:47 $
 *
 * \sa wss_cv.c
 */

#ifndef __WSS_CV_H
#define __WSS_CV_H   1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifndef __WSI_TYPES_H
#include <wsi_types.h>
#endif

/* Include platform specific parts. */
#ifndef __PI_CV_H
#include <pdpi/pi_cv.h>
#endif


/* Define our condition variable macros to set proper PD cv linkage */
#define WSS_CV_PROTECT(a)          PD_CV_PROTECT(WSSLINKAGE,a)
#define WSS_CV_PROTECT_EXPORTED(a) PD_CV_PROTECT_EXPORTED(WSSLINKAGE,a)
#define WSS_CV_EXPORT(a)           PD_CV_EXPORT(WSSLINKAGE,a)
#define WSS_CV_INIT(a)             PD_CV_INIT(WSSLINKAGE,a)
#define WSS_CV_DESTROY(a)          PD_CV_DESTROY(WSSLINKAGE,a)
#define WSS_CV_WAIT(a)             PD_CV_WAIT(WSSLINKAGE,a)
#define WSS_CV_WAIT_DEBUG(a)       PD_CV_WAIT_DEBUG(WSSLINKAGE,a)
#define WSS_CV_SIGNAL(a)           PD_CV_SIGNAL(WSSLINKAGE,a)
#define WSS_CV_SIGNAL_DEBUG(a)     PD_CV_SIGNAL_DEBUG(WSSLINKAGE,a)
#define WSS_CV_BROADCAST(a)        PD_CV_BROADCAST(WSSLINKAGE,a)
#define WSS_CV_BROADCAST_DEBUG(a)  PD_CV_BROADCAST_DEBUG(WSSLINKAGE,a)


#ifdef __cplusplus
extern "C" {
#endif

/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/

#if 0
void WSSLINKAGE wss_cv_init     ( pd_cv_t *, pd_char_t * );
void WSSLINKAGE wss_cv_destroy  ( pd_cv_t * );
void WSSLINKAGE wss_cv_wait     ( pd_cv_t * );
void WSSLINKAGE wss_cv_signal   ( pd_cv_t * );
void WSSLINKAGE wss_cv_broadcast( pd_cv_t * );
#endif

#ifdef __cplusplus
}
#endif

#endif /* !__WSS_MUTEX_H */

