/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wss_debug.h,v 1.6 2001/02/23 19:02:47 stevek Exp $
 *
 * Author: Steve Kiernan
 *
 * Purpose: This file contains prototypes and structures used for debugging.
 */

#ifndef __WSS_DEBUG_H
#define __WSS_DEBUG_H 1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif /* !WR_DEFS_INCLUDED */

#ifndef __WSI_TYPES_H
#include <wsi_types.h>
#endif /* !__WSI_TYPES_H */

#ifndef __WSI_DEBUG_H
#include <wsi_debug.h>
#endif /* !__WSI_DEBUG_H */

#ifdef __cplusplus
extern "C" {
#endif


/************************************************************************\
 * Public functions                                                     *
\************************************************************************/

int  WSSLINKAGE wss_debug_log __P(( const pd_char_t *format, ... ));


/************************************************************************\
 * Functions implemented as macros                                      *
\************************************************************************/

#define wss_debug_log wsi_debug_log

#ifdef __cplusplus
}
#endif

#endif /* !__WSS_DEBUG_H */

