/*! \file wss_dispatch.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wss_dispatch.h,v 1.10 2001/02/23 19:02:47 stevek Exp $
 *
 * \brief   Declarations for the the WSS implementation of event dispatching
 *          functions
 * \author  Douglas Kilpatrick
 * \version $Revision: 1.10 $
 * \date    $Date: 2001/02/23 19:02:47 $
 */

#ifndef __WSS_DISPATCH_H
#define __WSS_DISPATCH_H 1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/***************************************************************************\
 * Public Functions                                                        *
\***************************************************************************/

int WSSLINKAGE wss_dispatch       ( int, pd_syscall_id_t, wss_proc_t *, int,
                                    int, ... );
int WSSLINKAGE wss_dispatch_unsafe( int, pd_syscall_id_t, wss_proc_t *, int,
                                    int, ... );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __WSS_DISPATCH_H */

