/*! \file wss_elf.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wss_elf.h,v 1.15 2001/02/23 19:02:47 stevek Exp $
 *
 * \brief   Prototypes and structures use by the module loading code for
 *          ELF-32 format modules
 * \author  Steve Kiernan
 * \version $Revision: 1.15 $
 * \date    $Date: 2001/02/23 19:02:47 $
 */


#ifndef __WSS_ELF_H
#define __WSS_ELF_H  1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifndef __WSI_TYPES_H
#include <wsi_types.h>
#endif

#include <imported/elf.h>

#include <wsi_elf.h>
#include <wss_module.h>

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/

int WSSLINKAGE wss_module_is_elf  ( wss_mod_t *wrm );
int WSSLINKAGE wss_elf_load_module( wss_mod_t *wrm );

#ifdef __cplusplus
}
#endif

#endif /* __WSS_ELF_H */

