/*! \file wss_export.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wss_export.h,v 1.7 2001/02/23 19:02:47 stevek Exp $
 *
 * \brief   Prototypes and structures used by the module linker
 * \author  Steve Kiernan
 * \version $Revision: 1.7 $
 * \date    $Date: 2001/02/23 19:02:47 $
 */

#ifndef __WSS_EXPORT_H
#define __WSS_EXPORT_H	1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifndef __WSI_TYPES_H
#include <wsi_types.h>
#endif

#ifndef __WSS_IFACE_H
#include <wss_iface.h>
#endif

#ifndef __WSS_LINKER_H
#include <wss_linker.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/

int WSSLINKAGE wss_export_lookup          __P(( wss_linker_file_t *,
                                                const pd_char_t *,
                                                wss_linker_addr_t * ));
int WSSLINKAGE wss_export_noop            __P(( wss_linker_file_t * ));

#ifdef __cplusplus
}
#endif

#endif /* __WSS_EXPORT_H */

