/*! \file wss_path.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wss_path.h,v 1.15 2001/02/23 19:02:47 stevek Exp $ 
 * 
 * \brief   Declaration of WSS path services
 * \author  Linda Thomas
 * \version $Revision: 1.15 $
 * \date    $Date: 2001/02/23 19:02:47 $
 *
 * \sa wss_path.c
 */

#ifndef __WSS_PATH_H
#define __WSS_PATH_H 1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifndef __WSI_TYPES_H
#include <wsi_types.h>
#endif

#ifndef __WSS_FILE_H
#include <wss_file.h>
#endif

/* Include platform specific parts. */
#include <wsi_path.h>


#ifdef __cplusplus
extern "C" {
#endif

/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/

pd_char_t WSSLINKAGE *wss_path_rel_to_abspath( pd_char_t const *,
                                               pd_char_t const * );


/***************************************************************************\
 * Public macros                                                           *
\***************************************************************************/

/* Return absoulte string path */
#define wss_path_abspath          wsi_path_abspath

/* Return string path for process p's cwd */
#define wss_path_cwd(wrp)         wsi_path_cwd(wrp)

/* Return string pathname for vnode v */
#define wss_path_vnode_to_path(v) wsi_path_vnode_to_path(v)

#ifdef __cplusplus
}
#endif

#endif /* __WSS_PATH_H */

