/*! \file wss_pe.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wss_pe.h,v 1.6 2001/02/23 19:02:47 stevek Exp $
 *
 * \brief   Prototypes and structures use by the module loading code for PE
 *          format modules
 * \author  Steve Kiernan
 * \version $Revision: 1.6 $
 * \date    $Date: 2001/02/23 19:02:47 $
 *
 * \sa wsi_pe.c
 */


#ifndef __WSS_PE_H
#define __WSS_PE_H 1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifdef WR_HAS_PE_MODULES

#include <wsi_types.h>

#include <wss_module.h>
#include <wsi_pe.h>

#ifdef __cplusplus
extern "C" {
#endif


/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/

int WSSLINKAGE wss_module_is_pe  ( wss_mod_t * );
int WSSLINKAGE wss_pe_load_module( wss_mod_t * );


/***************************************************************************\
 * Functions implemented as macros                                         *
\***************************************************************************/

#define wss_module_is_pe(wrm)   wsi_module_is_pe(wrm)
#define wss_pe_load_module(wrm) wsi_pe_load_module(wrm)


#ifdef __cplusplus
}
#endif

#endif /* WR_HAS_PE_MODULES */

#endif /* __WSS_PE_H */

