/* 
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef __WSS_REF_H
#define __WSS_REF_H 1

typedef struct _wss_ref wss_ref_t;

struct _wss_ref
{
   union
   {
      int                  ref_count;
#ifdef DEBUG_REFS
      struct
      {
         const pd_char_t *ref_file;
         int               ref_line;
      }
      st;
#endif /* DEBUG_REFS */
   }
   un;
#ifdef DEBUG_REFS
   wss_ref_t              *ref_next;
#endif /* DEBUG_REFS */
};


#ifdef DEBUG_REFS
#define WSS_REF_INC_DEBUG(r,f,l) wss_ref_debug_inc( &(r), (f), (l) )
#define WSS_REF_DEC_DEBUG(r,f,l) wss_ref_debug_dec( &(r), (f), (l) )
#define WSS_REF_INC(r)           wss_ref_debug_inc( &(r), __FILE__, __LINE__ )
#define WSS_REF_DEC(r)           wss_ref_debug_dec( &(r), __FILE__, __LINE__ )
#else
#define WSS_REF_INC(r)           ((r).un.ref_count++)
#define WSS_REF_DEC(r)           (--(r).un.ref_count)
#endif /* DEBUG_REFS */
#define WSS_REF_COUNT(r)         ((r).un.ref_count)


void WSSLINKAGE wss_ref_init      __P(( wss_ref_t * ));
void WSSLINKAGE wss_ref_destroy   __P(( wss_ref_t * ));
#ifdef DEBUG_REFS
int  WSSLINKAGE wss_ref_debug_inc __P(( wss_ref_t *, const pd_char_t *, int ));
int  WSSLINKAGE wss_ref_debug_dec __P(( wss_ref_t *, const pd_char_t *, int ));
#endif /* DEBUG_REFS */

#endif /* __WSS_REF_H */

