/*! \file wss_strings.h
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * $Id: wss_strings.h,v 1.13 2001/02/23 19:02:47 stevek Exp $
 *
 * \brief   Functions exported from the WSS to wrappers to be used for
 *          manipulating strings
 * \author  Chris Vance, Ben Uecker, Mark Feldman
 * \version $Revision: 1.13 $
 * \date    $Date: 2001/02/23 19:02:47 $
 *
 * \sa wss_strings.c
 */

#ifndef __WSS_STRINGS_H
#define __WSS_STRINGS_H 1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifndef __WSI_TYPES_H
#include <wsi_types.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif

/***************************************************************************\
 * Public functions                                                        *
\***************************************************************************/

pd_char_t WSSLINKAGE *wss_strchr   ( const pd_char_t *, int );
pd_char_t WSSLINKAGE *wss_strrchr  ( const pd_char_t *, int );
pd_char_t WSSLINKAGE *wss_strncpy  ( pd_char_t *, const pd_char_t *,
                                      size_t );
pd_char_t WSSLINKAGE *wss_strstr   ( const pd_char_t *, const pd_char_t * );
int        WSSLINKAGE wss_replace   ( pd_char_t **, pd_char_t *,
                                      pd_char_t *, pd_char_t * );
int        WSSLINKAGE wss_substitute( pd_char_t **, pd_char_t *,
                                      pd_char_t * );
int        WSSLINKAGE wss_match     ( pd_char_t *, pd_char_t *,
                                      pd_char_t **, pd_char_t ** );


#ifdef __cplusplus
}
#endif

#endif /* __WSS_STRINGS_H */

