/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 *  $Id: wss_wrv.h,v 1.17 2001/02/23 19:02:47 stevek Exp $
 *
 *  Author: 
 *
 *  Purpose: Generic wrv datatypes
 *
 */

#ifndef __WSS_WRV_H
#define __WSS_WRV_H 1

#ifndef WR_DEFS_INCLUDED
#include <wr_conf.h>
#endif

#ifndef __WSI_TYPES_H
#include <wsi_types.h>
#endif

#ifndef __WSI_DB_H
#include <wss_db.h>
#endif

#ifndef __WSS_WRVEVENT_H
#include <wss_wrvevent.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************************************\
 * Public structures and types                                             *
\***************************************************************************/

typedef struct wss_wrv_db_row   wss_wrv_db_row_t;
typedef struct wss_wrv_table_id wss_wrv_table_id_t;

struct wss_wrv_table_id
{
   wss_db_handle_t     handle;
   pd_char_t          *name;
   wss_wrv_table_id_t *next;
};

struct wss_wrv_db_row
{
   wqrow           row;
   int             numvals;
   wss_db_handle_t handle;
};


/***************************************************************************\
 * Public macros                                                           *
\***************************************************************************/

#define ROW(r)         (&((wss_wrv_db_row_t *)r)->row)
#define ROW_NEXT(r)    ((wss_wrv_db_row_t *)((wss_wrv_db_row_t *)r)->row.next)
#define ROW_NUMVALS(r) (((wss_wrv_db_row_t *)r)->numvals)


#ifdef __cplusplus
}
#endif

#endif /* !__WSS_WRV_H */

