/*
 * Copyright (C) 1999, 2000, 2001  Network Associates, Incorporated (NAI)
 * All rights reserved.
 *
 * This file is part of the NAI Generic Software Wrappers Toolkit
 * (GSWTK).  See ftp://ftp.tislabs.com/pub/wrappers/ for the latest
 * distribution.
 *
 * The GSWTK is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * The GSWTK is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * lwmstubs4_1.cxx
 *
 * $Id: lwmstubs4_1.cxx,v 1.7 2001/04/05 18:40:40 stevek Exp $
 *
 * Note: This file is automatically generated by genstubs.pl
 *       Do not modify.
 */

/****************************************************************************
 *
 * Here are the hooked function replacements (#501 - #797)
 *
****************************************************************************/

int WINAPI LWM_MultiByteToWideChar( UINT CodePage,
                                    DWORD dwFlags,
                                    LPCSTR lpMultiByteStr,
                                    int cbMultiByte,
                                    LPWSTR lpWideCharStr,
                                    int cchWideChar
                                  )
{
   int callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("MultiByteToWideChar"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("MultiByteToWideChar");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) CodePage;
   uapsave[1] =
      uap[1] = (LPVOID) dwFlags;
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpMultiByteStr );
   uapsave[3] =
      uap[3] = (LPVOID) cbMultiByte;
   uapsave[4] =
      uap[4] = (LPVOID) lpWideCharStr;
   uapsave[5] =
      uap[5] = (LPVOID) cchWideChar;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("int"),
                  PD_MAKESTR("MultiByteToWideChar"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 501, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[6];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      callRet = MultiByteToWideChar( (UINT) uapascii[0],
                                     (DWORD) uapascii[1],
                                     (LPCSTR) uapascii[2],
                                     (int) uapascii[3],
                                     (LPWSTR) uapascii[4],
                                     (int) uapascii[5]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[2] )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 501, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[2] )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 502, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_NotifyBootConfigStatus( BOOL BootAcceptable )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("NotifyBootConfigStatus"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("NotifyBootConfigStatus");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) BootAcceptable;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("NotifyBootConfigStatus"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 502, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = NotifyBootConfigStatus( (BOOL) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 502, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 503, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_NotifyChangeEventLog( HANDLE hEventLog,
                                      HANDLE hEvent
                                    )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("NotifyChangeEventLog"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("NotifyChangeEventLog");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hEventLog;
   uapsave[1] =
      uap[1] = (LPVOID) hEvent;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("NotifyChangeEventLog"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 503, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = NotifyChangeEventLog( (HANDLE) uapascii[0],
                                      (HANDLE) uapascii[1]
                                   );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 503, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 504, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ObjectCloseAuditAlarmA( LPCSTR SubsystemName,
                                        LPVOID HandleId,
                                        BOOL GenerateOnClose
                                      )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ObjectCloseAuditAlarmA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ObjectCloseAuditAlarmA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)SubsystemName );
   uapsave[1] =
      uap[1] = (LPVOID) HandleId;
   uapsave[2] =
      uap[2] = (LPVOID) GenerateOnClose;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ObjectCloseAuditAlarmA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 504, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = ObjectCloseAuditAlarmA( (LPCSTR) uapascii[0],
                                        (LPVOID) uapascii[1],
                                        (BOOL) uapascii[2]
                                     );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 504, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 505, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ObjectCloseAuditAlarmW( LPCWSTR SubsystemName,
                                        LPVOID HandleId,
                                        BOOL GenerateOnClose
                                      )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ObjectCloseAuditAlarmW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ObjectCloseAuditAlarmW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) SubsystemName;
   uapsave[1] =
      uap[1] = (LPVOID) HandleId;
   uapsave[2] =
      uap[2] = (LPVOID) GenerateOnClose;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ObjectCloseAuditAlarmW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 505, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ObjectCloseAuditAlarmW( (LPCWSTR) uap[0],
                                        (LPVOID) uap[1],
                                        (BOOL) uap[2]
                                     );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 505, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 506, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ObjectDeleteAuditAlarmA( LPCSTR SubsystemName,
                                         LPVOID HandleId,
                                         BOOL GenerateOnClose
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ObjectDeleteAuditAlarmA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ObjectDeleteAuditAlarmA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)SubsystemName );
   uapsave[1] =
      uap[1] = (LPVOID) HandleId;
   uapsave[2] =
      uap[2] = (LPVOID) GenerateOnClose;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ObjectDeleteAuditAlarmA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 506, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = ObjectDeleteAuditAlarmA( (LPCSTR) uapascii[0],
                                         (LPVOID) uapascii[1],
                                         (BOOL) uapascii[2]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 506, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 507, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ObjectDeleteAuditAlarmW( LPCWSTR SubsystemName,
                                         LPVOID HandleId,
                                         BOOL GenerateOnClose
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ObjectDeleteAuditAlarmW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ObjectDeleteAuditAlarmW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) SubsystemName;
   uapsave[1] =
      uap[1] = (LPVOID) HandleId;
   uapsave[2] =
      uap[2] = (LPVOID) GenerateOnClose;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ObjectDeleteAuditAlarmW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 507, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ObjectDeleteAuditAlarmW( (LPCWSTR) uap[0],
                                         (LPVOID) uap[1],
                                         (BOOL) uap[2]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 507, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 508, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ObjectOpenAuditAlarmA( LPCSTR SubsystemName,
                                       LPVOID HandleId,
                                       LPSTR ObjectTypeName,
                                       LPSTR ObjectName,
                                       PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                       HANDLE ClientToken,
                                       DWORD DesiredAccess,
                                       DWORD GrantedAccess,
                                       PPRIVILEGE_SET Privileges,
                                       BOOL ObjectCreation,
                                       BOOL AccessGranted,
                                       LPBOOL GenerateOnClose
                                     )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[12];
   LPVOID uap[12];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ObjectOpenAuditAlarmA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ObjectOpenAuditAlarmA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)SubsystemName );
   uapsave[1] =
      uap[1] = (LPVOID) HandleId;
   uapsave[2] =
      uap[2] = (LPVOID) ObjectTypeName;
   uapsave[3] =
      uap[3] = (LPVOID) ObjectName;
   uapsave[4] =
      uap[4] = (LPVOID) pSecurityDescriptor;
   uapsave[5] =
      uap[5] = (LPVOID) ClientToken;
   uapsave[6] =
      uap[6] = (LPVOID) DesiredAccess;
   uapsave[7] =
      uap[7] = (LPVOID) GrantedAccess;
   uapsave[8] =
      uap[8] = (LPVOID) Privileges;
   uapsave[9] =
      uap[9] = (LPVOID) ObjectCreation;
   uapsave[10] =
      uap[10] = (LPVOID) AccessGranted;
   uapsave[11] =
      uap[11] = (LPVOID) GenerateOnClose;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ObjectOpenAuditAlarmA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7],
                  uap[8],
                  uap[9],
                  uap[10],
                  uap[11]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 508, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[12];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      uapascii[6] = uap[6];
      uapascii[7] = uap[7];
      uapascii[8] = uap[8];
      uapascii[9] = uap[9];
      uapascii[10] = uap[10];
      uapascii[11] = uap[11];
      callRet = ObjectOpenAuditAlarmA( (LPCSTR) uapascii[0],
                                       (LPVOID) uapascii[1],
                                       (LPSTR) uapascii[2],
                                       (LPSTR) uapascii[3],
                                       (PSECURITY_DESCRIPTOR) uapascii[4],
                                       (HANDLE) uapascii[5],
                                       (DWORD) uapascii[6],
                                       (DWORD) uapascii[7],
                                       (PPRIVILEGE_SET) uapascii[8],
                                       (BOOL) uapascii[9],
                                       (BOOL) uapascii[10],
                                       (LPBOOL) uapascii[11]
                                    );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 508, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 509, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ObjectOpenAuditAlarmW( LPCWSTR SubsystemName,
                                       LPVOID HandleId,
                                       LPWSTR ObjectTypeName,
                                       LPWSTR ObjectName,
                                       PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                       HANDLE ClientToken,
                                       DWORD DesiredAccess,
                                       DWORD GrantedAccess,
                                       PPRIVILEGE_SET Privileges,
                                       BOOL ObjectCreation,
                                       BOOL AccessGranted,
                                       LPBOOL GenerateOnClose
                                     )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[12];
   LPVOID uap[12];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ObjectOpenAuditAlarmW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ObjectOpenAuditAlarmW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) SubsystemName;
   uapsave[1] =
      uap[1] = (LPVOID) HandleId;
   uapsave[2] =
      uap[2] = (LPVOID) ObjectTypeName;
   uapsave[3] =
      uap[3] = (LPVOID) ObjectName;
   uapsave[4] =
      uap[4] = (LPVOID) pSecurityDescriptor;
   uapsave[5] =
      uap[5] = (LPVOID) ClientToken;
   uapsave[6] =
      uap[6] = (LPVOID) DesiredAccess;
   uapsave[7] =
      uap[7] = (LPVOID) GrantedAccess;
   uapsave[8] =
      uap[8] = (LPVOID) Privileges;
   uapsave[9] =
      uap[9] = (LPVOID) ObjectCreation;
   uapsave[10] =
      uap[10] = (LPVOID) AccessGranted;
   uapsave[11] =
      uap[11] = (LPVOID) GenerateOnClose;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ObjectOpenAuditAlarmW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7],
                  uap[8],
                  uap[9],
                  uap[10],
                  uap[11]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 509, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ObjectOpenAuditAlarmW( (LPCWSTR) uap[0],
                                       (LPVOID) uap[1],
                                       (LPWSTR) uap[2],
                                       (LPWSTR) uap[3],
                                       (PSECURITY_DESCRIPTOR) uap[4],
                                       (HANDLE) uap[5],
                                       (DWORD) uap[6],
                                       (DWORD) uap[7],
                                       (PPRIVILEGE_SET) uap[8],
                                       (BOOL) uap[9],
                                       (BOOL) uap[10],
                                       (LPBOOL) uap[11]
                                    );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 509, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 510, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ObjectPrivilegeAuditAlarmA( LPCSTR SubsystemName,
                                            LPVOID HandleId,
                                            HANDLE ClientToken,
                                            DWORD DesiredAccess,
                                            PPRIVILEGE_SET Privileges,
                                            BOOL AccessGranted
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ObjectPrivilegeAuditAlarmA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ObjectPrivilegeAuditAlarmA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)SubsystemName );
   uapsave[1] =
      uap[1] = (LPVOID) HandleId;
   uapsave[2] =
      uap[2] = (LPVOID) ClientToken;
   uapsave[3] =
      uap[3] = (LPVOID) DesiredAccess;
   uapsave[4] =
      uap[4] = (LPVOID) Privileges;
   uapsave[5] =
      uap[5] = (LPVOID) AccessGranted;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ObjectPrivilegeAuditAlarmA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 510, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[6];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      callRet = ObjectPrivilegeAuditAlarmA( (LPCSTR) uapascii[0],
                                            (LPVOID) uapascii[1],
                                            (HANDLE) uapascii[2],
                                            (DWORD) uapascii[3],
                                            (PPRIVILEGE_SET) uapascii[4],
                                            (BOOL) uapascii[5]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 510, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 511, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ObjectPrivilegeAuditAlarmW( LPCWSTR SubsystemName,
                                            LPVOID HandleId,
                                            HANDLE ClientToken,
                                            DWORD DesiredAccess,
                                            PPRIVILEGE_SET Privileges,
                                            BOOL AccessGranted
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ObjectPrivilegeAuditAlarmW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ObjectPrivilegeAuditAlarmW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) SubsystemName;
   uapsave[1] =
      uap[1] = (LPVOID) HandleId;
   uapsave[2] =
      uap[2] = (LPVOID) ClientToken;
   uapsave[3] =
      uap[3] = (LPVOID) DesiredAccess;
   uapsave[4] =
      uap[4] = (LPVOID) Privileges;
   uapsave[5] =
      uap[5] = (LPVOID) AccessGranted;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ObjectPrivilegeAuditAlarmW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 511, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ObjectPrivilegeAuditAlarmW( (LPCWSTR) uap[0],
                                            (LPVOID) uap[1],
                                            (HANDLE) uap[2],
                                            (DWORD) uap[3],
                                            (PPRIVILEGE_SET) uap[4],
                                            (BOOL) uap[5]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 511, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 512, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenBackupEventLogA( LPCSTR lpUNCServerName,
                                       LPCSTR lpFileName
                                     )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenBackupEventLogA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenBackupEventLogA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpUNCServerName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpFileName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenBackupEventLogA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 512, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      callRet = OpenBackupEventLogA( (LPCSTR) uapascii[0],
                                     (LPCSTR) uapascii[1]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 512, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 513, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenBackupEventLogW( LPCWSTR lpUNCServerName,
                                       LPCWSTR lpFileName
                                     )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenBackupEventLogW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenBackupEventLogW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpUNCServerName;
   uapsave[1] =
      uap[1] = (LPVOID) lpFileName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenBackupEventLogW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 513, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = OpenBackupEventLogW( (LPCWSTR) uap[0],
                                     (LPCWSTR) uap[1]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 513, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 514, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenEventA( DWORD dwDesiredAccess,
                              BOOL bInheritHandle,
                              LPCSTR lpName
                            )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenEventA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenEventA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenEventA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 514, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      callRet = OpenEventA( (DWORD) uapascii[0],
                            (BOOL) uapascii[1],
                            (LPCSTR) uapascii[2]
                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[2] )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 514, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[2] )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 515, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenEventLogA( LPCSTR lpUNCServerName,
                                 LPCSTR lpSourceName
                               )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenEventLogA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenEventLogA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpUNCServerName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSourceName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenEventLogA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 515, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      callRet = OpenEventLogA( (LPCSTR) uapascii[0],
                               (LPCSTR) uapascii[1]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 515, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 516, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenEventLogW( LPCWSTR lpUNCServerName,
                                 LPCWSTR lpSourceName
                               )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenEventLogW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenEventLogW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpUNCServerName;
   uapsave[1] =
      uap[1] = (LPVOID) lpSourceName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenEventLogW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 516, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = OpenEventLogW( (LPCWSTR) uap[0],
                               (LPCWSTR) uap[1]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 516, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 517, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenEventW( DWORD dwDesiredAccess,
                              BOOL bInheritHandle,
                              LPCWSTR lpName
                            )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenEventW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenEventW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) lpName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenEventW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 517, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = OpenEventW( (DWORD) uap[0],
                            (BOOL) uap[1],
                            (LPCWSTR) uap[2]
                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 517, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 518, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HFILE WINAPI LWM_OpenFile( LPCSTR lpFileName,
                           LPOFSTRUCT lpReOpenBuff,
                           UINT uStyle
                         )
{
   HFILE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenFile"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenFile");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpFileName );
   uapsave[1] =
      uap[1] = (LPVOID) lpReOpenBuff;
   uapsave[2] =
      uap[2] = (LPVOID) uStyle;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("HFILE"),
                  PD_MAKESTR("OpenFile"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 518, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = OpenFile( (LPCSTR) uapascii[0],
                          (LPOFSTRUCT) uapascii[1],
                          (UINT) uapascii[2]
                       );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 518, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 519, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenFileMappingA( DWORD dwDesiredAccess,
                                    BOOL bInheritHandle,
                                    LPCSTR lpName
                                  )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenFileMappingA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenFileMappingA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenFileMappingA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 519, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      callRet = OpenFileMappingA( (DWORD) uapascii[0],
                                  (BOOL) uapascii[1],
                                  (LPCSTR) uapascii[2]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[2] )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 519, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[2] )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 520, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenFileMappingW( DWORD dwDesiredAccess,
                                    BOOL bInheritHandle,
                                    LPCWSTR lpName
                                  )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenFileMappingW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenFileMappingW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) lpName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenFileMappingW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 520, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = OpenFileMappingW( (DWORD) uap[0],
                                  (BOOL) uap[1],
                                  (LPCWSTR) uap[2]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 520, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 521, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenMutexA( DWORD dwDesiredAccess,
                              BOOL bInheritHandle,
                              LPCSTR lpName
                            )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenMutexA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenMutexA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenMutexA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 521, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      callRet = OpenMutexA( (DWORD) uapascii[0],
                            (BOOL) uapascii[1],
                            (LPCSTR) uapascii[2]
                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[2] )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 521, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[2] )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 522, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenMutexW( DWORD dwDesiredAccess,
                              BOOL bInheritHandle,
                              LPCWSTR lpName
                            )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenMutexW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenMutexW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) lpName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenMutexW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 522, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = OpenMutexW( (DWORD) uap[0],
                            (BOOL) uap[1],
                            (LPCWSTR) uap[2]
                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 522, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 523, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenProcess( DWORD dwDesiredAccess,
                               BOOL bInheritHandle,
                               DWORD dwProcessId
                             )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenProcess"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenProcess");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) dwProcessId;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenProcess"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 523, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = OpenProcess( (DWORD) uapascii[0],
                             (BOOL) uapascii[1],
                             (DWORD) uapascii[2]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 523, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 524, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_OpenProcessToken( HANDLE ProcessHandle,
                                  DWORD DesiredAccess,
                                  PHANDLE TokenHandle
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenProcessToken"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenProcessToken");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) ProcessHandle;
   uapsave[1] =
      uap[1] = (LPVOID) DesiredAccess;
   uapsave[2] =
      uap[2] = (LPVOID) TokenHandle;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("OpenProcessToken"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 524, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = OpenProcessToken( (HANDLE) uapascii[0],
                                  (DWORD) uapascii[1],
                                  (PHANDLE) uapascii[2]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 524, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 525, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

SC_HANDLE WINAPI LWM_OpenSCManagerA( LPCSTR lpMachineName,
                                     LPCSTR lpDatabaseName,
                                     DWORD dwDesiredAccess
                                   )
{
   SC_HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenSCManagerA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenSCManagerA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpMachineName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpDatabaseName );
   uapsave[2] =
      uap[2] = (LPVOID) dwDesiredAccess;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("SC_HANDLE"),
                  PD_MAKESTR("OpenSCManagerA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 525, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      callRet = OpenSCManagerA( (LPCSTR) uapascii[0],
                                (LPCSTR) uapascii[1],
                                (DWORD) uapascii[2]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 525, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 526, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

SC_HANDLE WINAPI LWM_OpenSCManagerW( LPCWSTR lpMachineName,
                                     LPCWSTR lpDatabaseName,
                                     DWORD dwDesiredAccess
                                   )
{
   SC_HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenSCManagerW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenSCManagerW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpMachineName;
   uapsave[1] =
      uap[1] = (LPVOID) lpDatabaseName;
   uapsave[2] =
      uap[2] = (LPVOID) dwDesiredAccess;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("SC_HANDLE"),
                  PD_MAKESTR("OpenSCManagerW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 526, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = OpenSCManagerW( (LPCWSTR) uap[0],
                                (LPCWSTR) uap[1],
                                (DWORD) uap[2]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 526, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 527, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenSemaphoreA( DWORD dwDesiredAccess,
                                  BOOL bInheritHandle,
                                  LPCSTR lpName
                                )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenSemaphoreA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenSemaphoreA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenSemaphoreA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 527, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      callRet = OpenSemaphoreA( (DWORD) uapascii[0],
                                (BOOL) uapascii[1],
                                (LPCSTR) uapascii[2]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[2] )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 527, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[2] )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 528, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenSemaphoreW( DWORD dwDesiredAccess,
                                  BOOL bInheritHandle,
                                  LPCWSTR lpName
                                )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenSemaphoreW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenSemaphoreW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) lpName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenSemaphoreW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 528, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = OpenSemaphoreW( (DWORD) uap[0],
                                (BOOL) uap[1],
                                (LPCWSTR) uap[2]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 528, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 529, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

SC_HANDLE WINAPI LWM_OpenServiceA( SC_HANDLE hSCManager,
                                   LPCSTR lpServiceName,
                                   DWORD dwDesiredAccess
                                 )
{
   SC_HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenServiceA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenServiceA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hSCManager;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpServiceName );
   uapsave[2] =
      uap[2] = (LPVOID) dwDesiredAccess;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("SC_HANDLE"),
                  PD_MAKESTR("OpenServiceA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 529, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      callRet = OpenServiceA( (SC_HANDLE) uapascii[0],
                              (LPCSTR) uapascii[1],
                              (DWORD) uapascii[2]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 529, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 530, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

SC_HANDLE WINAPI LWM_OpenServiceW( SC_HANDLE hSCManager,
                                   LPCWSTR lpServiceName,
                                   DWORD dwDesiredAccess
                                 )
{
   SC_HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenServiceW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenServiceW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hSCManager;
   uapsave[1] =
      uap[1] = (LPVOID) lpServiceName;
   uapsave[2] =
      uap[2] = (LPVOID) dwDesiredAccess;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("SC_HANDLE"),
                  PD_MAKESTR("OpenServiceW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 530, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = OpenServiceW( (SC_HANDLE) uap[0],
                              (LPCWSTR) uap[1],
                              (DWORD) uap[2]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 530, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 531, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_OpenThreadToken( HANDLE ThreadHandle,
                                 DWORD DesiredAccess,
                                 BOOL OpenAsSelf,
                                 PHANDLE TokenHandle
                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenThreadToken"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenThreadToken");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) ThreadHandle;
   uapsave[1] =
      uap[1] = (LPVOID) DesiredAccess;
   uapsave[2] =
      uap[2] = (LPVOID) OpenAsSelf;
   uapsave[3] =
      uap[3] = (LPVOID) TokenHandle;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("OpenThreadToken"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 531, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = OpenThreadToken( (HANDLE) uapascii[0],
                                 (DWORD) uapascii[1],
                                 (BOOL) uapascii[2],
                                 (PHANDLE) uapascii[3]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 531, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 532, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenWaitableTimerA( DWORD dwDesiredAccess,
                                      BOOL bInheritHandle,
                                      LPCSTR lpTimerName
                                    )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenWaitableTimerA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenWaitableTimerA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpTimerName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenWaitableTimerA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 532, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      callRet = OpenWaitableTimerA( (DWORD) uapascii[0],
                                    (BOOL) uapascii[1],
                                    (LPCSTR) uapascii[2]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[2] )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 532, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[2] )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 533, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_OpenWaitableTimerW( DWORD dwDesiredAccess,
                                      BOOL bInheritHandle,
                                      LPCWSTR lpTimerName
                                    )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OpenWaitableTimerW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OpenWaitableTimerW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwDesiredAccess;
   uapsave[1] =
      uap[1] = (LPVOID) bInheritHandle;
   uapsave[2] =
      uap[2] = (LPVOID) lpTimerName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("OpenWaitableTimerW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 533, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = OpenWaitableTimerW( (DWORD) uap[0],
                                    (BOOL) uap[1],
                                    (LPCWSTR) uap[2]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 533, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 534, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

void WINAPI LWM_OutputDebugStringA( LPCSTR lpOutputString )
{
   void *callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OutputDebugStringA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OutputDebugStringA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpOutputString );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("void"),
                  PD_MAKESTR("OutputDebugStringA"),
                  uap[0],
                  (LPCWSTR) uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 534, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      OutputDebugStringA( (LPCSTR) uapascii[0]);

      if( g_bTraceCalls )
      wsi_printf( PD_MAKESTR("\n") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 534, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 535, (void **)uap );

}

void WINAPI LWM_OutputDebugStringW( LPCWSTR lpOutputString )
{
   void *callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("OutputDebugStringW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("OutputDebugStringW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpOutputString;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("void"),
                  PD_MAKESTR("OutputDebugStringW"),
                  uap[0],
                  (LPCWSTR) uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 535, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      OutputDebugStringW( (LPCWSTR) uap[0]);

      if( g_bTraceCalls )
      wsi_printf( PD_MAKESTR("\n") );


      retval = hook->callDispatchPost( /*space*/ 0, 535, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 536, (void **)uap );

}

BOOL WINAPI LWM_PeekConsoleInputA( HANDLE hConsoleInput,
                                   PINPUT_RECORD lpBuffer,
                                   DWORD nLength,
                                   LPDWORD lpNumberOfEventsRead
                                 )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("PeekConsoleInputA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("PeekConsoleInputA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleInput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfEventsRead;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("PeekConsoleInputA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 536, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = PeekConsoleInputA( (HANDLE) uapascii[0],
                                   (PINPUT_RECORD) uapascii[1],
                                   (DWORD) uapascii[2],
                                   (LPDWORD) uapascii[3]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 536, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 537, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_PeekConsoleInputW( HANDLE hConsoleInput,
                                   PINPUT_RECORD lpBuffer,
                                   DWORD nLength,
                                   LPDWORD lpNumberOfEventsRead
                                 )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("PeekConsoleInputW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("PeekConsoleInputW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleInput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfEventsRead;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("PeekConsoleInputW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 537, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = PeekConsoleInputW( (HANDLE) uap[0],
                                   (PINPUT_RECORD) uap[1],
                                   (DWORD) uap[2],
                                   (LPDWORD) uap[3]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 537, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 538, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_PeekNamedPipe( HANDLE hNamedPipe,
                               LPVOID lpBuffer,
                               DWORD nBufferSize,
                               LPDWORD lpBytesRead,
                               LPDWORD lpTotalBytesAvail,
                               LPDWORD lpBytesLeftThisMessage
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("PeekNamedPipe"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("PeekNamedPipe");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hNamedPipe;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nBufferSize;
   uapsave[3] =
      uap[3] = (LPVOID) lpBytesRead;
   uapsave[4] =
      uap[4] = (LPVOID) lpTotalBytesAvail;
   uapsave[5] =
      uap[5] = (LPVOID) lpBytesLeftThisMessage;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("PeekNamedPipe"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 538, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[6];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      callRet = PeekNamedPipe( (HANDLE) uapascii[0],
                               (LPVOID) uapascii[1],
                               (DWORD) uapascii[2],
                               (LPDWORD) uapascii[3],
                               (LPDWORD) uapascii[4],
                               (LPDWORD) uapascii[5]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 538, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 539, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_PostQueuedCompletionStatus( HANDLE CompletionPort,
                                            DWORD dwNumberOfBytesTransferred,
                                            ULONG_PTR dwCompletionKey,
                                            LPOVERLAPPED lpOverlapped
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("PostQueuedCompletionStatus"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("PostQueuedCompletionStatus");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) CompletionPort;
   uapsave[1] =
      uap[1] = (LPVOID) dwNumberOfBytesTransferred;
   uapsave[2] =
      uap[2] = (LPVOID) dwCompletionKey;
   uapsave[3] =
      uap[3] = (LPVOID) lpOverlapped;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("PostQueuedCompletionStatus"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 539, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = PostQueuedCompletionStatus( (HANDLE) uapascii[0],
                                            (DWORD) uapascii[1],
                                            (ULONG_PTR) uapascii[2],
                                            (LPOVERLAPPED) uapascii[3]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 539, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 540, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_PrepareTape( HANDLE hDevice,
                              DWORD dwOperation,
                              BOOL bImmediate
                            )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("PrepareTape"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("PrepareTape");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hDevice;
   uapsave[1] =
      uap[1] = (LPVOID) dwOperation;
   uapsave[2] =
      uap[2] = (LPVOID) bImmediate;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("PrepareTape"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 540, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = PrepareTape( (HANDLE) uapascii[0],
                             (DWORD) uapascii[1],
                             (BOOL) uapascii[2]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 540, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 541, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_PrivilegeCheck( HANDLE ClientToken,
                                PPRIVILEGE_SET RequiredPrivileges,
                                LPBOOL pfResult
                              )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("PrivilegeCheck"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("PrivilegeCheck");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) ClientToken;
   uapsave[1] =
      uap[1] = (LPVOID) RequiredPrivileges;
   uapsave[2] =
      uap[2] = (LPVOID) pfResult;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("PrivilegeCheck"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 541, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = PrivilegeCheck( (HANDLE) uapascii[0],
                                (PPRIVILEGE_SET) uapascii[1],
                                (LPBOOL) uapascii[2]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 541, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 542, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_PrivilegedServiceAuditAlarmA( LPCSTR SubsystemName,
                                              LPCSTR ServiceName,
                                              HANDLE ClientToken,
                                              PPRIVILEGE_SET Privileges,
                                              BOOL AccessGranted
                                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("PrivilegedServiceAuditAlarmA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("PrivilegedServiceAuditAlarmA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)SubsystemName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)ServiceName );
   uapsave[2] =
      uap[2] = (LPVOID) ClientToken;
   uapsave[3] =
      uap[3] = (LPVOID) Privileges;
   uapsave[4] =
      uap[4] = (LPVOID) AccessGranted;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("PrivilegedServiceAuditAlarmA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 542, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = PrivilegedServiceAuditAlarmA( (LPCSTR) uapascii[0],
                                              (LPCSTR) uapascii[1],
                                              (HANDLE) uapascii[2],
                                              (PPRIVILEGE_SET) uapascii[3],
                                              (BOOL) uapascii[4]
                                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 542, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 543, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_PrivilegedServiceAuditAlarmW( LPCWSTR SubsystemName,
                                              LPCWSTR ServiceName,
                                              HANDLE ClientToken,
                                              PPRIVILEGE_SET Privileges,
                                              BOOL AccessGranted
                                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("PrivilegedServiceAuditAlarmW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("PrivilegedServiceAuditAlarmW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) SubsystemName;
   uapsave[1] =
      uap[1] = (LPVOID) ServiceName;
   uapsave[2] =
      uap[2] = (LPVOID) ClientToken;
   uapsave[3] =
      uap[3] = (LPVOID) Privileges;
   uapsave[4] =
      uap[4] = (LPVOID) AccessGranted;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("PrivilegedServiceAuditAlarmW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 543, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = PrivilegedServiceAuditAlarmW( (LPCWSTR) uap[0],
                                              (LPCWSTR) uap[1],
                                              (HANDLE) uap[2],
                                              (PPRIVILEGE_SET) uap[3],
                                              (BOOL) uap[4]
                                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 543, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 544, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_PulseEvent( HANDLE hEvent )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("PulseEvent"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("PulseEvent");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hEvent;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("PulseEvent"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 544, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = PulseEvent( (HANDLE) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 544, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 545, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_PurgeComm( HANDLE hFile,
                           DWORD dwFlags
                         )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("PurgeComm"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("PurgeComm");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) dwFlags;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("PurgeComm"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 545, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = PurgeComm( (HANDLE) uapascii[0],
                           (DWORD) uapascii[1]
                        );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 545, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 546, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_QueryDosDeviceA( LPCSTR lpDeviceName,
                                  LPSTR lpTargetPath,
                                  DWORD ucchMax
                                )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryDosDeviceA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryDosDeviceA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpDeviceName );
   uapsave[1] =
      uap[1] = (LPVOID) lpTargetPath;
   uapsave[2] =
      uap[2] = (LPVOID) ucchMax;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("QueryDosDeviceA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 546, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = QueryDosDeviceA( (LPCSTR) uapascii[0],
                                 (LPSTR) uapascii[1],
                                 (DWORD) uapascii[2]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 546, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 547, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_QueryDosDeviceW( LPCWSTR lpDeviceName,
                                  LPWSTR lpTargetPath,
                                  DWORD ucchMax
                                )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryDosDeviceW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryDosDeviceW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpDeviceName;
   uapsave[1] =
      uap[1] = (LPVOID) lpTargetPath;
   uapsave[2] =
      uap[2] = (LPVOID) ucchMax;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("QueryDosDeviceW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 547, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = QueryDosDeviceW( (LPCWSTR) uap[0],
                                 (LPWSTR) uap[1],
                                 (DWORD) uap[2]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 547, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 548, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_QueryPerformanceCounter( LARGE_INTEGER * lpPerformanceCount )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryPerformanceCounter"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryPerformanceCounter");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpPerformanceCount;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("QueryPerformanceCounter"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 548, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = QueryPerformanceCounter( (LARGE_INTEGER *) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 548, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 549, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_QueryPerformanceFrequency( LARGE_INTEGER * lpFrequency )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryPerformanceFrequency"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryPerformanceFrequency");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpFrequency;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("QueryPerformanceFrequency"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 549, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = QueryPerformanceFrequency( (LARGE_INTEGER *) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 549, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 550, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_QueryServiceConfigA( SC_HANDLE hService,
                                     LPQUERY_SERVICE_CONFIGA lpServiceConfig,
                                     DWORD cbBufSize,
                                     LPDWORD pcbBytesNeeded
                                   )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryServiceConfigA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryServiceConfigA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hService;
   uapsave[1] =
      uap[1] = (LPVOID) lpServiceConfig;
   uapsave[2] =
      uap[2] = (LPVOID) cbBufSize;
   uapsave[3] =
      uap[3] = (LPVOID) pcbBytesNeeded;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("QueryServiceConfigA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 550, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = QueryServiceConfigA( (SC_HANDLE) uapascii[0],
                                     (LPQUERY_SERVICE_CONFIGA) uapascii[1],
                                     (DWORD) uapascii[2],
                                     (LPDWORD) uapascii[3]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 550, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 551, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_QueryServiceConfigW( SC_HANDLE hService,
                                     LPQUERY_SERVICE_CONFIGW lpServiceConfig,
                                     DWORD cbBufSize,
                                     LPDWORD pcbBytesNeeded
                                   )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryServiceConfigW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryServiceConfigW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hService;
   uapsave[1] =
      uap[1] = (LPVOID) lpServiceConfig;
   uapsave[2] =
      uap[2] = (LPVOID) cbBufSize;
   uapsave[3] =
      uap[3] = (LPVOID) pcbBytesNeeded;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("QueryServiceConfigW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 551, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = QueryServiceConfigW( (SC_HANDLE) uap[0],
                                     (LPQUERY_SERVICE_CONFIGW) uap[1],
                                     (DWORD) uap[2],
                                     (LPDWORD) uap[3]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 551, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 552, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_QueryServiceLockStatusA( SC_HANDLE hSCManager,
                                         LPQUERY_SERVICE_LOCK_STATUSA lpLockStatus,
                                         DWORD cbBufSize,
                                         LPDWORD pcbBytesNeeded
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryServiceLockStatusA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryServiceLockStatusA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hSCManager;
   uapsave[1] =
      uap[1] = (LPVOID) lpLockStatus;
   uapsave[2] =
      uap[2] = (LPVOID) cbBufSize;
   uapsave[3] =
      uap[3] = (LPVOID) pcbBytesNeeded;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("QueryServiceLockStatusA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 552, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = QueryServiceLockStatusA( (SC_HANDLE) uapascii[0],
                                         (LPQUERY_SERVICE_LOCK_STATUSA) uapascii[1],
                                         (DWORD) uapascii[2],
                                         (LPDWORD) uapascii[3]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 552, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 553, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_QueryServiceLockStatusW( SC_HANDLE hSCManager,
                                         LPQUERY_SERVICE_LOCK_STATUSW lpLockStatus,
                                         DWORD cbBufSize,
                                         LPDWORD pcbBytesNeeded
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryServiceLockStatusW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryServiceLockStatusW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hSCManager;
   uapsave[1] =
      uap[1] = (LPVOID) lpLockStatus;
   uapsave[2] =
      uap[2] = (LPVOID) cbBufSize;
   uapsave[3] =
      uap[3] = (LPVOID) pcbBytesNeeded;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("QueryServiceLockStatusW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 553, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = QueryServiceLockStatusW( (SC_HANDLE) uap[0],
                                         (LPQUERY_SERVICE_LOCK_STATUSW) uap[1],
                                         (DWORD) uap[2],
                                         (LPDWORD) uap[3]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 553, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 554, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_QueryServiceObjectSecurity( SC_HANDLE hService,
                                            SECURITY_INFORMATION dwSecurityInformation,
                                            PSECURITY_DESCRIPTOR lpSecurityDescriptor,
                                            DWORD cbBufSize,
                                            LPDWORD pcbBytesNeeded
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryServiceObjectSecurity"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryServiceObjectSecurity");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hService;
   uapsave[1] =
      uap[1] = (LPVOID) dwSecurityInformation;
   uapsave[2] =
      uap[2] = (LPVOID) lpSecurityDescriptor;
   uapsave[3] =
      uap[3] = (LPVOID) cbBufSize;
   uapsave[4] =
      uap[4] = (LPVOID) pcbBytesNeeded;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("QueryServiceObjectSecurity"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 554, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = QueryServiceObjectSecurity( (SC_HANDLE) uapascii[0],
                                            (SECURITY_INFORMATION) uapascii[1],
                                            (PSECURITY_DESCRIPTOR) uapascii[2],
                                            (DWORD) uapascii[3],
                                            (LPDWORD) uapascii[4]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 554, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 555, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_QueryServiceStatus( SC_HANDLE hService,
                                    LPSERVICE_STATUS lpServiceStatus
                                  )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryServiceStatus"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryServiceStatus");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hService;
   uapsave[1] =
      uap[1] = (LPVOID) lpServiceStatus;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("QueryServiceStatus"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 555, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = QueryServiceStatus( (SC_HANDLE) uapascii[0],
                                    (LPSERVICE_STATUS) uapascii[1]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 555, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 556, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_QueryServiceStatusEx( SC_HANDLE hService,
                                      SC_STATUS_TYPE InfoLevel,
                                      LPBYTE lpBuffer,
                                      DWORD cbBufSize,
                                      LPDWORD pcbBytesNeeded
                                    )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueryServiceStatusEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueryServiceStatusEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hService;
   uapsave[1] =
      uap[1] = (LPVOID) InfoLevel;
   uapsave[2] =
      uap[2] = (LPVOID) lpBuffer;
   uapsave[3] =
      uap[3] = (LPVOID) cbBufSize;
   uapsave[4] =
      uap[4] = (LPVOID) pcbBytesNeeded;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("QueryServiceStatusEx"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 556, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = QueryServiceStatusEx( (SC_HANDLE) uapascii[0],
                                      (SC_STATUS_TYPE) ((DWORD)uapascii[1]),
                                      (LPBYTE) uapascii[2],
                                      (DWORD) uapascii[3],
                                      (LPDWORD) uapascii[4]
                                   );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 556, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 557, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_QueueUserAPC( PAPCFUNC pfnAPC,
                               HANDLE hThread,
                               ULONG_PTR dwData
                             )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("QueueUserAPC"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("QueueUserAPC");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) pfnAPC;
   uapsave[1] =
      uap[1] = (LPVOID) hThread;
   uapsave[2] =
      uap[2] = (LPVOID) dwData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("QueueUserAPC"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 557, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = QueueUserAPC( (PAPCFUNC) uapascii[0],
                              (HANDLE) uapascii[1],
                              (ULONG_PTR) uapascii[2]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 557, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 558, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

void WINAPI LWM_RaiseException( DWORD dwExceptionCode,
                                DWORD dwExceptionFlags,
                                DWORD nNumberOfArguments,
                                const ULONG_PTR * lpArguments
                              )
{
   void *callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RaiseException"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RaiseException");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwExceptionCode;
   uapsave[1] =
      uap[1] = (LPVOID) dwExceptionFlags;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfArguments;
   uapsave[3] =
      uap[3] = (LPVOID) lpArguments;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("void"),
                  PD_MAKESTR("RaiseException"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 558, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      RaiseException( (DWORD) uapascii[0],
                      (DWORD) uapascii[1],
                      (DWORD) uapascii[2],
                      (const ULONG_PTR *) uapascii[3]
                   );

      if( g_bTraceCalls )
      wsi_printf( PD_MAKESTR("\n") );


      retval = hook->callDispatchPost( /*space*/ 0, 558, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 559, (void **)uap );

}

BOOL WINAPI LWM_ReadConsoleA( HANDLE hConsoleInput,
                              LPVOID lpBuffer,
                              DWORD nNumberOfCharsToRead,
                              LPDWORD lpNumberOfCharsRead,
                              LPVOID lpReserved
                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadConsoleA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadConsoleA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleInput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfCharsToRead;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfCharsRead;
   uapsave[4] =
      uap[4] = (LPVOID) lpReserved;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadConsoleA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 559, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = ReadConsoleA( (HANDLE) uapascii[0],
                              (LPVOID) uapascii[1],
                              (DWORD) uapascii[2],
                              (LPDWORD) uapascii[3],
                              (LPVOID) uapascii[4]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 559, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 560, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadConsoleInputA( HANDLE hConsoleInput,
                                   PINPUT_RECORD lpBuffer,
                                   DWORD nLength,
                                   LPDWORD lpNumberOfEventsRead
                                 )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadConsoleInputA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadConsoleInputA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleInput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfEventsRead;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadConsoleInputA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 560, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = ReadConsoleInputA( (HANDLE) uapascii[0],
                                   (PINPUT_RECORD) uapascii[1],
                                   (DWORD) uapascii[2],
                                   (LPDWORD) uapascii[3]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 560, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 561, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadConsoleInputW( HANDLE hConsoleInput,
                                   PINPUT_RECORD lpBuffer,
                                   DWORD nLength,
                                   LPDWORD lpNumberOfEventsRead
                                 )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadConsoleInputW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadConsoleInputW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleInput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfEventsRead;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadConsoleInputW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 561, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ReadConsoleInputW( (HANDLE) uap[0],
                                   (PINPUT_RECORD) uap[1],
                                   (DWORD) uap[2],
                                   (LPDWORD) uap[3]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 561, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 562, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadConsoleOutputA( HANDLE hConsoleOutput,
                                    PCHAR_INFO lpBuffer,
                                    COORD dwBufferSize,
                                    COORD dwBufferCoord,
                                    PSMALL_RECT lpReadRegion
                                  )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadConsoleOutputA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadConsoleOutputA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) &dwBufferSize;
   uapsave[3] =
      uap[3] = (LPVOID) &dwBufferCoord;
   uapsave[4] =
      uap[4] = (LPVOID) lpReadRegion;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadConsoleOutputA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 562, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = ReadConsoleOutputA( (HANDLE) uapascii[0],
                                    (PCHAR_INFO) uapascii[1],
                                   dwBufferSize,
                                   dwBufferCoord,
                                    (PSMALL_RECT) uapascii[4]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 562, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 563, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadConsoleOutputAttribute( HANDLE hConsoleOutput,
                                            LPWORD lpAttribute,
                                            DWORD nLength,
                                            COORD dwReadCoord,
                                            LPDWORD lpNumberOfAttrsRead
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadConsoleOutputAttribute"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadConsoleOutputAttribute");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpAttribute;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) &dwReadCoord;
   uapsave[4] =
      uap[4] = (LPVOID) lpNumberOfAttrsRead;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadConsoleOutputAttribute"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 563, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = ReadConsoleOutputAttribute( (HANDLE) uapascii[0],
                                            (LPWORD) uapascii[1],
                                            (DWORD) uapascii[2],
                                           dwReadCoord,
                                            (LPDWORD) uapascii[4]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 563, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 564, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadConsoleOutputCharacterA( HANDLE hConsoleOutput,
                                             LPSTR lpCharacter,
                                             DWORD nLength,
                                             COORD dwReadCoord,
                                             LPDWORD lpNumberOfCharsRead
                                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadConsoleOutputCharacterA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadConsoleOutputCharacterA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpCharacter;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) &dwReadCoord;
   uapsave[4] =
      uap[4] = (LPVOID) lpNumberOfCharsRead;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadConsoleOutputCharacterA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 564, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = ReadConsoleOutputCharacterA( (HANDLE) uapascii[0],
                                             (LPSTR) uapascii[1],
                                             (DWORD) uapascii[2],
                                            dwReadCoord,
                                             (LPDWORD) uapascii[4]
                                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 564, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 565, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadConsoleOutputCharacterW( HANDLE hConsoleOutput,
                                             LPWSTR lpCharacter,
                                             DWORD nLength,
                                             COORD dwReadCoord,
                                             LPDWORD lpNumberOfCharsRead
                                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadConsoleOutputCharacterW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadConsoleOutputCharacterW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpCharacter;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) &dwReadCoord;
   uapsave[4] =
      uap[4] = (LPVOID) lpNumberOfCharsRead;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadConsoleOutputCharacterW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 565, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ReadConsoleOutputCharacterW( (HANDLE) uap[0],
                                             (LPWSTR) uap[1],
                                             (DWORD) uap[2],
                                            dwReadCoord,
                                             (LPDWORD) uap[4]
                                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 565, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 566, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadConsoleOutputW( HANDLE hConsoleOutput,
                                    PCHAR_INFO lpBuffer,
                                    COORD dwBufferSize,
                                    COORD dwBufferCoord,
                                    PSMALL_RECT lpReadRegion
                                  )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadConsoleOutputW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadConsoleOutputW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) &dwBufferSize;
   uapsave[3] =
      uap[3] = (LPVOID) &dwBufferCoord;
   uapsave[4] =
      uap[4] = (LPVOID) lpReadRegion;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadConsoleOutputW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 566, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ReadConsoleOutputW( (HANDLE) uap[0],
                                    (PCHAR_INFO) uap[1],
                                   dwBufferSize,
                                   dwBufferCoord,
                                    (PSMALL_RECT) uap[4]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 566, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 567, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadConsoleW( HANDLE hConsoleInput,
                              LPVOID lpBuffer,
                              DWORD nNumberOfCharsToRead,
                              LPDWORD lpNumberOfCharsRead,
                              LPVOID lpReserved
                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadConsoleW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadConsoleW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleInput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfCharsToRead;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfCharsRead;
   uapsave[4] =
      uap[4] = (LPVOID) lpReserved;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadConsoleW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 567, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ReadConsoleW( (HANDLE) uap[0],
                              (LPVOID) uap[1],
                              (DWORD) uap[2],
                              (LPDWORD) uap[3],
                              (LPVOID) uap[4]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 567, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 568, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadDirectoryChangesW( HANDLE hDirectory,
                                       LPVOID lpBuffer,
                                       DWORD nBufferLength,
                                       BOOL bWatchSubtree,
                                       DWORD dwNotifyFilter,
                                       LPDWORD lpBytesReturned,
                                       LPOVERLAPPED lpOverlapped,
                                       LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
                                     )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[8];
   LPVOID uap[8];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadDirectoryChangesW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadDirectoryChangesW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hDirectory;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nBufferLength;
   uapsave[3] =
      uap[3] = (LPVOID) bWatchSubtree;
   uapsave[4] =
      uap[4] = (LPVOID) dwNotifyFilter;
   uapsave[5] =
      uap[5] = (LPVOID) lpBytesReturned;
   uapsave[6] =
      uap[6] = (LPVOID) lpOverlapped;
   uapsave[7] =
      uap[7] = (LPVOID) lpCompletionRoutine;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadDirectoryChangesW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 568, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ReadDirectoryChangesW( (HANDLE) uap[0],
                                       (LPVOID) uap[1],
                                       (DWORD) uap[2],
                                       (BOOL) uap[3],
                                       (DWORD) uap[4],
                                       (LPDWORD) uap[5],
                                       (LPOVERLAPPED) uap[6],
                                       (LPOVERLAPPED_COMPLETION_ROUTINE) uap[7]
                                    );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 568, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 569, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadEventLogA( HANDLE hEventLog,
                               DWORD dwReadFlags,
                               DWORD dwRecordOffset,
                               LPVOID lpBuffer,
                               DWORD nNumberOfBytesToRead,
                               DWORD * pnBytesRead,
                               DWORD * pnMinNumberOfBytesNeeded
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[7];
   LPVOID uap[7];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadEventLogA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadEventLogA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hEventLog;
   uapsave[1] =
      uap[1] = (LPVOID) dwReadFlags;
   uapsave[2] =
      uap[2] = (LPVOID) dwRecordOffset;
   uapsave[3] =
      uap[3] = (LPVOID) lpBuffer;
   uapsave[4] =
      uap[4] = (LPVOID) nNumberOfBytesToRead;
   uapsave[5] =
      uap[5] = (LPVOID) pnBytesRead;
   uapsave[6] =
      uap[6] = (LPVOID) pnMinNumberOfBytesNeeded;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadEventLogA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 569, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[7];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      uapascii[6] = uap[6];
      callRet = ReadEventLogA( (HANDLE) uapascii[0],
                               (DWORD) uapascii[1],
                               (DWORD) uapascii[2],
                               (LPVOID) uapascii[3],
                               (DWORD) uapascii[4],
                               (DWORD *) uapascii[5],
                               (DWORD *) uapascii[6]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 569, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 570, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadEventLogW( HANDLE hEventLog,
                               DWORD dwReadFlags,
                               DWORD dwRecordOffset,
                               LPVOID lpBuffer,
                               DWORD nNumberOfBytesToRead,
                               DWORD * pnBytesRead,
                               DWORD * pnMinNumberOfBytesNeeded
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[7];
   LPVOID uap[7];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadEventLogW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadEventLogW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hEventLog;
   uapsave[1] =
      uap[1] = (LPVOID) dwReadFlags;
   uapsave[2] =
      uap[2] = (LPVOID) dwRecordOffset;
   uapsave[3] =
      uap[3] = (LPVOID) lpBuffer;
   uapsave[4] =
      uap[4] = (LPVOID) nNumberOfBytesToRead;
   uapsave[5] =
      uap[5] = (LPVOID) pnBytesRead;
   uapsave[6] =
      uap[6] = (LPVOID) pnMinNumberOfBytesNeeded;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadEventLogW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 570, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ReadEventLogW( (HANDLE) uap[0],
                               (DWORD) uap[1],
                               (DWORD) uap[2],
                               (LPVOID) uap[3],
                               (DWORD) uap[4],
                               (DWORD *) uap[5],
                               (DWORD *) uap[6]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 570, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 571, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadFile( HANDLE hFile,
                          LPVOID lpBuffer,
                          DWORD nNumberOfBytesToRead,
                          LPDWORD lpNumberOfBytesRead,
                          LPOVERLAPPED lpOverlapped
                        )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadFile"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadFile");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfBytesToRead;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfBytesRead;
   uapsave[4] =
      uap[4] = (LPVOID) lpOverlapped;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadFile"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 571, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = ReadFile( (HANDLE) uapascii[0],
                          (LPVOID) uapascii[1],
                          (DWORD) uapascii[2],
                          (LPDWORD) uapascii[3],
                          (LPOVERLAPPED) uapascii[4]
                       );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 571, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 572, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadFileEx( HANDLE hFile,
                            LPVOID lpBuffer,
                            DWORD nNumberOfBytesToRead,
                            LPOVERLAPPED lpOverlapped,
                            LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadFileEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadFileEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfBytesToRead;
   uapsave[3] =
      uap[3] = (LPVOID) lpOverlapped;
   uapsave[4] =
      uap[4] = (LPVOID) lpCompletionRoutine;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadFileEx"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 572, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = ReadFileEx( (HANDLE) uapascii[0],
                            (LPVOID) uapascii[1],
                            (DWORD) uapascii[2],
                            (LPOVERLAPPED) uapascii[3],
                            (LPOVERLAPPED_COMPLETION_ROUTINE) uapascii[4]
                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 572, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 573, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadFileScatter( HANDLE hFile,
                                 FILE_SEGMENT_ELEMENT aSegmentArray [ ],
                                 DWORD nNumberOfBytesToRead,
                                 LPDWORD lpReserved,
                                 LPOVERLAPPED lpOverlapped
                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadFileScatter"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadFileScatter");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) aSegmentArray;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfBytesToRead;
   uapsave[3] =
      uap[3] = (LPVOID) lpReserved;
   uapsave[4] =
      uap[4] = (LPVOID) lpOverlapped;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadFileScatter"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 573, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = ReadFileScatter( (HANDLE) uapascii[0],
                                 (FILE_SEGMENT_ELEMENT *) uapascii[1],
                                 (DWORD) uapascii[2],
                                 (LPDWORD) uapascii[3],
                                 (LPOVERLAPPED) uapascii[4]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 573, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 574, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReadProcessMemory( HANDLE hProcess,
                                   LPCVOID lpBaseAddress,
                                   LPVOID lpBuffer,
                                   DWORD nSize,
                                   LPDWORD lpNumberOfBytesRead
                                 )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReadProcessMemory"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReadProcessMemory");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) lpBaseAddress;
   uapsave[2] =
      uap[2] = (LPVOID) lpBuffer;
   uapsave[3] =
      uap[3] = (LPVOID) ( nSize * sizeof(pd_char_t) );
   uapsave[4] =
      uap[4] = (LPVOID) lpNumberOfBytesRead;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReadProcessMemory"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 574, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = (LPVOID) nSize;
      uapascii[4] = uap[4];
      callRet = ReadProcessMemory( (HANDLE) uapascii[0],
                                   (LPCVOID) uapascii[1],
                                   (LPVOID) uapascii[2],
                                   (DWORD) uapascii[3],
                                   (LPDWORD) uapascii[4]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 574, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 575, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegCloseKey( HKEY hKey )
{
   LONG callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegCloseKey"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegCloseKey");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegCloseKey"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 575, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = RegCloseKey( (HKEY) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 575, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 576, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegConnectRegistryA( LPCSTR lpMachineName,
                                     HKEY hKey,
                                     PHKEY phkResult
                                   )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegConnectRegistryA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegConnectRegistryA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpMachineName );
   uapsave[1] =
      uap[1] = (LPVOID) hKey;
   uapsave[2] =
      uap[2] = (LPVOID) phkResult;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegConnectRegistryA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 576, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = RegConnectRegistryA( (LPCSTR) uapascii[0],
                                     (HKEY) uapascii[1],
                                     (PHKEY) uapascii[2]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 576, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 577, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegConnectRegistryW( LPCWSTR lpMachineName,
                                     HKEY hKey,
                                     PHKEY phkResult
                                   )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegConnectRegistryW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegConnectRegistryW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpMachineName;
   uapsave[1] =
      uap[1] = (LPVOID) hKey;
   uapsave[2] =
      uap[2] = (LPVOID) phkResult;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegConnectRegistryW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 577, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegConnectRegistryW( (LPCWSTR) uap[0],
                                     (HKEY) uap[1],
                                     (PHKEY) uap[2]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 577, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 578, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegCreateKeyA( HKEY hKey,
                               LPCSTR lpSubKey,
                               PHKEY phkResult
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegCreateKeyA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegCreateKeyA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSubKey );
   uapsave[2] =
      uap[2] = (LPVOID) phkResult;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegCreateKeyA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 578, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      callRet = RegCreateKeyA( (HKEY) uapascii[0],
                               (LPCSTR) uapascii[1],
                               (PHKEY) uapascii[2]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 578, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 579, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegCreateKeyExA( HKEY hKey,
                                 LPCSTR lpSubKey,
                                 DWORD Reserved,
                                 LPSTR lpClass,
                                 DWORD dwOptions,
                                 REGSAM samDesired,
                                 LPSECURITY_ATTRIBUTES lpSecurityAttributes,
                                 PHKEY phkResult,
                                 LPDWORD lpdwDisposition
                               )
{
   LONG callRet = {NULL};
   LPVOID uapsave[9];
   LPVOID uap[9];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegCreateKeyExA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegCreateKeyExA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSubKey );
   uapsave[2] =
      uap[2] = (LPVOID) Reserved;
   uapsave[3] =
      uap[3] = (LPVOID) lpClass;
   uapsave[4] =
      uap[4] = (LPVOID) dwOptions;
   uapsave[5] =
      uap[5] = (LPVOID) samDesired;
   uapsave[6] =
      uap[6] = (LPVOID) lpSecurityAttributes;
   uapsave[7] =
      uap[7] = (LPVOID) phkResult;
   uapsave[8] =
      uap[8] = (LPVOID) lpdwDisposition;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegCreateKeyExA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7],
                  uap[8]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 579, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[9];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      uapascii[6] = uap[6];
      uapascii[7] = uap[7];
      uapascii[8] = uap[8];
      callRet = RegCreateKeyExA( (HKEY) uapascii[0],
                                 (LPCSTR) uapascii[1],
                                 (DWORD) uapascii[2],
                                 (LPSTR) uapascii[3],
                                 (DWORD) uapascii[4],
                                 (REGSAM) uapascii[5],
                                 (LPSECURITY_ATTRIBUTES) uapascii[6],
                                 (PHKEY) uapascii[7],
                                 (LPDWORD) uapascii[8]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 579, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 580, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegCreateKeyExW( HKEY hKey,
                                 LPCWSTR lpSubKey,
                                 DWORD Reserved,
                                 LPWSTR lpClass,
                                 DWORD dwOptions,
                                 REGSAM samDesired,
                                 LPSECURITY_ATTRIBUTES lpSecurityAttributes,
                                 PHKEY phkResult,
                                 LPDWORD lpdwDisposition
                               )
{
   LONG callRet = {NULL};
   LPVOID uapsave[9];
   LPVOID uap[9];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegCreateKeyExW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegCreateKeyExW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpSubKey;
   uapsave[2] =
      uap[2] = (LPVOID) Reserved;
   uapsave[3] =
      uap[3] = (LPVOID) lpClass;
   uapsave[4] =
      uap[4] = (LPVOID) dwOptions;
   uapsave[5] =
      uap[5] = (LPVOID) samDesired;
   uapsave[6] =
      uap[6] = (LPVOID) lpSecurityAttributes;
   uapsave[7] =
      uap[7] = (LPVOID) phkResult;
   uapsave[8] =
      uap[8] = (LPVOID) lpdwDisposition;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegCreateKeyExW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7],
                  uap[8]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 580, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegCreateKeyExW( (HKEY) uap[0],
                                 (LPCWSTR) uap[1],
                                 (DWORD) uap[2],
                                 (LPWSTR) uap[3],
                                 (DWORD) uap[4],
                                 (REGSAM) uap[5],
                                 (LPSECURITY_ATTRIBUTES) uap[6],
                                 (PHKEY) uap[7],
                                 (LPDWORD) uap[8]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 580, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 581, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegCreateKeyW( HKEY hKey,
                               LPCWSTR lpSubKey,
                               PHKEY phkResult
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegCreateKeyW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegCreateKeyW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpSubKey;
   uapsave[2] =
      uap[2] = (LPVOID) phkResult;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegCreateKeyW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 581, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegCreateKeyW( (HKEY) uap[0],
                               (LPCWSTR) uap[1],
                               (PHKEY) uap[2]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 581, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 582, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegDeleteKeyA( HKEY hKey,
                               LPCSTR lpSubKey
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegDeleteKeyA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegDeleteKeyA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSubKey );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegDeleteKeyA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 582, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      callRet = RegDeleteKeyA( (HKEY) uapascii[0],
                               (LPCSTR) uapascii[1]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 582, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 583, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegDeleteKeyW( HKEY hKey,
                               LPCWSTR lpSubKey
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegDeleteKeyW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegDeleteKeyW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpSubKey;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegDeleteKeyW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 583, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegDeleteKeyW( (HKEY) uap[0],
                               (LPCWSTR) uap[1]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 583, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 584, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegDeleteValueA( HKEY hKey,
                                 LPCSTR lpValueName
                               )
{
   LONG callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegDeleteValueA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegDeleteValueA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpValueName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegDeleteValueA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 584, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      callRet = RegDeleteValueA( (HKEY) uapascii[0],
                                 (LPCSTR) uapascii[1]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 584, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 585, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegDeleteValueW( HKEY hKey,
                                 LPCWSTR lpValueName
                               )
{
   LONG callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegDeleteValueW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegDeleteValueW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpValueName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegDeleteValueW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 585, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegDeleteValueW( (HKEY) uap[0],
                                 (LPCWSTR) uap[1]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 585, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 586, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegEnumKeyA( HKEY hKey,
                             DWORD dwIndex,
                             LPSTR lpName,
                             DWORD cbName
                           )
{
   LONG callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegEnumKeyA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegEnumKeyA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) dwIndex;
   uapsave[2] =
      uap[2] = (LPVOID) lpName;
   uapsave[3] =
      uap[3] = (LPVOID) cbName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegEnumKeyA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 586, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = RegEnumKeyA( (HKEY) uapascii[0],
                             (DWORD) uapascii[1],
                             (LPSTR) uapascii[2],
                             (DWORD) uapascii[3]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 586, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 587, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegEnumKeyExA( HKEY hKey,
                               DWORD dwIndex,
                               LPSTR lpName,
                               LPDWORD lpcbName,
                               LPDWORD lpReserved,
                               LPSTR lpClass,
                               LPDWORD lpcbClass,
                               PFILETIME lpftLastWriteTime
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[8];
   LPVOID uap[8];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegEnumKeyExA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegEnumKeyExA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) dwIndex;
   uapsave[2] =
      uap[2] = (LPVOID) lpName;
   uapsave[3] =
      uap[3] = (LPVOID) lpcbName;
   uapsave[4] =
      uap[4] = (LPVOID) lpReserved;
   uapsave[5] =
      uap[5] = (LPVOID) lpClass;
   uapsave[6] =
      uap[6] = (LPVOID) lpcbClass;
   uapsave[7] =
      uap[7] = (LPVOID) lpftLastWriteTime;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegEnumKeyExA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 587, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[8];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      uapascii[6] = uap[6];
      uapascii[7] = uap[7];
      callRet = RegEnumKeyExA( (HKEY) uapascii[0],
                               (DWORD) uapascii[1],
                               (LPSTR) uapascii[2],
                               (LPDWORD) uapascii[3],
                               (LPDWORD) uapascii[4],
                               (LPSTR) uapascii[5],
                               (LPDWORD) uapascii[6],
                               (PFILETIME) uapascii[7]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 587, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 588, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegEnumKeyExW( HKEY hKey,
                               DWORD dwIndex,
                               LPWSTR lpName,
                               LPDWORD lpcbName,
                               LPDWORD lpReserved,
                               LPWSTR lpClass,
                               LPDWORD lpcbClass,
                               PFILETIME lpftLastWriteTime
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[8];
   LPVOID uap[8];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegEnumKeyExW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegEnumKeyExW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) dwIndex;
   uapsave[2] =
      uap[2] = (LPVOID) lpName;
   uapsave[3] =
      uap[3] = (LPVOID) lpcbName;
   uapsave[4] =
      uap[4] = (LPVOID) lpReserved;
   uapsave[5] =
      uap[5] = (LPVOID) lpClass;
   uapsave[6] =
      uap[6] = (LPVOID) lpcbClass;
   uapsave[7] =
      uap[7] = (LPVOID) lpftLastWriteTime;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegEnumKeyExW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 588, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegEnumKeyExW( (HKEY) uap[0],
                               (DWORD) uap[1],
                               (LPWSTR) uap[2],
                               (LPDWORD) uap[3],
                               (LPDWORD) uap[4],
                               (LPWSTR) uap[5],
                               (LPDWORD) uap[6],
                               (PFILETIME) uap[7]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 588, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 589, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegEnumKeyW( HKEY hKey,
                             DWORD dwIndex,
                             LPWSTR lpName,
                             DWORD cbName
                           )
{
   LONG callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegEnumKeyW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegEnumKeyW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) dwIndex;
   uapsave[2] =
      uap[2] = (LPVOID) lpName;
   uapsave[3] =
      uap[3] = (LPVOID) cbName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegEnumKeyW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 589, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegEnumKeyW( (HKEY) uap[0],
                             (DWORD) uap[1],
                             (LPWSTR) uap[2],
                             (DWORD) uap[3]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 589, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 590, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegEnumValueA( HKEY hKey,
                               DWORD dwIndex,
                               LPSTR lpValueName,
                               LPDWORD lpcbValueName,
                               LPDWORD lpReserved,
                               LPDWORD lpType,
                               LPBYTE lpData,
                               LPDWORD lpcbData
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[8];
   LPVOID uap[8];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegEnumValueA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegEnumValueA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) dwIndex;
   uapsave[2] =
      uap[2] = (LPVOID) lpValueName;
   uapsave[3] =
      uap[3] = (LPVOID) lpcbValueName;
   uapsave[4] =
      uap[4] = (LPVOID) lpReserved;
   uapsave[5] =
      uap[5] = (LPVOID) lpType;
   uapsave[6] =
      uap[6] = (LPVOID) lpData;
   uapsave[7] =
      uap[7] = (LPVOID) lpcbData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegEnumValueA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 590, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[8];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      uapascii[6] = uap[6];
      uapascii[7] = uap[7];
      callRet = RegEnumValueA( (HKEY) uapascii[0],
                               (DWORD) uapascii[1],
                               (LPSTR) uapascii[2],
                               (LPDWORD) uapascii[3],
                               (LPDWORD) uapascii[4],
                               (LPDWORD) uapascii[5],
                               (LPBYTE) uapascii[6],
                               (LPDWORD) uapascii[7]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 590, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 591, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegEnumValueW( HKEY hKey,
                               DWORD dwIndex,
                               LPWSTR lpValueName,
                               LPDWORD lpcbValueName,
                               LPDWORD lpReserved,
                               LPDWORD lpType,
                               LPBYTE lpData,
                               LPDWORD lpcbData
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[8];
   LPVOID uap[8];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegEnumValueW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegEnumValueW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) dwIndex;
   uapsave[2] =
      uap[2] = (LPVOID) lpValueName;
   uapsave[3] =
      uap[3] = (LPVOID) lpcbValueName;
   uapsave[4] =
      uap[4] = (LPVOID) lpReserved;
   uapsave[5] =
      uap[5] = (LPVOID) lpType;
   uapsave[6] =
      uap[6] = (LPVOID) lpData;
   uapsave[7] =
      uap[7] = (LPVOID) lpcbData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegEnumValueW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 591, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegEnumValueW( (HKEY) uap[0],
                               (DWORD) uap[1],
                               (LPWSTR) uap[2],
                               (LPDWORD) uap[3],
                               (LPDWORD) uap[4],
                               (LPDWORD) uap[5],
                               (LPBYTE) uap[6],
                               (LPDWORD) uap[7]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 591, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 592, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegFlushKey( HKEY hKey )
{
   LONG callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegFlushKey"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegFlushKey");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegFlushKey"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 592, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = RegFlushKey( (HKEY) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 592, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 593, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegGetKeySecurity( HKEY hKey,
                                   SECURITY_INFORMATION SecurityInformation,
                                   PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                   LPDWORD lpcbSecurityDescriptor
                                 )
{
   LONG callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegGetKeySecurity"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegGetKeySecurity");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) SecurityInformation;
   uapsave[2] =
      uap[2] = (LPVOID) pSecurityDescriptor;
   uapsave[3] =
      uap[3] = (LPVOID) lpcbSecurityDescriptor;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegGetKeySecurity"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 593, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = RegGetKeySecurity( (HKEY) uapascii[0],
                                   (SECURITY_INFORMATION) uapascii[1],
                                   (PSECURITY_DESCRIPTOR) uapascii[2],
                                   (LPDWORD) uapascii[3]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 593, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 594, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegLoadKeyA( HKEY hKey,
                             LPCSTR lpSubKey,
                             LPCSTR lpFile
                           )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegLoadKeyA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegLoadKeyA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSubKey );
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpFile );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegLoadKeyA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 594, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      callRet = RegLoadKeyA( (HKEY) uapascii[0],
                             (LPCSTR) uapascii[1],
                             (LPCSTR) uapascii[2]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );
      if( uapascii[2] )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 594, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );
   if( uapsave[2] )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 595, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegLoadKeyW( HKEY hKey,
                             LPCWSTR lpSubKey,
                             LPCWSTR lpFile
                           )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegLoadKeyW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegLoadKeyW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpSubKey;
   uapsave[2] =
      uap[2] = (LPVOID) lpFile;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegLoadKeyW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 595, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegLoadKeyW( (HKEY) uap[0],
                             (LPCWSTR) uap[1],
                             (LPCWSTR) uap[2]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 595, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 596, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegNotifyChangeKeyValue( HKEY hKey,
                                         BOOL bWatchSubtree,
                                         DWORD dwNotifyFilter,
                                         HANDLE hEvent,
                                         BOOL fAsynchronus
                                       )
{
   LONG callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegNotifyChangeKeyValue"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegNotifyChangeKeyValue");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) bWatchSubtree;
   uapsave[2] =
      uap[2] = (LPVOID) dwNotifyFilter;
   uapsave[3] =
      uap[3] = (LPVOID) hEvent;
   uapsave[4] =
      uap[4] = (LPVOID) fAsynchronus;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegNotifyChangeKeyValue"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 596, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = RegNotifyChangeKeyValue( (HKEY) uapascii[0],
                                         (BOOL) uapascii[1],
                                         (DWORD) uapascii[2],
                                         (HANDLE) uapascii[3],
                                         (BOOL) uapascii[4]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 596, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 597, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegOpenKeyA( HKEY hKey,
                             LPCSTR lpSubKey,
                             PHKEY phkResult
                           )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegOpenKeyA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegOpenKeyA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSubKey );
   uapsave[2] =
      uap[2] = (LPVOID) phkResult;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegOpenKeyA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 597, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      callRet = RegOpenKeyA( (HKEY) uapascii[0],
                             (LPCSTR) uapascii[1],
                             (PHKEY) uapascii[2]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 597, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 598, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegOpenKeyExA( HKEY hKey,
                               LPCSTR lpSubKey,
                               DWORD ulOptions,
                               REGSAM samDesired,
                               PHKEY phkResult
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegOpenKeyExA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegOpenKeyExA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSubKey );
   uapsave[2] =
      uap[2] = (LPVOID) ulOptions;
   uapsave[3] =
      uap[3] = (LPVOID) samDesired;
   uapsave[4] =
      uap[4] = (LPVOID) phkResult;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegOpenKeyExA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 598, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = RegOpenKeyExA( (HKEY) uapascii[0],
                               (LPCSTR) uapascii[1],
                               (DWORD) uapascii[2],
                               (REGSAM) uapascii[3],
                               (PHKEY) uapascii[4]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 598, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 599, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegOpenKeyExW( HKEY hKey,
                               LPCWSTR lpSubKey,
                               DWORD ulOptions,
                               REGSAM samDesired,
                               PHKEY phkResult
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegOpenKeyExW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegOpenKeyExW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpSubKey;
   uapsave[2] =
      uap[2] = (LPVOID) ulOptions;
   uapsave[3] =
      uap[3] = (LPVOID) samDesired;
   uapsave[4] =
      uap[4] = (LPVOID) phkResult;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegOpenKeyExW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 599, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegOpenKeyExW( (HKEY) uap[0],
                               (LPCWSTR) uap[1],
                               (DWORD) uap[2],
                               (REGSAM) uap[3],
                               (PHKEY) uap[4]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 599, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 600, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegOpenKeyW( HKEY hKey,
                             LPCWSTR lpSubKey,
                             PHKEY phkResult
                           )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegOpenKeyW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegOpenKeyW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpSubKey;
   uapsave[2] =
      uap[2] = (LPVOID) phkResult;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegOpenKeyW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 600, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegOpenKeyW( (HKEY) uap[0],
                             (LPCWSTR) uap[1],
                             (PHKEY) uap[2]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 600, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 601, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegQueryInfoKeyA( HKEY hKey,
                                  LPSTR lpClass,
                                  LPDWORD lpcbClass,
                                  LPDWORD lpReserved,
                                  LPDWORD lpcSubKeys,
                                  LPDWORD lpcbMaxSubKeyLen,
                                  LPDWORD lpcbMaxClassLen,
                                  LPDWORD lpcValues,
                                  LPDWORD lpcbMaxValueNameLen,
                                  LPDWORD lpcbMaxValueLen,
                                  LPDWORD lpcbSecurityDescriptor,
                                  PFILETIME lpftLastWriteTime
                                )
{
   LONG callRet = {NULL};
   LPVOID uapsave[12];
   LPVOID uap[12];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegQueryInfoKeyA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegQueryInfoKeyA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpClass;
   uapsave[2] =
      uap[2] = (LPVOID) lpcbClass;
   uapsave[3] =
      uap[3] = (LPVOID) lpReserved;
   uapsave[4] =
      uap[4] = (LPVOID) lpcSubKeys;
   uapsave[5] =
      uap[5] = (LPVOID) lpcbMaxSubKeyLen;
   uapsave[6] =
      uap[6] = (LPVOID) lpcbMaxClassLen;
   uapsave[7] =
      uap[7] = (LPVOID) lpcValues;
   uapsave[8] =
      uap[8] = (LPVOID) lpcbMaxValueNameLen;
   uapsave[9] =
      uap[9] = (LPVOID) lpcbMaxValueLen;
   uapsave[10] =
      uap[10] = (LPVOID) lpcbSecurityDescriptor;
   uapsave[11] =
      uap[11] = (LPVOID) lpftLastWriteTime;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegQueryInfoKeyA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7],
                  uap[8],
                  uap[9],
                  uap[10],
                  uap[11]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 601, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[12];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      uapascii[6] = uap[6];
      uapascii[7] = uap[7];
      uapascii[8] = uap[8];
      uapascii[9] = uap[9];
      uapascii[10] = uap[10];
      uapascii[11] = uap[11];
      callRet = RegQueryInfoKeyA( (HKEY) uapascii[0],
                                  (LPSTR) uapascii[1],
                                  (LPDWORD) uapascii[2],
                                  (LPDWORD) uapascii[3],
                                  (LPDWORD) uapascii[4],
                                  (LPDWORD) uapascii[5],
                                  (LPDWORD) uapascii[6],
                                  (LPDWORD) uapascii[7],
                                  (LPDWORD) uapascii[8],
                                  (LPDWORD) uapascii[9],
                                  (LPDWORD) uapascii[10],
                                  (PFILETIME) uapascii[11]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 601, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 602, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegQueryInfoKeyW( HKEY hKey,
                                  LPWSTR lpClass,
                                  LPDWORD lpcbClass,
                                  LPDWORD lpReserved,
                                  LPDWORD lpcSubKeys,
                                  LPDWORD lpcbMaxSubKeyLen,
                                  LPDWORD lpcbMaxClassLen,
                                  LPDWORD lpcValues,
                                  LPDWORD lpcbMaxValueNameLen,
                                  LPDWORD lpcbMaxValueLen,
                                  LPDWORD lpcbSecurityDescriptor,
                                  PFILETIME lpftLastWriteTime
                                )
{
   LONG callRet = {NULL};
   LPVOID uapsave[12];
   LPVOID uap[12];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegQueryInfoKeyW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegQueryInfoKeyW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpClass;
   uapsave[2] =
      uap[2] = (LPVOID) lpcbClass;
   uapsave[3] =
      uap[3] = (LPVOID) lpReserved;
   uapsave[4] =
      uap[4] = (LPVOID) lpcSubKeys;
   uapsave[5] =
      uap[5] = (LPVOID) lpcbMaxSubKeyLen;
   uapsave[6] =
      uap[6] = (LPVOID) lpcbMaxClassLen;
   uapsave[7] =
      uap[7] = (LPVOID) lpcValues;
   uapsave[8] =
      uap[8] = (LPVOID) lpcbMaxValueNameLen;
   uapsave[9] =
      uap[9] = (LPVOID) lpcbMaxValueLen;
   uapsave[10] =
      uap[10] = (LPVOID) lpcbSecurityDescriptor;
   uapsave[11] =
      uap[11] = (LPVOID) lpftLastWriteTime;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegQueryInfoKeyW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7],
                  uap[8],
                  uap[9],
                  uap[10],
                  uap[11]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 602, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegQueryInfoKeyW( (HKEY) uap[0],
                                  (LPWSTR) uap[1],
                                  (LPDWORD) uap[2],
                                  (LPDWORD) uap[3],
                                  (LPDWORD) uap[4],
                                  (LPDWORD) uap[5],
                                  (LPDWORD) uap[6],
                                  (LPDWORD) uap[7],
                                  (LPDWORD) uap[8],
                                  (LPDWORD) uap[9],
                                  (LPDWORD) uap[10],
                                  (PFILETIME) uap[11]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 602, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 603, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegQueryMultipleValuesA( HKEY hKey,
                                         PVALENTA val_list,
                                         DWORD num_vals,
                                         LPSTR lpValueBuf,
                                         LPDWORD ldwTotsize
                                       )
{
   LONG callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegQueryMultipleValuesA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegQueryMultipleValuesA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) val_list;
   uapsave[2] =
      uap[2] = (LPVOID) num_vals;
   uapsave[3] =
      uap[3] = (LPVOID) lpValueBuf;
   uapsave[4] =
      uap[4] = (LPVOID) ldwTotsize;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegQueryMultipleValuesA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 603, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = RegQueryMultipleValuesA( (HKEY) uapascii[0],
                                         (PVALENTA) uapascii[1],
                                         (DWORD) uapascii[2],
                                         (LPSTR) uapascii[3],
                                         (LPDWORD) uapascii[4]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 603, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 604, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegQueryMultipleValuesW( HKEY hKey,
                                         PVALENTW val_list,
                                         DWORD num_vals,
                                         LPWSTR lpValueBuf,
                                         LPDWORD ldwTotsize
                                       )
{
   LONG callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegQueryMultipleValuesW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegQueryMultipleValuesW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) val_list;
   uapsave[2] =
      uap[2] = (LPVOID) num_vals;
   uapsave[3] =
      uap[3] = (LPVOID) lpValueBuf;
   uapsave[4] =
      uap[4] = (LPVOID) ldwTotsize;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegQueryMultipleValuesW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 604, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegQueryMultipleValuesW( (HKEY) uap[0],
                                         (PVALENTW) uap[1],
                                         (DWORD) uap[2],
                                         (LPWSTR) uap[3],
                                         (LPDWORD) uap[4]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 604, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 605, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegQueryValueA( HKEY hKey,
                                LPCSTR lpSubKey,
                                LPSTR lpValue,
                                PLONG lpcbValue
                              )
{
   LONG callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegQueryValueA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegQueryValueA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSubKey );
   uapsave[2] =
      uap[2] = (LPVOID) lpValue;
   uapsave[3] =
      uap[3] = (LPVOID) lpcbValue;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegQueryValueA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 605, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = RegQueryValueA( (HKEY) uapascii[0],
                                (LPCSTR) uapascii[1],
                                (LPSTR) uapascii[2],
                                (PLONG) uapascii[3]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 605, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 606, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegQueryValueExA( HKEY hKey,
                                  LPCSTR lpValueName,
                                  LPDWORD lpReserved,
                                  LPDWORD lpType,
                                  LPBYTE lpData,
                                  LPDWORD lpcbData
                                )
{
   LONG callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegQueryValueExA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegQueryValueExA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpValueName );
   uapsave[2] =
      uap[2] = (LPVOID) lpReserved;
   uapsave[3] =
      uap[3] = (LPVOID) lpType;
   uapsave[4] =
      uap[4] = (LPVOID) lpData;
   uapsave[5] =
      uap[5] = (LPVOID) lpcbData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegQueryValueExA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 606, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[6];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      callRet = RegQueryValueExA( (HKEY) uapascii[0],
                                  (LPCSTR) uapascii[1],
                                  (LPDWORD) uapascii[2],
                                  (LPDWORD) uapascii[3],
                                  (LPBYTE) uapascii[4],
                                  (LPDWORD) uapascii[5]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 606, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 607, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegQueryValueExW( HKEY hKey,
                                  LPCWSTR lpValueName,
                                  LPDWORD lpReserved,
                                  LPDWORD lpType,
                                  LPBYTE lpData,
                                  LPDWORD lpcbData
                                )
{
   LONG callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegQueryValueExW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegQueryValueExW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpValueName;
   uapsave[2] =
      uap[2] = (LPVOID) lpReserved;
   uapsave[3] =
      uap[3] = (LPVOID) lpType;
   uapsave[4] =
      uap[4] = (LPVOID) lpData;
   uapsave[5] =
      uap[5] = (LPVOID) lpcbData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegQueryValueExW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 607, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegQueryValueExW( (HKEY) uap[0],
                                  (LPCWSTR) uap[1],
                                  (LPDWORD) uap[2],
                                  (LPDWORD) uap[3],
                                  (LPBYTE) uap[4],
                                  (LPDWORD) uap[5]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 607, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 608, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegQueryValueW( HKEY hKey,
                                LPCWSTR lpSubKey,
                                LPWSTR lpValue,
                                PLONG lpcbValue
                              )
{
   LONG callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegQueryValueW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegQueryValueW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpSubKey;
   uapsave[2] =
      uap[2] = (LPVOID) lpValue;
   uapsave[3] =
      uap[3] = (LPVOID) lpcbValue;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegQueryValueW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 608, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegQueryValueW( (HKEY) uap[0],
                                (LPCWSTR) uap[1],
                                (LPWSTR) uap[2],
                                (PLONG) uap[3]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 608, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 609, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegReplaceKeyA( HKEY hKey,
                                LPCSTR lpSubKey,
                                LPCSTR lpNewFile,
                                LPCSTR lpOldFile
                              )
{
   LONG callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegReplaceKeyA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegReplaceKeyA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSubKey );
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpNewFile );
   uapsave[3] =
      uap[3] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpOldFile );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegReplaceKeyA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2],
                  uap[3],
                  (LPCWSTR) uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 609, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      uapascii[3] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[3] );
      callRet = RegReplaceKeyA( (HKEY) uapascii[0],
                                (LPCSTR) uapascii[1],
                                (LPCSTR) uapascii[2],
                                (LPCSTR) uapascii[3]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );
      if( uapascii[2] )
         free( (PVOID)uapascii[2] );
      if( uapascii[3] )
         free( (PVOID)uapascii[3] );

      retval = hook->callDispatchPost( /*space*/ 0, 609, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );
   if( uapsave[2] )
      free( (PVOID)uapsave[2] );
   if( uapsave[3] )
      free( (PVOID)uapsave[3] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 610, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegReplaceKeyW( HKEY hKey,
                                LPCWSTR lpSubKey,
                                LPCWSTR lpNewFile,
                                LPCWSTR lpOldFile
                              )
{
   LONG callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegReplaceKeyW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegReplaceKeyW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpSubKey;
   uapsave[2] =
      uap[2] = (LPVOID) lpNewFile;
   uapsave[3] =
      uap[3] = (LPVOID) lpOldFile;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegReplaceKeyW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2],
                  uap[3],
                  (LPCWSTR) uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 610, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegReplaceKeyW( (HKEY) uap[0],
                                (LPCWSTR) uap[1],
                                (LPCWSTR) uap[2],
                                (LPCWSTR) uap[3]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 610, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 611, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegRestoreKeyA( HKEY hKey,
                                LPCSTR lpFile,
                                DWORD dwFlags
                              )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegRestoreKeyA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegRestoreKeyA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpFile );
   uapsave[2] =
      uap[2] = (LPVOID) dwFlags;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegRestoreKeyA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 611, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      callRet = RegRestoreKeyA( (HKEY) uapascii[0],
                                (LPCSTR) uapascii[1],
                                (DWORD) uapascii[2]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 611, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 612, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegRestoreKeyW( HKEY hKey,
                                LPCWSTR lpFile,
                                DWORD dwFlags
                              )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegRestoreKeyW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegRestoreKeyW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpFile;
   uapsave[2] =
      uap[2] = (LPVOID) dwFlags;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegRestoreKeyW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 612, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegRestoreKeyW( (HKEY) uap[0],
                                (LPCWSTR) uap[1],
                                (DWORD) uap[2]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 612, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 613, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegSaveKeyA( HKEY hKey,
                             LPCSTR lpFile,
                             LPSECURITY_ATTRIBUTES lpSecurityAttributes
                           )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegSaveKeyA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegSaveKeyA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpFile );
   uapsave[2] =
      uap[2] = (LPVOID) lpSecurityAttributes;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegSaveKeyA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 613, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      callRet = RegSaveKeyA( (HKEY) uapascii[0],
                             (LPCSTR) uapascii[1],
                             (LPSECURITY_ATTRIBUTES) uapascii[2]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 613, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 614, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegSaveKeyW( HKEY hKey,
                             LPCWSTR lpFile,
                             LPSECURITY_ATTRIBUTES lpSecurityAttributes
                           )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegSaveKeyW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegSaveKeyW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpFile;
   uapsave[2] =
      uap[2] = (LPVOID) lpSecurityAttributes;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegSaveKeyW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 614, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegSaveKeyW( (HKEY) uap[0],
                             (LPCWSTR) uap[1],
                             (LPSECURITY_ATTRIBUTES) uap[2]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 614, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 615, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegSetKeySecurity( HKEY hKey,
                                   SECURITY_INFORMATION SecurityInformation,
                                   PSECURITY_DESCRIPTOR pSecurityDescriptor
                                 )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegSetKeySecurity"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegSetKeySecurity");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) SecurityInformation;
   uapsave[2] =
      uap[2] = (LPVOID) pSecurityDescriptor;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegSetKeySecurity"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 615, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = RegSetKeySecurity( (HKEY) uapascii[0],
                                   (SECURITY_INFORMATION) uapascii[1],
                                   (PSECURITY_DESCRIPTOR) uapascii[2]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 615, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 616, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegSetValueA( HKEY hKey,
                              LPCSTR lpSubKey,
                              DWORD dwType,
                              LPCSTR lpData,
                              DWORD cbData
                            )
{
   LONG callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegSetValueA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegSetValueA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSubKey );
   uapsave[2] =
      uap[2] = (LPVOID) dwType;
   uapsave[3] =
      uap[3] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpData );
   uapsave[4] =
      uap[4] = (LPVOID) cbData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegSetValueA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  (LPCWSTR) uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 616, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      uapascii[3] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[3] );
      uapascii[4] = uap[4];
      callRet = RegSetValueA( (HKEY) uapascii[0],
                              (LPCSTR) uapascii[1],
                              (DWORD) uapascii[2],
                              (LPCSTR) uapascii[3],
                              (DWORD) uapascii[4]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );
      if( uapascii[3] )
         free( (PVOID)uapascii[3] );

      retval = hook->callDispatchPost( /*space*/ 0, 616, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );
   if( uapsave[3] )
      free( (PVOID)uapsave[3] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 617, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegSetValueExA( HKEY hKey,
                                LPCSTR lpValueName,
                                DWORD Reserved,
                                DWORD dwType,
                                const BYTE * lpData,
                                DWORD cbData
                              )
{
   LONG callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegSetValueExA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegSetValueExA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpValueName );
   uapsave[2] =
      uap[2] = (LPVOID) Reserved;
   uapsave[3] =
      uap[3] = (LPVOID) dwType;
   uapsave[4] =
      uap[4] = (LPVOID) lpData;
   uapsave[5] =
      uap[5] = (LPVOID) cbData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegSetValueExA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 617, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[6];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      callRet = RegSetValueExA( (HKEY) uapascii[0],
                                (LPCSTR) uapascii[1],
                                (DWORD) uapascii[2],
                                (DWORD) uapascii[3],
                                (const BYTE *) uapascii[4],
                                (DWORD) uapascii[5]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 617, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 618, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegSetValueExW( HKEY hKey,
                                LPCWSTR lpValueName,
                                DWORD Reserved,
                                DWORD dwType,
                                const BYTE * lpData,
                                DWORD cbData
                              )
{
   LONG callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegSetValueExW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegSetValueExW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpValueName;
   uapsave[2] =
      uap[2] = (LPVOID) Reserved;
   uapsave[3] =
      uap[3] = (LPVOID) dwType;
   uapsave[4] =
      uap[4] = (LPVOID) lpData;
   uapsave[5] =
      uap[5] = (LPVOID) cbData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegSetValueExW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 618, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegSetValueExW( (HKEY) uap[0],
                                (LPCWSTR) uap[1],
                                (DWORD) uap[2],
                                (DWORD) uap[3],
                                (const BYTE *) uap[4],
                                (DWORD) uap[5]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 618, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 619, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegSetValueW( HKEY hKey,
                              LPCWSTR lpSubKey,
                              DWORD dwType,
                              LPCWSTR lpData,
                              DWORD cbData
                            )
{
   LONG callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegSetValueW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegSetValueW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpSubKey;
   uapsave[2] =
      uap[2] = (LPVOID) dwType;
   uapsave[3] =
      uap[3] = (LPVOID) lpData;
   uapsave[4] =
      uap[4] = (LPVOID) cbData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegSetValueW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  (LPCWSTR) uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 619, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegSetValueW( (HKEY) uap[0],
                              (LPCWSTR) uap[1],
                              (DWORD) uap[2],
                              (LPCWSTR) uap[3],
                              (DWORD) uap[4]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 619, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 620, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegUnLoadKeyA( HKEY hKey,
                               LPCSTR lpSubKey
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegUnLoadKeyA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegUnLoadKeyA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSubKey );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegUnLoadKeyA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 620, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      callRet = RegUnLoadKeyA( (HKEY) uapascii[0],
                               (LPCSTR) uapascii[1]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 620, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 621, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_RegUnLoadKeyW( HKEY hKey,
                               LPCWSTR lpSubKey
                             )
{
   LONG callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegUnLoadKeyW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegUnLoadKeyW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hKey;
   uapsave[1] =
      uap[1] = (LPVOID) lpSubKey;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("RegUnLoadKeyW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 621, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegUnLoadKeyW( (HKEY) uap[0],
                               (LPCWSTR) uap[1]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 621, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 622, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_RegisterEventSourceA( LPCSTR lpUNCServerName,
                                        LPCSTR lpSourceName
                                      )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegisterEventSourceA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegisterEventSourceA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpUNCServerName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpSourceName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("RegisterEventSourceA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 622, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      callRet = RegisterEventSourceA( (LPCSTR) uapascii[0],
                                      (LPCSTR) uapascii[1]
                                   );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 622, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 623, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HANDLE WINAPI LWM_RegisterEventSourceW( LPCWSTR lpUNCServerName,
                                        LPCWSTR lpSourceName
                                      )
{
   HANDLE callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegisterEventSourceW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegisterEventSourceW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpUNCServerName;
   uapsave[1] =
      uap[1] = (LPVOID) lpSourceName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("HANDLE"),
                  PD_MAKESTR("RegisterEventSourceW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 623, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegisterEventSourceW( (LPCWSTR) uap[0],
                                      (LPCWSTR) uap[1]
                                   );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 623, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 624, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

SERVICE_STATUS_HANDLE WINAPI LWM_RegisterServiceCtrlHandlerA( LPCSTR lpServiceName,
                                                              LPHANDLER_FUNCTION lpHandlerProc
                                                            )
{
   SERVICE_STATUS_HANDLE callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegisterServiceCtrlHandlerA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegisterServiceCtrlHandlerA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpServiceName );
   uapsave[1] =
      uap[1] = (LPVOID) lpHandlerProc;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("SERVICE_STATUS_HANDLE"),
                  PD_MAKESTR("RegisterServiceCtrlHandlerA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 624, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      callRet = RegisterServiceCtrlHandlerA( (LPCSTR) uapascii[0],
                                             (LPHANDLER_FUNCTION) uapascii[1]
                                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 624, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 625, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

SERVICE_STATUS_HANDLE WINAPI LWM_RegisterServiceCtrlHandlerW( LPCWSTR lpServiceName,
                                                              LPHANDLER_FUNCTION lpHandlerProc
                                                            )
{
   SERVICE_STATUS_HANDLE callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RegisterServiceCtrlHandlerW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RegisterServiceCtrlHandlerW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpServiceName;
   uapsave[1] =
      uap[1] = (LPVOID) lpHandlerProc;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("SERVICE_STATUS_HANDLE"),
                  PD_MAKESTR("RegisterServiceCtrlHandlerW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 625, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RegisterServiceCtrlHandlerW( (LPCWSTR) uap[0],
                                             (LPHANDLER_FUNCTION) uap[1]
                                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 625, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 626, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReleaseMutex( HANDLE hMutex )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReleaseMutex"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReleaseMutex");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hMutex;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReleaseMutex"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 626, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = ReleaseMutex( (HANDLE) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 626, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 627, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReleaseSemaphore( HANDLE hSemaphore,
                                  LONG lReleaseCount,
                                  LPLONG lpPreviousCount
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReleaseSemaphore"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReleaseSemaphore");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hSemaphore;
   uapsave[1] =
      uap[1] = (LPVOID) lReleaseCount;
   uapsave[2] =
      uap[2] = (LPVOID) lpPreviousCount;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReleaseSemaphore"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 627, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = ReleaseSemaphore( (HANDLE) uapascii[0],
                                  (LONG) uapascii[1],
                                  (LPLONG) uapascii[2]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 627, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 628, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_RemoveDirectoryA( LPCSTR lpPathName )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RemoveDirectoryA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RemoveDirectoryA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpPathName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("RemoveDirectoryA"),
                  uap[0],
                  (LPCWSTR) uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 628, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      callRet = RemoveDirectoryA( (LPCSTR) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 628, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 629, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_RemoveDirectoryW( LPCWSTR lpPathName )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RemoveDirectoryW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RemoveDirectoryW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpPathName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("RemoveDirectoryW"),
                  uap[0],
                  (LPCWSTR) uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 629, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RemoveDirectoryW( (LPCWSTR) uap[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 629, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 630, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReportEventA( HANDLE hEventLog,
                              WORD wType,
                              WORD wCategory,
                              DWORD dwEventID,
                              PSID lpUserSid,
                              WORD wNumStrings,
                              DWORD dwDataSize,
                              LPCSTR * lpStrings,
                              LPVOID lpRawData
                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[9];
   LPVOID uap[9];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReportEventA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReportEventA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hEventLog;
   uapsave[1] =
      uap[1] = (LPVOID) wType;
   uapsave[2] =
      uap[2] = (LPVOID) wCategory;
   uapsave[3] =
      uap[3] = (LPVOID) dwEventID;
   uapsave[4] =
      uap[4] = (LPVOID) lpUserSid;
   uapsave[5] =
      uap[5] = (LPVOID) wNumStrings;
   uapsave[6] =
      uap[6] = (LPVOID) dwDataSize;
   uapsave[7] =
      uap[7] = (LPVOID) lpStrings;
   uapsave[8] =
      uap[8] = (LPVOID) lpRawData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReportEventA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7],
                  uap[8]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 630, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[9];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      uapascii[6] = uap[6];
      uapascii[7] = uap[7];
      uapascii[8] = uap[8];
      callRet = ReportEventA( (HANDLE) uapascii[0],
                              (WORD) uapascii[1],
                              (WORD) uapascii[2],
                              (DWORD) uapascii[3],
                              (PSID) uapascii[4],
                              (WORD) uapascii[5],
                              (DWORD) uapascii[6],
                              (LPCSTR *) uapascii[7],
                              (LPVOID) uapascii[8]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 630, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 631, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ReportEventW( HANDLE hEventLog,
                              WORD wType,
                              WORD wCategory,
                              DWORD dwEventID,
                              PSID lpUserSid,
                              WORD wNumStrings,
                              DWORD dwDataSize,
                              LPCWSTR * lpStrings,
                              LPVOID lpRawData
                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[9];
   LPVOID uap[9];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ReportEventW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ReportEventW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hEventLog;
   uapsave[1] =
      uap[1] = (LPVOID) wType;
   uapsave[2] =
      uap[2] = (LPVOID) wCategory;
   uapsave[3] =
      uap[3] = (LPVOID) dwEventID;
   uapsave[4] =
      uap[4] = (LPVOID) lpUserSid;
   uapsave[5] =
      uap[5] = (LPVOID) wNumStrings;
   uapsave[6] =
      uap[6] = (LPVOID) dwDataSize;
   uapsave[7] =
      uap[7] = (LPVOID) lpStrings;
   uapsave[8] =
      uap[8] = (LPVOID) lpRawData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ReportEventW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  uap[7],
                  uap[8]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 631, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ReportEventW( (HANDLE) uap[0],
                              (WORD) uap[1],
                              (WORD) uap[2],
                              (DWORD) uap[3],
                              (PSID) uap[4],
                              (WORD) uap[5],
                              (DWORD) uap[6],
                              (LPCWSTR *) uap[7],
                              (LPVOID) uap[8]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 631, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 632, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ResetEvent( HANDLE hEvent )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ResetEvent"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ResetEvent");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hEvent;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ResetEvent"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 632, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = ResetEvent( (HANDLE) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 632, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 633, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_ResumeThread( HANDLE hThread )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ResumeThread"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ResumeThread");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hThread;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("ResumeThread"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 633, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = ResumeThread( (HANDLE) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 633, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 634, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_RevertToSelf( void )
{
   BOOL callRet = {NULL};
   LPVOID *uap = NULL;

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("RevertToSelf"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("RevertToSelf");
      hook = &(*hookIterator).second;
   }

   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s()"), g_tracecount++,
                  PD_MAKESTR("BOOL"), PD_MAKESTR("RevertToSelf") );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 634, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = RevertToSelf();

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 634, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ScrollConsoleScreenBufferA( HANDLE hConsoleOutput,
                                            const SMALL_RECT * lpScrollRectangle,
                                            const SMALL_RECT * lpClipRectangle,
                                            COORD dwDestinationOrigin,
                                            const CHAR_INFO * lpFill
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ScrollConsoleScreenBufferA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ScrollConsoleScreenBufferA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpScrollRectangle;
   uapsave[2] =
      uap[2] = (LPVOID) lpClipRectangle;
   uapsave[3] =
      uap[3] = (LPVOID) &dwDestinationOrigin;
   uapsave[4] =
      uap[4] = (LPVOID) lpFill;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ScrollConsoleScreenBufferA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 635, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = ScrollConsoleScreenBufferA( (HANDLE) uapascii[0],
                                            (const SMALL_RECT *) uapascii[1],
                                            (const SMALL_RECT *) uapascii[2],
                                           dwDestinationOrigin,
                                            (const CHAR_INFO *) uapascii[4]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 635, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 636, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_ScrollConsoleScreenBufferW( HANDLE hConsoleOutput,
                                            const SMALL_RECT * lpScrollRectangle,
                                            const SMALL_RECT * lpClipRectangle,
                                            COORD dwDestinationOrigin,
                                            const CHAR_INFO * lpFill
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("ScrollConsoleScreenBufferW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("ScrollConsoleScreenBufferW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpScrollRectangle;
   uapsave[2] =
      uap[2] = (LPVOID) lpClipRectangle;
   uapsave[3] =
      uap[3] = (LPVOID) &dwDestinationOrigin;
   uapsave[4] =
      uap[4] = (LPVOID) lpFill;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("ScrollConsoleScreenBufferW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 636, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = ScrollConsoleScreenBufferW( (HANDLE) uap[0],
                                            (const SMALL_RECT *) uap[1],
                                            (const SMALL_RECT *) uap[2],
                                           dwDestinationOrigin,
                                            (const CHAR_INFO *) uap[4]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 636, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 637, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_SearchPathA( LPCSTR lpPath,
                              LPCSTR lpFileName,
                              LPCSTR lpExtension,
                              DWORD nBufferLength,
                              LPSTR lpBuffer,
                              LPSTR * lpFilePart
                            )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SearchPathA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SearchPathA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpPath );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpFileName );
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpExtension );
   uapsave[3] =
      uap[3] = (LPVOID) ( nBufferLength * sizeof(pd_char_t) );
   uapsave[4] =
      uap[4] = (LPVOID) ((lpBuffer==NULL)?NULL:((nBufferLength>0)?malloc(nBufferLength * sizeof(pd_char_t)):lpBuffer));
   uapsave[5] =
      uap[5] = (LPVOID) lpFilePart;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("SearchPathA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 637, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );

   DWORD lpFilePart__offset = 0;

   if( !retval )
   {
      LPVOID uapascii[6];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      uapascii[3] = (LPVOID) nBufferLength;
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      callRet = SearchPathA( (LPCSTR) uapascii[0],
                             (LPCSTR) uapascii[1],
                             (LPCSTR) uapascii[2],
                             (DWORD) uapascii[3],
                             (LPSTR) uapascii[4],
                             (LPSTR *) uapascii[5]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );
      if( uapascii[2] )
         free( (PVOID)uapascii[2] );
      if( uapascii[4] )
      {
         pd_char_t *replace = (pd_char_t *)malloc(nBufferLength * sizeof(pd_char_t));
         if( lpFilePart != NULL ) lpFilePart__offset = (DWORD)*lpFilePart - (DWORD)uapascii[4];
         MultiByteToWideChar( CP_ACP, 0, (LPCSTR)uapascii[4], nBufferLength,
                              replace, nBufferLength * sizeof(pd_char_t) );
         free( (PVOID)uapascii[4] );
         uap[4] = (LPVOID) replace;
      }

      retval = hook->callDispatchPost( /*space*/ 0, 637, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );
   if( uapsave[2] )
      free( (PVOID)uapsave[2] );
   if( uap[4] )
   {
      WideCharToMultiByte( CP_ACP, 0, (LPCWSTR)uap[4],
                           nBufferLength * sizeof(pd_char_t),
                           (char *)lpBuffer, nBufferLength, NULL, NULL );
      free( (PVOID)uap[4] );
      if( lpFilePart != NULL ) *lpFilePart = lpBuffer + lpFilePart__offset;
   }

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 638, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_SearchPathW( LPCWSTR lpPath,
                              LPCWSTR lpFileName,
                              LPCWSTR lpExtension,
                              DWORD nBufferLength,
                              LPWSTR lpBuffer,
                              LPWSTR * lpFilePart
                            )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SearchPathW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SearchPathW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpPath;
   uapsave[1] =
      uap[1] = (LPVOID) lpFileName;
   uapsave[2] =
      uap[2] = (LPVOID) lpExtension;
   uapsave[3] =
      uap[3] = (LPVOID) nBufferLength;
   uapsave[4] =
      uap[4] = (LPVOID) lpBuffer;
   uapsave[5] =
      uap[5] = (LPVOID) lpFilePart;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("SearchPathW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 638, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SearchPathW( (LPCWSTR) uap[0],
                             (LPCWSTR) uap[1],
                             (LPCWSTR) uap[2],
                             (DWORD) uap[3],
                             (LPWSTR) uap[4],
                             (LPWSTR *) uap[5]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 638, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 639, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetAclInformation( PACL pAcl,
                                   LPVOID pAclInformation,
                                   DWORD nAclInformationLength,
                                   ACL_INFORMATION_CLASS dwAclInformationClass
                                 )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetAclInformation"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetAclInformation");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) pAcl;
   uapsave[1] =
      uap[1] = (LPVOID) pAclInformation;
   uapsave[2] =
      uap[2] = (LPVOID) nAclInformationLength;
   uapsave[3] =
      uap[3] = (LPVOID) dwAclInformationClass;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetAclInformation"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 639, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = SetAclInformation( (PACL) uapascii[0],
                                   (LPVOID) uapascii[1],
                                   (DWORD) uapascii[2],
                                   (ACL_INFORMATION_CLASS) ((DWORD)uapascii[3])
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 639, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 640, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetCommBreak( HANDLE hFile )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetCommBreak"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetCommBreak");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetCommBreak"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 640, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetCommBreak( (HANDLE) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 640, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 641, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetCommConfig( HANDLE hCommDev,
                               LPCOMMCONFIG lpCC,
                               DWORD dwSize
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetCommConfig"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetCommConfig");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hCommDev;
   uapsave[1] =
      uap[1] = (LPVOID) lpCC;
   uapsave[2] =
      uap[2] = (LPVOID) dwSize;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetCommConfig"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 641, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetCommConfig( (HANDLE) uapascii[0],
                               (LPCOMMCONFIG) uapascii[1],
                               (DWORD) uapascii[2]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 641, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 642, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetCommMask( HANDLE hFile,
                             DWORD dwEvtMask
                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetCommMask"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetCommMask");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) dwEvtMask;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetCommMask"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 642, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetCommMask( (HANDLE) uapascii[0],
                             (DWORD) uapascii[1]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 642, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 643, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetCommState( HANDLE hFile,
                              LPDCB lpDCB
                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetCommState"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetCommState");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lpDCB;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetCommState"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 643, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetCommState( (HANDLE) uapascii[0],
                              (LPDCB) uapascii[1]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 643, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 644, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetCommTimeouts( HANDLE hFile,
                                 LPCOMMTIMEOUTS lpCommTimeouts
                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetCommTimeouts"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetCommTimeouts");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lpCommTimeouts;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetCommTimeouts"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 644, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetCommTimeouts( (HANDLE) uapascii[0],
                                 (LPCOMMTIMEOUTS) uapascii[1]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 644, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 645, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetComputerNameA( LPCSTR lpComputerName )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetComputerNameA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetComputerNameA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpComputerName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetComputerNameA"),
                  uap[0],
                  (LPCWSTR) uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 645, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      callRet = SetComputerNameA( (LPCSTR) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 645, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 646, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetComputerNameW( LPCWSTR lpComputerName )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetComputerNameW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetComputerNameW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpComputerName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetComputerNameW"),
                  uap[0],
                  (LPCWSTR) uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 646, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SetComputerNameW( (LPCWSTR) uap[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 646, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 647, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleActiveScreenBuffer( HANDLE hConsoleOutput )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleActiveScreenBuffer"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleActiveScreenBuffer");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleActiveScreenBuffer"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 647, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetConsoleActiveScreenBuffer( (HANDLE) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 647, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 648, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleCP( UINT wCodePageID )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleCP"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleCP");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) wCodePageID;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleCP"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 648, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetConsoleCP( (UINT) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 648, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 649, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleCtrlHandler( PHANDLER_ROUTINE HandlerRoutine,
                                       BOOL Add
                                     )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleCtrlHandler"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleCtrlHandler");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) HandlerRoutine;
   uapsave[1] =
      uap[1] = (LPVOID) Add;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleCtrlHandler"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 649, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetConsoleCtrlHandler( (PHANDLER_ROUTINE) uapascii[0],
                                       (BOOL) uapascii[1]
                                    );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 649, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 650, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleCursorInfo( HANDLE hConsoleOutput,
                                      const CONSOLE_CURSOR_INFO * lpConsoleCursorInfo
                                    )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleCursorInfo"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleCursorInfo");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpConsoleCursorInfo;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleCursorInfo"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 650, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetConsoleCursorInfo( (HANDLE) uapascii[0],
                                      (const CONSOLE_CURSOR_INFO *) uapascii[1]
                                   );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 650, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 651, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleCursorPosition( HANDLE hConsoleOutput,
                                          COORD dwCursorPosition
                                        )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleCursorPosition"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleCursorPosition");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) &dwCursorPosition;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleCursorPosition"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 651, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetConsoleCursorPosition( (HANDLE) uapascii[0],
                                         dwCursorPosition
                                       );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 651, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 652, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleMode( HANDLE hConsoleHandle,
                                DWORD dwMode
                              )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleMode"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleMode");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleHandle;
   uapsave[1] =
      uap[1] = (LPVOID) dwMode;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleMode"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 652, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetConsoleMode( (HANDLE) uapascii[0],
                                (DWORD) uapascii[1]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 652, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 653, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleOutputCP( UINT wCodePageID )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleOutputCP"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleOutputCP");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) wCodePageID;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleOutputCP"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 653, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetConsoleOutputCP( (UINT) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 653, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 654, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleScreenBufferSize( HANDLE hConsoleOutput,
                                            COORD dwSize
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleScreenBufferSize"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleScreenBufferSize");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) &dwSize;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleScreenBufferSize"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 654, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetConsoleScreenBufferSize( (HANDLE) uapascii[0],
                                           dwSize
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 654, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 655, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleTextAttribute( HANDLE hConsoleOutput,
                                         WORD wAttributes
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleTextAttribute"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleTextAttribute");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) wAttributes;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleTextAttribute"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 655, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetConsoleTextAttribute( (HANDLE) uapascii[0],
                                         (WORD) uapascii[1]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 655, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 656, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleTitleA( LPCSTR lpConsoleTitle )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleTitleA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleTitleA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpConsoleTitle );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleTitleA"),
                  uap[0],
                  (LPCWSTR) uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 656, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      callRet = SetConsoleTitleA( (LPCSTR) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 656, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 657, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleTitleW( LPCWSTR lpConsoleTitle )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleTitleW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleTitleW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpConsoleTitle;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleTitleW"),
                  uap[0],
                  (LPCWSTR) uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 657, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SetConsoleTitleW( (LPCWSTR) uap[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 657, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 658, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetConsoleWindowInfo( HANDLE hConsoleOutput,
                                      BOOL bAbsolute,
                                      const SMALL_RECT * lpConsoleWindow
                                    )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetConsoleWindowInfo"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetConsoleWindowInfo");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) bAbsolute;
   uapsave[2] =
      uap[2] = (LPVOID) lpConsoleWindow;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetConsoleWindowInfo"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 658, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetConsoleWindowInfo( (HANDLE) uapascii[0],
                                      (BOOL) uapascii[1],
                                      (const SMALL_RECT *) uapascii[2]
                                   );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 658, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 659, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetCurrentDirectoryA( LPCSTR lpPathName )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetCurrentDirectoryA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetCurrentDirectoryA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpPathName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetCurrentDirectoryA"),
                  uap[0],
                  (LPCWSTR) uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 659, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      callRet = SetCurrentDirectoryA( (LPCSTR) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 659, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 660, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetCurrentDirectoryW( LPCWSTR lpPathName )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetCurrentDirectoryW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetCurrentDirectoryW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpPathName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetCurrentDirectoryW"),
                  uap[0],
                  (LPCWSTR) uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 660, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SetCurrentDirectoryW( (LPCWSTR) uap[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 660, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 661, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetDefaultCommConfigA( LPCSTR lpszName,
                                       LPCOMMCONFIG lpCC,
                                       DWORD dwSize
                                     )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetDefaultCommConfigA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetDefaultCommConfigA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpszName );
   uapsave[1] =
      uap[1] = (LPVOID) lpCC;
   uapsave[2] =
      uap[2] = (LPVOID) dwSize;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetDefaultCommConfigA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 661, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetDefaultCommConfigA( (LPCSTR) uapascii[0],
                                       (LPCOMMCONFIG) uapascii[1],
                                       (DWORD) uapascii[2]
                                    );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 661, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 662, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetDefaultCommConfigW( LPCWSTR lpszName,
                                       LPCOMMCONFIG lpCC,
                                       DWORD dwSize
                                     )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetDefaultCommConfigW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetDefaultCommConfigW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpszName;
   uapsave[1] =
      uap[1] = (LPVOID) lpCC;
   uapsave[2] =
      uap[2] = (LPVOID) dwSize;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetDefaultCommConfigW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 662, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SetDefaultCommConfigW( (LPCWSTR) uap[0],
                                       (LPCOMMCONFIG) uap[1],
                                       (DWORD) uap[2]
                                    );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 662, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 663, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetEndOfFile( HANDLE hFile )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetEndOfFile"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetEndOfFile");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetEndOfFile"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 663, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetEndOfFile( (HANDLE) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 663, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 664, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetEnvironmentVariableA( LPCSTR lpName,
                                         LPCSTR lpValue
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetEnvironmentVariableA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetEnvironmentVariableA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpValue );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetEnvironmentVariableA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 664, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      callRet = SetEnvironmentVariableA( (LPCSTR) uapascii[0],
                                         (LPCSTR) uapascii[1]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 664, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 665, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetEnvironmentVariableW( LPCWSTR lpName,
                                         LPCWSTR lpValue
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetEnvironmentVariableW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetEnvironmentVariableW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpName;
   uapsave[1] =
      uap[1] = (LPVOID) lpValue;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetEnvironmentVariableW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 665, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SetEnvironmentVariableW( (LPCWSTR) uap[0],
                                         (LPCWSTR) uap[1]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 665, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 666, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

UINT WINAPI LWM_SetErrorMode( UINT uMode )
{
   UINT callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetErrorMode"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetErrorMode");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) uMode;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("UINT"),
                  PD_MAKESTR("SetErrorMode"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 666, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetErrorMode( (UINT) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 666, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 667, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetEvent( HANDLE hEvent )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetEvent"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetEvent");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hEvent;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetEvent"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 667, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetEvent( (HANDLE) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 667, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 668, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

void WINAPI LWM_SetFileApisToANSI( void )
{
   void *callRet = {NULL};
   LPVOID *uap = NULL;

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetFileApisToANSI"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetFileApisToANSI");
      hook = &(*hookIterator).second;
   }

   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s()"), g_tracecount++,
                  PD_MAKESTR("void"), PD_MAKESTR("SetFileApisToANSI") );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 668, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      SetFileApisToANSI();

      if( g_bTraceCalls )
      wsi_printf( PD_MAKESTR("\n") );


      retval = hook->callDispatchPost( /*space*/ 0, 668, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

}

void WINAPI LWM_SetFileApisToOEM( void )
{
   void *callRet = {NULL};
   LPVOID *uap = NULL;

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetFileApisToOEM"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetFileApisToOEM");
      hook = &(*hookIterator).second;
   }

   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s()"), g_tracecount++,
                  PD_MAKESTR("void"), PD_MAKESTR("SetFileApisToOEM") );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 669, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      SetFileApisToOEM();

      if( g_bTraceCalls )
      wsi_printf( PD_MAKESTR("\n") );


      retval = hook->callDispatchPost( /*space*/ 0, 669, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

}

BOOL WINAPI LWM_SetFileAttributesA( LPCSTR lpFileName,
                                    DWORD dwFileAttributes
                                  )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetFileAttributesA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetFileAttributesA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpFileName );
   uapsave[1] =
      uap[1] = (LPVOID) dwFileAttributes;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetFileAttributesA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 670, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      callRet = SetFileAttributesA( (LPCSTR) uapascii[0],
                                    (DWORD) uapascii[1]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 670, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 671, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetFileAttributesW( LPCWSTR lpFileName,
                                    DWORD dwFileAttributes
                                  )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetFileAttributesW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetFileAttributesW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpFileName;
   uapsave[1] =
      uap[1] = (LPVOID) dwFileAttributes;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetFileAttributesW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 671, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SetFileAttributesW( (LPCWSTR) uap[0],
                                    (DWORD) uap[1]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 671, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 672, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_SetFilePointer( HANDLE hFile,
                                 LONG lDistanceToMove,
                                 PLONG lpDistanceToMoveHigh,
                                 DWORD dwMoveMethod
                               )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetFilePointer"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetFilePointer");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lDistanceToMove;
   uapsave[2] =
      uap[2] = (LPVOID) lpDistanceToMoveHigh;
   uapsave[3] =
      uap[3] = (LPVOID) dwMoveMethod;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("SetFilePointer"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 672, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = SetFilePointer( (HANDLE) uapascii[0],
                                (LONG) uapascii[1],
                                (PLONG) uapascii[2],
                                (DWORD) uapascii[3]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 672, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 673, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetFileSecurityA( LPCSTR lpFileName,
                                  SECURITY_INFORMATION SecurityInformation,
                                  PSECURITY_DESCRIPTOR pSecurityDescriptor
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetFileSecurityA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetFileSecurityA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpFileName );
   uapsave[1] =
      uap[1] = (LPVOID) SecurityInformation;
   uapsave[2] =
      uap[2] = (LPVOID) pSecurityDescriptor;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetFileSecurityA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 673, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetFileSecurityA( (LPCSTR) uapascii[0],
                                  (SECURITY_INFORMATION) uapascii[1],
                                  (PSECURITY_DESCRIPTOR) uapascii[2]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 673, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 674, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetFileSecurityW( LPCWSTR lpFileName,
                                  SECURITY_INFORMATION SecurityInformation,
                                  PSECURITY_DESCRIPTOR pSecurityDescriptor
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetFileSecurityW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetFileSecurityW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpFileName;
   uapsave[1] =
      uap[1] = (LPVOID) SecurityInformation;
   uapsave[2] =
      uap[2] = (LPVOID) pSecurityDescriptor;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetFileSecurityW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 674, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SetFileSecurityW( (LPCWSTR) uap[0],
                                  (SECURITY_INFORMATION) uap[1],
                                  (PSECURITY_DESCRIPTOR) uap[2]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 674, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 675, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetFileTime( HANDLE hFile,
                             const FILETIME * lpCreationTime,
                             const FILETIME * lpLastAccessTime,
                             const FILETIME * lpLastWriteTime
                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetFileTime"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetFileTime");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lpCreationTime;
   uapsave[2] =
      uap[2] = (LPVOID) lpLastAccessTime;
   uapsave[3] =
      uap[3] = (LPVOID) lpLastWriteTime;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetFileTime"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 675, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = SetFileTime( (HANDLE) uapascii[0],
                             (const FILETIME *) uapascii[1],
                             (const FILETIME *) uapascii[2],
                             (const FILETIME *) uapascii[3]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 675, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 676, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

UINT WINAPI LWM_SetHandleCount( UINT uNumber )
{
   UINT callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetHandleCount"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetHandleCount");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) uNumber;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("UINT"),
                  PD_MAKESTR("SetHandleCount"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 676, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetHandleCount( (UINT) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 676, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 677, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetHandleInformation( HANDLE hObject,
                                      DWORD dwMask,
                                      DWORD dwFlags
                                    )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetHandleInformation"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetHandleInformation");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hObject;
   uapsave[1] =
      uap[1] = (LPVOID) dwMask;
   uapsave[2] =
      uap[2] = (LPVOID) dwFlags;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetHandleInformation"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 677, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetHandleInformation( (HANDLE) uapascii[0],
                                      (DWORD) uapascii[1],
                                      (DWORD) uapascii[2]
                                   );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 677, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 678, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetKernelObjectSecurity( HANDLE Handle,
                                         SECURITY_INFORMATION SecurityInformation,
                                         PSECURITY_DESCRIPTOR SecurityDescriptor
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetKernelObjectSecurity"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetKernelObjectSecurity");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) Handle;
   uapsave[1] =
      uap[1] = (LPVOID) SecurityInformation;
   uapsave[2] =
      uap[2] = (LPVOID) SecurityDescriptor;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetKernelObjectSecurity"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 678, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetKernelObjectSecurity( (HANDLE) uapascii[0],
                                         (SECURITY_INFORMATION) uapascii[1],
                                         (PSECURITY_DESCRIPTOR) uapascii[2]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 678, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 679, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

void WINAPI LWM_SetLastError( DWORD dwErrCode )
{
   void *callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetLastError"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetLastError");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwErrCode;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("void"),
                  PD_MAKESTR("SetLastError"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 679, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      SetLastError( (DWORD) uapascii[0]);

      if( g_bTraceCalls )
      wsi_printf( PD_MAKESTR("\n") );


      retval = hook->callDispatchPost( /*space*/ 0, 679, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 680, (void **)uap );

}

BOOL WINAPI LWM_SetLocalTime( const SYSTEMTIME * lpSystemTime )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetLocalTime"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetLocalTime");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpSystemTime;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetLocalTime"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 680, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetLocalTime( (const SYSTEMTIME *) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 680, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 681, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetLocaleInfoA( LCID Locale,
                                LCTYPE LCType,
                                LPCSTR lpLCData
                              )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetLocaleInfoA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetLocaleInfoA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) Locale;
   uapsave[1] =
      uap[1] = (LPVOID) LCType;
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpLCData );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetLocaleInfoA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 681, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      callRet = SetLocaleInfoA( (LCID) uapascii[0],
                                (LCTYPE) uapascii[1],
                                (LPCSTR) uapascii[2]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[2] )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 681, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[2] )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 682, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetLocaleInfoW( LCID Locale,
                                LCTYPE LCType,
                                LPCWSTR lpLCData
                              )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetLocaleInfoW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetLocaleInfoW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) Locale;
   uapsave[1] =
      uap[1] = (LPVOID) LCType;
   uapsave[2] =
      uap[2] = (LPVOID) lpLCData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetLocaleInfoW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 682, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SetLocaleInfoW( (LCID) uap[0],
                                (LCTYPE) uap[1],
                                (LPCWSTR) uap[2]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 682, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 683, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetMailslotInfo( HANDLE hMailslot,
                                 DWORD lReadTimeout
                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetMailslotInfo"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetMailslotInfo");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hMailslot;
   uapsave[1] =
      uap[1] = (LPVOID) lReadTimeout;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetMailslotInfo"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 683, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetMailslotInfo( (HANDLE) uapascii[0],
                                 (DWORD) uapascii[1]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 683, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 684, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetNamedPipeHandleState( HANDLE hNamedPipe,
                                         LPDWORD lpMode,
                                         LPDWORD lpMaxCollectionCount,
                                         LPDWORD lpCollectDataTimeout
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetNamedPipeHandleState"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetNamedPipeHandleState");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hNamedPipe;
   uapsave[1] =
      uap[1] = (LPVOID) lpMode;
   uapsave[2] =
      uap[2] = (LPVOID) lpMaxCollectionCount;
   uapsave[3] =
      uap[3] = (LPVOID) lpCollectDataTimeout;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetNamedPipeHandleState"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 684, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = SetNamedPipeHandleState( (HANDLE) uapascii[0],
                                         (LPDWORD) uapascii[1],
                                         (LPDWORD) uapascii[2],
                                         (LPDWORD) uapascii[3]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 684, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 685, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetPriorityClass( HANDLE hProcess,
                                  DWORD dwPriorityClass
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetPriorityClass"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetPriorityClass");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) dwPriorityClass;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetPriorityClass"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 685, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetPriorityClass( (HANDLE) uapascii[0],
                                  (DWORD) uapascii[1]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 685, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 686, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetPrivateObjectSecurity( SECURITY_INFORMATION SecurityInformation,
                                          PSECURITY_DESCRIPTOR ModificationDescriptor,
                                          PSECURITY_DESCRIPTOR * ObjectsSecurityDescriptor,
                                          PGENERIC_MAPPING GenericMapping,
                                          HANDLE Token
                                        )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetPrivateObjectSecurity"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetPrivateObjectSecurity");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) SecurityInformation;
   uapsave[1] =
      uap[1] = (LPVOID) ModificationDescriptor;
   uapsave[2] =
      uap[2] = (LPVOID) ObjectsSecurityDescriptor;
   uapsave[3] =
      uap[3] = (LPVOID) GenericMapping;
   uapsave[4] =
      uap[4] = (LPVOID) Token;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetPrivateObjectSecurity"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 686, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = SetPrivateObjectSecurity( (SECURITY_INFORMATION) uapascii[0],
                                          (PSECURITY_DESCRIPTOR) uapascii[1],
                                          (PSECURITY_DESCRIPTOR *) uapascii[2],
                                          (PGENERIC_MAPPING) uapascii[3],
                                          (HANDLE) uapascii[4]
                                       );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 686, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 687, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetProcessAffinityMask( HANDLE hProcess,
                                        DWORD_PTR dwProcessAffinityMask
                                      )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetProcessAffinityMask"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetProcessAffinityMask");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) dwProcessAffinityMask;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetProcessAffinityMask"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 687, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetProcessAffinityMask( (HANDLE) uapascii[0],
                                        (DWORD_PTR) uapascii[1]
                                     );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 687, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 688, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetProcessPriorityBoost( HANDLE hProcess,
                                         BOOL bDisablePriorityBoost
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetProcessPriorityBoost"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetProcessPriorityBoost");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) bDisablePriorityBoost;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetProcessPriorityBoost"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 688, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetProcessPriorityBoost( (HANDLE) uapascii[0],
                                         (BOOL) uapascii[1]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 688, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 689, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetProcessShutdownParameters( DWORD dwLevel,
                                              DWORD dwFlags
                                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetProcessShutdownParameters"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetProcessShutdownParameters");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwLevel;
   uapsave[1] =
      uap[1] = (LPVOID) dwFlags;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetProcessShutdownParameters"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 689, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetProcessShutdownParameters( (DWORD) uapascii[0],
                                              (DWORD) uapascii[1]
                                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 689, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 690, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetProcessWorkingSetSize( HANDLE hProcess,
                                          SIZE_T dwMinimumWorkingSetSize,
                                          SIZE_T dwMaximumWorkingSetSize
                                        )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetProcessWorkingSetSize"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetProcessWorkingSetSize");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) dwMinimumWorkingSetSize;
   uapsave[2] =
      uap[2] = (LPVOID) dwMaximumWorkingSetSize;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetProcessWorkingSetSize"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 690, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetProcessWorkingSetSize( (HANDLE) uapascii[0],
                                          (SIZE_T) uapascii[1],
                                          (SIZE_T) uapascii[2]
                                       );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 690, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 691, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetSecurityDescriptorDacl( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                           BOOL bDaclPresent,
                                           PACL pDacl,
                                           BOOL bDaclDefaulted
                                         )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetSecurityDescriptorDacl"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetSecurityDescriptorDacl");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) pSecurityDescriptor;
   uapsave[1] =
      uap[1] = (LPVOID) bDaclPresent;
   uapsave[2] =
      uap[2] = (LPVOID) pDacl;
   uapsave[3] =
      uap[3] = (LPVOID) bDaclDefaulted;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetSecurityDescriptorDacl"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 691, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = SetSecurityDescriptorDacl( (PSECURITY_DESCRIPTOR) uapascii[0],
                                           (BOOL) uapascii[1],
                                           (PACL) uapascii[2],
                                           (BOOL) uapascii[3]
                                        );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 691, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 692, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetSecurityDescriptorGroup( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                            PSID pGroup,
                                            BOOL bGroupDefaulted
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetSecurityDescriptorGroup"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetSecurityDescriptorGroup");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) pSecurityDescriptor;
   uapsave[1] =
      uap[1] = (LPVOID) pGroup;
   uapsave[2] =
      uap[2] = (LPVOID) bGroupDefaulted;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetSecurityDescriptorGroup"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 692, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetSecurityDescriptorGroup( (PSECURITY_DESCRIPTOR) uapascii[0],
                                            (PSID) uapascii[1],
                                            (BOOL) uapascii[2]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 692, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 693, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetSecurityDescriptorOwner( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                            PSID pOwner,
                                            BOOL bOwnerDefaulted
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetSecurityDescriptorOwner"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetSecurityDescriptorOwner");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) pSecurityDescriptor;
   uapsave[1] =
      uap[1] = (LPVOID) pOwner;
   uapsave[2] =
      uap[2] = (LPVOID) bOwnerDefaulted;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetSecurityDescriptorOwner"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 693, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetSecurityDescriptorOwner( (PSECURITY_DESCRIPTOR) uapascii[0],
                                            (PSID) uapascii[1],
                                            (BOOL) uapascii[2]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 693, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 694, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetSecurityDescriptorSacl( PSECURITY_DESCRIPTOR pSecurityDescriptor,
                                           BOOL bSaclPresent,
                                           PACL pSacl,
                                           BOOL bSaclDefaulted
                                         )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetSecurityDescriptorSacl"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetSecurityDescriptorSacl");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) pSecurityDescriptor;
   uapsave[1] =
      uap[1] = (LPVOID) bSaclPresent;
   uapsave[2] =
      uap[2] = (LPVOID) pSacl;
   uapsave[3] =
      uap[3] = (LPVOID) bSaclDefaulted;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetSecurityDescriptorSacl"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 694, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = SetSecurityDescriptorSacl( (PSECURITY_DESCRIPTOR) uapascii[0],
                                           (BOOL) uapascii[1],
                                           (PACL) uapascii[2],
                                           (BOOL) uapascii[3]
                                        );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 694, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 695, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetServiceObjectSecurity( SC_HANDLE hService,
                                          SECURITY_INFORMATION dwSecurityInformation,
                                          PSECURITY_DESCRIPTOR lpSecurityDescriptor
                                        )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetServiceObjectSecurity"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetServiceObjectSecurity");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hService;
   uapsave[1] =
      uap[1] = (LPVOID) dwSecurityInformation;
   uapsave[2] =
      uap[2] = (LPVOID) lpSecurityDescriptor;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetServiceObjectSecurity"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 695, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetServiceObjectSecurity( (SC_HANDLE) uapascii[0],
                                          (SECURITY_INFORMATION) uapascii[1],
                                          (PSECURITY_DESCRIPTOR) uapascii[2]
                                       );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 695, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 696, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetServiceStatus( SERVICE_STATUS_HANDLE hServiceStatus,
                                  LPSERVICE_STATUS lpServiceStatus
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetServiceStatus"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetServiceStatus");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hServiceStatus;
   uapsave[1] =
      uap[1] = (LPVOID) lpServiceStatus;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetServiceStatus"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 696, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetServiceStatus( (SERVICE_STATUS_HANDLE) uapascii[0],
                                  (LPSERVICE_STATUS) uapascii[1]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 696, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 697, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetStdHandle( DWORD nStdHandle,
                              HANDLE hHandle
                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetStdHandle"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetStdHandle");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) nStdHandle;
   uapsave[1] =
      uap[1] = (LPVOID) hHandle;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetStdHandle"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 697, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetStdHandle( (DWORD) uapascii[0],
                              (HANDLE) uapascii[1]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 697, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 698, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetSystemTime( const SYSTEMTIME * lpSystemTime )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetSystemTime"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetSystemTime");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpSystemTime;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetSystemTime"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 698, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetSystemTime( (const SYSTEMTIME *) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 698, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 699, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetSystemTimeAdjustment( DWORD dwTimeAdjustment,
                                         BOOL bTimeAdjustmentDisabled
                                       )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetSystemTimeAdjustment"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetSystemTimeAdjustment");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwTimeAdjustment;
   uapsave[1] =
      uap[1] = (LPVOID) bTimeAdjustmentDisabled;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetSystemTimeAdjustment"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 699, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetSystemTimeAdjustment( (DWORD) uapascii[0],
                                         (BOOL) uapascii[1]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 699, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 700, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_SetTapeParameters( HANDLE hDevice,
                                    DWORD dwOperation,
                                    LPVOID lpTapeInformation
                                  )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetTapeParameters"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetTapeParameters");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hDevice;
   uapsave[1] =
      uap[1] = (LPVOID) dwOperation;
   uapsave[2] =
      uap[2] = (LPVOID) lpTapeInformation;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("SetTapeParameters"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 700, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetTapeParameters( (HANDLE) uapascii[0],
                                   (DWORD) uapascii[1],
                                   (LPVOID) uapascii[2]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 700, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 701, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_SetTapePosition( HANDLE hDevice,
                                  DWORD dwPositionMethod,
                                  DWORD dwPartition,
                                  DWORD dwOffsetLow,
                                  DWORD dwOffsetHigh,
                                  BOOL bImmediate
                                )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetTapePosition"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetTapePosition");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hDevice;
   uapsave[1] =
      uap[1] = (LPVOID) dwPositionMethod;
   uapsave[2] =
      uap[2] = (LPVOID) dwPartition;
   uapsave[3] =
      uap[3] = (LPVOID) dwOffsetLow;
   uapsave[4] =
      uap[4] = (LPVOID) dwOffsetHigh;
   uapsave[5] =
      uap[5] = (LPVOID) bImmediate;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("SetTapePosition"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 701, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[6];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      callRet = SetTapePosition( (HANDLE) uapascii[0],
                                 (DWORD) uapascii[1],
                                 (DWORD) uapascii[2],
                                 (DWORD) uapascii[3],
                                 (DWORD) uapascii[4],
                                 (BOOL) uapascii[5]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 701, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 702, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD_PTR WINAPI LWM_SetThreadAffinityMask( HANDLE hThread,
                                            DWORD_PTR dwThreadAffinityMask
                                          )
{
   DWORD_PTR callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetThreadAffinityMask"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetThreadAffinityMask");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hThread;
   uapsave[1] =
      uap[1] = (LPVOID) dwThreadAffinityMask;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD_PTR"),
                  PD_MAKESTR("SetThreadAffinityMask"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 702, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetThreadAffinityMask( (HANDLE) uapascii[0],
                                       (DWORD_PTR) uapascii[1]
                                    );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 702, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 703, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetThreadContext( HANDLE hThread,
                                  const CONTEXT * lpContext
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetThreadContext"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetThreadContext");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hThread;
   uapsave[1] =
      uap[1] = (LPVOID) lpContext;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetThreadContext"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 703, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetThreadContext( (HANDLE) uapascii[0],
                                  (const CONTEXT *) uapascii[1]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 703, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 704, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_SetThreadIdealProcessor( HANDLE hThread,
                                          DWORD dwIdealProcessor
                                        )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetThreadIdealProcessor"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetThreadIdealProcessor");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hThread;
   uapsave[1] =
      uap[1] = (LPVOID) dwIdealProcessor;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("SetThreadIdealProcessor"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 704, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetThreadIdealProcessor( (HANDLE) uapascii[0],
                                         (DWORD) uapascii[1]
                                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 704, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 705, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetThreadLocale( LCID Locale )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetThreadLocale"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetThreadLocale");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) Locale;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetThreadLocale"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 705, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetThreadLocale( (LCID) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 705, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 706, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetThreadPriority( HANDLE hThread,
                                   int nPriority
                                 )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetThreadPriority"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetThreadPriority");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hThread;
   uapsave[1] =
      uap[1] = (LPVOID) nPriority;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetThreadPriority"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 706, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetThreadPriority( (HANDLE) uapascii[0],
                                   (int) uapascii[1]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 706, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 707, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetThreadPriorityBoost( HANDLE hThread,
                                        BOOL bDisablePriorityBoost
                                      )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetThreadPriorityBoost"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetThreadPriorityBoost");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hThread;
   uapsave[1] =
      uap[1] = (LPVOID) bDisablePriorityBoost;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetThreadPriorityBoost"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 707, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetThreadPriorityBoost( (HANDLE) uapascii[0],
                                        (BOOL) uapascii[1]
                                     );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 707, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 708, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetThreadToken( PHANDLE Thread,
                                HANDLE Token
                              )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetThreadToken"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetThreadToken");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) Thread;
   uapsave[1] =
      uap[1] = (LPVOID) Token;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetThreadToken"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 708, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SetThreadToken( (PHANDLE) uapascii[0],
                                (HANDLE) uapascii[1]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 708, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 709, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetTimeZoneInformation( const TIME_ZONE_INFORMATION * lpTimeZoneInformation )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetTimeZoneInformation"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetTimeZoneInformation");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpTimeZoneInformation;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetTimeZoneInformation"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 709, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetTimeZoneInformation( (const TIME_ZONE_INFORMATION *) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 709, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 710, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetTokenInformation( HANDLE TokenHandle,
                                     TOKEN_INFORMATION_CLASS TokenInformationClass,
                                     LPVOID TokenInformation,
                                     DWORD TokenInformationLength
                                   )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetTokenInformation"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetTokenInformation");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) TokenHandle;
   uapsave[1] =
      uap[1] = (LPVOID) TokenInformationClass;
   uapsave[2] =
      uap[2] = (LPVOID) TokenInformation;
   uapsave[3] =
      uap[3] = (LPVOID) TokenInformationLength;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetTokenInformation"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 710, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = SetTokenInformation( (HANDLE) uapascii[0],
                                     (TOKEN_INFORMATION_CLASS) ((DWORD)uapascii[1]),
                                     (LPVOID) uapascii[2],
                                     (DWORD) uapascii[3]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 710, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 711, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LPTOP_LEVEL_EXCEPTION_FILTER WINAPI LWM_SetUnhandledExceptionFilter( LPTOP_LEVEL_EXCEPTION_FILTER lpTopLevelExceptionFilter )
{
   LPTOP_LEVEL_EXCEPTION_FILTER callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetUnhandledExceptionFilter"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetUnhandledExceptionFilter");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpTopLevelExceptionFilter;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LPTOP_LEVEL_EXCEPTION_FILTER"),
                  PD_MAKESTR("SetUnhandledExceptionFilter"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 711, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SetUnhandledExceptionFilter( (LPTOP_LEVEL_EXCEPTION_FILTER) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 711, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 712, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetVolumeLabelA( LPCSTR lpRootPathName,
                                 LPCSTR lpVolumeName
                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetVolumeLabelA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetVolumeLabelA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpRootPathName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpVolumeName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetVolumeLabelA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 712, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      callRet = SetVolumeLabelA( (LPCSTR) uapascii[0],
                                 (LPCSTR) uapascii[1]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 712, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 713, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetVolumeLabelW( LPCWSTR lpRootPathName,
                                 LPCWSTR lpVolumeName
                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetVolumeLabelW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetVolumeLabelW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpRootPathName;
   uapsave[1] =
      uap[1] = (LPVOID) lpVolumeName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetVolumeLabelW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 713, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SetVolumeLabelW( (LPCWSTR) uap[0],
                                 (LPCWSTR) uap[1]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 713, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 714, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetWaitableTimer( HANDLE hTimer,
                                  const LARGE_INTEGER * lpDueTime,
                                  LONG lPeriod,
                                  PTIMERAPCROUTINE pfnCompletionRoutine,
                                  LPVOID lpArgToCompletionRoutine,
                                  BOOL fResume
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetWaitableTimer"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetWaitableTimer");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hTimer;
   uapsave[1] =
      uap[1] = (LPVOID) lpDueTime;
   uapsave[2] =
      uap[2] = (LPVOID) lPeriod;
   uapsave[3] =
      uap[3] = (LPVOID) pfnCompletionRoutine;
   uapsave[4] =
      uap[4] = (LPVOID) lpArgToCompletionRoutine;
   uapsave[5] =
      uap[5] = (LPVOID) fResume;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetWaitableTimer"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 714, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[6];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      callRet = SetWaitableTimer( (HANDLE) uapascii[0],
                                  (const LARGE_INTEGER *) uapascii[1],
                                  (LONG) uapascii[2],
                                  (PTIMERAPCROUTINE) uapascii[3],
                                  (LPVOID) uapascii[4],
                                  (BOOL) uapascii[5]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 714, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 715, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SetupComm( HANDLE hFile,
                           DWORD dwInQueue,
                           DWORD dwOutQueue
                         )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SetupComm"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SetupComm");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) dwInQueue;
   uapsave[2] =
      uap[2] = (LPVOID) dwOutQueue;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SetupComm"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 715, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SetupComm( (HANDLE) uapascii[0],
                           (DWORD) uapascii[1],
                           (DWORD) uapascii[2]
                        );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 715, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 716, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_SignalObjectAndWait( HANDLE hObjectToSignal,
                                      HANDLE hObjectToWaitOn,
                                      DWORD dwMilliseconds,
                                      BOOL bAlertable
                                    )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SignalObjectAndWait"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SignalObjectAndWait");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hObjectToSignal;
   uapsave[1] =
      uap[1] = (LPVOID) hObjectToWaitOn;
   uapsave[2] =
      uap[2] = (LPVOID) dwMilliseconds;
   uapsave[3] =
      uap[3] = (LPVOID) bAlertable;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("SignalObjectAndWait"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 716, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = SignalObjectAndWait( (HANDLE) uapascii[0],
                                     (HANDLE) uapascii[1],
                                     (DWORD) uapascii[2],
                                     (BOOL) uapascii[3]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 716, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 717, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_SizeofResource( HMODULE hModule,
                                 HRSRC hResInfo
                               )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SizeofResource"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SizeofResource");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hModule;
   uapsave[1] =
      uap[1] = (LPVOID) hResInfo;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("SizeofResource"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 717, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SizeofResource( (HMODULE) uapascii[0],
                                (HRSRC) uapascii[1]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 717, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 718, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

void WINAPI LWM_Sleep( DWORD dwMilliseconds )
{
   void *callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("Sleep"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("Sleep");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwMilliseconds;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("void"),
                  PD_MAKESTR("Sleep"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 718, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      Sleep( (DWORD) uapascii[0]);

      if( g_bTraceCalls )
      wsi_printf( PD_MAKESTR("\n") );


      retval = hook->callDispatchPost( /*space*/ 0, 718, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 719, (void **)uap );

}

DWORD WINAPI LWM_SleepEx( DWORD dwMilliseconds,
                          BOOL bAlertable
                        )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SleepEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SleepEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwMilliseconds;
   uapsave[1] =
      uap[1] = (LPVOID) bAlertable;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("SleepEx"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 719, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SleepEx( (DWORD) uapascii[0],
                         (BOOL) uapascii[1]
                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 719, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 720, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_StartServiceA( SC_HANDLE hService,
                               DWORD dwNumServiceArgs,
                               LPCSTR * lpServiceArgVectors
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("StartServiceA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("StartServiceA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hService;
   uapsave[1] =
      uap[1] = (LPVOID) dwNumServiceArgs;
   uapsave[2] =
      uap[2] = (LPVOID) lpServiceArgVectors;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("StartServiceA"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 720, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = StartServiceA( (SC_HANDLE) uapascii[0],
                               (DWORD) uapascii[1],
                               (LPCSTR *) uapascii[2]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 720, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 721, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_StartServiceCtrlDispatcherA( const SERVICE_TABLE_ENTRYA * lpServiceStartTable )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("StartServiceCtrlDispatcherA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("StartServiceCtrlDispatcherA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpServiceStartTable;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("StartServiceCtrlDispatcherA"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 721, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = StartServiceCtrlDispatcherA( (const SERVICE_TABLE_ENTRYA *) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 721, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 722, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_StartServiceCtrlDispatcherW( const SERVICE_TABLE_ENTRYW * lpServiceStartTable )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("StartServiceCtrlDispatcherW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("StartServiceCtrlDispatcherW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpServiceStartTable;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("StartServiceCtrlDispatcherW"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 722, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = StartServiceCtrlDispatcherW( (const SERVICE_TABLE_ENTRYW *) uap[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 722, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 723, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_StartServiceW( SC_HANDLE hService,
                               DWORD dwNumServiceArgs,
                               LPCWSTR * lpServiceArgVectors
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("StartServiceW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("StartServiceW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hService;
   uapsave[1] =
      uap[1] = (LPVOID) dwNumServiceArgs;
   uapsave[2] =
      uap[2] = (LPVOID) lpServiceArgVectors;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("StartServiceW"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 723, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = StartServiceW( (SC_HANDLE) uap[0],
                               (DWORD) uap[1],
                               (LPCWSTR *) uap[2]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 723, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 724, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_SuspendThread( HANDLE hThread )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SuspendThread"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SuspendThread");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hThread;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("SuspendThread"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 724, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = SuspendThread( (HANDLE) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 724, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 725, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

void WINAPI LWM_SwitchToFiber( LPVOID lpFiber )
{
   void *callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SwitchToFiber"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SwitchToFiber");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpFiber;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("void"),
                  PD_MAKESTR("SwitchToFiber"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 725, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      SwitchToFiber( (LPVOID) uapascii[0]);

      if( g_bTraceCalls )
      wsi_printf( PD_MAKESTR("\n") );


      retval = hook->callDispatchPost( /*space*/ 0, 725, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 726, (void **)uap );

}

BOOL WINAPI LWM_SwitchToThread( void )
{
   BOOL callRet = {NULL};
   LPVOID *uap = NULL;

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SwitchToThread"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SwitchToThread");
      hook = &(*hookIterator).second;
   }

   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s()"), g_tracecount++,
                  PD_MAKESTR("BOOL"), PD_MAKESTR("SwitchToThread") );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 726, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = SwitchToThread();

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 726, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SystemTimeToFileTime( const SYSTEMTIME * lpSystemTime,
                                      LPFILETIME lpFileTime
                                    )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SystemTimeToFileTime"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SystemTimeToFileTime");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpSystemTime;
   uapsave[1] =
      uap[1] = (LPVOID) lpFileTime;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SystemTimeToFileTime"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 727, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = SystemTimeToFileTime( (const SYSTEMTIME *) uapascii[0],
                                      (LPFILETIME) uapascii[1]
                                   );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 727, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 728, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_SystemTimeToTzSpecificLocalTime( LPTIME_ZONE_INFORMATION lpTimeZoneInformation,
                                                 LPSYSTEMTIME lpUniversalTime,
                                                 LPSYSTEMTIME lpLocalTime
                                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("SystemTimeToTzSpecificLocalTime"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("SystemTimeToTzSpecificLocalTime");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpTimeZoneInformation;
   uapsave[1] =
      uap[1] = (LPVOID) lpUniversalTime;
   uapsave[2] =
      uap[2] = (LPVOID) lpLocalTime;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("SystemTimeToTzSpecificLocalTime"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 728, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = SystemTimeToTzSpecificLocalTime( (LPTIME_ZONE_INFORMATION) uapascii[0],
                                                 (LPSYSTEMTIME) uapascii[1],
                                                 (LPSYSTEMTIME) uapascii[2]
                                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 728, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 729, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_TerminateProcess( HANDLE hProcess,
                                  UINT uExitCode
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("TerminateProcess"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("TerminateProcess");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) uExitCode;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("TerminateProcess"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 729, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = TerminateProcess( (HANDLE) uapascii[0],
                                  (UINT) uapascii[1]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 729, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 730, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_TerminateThread( HANDLE hThread,
                                 DWORD dwExitCode
                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("TerminateThread"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("TerminateThread");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hThread;
   uapsave[1] =
      uap[1] = (LPVOID) dwExitCode;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("TerminateThread"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 730, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = TerminateThread( (HANDLE) uapascii[0],
                                 (DWORD) uapascii[1]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 730, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 731, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_TlsAlloc( void )
{
   DWORD callRet = {NULL};
   LPVOID *uap = NULL;

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("TlsAlloc"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("TlsAlloc");
      hook = &(*hookIterator).second;
   }

   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s()"), g_tracecount++,
                  PD_MAKESTR("DWORD"), PD_MAKESTR("TlsAlloc") );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 731, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = TlsAlloc();

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 731, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_TlsFree( DWORD dwTlsIndex )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("TlsFree"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("TlsFree");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwTlsIndex;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("TlsFree"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 732, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = TlsFree( (DWORD) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 732, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 733, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LPVOID WINAPI LWM_TlsGetValue( DWORD dwTlsIndex )
{
   LPVOID callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("TlsGetValue"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("TlsGetValue");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwTlsIndex;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LPVOID"),
                  PD_MAKESTR("TlsGetValue"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 733, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = TlsGetValue( (DWORD) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 733, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 734, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_TlsSetValue( DWORD dwTlsIndex,
                             LPVOID lpTlsValue
                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("TlsSetValue"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("TlsSetValue");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) dwTlsIndex;
   uapsave[1] =
      uap[1] = (LPVOID) lpTlsValue;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("TlsSetValue"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 734, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = TlsSetValue( (DWORD) uapascii[0],
                             (LPVOID) uapascii[1]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 734, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 735, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_TransactNamedPipe( HANDLE hNamedPipe,
                                   LPVOID lpInBuffer,
                                   DWORD nInBufferSize,
                                   LPVOID lpOutBuffer,
                                   DWORD nOutBufferSize,
                                   LPDWORD lpBytesRead,
                                   LPOVERLAPPED lpOverlapped
                                 )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[7];
   LPVOID uap[7];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("TransactNamedPipe"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("TransactNamedPipe");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hNamedPipe;
   uapsave[1] =
      uap[1] = (LPVOID) lpInBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nInBufferSize;
   uapsave[3] =
      uap[3] = (LPVOID) lpOutBuffer;
   uapsave[4] =
      uap[4] = (LPVOID) nOutBufferSize;
   uapsave[5] =
      uap[5] = (LPVOID) lpBytesRead;
   uapsave[6] =
      uap[6] = (LPVOID) lpOverlapped;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("TransactNamedPipe"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 735, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[7];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      uapascii[6] = uap[6];
      callRet = TransactNamedPipe( (HANDLE) uapascii[0],
                                   (LPVOID) uapascii[1],
                                   (DWORD) uapascii[2],
                                   (LPVOID) uapascii[3],
                                   (DWORD) uapascii[4],
                                   (LPDWORD) uapascii[5],
                                   (LPOVERLAPPED) uapascii[6]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 735, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 736, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_TransmitCommChar( HANDLE hFile,
                                  char cChar
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("TransmitCommChar"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("TransmitCommChar");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) cChar;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("TransmitCommChar"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 736, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = TransmitCommChar( (HANDLE) uapascii[0],
                                  (char) uapascii[1]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 736, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 737, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM_UnhandledExceptionFilter( struct _EXCEPTION_POINTERS * ExceptionInfo )
{
   LONG callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("UnhandledExceptionFilter"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("UnhandledExceptionFilter");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) ExceptionInfo;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("UnhandledExceptionFilter"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 737, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = UnhandledExceptionFilter( (struct _EXCEPTION_POINTERS *) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 737, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 738, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_UnlockFile( HANDLE hFile,
                            DWORD dwFileOffsetLow,
                            DWORD dwFileOffsetHigh,
                            DWORD nNumberOfBytesToUnlockLow,
                            DWORD nNumberOfBytesToUnlockHigh
                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("UnlockFile"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("UnlockFile");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) dwFileOffsetLow;
   uapsave[2] =
      uap[2] = (LPVOID) dwFileOffsetHigh;
   uapsave[3] =
      uap[3] = (LPVOID) nNumberOfBytesToUnlockLow;
   uapsave[4] =
      uap[4] = (LPVOID) nNumberOfBytesToUnlockHigh;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("UnlockFile"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 738, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = UnlockFile( (HANDLE) uapascii[0],
                            (DWORD) uapascii[1],
                            (DWORD) uapascii[2],
                            (DWORD) uapascii[3],
                            (DWORD) uapascii[4]
                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 738, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 739, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_UnlockFileEx( HANDLE hFile,
                              DWORD dwReserved,
                              DWORD nNumberOfBytesToUnlockLow,
                              DWORD nNumberOfBytesToUnlockHigh,
                              LPOVERLAPPED lpOverlapped
                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("UnlockFileEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("UnlockFileEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) dwReserved;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfBytesToUnlockLow;
   uapsave[3] =
      uap[3] = (LPVOID) nNumberOfBytesToUnlockHigh;
   uapsave[4] =
      uap[4] = (LPVOID) lpOverlapped;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("UnlockFileEx"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 739, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = UnlockFileEx( (HANDLE) uapascii[0],
                              (DWORD) uapascii[1],
                              (DWORD) uapascii[2],
                              (DWORD) uapascii[3],
                              (LPOVERLAPPED) uapascii[4]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 739, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 740, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_UnlockServiceDatabase( SC_LOCK ScLock )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("UnlockServiceDatabase"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("UnlockServiceDatabase");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) ScLock;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("UnlockServiceDatabase"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 740, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = UnlockServiceDatabase( (SC_LOCK) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 740, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 741, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_UnmapViewOfFile( LPCVOID lpBaseAddress )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("UnmapViewOfFile"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("UnmapViewOfFile");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpBaseAddress;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("UnmapViewOfFile"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 741, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = UnmapViewOfFile( (LPCVOID) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 741, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 742, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_UpdateResourceA( HANDLE hUpdate,
                                 LPCSTR lpType,
                                 LPCSTR lpName,
                                 WORD wLanguage,
                                 LPVOID lpData,
                                 DWORD cbData
                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("UpdateResourceA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("UpdateResourceA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hUpdate;
   uapsave[1] =
      uap[1] = (LPVOID) ((HIWORD(lpType)==0)? (LPVOID) lpType : (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpType ));
   uapsave[2] =
      uap[2] = (LPVOID) ((HIWORD(lpName)==0)? (LPVOID) lpName : (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpName ));
   uapsave[3] =
      uap[3] = (LPVOID) wLanguage;
   uapsave[4] =
      uap[4] = (LPVOID) lpData;
   uapsave[5] =
      uap[5] = (LPVOID) cbData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("UpdateResourceA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) ((HIWORD(uap[1])==0)? PD_MAKESTR("<resource id>") : uap[1]),
                  uap[2],
                  (LPCWSTR) ((HIWORD(uap[2])==0)? PD_MAKESTR("<resource id>") : uap[2]),
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 742, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[6];
      uapascii[0] = uap[0];
      uapascii[1] =
         ((HIWORD(lpType)==0)? (LPVOID) lpType : (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] ));
      uapascii[2] =
         ((HIWORD(lpName)==0)? (LPVOID) lpName : (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] ));
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      callRet = UpdateResourceA( (HANDLE) uapascii[0],
                                 (LPCSTR) uapascii[1],
                                 (LPCSTR) uapascii[2],
                                 (WORD) uapascii[3],
                                 (LPVOID) uapascii[4],
                                 (DWORD) uapascii[5]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[1] && ( HIWORD(uapascii[1]) != 0 ) )
         free( (PVOID)uapascii[1] );
      if( uapascii[2] && ( HIWORD(uapascii[2]) != 0 ) )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 742, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] && ( HIWORD(uapsave[1]) != 0 ) )
      free( (PVOID)uapsave[1] );
   if( uapsave[2] && ( HIWORD(uapsave[2]) != 0 ) )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 743, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_UpdateResourceW( HANDLE hUpdate,
                                 LPCWSTR lpType,
                                 LPCWSTR lpName,
                                 WORD wLanguage,
                                 LPVOID lpData,
                                 DWORD cbData
                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[6];
   LPVOID uap[6];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("UpdateResourceW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("UpdateResourceW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hUpdate;
   uapsave[1] =
      uap[1] = (LPVOID) lpType;
   uapsave[2] =
      uap[2] = (LPVOID) lpName;
   uapsave[3] =
      uap[3] = (LPVOID) wLanguage;
   uapsave[4] =
      uap[4] = (LPVOID) lpData;
   uapsave[5] =
      uap[5] = (LPVOID) cbData;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("UpdateResourceW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) ((HIWORD(uap[1])==0)? PD_MAKESTR("<resource id>") : uap[1]),
                  uap[2],
                  (LPCWSTR) ((HIWORD(uap[2])==0)? PD_MAKESTR("<resource id>") : uap[2]),
                  uap[3],
                  uap[4],
                  uap[5]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 743, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = UpdateResourceW( (HANDLE) uap[0],
                                 (LPCWSTR) uap[1],
                                 (LPCWSTR) uap[2],
                                 (WORD) uap[3],
                                 (LPVOID) uap[4],
                                 (DWORD) uap[5]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 743, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 744, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_VerifyVersionInfoA( LPOSVERSIONINFOEXA lpVersionInformation,
                                    DWORD dwTypeMask,
                                    DWORDLONG dwlConditionMask
                                  )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VerifyVersionInfoA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VerifyVersionInfoA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpVersionInformation;
   uapsave[1] =
      uap[1] = (LPVOID) dwTypeMask;
   uapsave[2] =
      uap[2] = (LPVOID) dwlConditionMask;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("VerifyVersionInfoA"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 744, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = VerifyVersionInfoA( (LPOSVERSIONINFOEXA) uapascii[0],
                                    (DWORD) uapascii[1],
                                    (DWORDLONG) uapascii[2]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 744, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 745, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_VerifyVersionInfoW( LPOSVERSIONINFOEXW lpVersionInformation,
                                    DWORD dwTypeMask,
                                    DWORDLONG dwlConditionMask
                                  )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VerifyVersionInfoW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VerifyVersionInfoW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpVersionInformation;
   uapsave[1] =
      uap[1] = (LPVOID) dwTypeMask;
   uapsave[2] =
      uap[2] = (LPVOID) dwlConditionMask;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("VerifyVersionInfoW"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 745, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = VerifyVersionInfoW( (LPOSVERSIONINFOEXW) uap[0],
                                    (DWORD) uap[1],
                                    (DWORDLONG) uap[2]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 745, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 746, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LPVOID WINAPI LWM_VirtualAlloc( LPVOID lpAddress,
                                SIZE_T dwSize,
                                DWORD flAllocationType,
                                DWORD flProtect
                              )
{
   LPVOID callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VirtualAlloc"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VirtualAlloc");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpAddress;
   uapsave[1] =
      uap[1] = (LPVOID) dwSize;
   uapsave[2] =
      uap[2] = (LPVOID) flAllocationType;
   uapsave[3] =
      uap[3] = (LPVOID) flProtect;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LPVOID"),
                  PD_MAKESTR("VirtualAlloc"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 746, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = VirtualAlloc( (LPVOID) uapascii[0],
                              (SIZE_T) uapascii[1],
                              (DWORD) uapascii[2],
                              (DWORD) uapascii[3]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 746, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 747, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LPVOID WINAPI LWM_VirtualAllocEx( HANDLE hProcess,
                                  LPVOID lpAddress,
                                  SIZE_T dwSize,
                                  DWORD flAllocationType,
                                  DWORD flProtect
                                )
{
   LPVOID callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VirtualAllocEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VirtualAllocEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) lpAddress;
   uapsave[2] =
      uap[2] = (LPVOID) dwSize;
   uapsave[3] =
      uap[3] = (LPVOID) flAllocationType;
   uapsave[4] =
      uap[4] = (LPVOID) flProtect;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LPVOID"),
                  PD_MAKESTR("VirtualAllocEx"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 747, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = VirtualAllocEx( (HANDLE) uapascii[0],
                                (LPVOID) uapascii[1],
                                (SIZE_T) uapascii[2],
                                (DWORD) uapascii[3],
                                (DWORD) uapascii[4]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 747, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 748, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_VirtualFree( LPVOID lpAddress,
                             SIZE_T dwSize,
                             DWORD dwFreeType
                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VirtualFree"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VirtualFree");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpAddress;
   uapsave[1] =
      uap[1] = (LPVOID) dwSize;
   uapsave[2] =
      uap[2] = (LPVOID) dwFreeType;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("VirtualFree"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 748, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = VirtualFree( (LPVOID) uapascii[0],
                             (SIZE_T) uapascii[1],
                             (DWORD) uapascii[2]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 748, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 749, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_VirtualFreeEx( HANDLE hProcess,
                               LPVOID lpAddress,
                               SIZE_T dwSize,
                               DWORD dwFreeType
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VirtualFreeEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VirtualFreeEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) lpAddress;
   uapsave[2] =
      uap[2] = (LPVOID) dwSize;
   uapsave[3] =
      uap[3] = (LPVOID) dwFreeType;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("VirtualFreeEx"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 749, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = VirtualFreeEx( (HANDLE) uapascii[0],
                               (LPVOID) uapascii[1],
                               (SIZE_T) uapascii[2],
                               (DWORD) uapascii[3]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 749, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 750, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_VirtualLock( LPVOID lpAddress,
                             SIZE_T dwSize
                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VirtualLock"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VirtualLock");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpAddress;
   uapsave[1] =
      uap[1] = (LPVOID) dwSize;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("VirtualLock"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 750, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = VirtualLock( (LPVOID) uapascii[0],
                             (SIZE_T) uapascii[1]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 750, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 751, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_VirtualProtect( LPVOID lpAddress,
                                SIZE_T dwSize,
                                DWORD flNewProtect,
                                PDWORD lpflOldProtect
                              )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VirtualProtect"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VirtualProtect");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpAddress;
   uapsave[1] =
      uap[1] = (LPVOID) dwSize;
   uapsave[2] =
      uap[2] = (LPVOID) flNewProtect;
   uapsave[3] =
      uap[3] = (LPVOID) lpflOldProtect;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("VirtualProtect"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 751, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = VirtualProtect( (LPVOID) uapascii[0],
                                (SIZE_T) uapascii[1],
                                (DWORD) uapascii[2],
                                (PDWORD) uapascii[3]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 751, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 752, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_VirtualProtectEx( HANDLE hProcess,
                                  LPVOID lpAddress,
                                  SIZE_T dwSize,
                                  DWORD flNewProtect,
                                  PDWORD lpflOldProtect
                                )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VirtualProtectEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VirtualProtectEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) lpAddress;
   uapsave[2] =
      uap[2] = (LPVOID) dwSize;
   uapsave[3] =
      uap[3] = (LPVOID) flNewProtect;
   uapsave[4] =
      uap[4] = (LPVOID) lpflOldProtect;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("VirtualProtectEx"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 752, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = VirtualProtectEx( (HANDLE) uapascii[0],
                                  (LPVOID) uapascii[1],
                                  (SIZE_T) uapascii[2],
                                  (DWORD) uapascii[3],
                                  (PDWORD) uapascii[4]
                               );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 752, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 753, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_VirtualQuery( LPCVOID lpAddress,
                               PMEMORY_BASIC_INFORMATION lpBuffer,
                               DWORD dwLength
                             )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VirtualQuery"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VirtualQuery");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpAddress;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) dwLength;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("VirtualQuery"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 753, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = VirtualQuery( (LPCVOID) uapascii[0],
                              (PMEMORY_BASIC_INFORMATION) uapascii[1],
                              (DWORD) uapascii[2]
                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 753, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 754, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_VirtualQueryEx( HANDLE hProcess,
                                 LPCVOID lpAddress,
                                 PMEMORY_BASIC_INFORMATION lpBuffer,
                                 DWORD dwLength
                               )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VirtualQueryEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VirtualQueryEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) lpAddress;
   uapsave[2] =
      uap[2] = (LPVOID) lpBuffer;
   uapsave[3] =
      uap[3] = (LPVOID) dwLength;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("VirtualQueryEx"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 754, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = VirtualQueryEx( (HANDLE) uapascii[0],
                                (LPCVOID) uapascii[1],
                                (PMEMORY_BASIC_INFORMATION) uapascii[2],
                                (DWORD) uapascii[3]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 754, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 755, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_VirtualUnlock( LPVOID lpAddress,
                               SIZE_T dwSize
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("VirtualUnlock"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("VirtualUnlock");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpAddress;
   uapsave[1] =
      uap[1] = (LPVOID) dwSize;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("VirtualUnlock"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 755, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = VirtualUnlock( (LPVOID) uapascii[0],
                               (SIZE_T) uapascii[1]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 755, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 756, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WaitCommEvent( HANDLE hFile,
                               LPDWORD lpEvtMask,
                               LPOVERLAPPED lpOverlapped
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WaitCommEvent"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WaitCommEvent");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lpEvtMask;
   uapsave[2] =
      uap[2] = (LPVOID) lpOverlapped;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WaitCommEvent"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 756, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = WaitCommEvent( (HANDLE) uapascii[0],
                               (LPDWORD) uapascii[1],
                               (LPOVERLAPPED) uapascii[2]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 756, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 757, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WaitForDebugEvent( LPDEBUG_EVENT lpDebugEvent,
                                   DWORD dwMilliseconds
                                 )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WaitForDebugEvent"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WaitForDebugEvent");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpDebugEvent;
   uapsave[1] =
      uap[1] = (LPVOID) dwMilliseconds;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WaitForDebugEvent"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 757, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = WaitForDebugEvent( (LPDEBUG_EVENT) uapascii[0],
                                   (DWORD) uapascii[1]
                                );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 757, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 758, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_WaitForMultipleObjects( DWORD nCount,
                                         const HANDLE * lpHandles,
                                         BOOL bWaitAll,
                                         DWORD dwMilliseconds
                                       )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WaitForMultipleObjects"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WaitForMultipleObjects");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) nCount;
   uapsave[1] =
      uap[1] = (LPVOID) lpHandles;
   uapsave[2] =
      uap[2] = (LPVOID) bWaitAll;
   uapsave[3] =
      uap[3] = (LPVOID) dwMilliseconds;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("WaitForMultipleObjects"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 758, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = WaitForMultipleObjects( (DWORD) uapascii[0],
                                        (const HANDLE *) uapascii[1],
                                        (BOOL) uapascii[2],
                                        (DWORD) uapascii[3]
                                     );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 758, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 759, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_WaitForMultipleObjectsEx( DWORD nCount,
                                           const HANDLE * lpHandles,
                                           BOOL bWaitAll,
                                           DWORD dwMilliseconds,
                                           BOOL bAlertable
                                         )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WaitForMultipleObjectsEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WaitForMultipleObjectsEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) nCount;
   uapsave[1] =
      uap[1] = (LPVOID) lpHandles;
   uapsave[2] =
      uap[2] = (LPVOID) bWaitAll;
   uapsave[3] =
      uap[3] = (LPVOID) dwMilliseconds;
   uapsave[4] =
      uap[4] = (LPVOID) bAlertable;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("WaitForMultipleObjectsEx"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 759, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = WaitForMultipleObjectsEx( (DWORD) uapascii[0],
                                          (const HANDLE *) uapascii[1],
                                          (BOOL) uapascii[2],
                                          (DWORD) uapascii[3],
                                          (BOOL) uapascii[4]
                                       );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 759, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 760, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_WaitForSingleObject( HANDLE hHandle,
                                      DWORD dwMilliseconds
                                    )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WaitForSingleObject"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WaitForSingleObject");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hHandle;
   uapsave[1] =
      uap[1] = (LPVOID) dwMilliseconds;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("WaitForSingleObject"),
                  uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 760, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      callRet = WaitForSingleObject( (HANDLE) uapascii[0],
                                     (DWORD) uapascii[1]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 760, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 761, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_WaitForSingleObjectEx( HANDLE hHandle,
                                        DWORD dwMilliseconds,
                                        BOOL bAlertable
                                      )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WaitForSingleObjectEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WaitForSingleObjectEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hHandle;
   uapsave[1] =
      uap[1] = (LPVOID) dwMilliseconds;
   uapsave[2] =
      uap[2] = (LPVOID) bAlertable;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("WaitForSingleObjectEx"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 761, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = WaitForSingleObjectEx( (HANDLE) uapascii[0],
                                       (DWORD) uapascii[1],
                                       (BOOL) uapascii[2]
                                    );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 761, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 762, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WaitNamedPipeA( LPCSTR lpNamedPipeName,
                                DWORD nTimeOut
                              )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WaitNamedPipeA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WaitNamedPipeA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpNamedPipeName );
   uapsave[1] =
      uap[1] = (LPVOID) nTimeOut;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WaitNamedPipeA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 762, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      callRet = WaitNamedPipeA( (LPCSTR) uapascii[0],
                                (DWORD) uapascii[1]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 762, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 763, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WaitNamedPipeW( LPCWSTR lpNamedPipeName,
                                DWORD nTimeOut
                              )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WaitNamedPipeW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WaitNamedPipeW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpNamedPipeName;
   uapsave[1] =
      uap[1] = (LPVOID) nTimeOut;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WaitNamedPipeW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 763, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = WaitNamedPipeW( (LPCWSTR) uap[0],
                                (DWORD) uap[1]
                             );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 763, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 764, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

int WINAPI LWM_WideCharToMultiByte( UINT CodePage,
                                    DWORD dwFlags,
                                    LPCWSTR lpWideCharStr,
                                    int cchWideChar,
                                    LPSTR lpMultiByteStr,
                                    int cbMultiByte,
                                    LPCSTR lpDefaultChar,
                                    LPBOOL lpUsedDefaultChar
                                  )
{
   int callRet = {NULL};
   LPVOID uapsave[8];
   LPVOID uap[8];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WideCharToMultiByte"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WideCharToMultiByte");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) CodePage;
   uapsave[1] =
      uap[1] = (LPVOID) dwFlags;
   uapsave[2] =
      uap[2] = (LPVOID) lpWideCharStr;
   uapsave[3] =
      uap[3] = (LPVOID) cchWideChar;
   uapsave[4] =
      uap[4] = (LPVOID) lpMultiByteStr;
   uapsave[5] =
      uap[5] = (LPVOID) cbMultiByte;
   uapsave[6] =
      uap[6] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpDefaultChar );
   uapsave[7] =
      uap[7] = (LPVOID) lpUsedDefaultChar;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("int"),
                  PD_MAKESTR("WideCharToMultiByte"),
                  uap[0],
                  uap[1],
                  uap[2],
                  (LPCWSTR) uap[2],
                  uap[3],
                  uap[4],
                  uap[5],
                  uap[6],
                  (LPCWSTR) uap[6],
                  uap[7]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 764, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[8];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      uapascii[5] = uap[5];
      uapascii[6] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[6] );
      uapascii[7] = uap[7];
      callRet = WideCharToMultiByte( (UINT) uapascii[0],
                                     (DWORD) uapascii[1],
                                     (LPCWSTR) uapascii[2],
                                     (int) uapascii[3],
                                     (LPSTR) uapascii[4],
                                     (int) uapascii[5],
                                     (LPCSTR) uapascii[6],
                                     (LPBOOL) uapascii[7]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[6] )
         free( (PVOID)uapascii[6] );

      retval = hook->callDispatchPost( /*space*/ 0, 764, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[6] )
      free( (PVOID)uapsave[6] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 765, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

UINT WINAPI LWM_WinExec( LPCSTR lpCmdLine,
                         UINT uCmdShow
                       )
{
   UINT callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WinExec"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WinExec");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpCmdLine );
   uapsave[1] =
      uap[1] = (LPVOID) uCmdShow;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("UINT"),
                  PD_MAKESTR("WinExec"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 765, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      callRet = WinExec( (LPCSTR) uapascii[0],
                         (UINT) uapascii[1]
                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 765, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 766, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteConsoleA( HANDLE hConsoleOutput,
                               const void * lpBuffer,
                               DWORD nNumberOfCharsToWrite,
                               LPDWORD lpNumberOfCharsWritten,
                               LPVOID lpReserved
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteConsoleA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteConsoleA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfCharsToWrite;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfCharsWritten;
   uapsave[4] =
      uap[4] = (LPVOID) lpReserved;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteConsoleA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 766, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = WriteConsoleA( (HANDLE) uapascii[0],
                               (const void *) uapascii[1],
                               (DWORD) uapascii[2],
                               (LPDWORD) uapascii[3],
                               (LPVOID) uapascii[4]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 766, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 767, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteConsoleInputA( HANDLE hConsoleInput,
                                    const INPUT_RECORD * lpBuffer,
                                    DWORD nLength,
                                    LPDWORD lpNumberOfEventsWritten
                                  )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteConsoleInputA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteConsoleInputA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleInput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfEventsWritten;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteConsoleInputA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 767, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = WriteConsoleInputA( (HANDLE) uapascii[0],
                                    (const INPUT_RECORD *) uapascii[1],
                                    (DWORD) uapascii[2],
                                    (LPDWORD) uapascii[3]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 767, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 768, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteConsoleInputW( HANDLE hConsoleInput,
                                    const INPUT_RECORD * lpBuffer,
                                    DWORD nLength,
                                    LPDWORD lpNumberOfEventsWritten
                                  )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteConsoleInputW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteConsoleInputW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleInput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfEventsWritten;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteConsoleInputW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 768, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = WriteConsoleInputW( (HANDLE) uap[0],
                                    (const INPUT_RECORD *) uap[1],
                                    (DWORD) uap[2],
                                    (LPDWORD) uap[3]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 768, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 769, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteConsoleOutputA( HANDLE hConsoleOutput,
                                     const CHAR_INFO * lpBuffer,
                                     COORD dwBufferSize,
                                     COORD dwBufferCoord,
                                     PSMALL_RECT lpWriteRegion
                                   )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteConsoleOutputA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteConsoleOutputA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) &dwBufferSize;
   uapsave[3] =
      uap[3] = (LPVOID) &dwBufferCoord;
   uapsave[4] =
      uap[4] = (LPVOID) lpWriteRegion;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteConsoleOutputA"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 769, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = WriteConsoleOutputA( (HANDLE) uapascii[0],
                                     (const CHAR_INFO *) uapascii[1],
                                    dwBufferSize,
                                    dwBufferCoord,
                                     (PSMALL_RECT) uapascii[4]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 769, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 770, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteConsoleOutputAttribute( HANDLE hConsoleOutput,
                                             const WORD * lpAttribute,
                                             DWORD nLength,
                                             COORD dwWriteCoord,
                                             LPDWORD lpNumberOfAttrsWritten
                                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteConsoleOutputAttribute"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteConsoleOutputAttribute");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpAttribute;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) &dwWriteCoord;
   uapsave[4] =
      uap[4] = (LPVOID) lpNumberOfAttrsWritten;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteConsoleOutputAttribute"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 770, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = WriteConsoleOutputAttribute( (HANDLE) uapascii[0],
                                             (const WORD *) uapascii[1],
                                             (DWORD) uapascii[2],
                                            dwWriteCoord,
                                             (LPDWORD) uapascii[4]
                                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 770, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 771, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteConsoleOutputCharacterA( HANDLE hConsoleOutput,
                                              LPCSTR lpCharacter,
                                              DWORD nLength,
                                              COORD dwWriteCoord,
                                              LPDWORD lpNumberOfCharsWritten
                                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteConsoleOutputCharacterA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteConsoleOutputCharacterA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpCharacter );
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) &dwWriteCoord;
   uapsave[4] =
      uap[4] = (LPVOID) lpNumberOfCharsWritten;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteConsoleOutputCharacterA"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 771, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = WriteConsoleOutputCharacterA( (HANDLE) uapascii[0],
                                              (LPCSTR) uapascii[1],
                                              (DWORD) uapascii[2],
                                             dwWriteCoord,
                                              (LPDWORD) uapascii[4]
                                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 771, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 772, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteConsoleOutputCharacterW( HANDLE hConsoleOutput,
                                              LPCWSTR lpCharacter,
                                              DWORD nLength,
                                              COORD dwWriteCoord,
                                              LPDWORD lpNumberOfCharsWritten
                                            )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteConsoleOutputCharacterW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteConsoleOutputCharacterW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpCharacter;
   uapsave[2] =
      uap[2] = (LPVOID) nLength;
   uapsave[3] =
      uap[3] = (LPVOID) &dwWriteCoord;
   uapsave[4] =
      uap[4] = (LPVOID) lpNumberOfCharsWritten;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteConsoleOutputCharacterW"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 772, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = WriteConsoleOutputCharacterW( (HANDLE) uap[0],
                                              (LPCWSTR) uap[1],
                                              (DWORD) uap[2],
                                             dwWriteCoord,
                                              (LPDWORD) uap[4]
                                           );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 772, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 773, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteConsoleOutputW( HANDLE hConsoleOutput,
                                     const CHAR_INFO * lpBuffer,
                                     COORD dwBufferSize,
                                     COORD dwBufferCoord,
                                     PSMALL_RECT lpWriteRegion
                                   )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteConsoleOutputW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteConsoleOutputW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) &dwBufferSize;
   uapsave[3] =
      uap[3] = (LPVOID) &dwBufferCoord;
   uapsave[4] =
      uap[4] = (LPVOID) lpWriteRegion;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteConsoleOutputW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 773, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = WriteConsoleOutputW( (HANDLE) uap[0],
                                     (const CHAR_INFO *) uap[1],
                                    dwBufferSize,
                                    dwBufferCoord,
                                     (PSMALL_RECT) uap[4]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 773, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 774, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteConsoleW( HANDLE hConsoleOutput,
                               const void * lpBuffer,
                               DWORD nNumberOfCharsToWrite,
                               LPDWORD lpNumberOfCharsWritten,
                               LPVOID lpReserved
                             )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteConsoleW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteConsoleW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hConsoleOutput;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfCharsToWrite;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfCharsWritten;
   uapsave[4] =
      uap[4] = (LPVOID) lpReserved;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteConsoleW"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 774, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = WriteConsoleW( (HANDLE) uap[0],
                               (const void *) uap[1],
                               (DWORD) uap[2],
                               (LPDWORD) uap[3],
                               (LPVOID) uap[4]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 774, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 775, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteFile( HANDLE hFile,
                           LPCVOID lpBuffer,
                           DWORD nNumberOfBytesToWrite,
                           LPDWORD lpNumberOfBytesWritten,
                           LPOVERLAPPED lpOverlapped
                         )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteFile"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteFile");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfBytesToWrite;
   uapsave[3] =
      uap[3] = (LPVOID) lpNumberOfBytesWritten;
   uapsave[4] =
      uap[4] = (LPVOID) lpOverlapped;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteFile"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 775, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = WriteFile( (HANDLE) uapascii[0],
                           (LPCVOID) uapascii[1],
                           (DWORD) uapascii[2],
                           (LPDWORD) uapascii[3],
                           (LPOVERLAPPED) uapascii[4]
                        );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 775, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 776, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteFileEx( HANDLE hFile,
                             LPCVOID lpBuffer,
                             DWORD nNumberOfBytesToWrite,
                             LPOVERLAPPED lpOverlapped,
                             LPOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteFileEx"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteFileEx");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfBytesToWrite;
   uapsave[3] =
      uap[3] = (LPVOID) lpOverlapped;
   uapsave[4] =
      uap[4] = (LPVOID) lpCompletionRoutine;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteFileEx"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 776, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = WriteFileEx( (HANDLE) uapascii[0],
                             (LPCVOID) uapascii[1],
                             (DWORD) uapascii[2],
                             (LPOVERLAPPED) uapascii[3],
                             (LPOVERLAPPED_COMPLETION_ROUTINE) uapascii[4]
                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 776, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 777, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteFileGather( HANDLE hFile,
                                 FILE_SEGMENT_ELEMENT aSegmentArray [ ],
                                 DWORD nNumberOfBytesToWrite,
                                 LPDWORD lpReserved,
                                 LPOVERLAPPED lpOverlapped
                               )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteFileGather"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteFileGather");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) aSegmentArray;
   uapsave[2] =
      uap[2] = (LPVOID) nNumberOfBytesToWrite;
   uapsave[3] =
      uap[3] = (LPVOID) lpReserved;
   uapsave[4] =
      uap[4] = (LPVOID) lpOverlapped;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteFileGather"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 777, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] = uap[4];
      callRet = WriteFileGather( (HANDLE) uapascii[0],
                                 (FILE_SEGMENT_ELEMENT *) uapascii[1],
                                 (DWORD) uapascii[2],
                                 (LPDWORD) uapascii[3],
                                 (LPOVERLAPPED) uapascii[4]
                              );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 777, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 778, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WritePrivateProfileSectionA( LPCSTR lpAppName,
                                             LPCSTR lpString,
                                             LPCSTR lpFileName
                                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WritePrivateProfileSectionA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WritePrivateProfileSectionA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpAppName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpString );
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpFileName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WritePrivateProfileSectionA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 778, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      callRet = WritePrivateProfileSectionA( (LPCSTR) uapascii[0],
                                             (LPCSTR) uapascii[1],
                                             (LPCSTR) uapascii[2]
                                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );
      if( uapascii[2] )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 778, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );
   if( uapsave[2] )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 779, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WritePrivateProfileSectionW( LPCWSTR lpAppName,
                                             LPCWSTR lpString,
                                             LPCWSTR lpFileName
                                           )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WritePrivateProfileSectionW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WritePrivateProfileSectionW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpAppName;
   uapsave[1] =
      uap[1] = (LPVOID) lpString;
   uapsave[2] =
      uap[2] = (LPVOID) lpFileName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WritePrivateProfileSectionW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 779, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = WritePrivateProfileSectionW( (LPCWSTR) uap[0],
                                             (LPCWSTR) uap[1],
                                             (LPCWSTR) uap[2]
                                          );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 779, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 780, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WritePrivateProfileStringA( LPCSTR lpAppName,
                                            LPCSTR lpKeyName,
                                            LPCSTR lpString,
                                            LPCSTR lpFileName
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WritePrivateProfileStringA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WritePrivateProfileStringA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpAppName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpKeyName );
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpString );
   uapsave[3] =
      uap[3] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpFileName );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WritePrivateProfileStringA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2],
                  uap[3],
                  (LPCWSTR) uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 780, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      uapascii[3] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[3] );
      callRet = WritePrivateProfileStringA( (LPCSTR) uapascii[0],
                                            (LPCSTR) uapascii[1],
                                            (LPCSTR) uapascii[2],
                                            (LPCSTR) uapascii[3]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );
      if( uapascii[2] )
         free( (PVOID)uapascii[2] );
      if( uapascii[3] )
         free( (PVOID)uapascii[3] );

      retval = hook->callDispatchPost( /*space*/ 0, 780, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );
   if( uapsave[2] )
      free( (PVOID)uapsave[2] );
   if( uapsave[3] )
      free( (PVOID)uapsave[3] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 781, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WritePrivateProfileStringW( LPCWSTR lpAppName,
                                            LPCWSTR lpKeyName,
                                            LPCWSTR lpString,
                                            LPCWSTR lpFileName
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WritePrivateProfileStringW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WritePrivateProfileStringW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpAppName;
   uapsave[1] =
      uap[1] = (LPVOID) lpKeyName;
   uapsave[2] =
      uap[2] = (LPVOID) lpString;
   uapsave[3] =
      uap[3] = (LPVOID) lpFileName;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WritePrivateProfileStringW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2],
                  uap[3],
                  (LPCWSTR) uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 781, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = WritePrivateProfileStringW( (LPCWSTR) uap[0],
                                            (LPCWSTR) uap[1],
                                            (LPCWSTR) uap[2],
                                            (LPCWSTR) uap[3]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 781, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 782, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WritePrivateProfileStructA( LPCSTR lpszSection,
                                            LPCSTR lpszKey,
                                            LPVOID lpStruct,
                                            UINT uSizeStruct,
                                            LPCSTR szFile
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WritePrivateProfileStructA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WritePrivateProfileStructA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpszSection );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpszKey );
   uapsave[2] =
      uap[2] = (LPVOID) lpStruct;
   uapsave[3] =
      uap[3] = (LPVOID) uSizeStruct;
   uapsave[4] =
      uap[4] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)szFile );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WritePrivateProfileStructA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  (LPCWSTR) uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 782, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      uapascii[4] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[4] );
      callRet = WritePrivateProfileStructA( (LPCSTR) uapascii[0],
                                            (LPCSTR) uapascii[1],
                                            (LPVOID) uapascii[2],
                                            (UINT) uapascii[3],
                                            (LPCSTR) uapascii[4]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );
      if( uapascii[4] )
         free( (PVOID)uapascii[4] );

      retval = hook->callDispatchPost( /*space*/ 0, 782, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );
   if( uapsave[4] )
      free( (PVOID)uapsave[4] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 783, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WritePrivateProfileStructW( LPCWSTR lpszSection,
                                            LPCWSTR lpszKey,
                                            LPVOID lpStruct,
                                            UINT uSizeStruct,
                                            LPCWSTR szFile
                                          )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WritePrivateProfileStructW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WritePrivateProfileStructW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpszSection;
   uapsave[1] =
      uap[1] = (LPVOID) lpszKey;
   uapsave[2] =
      uap[2] = (LPVOID) lpStruct;
   uapsave[3] =
      uap[3] = (LPVOID) uSizeStruct;
   uapsave[4] =
      uap[4] = (LPVOID) szFile;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x 0x%x 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WritePrivateProfileStructW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  uap[3],
                  uap[4],
                  (LPCWSTR) uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 783, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = WritePrivateProfileStructW( (LPCWSTR) uap[0],
                                            (LPCWSTR) uap[1],
                                            (LPVOID) uap[2],
                                            (UINT) uap[3],
                                            (LPCWSTR) uap[4]
                                         );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 783, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 784, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteProcessMemory( HANDLE hProcess,
                                    LPVOID lpBaseAddress,
                                    LPVOID lpBuffer,
                                    DWORD nSize,
                                    LPDWORD lpNumberOfBytesWritten
                                  )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[5];
   LPVOID uap[5];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteProcessMemory"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteProcessMemory");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hProcess;
   uapsave[1] =
      uap[1] = (LPVOID) lpBaseAddress;
   uapsave[2] =
      uap[2] = (LPVOID) lpBuffer;
   uapsave[3] =
      uap[3] = (LPVOID) ( nSize * sizeof(pd_char_t) );
   uapsave[4] =
      uap[4] = (LPVOID) lpNumberOfBytesWritten;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteProcessMemory"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3],
                  uap[4]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 784, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[5];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = (LPVOID) nSize;
      uapascii[4] = uap[4];
      callRet = WriteProcessMemory( (HANDLE) uapascii[0],
                                    (LPVOID) uapascii[1],
                                    (LPVOID) uapascii[2],
                                    (DWORD) uapascii[3],
                                    (LPDWORD) uapascii[4]
                                 );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 784, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 785, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteProfileSectionA( LPCSTR lpAppName,
                                      LPCSTR lpString
                                    )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteProfileSectionA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteProfileSectionA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpAppName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpString );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteProfileSectionA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 785, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      callRet = WriteProfileSectionA( (LPCSTR) uapascii[0],
                                      (LPCSTR) uapascii[1]
                                   );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 785, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 786, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteProfileSectionW( LPCWSTR lpAppName,
                                      LPCWSTR lpString
                                    )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteProfileSectionW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteProfileSectionW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpAppName;
   uapsave[1] =
      uap[1] = (LPVOID) lpString;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteProfileSectionW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 786, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = WriteProfileSectionW( (LPCWSTR) uap[0],
                                      (LPCWSTR) uap[1]
                                   );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 786, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 787, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteProfileStringA( LPCSTR lpAppName,
                                     LPCSTR lpKeyName,
                                     LPCSTR lpString
                                   )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteProfileStringA"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteProfileStringA");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpAppName );
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpKeyName );
   uapsave[2] =
      uap[2] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpString );
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteProfileStringA"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 787, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[2] );
      callRet = WriteProfileStringA( (LPCSTR) uapascii[0],
                                     (LPCSTR) uapascii[1],
                                     (LPCSTR) uapascii[2]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );
      if( uapascii[1] )
         free( (PVOID)uapascii[1] );
      if( uapascii[2] )
         free( (PVOID)uapascii[2] );

      retval = hook->callDispatchPost( /*space*/ 0, 787, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );
   if( uapsave[1] )
      free( (PVOID)uapsave[1] );
   if( uapsave[2] )
      free( (PVOID)uapsave[2] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 788, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

BOOL WINAPI LWM_WriteProfileStringW( LPCWSTR lpAppName,
                                     LPCWSTR lpKeyName,
                                     LPCWSTR lpString
                                   )
{
   BOOL callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteProfileStringW"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteProfileStringW");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) lpAppName;
   uapsave[1] =
      uap[1] = (LPVOID) lpKeyName;
   uapsave[2] =
      uap[2] = (LPVOID) lpString;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x:\"%s\" 0x%x:\"%s\" )"),
                  g_tracecount++,
                  PD_MAKESTR("BOOL"),
                  PD_MAKESTR("WriteProfileStringW"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2],
                  (LPCWSTR) uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 788, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      callRet = WriteProfileStringW( (LPCWSTR) uap[0],
                                     (LPCWSTR) uap[1],
                                     (LPCWSTR) uap[2]
                                  );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> %s\n"), callRet ? PD_MAKESTR("TRUE") : PD_MAKESTR("FALSE") );


      retval = hook->callDispatchPost( /*space*/ 0, 788, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 789, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

DWORD WINAPI LWM_WriteTapemark( HANDLE hDevice,
                                DWORD dwTapemarkType,
                                DWORD dwTapemarkCount,
                                BOOL bImmediate
                              )
{
   DWORD callRet = {NULL};
   LPVOID uapsave[4];
   LPVOID uap[4];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("WriteTapemark"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("WriteTapemark");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hDevice;
   uapsave[1] =
      uap[1] = (LPVOID) dwTapemarkType;
   uapsave[2] =
      uap[2] = (LPVOID) dwTapemarkCount;
   uapsave[3] =
      uap[3] = (LPVOID) bImmediate;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("DWORD"),
                  PD_MAKESTR("WriteTapemark"),
                  uap[0],
                  uap[1],
                  uap[2],
                  uap[3]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 789, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[4];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      uapascii[3] = uap[3];
      callRet = WriteTapemark( (HANDLE) uapascii[0],
                               (DWORD) uapascii[1],
                               (DWORD) uapascii[2],
                               (BOOL) uapascii[3]
                            );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 789, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 790, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

long WINAPI LWM__hread( HFILE hFile,
                        LPVOID lpBuffer,
                        long lBytes
                      )
{
   long callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("_hread"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("_hread");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) lBytes;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("long"),
                  PD_MAKESTR("_hread"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 790, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = _hread( (HFILE) uapascii[0],
                        (LPVOID) uapascii[1],
                        (long) uapascii[2]
                     );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 790, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 791, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

long WINAPI LWM__hwrite( HFILE hFile,
                         LPCSTR lpBuffer,
                         long lBytes
                       )
{
   long callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("_hwrite"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("_hwrite");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpBuffer );
   uapsave[2] =
      uap[2] = (LPVOID) lBytes;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("long"),
                  PD_MAKESTR("_hwrite"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 791, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      callRet = _hwrite( (HFILE) uapascii[0],
                         (LPCSTR) uapascii[1],
                         (long) uapascii[2]
                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 791, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 792, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HFILE WINAPI LWM__lclose( HFILE hFile )
{
   HFILE callRet = {NULL};
   LPVOID uapsave[1];
   LPVOID uap[1];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("_lclose"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("_lclose");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("HFILE"),
                  PD_MAKESTR("_lclose"),
                  uap[0]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 792, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[1];
      uapascii[0] = uap[0];
      callRet = _lclose( (HFILE) uapascii[0]);

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 792, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 793, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HFILE WINAPI LWM__lcreat( LPCSTR lpPathName,
                          int iAttribute
                        )
{
   HFILE callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("_lcreat"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("_lcreat");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpPathName );
   uapsave[1] =
      uap[1] = (LPVOID) iAttribute;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("HFILE"),
                  PD_MAKESTR("_lcreat"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 793, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      callRet = _lcreat( (LPCSTR) uapascii[0],
                         (int) uapascii[1]
                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 793, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 794, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

LONG WINAPI LWM__llseek( HFILE hFile,
                         LONG lOffset,
                         int iOrigin
                       )
{
   LONG callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("_llseek"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("_llseek");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lOffset;
   uapsave[2] =
      uap[2] = (LPVOID) iOrigin;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("LONG"),
                  PD_MAKESTR("_llseek"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 794, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = _llseek( (HFILE) uapascii[0],
                         (LONG) uapascii[1],
                         (int) uapascii[2]
                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 794, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 795, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

HFILE WINAPI LWM__lopen( LPCSTR lpPathName,
                         int iReadWrite
                       )
{
   HFILE callRet = {NULL};
   LPVOID uapsave[2];
   LPVOID uap[2];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("_lopen"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("_lopen");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpPathName );
   uapsave[1] =
      uap[1] = (LPVOID) iReadWrite;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("HFILE"),
                  PD_MAKESTR("_lopen"),
                  uap[0],
                  (LPCWSTR) uap[0],
                  uap[1]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 795, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[2];
      uapascii[0] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[0] );
      uapascii[1] = uap[1];
      callRet = _lopen( (LPCSTR) uapascii[0],
                        (int) uapascii[1]
                     );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[0] )
         free( (PVOID)uapascii[0] );

      retval = hook->callDispatchPost( /*space*/ 0, 795, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[0] )
      free( (PVOID)uapsave[0] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 796, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

UINT WINAPI LWM__lread( HFILE hFile,
                        LPVOID lpBuffer,
                        UINT uBytes
                      )
{
   UINT callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("_lread"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("_lread");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) lpBuffer;
   uapsave[2] =
      uap[2] = (LPVOID) uBytes;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("UINT"),
                  PD_MAKESTR("_lread"),
                  uap[0],
                  uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 796, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] = uap[1];
      uapascii[2] = uap[2];
      callRet = _lread( (HFILE) uapascii[0],
                        (LPVOID) uapascii[1],
                        (UINT) uapascii[2]
                     );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );


      retval = hook->callDispatchPost( /*space*/ 0, 796, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }


   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 797, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

UINT WINAPI LWM__lwrite( HFILE hFile,
                         LPCSTR lpBuffer,
                         UINT uBytes
                       )
{
   UINT callRet = {NULL};
   LPVOID uapsave[3];
   LPVOID uap[3];

   static HOOKFUNCDESC *hook = NULL;

   if( !hook )
   {
      if( g_bCountCalls )
      {
         WSS_MUTEX_ENTER( g_callcount );
         wsi_printf( PD_MAKESTR("%6d:%-32s%c"), g_callcount++,
                     PD_MAKESTR("_lwrite"),
                     (g_callcount % 2)?PD_MAKESTR('\n'):PD_MAKESTR(' ') );
         WSS_MUTEX_EXIT( g_callcount );
      }

      HOOKMAP::iterator hookIterator;
      hookIterator = g_hookMap.find("_lwrite");
      hook = &(*hookIterator).second;
   }

   uapsave[0] =
      uap[0] = (LPVOID) hFile;
   uapsave[1] =
      uap[1] = (LPVOID) (LPVOID) _LWMStubs_ConvertASCIIToUnicode( (LPCSTR)lpBuffer );
   uapsave[2] =
      uap[2] = (LPVOID) uBytes;
   if( g_bTraceCalls )
   {
      WSS_MUTEX_ENTER( g_tracecount );
      wsi_printf( PD_MAKESTR("%6d:%s %s( 0x%x 0x%x:\"%s\" 0x%x )"),
                  g_tracecount++,
                  PD_MAKESTR("UINT"),
                  PD_MAKESTR("_lwrite"),
                  uap[0],
                  uap[1],
                  (LPCWSTR) uap[1],
                  uap[2]
                );
      WSS_MUTEX_EXIT( g_tracecount );
   }

   int err = 0;
   wss_wrapper_data data = { 0, 0 };
   data.errnum = &err;

   int retval = hook->callDispatchPre( /*space*/ 0, 797, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );


   if( !retval )
   {
      LPVOID uapascii[3];
      uapascii[0] = uap[0];
      uapascii[1] =
         (LPVOID) _LWMStubs_ConvertUnicodeToASCII( (LPCWSTR)uap[1] );
      uapascii[2] = uap[2];
      callRet = _lwrite( (HFILE) uapascii[0],
                         (LPCSTR) uapascii[1],
                         (UINT) uapascii[2]
                      );

      if( g_bTraceCalls )
         wsi_printf( PD_MAKESTR(" ==> 0x%1x\n"), callRet );

      if( uapascii[1] )
         free( (PVOID)uapascii[1] );

      retval = hook->callDispatchPost( /*space*/ 0, 797, (void **)uap, 
                                       &callRet, g_wrp, &data,
                                       /*args_in_user_space*/ 1 );
   }

   if( uapsave[1] )
      free( (PVOID)uapsave[1] );

   /* Clean up arg replacement */
   wss_arg_donesyscall( g_wrp, wsi_os_curthreadid(), 0, 798, (void **)uap );

   if( !retval )
   {
      return callRet;
   }
   else
   {
      // we should really decompose the relevant return code!!!
      return callRet;
   }
}

